#include <gracelib.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
static char compilerRevision[] = "ebebbdf31e78362af099d4a09ba52e11d415ff8e";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "math";
Object module_StandardPrelude_init();
static char *originalSourceLines[] = {
  "// C calling conventions:",
  "// - the method's arguments are in args[0], args[1], ...",
  "// - the insatnce variables of an object o are in o->data, but exactly where depends",
  "//     on whether it is built-in or defined in Grace.",
  "// - ‹return› returns from the method",
  "// - the native code insertions can be treated as an expression answering a value;",
  "//     that value should be assigend to ‹result›",
  "",
  "// JS conventions:",
  "// - Access ‹param› by writing var_‹param›",
  "// - Access ‹field› by writing this.data.‹field›",
  "// - set result by assigning to ‹result›",
  "// - ‹return› returns from the method",
  "",
  "",
  "method sin(a:Number) -> Number {",
  "    // sine of a (assumed to be radians)",
  "    native \"c\" code ‹    return alloc_Float64(sin(*(double*) args[0]->data));›",
  "    native \"js\" code ‹    return new GraceNum(Math.sin(var_a._value));›",
  "}",
  "",
  "method cos(a:Number) -> Number {",
  "    // cosine of a (assumed to be radians)",
  "    native \"c\" code ‹    return alloc_Float64(cos(*(double*) args[0]->data));›",
  "    native \"js\" code ‹    return new GraceNum(Math.cos(var_a._value));›",
  "}",
  "",
  "method tan(a:Number) -> Number {",
  "    // tangent of a (assumed to be radians)",
  "    native \"c\" code ‹    return alloc_Float64(tan(*(double*) args[0]->data));›",
  "    native \"js\" code ‹    return new GraceNum(Math.tan(var_a._value));›",
  "}",
  "",
  "method asin(a:Number) -> Number {",
  "    // arcsin of a (in radians)",
  "    native \"c\" code ‹    return alloc_Float64(asin(*(double*) args[0]->data));›",
  "    native \"js\" code ‹    return new GraceNum(Math.asin(var_a._value));›",
  "}",
  "",
  "method acos(a:Number) -> Number {",
  "    // arccos of a (in radians)",
  "    native \"c\" code ‹    return alloc_Float64(acos(*(double*) args[0]->data));›",
  "    native \"js\" code ‹    return new GraceNum(Math.acos(var_a._value));›",
  "}",
  "",
  "method atan(a:Number) -> Number {",
  "    // arctan of a (in radians)",
  "    native \"c\" code ‹    return alloc_Float64(atan(*(double*) args[0]->data));›",
  "    native \"js\" code ‹    return new GraceNum(Math.atan(var_a._value));›",
  "}",
  "",
  "method random -> Number {",
  "    // a pseudo-random number",
  "    native \"c\" code ‹    return alloc_Float64((double)rand() / RAND_MAX);›",
  "    native \"js\" code ‹    return new GraceNum(Math.random());›",
  "}",
  "",
  "method π -> Number {",
  "    // an approximation of the constant π",
  "    native \"c\" code ‹    return alloc_Float64((double)3.141592653589793);›",
  "    native \"js\" code ‹    return new GraceNum(3.141592653589793);›",
  "}",
  "",
  "method pi -> Number {",
  "    // same as π — for those who don't know Greek",
  "    native \"c\" code ‹    return alloc_Float64((double)3.141592653589793);›",
  "    native \"js\" code ‹    return new GraceNum(3.141592653589793);›",
  "}",
  "",
  "method sqrt(a:Number) -> Number {",
  "    // square root of a",
  "    native \"c\" code ‹    return alloc_Float64(sqrt(*(double*) args[0]->data));›",
  "    native \"js\" code ‹    return new GraceNum(Math.sqrt(var_a._value));›",
  "}",
  "",
  "method abs(a:Number) -> Number {",
  "    // absolute value of a",
  "    native \"c\" code ‹    return alloc_Float64(fabs(*(double*) args[0]->data));›",
  "    native \"js\" code ‹    return new GraceNum(Math.abs(var_a._value));›",
  "}",
  "",
  "method lg(a:Number) -> Number {",
  "    // logarithm to base 2 of a",
  "    native \"c\" code ‹    double log2 = log(2.0);",
  "    double logA = log(*(double*) args[0]->data);",
  "    return alloc_Float64(logA/log2);›",
  "    native \"js\" code ‹    return new GraceNum(Math.log(var_a._value) / Math.LN2);›",
  "}",
  "",
  "method ln(a:Number) -> Number {",
  "    // natural logarithm (base e) of a",
  "    native \"c\" code ‹    return alloc_Float64(log(*(double*) args[0]->data));›",
  "    native \"js\" code ‹    return new GraceNum(Math.log(var_a._value));›",
  "}",
  "",
  "method exp(a:Number) -> Number {",
  "    // e to the power a",
  "    native \"c\" code ‹    return alloc_Float64(exp(*(double*) args[0]->data));›",
  "    native \"js\" code ‹    return new GraceNum(Math.exp(var_a._value));›",
  "}",
  "",
  "method log10(a:Number) -> Number {",
  "    // logarithm to base 10 of a",
  "    native \"c\" code ‹    return alloc_Float64(log10(*(double*) args[0]->data));›",
  "    native \"js\" code ‹    return new GraceNum(Math.log(var_a._value) / Math.LN10);›",
  "}",
  NULL
};
Object meth_math_sin_40_1_41_1(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sin(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sin(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sin(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sin(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 18
  Object nat2;
  { Object result = done;
    return alloc_Float64(sin(*(double*) args[0]->data));
  nat2 = result;
  }
// compiled call node returning nat2 (depth = 2)
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_math_cos_40_1_41_3(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "cos(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method cos(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for cos(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part cos(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 24
  Object nat4;
  { Object result = done;
    return alloc_Float64(cos(*(double*) args[0]->data));
  nat4 = result;
  }
// compiled call node returning nat4 (depth = 2)
// Begin line 25
  setline(25);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_math_tan_40_1_41_5(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "tan(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method tan(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for tan(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part tan(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 30
  Object nat6;
  { Object result = done;
    return alloc_Float64(tan(*(double*) args[0]->data));
  nat6 = result;
  }
// compiled call node returning nat6 (depth = 2)
// Begin line 31
  setline(31);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_math_asin_40_1_41_7(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asin(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method asin(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asin(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part asin(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 36
  setline(36);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 36
  Object nat8;
  { Object result = done;
    return alloc_Float64(asin(*(double*) args[0]->data));
  nat8 = result;
  }
// compiled call node returning nat8 (depth = 2)
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_math_acos_40_1_41_9(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "acos(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method acos(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for acos(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part acos(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 42
  setline(42);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 42
  Object nat10;
  { Object result = done;
    return alloc_Float64(acos(*(double*) args[0]->data));
  nat10 = result;
  }
// compiled call node returning nat10 (depth = 2)
// Begin line 43
  setline(43);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_math_atan_40_1_41_11(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "atan(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method atan(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for atan(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part atan(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 48
  setline(48);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 48
  Object nat12;
  { Object result = done;
    return alloc_Float64(atan(*(double*) args[0]->data));
  nat12 = result;
  }
// compiled call node returning nat12 (depth = 2)
// Begin line 49
  setline(49);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_math_random13(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "random");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 54
  Object nat14;
  { Object result = done;
    return alloc_Float64((double)rand() / RAND_MAX);
  nat14 = result;
  }
// compiled call node returning nat14 (depth = 2)
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_math__34__34__92_xcf_34__34__34__34__92_x80_34__34_15(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, """\xcf""""\x80""");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 60
  setline(60);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 60
  Object nat16;
  { Object result = done;
    return alloc_Float64((double)3.141592653589793);
  nat16 = result;
  }
// compiled call node returning nat16 (depth = 2)
// Begin line 61
  setline(61);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_math_pi17(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pi");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 66
  setline(66);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 66
  Object nat18;
  { Object result = done;
    return alloc_Float64((double)3.141592653589793);
  nat18 = result;
  }
// compiled call node returning nat18 (depth = 2)
// Begin line 67
  setline(67);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_math_sqrt_40_1_41_19(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sqrt(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sqrt(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sqrt(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sqrt(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 72
  setline(72);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 72
  Object nat20;
  { Object result = done;
    return alloc_Float64(sqrt(*(double*) args[0]->data));
  nat20 = result;
  }
// compiled call node returning nat20 (depth = 2)
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_math_abs_40_1_41_21(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "abs(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method abs(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for abs(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part abs(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 78
  setline(78);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 78
  Object nat22;
  { Object result = done;
    return alloc_Float64(fabs(*(double*) args[0]->data));
  nat22 = result;
  }
// compiled call node returning nat22 (depth = 2)
// Begin line 79
  setline(79);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_math_lg_40_1_41_23(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "lg(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lg(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lg(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part lg(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 84
  setline(84);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 84
  Object nat24;
  { Object result = done;
    double log2 = log(2.0);
    double logA = log(*(double*) args[0]->data);
    return alloc_Float64(logA/log2);
  nat24 = result;
  }
// compiled call node returning nat24 (depth = 2)
// Begin line 87
  setline(87);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_math_ln_40_1_41_25(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "ln(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ln(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ln(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ln(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 92
  Object nat26;
  { Object result = done;
    return alloc_Float64(log(*(double*) args[0]->data));
  nat26 = result;
  }
// compiled call node returning nat26 (depth = 2)
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_math_exp_40_1_41_27(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "exp(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method exp(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for exp(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part exp(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 98
  setline(98);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 98
  Object nat28;
  { Object result = done;
    return alloc_Float64(exp(*(double*) args[0]->data));
  nat28 = result;
  }
// compiled call node returning nat28 (depth = 2)
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object meth_math_log10_40_1_41_29(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "log10(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method log10(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for log10(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part log10(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 104
  setline(104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
   // start native code from line 104
  Object nat30;
  { Object result = done;
    return alloc_Float64(log10(*(double*) args[0]->data));
  nat30 = result;
  }
// compiled call node returning nat30 (depth = 2)
// Begin line 105
  setline(105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
// compiled call node returning done (depth = 2)
  gc_frame_end(frame);
  return done;
}
Object module_math_init() {
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(17, 17);
  self->class->definitionModule = modulename;
  gc_root(self);
  prelude = module_StandardPrelude_init();
  adddatum2(self, prelude, 0);
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
  setclassname(self, "Module<math>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = prelude;
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(17, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
// end of preamble
  Object params[1];
  int partcv[1];
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "sin(_)"
  struct UserObject *uo1 = (struct UserObject*)self;
  uo1->data[1] = emptyclosure;
  Method *meth_meth_math_sin_40_1_41_1 = addmethod2pos(self, "sin(1)", &meth_math_sin_40_1_41_1, 1);
  int argcv_meth_math_sin_40_1_41_1[] = {1};
  meth_meth_math_sin_40_1_41_1->type = alloc_MethodType(1, argcv_meth_math_sin_40_1_41_1);
meth_meth_math_sin_40_1_41_1->type->types[0] = type_Number;
meth_meth_math_sin_40_1_41_1->type->names[0] = "a";
  meth_meth_math_sin_40_1_41_1->definitionModule = modulename;
  meth_meth_math_sin_40_1_41_1->definitionLine = 16;
// compiled method node returning  (depth = 1)
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "cos(_)"
  struct UserObject *uo3 = (struct UserObject*)self;
  uo3->data[2] = emptyclosure;
  Method *meth_meth_math_cos_40_1_41_3 = addmethod2pos(self, "cos(1)", &meth_math_cos_40_1_41_3, 2);
  int argcv_meth_math_cos_40_1_41_3[] = {1};
  meth_meth_math_cos_40_1_41_3->type = alloc_MethodType(1, argcv_meth_math_cos_40_1_41_3);
meth_meth_math_cos_40_1_41_3->type->types[0] = type_Number;
meth_meth_math_cos_40_1_41_3->type->names[0] = "a";
  meth_meth_math_cos_40_1_41_3->definitionModule = modulename;
  meth_meth_math_cos_40_1_41_3->definitionLine = 22;
// compiled method node returning  (depth = 1)
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "tan(_)"
  struct UserObject *uo5 = (struct UserObject*)self;
  uo5->data[3] = emptyclosure;
  Method *meth_meth_math_tan_40_1_41_5 = addmethod2pos(self, "tan(1)", &meth_math_tan_40_1_41_5, 3);
  int argcv_meth_math_tan_40_1_41_5[] = {1};
  meth_meth_math_tan_40_1_41_5->type = alloc_MethodType(1, argcv_meth_math_tan_40_1_41_5);
meth_meth_math_tan_40_1_41_5->type->types[0] = type_Number;
meth_meth_math_tan_40_1_41_5->type->names[0] = "a";
  meth_meth_math_tan_40_1_41_5->definitionModule = modulename;
  meth_meth_math_tan_40_1_41_5->definitionLine = 28;
// compiled method node returning  (depth = 1)
// Begin line 34
  setline(34);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "asin(_)"
  struct UserObject *uo7 = (struct UserObject*)self;
  uo7->data[4] = emptyclosure;
  Method *meth_meth_math_asin_40_1_41_7 = addmethod2pos(self, "asin(1)", &meth_math_asin_40_1_41_7, 4);
  int argcv_meth_math_asin_40_1_41_7[] = {1};
  meth_meth_math_asin_40_1_41_7->type = alloc_MethodType(1, argcv_meth_math_asin_40_1_41_7);
meth_meth_math_asin_40_1_41_7->type->types[0] = type_Number;
meth_meth_math_asin_40_1_41_7->type->names[0] = "a";
  meth_meth_math_asin_40_1_41_7->definitionModule = modulename;
  meth_meth_math_asin_40_1_41_7->definitionLine = 34;
// compiled method node returning  (depth = 1)
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "acos(_)"
  struct UserObject *uo9 = (struct UserObject*)self;
  uo9->data[5] = emptyclosure;
  Method *meth_meth_math_acos_40_1_41_9 = addmethod2pos(self, "acos(1)", &meth_math_acos_40_1_41_9, 5);
  int argcv_meth_math_acos_40_1_41_9[] = {1};
  meth_meth_math_acos_40_1_41_9->type = alloc_MethodType(1, argcv_meth_math_acos_40_1_41_9);
meth_meth_math_acos_40_1_41_9->type->types[0] = type_Number;
meth_meth_math_acos_40_1_41_9->type->names[0] = "a";
  meth_meth_math_acos_40_1_41_9->definitionModule = modulename;
  meth_meth_math_acos_40_1_41_9->definitionLine = 40;
// compiled method node returning  (depth = 1)
// Begin line 46
  setline(46);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "atan(_)"
  struct UserObject *uo11 = (struct UserObject*)self;
  uo11->data[6] = emptyclosure;
  Method *meth_meth_math_atan_40_1_41_11 = addmethod2pos(self, "atan(1)", &meth_math_atan_40_1_41_11, 6);
  int argcv_meth_math_atan_40_1_41_11[] = {1};
  meth_meth_math_atan_40_1_41_11->type = alloc_MethodType(1, argcv_meth_math_atan_40_1_41_11);
meth_meth_math_atan_40_1_41_11->type->types[0] = type_Number;
meth_meth_math_atan_40_1_41_11->type->names[0] = "a";
  meth_meth_math_atan_40_1_41_11->definitionModule = modulename;
  meth_meth_math_atan_40_1_41_11->definitionLine = 46;
// compiled method node returning  (depth = 1)
// Begin line 52
  setline(52);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "random"
  struct UserObject *uo13 = (struct UserObject*)self;
  uo13->data[7] = emptyclosure;
  Method *meth_meth_math_random13 = addmethod2pos(self, "random", &meth_math_random13, 7);
  int argcv_meth_math_random13[] = {0};
  meth_meth_math_random13->type = alloc_MethodType(1, argcv_meth_math_random13);
  meth_meth_math_random13->definitionModule = modulename;
  meth_meth_math_random13->definitionLine = 52;
// compiled method node returning  (depth = 1)
// Begin line 58
  setline(58);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "π"
  struct UserObject *uo15 = (struct UserObject*)self;
  uo15->data[8] = emptyclosure;
  Method *meth_meth_math__34__34__92_xcf_34__34__34__34__92_x80_34__34_15 = addmethod2pos(self, """\xcf""""\x80""", &meth_math__34__34__92_xcf_34__34__34__34__92_x80_34__34_15, 8);
  int argcv_meth_math__34__34__92_xcf_34__34__34__34__92_x80_34__34_15[] = {0};
  meth_meth_math__34__34__92_xcf_34__34__34__34__92_x80_34__34_15->type = alloc_MethodType(1, argcv_meth_math__34__34__92_xcf_34__34__34__34__92_x80_34__34_15);
  meth_meth_math__34__34__92_xcf_34__34__34__34__92_x80_34__34_15->definitionModule = modulename;
  meth_meth_math__34__34__92_xcf_34__34__34__34__92_x80_34__34_15->definitionLine = 58;
// compiled method node returning  (depth = 1)
// Begin line 64
  setline(64);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "pi"
  struct UserObject *uo17 = (struct UserObject*)self;
  uo17->data[9] = emptyclosure;
  Method *meth_meth_math_pi17 = addmethod2pos(self, "pi", &meth_math_pi17, 9);
  int argcv_meth_math_pi17[] = {0};
  meth_meth_math_pi17->type = alloc_MethodType(1, argcv_meth_math_pi17);
  meth_meth_math_pi17->definitionModule = modulename;
  meth_meth_math_pi17->definitionLine = 64;
// compiled method node returning  (depth = 1)
// Begin line 70
  setline(70);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "sqrt(_)"
  struct UserObject *uo19 = (struct UserObject*)self;
  uo19->data[10] = emptyclosure;
  Method *meth_meth_math_sqrt_40_1_41_19 = addmethod2pos(self, "sqrt(1)", &meth_math_sqrt_40_1_41_19, 10);
  int argcv_meth_math_sqrt_40_1_41_19[] = {1};
  meth_meth_math_sqrt_40_1_41_19->type = alloc_MethodType(1, argcv_meth_math_sqrt_40_1_41_19);
meth_meth_math_sqrt_40_1_41_19->type->types[0] = type_Number;
meth_meth_math_sqrt_40_1_41_19->type->names[0] = "a";
  meth_meth_math_sqrt_40_1_41_19->definitionModule = modulename;
  meth_meth_math_sqrt_40_1_41_19->definitionLine = 70;
// compiled method node returning  (depth = 1)
// Begin line 76
  setline(76);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "abs(_)"
  struct UserObject *uo21 = (struct UserObject*)self;
  uo21->data[11] = emptyclosure;
  Method *meth_meth_math_abs_40_1_41_21 = addmethod2pos(self, "abs(1)", &meth_math_abs_40_1_41_21, 11);
  int argcv_meth_math_abs_40_1_41_21[] = {1};
  meth_meth_math_abs_40_1_41_21->type = alloc_MethodType(1, argcv_meth_math_abs_40_1_41_21);
meth_meth_math_abs_40_1_41_21->type->types[0] = type_Number;
meth_meth_math_abs_40_1_41_21->type->names[0] = "a";
  meth_meth_math_abs_40_1_41_21->definitionModule = modulename;
  meth_meth_math_abs_40_1_41_21->definitionLine = 76;
// compiled method node returning  (depth = 1)
// Begin line 82
  setline(82);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "lg(_)"
  struct UserObject *uo23 = (struct UserObject*)self;
  uo23->data[12] = emptyclosure;
  Method *meth_meth_math_lg_40_1_41_23 = addmethod2pos(self, "lg(1)", &meth_math_lg_40_1_41_23, 12);
  int argcv_meth_math_lg_40_1_41_23[] = {1};
  meth_meth_math_lg_40_1_41_23->type = alloc_MethodType(1, argcv_meth_math_lg_40_1_41_23);
meth_meth_math_lg_40_1_41_23->type->types[0] = type_Number;
meth_meth_math_lg_40_1_41_23->type->names[0] = "a";
  meth_meth_math_lg_40_1_41_23->definitionModule = modulename;
  meth_meth_math_lg_40_1_41_23->definitionLine = 82;
// compiled method node returning  (depth = 1)
// Begin line 90
  setline(90);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "ln(_)"
  struct UserObject *uo25 = (struct UserObject*)self;
  uo25->data[13] = emptyclosure;
  Method *meth_meth_math_ln_40_1_41_25 = addmethod2pos(self, "ln(1)", &meth_math_ln_40_1_41_25, 13);
  int argcv_meth_math_ln_40_1_41_25[] = {1};
  meth_meth_math_ln_40_1_41_25->type = alloc_MethodType(1, argcv_meth_math_ln_40_1_41_25);
meth_meth_math_ln_40_1_41_25->type->types[0] = type_Number;
meth_meth_math_ln_40_1_41_25->type->names[0] = "a";
  meth_meth_math_ln_40_1_41_25->definitionModule = modulename;
  meth_meth_math_ln_40_1_41_25->definitionLine = 90;
// compiled method node returning  (depth = 1)
// Begin line 96
  setline(96);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "exp(_)"
  struct UserObject *uo27 = (struct UserObject*)self;
  uo27->data[14] = emptyclosure;
  Method *meth_meth_math_exp_40_1_41_27 = addmethod2pos(self, "exp(1)", &meth_math_exp_40_1_41_27, 14);
  int argcv_meth_math_exp_40_1_41_27[] = {1};
  meth_meth_math_exp_40_1_41_27->type = alloc_MethodType(1, argcv_meth_math_exp_40_1_41_27);
meth_meth_math_exp_40_1_41_27->type->types[0] = type_Number;
meth_meth_math_exp_40_1_41_27->type->names[0] = "a";
  meth_meth_math_exp_40_1_41_27->definitionModule = modulename;
  meth_meth_math_exp_40_1_41_27->definitionLine = 96;
// compiled method node returning  (depth = 1)
// Begin line 102
  setline(102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "log10(_)"
  struct UserObject *uo29 = (struct UserObject*)self;
  uo29->data[15] = emptyclosure;
  Method *meth_meth_math_log10_40_1_41_29 = addmethod2pos(self, "log10(1)", &meth_math_log10_40_1_41_29, 15);
  int argcv_meth_math_log10_40_1_41_29[] = {1};
  meth_meth_math_log10_40_1_41_29->type = alloc_MethodType(1, argcv_meth_math_log10_40_1_41_29);
meth_meth_math_log10_40_1_41_29->type->types[0] = type_Number;
meth_meth_math_log10_40_1_41_29->type->names[0] = "a";
  meth_meth_math_log10_40_1_41_29->definitionModule = modulename;
  meth_meth_math_log10_40_1_41_29->definitionLine = 102;
// compiled method node returning  (depth = 1)
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 27
  setline(27);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 33
  setline(33);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 39
  setline(39);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 45
  setline(45);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 51
  setline(51);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 63
  setline(63);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 69
  setline(69);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 75
  setline(75);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 81
  setline(81);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 95
  setline(95);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 101
  setline(101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
  gc_frame_end(frame);
  return self;
}
