#include <gracelib.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
static char compilerRevision[] = "ebebbdf31e78362af099d4a09ba52e11d415ff8e";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "collectionsPrelude";
Object module_StandardPrelude_init();
static char *originalSourceLines[] = {
  "#pragma NativePrelude",
  "",
  "def BoundsError = ProgrammingError.refine \"BoundsError\"",
  "def IteratorExhausted = ProgrammingError.refine \"IteratorExhausted\"",
  "def SubobjectResponsibility = ProgrammingError.refine \"SubobjectResponsibility\"",
  "def NoSuchObject = ProgrammingError.refine \"NoSuchObject\"",
  "def RequestError = ProgrammingError.refine \"RequestError\"",
  "def ConcurrentModification = ProgrammingError.refine \"ConcurrentModification\"",
  "def SizeUnknown = Exception.refine \"SizeUnknown\"",
  "",
  "method abstract is confidential {",
  "    // copied from StandardPrelude",
  "    SubobjectResponsibility.raise \"abstract method not overriden by subobject\"",
  "}",
  "",
  "type Block0⟦R⟧ = type {",
  "    apply -> R",
  "}",
  "",
  "type Block1⟦T,R⟧ = type {",
  "    apply(a:T) -> R",
  "}",
  "",
  "type Block2⟦S,T,R⟧ = type {",
  "    apply(a:S, b:T) -> R",
  "}",
  "",
  "type SelfType = Unknown     // becuase it's not yet in the language",
  "",
  "type Iterable⟦T⟧ = Object & type {",
  "    iterator -> Iterator⟦T⟧",
  "        // the iterator on which I am based",
  "    isEmpty -> Boolean",
  "        // true if I have no elements",
  "    size -> Number",
  "        // my size (the number of elements that I contain);",
  "        // may raise SizeUnknown.",
  "    sizeIfUnknown(action: Block0⟦Number⟧)",
  "        // my size; if not known, then the result of applying action",
  "    first -> T",
  "        // my first element; raises BoundsError if I have none.",
  "    do(block1: Block1⟦T, Done⟧) -> Done",
  "        // an internal iterator; applies block1 to each of my elements",
  "    do(body:Block1⟦T, Done⟧) separatedBy(separator:Block0⟦Done⟧) -> Done",
  "        // an internal iterator; ; applies block1 to each of my elements, and applies separator in between",
  "    ++(other: Iterable⟦T⟧) -> Iterable⟦T⟧",
  "        // returns a new Iterable over the concatenation of self and other",
  "    fold(binaryFunction:Block2⟦T, T, T⟧) startingWith(initial:T) -> Object",
  "        // the left-associative fold of binaryFunction over self, starting with initial",
  "    map⟦U⟧(function:Block1⟦T, U⟧) -> Iterable⟦U⟧",
  "        // returns a new iterator that yields my elements mapped by function",
  "    filter(condition:Block1⟦T,Boolean⟧) -> Iterable⟦T⟧",
  "        // returns a new iterator that yields those of my elements for which condition holds",
  "}",
  "",
  "type Expandable⟦T⟧ = Iterable⟦T⟧ & type {",
  "    add(x: T) -> SelfType",
  "    addAll(xs: Iterable⟦T⟧) -> SelfType",
  "}",
  "",
  "type Collection⟦T⟧ = Iterable⟦T⟧ & type {",
  "    asList -> List⟦T⟧",
  "    asSequence -> Sequence⟦T⟧",
  "    asSet -> Set⟦T⟧",
  "}",
  "",
  "type Enumerable⟦T⟧ = Collection⟦T⟧ & type {",
  "    values -> Collection⟦T⟧",
  "    asDictionary -> Dictionary⟦Number,T⟧",
  "    keysAndValuesDo(action:Block2⟦Number,T,Object⟧) -> Done",
  "    into(existing: Expandable⟦Unknown⟧) -> Collection⟦Unknown⟧",
  "    sortedBy(comparison:Block2⟦T,T,Number⟧) -> SelfType",
  "    sorted -> SelfType",
  "}",
  "",
  "type Sequence⟦T⟧ = Enumerable⟦T⟧ & type {",
  "    size -> Number",
  "    at(n:Number) -> T",
  "    indices -> Sequence⟦Number⟧",
  "    keys -> Sequence⟦Number⟧",
  "    second -> T",
  "    third -> T",
  "    fourth -> T",
  "    fifth -> T",
  "    last -> T",
  "    indexOf⟦W⟧(elem:T)ifAbsent(action:Block0⟦W⟧) -> Number | W",
  "    indexOf(elem:T) -> Number",
  "    contains(elem:T) -> Boolean",
  "    reversed -> Sequence⟦T⟧",
  "}",
  "",
  "type List⟦T⟧ = Sequence⟦T⟧ & type {",
  "    add(x: T) -> List⟦T⟧",
  "    addAll(xs: Iterable⟦T⟧) -> List⟦T⟧",
  "    addFirst(x: T) -> List⟦T⟧",
  "    addAllFirst(xs: Iterable⟦T⟧) -> List⟦T⟧",
  "    addLast(x: T) -> List⟦T⟧    // same as add",
  "    at(ix:Number) put(v:T) -> List⟦T⟧",
  "    removeFirst -> T",
  "    removeAt(n: Number) -> T",
  "    removeLast -> T",
  "    remove(v:T)",
  "    remove(v:T) ifAbsent(action:Block0⟦Done⟧)",
  "    removeAll(vs: Iterable⟦T⟧)",
  "    removeAll(vs: Iterable⟦T⟧) ifAbsent(action:Block0⟦Unknown⟧)",
  "    pop -> T",
  "    ++(o: List⟦T⟧) -> List⟦T⟧",
  "    addAll(l: Iterable⟦T⟧) -> List⟦T⟧",
  "    copy -> List⟦T⟧",
  "    sort -> List⟦T⟧",
  "    sortBy(sortBlock:Block2⟦T,T,Number⟧) -> List⟦T⟧",
  "    reverse -> List⟦T⟧",
  "    reversed -> List⟦T⟧",
  "}",
  "",
  "type Set⟦T⟧ = Collection⟦T⟧ & type {",
  "    size -> Number",
  "    add(x:T) -> SelfType",
  "    addAll(elements: Iterable⟦T⟧) -> SelfType",
  "    remove(x: T) -> Set⟦T⟧",
  "    remove(x: T) ifAbsent(block: Block0⟦Done⟧) -> Set⟦T⟧",
  "    includes(booleanBlock: Block1⟦T,Boolean⟧) -> Boolean",
  "    find(booleanBlock: Block1⟦T,Boolean⟧) ifNone(notFoundBlock: Block0⟦T⟧) -> T",
  "    copy -> Set⟦T⟧",
  "    contains(elem:T) -> Boolean",
  "    ** (other:Set⟦T⟧) -> Set⟦T⟧",
  "    -- (other:Set⟦T⟧) -> Set⟦T⟧",
  "    ++ (other:Set⟦T⟧) -> Set⟦T⟧",
  "    isSubset(s2: Set⟦T⟧) -> Boolean",
  "    isSuperset(s2: Iterable⟦T⟧) -> Boolean",
  "    removeAll(elems: Iterable⟦T⟧)",
  "    removeAll(elems: Iterable⟦T⟧)ifAbsent(action:Block0⟦Done⟧) -> Set⟦T⟧",
  "    into(existing: Expandable⟦Unknown⟧) -> Collection⟦Unknown⟧",
  "}",
  "",
  "type Dictionary⟦K,T⟧ = Collection⟦T⟧ & type {",
  "    size -> Number",
  "    containsKey(k:K) -> Boolean",
  "    containsValue(v:T) -> Boolean",
  "    contains(elem:T) -> Boolean",
  "    at(key:K)ifAbsent(action:Block0⟦Unknown⟧) -> Unknown",
  "    at(key:K)put(value:T) -> Dictionary⟦K,T⟧",
  "    at(k:K) -> T",
  "    removeAllKeys(keys: Iterable⟦K⟧) -> Dictionary⟦K,T⟧",
  "    removeKey(key:K) -> Dictionary⟦K,T⟧",
  "    removeAllValues(removals: Iterable⟦T⟧) -> Dictionary⟦K,T⟧",
  "    removeValue(v:T) -> Dictionary⟦K,T⟧",
  "    keys -> Enumerable⟦K⟧",
  "    values -> Enumerable⟦T⟧",
  "    bindings -> Enumerable⟦Binding⟦K,T⟧⟧",
  "    keysAndValuesDo(action:Block2⟦K,T,Done⟧) -> Done",
  "    keysDo(action:Block1⟦K,Done⟧) -> Done",
  "    valuesDo(action:Block1⟦T,Done⟧) -> Done",
  "    == (other:Object) -> Boolean",
  "    copy -> Dictionary⟦K,T⟧",
  "    ++ (other:Dictionary⟦K, T⟧) -> Dictionary⟦K, T⟧",
  "    -- (other:Dictionary⟦K, T⟧) -> Dictionary⟦K, T⟧",
  "    asDictionary -> Dictionary⟦K, T⟧",
  "}",
  "",
  "type Iterator⟦T⟧ = type {",
  "    hasNext -> Boolean",
  "    next -> T",
  "}",
  "",
  "class lazySequenceOver⟦T,R⟧ (source: Iterable⟦T⟧)",
  "        mappedBy (function:Block1⟦T,R⟧) -> Enumerable⟦R⟧ is confidential {",
  "    inherits enumerable.TRAIT⟦T⟧",
  "    class iterator {",
  "        def sourceIterator = source.iterator",
  "        method asString { \"an iterator over a lazy map sequence\" }",
  "        method hasNext { sourceIterator.hasNext }",
  "        method next { function.apply(sourceIterator.next) }",
  "    }",
  "    method size { source.size }",
  "    method isEmpty { source.isEmpty }",
  "    method asDebugString { \"a lazy sequence mapping over {source}\" }",
  "}",
  "",
  "class lazySequenceOver⟦T⟧ (source: Iterable⟦T⟧)",
  "        filteredBy(predicate:Block1⟦T,Boolean⟧) -> Enumerable⟦T⟧ is confidential {",
  "    inherits enumerable.TRAIT⟦T⟧",
  "    class iterator {",
  "        var cache",
  "        var cacheLoaded := false",
  "        def sourceIterator = source.iterator",
  "        method asString { \"an iterator over filtered {source}\" }",
  "        method hasNext {",
  "        // To determine if this iterator has a next element, we have to find",
  "        // an acceptable element; this is then cached, for the use of next",
  "            if (cacheLoaded) then { true } else { hasNextAcceptableElement }",
  "        }",
  "        method next {",
  "            if (cacheLoaded.not) then { cache := nextAcceptableElement }",
  "            cacheLoaded := false",
  "            return cache",
  "        }",
  "        method nextAcceptableElement is confidential {",
  "        // return the next element of the underlying iterator satisfying",
  "        // predicate; if there is none, raises IteratorExhausted.",
  "            while { true } do {",
  "                def outerNext = sourceIterator.next",
  "                def isAcceptable = predicate.apply(outerNext)",
  "                if (isAcceptable) then { return outerNext }",
  "            }",
  "        }",
  "        method hasNextAcceptableElement is confidential {",
  "        // returns true is there is another element in the underlying iterator",
  "        // satisfying predicate, otherwise false",
  "            while { true } do {",
  "                if (sourceIterator.hasNext.not) then { return false }",
  "                def outerNext = sourceIterator.next",
  "                def isAcceptable = predicate.apply(outerNext)",
  "                if (isAcceptable) then {",
  "                    cacheLoaded := true",
  "                    cache := outerNext",
  "                    return true",
  "                }",
  "            }",
  "        }",
  "    }",
  "    method asDebugString { \"a lazy sequence filtering {source}\" }",
  "}",
  "",
  "class iteratorConcat⟦T⟧(left:Iterator⟦T⟧, right:Iterator⟦T⟧) {",
  "    method next {",
  "        if (left.hasNext) then {",
  "            left.next",
  "        } else {",
  "            right.next",
  "        }",
  "    }",
  "    method hasNext {",
  "        if (left.hasNext) then { return true }",
  "        return right.hasNext",
  "    }",
  "    method asDebugString { \"iteratorConcat of {left} and {right}\" }",
  "    method asString { \"an iterator over a concatenation\" }",
  "}",
  "class lazyConcatenation⟦T⟧(left, right) -> Enumerable⟦T⟧{",
  "    inherits enumerable.TRAIT⟦T⟧",
  "    method iterator {",
  "        iteratorConcat(left.iterator, right.iterator)",
  "    }",
  "    method asDebugString { \"lazy concatenation of {left} and {right}\" }",
  "    method asString { super.asString }",
  "    method size { left.size + right.size }  // may raise SizeUnknown",
  "}",
  "",
  "class collection.TRAIT⟦T⟧ {",
  "    ",
  "    method asString { \"a collection TRAIT\" }",
  "    method sizeIfUnknown(action) {",
  "        action.apply",
  "    }",
  "    method size {",
  "        SizeUnknown.raise \"this collection does not know its size\"",
  "    }",
  "    method do { abstract }",
  "    method iterator { abstract }",
  "    method isEmpty {",
  "        // override if size is known",
  "        iterator.hasNext.not",
  "    }",
  "    method first {",
  "        def it = self.iterator",
  "        if (it.hasNext) then { ",
  "            it.next",
  "        } else {",
  "            BoundsError.raise \"no first element in {self}\"",
  "        }",
  "    }",
  "    method do(block1) separatedBy(block0) {",
  "        var firstTime := true",
  "        var i := 0",
  "        self.do { each ->",
  "            if (firstTime) then {",
  "                firstTime := false",
  "            } else {",
  "                block0.apply",
  "            }",
  "            block1.apply(each)",
  "        }",
  "        return self",
  "    }",
  "    method reduce(initial, blk) {",
  "    // deprecated; for compatibility with builtInList",
  "        fold(blk)startingWith(initial)",
  "    }",
  "    method fold(blk)startingWith(initial) {",
  "        var result := initial",
  "        self.do {it ->",
  "            result := blk.apply(result, it)",
  "        }",
  "        return result",
  "    }",
  "    method map⟦R⟧(block1:Block1⟦T,R⟧) -> Enumerable⟦R⟧ {",
  "        lazySequenceOver(self) mappedBy(block1)",
  "    }",
  "    method filter(selectionCondition:Block1⟦T,Boolean⟧) -> Enumerable⟦T⟧ {",
  "        lazySequenceOver(self) filteredBy(selectionCondition)",
  "    }",
  "",
  "    method iter { self.iterator }",
  "",
  "    method asSequence {",
  "        sequence.withAll(self)",
  "    }",
  "    method asList {",
  "        list.withAll(self)",
  "    }",
  "    method asSet {",
  "        set.withAll(self)",
  "    }",
  "}",
  "",
  "class enumerable.TRAIT⟦T⟧ {",
  "    inherits collection.TRAIT⟦T⟧",
  "    method iterator { abstract }",
  "    method size {",
  "        // override if size is known",
  "        SizeUnknown.raise \"size requested on {asDebugString}\"",
  "    }",
  "    method asDictionary {",
  "        def result = dictionary.empty",
  "        keysAndValuesDo { k, v ->",
  "            result.at(k) put(v)",
  "        }",
  "        return result",
  "    }",
  "    method into(existing: Expandable⟦T⟧) -> Collection⟦T⟧ {",
  "        def selfIterator = self.iterator",
  "        while {selfIterator.hasNext} do {",
  "            existing.add(selfIterator.next)",
  "        }",
  "        existing",
  "    }",
  "    method ==(other) {",
  "        isEqual (self) toIterable (other)",
  "    }",
  "    method do(block1:Block1⟦T,Done⟧) -> Done {",
  "        def selfIterator = self.iterator",
  "        while {selfIterator.hasNext} do {",
  "            block1.apply(selfIterator.next)",
  "        }",
  "    }",
  "    method keysAndValuesDo(block2:Block2⟦Number,T,Done⟧) -> Done {",
  "        var ix := 0",
  "        def selfIterator = self.iterator",
  "        while {selfIterator.hasNext} do {",
  "            ix := ix + 1",
  "            block2.apply(ix, selfIterator.next)",
  "        }",
  "    }",
  "    method values -> Collection⟦T⟧ {",
  "        self",
  "    }",
  "    method fold⟦R⟧(block2)startingWith(initial) -> R {",
  "        var res := initial",
  "        def selfIterator = self.iterator",
  "        while { selfIterator.hasNext } do {",
  "            res := block2.apply(res, selfIterator.next)",
  "        }",
  "        return res",
  "    }",
  "    method ++ (other) -> Enumerable⟦T⟧ {",
  "        lazyConcatenation(self, other)",
  "    }",
  "    method sortedBy(sortBlock:Block2) -> List⟦T⟧ {",
  "        self.asList.sortBy(sortBlock:Block2)",
  "    }",
  "    method sorted -> List⟦T⟧ {",
  "        self.asList.sort",
  "    }",
  "    method asString {",
  "        var s := \"⟨\"",
  "        do { each -> s := s ++ each.asString } separatedBy { s := s ++ \", \" }",
  "        s ++ \"⟩\"",
  "    }",
  "}",
  "",
  "class indexable.TRAIT⟦T⟧ {",
  "    inherits collection.TRAIT⟦T⟧",
  "    method at(index) { abstract }",
  "    method size { abstract }",
  "    method isEmpty { size == 0 }",
  "    method keysAndValuesDo(action:Block2⟦Number,T,Done⟧) -> Done {",
  "        def curSize = size",
  "        var i := 1",
  "        while {i <= curSize} do {",
  "            action.apply(i, self.at(i))",
  "            i := i + 1",
  "        }",
  "    }",
  "    method first { at(1) }",
  "    method second { at(2) }",
  "    method third { at(3) }",
  "    method fourth { at(4) }",
  "    method fifth { at(5) }",
  "    method last { at(size) }",
  "    method indices { range.from 1 to(size) }",
  "    method indexOf(sought:T)  {",
  "        indexOf(sought) ifAbsent { NoSuchObject.raise \"collection does not contain {sought}\" }",
  "    }",
  "    method indexOf(sought:T) ifAbsent(action:Block0)  {",
  "        keysAndValuesDo { ix, v ->",
  "            if (v == sought) then { return ix }",
  "        }",
  "        action.apply",
  "    }",
  "    method asDictionary {",
  "        def result = dictionary.empty",
  "        keysAndValuesDo { k, v ->",
  "            result.at(k) put(v)",
  "        }",
  "        return result",
  "    }",
  "    method into(existing: Expandable⟦T⟧) -> Collection⟦T⟧ {",
  "        def selfIterator = self.iterator",
  "        while {selfIterator.hasNext} do {",
  "            existing.add(selfIterator.next)",
  "        }",
  "        existing",
  "    }",
  "}",
  "",
  "method max(a,b) is confidential {       // copied from standard prelude",
  "    if (a > b) then { a } else { b }",
  "}",
  "",
  "def emptySequence is confidential = object {",
  "    inherits indexable.TRAIT",
  "    method size { 0 }",
  "    method isEmpty { true }",
  "    method at(n) { BoundsError.raise \"index {n} of empty sequence\" }",
  "    method keys { self }",
  "    method values { self }",
  "    method keysAndValuesDo(block2) { done }",
  "    method reversed { self }",
  "    method ++(other: Iterable) { sequence.withAll(other) }",
  "    method asString { \"⟨⟩\" }",
  "    method contains(element) { false }",
  "    method do(block1) { done }",
  "    method ==(other) {",
  "        match (other)",
  "            case {o: Iterable ->",
  "                o.isEmpty",
  "            }",
  "            case {_ ->",
  "                false",
  "            }",
  "    }",
  "    class iterator {",
  "        method asString { \"emptySequenceIterator\" }",
  "        method hasNext { false }",
  "        method next { IteratorExhausted.raise \"on empty sequence\" }",
  "    }",
  "    method sorted { self }",
  "    method sortedBy(sortBlock:Block2){ self }",
  "}",
  "",
  "class sequence⟦T⟧ {",
  "",
  "    method asString { \"a sequence factory\" }",
  "",
  "    method empty {",
  "        // this is an optimization: there need be just one empty sequence",
  "        emptySequence",
  "    }",
  "",
  "    method withAll(arg: Iterable⟦T⟧) {",
  "        var sizeCertain := true",
  "        // size might be uncertain if arg is a lazy collection.",
  "        def forecastSize = arg.sizeIfUnknown {",
  "            sizeCertain := false",
  "            8",
  "        }",
  "        var inner := _prelude.primitiveArray.new(forecastSize)",
  "        var innerSize := inner.size",
  "        var ix := 0",
  "        if (sizeCertain) then {",
  "            // common, fast path",
  "            for (arg) do { elt ->",
  "                inner.at(ix)put(elt)",
  "                ix := ix + 1",
  "            }",
  "        } else {",
  "            // less-than-optimal path",
  "            for (arg) do { elt ->",
  "                if (innerSize <= ix) then {",
  "                    def newInner = _prelude.primitiveArray.new(innerSize * 2)",
  "                    for (0..(innerSize-1)) do { i ->",
  "                        newInner.at(i)put(inner.at(i))",
  "                    }",
  "                    inner := newInner",
  "                    innerSize := inner.size",
  "                }",
  "                inner.at(ix)put(elt)",
  "                ix := ix + 1",
  "            }",
  "        }",
  "        if (ix == 0) then { return emptySequence }",
  "        self.fromprimitiveArray(inner, ix)",
  "    }",
  "    method fromprimitiveArray(pArray, sz) is confidential {",
  "        // constructs a sequence from the first sz elements of pArray",
  "",
  "        object {",
  "            inherits indexable.TRAIT",
  "            def size is public = sz",
  "            def inner = pArray",
  "",
  "            method boundsCheck(n) is confidential {",
  "                if (!(n >= 1) || !(n <= size)) then {",
  "                    // the condition is written this way because NaN always",
  "                    // compares false",
  "                    BoundsError.raise \"index {n} out of bounds 1..{size}\"",
  "                }",
  "            }",
  "            method at(n) {",
  "                boundsCheck(n)",
  "                inner.at(n-1)",
  "            }",
  "            method keys {",
  "                range.from(1)to(size)",
  "            }",
  "            method values {",
  "                self",
  "            }",
  "            method keysAndValuesDo(block2) {",
  "                var i := 0",
  "                while {i < size} do {",
  "                    block2.apply(i+1, inner.at(i))",
  "                    i := i + 1",
  "                }",
  "            }",
  "            method reversed {",
  "                def freshArray = _prelude.primitiveArray.new(size)",
  "                var ix := size - 1",
  "                do { each ->",
  "                    freshArray.at (ix) put(each)",
  "                    ix := ix - 1",
  "                }",
  "                outer.fromprimitiveArray(freshArray, size)",
  "            }",
  "            method ++(other: Iterable) {",
  "                sequence.withAll(lazyConcatenation(self, other))",
  "            }",
  "            method asString {",
  "                var s := \"⟨\"",
  "                for (0..(size-1)) do {i->",
  "                    s := s ++ inner.at(i).asString",
  "                    if (i < (size-1)) then { s := s ++ \", \" }",
  "                }",
  "                s ++ \"⟩\"",
  "            }",
  "            method contains(element) {",
  "                do { each -> if (each == element) then { return true } }",
  "                return false",
  "            }",
  "            method do(block1) {",
  "                var i := 0",
  "                while {i < size} do {",
  "                    block1.apply(inner.at(i))",
  "                    i := i + 1",
  "                }",
  "            }",
  "            method ==(other) {",
  "                isEqual (self) toIterable (other)",
  "            }",
  "            method iterator {",
  "                object {",
  "                    var idx := 1",
  "                    method asDebugString { \"{asString}⟪{idx}⟫\" }",
  "                    method asString { \"aSequenceIterator\" }",
  "                    method hasNext { idx <= sz }",
  "                    method next {",
  "                        if (idx > sz) then { IteratorExhausted.raise \"on sequence {outer}⟪{idx}⟫\" }",
  "                        def ret = at(idx)",
  "                        idx := idx + 1",
  "                        ret",
  "                    }",
  "                }",
  "            }",
  "            method sorted {",
  "                asList.sortBy { l, r ->",
  "                    if (l == r) then {0}",
  "                        elseif {l < r} then {-1}",
  "                        else {1}",
  "                }.asSequence",
  "            }",
  "            method sortedBy(sortBlock:Block2){",
  "                asList.sortBy(sortBlock:Block2).asSequence",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "type MinimalyIterable = type {",
  "    iterator -> Iterator",
  "}",
  "",
  "method isEqual(left) toIterable(right) {",
  "    if (MinimalyIterable.match(right)) then {",
  "        def leftIter = left.iterator",
  "        def rightIter = right.iterator",
  "        while {leftIter.hasNext && rightIter.hasNext} do {",
  "            if (leftIter.next != rightIter.next) then {",
  "                return false",
  "            }",
  "        }",
  "        leftIter.hasNext == rightIter.hasNext",
  "    } else { ",
  "        false",
  "    }",
  "}",
  "",
  "class list⟦T⟧ {",
  "    ",
  "    method asString { \"a list factory\" }",
  "    ",
  "    method empty -> List⟦T⟧ {",
  "        withAll(emptySequence)",
  "    }",
  "",
  "    method withAll(a: Iterable⟦T⟧) -> List⟦T⟧ {",
  "        if (engine == \"js\") then {",
  "          if (native \"js\" code ‹result = (this === superDepth) ? GraceTrue : GraceFalse;›) then {",
  "            return object {",
  "                inherits indexable.TRAIT⟦T⟧",
  "",
  "                var mods is readable := 0",
  "                var sz := 0",
  "                var jsArray := native \"js\" code ‹result = [];›",
  "                a.do { each ->",
  "                    native \"js\" code ‹this.data.jsArray.push(var_each);›",
  "                }",
  "",
  "                method size {",
  "                    native \"js\" code ‹return new GraceNum(this.data.jsArray.length);›",
  "                    sz",
  "                }",
  "",
  "                method at(n) {",
  "                    native \"js\" code ‹var ix = var_n._value;",
  "                        if ( !(ix >= 1) || !(ix <= this.data.jsArray.length)) {",
  "                            var msg = \"index \" + ix + \" out of bounds 1..\" + this.data.jsArray.length;",
  "                            var BoundsError = callmethod(Grace_prelude, \"BoundsError\", [0]);",
  "                            callmethod(BoundsError, \"raise(1)\", [1], new GraceString(msg));",
  "                        }",
  "                        return this.data.jsArray[ix - 1];›",
  "                }",
  "",
  "                method at(n)put(x) {",
  "                    mods := mods + 1",
  "                    native \"js\" code ‹var  ix = var_n._value;",
  "                        if (!(ix >= 1) || !(ix <= this.data.jsArray.length + 1)) {",
  "                            var msg = \"index \" + ix + \" out of bounds 1..\" + this.data.jsArray.length;",
  "                            var BoundsError = callmethod(Grace_prelude, \"BoundsError\", [0]);",
  "                            callmethod(BoundsError, \"raise(1)\", [1], new GraceString(msg));",
  "                        }",
  "                        this.data.jsArray[ix-1] = var_x;",
  "                        return this;›",
  "                }",
  "",
  "                method add(x:T) {",
  "                    mods := mods + 1",
  "                    native \"js\" code ‹this.data.jsArray.push(var_x);",
  "                        return this;›",
  "                }",
  "",
  "                method push(x) {",
  "                    mods := mods + 1",
  "                    native \"js\" code ‹this.data.jsArray.push(var_x);",
  "                        return this;›",
  "                }",
  "",
  "                method removeLast {",
  "                    mods := mods + 1",
  "                    native \"js\" code ‹if (this.data.jsArray.length === 0) {",
  "                        var msg = \"you can't remove an element from an empty list\";",
  "                        var BoundsError = callmethod(Grace_prelude, \"BoundsError\", [0]);",
  "                        callmethod(BoundsError, \"raise(1)\", [1], new GraceString(msg));",
  "                    } else",
  "                        return this.data.jsArray.pop();›",
  "                }",
  "",
  "                method addAllFirst(l) {",
  "                    mods := mods + 1",
  "                    var ix := l.size;",
  "                    while {ix > 0} do {",
  "                        def each = l.at(ix)",
  "                        ix := ix - 1",
  "                        native \"js\" code ‹this.data.jsArray.unshift(var_each);›",
  "                    }",
  "                    self",
  "                }",
  "",
  "                method removeAt(n) {",
  "                    mods := mods + 1",
  "                    def removed = self.at(n)    // does the bounds check",
  "                    native \"js\" code ‹this.data.jsArray.splice(var_n._value - 1, 1);›",
  "                    return removed",
  "                }",
  "",
  "                method sortBy(sortBlock:Block2) {",
  "                    mods := mods + 1",
  "                    native \"js\" code ‹var compareFun = function compareFun(a, b) {",
  "                              var res = callmethod(var_sortBlock, \"apply(2)\", [2], a, b);",
  "                              if (res.className == \"number\") return res._value;",
  "                              throw new GraceExceptionPacket(TypeErrorObject,",
  "                                     new GraceString(\"sort block in list.sortBy method did not return a number\"));",
  "                          };",
  "                          this.data.jsArray.sort(compareFun);›",
  "                    self",
  "                }",
  "                // end of native methods",
  "",
  "",
  "                method addLast(x) { push(x) }    // compatibility",
  "                method addAll(l) {",
  "                    for (l) do { each -> push(each) }",
  "                    self",
  "                }",
  "",
  "                method addFirst(elem) {",
  "                    mods := mods + 1",
  "                    native \"js\" code ‹this.data.jsArray.unshift(var_elem);›",
  "                    self",
  "                }                ",
  "",
  "                method removeFirst {",
  "                    removeAt(1)",
  "                }",
  "",
  "",
  "                method remove(elt:T) {",
  "                    def ix = self.indexOf(elt) ifAbsent {",
  "                        NoSuchObject.raise \"list does not contain object {elt}\"",
  "                    }",
  "                    removeAt(ix)",
  "                    self",
  "                }",
  "",
  "",
  "                method remove(elt:T) ifAbsent(action:Block0⟦Done⟧) {",
  "                    def ix = self.indexOf(elt) ifAbsent {",
  "                        return action.apply",
  "                    }",
  "                    removeAt(ix)",
  "                    self",
  "                }",
  "",
  "                method removeAll(vs: Iterable⟦T⟧) {",
  "                    removeAll(vs) ifAbsent { NoSuchObject.raise \"list does not contain object\" }",
  "                }",
  "",
  "",
  "                method removeAll(vs: Iterable⟦T⟧) ifAbsent(action:Block0⟦Unknown⟧)  {",
  "                    for (vs) do { each ->",
  "                        def ix = self.indexOf(each) ifAbsent { 0 }",
  "                        if (ix ≠ 0) then {",
  "                            removeAt(ix)",
  "                        } else {",
  "                            action.apply",
  "                        }",
  "                    }",
  "                    self",
  "                }",
  "",
  "                method pop { removeLast }",
  "",
  "                method reversed {",
  "                    def result = list.empty",
  "                    do { each -> result.addFirst(each) }",
  "                    result",
  "                }",
  "                method reverse {",
  "                    mods := mods + 1",
  "                    var hiIx := size",
  "                    var loIx := 1",
  "                    while {loIx < hiIx} do {",
  "                        def hiVal = self.at(hiIx)",
  "                        self.at(hiIx) put (self.at(loIx))",
  "                        self.at(loIx) put (hiVal)",
  "                        hiIx := hiIx - 1",
  "                        loIx := loIx + 1",
  "                    }",
  "                    self",
  "                }",
  "",
  "                method ++(o) {",
  "                    def l = list.withAll(self)",
  "                    l.addAll(o)",
  "                }",
  "",
  "",
  "                method asString {",
  "                    var s := \"[\"",
  "                    def curSize = self.size",
  "                    for (1..curSize) do { i ->",
  "                        s := s ++ at(i).asString",
  "                        if (i < curSize) then { s := s ++ \", \" }",
  "                    }",
  "                    s ++ \"]\"",
  "                }",
  "",
  "                method asDebugString {",
  "                    var s := \"[\"",
  "                    def curSize = self.size",
  "                    for (1..curSize) do { i ->",
  "                        s := s ++ at(i).asDebugString",
  "                        if (i < curSize) then { s := s ++ \", \" }",
  "                    }",
  "                    s ++ \"]\"",
  "                }",
  "",
  "                method extend(l) { addAll(l); done }    // compatibility",
  "",
  "",
  "                method contains(element) {",
  "                    do { each -> if (each == element) then { return true } }",
  "                    return false",
  "                }",
  "",
  "                method do(block1) {",
  "                    var i := 1",
  "                    def curSize = self.size",
  "                    while {i <= curSize} do {",
  "                        block1.apply(self.at(i))",
  "                        i := i + 1",
  "                    }",
  "                }",
  "",
  "                method ==(other) {",
  "                    isEqual (self) toIterable (other)",
  "                }",
  "",
  "                method iterator {",
  "                    object {",
  "                        var imods := mods",
  "                        var idx := 1",
  "                        method asDebugString { \"{asString}⟪{idx}⟫\" }",
  "                        method asString { \"aListIterator\" }",
  "                        method hasNext { idx <= size }",
  "                        method next {",
  "                            if (imods != mods) then {",
  "                                ConcurrentModification.raise (asDebugString)",
  "                            }",
  "                            if (idx > size) then { IteratorExhausted.raise \"on list\" }",
  "                            def ret = at(idx)",
  "                            idx := idx + 1",
  "                            ret",
  "                        }",
  "                    }",
  "                }",
  "",
  "                method values {",
  "                    self",
  "                }",
  "",
  "                method keys {",
  "                    self.indices",
  "                }",
  "",
  "                method sort {",
  "                    mods := mods + 1",
  "                    sortBy { l, r ->",
  "                        if (l == r) then {0}",
  "                            elseif {l < r} then {-1}",
  "                            else {1}",
  "                    }",
  "                }",
  "                method sortedBy(sortBlock:Block2) {",
  "                    copy.sortBy(sortBlock:Block2)",
  "                }",
  "                method sorted {",
  "                    copy.sort",
  "                }",
  "                method copy {",
  "                    outer.withAll(self)",
  "                }",
  "            }",
  "          }",
  "        }   // end of if (engine == \"js\") then ...",
  "",
  "        object {",
  "            // the new list object without native code",
  "            inherits indexable.TRAIT⟦T⟧",
  "",
  "            var mods is readable := 0",
  "            var sizeCertain := true",
  "            // size might be uncertain if a is a lazy collection.",
  "            def initialSize = a.sizeIfUnknown{ sizeCertain := false ; 4 } * 2 + 1",
  "            var inner := _prelude.primitiveArray.new(initialSize)",
  "            var size is readable := 0",
  "            if (sizeCertain) then {",
  "                // common, fast path",
  "                for (a) do { x ->",
  "                    inner.at(size)put(x)",
  "                    size := size + 1",
  "                }",
  "            } else {",
  "                // less-than-optimal path",
  "                var innerSize := initialSize",
  "                for (a) do { x ->",
  "                    if (innerSize <= size) then {",
  "                        def newInner = _prelude.primitiveArray.new(innerSize * 2)",
  "                        for (0..(innerSize-1)) do { i ->",
  "                            newInner.at (i) put (inner.at(i) )",
  "                        }",
  "                        inner := newInner",
  "                        innerSize := inner.size",
  "                    }",
  "                    inner.at(size)put(x)",
  "                    size := size + 1",
  "                }",
  "            }",
  "            method boundsCheck(n) is confidential {",
  "                if ( !(n >= 1) || !(n <= size)) then {",
  "                    BoundsError.raise \"index {n} out of bounds 1..{size}\"",
  "                }",
  "            }",
  "            method at(n) {",
  "                boundsCheck(n)",
  "                inner.at(n-1)",
  "            }",
  "            method at(n)put(x) {",
  "                mods := mods + 1",
  "                if (n == (size+1)) then {",
  "                    addLast(x)",
  "                } else {",
  "                    boundsCheck(n)",
  "                    inner.at(n-1)put(x)",
  "                }",
  "                self",
  "            }",
  "            method add(x) {",
  "                mods := mods + 1",
  "                if (size == inner.size) then { expandTo(inner.size * 2) }",
  "                inner.at(size)put(x)",
  "                size := size + 1",
  "                self",
  "            }",
  "            method addAll(l) {",
  "                mods := mods + 1",
  "                if ((size + l.size) > inner.size) then {",
  "                    expandTo(max(size + l.size, size * 2))",
  "                }",
  "                for (l) do {each ->",
  "                    inner.at(size)put(each)",
  "                    size := size + 1",
  "                }",
  "                self",
  "            }",
  "            method push(x) {",
  "                mods := mods + 1",
  "                if (size == inner.size) then { expandTo(inner.size * 2) }",
  "                inner.at(size)put(x)",
  "                size := size + 1",
  "                self",
  "            }",
  "            method addLast(x) { push(x) }    // compatibility",
  "            method removeLast {",
  "                mods := mods + 1",
  "                def result = inner.at(size - 1)",
  "                size := size - 1",
  "                result",
  "            }",
  "            method addAllFirst(l) {",
  "                mods := mods + 1",
  "                def increase = l.size",
  "                if ((size + increase) > inner.size) then {",
  "                    expandTo(max(size + increase, size * 2))",
  "                }",
  "                for (range.from(size-1)downTo(0)) do {i->",
  "                    inner.at(i+increase)put(inner.at(i))",
  "                }",
  "                var insertionIndex := 0",
  "                for (l) do {each ->",
  "                    inner.at(insertionIndex)put(each)",
  "                    insertionIndex := insertionIndex + 1",
  "                }",
  "                size := size + increase",
  "                self",
  "            }",
  "            method addFirst(elt:T) {",
  "                mods := mods + 1",
  "                if ((size + 1) > inner.size) then {",
  "                    expandTo(size * 2)",
  "                }",
  "                for (range.from (size-1) downTo 0) do {i->",
  "                    inner.at (i+1) put (inner.at(i) )",
  "                }",
  "                inner.at(0)put(elt)",
  "                size := size + 1",
  "                self",
  "            }",
  "            method removeFirst {",
  "                removeAt(1)",
  "            }",
  "            method removeAt(n) {",
  "                mods := mods + 1",
  "                boundsCheck(n)",
  "                def removed = inner.at(n-1)",
  "                for (n..(size-1)) do {i->",
  "                    inner.at(i-1)put(inner.at(i))",
  "                }",
  "                size := size - 1",
  "                return removed",
  "            }",
  "",
  "            method remove(elt:T) {",
  "                def ix = self.indexOf(elt) ifAbsent {",
  "                    NoSuchObject.raise \"list does not contain {elt}\"",
  "                }",
  "                removeAt(ix)",
  "                self",
  "            }",
  "",
  "            method remove(elt:T) ifAbsent(action:Block0⟦Done⟧) {",
  "                def ix = self.indexOf(elt) ifAbsent {",
  "                    action.apply",
  "                    return self",
  "                }",
  "                removeAt(ix)",
  "                self",
  "            }",
  "",
  "            method removeAll(vs: Iterable⟦T⟧) {",
  "                removeAll(vs) ifAbsent { NoSuchObject.raise \"list does not contain object\" }",
  "                self",
  "            }",
  "            method removeAll(vs: Iterable⟦T⟧) ifAbsent(action:Block0⟦Done⟧)  {",
  "                for (vs) do { each ->",
  "                    def ix = indexOf(each) ifAbsent { 0 }",
  "                    if (ix ≠ 0) then {",
  "                        removeAt(ix)",
  "                    } else {",
  "                        action.apply",
  "                    }",
  "                }",
  "                self",
  "            }",
  "            method pop { removeLast }",
  "            method reversed {",
  "                def result = list.empty",
  "                do { each -> result.addFirst(each) }",
  "                result",
  "            }",
  "            method reverse {",
  "                mods := mods + 1",
  "                var hiIx := size",
  "                var loIx := 1",
  "                while {loIx < hiIx} do {",
  "                    def hiVal = self.at(hiIx)",
  "                    self.at(hiIx) put (self.at(loIx))",
  "                    self.at(loIx) put (hiVal)",
  "                    hiIx := hiIx - 1",
  "                    loIx := loIx + 1",
  "                }",
  "                self",
  "            }",
  "            method ++(o) {",
  "                def l = list.withAll(self)",
  "                l.addAll(o)",
  "            }",
  "            method asString {",
  "                var s := \"[\"",
  "                for (0..(size-1)) do {i->",
  "                    s := s ++ inner.at(i).asString",
  "                    if (i < (size-1)) then { s := s ++ \", \" }",
  "                }",
  "                s ++ \"]\"",
  "            }",
  "            method asDebugString {",
  "                var s := \"[\"",
  "                for (0..(size-1)) do {i->",
  "                    s := s ++ inner.at(i).asDebugString",
  "                    if (i < (size-1)) then { s := s ++ \", \" }",
  "                }",
  "                s ++ \"]\"",
  "            }",
  "            method contains(element) {",
  "                do { each -> if (each == element) then { return true } }",
  "                return false",
  "            }",
  "            method do(block1) {",
  "                var i := 0",
  "                while {i < size} do {",
  "                    block1.apply(inner.at(i))",
  "                    i := i + 1",
  "                }",
  "            }",
  "",
  "            method ==(other) {",
  "                isEqual (self) toIterable (other)",
  "            }",
  "            method iterator {",
  "                object {",
  "                    var imods := mods",
  "                    var idx := 1",
  "                    method asDebugString { \"{asString}⟪{idx}⟫\" }",
  "                    method asString { \"aListIterator\" }",
  "                    method hasNext { idx <= size }",
  "                    method next {",
  "                        if (imods != mods) then {",
  "                            ConcurrentModification.raise (asDebugString)",
  "                        }",
  "                        if (idx > size) then { IteratorExhausted.raise \"on list\" }",
  "                        def ret = at(idx)",
  "                        idx := idx + 1",
  "                        ret",
  "                    }",
  "                }",
  "            }",
  "            method values {",
  "                self",
  "            }",
  "            method keys {",
  "                self.indices",
  "            }",
  "            method expandTo(newSize) is confidential {",
  "                def newInner = _prelude.primitiveArray.new(newSize)",
  "                for (0..(size-1)) do {i->",
  "                    newInner.at(i)put(inner.at(i))",
  "                }",
  "                inner := newInner",
  "            }",
  "            method sortBy(sortBlock:Block2) {",
  "                mods := mods + 1",
  "                inner.sortInitial(size) by(sortBlock)",
  "                self",
  "            }",
  "            method sort {",
  "                sortBy { l, r ->",
  "                    if (l == r) then {0}",
  "                        elseif {l < r} then {-1}",
  "                        else {1}",
  "                }",
  "            }",
  "            method sortedBy(sortBlock:Block2) {",
  "                copy.sortBy(sortBlock:Block2)",
  "            }",
  "            method sorted {",
  "                copy.sort",
  "            }",
  "            method copy {",
  "                outer.withAll(self)",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "",
  "def unused = object {",
  "    var unused := true",
  "    def key is public = self",
  "    def value is public = self",
  "    method asString { \"unused\" }",
  "    method == (other) { self.isMe(other) }",
  "}",
  "",
  "def removed = object {",
  "    var removed := true",
  "    def key is public = self",
  "    def value is public = self",
  "    method asString { \"removed\" }",
  "    method == (other) { self.isMe(other) }",
  "}",
  "",
  "class set⟦T⟧ {",
  "",
  "    method asString { \"a set factory\" }",
  "",
  "    method withAll(a: Iterable⟦T⟧) -> Set⟦T⟧ {",
  "        def cap = max (a.sizeIfUnknown{2} * 3 + 1, 8)",
  "        def result = ofCapacity (cap)",
  "        a.do { x -> result.add(x) }",
  "        result",
  "    }",
  "    ",
  "    method empty -> Set⟦T⟧ {",
  "        ofCapacity 8",
  "    }",
  "",
  "    class ofCapacity(cap) -> Set⟦T⟧ is confidential {",
  "        inherits collection.TRAIT",
  "        var mods is readable := 0",
  "        var inner := _prelude.primitiveArray.new(cap)",
  "        var size is readable := 0",
  "        (0..(cap - 1)).do { i ->",
  "            inner.at (i) put (unused)",
  "        }",
  "",
  "        method addAll(elements) {",
  "            mods := mods + 1",
  "            for (elements) do { x ->",
  "                if (! contains(x)) then {",
  "                    def t = findPositionForAdd(x)",
  "                    inner.at(t)put(x)",
  "                    size := size + 1",
  "                    if (size > (inner.size / 2)) then {",
  "                        expand",
  "                    }",
  "                }",
  "            }",
  "            self    // for chaining",
  "        }",
  "",
  "        method add(x:T) {",
  "            if (! contains(x)) then {",
  "                mods := mods + 1",
  "                def t = findPositionForAdd(x)",
  "                inner.at(t)put(x)",
  "                size := size + 1",
  "                if (size > (inner.size / 2)) then {",
  "                    expand",
  "                }",
  "            }",
  "            self    // for chaining",
  "        }",
  "",
  "        method removeAll(elements) {",
  "            for (elements) do { x ->",
  "                remove (x) ifAbsent {",
  "                    NoSuchObject.raise \"set does not contain {x}\"",
  "                }",
  "            }",
  "            self    // for chaining",
  "        }",
  "        method removeAll(elements)ifAbsent(block:Block1⟦T,Done⟧) {",
  "            mods := mods + 1",
  "            for (elements) do { x ->",
  "                var t := findPosition(x)",
  "                if (inner.at(t) == x) then {",
  "                    inner.at(t) put (removed)",
  "                    size := size - 1",
  "                } else {",
  "                    block.apply(x)",
  "                }",
  "            }",
  "            self    // for chaining",
  "        }",
  "",
  "        method remove (elt:T) ifAbsent (block) {",
  "            var t := findPosition(elt)",
  "            if (inner.at(t) == elt) then {",
  "                inner.at(t) put (removed)",
  "                mods := mods + 1",
  "                size := size - 1",
  "            } else {",
  "                block.apply",
  "            }",
  "            self    // for chaining",
  "        }",
  "",
  "        method remove(elt:T) {",
  "            remove (elt) ifAbsent {",
  "                NoSuchObject.raise \"set does not contain {elt}\"",
  "            }",
  "            self    // for chaining",
  "        }",
  "",
  "        method contains(x) {",
  "            var t := findPosition(x)",
  "            if (inner.at(t) == x) then {",
  "                return true",
  "            }",
  "            return false",
  "        }",
  "        method includes(booleanBlock) {",
  "            self.do { each ->",
  "                if (booleanBlock.apply(each)) then { return true }",
  "            }",
  "            return false",
  "        }",
  "        method find(booleanBlock)ifNone(notFoundBlock) {",
  "            self.do { each ->",
  "                if (booleanBlock.apply(each)) then { return each }",
  "            }",
  "            return notFoundBlock.apply",
  "        }",
  "        method findPosition(x) is confidential {",
  "            def h = x.hash",
  "            def s = inner.size",
  "            var t := h % s",
  "            var jump := 5",
  "            var candidate",
  "            while {",
  "                candidate := inner.at(t)",
  "                unused ≠ candidate",
  "            } do {",
  "                if (candidate == x) then {",
  "                    return t",
  "                }",
  "                if (jump != 0) then {",
  "                    t := (t * 3 + 1) % s",
  "                    jump := jump - 1",
  "                } else {",
  "                    t := (t + 1) % s",
  "                }",
  "            }",
  "            return t",
  "        }",
  "        method findPositionForAdd(x) is confidential {",
  "            def h = x.hash",
  "            def s = inner.size",
  "            var t := h % s",
  "            var jump := 5",
  "            var candidate",
  "            while {",
  "                candidate := inner.at(t)",
  "                (unused != candidate) && (removed != candidate)",
  "            } do {",
  "                if (candidate == x) then {",
  "                    return t",
  "                }",
  "                if (jump != 0) then {",
  "                    t := (t * 3 + 1) % s",
  "                    jump := jump - 1",
  "                } else {",
  "                    t := (t + 1) % s",
  "                }",
  "            }",
  "            return t",
  "        }",
  "",
  "        method asString {",
  "            var s := \"set\\{\"",
  "            do {each -> s := s ++ each.asString }",
  "                separatedBy { s := s ++ \", \" }",
  "            s ++ \"\\}\"",
  "        }",
  "        method asDebugString {",
  "            var s := \"set\\{\"",
  "            do {each -> s := s ++ each.asDebugString }",
  "                separatedBy { s := s ++ \", \" }",
  "            s ++ \"\\}\"",
  "        }",
  "        method extend(l) {",
  "            for (l) do {i->",
  "                add(i)",
  "            }",
  "        }",
  "        method do(block1) {",
  "            var i := 0",
  "            var found := 0",
  "            var candidate",
  "            while {found < size} do {",
  "                candidate := inner.at(i)",
  "                if ((unused != candidate) && (removed != candidate)) then {",
  "                    found := found + 1",
  "                    block1.apply(candidate)",
  "                }",
  "                i := i + 1",
  "            }",
  "        }",
  "        method iterator {",
  "            object {",
  "                var imods:Number := mods",
  "                var count := 1",
  "                var idx := -1",
  "                method hasNext { size >= count }",
  "                method next {",
  "                    var candidate",
  "                    def innerSize = inner.size",
  "                    while {",
  "                        idx := idx + 1",
  "                        if (imods != mods) then {",
  "                            ConcurrentModification.raise (outer.asString)",
  "                        }",
  "                        if (idx >= innerSize) then {",
  "                            IteratorExhausted.raise \"iterator over {outer.asString}\"",
  "                        }",
  "                        candidate := inner.at(idx)",
  "                        (unused == candidate) || (removed == candidate)",
  "                    } do { }",
  "                    count := count + 1",
  "                    candidate",
  "                }",
  "            }",
  "        }",
  "",
  "        method expand is confidential {",
  "            def c = inner.size",
  "            def n = c * 2",
  "            def oldInner = inner",
  "            size := 0",
  "            inner := _prelude.primitiveArray.new(n)",
  "            for (0..(inner.size-1)) do {i->",
  "                inner.at(i)put(unused)",
  "            }",
  "            for (0..(oldInner.size-1)) do {i->",
  "                if ((unused != oldInner.at(i)) && (removed != oldInner.at(i))) then {",
  "                    add(oldInner.at(i))",
  "                }",
  "            }",
  "        }",
  "        method ==(other) {",
  "            if (Iterable.match(other)) then {",
  "                var otherSize := 0",
  "                other.do { each ->",
  "                    otherSize := otherSize + 1",
  "                    if (! self.contains(each)) then {",
  "                        return false",
  "                    }",
  "                }",
  "                otherSize == self.size",
  "            } else { ",
  "                false",
  "            }",
  "        }",
  "        method copy {",
  "            outer.withAll(self)",
  "        }",
  "        method ++ (other) {",
  "        // set union",
  "            copy.addAll(other)",
  "        }",
  "        method -- (other) {",
  "        // set difference",
  "            def result = set.empty",
  "            for (self) do {v->",
  "                if (!other.contains(v)) then {",
  "                    result.add(v)",
  "                }",
  "            }",
  "            result",
  "        }",
  "        method ** (other) {",
  "        // set intersection",
  "            (filter {each -> other.contains(each)}).asSet",
  "        }",
  "        method isSubset(s2: Set⟦T⟧) {",
  "            self.do{ each ->",
  "                if (s2.contains(each).not) then { return false }",
  "            }",
  "            return true",
  "        }",
  "",
  "        method isSuperset(s2: Iterable⟦T⟧) {",
  "            s2.do{ each ->",
  "                if (self.contains(each).not) then { return false }",
  "            }",
  "            return true",
  "        }",
  "        method into(existing: Expandable⟦T⟧) -> Collection⟦T⟧ {",
  "            do { each -> existing.add(each) }",
  "            existing",
  "        }",
  "    }",
  "}",
  "",
  "type Binding⟦K,T⟧ = {",
  "    key -> K",
  "    value -> T",
  "    hash -> Number",
  "    ==(other) -> Boolean",
  "}",
  "",
  "def binding = object {",
  "    method asString { \"binding class\" }",
  "",
  "    class key(k)value(v) {",
  "        method key {k}",
  "        method value {v}",
  "        method asString { \"{k}::{v}\" }",
  "        method hashcode { (k.hashcode * 1021) + v.hashcode }",
  "        method hash { (k.hash * 1021) + v.hash }",
  "        method == (other) {",
  "            match (other)",
  "                case {o:Binding -> (k == o.key) && (v == o.value) }",
  "                case {_ -> return false }",
  "        }",
  "    }",
  "}",
  "",
  "type ComparableToDictionary⟦K,T⟧ = type {",
  "    size -> Number",
  "    at(_:K)ifAbsent(_) -> T",
  "}",
  "",
  "class dictionary⟦K,T⟧ {",
  "",
  "    method asString { \"a dictionary factory\" }",
  "",
  "    method withAll(initialBindings: Iterable⟦Binding⟦K,T⟧⟧) -> Dictionary⟦K,T⟧ {",
  "        def result = empty",
  "        for (initialBindings) do { b -> result.add(b) }",
  "        result",
  "    }",
  "",
  "    class empty -> Dictionary⟦K,T⟧ {",
  "        inherits collection.TRAIT⟦T⟧",
  "        var mods is readable := 0",
  "        var numBindings := 0",
  "        var inner := _prelude.primitiveArray.new(8)",
  "        for (0..(inner.size-1)) do { i ->",
  "            inner.at(i)put(unused)",
  "        }",
  "        method size { numBindings }",
  "        method at(key')put(value') {",
  "            mods := mods + 1",
  "            var t := findPositionForAdd(key')",
  "            if ((unused == inner.at(t)) || (removed == inner.at(t))) then {",
  "                numBindings := numBindings + 1",
  "            }",
  "            inner.at(t)put(binding.key(key')value(value'))",
  "            if ((size * 2) > inner.size) then { expand }",
  "            self    // for chaining",
  "        }",
  "        method add(aBinding) {",
  "            mods := mods + 1",
  "            var t := findPositionForAdd (aBinding.key)",
  "            if ((unused == inner.at(t)) || (removed == inner.at(t))) then {",
  "                numBindings := numBindings + 1",
  "            }",
  "            inner.at(t)put(aBinding)",
  "            if ((size * 2) > inner.size) then { expand }",
  "            self    // for chaining",
  "        }",
  "        method at(k) {",
  "            var b := inner.at(findPosition(k))",
  "            if (b.key == k) then {",
  "                return b.value",
  "            }",
  "            NoSuchObject.raise \"dictionary does not contain entry with key {k}\"",
  "        }",
  "        method at(k) ifAbsent(action) {",
  "            var b := inner.at(findPosition(k))",
  "            if (b.key == k) then {",
  "                return b.value",
  "            }",
  "            action.apply",
  "        }",
  "        method containsKey(k) {",
  "            var t := findPosition(k)",
  "            if (inner.at(t).key == k) then {",
  "                return true",
  "            }",
  "            false",
  "        }",
  "        method removeAllKeys(keys) {",
  "            mods := mods + 1",
  "            for (keys) do { k ->",
  "                var t := findPosition(k)",
  "                if (inner.at(t).key == k) then {",
  "                    inner.at(t)put(removed)",
  "                    numBindings := numBindings - 1",
  "                } else {",
  "                    NoSuchObject.raise \"dictionary does not contain entry with key {k}\"",
  "                }",
  "            }",
  "            self",
  "        }",
  "        method removeKey(k:K) {",
  "            mods := mods + 1",
  "            var t := findPosition(k)",
  "            if (inner.at(t).key == k) then {",
  "                inner.at(t)put(removed)",
  "                numBindings := numBindings - 1",
  "            } else {",
  "                NoSuchObject.raise \"dictionary does not contain entry with key {k}\"",
  "            }",
  "            self",
  "        }",
  "        method removeAllValues(removals) {",
  "            mods := mods + 1",
  "            for (0..(inner.size-1)) do {i->",
  "                def a = inner.at(i)",
  "                if (removals.contains(a.value)) then {",
  "                    inner.at(i)put(removed)",
  "                    numBindings := numBindings - 1",
  "                }",
  "            }",
  "            self",
  "        }",
  "        method removeValue(v) {",
  "            // remove all bindings with value v",
  "            mods := mods + 1",
  "            def initialNumBindings = numBindings",
  "            for (0..(inner.size-1)) do {i->",
  "                def a = inner.at(i)",
  "                if (v == a.value) then {",
  "                    inner.at (i) put (removed)",
  "                    numBindings := numBindings - 1",
  "                }",
  "            }",
  "            if (numBindings == initialNumBindings) then {",
  "                NoSuchObject.raise \"dictionary does not contain entry with value {v}\"",
  "            }",
  "            self",
  "        }",
  "        method removeValue(v) ifAbsent (action:Block0⟦Unknown⟧) {",
  "            // remove all bindings with value v",
  "            mods := mods + 1",
  "            def initialNumBindings = numBindings",
  "            for (0..(inner.size-1)) do {i->",
  "                def a = inner.at(i)",
  "                if (v == a.value) then {",
  "                    inner.at (i) put (removed)",
  "                    numBindings := numBindings - 1",
  "                }",
  "            }",
  "            if (numBindings == initialNumBindings) then {",
  "                action.apply",
  "            }",
  "            self",
  "        }",
  "        method containsValue(v) {",
  "            self.valuesDo{ each ->",
  "                if (v == each) then { return true }",
  "            }",
  "            false",
  "        }",
  "        method contains(v) { containsValue(v) }",
  "",
  "        method findPosition(x) is confidential {",
  "            def h = x.hash",
  "            def s = inner.size",
  "            var t := h % s",
  "            var jump := 5",
  "            while { unused ≠ inner.at(t) } do {",
  "                if (inner.at(t).key == x) then {",
  "                    return t",
  "                }",
  "                if (jump != 0) then {",
  "                    t := (t * 3 + 1) % s",
  "                    jump := jump - 1",
  "                } else {",
  "                    t := (t + 1) % s",
  "                }",
  "            }",
  "            return t",
  "        }",
  "        method findPositionForAdd(x) is confidential {",
  "            def h = x.hash",
  "            def s = inner.size",
  "            var t := h % s",
  "            var jump := 5",
  "            while { (unused ≠ inner.at(t)) && (removed ≠ inner.at(t)) } do {",
  "                if (inner.at(t).key == x) then {",
  "                    return t",
  "                }",
  "                if (jump != 0) then {",
  "                    t := (t * 3 + 1) % s",
  "                    jump := jump - 1",
  "                } else {",
  "                    t := (t + 1) % s",
  "                }",
  "            }",
  "            return t",
  "        }",
  "        method asString {",
  "            // do()separatedBy won't work, because it iterates over values,",
  "            // and we need an iterator over bindings.",
  "            var s := \"dict⟬\"",
  "            var firstElement := true",
  "            for (0..(inner.size-1)) do {i->",
  "                def a = inner.at(i)",
  "                if ((unused ≠ a) && (removed ≠ a)) then {",
  "                    if (! firstElement) then {",
  "                        s := s ++ \", \"",
  "                    } else {",
  "                        firstElement := false",
  "                    }",
  "                    s := s ++ \"{a.key}::{a.value}\"",
  "                }",
  "            }",
  "            s ++ \"⟭\"",
  "        }",
  "        method asDebugString {",
  "            var s := \"dict⟬\"",
  "            for (0..(inner.size-1)) do {i->",
  "                if (i > 0) then { s := s ++ \", \" }",
  "                def a = inner.at(i)",
  "                if ((unused ≠ a) && (removed ≠ a)) then {",
  "                    s := s ++ \"{i}→{a.key}::{a.value}\"",
  "                } else {",
  "                    s := s ++ \"{i}→{a.asDebugString}\"",
  "                }",
  "            }",
  "            s ++ \"⟭\"",
  "        }",
  "        method keys -> Enumerable⟦K⟧ {",
  "            def sourceDictionary = self",
  "            object {",
  "                inherits enumerable.TRAIT⟦K⟧",
  "                class iterator {",
  "                    def sourceIterator = sourceDictionary.bindingsIterator",
  "                    method hasNext { sourceIterator.hasNext }",
  "                    method next { sourceIterator.next.key }",
  "                    method asString {",
  "                        \"an iterator over keys of {sourceDictionary}\"",
  "                    }",
  "                }",
  "                def size is public = sourceDictionary.size",
  "                method asDebugString {",
  "                    \"a lazy sequence over keys of {sourceDictionary}\"",
  "                }",
  "            }",
  "        }",
  "        method values -> Enumerable⟦T⟧ {",
  "            def sourceDictionary = self",
  "            object {",
  "                inherits enumerable.TRAIT⟦T⟧",
  "                class iterator {",
  "                    def sourceIterator = sourceDictionary.bindingsIterator",
  "                    // should be request on outer",
  "                    method hasNext { sourceIterator.hasNext }",
  "                    method next { sourceIterator.next.value }",
  "                    method asString {",
  "                        \"an iterator over values of {sourceDictionary}\"",
  "                    }",
  "                }",
  "                def size is public = sourceDictionary.size",
  "                method asDebugString {",
  "                    \"a lazy sequence over values of {sourceDictionary}\"",
  "                }",
  "            }",
  "        }",
  "        method bindings -> Enumerable⟦T⟧ {",
  "            def sourceDictionary = self",
  "            object {",
  "                inherits enumerable.TRAIT⟦T⟧",
  "                method iterator { sourceDictionary.bindingsIterator }",
  "                // should be request on outer",
  "                def size is public = sourceDictionary.size",
  "                method asDebugString {",
  "                    \"a lazy sequence over bindings of {sourceDictionary}\"",
  "                }",
  "            }",
  "        }",
  "        method iterator -> Iterator⟦T⟧ { values.iterator }",
  "        class bindingsIterator -> Iterator⟦Binding⟦K, T⟧⟧ {",
  "            // this should be confidential, but can't be until `outer` is fixed.",
  "            def imods:Number = mods",
  "            var count := 1",
  "            var idx := 0",
  "            var elt",
  "            method hasNext { size >= count }",
  "            method next {",
  "                if (imods != mods) then {",
  "                    ConcurrentModification.raise (outer.asString)",
  "                }",
  "                if (size < count) then { IteratorExhausted.raise \"over {outer.asString}\" }",
  "                while {",
  "                    elt := inner.at(idx)",
  "                    (unused == elt) || (removed == elt)",
  "                } do {",
  "                    idx := idx + 1",
  "                }",
  "                count := count + 1",
  "                idx := idx + 1",
  "                elt",
  "            }",
  "        }",
  "        method expand is confidential {",
  "            def c = inner.size",
  "            def n = c * 2",
  "            def oldInner = inner",
  "            inner := _prelude.primitiveArray.new(n)",
  "            for (0..(n - 1)) do {i->",
  "                inner.at(i)put(unused)",
  "            }",
  "            numBindings := 0",
  "            for (0..(c - 1)) do {i->",
  "                def a = oldInner.at(i)",
  "                if ((unused ≠ a) && (removed ≠ a)) then {",
  "                    self.at(a.key)put(a.value)",
  "                }",
  "            }",
  "        }",
  "        method keysAndValuesDo(block2) {",
  "            for (0..(inner.size-1)) do {i->",
  "                def a = inner.at(i)",
  "                if ((unused ≠ a) && (removed ≠ a)) then {",
  "                    block2.apply(a.key, a.value)",
  "                }",
  "            }",
  "        }",
  "        method keysDo(block1) {",
  "            for (0..(inner.size-1)) do {i->",
  "                def a = inner.at(i)",
  "                if ((unused ≠ a) && (removed ≠ a)) then {",
  "                    block1.apply(a.key)",
  "                }",
  "            }",
  "        }",
  "        method valuesDo(block1) {",
  "            for (0..(inner.size-1)) do {i->",
  "                def a = inner.at(i)",
  "                if ((unused ≠ a) && (removed ≠ a)) then {",
  "                    block1.apply(a.value)",
  "                }",
  "            }",
  "        }",
  "        method do(block1) { valuesDo(block1) }",
  "",
  "        method ==(other) {",
  "            match (other)",
  "                case {o:ComparableToDictionary⟦K,V⟧ ->",
  "                    if (self.size != o.size) then {return false}",
  "                    self.keysAndValuesDo { k, v ->",
  "                        if (o.at(k)ifAbsent{return false} != v) then {",
  "                            return false",
  "                        }",
  "                    }",
  "                    return true",
  "                }",
  "                case {_ ->",
  "                    return false",
  "                }",
  "        }",
  "",
  "        method copy {",
  "            def newCopy = dictionary.empty",
  "            self.keysAndValuesDo{ k, v ->",
  "                newCopy.at(k)put(v)",
  "            }",
  "            newCopy",
  "        }",
  "",
  "        method asDictionary {",
  "            self",
  "        }",
  "",
  "        method ++(other) {",
  "            def newDict = self.copy",
  "            other.keysAndValuesDo {k, v ->",
  "                newDict.at(k) put(v)",
  "            }",
  "            return newDict",
  "        }",
  "",
  "        method --(other) {",
  "            def newDict = dictionary.empty",
  "            keysAndValuesDo { k, v ->",
  "                if (! other.containsKey(k)) then {",
  "                    newDict.at(k) put(v)",
  "                }",
  "            }",
  "            return newDict",
  "        }",
  "    }",
  "}",
  "",
  "class range {",
  "    method from(lower)to(upper) -> Sequence⟦Number⟧ {",
  "        match (lower)",
  "            case {_:Number -> }",
  "            case {_ -> RequestError.raise (\"lower bound {lower}\" ++",
  "                \" in range.from({lower})to({upper}) is not an integer\") }",
  "        def start = lower.truncated",
  "        if (start != lower) then {",
  "            RequestError.raise (\"lower bound {lower}\" ++",
  "                \" in range.from({lower})to({upper}) is not an integer\") }",
  "",
  "        match (upper)",
  "            case {_:Number -> }",
  "            case {_ -> RequestError.raise (\"upper bound {upper}\" ++",
  "                \" in range.from({lower})to({upper}) is not an integer\") }",
  "        def stop = upper.truncated",
  "        if (stop != upper) then {",
  "            RequestError.raise (\"upper bound {upper}\" ++",
  "                \" in range.from()to() is not an integer\")",
  "        }",
  "",
  "        uncheckedFrom (lower) to (upper)",
  "    }",
  "",
  "    method uncheckedFrom (lower) to (upper) -> Sequence⟦Number⟧ {",
  "        object {",
  "            inherits indexable.TRAIT⟦Number⟧",
  "            def start = lower",
  "            def stop = upper",
  "            def size is public =",
  "                if ((upper-lower+1) < 0) then { 0 } else {upper-lower+1}",
  "",
  "            def hash is public = { ((start.hash * 1021) + stop.hash) * 3 }",
  "",
  "            method iterator -> Iterator {",
  "                object {",
  "                    var val := start",
  "                    method hasNext { val <= stop }",
  "                    method next {",
  "                        if (val > stop) then {",
  "                            IteratorExhausted.raise \"over {outer.asString}\"",
  "                        }",
  "                        val := val + 1",
  "                        return (val - 1)",
  "                    }",
  "                    method asString { \"{super.asString} from {upper} to {lower}\" }",
  "                }",
  "            }",
  "            method at(ix:Number) {",
  "                if (!(ix <= self.size)) then {",
  "                    BoundsError.raise \"requested range.at({ix}), but upper bound is {size}\"",
  "                }",
  "                if (!(ix >= 1)) then {",
  "                    BoundsError.raise \"requested range.at({ix}), but lower bound is 1\"",
  "                }",
  "                return start + (ix - 1)",
  "            }",
  "            method contains(elem) -> Boolean {",
  "                try {",
  "                    def intElem = elem.truncated",
  "                    if (intElem != elem) then {return false}",
  "                    if (intElem < start) then {return false}",
  "                    if (intElem > stop) then {return false}",
  "                } catch { ex:_prelude.Exception -> return false }",
  "                return true",
  "            }",
  "            method do(block1) {",
  "                var val := start",
  "                while {val <= stop} do {",
  "                    block1.apply(val)",
  "                    val := val + 1",
  "                }",
  "            }",
  "            method keysAndValuesDo(block2) {",
  "                var key := 1",
  "                var val := start",
  "                while {val <= stop} do {",
  "                    block2.apply(key, val)",
  "                    key := key + 1",
  "                    val := val + 1",
  "                }",
  "            }",
  "            method reversed {",
  "                from(upper)downTo(lower)",
  "            }",
  "            method ++(other) {",
  "                sequence.withAll(lazyConcatenation(self, other))",
  "            }",
  "            method ==(other) {",
  "                isEqual (self) toIterable (other)",
  "            }",
  "            method sorted { self }",
  "",
  "            method sortedBy(c) { self.asList.sortBy(c) }",
  "",
  "            method keys { 1..self.size }",
  "",
  "            method values { self }",
  "",
  "            method asString -> String{",
  "                \"range.from({lower})to({upper})\"",
  "            }",
  "",
  "            method asList{",
  "                var result := list.empty",
  "                for (self) do { each -> result.add(each) }",
  "                result",
  "            }",
  "",
  "            method asSequence {",
  "                self",
  "            }",
  "        }",
  "    }",
  "    method from(upper)downTo(lower) -> Sequence⟦Number⟧ {",
  "        object {",
  "            inherits indexable.TRAIT",
  "            match (upper)",
  "                case {_:Number -> }",
  "                case {_ -> RequestError.raise (\"upper bound {upper}\" ++",
  "                    \" in range.from({upper})downTo({lower}) is not an integer\") }",
  "            def start = upper.truncated",
  "            if (start != upper) then {",
  "                RequestError.raise (\"upper bound {upper}\" ++",
  "                    \" in range.from({upper})downTo({lower}) is not an integer\")",
  "            }",
  "            match (lower)",
  "                case {_:Number -> }",
  "                case {_ -> RequestError.raise (\"lower bound {lower}\" ++",
  "                    \" in range.from({upper})downTo({lower}) is not an integer\") }",
  "            def stop = lower.truncated",
  "            if (stop != lower) then {",
  "                RequestError.raise (\"lower bound {lower}\" ++",
  "                    \" in range.from({upper})downTo({lower}) is not an integer\")",
  "            }",
  "            def size is public =",
  "                if ((upper-lower+1) < 0) then { 0 } else {upper-lower+1}",
  "            method iterator {",
  "                object {",
  "                    var val := start",
  "                    method hasNext { val >= stop }",
  "                    method next {",
  "                        if (val < stop) then { IteratorExhausted.raise \"over {outer.asString}\" }",
  "                        val := val - 1",
  "                        return (val + 1)",
  "                    }",
  "                    method asString { \"anIterator over {super.asString}\" }",
  "                }",
  "            }",
  "            method at(ix:Number) {",
  "                if (!(ix <= self.size)) then {",
  "                    BoundsError.raise \"requested range.at({ix}) but upper bound is {size}\"",
  "                }",
  "                if (!(ix >= 1)) then {",
  "                    BoundsError.raise \"requested range.at({ix}) but lower bound is 1\"",
  "                }",
  "                return start - (ix - 1)",
  "            }",
  "            method contains(elem) -> Boolean {",
  "                try {",
  "                    def intElem = elem.truncated",
  "                    if (intElem != elem) then {return false}",
  "                    if (intElem > start) then {return false}",
  "                    if (intElem < stop) then {return false}",
  "                } catch { ex:_prelude.Exception -> return false }",
  "                return true",
  "            }",
  "            method do(block1) {",
  "                var val := start",
  "                while {val >= stop} do {",
  "                    block1.apply(val)",
  "                    val := val - 1",
  "                }",
  "            }",
  "            method keysAndValuesDo(block2) {",
  "                var key := 1",
  "                var val := start",
  "                while {val >= stop} do {",
  "                    block2.apply(key, val)",
  "                    key := key + 1",
  "                    val := val - 1",
  "                }",
  "            }",
  "            method reversed {",
  "                from(lower)to(upper)",
  "            }",
  "            method ++(other) {",
  "                sequence.withAll(lazyConcatenation(self, other))",
  "            }",
  "            method ==(other) {",
  "                isEqual (self) toIterable (other)",
  "            }",
  "            method sorted { self.reversed }",
  "",
  "            method sortedBy(c) { self.asList.sortBy(c) }",
  "",
  "            method keys { 1..self.size }",
  "",
  "            method values { self }",
  "",
  "            method asString -> String {",
  "                \"range.from {upper} downTo {lower}\"",
  "            }",
  "            method asSequence {",
  "                self",
  "            }",
  "        }",
  "    }",
  "}",
  NULL
};
Object reader_collectionsPrelude_outer_7(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_10(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_sourceIterator_11(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_outer_49(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_52(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_cache_53(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_cache_53(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_cacheLoaded_54(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_cacheLoaded_54(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_sourceIterator_55(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_outer_153(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_190(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_237(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_325(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_size_326(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_inner_327(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_outer_558(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_idx_559(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_idx_559(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_708(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_724(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_mods_725(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_mods_725(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_sz_726(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_sz_726(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_jsArray_727(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_collectionsPrelude_jsArray_727(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_1087(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_imods_1088(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_imods_1088(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_idx_1089(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_idx_1089(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_1226(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_mods_1227(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_mods_1227(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_sizeCertain_1228(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_sizeCertain_1228(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_initialSize_1229(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_inner_1230(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_collectionsPrelude_inner_1230(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_collectionsPrelude_size_1231(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_collectionsPrelude_size_1231(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_1988(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_imods_1989(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_imods_1989(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_idx_1990(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_idx_1990(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_2267(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_2305(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_mods_2306(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_mods_2306(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_inner_2307(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_inner_2307(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_size_2308(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_collectionsPrelude_size_2308(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_2776(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_imods_2777(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_imods_2777(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_count_2778(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_count_2778(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_idx_2779(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_collectionsPrelude_idx_2779(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_3089(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_3104(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_mods_3105(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_mods_3105(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_numBindings_3106(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_numBindings_3106(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_inner_3107(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_collectionsPrelude_inner_3107(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_3876(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_3879(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_sourceIterator_3880(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_size_3905(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_outer_3922(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_3925(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_sourceIterator_3926(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_size_3951(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_outer_3968(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_size_3972(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_outer_3994(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_imods_3995(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_count_3996(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_count_3996(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_idx_3997(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_collectionsPrelude_idx_3997(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_collectionsPrelude_elt_3998(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_collectionsPrelude_elt_3998(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_4421(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_4569(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_start_4570(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_stop_4571(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_size_4572(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_hash_4573(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_collectionsPrelude_outer_4576(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_val_4577(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_val_4577(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_4926(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_start_4927(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_stop_4928(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_size_4929(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_outer_4932(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_val_4933(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_val_4933(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_5496(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5499(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5624(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5627(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5796(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5799(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5950(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_6004(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_6023(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_unused_6024(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_unused_6024(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_key_6025(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_value_6026(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_outer_6035(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_removed_6036(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_removed_6036(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_key_6037(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_value_6038(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_outer_6050(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_6055(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
static Object strlit3;
static ClassData objclass6;
static ClassData objclass9;
static Object strlit13;
static Object strlit37;
static Object strlit41;
static ClassData objclass48;
static ClassData objclass51;
static Object strlit58;
static Object strlit62;
static Object strlit141;
static Object strlit145;
static ClassData objclass152;
static Object strlit171;
static Object strlit176;
static Object strlit180;
static Object strlit186;
static ClassData objclass189;
static Object strlit202;
static Object strlit207;
static Object strlit211;
static ClassData objclass236;
static Object strlit239;
static ClassData objclass324;
static Object strlit348;
static Object strlit355;
static Object strlit359;
static Object strlit466;
static Object strlit501;
static Object strlit508;
static ClassData objclass557;
static Object strlit562;
static Object strlit569;
static Object strlit575;
static Object strlit581;
static Object strlit597;
static Object strlit604;
static Object strlit610;
static ClassData objclass707;
static Object strlit710;
static Object strlit717;
static ClassData objclass723;
static Object strlit848;
static Object strlit852;
static Object strlit875;
static Object strlit972;
static Object strlit995;
static Object strlit1002;
static Object strlit1006;
static Object strlit1029;
static Object strlit1036;
static ClassData objclass1086;
static Object strlit1092;
static Object strlit1099;
static Object strlit1105;
static Object strlit1111;
static Object strlit1148;
static ClassData objclass1225;
static Object strlit1252;
static Object strlit1259;
static Object strlit1263;
static Object strlit1726;
static Object strlit1730;
static Object strlit1753;
static Object strlit1850;
static Object strlit1885;
static Object strlit1892;
static Object strlit1896;
static Object strlit1931;
static Object strlit1938;
static ClassData objclass1987;
static Object strlit1993;
static Object strlit2000;
static Object strlit2006;
static Object strlit2012;
static Object strlit2049;
static ClassData objclass2266;
static Object strlit2269;
static ClassData objclass2304;
static Object strlit2411;
static Object strlit2415;
static Object strlit2500;
static Object strlit2504;
static Object strlit2674;
static Object strlit2688;
static Object strlit2695;
static Object strlit2699;
static Object strlit2713;
static Object strlit2720;
static ClassData objclass2775;
static Object strlit2832;
static Object strlit2840;
static ClassData objclass3088;
static Object strlit3091;
static ClassData objclass3103;
static Object strlit3246;
static Object strlit3250;
static Object strlit3324;
static Object strlit3328;
static Object strlit3369;
static Object strlit3373;
static Object strlit3482;
static Object strlit3486;
static Object strlit3706;
static Object strlit3741;
static Object strlit3749;
static Object strlit3756;
static Object strlit3762;
static Object strlit3773;
static Object strlit3777;
static Object strlit3799;
static Object strlit3819;
static Object strlit3826;
static Object strlit3833;
static Object strlit3837;
static Object strlit3849;
static Object strlit3856;
static Object strlit3860;
static Object strlit3871;
static ClassData objclass3875;
static ClassData objclass3878;
static Object strlit3895;
static Object strlit3899;
static Object strlit3908;
static Object strlit3912;
static ClassData objclass3921;
static ClassData objclass3924;
static Object strlit3941;
static Object strlit3945;
static Object strlit3954;
static Object strlit3958;
static ClassData objclass3967;
static Object strlit3975;
static Object strlit3979;
static ClassData objclass3993;
static Object strlit4038;
static Object strlit4046;
static Object strlit4328;
static ClassData objclass4420;
static Object strlit4429;
static Object strlit4441;
static Object strlit4446;
static Object strlit4450;
static Object strlit4457;
static Object strlit4461;
static Object strlit4476;
static Object strlit4481;
static Object strlit4485;
static Object strlit4492;
static Object strlit4496;
static Object strlit4507;
static Object strlit4519;
static Object strlit4524;
static Object strlit4528;
static Object strlit4535;
static Object strlit4539;
static Object strlit4553;
static Object strlit4556;
static Object strlit4560;
static ClassData objclass4568;
static ClassData objclass4575;
static Object strlit4601;
static Object strlit4609;
static Object strlit4629;
static Object strlit4634;
static Object strlit4639;
static Object strlit4645;
static Object strlit4668;
static Object strlit4675;
static Object strlit4679;
static Object strlit4694;
static Object strlit4698;
static Object strlit4743;
static Object strlit4848;
static Object strlit4853;
static Object strlit4857;
static ClassData objclass4925;
static ClassData objclass4931;
static Object strlit4957;
static Object strlit4965;
static Object strlit4985;
static Object strlit4991;
static Object strlit5010;
static Object strlit5017;
static Object strlit5021;
static Object strlit5036;
static Object strlit5040;
static Object strlit5085;
static Object strlit5192;
static Object strlit5197;
static Object strlit5201;
static Object strlit5215;
static Object strlit5227;
static Object strlit5232;
static Object strlit5236;
static Object strlit5243;
static Object strlit5247;
static Object strlit5264;
static Object strlit5269;
static Object strlit5273;
static Object strlit5280;
static Object strlit5284;
static Object strlit5295;
static Object strlit5307;
static Object strlit5312;
static Object strlit5316;
static Object strlit5323;
static Object strlit5327;
static Object strlit5344;
static Object strlit5349;
static Object strlit5353;
static Object strlit5360;
static Object strlit5364;
static Object strlit5392;
static Object strlit5398;
static Object strlit5404;
static Object strlit5410;
static Object strlit5416;
static Object strlit5422;
static Object strlit5428;
static ClassData objclass5495;
static ClassData objclass5498;
static Object strlit5501;
static Object strlit5507;
static Object strlit5540;
static Object strlit5544;
static Object strlit5621;
static ClassData objclass5623;
static ClassData objclass5626;
static Object strlit5638;
static Object strlit5644;
static Object strlit5765;
static Object strlit5779;
static Object strlit5786;
static Object strlit5793;
static ClassData objclass5795;
static ClassData objclass5798;
static Object strlit5888;
static Object strlit5892;
static Object strlit5947;
static ClassData objclass5949;
static Object strlit5958;
static Object strlit5962;
static Object strlit5978;
static Object strlit5991;
static ClassData objclass6003;
static Object strlit6006;
static Object strlit6011;
static ClassData objclass6022;
static Object strlit6028;
static ClassData objclass6034;
static Object strlit6040;
static ClassData objclass6049;
static Object strlit6052;
static ClassData objclass6054;
static Object strlit6060;
static Object strlit6065;
static Object strlit6069;
static Object strlit6118;
Object meth_collectionsPrelude_abstract1(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "abstract");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SubobjectResponsibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit3 == NULL) {
    strlit3 = alloc_String("abstract method not overriden by subobject");
    gc_root(strlit3);
  }
// compiled string node returning strlit3 (depth = 3)
  gc_frame_newslot(strlit3);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_SubobjectResponsibility (depth = 3)
  params[0] = strlit3;
  partcv[0] = 1;
  Object call4 = callmethodflags(*var_SubobjectResponsibility, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2);
// compiled call node returning call4 (depth = 2)
  gc_frame_end(frame);
  return call4;
}
Object meth_collectionsPrelude_asString12(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 171
  setline(171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit13 == NULL) {
    strlit13 = alloc_String("an iterator over a lazy map sequence");
    gc_root(strlit13);
  }
// compiled string node returning strlit13 (depth = 2)
  gc_frame_end(frame);
  return strlit13;
}
Object meth_collectionsPrelude_hasNext14(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 172
  setline(172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe15 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe16 = gc_frame_new();
// call case 4: self request
  Object call17 = callmethodflags(self, "sourceIterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe16);
// compiled member node returning call17 (depth = 3)
  Object call18 = callmethodflags(call17, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe15);
// compiled member node returning call18 (depth = 2)
  gc_frame_end(frame);
  return call18;
}
Object meth_collectionsPrelude_next19(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_function = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 173
  setline(173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe20 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe21 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe22 = gc_frame_new();
// call case 4: self request
  Object call23 = callmethodflags(self, "sourceIterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe22);
// compiled member node returning call23 (depth = 4)
  Object call24 = callmethodflags(call23, "next", 0, partcv, params, 0);
  gc_frame_end(callframe21);
// compiled member node returning call24 (depth = 3)
  gc_frame_newslot(call24);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_function (depth = 3)
  params[0] = call24;
  partcv[0] = 1;
  Object call25 = callmethodflags(*var_function, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe20);
// compiled call node returning call25 (depth = 2)
  gc_frame_end(frame);
  return call25;
}
Object meth_collectionsPrelude_iterator8(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_function = getfromclosure(closure, 0);
  Object *var_source = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9 = alloc_userobj2(4,5, objclass9);
  gc_frame_newslot(obj9);
if (objclass9 == NULL) {
  glfree(obj9->class->name);
  obj9->class->name = "lazySequenceOver(_)mappedBy(_).iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9, self, 0);
  addmethodreal(obj9,"outer", &reader_collectionsPrelude_outer_10);
  Object oldself9 = self;
  struct StackFrameObject *oldstackframe9 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9);
  gc_frame_newslot((Object)stackframe);
  self = obj9;
  Object *oldselfslot9 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9 = (*(struct UserObject *)self).data[0], lowerouter9 = thisouter9;
  if (inheritingObject9) {
    struct UserObject *inho9 = (struct UserObject *)inheritingObject9;
    while (inho9->super != GraceDefaultObject) inho9 = (struct UserObject *)inho9->super;
    inho9->super = obj9;
    self = inheritingObject9;
    *selfslot = self;
    lowerouter9 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9;
  }
if (objclass9 == NULL) {
  Method *reader11 = addmethodrealflags(obj9, "sourceIterator",&reader_collectionsPrelude_sourceIterator_11, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader11->definitionModule = modulename;
  reader11->definitionLine = 170;
}
adddatum2(obj9, alloc_Undefined(), 1);
// method "asString"
  struct UserObject *uo12 = (struct UserObject*)obj9;
  uo12->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString12 = addmethod2pos(obj9, "asString", &meth_collectionsPrelude_asString12, 2);
  int argcv_meth_collectionsPrelude_asString12[] = {0};
  meth_meth_collectionsPrelude_asString12->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString12);
  meth_meth_collectionsPrelude_asString12->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString12->definitionLine = 171;
// method "hasNext"
  struct UserObject *uo14 = (struct UserObject*)obj9;
  uo14->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext14 = addmethod2pos(obj9, "hasNext", &meth_collectionsPrelude_hasNext14, 3);
  int argcv_meth_collectionsPrelude_hasNext14[] = {0};
  meth_meth_collectionsPrelude_hasNext14->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext14);
  meth_meth_collectionsPrelude_hasNext14->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext14->definitionLine = 172;
// method "next"
  block_savedest(obj9);
  Object closure19 = createclosure(1, "next");
  setclosureframe(closure19, stackframe);
  addtoclosure(closure19, var_function);
  struct UserObject *uo19 = (struct UserObject*)obj9;
  uo19->data[4] = (Object)closure19;
  Method *meth_meth_collectionsPrelude_next19 = addmethod2pos(obj9, "next", &meth_collectionsPrelude_next19, 4);
  int argcv_meth_collectionsPrelude_next19[] = {0};
  meth_meth_collectionsPrelude_next19->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next19);
  meth_meth_collectionsPrelude_next19->definitionModule = modulename;
  meth_meth_collectionsPrelude_next19->definitionLine = 173;
  sourceObject = obj9;
// Begin line 170
  setline(170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe26 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_source (depth = 3)
  Object call27 = callmethodflags(*var_source, "iterator", 0, partcv, params, 0);
  gc_frame_end(callframe26);
// compiled member node returning call27 (depth = 2)
  adddatum2(obj9, call27, 1);
  sourceObject = obj9;
  sourceObject = obj9;
  sourceObject = obj9;
  objclass9 = obj9->class;
  objclass9->definitionModule = modulename;
  objclass9->definitionLine = 169;
  (*(struct UserObject *)self).data[0] = lowerouter9;
  self = oldself9;
  selfslot = oldselfslot9;
  stackframe = oldstackframe9;
  gc_frame_end(frame);
  return obj9;
}
Object meth_collectionsPrelude_iterator8_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_function = getfromclosure(closure, 0);
  Object *var_source = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9 = alloc_userobj2(4,5, objclass9);
  gc_frame_newslot(obj9);
if (objclass9 == NULL) {
  glfree(obj9->class->name);
  obj9->class->name = "lazySequenceOver(_)mappedBy(_).iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9, self, 0);
  addmethodreal(obj9,"outer", &reader_collectionsPrelude_outer_10);
  Object oldself9 = self;
  struct StackFrameObject *oldstackframe9 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9);
  gc_frame_newslot((Object)stackframe);
  self = obj9;
  Object *oldselfslot9 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9 = (*(struct UserObject *)self).data[0], lowerouter9 = thisouter9;
  if (inheritingObject9) {
    struct UserObject *inho9 = (struct UserObject *)inheritingObject9;
    while (inho9->super != GraceDefaultObject) inho9 = (struct UserObject *)inho9->super;
    inho9->super = obj9;
    self = inheritingObject9;
    *selfslot = self;
    lowerouter9 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9;
  }
if (objclass9 == NULL) {
  Method *reader11 = addmethodrealflags(obj9, "sourceIterator",&reader_collectionsPrelude_sourceIterator_11, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader11->definitionModule = modulename;
  reader11->definitionLine = 170;
}
adddatum2(obj9, alloc_Undefined(), 1);
// method "asString"
  struct UserObject *uo12 = (struct UserObject*)obj9;
  uo12->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString12 = addmethod2pos(obj9, "asString", &meth_collectionsPrelude_asString12, 2);
  int argcv_meth_collectionsPrelude_asString12[] = {0};
  meth_meth_collectionsPrelude_asString12->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString12);
  meth_meth_collectionsPrelude_asString12->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString12->definitionLine = 171;
// method "hasNext"
  struct UserObject *uo14 = (struct UserObject*)obj9;
  uo14->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext14 = addmethod2pos(obj9, "hasNext", &meth_collectionsPrelude_hasNext14, 3);
  int argcv_meth_collectionsPrelude_hasNext14[] = {0};
  meth_meth_collectionsPrelude_hasNext14->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext14);
  meth_meth_collectionsPrelude_hasNext14->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext14->definitionLine = 172;
// method "next"
  block_savedest(obj9);
  Object closure19 = createclosure(1, "next");
  setclosureframe(closure19, stackframe);
  addtoclosure(closure19, var_function);
  struct UserObject *uo19 = (struct UserObject*)obj9;
  uo19->data[4] = (Object)closure19;
  Method *meth_meth_collectionsPrelude_next19 = addmethod2pos(obj9, "next", &meth_collectionsPrelude_next19, 4);
  int argcv_meth_collectionsPrelude_next19[] = {0};
  meth_meth_collectionsPrelude_next19->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next19);
  meth_meth_collectionsPrelude_next19->definitionModule = modulename;
  meth_meth_collectionsPrelude_next19->definitionLine = 173;
  sourceObject = obj9;
// Begin line 170
  setline(170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe26 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_source (depth = 3)
  Object call27 = callmethodflags(*var_source, "iterator", 0, partcv, params, 0);
  gc_frame_end(callframe26);
// compiled member node returning call27 (depth = 2)
  adddatum2(obj9, call27, 1);
  sourceObject = obj9;
  sourceObject = obj9;
  sourceObject = obj9;
  objclass9 = obj9->class;
  objclass9->definitionModule = modulename;
  objclass9->definitionLine = 169;
  (*(struct UserObject *)self).data[0] = lowerouter9;
  self = oldself9;
  selfslot = oldselfslot9;
  stackframe = oldstackframe9;
  gc_frame_end(frame);
  return obj9;
}
Object meth_collectionsPrelude_size29(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 175
  setline(175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe30 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_source (depth = 3)
  Object call31 = callmethodflags(*var_source, "size", 0, partcv, params, 0);
  gc_frame_end(callframe30);
// compiled member node returning call31 (depth = 2)
  gc_frame_end(frame);
  return call31;
}
Object meth_collectionsPrelude_isEmpty32(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 176
  setline(176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe33 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_source (depth = 3)
  Object call34 = callmethodflags(*var_source, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe33);
// compiled member node returning call34 (depth = 2)
  gc_frame_end(frame);
  return call34;
}
Object meth_collectionsPrelude_asDebugString35(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 177
  setline(177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit37 == NULL) {
    strlit37 = alloc_String("");
    gc_root(strlit37);
  }
// compiled string node returning strlit37 (depth = 3)
  int op_slot_right_36 = gc_frame_newslot(strlit37);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_source (depth = 4)
  int op_slot_right_39 = gc_frame_newslot(*var_source);
// starting to compile string node (depth = 4)
  if (strlit41 == NULL) {
    strlit41 = alloc_String("a lazy sequence mapping over ");
    gc_root(strlit41);
  }
// compiled string node returning strlit41 (depth = 4)
  int op_slot_left_39 = gc_frame_newslot(strlit41);
  params[0] = *var_source;
  partcv[0] = 1;
  Object opresult42 = callmethod(strlit41, "++(1)", 1, partcv, params);
// compiled op node returning opresult42 (depth = 3)
  int op_slot_left_36 = gc_frame_newslot(opresult42);
  params[0] = strlit37;
  partcv[0] = 1;
  Object opresult43 = callmethod(opresult42, "++(1)", 1, partcv, params);
// compiled op node returning opresult43 (depth = 2)
  gc_frame_end(frame);
  return opresult43;
}
Object meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lazySequenceOver(1)mappedBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lazySequenceOver(_)mappedBy(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lazySequenceOver(_)mappedBy(_)");
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for lazySequenceOver(_)mappedBy(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_source = &(stackframe->slots[0]);
  *var_source = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part lazySequenceOver(_)");
  Object *var_function = &(stackframe->slots[1]);
  *var_function = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part mappedBy(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  Object *var_R = &(stackframe->slots[4]);
  if (nparts == 1 + 2 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 2) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
    *var_R = args[curarg++];
  } else {
    *var_T = Unknown;
    *var_R = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6 = alloc_userobj2(5,6, objclass6);
  gc_frame_newslot(obj6);
if (objclass6 == NULL) {
  glfree(obj6->class->name);
  obj6->class->name = "lazySequenceOver(_)mappedBy(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6, self, 0);
  addmethodreal(obj6,"outer", &reader_collectionsPrelude_outer_7);
  Object oldself6 = self;
  struct StackFrameObject *oldstackframe6 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6);
  gc_frame_newslot((Object)stackframe);
  self = obj6;
  Object *oldselfslot6 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6 = (*(struct UserObject *)self).data[0], lowerouter6 = thisouter6;
  if (inheritingObject6) {
    struct UserObject *inho6 = (struct UserObject *)inheritingObject6;
    while (inho6->super != GraceDefaultObject) inho6 = (struct UserObject *)inho6->super;
    inho6->super = obj6;
    self = inheritingObject6;
    *selfslot = self;
    lowerouter6 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6;
  }
// method "iterator"
  block_savedest(obj6);
  Object closure8 = createclosure(2, "iterator");
  setclosureframe(closure8, stackframe);
  addtoclosure(closure8, var_function);
  addtoclosure(closure8, var_source);
  struct UserObject *uo8 = (struct UserObject*)obj6;
  uo8->data[1] = (Object)closure8;
  Method *meth_meth_collectionsPrelude_iterator8 = addmethod2pos(obj6, "iterator", &meth_collectionsPrelude_iterator8, 1);
  int argcv_meth_collectionsPrelude_iterator8[] = {0};
  meth_meth_collectionsPrelude_iterator8->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator8);
  meth_meth_collectionsPrelude_iterator8->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator8->definitionLine = 169;
  block_savedest(obj6);
  Object closure28 = createclosure(2, "iterator$object(1)");
  setclosureframe(closure28, stackframe);
  addtoclosure(closure28, var_function);
  addtoclosure(closure28, var_source);
  Method *meth_meth_collectionsPrelude_iterator8_object = addmethod2pos(obj6, "iterator$object(1)", &meth_collectionsPrelude_iterator8_object, 1);
  meth_meth_collectionsPrelude_iterator8_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator8_object->definitionLine = 169;
// method "size"
  block_savedest(obj6);
  Object closure29 = createclosure(1, "size");
  setclosureframe(closure29, stackframe);
  addtoclosure(closure29, var_source);
  struct UserObject *uo29 = (struct UserObject*)obj6;
  uo29->data[2] = (Object)closure29;
  Method *meth_meth_collectionsPrelude_size29 = addmethod2pos(obj6, "size", &meth_collectionsPrelude_size29, 2);
  int argcv_meth_collectionsPrelude_size29[] = {0};
  meth_meth_collectionsPrelude_size29->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size29);
  meth_meth_collectionsPrelude_size29->definitionModule = modulename;
  meth_meth_collectionsPrelude_size29->definitionLine = 175;
// method "isEmpty"
  block_savedest(obj6);
  Object closure32 = createclosure(1, "isEmpty");
  setclosureframe(closure32, stackframe);
  addtoclosure(closure32, var_source);
  struct UserObject *uo32 = (struct UserObject*)obj6;
  uo32->data[3] = (Object)closure32;
  Method *meth_meth_collectionsPrelude_isEmpty32 = addmethod2pos(obj6, "isEmpty", &meth_collectionsPrelude_isEmpty32, 3);
  int argcv_meth_collectionsPrelude_isEmpty32[] = {0};
  meth_meth_collectionsPrelude_isEmpty32->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isEmpty32);
  meth_meth_collectionsPrelude_isEmpty32->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEmpty32->definitionLine = 176;
// method "asDebugString"
  block_savedest(obj6);
  Object closure35 = createclosure(1, "asDebugString");
  setclosureframe(closure35, stackframe);
  addtoclosure(closure35, var_source);
  struct UserObject *uo35 = (struct UserObject*)obj6;
  uo35->data[4] = (Object)closure35;
  Method *meth_meth_collectionsPrelude_asDebugString35 = addmethod2pos(obj6, "asDebugString", &meth_collectionsPrelude_asDebugString35, 4);
  int argcv_meth_collectionsPrelude_asDebugString35[] = {0};
  meth_meth_collectionsPrelude_asDebugString35->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString35);
  meth_meth_collectionsPrelude_asDebugString35->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString35->definitionLine = 177;
  sourceObject = obj6;
// Begin line 168
  setline(168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe44 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call45 = callmethodflags(*var_enumerable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe44);
// compiled call node returning call45 (depth = 2)
  struct UserObject *obj6_uo = (struct UserObject *)obj6;
  obj6_uo->super = call45;
  sourceObject = obj6;
  sourceObject = obj6;
  sourceObject = obj6;
  sourceObject = obj6;
  objclass6 = obj6->class;
  objclass6->definitionModule = modulename;
  objclass6->definitionLine = 166;
  (*(struct UserObject *)self).data[0] = lowerouter6;
  self = oldself6;
  selfslot = oldselfslot6;
  stackframe = oldstackframe6;
  gc_frame_end(frame);
  return obj6;
}
Object meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lazySequenceOver(1)mappedBy(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method lazySequenceOver(_)mappedBy(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments for method lazySequenceOver(_)mappedBy(_)");
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for lazySequenceOver(_)mappedBy(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_source = &(stackframe->slots[0]);
  *var_source = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part lazySequenceOver(_)");
  Object *var_function = &(stackframe->slots[1]);
  *var_function = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part mappedBy(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  Object *var_R = &(stackframe->slots[4]);
  if (nparts == 1 + 2 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 2) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
    *var_R = args[curarg++];
  } else {
    *var_T = Unknown;
    *var_R = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6 = alloc_userobj2(5,6, objclass6);
  gc_frame_newslot(obj6);
if (objclass6 == NULL) {
  glfree(obj6->class->name);
  obj6->class->name = "lazySequenceOver(_)mappedBy(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6, self, 0);
  addmethodreal(obj6,"outer", &reader_collectionsPrelude_outer_7);
  Object oldself6 = self;
  struct StackFrameObject *oldstackframe6 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6);
  gc_frame_newslot((Object)stackframe);
  self = obj6;
  Object *oldselfslot6 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6 = (*(struct UserObject *)self).data[0], lowerouter6 = thisouter6;
  if (inheritingObject6) {
    struct UserObject *inho6 = (struct UserObject *)inheritingObject6;
    while (inho6->super != GraceDefaultObject) inho6 = (struct UserObject *)inho6->super;
    inho6->super = obj6;
    self = inheritingObject6;
    *selfslot = self;
    lowerouter6 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6;
  }
// method "iterator"
  block_savedest(obj6);
  Object closure8 = createclosure(2, "iterator");
  setclosureframe(closure8, stackframe);
  addtoclosure(closure8, var_function);
  addtoclosure(closure8, var_source);
  struct UserObject *uo8 = (struct UserObject*)obj6;
  uo8->data[1] = (Object)closure8;
  Method *meth_meth_collectionsPrelude_iterator8 = addmethod2pos(obj6, "iterator", &meth_collectionsPrelude_iterator8, 1);
  int argcv_meth_collectionsPrelude_iterator8[] = {0};
  meth_meth_collectionsPrelude_iterator8->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator8);
  meth_meth_collectionsPrelude_iterator8->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator8->definitionLine = 169;
  block_savedest(obj6);
  Object closure28 = createclosure(2, "iterator$object(1)");
  setclosureframe(closure28, stackframe);
  addtoclosure(closure28, var_function);
  addtoclosure(closure28, var_source);
  Method *meth_meth_collectionsPrelude_iterator8_object = addmethod2pos(obj6, "iterator$object(1)", &meth_collectionsPrelude_iterator8_object, 1);
  meth_meth_collectionsPrelude_iterator8_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator8_object->definitionLine = 169;
// method "size"
  block_savedest(obj6);
  Object closure29 = createclosure(1, "size");
  setclosureframe(closure29, stackframe);
  addtoclosure(closure29, var_source);
  struct UserObject *uo29 = (struct UserObject*)obj6;
  uo29->data[2] = (Object)closure29;
  Method *meth_meth_collectionsPrelude_size29 = addmethod2pos(obj6, "size", &meth_collectionsPrelude_size29, 2);
  int argcv_meth_collectionsPrelude_size29[] = {0};
  meth_meth_collectionsPrelude_size29->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size29);
  meth_meth_collectionsPrelude_size29->definitionModule = modulename;
  meth_meth_collectionsPrelude_size29->definitionLine = 175;
// method "isEmpty"
  block_savedest(obj6);
  Object closure32 = createclosure(1, "isEmpty");
  setclosureframe(closure32, stackframe);
  addtoclosure(closure32, var_source);
  struct UserObject *uo32 = (struct UserObject*)obj6;
  uo32->data[3] = (Object)closure32;
  Method *meth_meth_collectionsPrelude_isEmpty32 = addmethod2pos(obj6, "isEmpty", &meth_collectionsPrelude_isEmpty32, 3);
  int argcv_meth_collectionsPrelude_isEmpty32[] = {0};
  meth_meth_collectionsPrelude_isEmpty32->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isEmpty32);
  meth_meth_collectionsPrelude_isEmpty32->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEmpty32->definitionLine = 176;
// method "asDebugString"
  block_savedest(obj6);
  Object closure35 = createclosure(1, "asDebugString");
  setclosureframe(closure35, stackframe);
  addtoclosure(closure35, var_source);
  struct UserObject *uo35 = (struct UserObject*)obj6;
  uo35->data[4] = (Object)closure35;
  Method *meth_meth_collectionsPrelude_asDebugString35 = addmethod2pos(obj6, "asDebugString", &meth_collectionsPrelude_asDebugString35, 4);
  int argcv_meth_collectionsPrelude_asDebugString35[] = {0};
  meth_meth_collectionsPrelude_asDebugString35->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString35);
  meth_meth_collectionsPrelude_asDebugString35->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString35->definitionLine = 177;
  sourceObject = obj6;
// Begin line 168
  setline(168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe44 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call45 = callmethodflags(*var_enumerable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe44);
// compiled call node returning call45 (depth = 2)
  struct UserObject *obj6_uo = (struct UserObject *)obj6;
  obj6_uo->super = call45;
  sourceObject = obj6;
  sourceObject = obj6;
  sourceObject = obj6;
  sourceObject = obj6;
  objclass6 = obj6->class;
  objclass6->definitionModule = modulename;
  objclass6->definitionLine = 166;
  (*(struct UserObject *)self).data[0] = lowerouter6;
  self = oldself6;
  selfslot = oldselfslot6;
  stackframe = oldstackframe6;
  gc_frame_end(frame);
  return obj6;
}
Object meth_collectionsPrelude_asString56(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 187
  setline(187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit58 == NULL) {
    strlit58 = alloc_String("");
    gc_root(strlit58);
  }
// compiled string node returning strlit58 (depth = 3)
  int op_slot_right_57 = gc_frame_newslot(strlit58);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_source (depth = 4)
  int op_slot_right_60 = gc_frame_newslot(*var_source);
// starting to compile string node (depth = 4)
  if (strlit62 == NULL) {
    strlit62 = alloc_String("an iterator over filtered ");
    gc_root(strlit62);
  }
// compiled string node returning strlit62 (depth = 4)
  int op_slot_left_60 = gc_frame_newslot(strlit62);
  params[0] = *var_source;
  partcv[0] = 1;
  Object opresult63 = callmethod(strlit62, "++(1)", 1, partcv, params);
// compiled op node returning opresult63 (depth = 3)
  int op_slot_left_57 = gc_frame_newslot(opresult63);
  params[0] = strlit58;
  partcv[0] = 1;
  Object opresult64 = callmethod(opresult63, "++(1)", 1, partcv, params);
// compiled op node returning opresult64 (depth = 2)
  gc_frame_end(frame);
  return opresult64;
}
Object meth_collectionsPrelude_hasNext65(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 191
  setline(191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe67 = gc_frame_new();
// call case 4: self request
  Object call68 = callmethodflags(self, "cacheLoaded", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe67);
// compiled member node returning call68 (depth = 3)
  Object if66 = done;
  if (istrue(call68)) {
// starting to compile identifier node (depth = 3)
  Object bool69 = alloc_Boolean(1);
// compiled identifier node returning bool69 (depth = 3)
    gc_frame_newslot(bool69);
    if66 = bool69;
  } else {
// starting to compile member node (depth = 3)
  int callframe70 = gc_frame_new();
// call case 4: self request
  Object call71 = callmethodflags(self, "hasNextAcceptableElement", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe70);
// compiled member node returning call71 (depth = 3)
    gc_frame_newslot(call71);
    if66 = call71;
  }
// compiled if node returning if66 (depth = 2)
  gc_frame_end(frame);
  return if66;
}
Object meth_collectionsPrelude_next72(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 194
  setline(194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe74 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe75 = gc_frame_new();
// call case 4: self request
  Object call76 = callmethodflags(self, "cacheLoaded", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe75);
// compiled member node returning call76 (depth = 4)
  Object call77 = callmethodflags(call76, "not", 0, partcv, params, 0);
  gc_frame_end(callframe74);
// compiled member node returning call77 (depth = 3)
  Object if73 = done;
  if (istrue(call77)) {
// starting to compile call node (depth = 3)
  int callframe78 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe79 = gc_frame_new();
// call case 4: self request
  Object call80 = callmethodflags(self, "nextAcceptableElement", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe79);
// compiled member node returning call80 (depth = 4)
  gc_frame_newslot(call80);
// call case 4: self request
  params[0] = call80;
  partcv[0] = 1;
  Object call81 = callmethodflags(self, "cache:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe78);
// compiled call node returning call81 (depth = 3)
    gc_frame_newslot(call81);
    if73 = call81;
  } else {
  }
// compiled if node returning if73 (depth = 2)
// Begin line 195
  setline(195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe82 = gc_frame_new();
// starting to compile identifier node (depth = 3)
  Object bool83 = alloc_Boolean(0);
// compiled identifier node returning bool83 (depth = 3)
  gc_frame_newslot(bool83);
// call case 4: self request
  params[0] = bool83;
  partcv[0] = 1;
  Object call84 = callmethodflags(self, "cacheLoaded:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe82);
// compiled call node returning call84 (depth = 2)
// Begin line 196
  setline(196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe85 = gc_frame_new();
// call case 4: self request
  Object call86 = callmethodflags(self, "cache", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe85);
// compiled member node returning call86 (depth = 3)
  return call86;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply90(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 4)
  Object bool91 = alloc_Boolean(1);
// compiled identifier node returning bool91 (depth = 4)
  gc_frame_end(frame);
  return bool91;
}
Object meth_collectionsPrelude__apply94(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_predicate = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_outerNext = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "outerNext");
  Object *var_isAcceptable = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "isAcceptable");
// Begin line 202
  setline(202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe95 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe96 = gc_frame_new();
// call case 4: self request
  Object call97 = callmethodflags(self, "sourceIterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe96);
// compiled member node returning call97 (depth = 6)
  Object call98 = callmethodflags(call97, "next", 0, partcv, params, 0);
  gc_frame_end(callframe95);
// compiled member node returning call98 (depth = 5)
  *var_outerNext = call98;
  if (call98 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 203
  setline(203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe99 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_outerNext (depth = 6)
  gc_frame_newslot(*var_outerNext);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_predicate (depth = 6)
  params[0] = *var_outerNext;
  partcv[0] = 1;
  Object call100 = callmethodflags(*var_predicate, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe99);
// compiled call node returning call100 (depth = 5)
  *var_isAcceptable = call100;
  if (call100 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 204
  setline(204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_isAcceptable (depth = 5)
  Object if101 = done;
  if (istrue(*var_isAcceptable)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_outerNext (depth = 6)
  block_return(realself, *var_outerNext);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if101 = undefined;
  } else {
  }
// compiled if node returning if101 (depth = 4)
  gc_frame_end(frame);
  return if101;
}
Object meth_collectionsPrelude_nextAcceptableElement87(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "nextAcceptableElement");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_predicate = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 201
  setline(201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe88 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block89 = alloc_Block(NULL, NULL, "collectionsPrelude", 201);
  gc_frame_newslot(block89);
// method "_apply"
  block_savedest(block89);
  Object closure90 = createclosure(1, "_apply");
  setclosureframe(closure90, stackframe);
  addtoclosure(closure90, selfslot);
  struct UserObject *uo90 = (struct UserObject*)block89;
  uo90->data[0] = (Object)closure90;
  Method *meth_meth_collectionsPrelude__apply90 = addmethod2pos(block89, "_apply", &meth_collectionsPrelude__apply90, 0);
  int argcv_meth_collectionsPrelude__apply90[] = {0};
  meth_meth_collectionsPrelude__apply90->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply90);
  meth_meth_collectionsPrelude__apply90->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply90->definitionLine = 1963;
// compiled block node returning block89 (depth = 3)
  gc_frame_newslot(block89);
// starting to compile block node (depth = 3)
  Object block93 = alloc_Block(NULL, NULL, "collectionsPrelude", 201);
  gc_frame_newslot(block93);
// method "_apply"
  block_savedest(block93);
  Object closure94 = createclosure(2, "_apply");
  setclosureframe(closure94, stackframe);
  addtoclosure(closure94, var_predicate);
  addtoclosure(closure94, selfslot);
  struct UserObject *uo94 = (struct UserObject*)block93;
  uo94->data[0] = (Object)closure94;
  Method *meth_meth_collectionsPrelude__apply94 = addmethod2pos(block93, "_apply", &meth_collectionsPrelude__apply94, 0);
  int argcv_meth_collectionsPrelude__apply94[] = {0};
  meth_meth_collectionsPrelude__apply94->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply94);
  meth_meth_collectionsPrelude__apply94->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply94->definitionLine = 1963;
// compiled block node returning block93 (depth = 3)
  gc_frame_newslot(block93);
// call case 5: prelude request
  params[0] = block89;
  params[1] = block93;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call103 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe88);
// compiled call node returning call103 (depth = 2)
  gc_frame_end(frame);
  return call103;
}
Object meth_collectionsPrelude__apply107(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 4)
  Object bool108 = alloc_Boolean(1);
// compiled identifier node returning bool108 (depth = 4)
  gc_frame_end(frame);
  return bool108;
}
Object meth_collectionsPrelude__apply111(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_predicate = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_outerNext = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "outerNext");
  Object *var_isAcceptable = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "isAcceptable");
// Begin line 211
  setline(211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe113 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe114 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe115 = gc_frame_new();
// call case 4: self request
  Object call116 = callmethodflags(self, "sourceIterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe115);
// compiled member node returning call116 (depth = 7)
  Object call117 = callmethodflags(call116, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe114);
// compiled member node returning call117 (depth = 6)
  Object call118 = callmethodflags(call117, "not", 0, partcv, params, 0);
  gc_frame_end(callframe113);
// compiled member node returning call118 (depth = 5)
  Object if112 = done;
  if (istrue(call118)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool119 = alloc_Boolean(0);
// compiled identifier node returning bool119 (depth = 6)
  block_return(realself, bool119);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if112 = undefined;
  } else {
  }
// compiled if node returning if112 (depth = 4)
// Begin line 212
  setline(212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe120 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe121 = gc_frame_new();
// call case 4: self request
  Object call122 = callmethodflags(self, "sourceIterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe121);
// compiled member node returning call122 (depth = 6)
  Object call123 = callmethodflags(call122, "next", 0, partcv, params, 0);
  gc_frame_end(callframe120);
// compiled member node returning call123 (depth = 5)
  *var_outerNext = call123;
  if (call123 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 213
  setline(213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe124 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_outerNext (depth = 6)
  gc_frame_newslot(*var_outerNext);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_predicate (depth = 6)
  params[0] = *var_outerNext;
  partcv[0] = 1;
  Object call125 = callmethodflags(*var_predicate, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe124);
// compiled call node returning call125 (depth = 5)
  *var_isAcceptable = call125;
  if (call125 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 214
  setline(214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_isAcceptable (depth = 5)
  Object if126 = done;
  if (istrue(*var_isAcceptable)) {
// Begin line 215
  setline(215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe127 = gc_frame_new();
// starting to compile identifier node (depth = 6)
  Object bool128 = alloc_Boolean(1);
// compiled identifier node returning bool128 (depth = 6)
  gc_frame_newslot(bool128);
// call case 4: self request
  params[0] = bool128;
  partcv[0] = 1;
  Object call129 = callmethodflags(self, "cacheLoaded:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe127);
// compiled call node returning call129 (depth = 5)
// Begin line 216
  setline(216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe130 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_outerNext (depth = 6)
  gc_frame_newslot(*var_outerNext);
// call case 4: self request
  params[0] = *var_outerNext;
  partcv[0] = 1;
  Object call131 = callmethodflags(self, "cache:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe130);
// compiled call node returning call131 (depth = 5)
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool132 = alloc_Boolean(1);
// compiled identifier node returning bool132 (depth = 6)
  block_return(realself, bool132);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if126 = undefined;
  } else {
  }
// compiled if node returning if126 (depth = 4)
  gc_frame_end(frame);
  return if126;
}
Object meth_collectionsPrelude_hasNextAcceptableElement104(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hasNextAcceptableElement");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_predicate = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 210
  setline(210);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe105 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block106 = alloc_Block(NULL, NULL, "collectionsPrelude", 210);
  gc_frame_newslot(block106);
// method "_apply"
  block_savedest(block106);
  Object closure107 = createclosure(1, "_apply");
  setclosureframe(closure107, stackframe);
  addtoclosure(closure107, selfslot);
  struct UserObject *uo107 = (struct UserObject*)block106;
  uo107->data[0] = (Object)closure107;
  Method *meth_meth_collectionsPrelude__apply107 = addmethod2pos(block106, "_apply", &meth_collectionsPrelude__apply107, 0);
  int argcv_meth_collectionsPrelude__apply107[] = {0};
  meth_meth_collectionsPrelude__apply107->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply107);
  meth_meth_collectionsPrelude__apply107->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply107->definitionLine = 1963;
// compiled block node returning block106 (depth = 3)
  gc_frame_newslot(block106);
// starting to compile block node (depth = 3)
  Object block110 = alloc_Block(NULL, NULL, "collectionsPrelude", 210);
  gc_frame_newslot(block110);
// method "_apply"
  block_savedest(block110);
  Object closure111 = createclosure(2, "_apply");
  setclosureframe(closure111, stackframe);
  addtoclosure(closure111, var_predicate);
  addtoclosure(closure111, selfslot);
  struct UserObject *uo111 = (struct UserObject*)block110;
  uo111->data[0] = (Object)closure111;
  Method *meth_meth_collectionsPrelude__apply111 = addmethod2pos(block110, "_apply", &meth_collectionsPrelude__apply111, 0);
  int argcv_meth_collectionsPrelude__apply111[] = {0};
  meth_meth_collectionsPrelude__apply111->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply111);
  meth_meth_collectionsPrelude__apply111->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply111->definitionLine = 1963;
// compiled block node returning block110 (depth = 3)
  gc_frame_newslot(block110);
// call case 5: prelude request
  params[0] = block106;
  params[1] = block110;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call134 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe105);
// compiled call node returning call134 (depth = 2)
  gc_frame_end(frame);
  return call134;
}
Object meth_collectionsPrelude_iterator50(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  Object *var_predicate = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject51 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj51 = alloc_userobj2(10,9, objclass51);
  gc_frame_newslot(obj51);
if (objclass51 == NULL) {
  glfree(obj51->class->name);
  obj51->class->name = "lazySequenceOver(_)filteredBy(_).iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj51, self, 0);
  addmethodreal(obj51,"outer", &reader_collectionsPrelude_outer_52);
  Object oldself51 = self;
  struct StackFrameObject *oldstackframe51 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe51);
  gc_frame_newslot((Object)stackframe);
  self = obj51;
  Object *oldselfslot51 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter51 = (*(struct UserObject *)self).data[0], lowerouter51 = thisouter51;
  if (inheritingObject51) {
    struct UserObject *inho51 = (struct UserObject *)inheritingObject51;
    while (inho51->super != GraceDefaultObject) inho51 = (struct UserObject *)inho51->super;
    inho51->super = obj51;
    self = inheritingObject51;
    *selfslot = self;
    lowerouter51 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter51;
  }
if (objclass51 == NULL) {
  Method *reader53 = addmethodrealflags(obj51, "cache", &reader_collectionsPrelude_cache_53, MFLAG_CONFIDENTIAL);
  Method *writer53 = addmethodrealflags(obj51, "cache:=(1)", &writer_collectionsPrelude_cache_53, MFLAG_CONFIDENTIAL);
  reader53->definitionModule = modulename;
  writer53->definitionModule = modulename;
  reader53->definitionLine = 184;
  writer53->definitionLine = 184;
}
obj51->flags |= OFLAG_MUTABLE;
adddatum2(obj51, alloc_Undefined(), 1);
if (objclass51 == NULL) {
  Method *reader54 = addmethodrealflags(obj51, "cacheLoaded", &reader_collectionsPrelude_cacheLoaded_54, MFLAG_CONFIDENTIAL);
  Method *writer54 = addmethodrealflags(obj51, "cacheLoaded:=(1)", &writer_collectionsPrelude_cacheLoaded_54, MFLAG_CONFIDENTIAL);
  reader54->definitionModule = modulename;
  writer54->definitionModule = modulename;
  reader54->definitionLine = 185;
  writer54->definitionLine = 185;
}
obj51->flags |= OFLAG_MUTABLE;
adddatum2(obj51, alloc_Undefined(), 2);
if (objclass51 == NULL) {
  Method *reader55 = addmethodrealflags(obj51, "sourceIterator",&reader_collectionsPrelude_sourceIterator_55, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader55->definitionModule = modulename;
  reader55->definitionLine = 186;
}
adddatum2(obj51, alloc_Undefined(), 3);
// method "asString"
  block_savedest(obj51);
  Object closure56 = createclosure(1, "asString");
  setclosureframe(closure56, stackframe);
  addtoclosure(closure56, var_source);
  struct UserObject *uo56 = (struct UserObject*)obj51;
  uo56->data[4] = (Object)closure56;
  Method *meth_meth_collectionsPrelude_asString56 = addmethod2pos(obj51, "asString", &meth_collectionsPrelude_asString56, 4);
  int argcv_meth_collectionsPrelude_asString56[] = {0};
  meth_meth_collectionsPrelude_asString56->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString56);
  meth_meth_collectionsPrelude_asString56->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString56->definitionLine = 187;
// method "hasNext"
  struct UserObject *uo65 = (struct UserObject*)obj51;
  uo65->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext65 = addmethod2pos(obj51, "hasNext", &meth_collectionsPrelude_hasNext65, 5);
  int argcv_meth_collectionsPrelude_hasNext65[] = {0};
  meth_meth_collectionsPrelude_hasNext65->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext65);
  meth_meth_collectionsPrelude_hasNext65->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext65->definitionLine = 188;
// method "next"
  struct UserObject *uo72 = (struct UserObject*)obj51;
  uo72->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_next72 = addmethod2pos(obj51, "next", &meth_collectionsPrelude_next72, 6);
  int argcv_meth_collectionsPrelude_next72[] = {0};
  meth_meth_collectionsPrelude_next72->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next72);
  meth_meth_collectionsPrelude_next72->definitionModule = modulename;
  meth_meth_collectionsPrelude_next72->definitionLine = 193;
// method "nextAcceptableElement"
  block_savedest(obj51);
  Object closure87 = createclosure(1, "nextAcceptableElement");
  setclosureframe(closure87, stackframe);
  addtoclosure(closure87, var_predicate);
  struct UserObject *uo87 = (struct UserObject*)obj51;
  uo87->data[7] = (Object)closure87;
  Method *meth_meth_collectionsPrelude_nextAcceptableElement87 = addmethod2pos(obj51, "nextAcceptableElement", &meth_collectionsPrelude_nextAcceptableElement87, 7);
  int argcv_meth_collectionsPrelude_nextAcceptableElement87[] = {0};
  meth_meth_collectionsPrelude_nextAcceptableElement87->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_nextAcceptableElement87);
  meth_meth_collectionsPrelude_nextAcceptableElement87->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_nextAcceptableElement87->definitionModule = modulename;
  meth_meth_collectionsPrelude_nextAcceptableElement87->definitionLine = 198;
// method "hasNextAcceptableElement"
  block_savedest(obj51);
  Object closure104 = createclosure(1, "hasNextAcceptableElement");
  setclosureframe(closure104, stackframe);
  addtoclosure(closure104, var_predicate);
  struct UserObject *uo104 = (struct UserObject*)obj51;
  uo104->data[8] = (Object)closure104;
  Method *meth_meth_collectionsPrelude_hasNextAcceptableElement104 = addmethod2pos(obj51, "hasNextAcceptableElement", &meth_collectionsPrelude_hasNextAcceptableElement104, 8);
  int argcv_meth_collectionsPrelude_hasNextAcceptableElement104[] = {0};
  meth_meth_collectionsPrelude_hasNextAcceptableElement104->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNextAcceptableElement104);
  meth_meth_collectionsPrelude_hasNextAcceptableElement104->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_hasNextAcceptableElement104->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNextAcceptableElement104->definitionLine = 207;
  sourceObject = obj51;
  adddatum2(obj51, undefined, 1);
  sourceObject = obj51;
// Begin line 185
  setline(185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool135 = alloc_Boolean(0);
// compiled identifier node returning bool135 (depth = 2)
  adddatum2(obj51, bool135, 2);
  sourceObject = obj51;
// Begin line 186
  setline(186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe136 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_source (depth = 3)
  Object call137 = callmethodflags(*var_source, "iterator", 0, partcv, params, 0);
  gc_frame_end(callframe136);
// compiled member node returning call137 (depth = 2)
  adddatum2(obj51, call137, 3);
  sourceObject = obj51;
  sourceObject = obj51;
  sourceObject = obj51;
  sourceObject = obj51;
  sourceObject = obj51;
  objclass51 = obj51->class;
  objclass51->definitionModule = modulename;
  objclass51->definitionLine = 183;
  (*(struct UserObject *)self).data[0] = lowerouter51;
  self = oldself51;
  selfslot = oldselfslot51;
  stackframe = oldstackframe51;
  gc_frame_end(frame);
  return obj51;
}
Object meth_collectionsPrelude_iterator50_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  Object *var_predicate = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject51 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj51 = alloc_userobj2(10,9, objclass51);
  gc_frame_newslot(obj51);
if (objclass51 == NULL) {
  glfree(obj51->class->name);
  obj51->class->name = "lazySequenceOver(_)filteredBy(_).iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj51, self, 0);
  addmethodreal(obj51,"outer", &reader_collectionsPrelude_outer_52);
  Object oldself51 = self;
  struct StackFrameObject *oldstackframe51 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe51);
  gc_frame_newslot((Object)stackframe);
  self = obj51;
  Object *oldselfslot51 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter51 = (*(struct UserObject *)self).data[0], lowerouter51 = thisouter51;
  if (inheritingObject51) {
    struct UserObject *inho51 = (struct UserObject *)inheritingObject51;
    while (inho51->super != GraceDefaultObject) inho51 = (struct UserObject *)inho51->super;
    inho51->super = obj51;
    self = inheritingObject51;
    *selfslot = self;
    lowerouter51 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter51;
  }
if (objclass51 == NULL) {
  Method *reader53 = addmethodrealflags(obj51, "cache", &reader_collectionsPrelude_cache_53, MFLAG_CONFIDENTIAL);
  Method *writer53 = addmethodrealflags(obj51, "cache:=(1)", &writer_collectionsPrelude_cache_53, MFLAG_CONFIDENTIAL);
  reader53->definitionModule = modulename;
  writer53->definitionModule = modulename;
  reader53->definitionLine = 184;
  writer53->definitionLine = 184;
}
obj51->flags |= OFLAG_MUTABLE;
adddatum2(obj51, alloc_Undefined(), 1);
if (objclass51 == NULL) {
  Method *reader54 = addmethodrealflags(obj51, "cacheLoaded", &reader_collectionsPrelude_cacheLoaded_54, MFLAG_CONFIDENTIAL);
  Method *writer54 = addmethodrealflags(obj51, "cacheLoaded:=(1)", &writer_collectionsPrelude_cacheLoaded_54, MFLAG_CONFIDENTIAL);
  reader54->definitionModule = modulename;
  writer54->definitionModule = modulename;
  reader54->definitionLine = 185;
  writer54->definitionLine = 185;
}
obj51->flags |= OFLAG_MUTABLE;
adddatum2(obj51, alloc_Undefined(), 2);
if (objclass51 == NULL) {
  Method *reader55 = addmethodrealflags(obj51, "sourceIterator",&reader_collectionsPrelude_sourceIterator_55, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader55->definitionModule = modulename;
  reader55->definitionLine = 186;
}
adddatum2(obj51, alloc_Undefined(), 3);
// method "asString"
  block_savedest(obj51);
  Object closure56 = createclosure(1, "asString");
  setclosureframe(closure56, stackframe);
  addtoclosure(closure56, var_source);
  struct UserObject *uo56 = (struct UserObject*)obj51;
  uo56->data[4] = (Object)closure56;
  Method *meth_meth_collectionsPrelude_asString56 = addmethod2pos(obj51, "asString", &meth_collectionsPrelude_asString56, 4);
  int argcv_meth_collectionsPrelude_asString56[] = {0};
  meth_meth_collectionsPrelude_asString56->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString56);
  meth_meth_collectionsPrelude_asString56->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString56->definitionLine = 187;
// method "hasNext"
  struct UserObject *uo65 = (struct UserObject*)obj51;
  uo65->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext65 = addmethod2pos(obj51, "hasNext", &meth_collectionsPrelude_hasNext65, 5);
  int argcv_meth_collectionsPrelude_hasNext65[] = {0};
  meth_meth_collectionsPrelude_hasNext65->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext65);
  meth_meth_collectionsPrelude_hasNext65->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext65->definitionLine = 188;
// method "next"
  struct UserObject *uo72 = (struct UserObject*)obj51;
  uo72->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_next72 = addmethod2pos(obj51, "next", &meth_collectionsPrelude_next72, 6);
  int argcv_meth_collectionsPrelude_next72[] = {0};
  meth_meth_collectionsPrelude_next72->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next72);
  meth_meth_collectionsPrelude_next72->definitionModule = modulename;
  meth_meth_collectionsPrelude_next72->definitionLine = 193;
// method "nextAcceptableElement"
  block_savedest(obj51);
  Object closure87 = createclosure(1, "nextAcceptableElement");
  setclosureframe(closure87, stackframe);
  addtoclosure(closure87, var_predicate);
  struct UserObject *uo87 = (struct UserObject*)obj51;
  uo87->data[7] = (Object)closure87;
  Method *meth_meth_collectionsPrelude_nextAcceptableElement87 = addmethod2pos(obj51, "nextAcceptableElement", &meth_collectionsPrelude_nextAcceptableElement87, 7);
  int argcv_meth_collectionsPrelude_nextAcceptableElement87[] = {0};
  meth_meth_collectionsPrelude_nextAcceptableElement87->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_nextAcceptableElement87);
  meth_meth_collectionsPrelude_nextAcceptableElement87->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_nextAcceptableElement87->definitionModule = modulename;
  meth_meth_collectionsPrelude_nextAcceptableElement87->definitionLine = 198;
// method "hasNextAcceptableElement"
  block_savedest(obj51);
  Object closure104 = createclosure(1, "hasNextAcceptableElement");
  setclosureframe(closure104, stackframe);
  addtoclosure(closure104, var_predicate);
  struct UserObject *uo104 = (struct UserObject*)obj51;
  uo104->data[8] = (Object)closure104;
  Method *meth_meth_collectionsPrelude_hasNextAcceptableElement104 = addmethod2pos(obj51, "hasNextAcceptableElement", &meth_collectionsPrelude_hasNextAcceptableElement104, 8);
  int argcv_meth_collectionsPrelude_hasNextAcceptableElement104[] = {0};
  meth_meth_collectionsPrelude_hasNextAcceptableElement104->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNextAcceptableElement104);
  meth_meth_collectionsPrelude_hasNextAcceptableElement104->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_hasNextAcceptableElement104->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNextAcceptableElement104->definitionLine = 207;
  sourceObject = obj51;
  adddatum2(obj51, undefined, 1);
  sourceObject = obj51;
// Begin line 185
  setline(185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool135 = alloc_Boolean(0);
// compiled identifier node returning bool135 (depth = 2)
  adddatum2(obj51, bool135, 2);
  sourceObject = obj51;
// Begin line 186
  setline(186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe136 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_source (depth = 3)
  Object call137 = callmethodflags(*var_source, "iterator", 0, partcv, params, 0);
  gc_frame_end(callframe136);
// compiled member node returning call137 (depth = 2)
  adddatum2(obj51, call137, 3);
  sourceObject = obj51;
  sourceObject = obj51;
  sourceObject = obj51;
  sourceObject = obj51;
  sourceObject = obj51;
  objclass51 = obj51->class;
  objclass51->definitionModule = modulename;
  objclass51->definitionLine = 183;
  (*(struct UserObject *)self).data[0] = lowerouter51;
  self = oldself51;
  selfslot = oldselfslot51;
  stackframe = oldstackframe51;
  gc_frame_end(frame);
  return obj51;
}
Object meth_collectionsPrelude_asDebugString139(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 222
  setline(222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit141 == NULL) {
    strlit141 = alloc_String("");
    gc_root(strlit141);
  }
// compiled string node returning strlit141 (depth = 3)
  int op_slot_right_140 = gc_frame_newslot(strlit141);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_source (depth = 4)
  int op_slot_right_143 = gc_frame_newslot(*var_source);
// starting to compile string node (depth = 4)
  if (strlit145 == NULL) {
    strlit145 = alloc_String("a lazy sequence filtering ");
    gc_root(strlit145);
  }
// compiled string node returning strlit145 (depth = 4)
  int op_slot_left_143 = gc_frame_newslot(strlit145);
  params[0] = *var_source;
  partcv[0] = 1;
  Object opresult146 = callmethod(strlit145, "++(1)", 1, partcv, params);
// compiled op node returning opresult146 (depth = 3)
  int op_slot_left_140 = gc_frame_newslot(opresult146);
  params[0] = strlit141;
  partcv[0] = 1;
  Object opresult147 = callmethod(opresult146, "++(1)", 1, partcv, params);
// compiled op node returning opresult147 (depth = 2)
  gc_frame_end(frame);
  return opresult147;
}
Object meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lazySequenceOver(1)filteredBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lazySequenceOver(_)filteredBy(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lazySequenceOver(_)filteredBy(_)");
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for lazySequenceOver(_)filteredBy(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_source = &(stackframe->slots[0]);
  *var_source = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part lazySequenceOver(_)");
  Object *var_predicate = &(stackframe->slots[1]);
  *var_predicate = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part filteredBy(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 2 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject48 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj48 = alloc_userobj2(3,4, objclass48);
  gc_frame_newslot(obj48);
if (objclass48 == NULL) {
  glfree(obj48->class->name);
  obj48->class->name = "lazySequenceOver(_)filteredBy(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj48, self, 0);
  addmethodreal(obj48,"outer", &reader_collectionsPrelude_outer_49);
  Object oldself48 = self;
  struct StackFrameObject *oldstackframe48 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe48);
  gc_frame_newslot((Object)stackframe);
  self = obj48;
  Object *oldselfslot48 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter48 = (*(struct UserObject *)self).data[0], lowerouter48 = thisouter48;
  if (inheritingObject48) {
    struct UserObject *inho48 = (struct UserObject *)inheritingObject48;
    while (inho48->super != GraceDefaultObject) inho48 = (struct UserObject *)inho48->super;
    inho48->super = obj48;
    self = inheritingObject48;
    *selfslot = self;
    lowerouter48 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter48;
  }
// method "iterator"
  block_savedest(obj48);
  Object closure50 = createclosure(2, "iterator");
  setclosureframe(closure50, stackframe);
  addtoclosure(closure50, var_source);
  addtoclosure(closure50, var_predicate);
  struct UserObject *uo50 = (struct UserObject*)obj48;
  uo50->data[1] = (Object)closure50;
  Method *meth_meth_collectionsPrelude_iterator50 = addmethod2pos(obj48, "iterator", &meth_collectionsPrelude_iterator50, 1);
  int argcv_meth_collectionsPrelude_iterator50[] = {0};
  meth_meth_collectionsPrelude_iterator50->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator50);
  meth_meth_collectionsPrelude_iterator50->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator50->definitionLine = 183;
  block_savedest(obj48);
  Object closure138 = createclosure(2, "iterator$object(1)");
  setclosureframe(closure138, stackframe);
  addtoclosure(closure138, var_source);
  addtoclosure(closure138, var_predicate);
  Method *meth_meth_collectionsPrelude_iterator50_object = addmethod2pos(obj48, "iterator$object(1)", &meth_collectionsPrelude_iterator50_object, 1);
  meth_meth_collectionsPrelude_iterator50_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator50_object->definitionLine = 183;
// method "asDebugString"
  block_savedest(obj48);
  Object closure139 = createclosure(1, "asDebugString");
  setclosureframe(closure139, stackframe);
  addtoclosure(closure139, var_source);
  struct UserObject *uo139 = (struct UserObject*)obj48;
  uo139->data[2] = (Object)closure139;
  Method *meth_meth_collectionsPrelude_asDebugString139 = addmethod2pos(obj48, "asDebugString", &meth_collectionsPrelude_asDebugString139, 2);
  int argcv_meth_collectionsPrelude_asDebugString139[] = {0};
  meth_meth_collectionsPrelude_asDebugString139->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString139);
  meth_meth_collectionsPrelude_asDebugString139->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString139->definitionLine = 222;
  sourceObject = obj48;
// Begin line 182
  setline(182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe148 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call149 = callmethodflags(*var_enumerable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe148);
// compiled call node returning call149 (depth = 2)
  struct UserObject *obj48_uo = (struct UserObject *)obj48;
  obj48_uo->super = call149;
  sourceObject = obj48;
  sourceObject = obj48;
  objclass48 = obj48->class;
  objclass48->definitionModule = modulename;
  objclass48->definitionLine = 180;
  (*(struct UserObject *)self).data[0] = lowerouter48;
  self = oldself48;
  selfslot = oldselfslot48;
  stackframe = oldstackframe48;
  gc_frame_end(frame);
  return obj48;
}
Object meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lazySequenceOver(1)filteredBy(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method lazySequenceOver(_)filteredBy(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments for method lazySequenceOver(_)filteredBy(_)");
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for lazySequenceOver(_)filteredBy(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_source = &(stackframe->slots[0]);
  *var_source = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part lazySequenceOver(_)");
  Object *var_predicate = &(stackframe->slots[1]);
  *var_predicate = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part filteredBy(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 2 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject48 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj48 = alloc_userobj2(3,4, objclass48);
  gc_frame_newslot(obj48);
if (objclass48 == NULL) {
  glfree(obj48->class->name);
  obj48->class->name = "lazySequenceOver(_)filteredBy(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj48, self, 0);
  addmethodreal(obj48,"outer", &reader_collectionsPrelude_outer_49);
  Object oldself48 = self;
  struct StackFrameObject *oldstackframe48 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe48);
  gc_frame_newslot((Object)stackframe);
  self = obj48;
  Object *oldselfslot48 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter48 = (*(struct UserObject *)self).data[0], lowerouter48 = thisouter48;
  if (inheritingObject48) {
    struct UserObject *inho48 = (struct UserObject *)inheritingObject48;
    while (inho48->super != GraceDefaultObject) inho48 = (struct UserObject *)inho48->super;
    inho48->super = obj48;
    self = inheritingObject48;
    *selfslot = self;
    lowerouter48 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter48;
  }
// method "iterator"
  block_savedest(obj48);
  Object closure50 = createclosure(2, "iterator");
  setclosureframe(closure50, stackframe);
  addtoclosure(closure50, var_source);
  addtoclosure(closure50, var_predicate);
  struct UserObject *uo50 = (struct UserObject*)obj48;
  uo50->data[1] = (Object)closure50;
  Method *meth_meth_collectionsPrelude_iterator50 = addmethod2pos(obj48, "iterator", &meth_collectionsPrelude_iterator50, 1);
  int argcv_meth_collectionsPrelude_iterator50[] = {0};
  meth_meth_collectionsPrelude_iterator50->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator50);
  meth_meth_collectionsPrelude_iterator50->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator50->definitionLine = 183;
  block_savedest(obj48);
  Object closure138 = createclosure(2, "iterator$object(1)");
  setclosureframe(closure138, stackframe);
  addtoclosure(closure138, var_source);
  addtoclosure(closure138, var_predicate);
  Method *meth_meth_collectionsPrelude_iterator50_object = addmethod2pos(obj48, "iterator$object(1)", &meth_collectionsPrelude_iterator50_object, 1);
  meth_meth_collectionsPrelude_iterator50_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator50_object->definitionLine = 183;
// method "asDebugString"
  block_savedest(obj48);
  Object closure139 = createclosure(1, "asDebugString");
  setclosureframe(closure139, stackframe);
  addtoclosure(closure139, var_source);
  struct UserObject *uo139 = (struct UserObject*)obj48;
  uo139->data[2] = (Object)closure139;
  Method *meth_meth_collectionsPrelude_asDebugString139 = addmethod2pos(obj48, "asDebugString", &meth_collectionsPrelude_asDebugString139, 2);
  int argcv_meth_collectionsPrelude_asDebugString139[] = {0};
  meth_meth_collectionsPrelude_asDebugString139->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString139);
  meth_meth_collectionsPrelude_asDebugString139->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString139->definitionLine = 222;
  sourceObject = obj48;
// Begin line 182
  setline(182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe148 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call149 = callmethodflags(*var_enumerable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe148);
// compiled call node returning call149 (depth = 2)
  struct UserObject *obj48_uo = (struct UserObject *)obj48;
  obj48_uo->super = call149;
  sourceObject = obj48;
  sourceObject = obj48;
  objclass48 = obj48->class;
  objclass48->definitionModule = modulename;
  objclass48->definitionLine = 180;
  (*(struct UserObject *)self).data[0] = lowerouter48;
  self = oldself48;
  selfslot = oldselfslot48;
  stackframe = oldstackframe48;
  gc_frame_end(frame);
  return obj48;
}
Object meth_collectionsPrelude_next154(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_left = getfromclosure(closure, 0);
  Object *var_right = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 227
  setline(227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe156 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_left (depth = 4)
  Object call157 = callmethodflags(*var_left, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe156);
// compiled member node returning call157 (depth = 3)
  Object if155 = done;
  if (istrue(call157)) {
// Begin line 228
  setline(228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe158 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_left (depth = 4)
  Object call159 = callmethodflags(*var_left, "next", 0, partcv, params, 0);
  gc_frame_end(callframe158);
// compiled member node returning call159 (depth = 3)
    gc_frame_newslot(call159);
    if155 = call159;
  } else {
// Begin line 230
  setline(230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe160 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_right (depth = 4)
  Object call161 = callmethodflags(*var_right, "next", 0, partcv, params, 0);
  gc_frame_end(callframe160);
// compiled member node returning call161 (depth = 3)
    gc_frame_newslot(call161);
    if155 = call161;
  }
// compiled if node returning if155 (depth = 2)
  gc_frame_end(frame);
  return if155;
}
Object meth_collectionsPrelude_hasNext162(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_left = getfromclosure(closure, 0);
  Object *var_right = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 234
  setline(234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe164 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_left (depth = 4)
  Object call165 = callmethodflags(*var_left, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe164);
// compiled member node returning call165 (depth = 3)
  Object if163 = done;
  if (istrue(call165)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool166 = alloc_Boolean(1);
// compiled identifier node returning bool166 (depth = 4)
  return bool166;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if163 = undefined;
  } else {
  }
// compiled if node returning if163 (depth = 2)
// Begin line 235
  setline(235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe167 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_right (depth = 4)
  Object call168 = callmethodflags(*var_right, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe167);
// compiled member node returning call168 (depth = 3)
  return call168;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_asDebugString169(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_right = getfromclosure(closure, 0);
  Object *var_left = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit171 == NULL) {
    strlit171 = alloc_String("");
    gc_root(strlit171);
  }
// compiled string node returning strlit171 (depth = 3)
  int op_slot_right_170 = gc_frame_newslot(strlit171);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_right (depth = 4)
  int op_slot_right_173 = gc_frame_newslot(*var_right);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit176 == NULL) {
    strlit176 = alloc_String(" and ");
    gc_root(strlit176);
  }
// compiled string node returning strlit176 (depth = 5)
  int op_slot_right_175 = gc_frame_newslot(strlit176);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_left (depth = 6)
  int op_slot_right_178 = gc_frame_newslot(*var_left);
// starting to compile string node (depth = 6)
  if (strlit180 == NULL) {
    strlit180 = alloc_String("iteratorConcat of ");
    gc_root(strlit180);
  }
// compiled string node returning strlit180 (depth = 6)
  int op_slot_left_178 = gc_frame_newslot(strlit180);
  params[0] = *var_left;
  partcv[0] = 1;
  Object opresult181 = callmethod(strlit180, "++(1)", 1, partcv, params);
// compiled op node returning opresult181 (depth = 5)
  int op_slot_left_175 = gc_frame_newslot(opresult181);
  params[0] = strlit176;
  partcv[0] = 1;
  Object opresult182 = callmethod(opresult181, "++(1)", 1, partcv, params);
// compiled op node returning opresult182 (depth = 4)
  int op_slot_left_173 = gc_frame_newslot(opresult182);
  params[0] = *var_right;
  partcv[0] = 1;
  Object opresult183 = callmethod(opresult182, "++(1)", 1, partcv, params);
// compiled op node returning opresult183 (depth = 3)
  int op_slot_left_170 = gc_frame_newslot(opresult183);
  params[0] = strlit171;
  partcv[0] = 1;
  Object opresult184 = callmethod(opresult183, "++(1)", 1, partcv, params);
// compiled op node returning opresult184 (depth = 2)
  gc_frame_end(frame);
  return opresult184;
}
Object meth_collectionsPrelude_asString185(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 238
  setline(238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit186 == NULL) {
    strlit186 = alloc_String("an iterator over a concatenation");
    gc_root(strlit186);
  }
// compiled string node returning strlit186 (depth = 2)
  gc_frame_end(frame);
  return strlit186;
}
Object meth_collectionsPrelude_iteratorConcat_40_2_41_151(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iteratorConcat(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method iteratorConcat(_,_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iteratorConcat(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_left = &(stackframe->slots[0]);
  *var_left = args[curarg];
  curarg++;
  Object *var_right = &(stackframe->slots[1]);
  *var_right = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part iteratorConcat(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject152 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj152 = alloc_userobj2(4,5, objclass152);
  gc_frame_newslot(obj152);
if (objclass152 == NULL) {
  glfree(obj152->class->name);
  obj152->class->name = "iteratorConcat(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj152, self, 0);
  addmethodreal(obj152,"outer", &reader_collectionsPrelude_outer_153);
  Object oldself152 = self;
  struct StackFrameObject *oldstackframe152 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe152);
  gc_frame_newslot((Object)stackframe);
  self = obj152;
  Object *oldselfslot152 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter152 = (*(struct UserObject *)self).data[0], lowerouter152 = thisouter152;
  if (inheritingObject152) {
    struct UserObject *inho152 = (struct UserObject *)inheritingObject152;
    while (inho152->super != GraceDefaultObject) inho152 = (struct UserObject *)inho152->super;
    inho152->super = obj152;
    self = inheritingObject152;
    *selfslot = self;
    lowerouter152 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter152;
  }
// method "next"
  block_savedest(obj152);
  Object closure154 = createclosure(2, "next");
  setclosureframe(closure154, stackframe);
  addtoclosure(closure154, var_left);
  addtoclosure(closure154, var_right);
  struct UserObject *uo154 = (struct UserObject*)obj152;
  uo154->data[1] = (Object)closure154;
  Method *meth_meth_collectionsPrelude_next154 = addmethod2pos(obj152, "next", &meth_collectionsPrelude_next154, 1);
  int argcv_meth_collectionsPrelude_next154[] = {0};
  meth_meth_collectionsPrelude_next154->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next154);
  meth_meth_collectionsPrelude_next154->definitionModule = modulename;
  meth_meth_collectionsPrelude_next154->definitionLine = 226;
// method "hasNext"
  block_savedest(obj152);
  Object closure162 = createclosure(2, "hasNext");
  setclosureframe(closure162, stackframe);
  addtoclosure(closure162, var_left);
  addtoclosure(closure162, var_right);
  struct UserObject *uo162 = (struct UserObject*)obj152;
  uo162->data[2] = (Object)closure162;
  Method *meth_meth_collectionsPrelude_hasNext162 = addmethod2pos(obj152, "hasNext", &meth_collectionsPrelude_hasNext162, 2);
  int argcv_meth_collectionsPrelude_hasNext162[] = {0};
  meth_meth_collectionsPrelude_hasNext162->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext162);
  meth_meth_collectionsPrelude_hasNext162->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext162->definitionLine = 233;
// method "asDebugString"
  block_savedest(obj152);
  Object closure169 = createclosure(2, "asDebugString");
  setclosureframe(closure169, stackframe);
  addtoclosure(closure169, var_right);
  addtoclosure(closure169, var_left);
  struct UserObject *uo169 = (struct UserObject*)obj152;
  uo169->data[3] = (Object)closure169;
  Method *meth_meth_collectionsPrelude_asDebugString169 = addmethod2pos(obj152, "asDebugString", &meth_collectionsPrelude_asDebugString169, 3);
  int argcv_meth_collectionsPrelude_asDebugString169[] = {0};
  meth_meth_collectionsPrelude_asDebugString169->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString169);
  meth_meth_collectionsPrelude_asDebugString169->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString169->definitionLine = 237;
// method "asString"
  struct UserObject *uo185 = (struct UserObject*)obj152;
  uo185->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString185 = addmethod2pos(obj152, "asString", &meth_collectionsPrelude_asString185, 4);
  int argcv_meth_collectionsPrelude_asString185[] = {0};
  meth_meth_collectionsPrelude_asString185->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString185);
  meth_meth_collectionsPrelude_asString185->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString185->definitionLine = 238;
  sourceObject = obj152;
  sourceObject = obj152;
  sourceObject = obj152;
  sourceObject = obj152;
  objclass152 = obj152->class;
  objclass152->definitionModule = modulename;
  objclass152->definitionLine = 225;
  (*(struct UserObject *)self).data[0] = lowerouter152;
  self = oldself152;
  selfslot = oldselfslot152;
  stackframe = oldstackframe152;
  gc_frame_end(frame);
  return obj152;
}
Object meth_collectionsPrelude_iteratorConcat_40_2_41_151_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iteratorConcat(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method iteratorConcat(_,_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iteratorConcat(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_left = &(stackframe->slots[0]);
  *var_left = args[curarg];
  curarg++;
  Object *var_right = &(stackframe->slots[1]);
  *var_right = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part iteratorConcat(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject152 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj152 = alloc_userobj2(4,5, objclass152);
  gc_frame_newslot(obj152);
if (objclass152 == NULL) {
  glfree(obj152->class->name);
  obj152->class->name = "iteratorConcat(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj152, self, 0);
  addmethodreal(obj152,"outer", &reader_collectionsPrelude_outer_153);
  Object oldself152 = self;
  struct StackFrameObject *oldstackframe152 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe152);
  gc_frame_newslot((Object)stackframe);
  self = obj152;
  Object *oldselfslot152 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter152 = (*(struct UserObject *)self).data[0], lowerouter152 = thisouter152;
  if (inheritingObject152) {
    struct UserObject *inho152 = (struct UserObject *)inheritingObject152;
    while (inho152->super != GraceDefaultObject) inho152 = (struct UserObject *)inho152->super;
    inho152->super = obj152;
    self = inheritingObject152;
    *selfslot = self;
    lowerouter152 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter152;
  }
// method "next"
  block_savedest(obj152);
  Object closure154 = createclosure(2, "next");
  setclosureframe(closure154, stackframe);
  addtoclosure(closure154, var_left);
  addtoclosure(closure154, var_right);
  struct UserObject *uo154 = (struct UserObject*)obj152;
  uo154->data[1] = (Object)closure154;
  Method *meth_meth_collectionsPrelude_next154 = addmethod2pos(obj152, "next", &meth_collectionsPrelude_next154, 1);
  int argcv_meth_collectionsPrelude_next154[] = {0};
  meth_meth_collectionsPrelude_next154->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next154);
  meth_meth_collectionsPrelude_next154->definitionModule = modulename;
  meth_meth_collectionsPrelude_next154->definitionLine = 226;
// method "hasNext"
  block_savedest(obj152);
  Object closure162 = createclosure(2, "hasNext");
  setclosureframe(closure162, stackframe);
  addtoclosure(closure162, var_left);
  addtoclosure(closure162, var_right);
  struct UserObject *uo162 = (struct UserObject*)obj152;
  uo162->data[2] = (Object)closure162;
  Method *meth_meth_collectionsPrelude_hasNext162 = addmethod2pos(obj152, "hasNext", &meth_collectionsPrelude_hasNext162, 2);
  int argcv_meth_collectionsPrelude_hasNext162[] = {0};
  meth_meth_collectionsPrelude_hasNext162->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext162);
  meth_meth_collectionsPrelude_hasNext162->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext162->definitionLine = 233;
// method "asDebugString"
  block_savedest(obj152);
  Object closure169 = createclosure(2, "asDebugString");
  setclosureframe(closure169, stackframe);
  addtoclosure(closure169, var_right);
  addtoclosure(closure169, var_left);
  struct UserObject *uo169 = (struct UserObject*)obj152;
  uo169->data[3] = (Object)closure169;
  Method *meth_meth_collectionsPrelude_asDebugString169 = addmethod2pos(obj152, "asDebugString", &meth_collectionsPrelude_asDebugString169, 3);
  int argcv_meth_collectionsPrelude_asDebugString169[] = {0};
  meth_meth_collectionsPrelude_asDebugString169->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString169);
  meth_meth_collectionsPrelude_asDebugString169->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString169->definitionLine = 237;
// method "asString"
  struct UserObject *uo185 = (struct UserObject*)obj152;
  uo185->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString185 = addmethod2pos(obj152, "asString", &meth_collectionsPrelude_asString185, 4);
  int argcv_meth_collectionsPrelude_asString185[] = {0};
  meth_meth_collectionsPrelude_asString185->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString185);
  meth_meth_collectionsPrelude_asString185->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString185->definitionLine = 238;
  sourceObject = obj152;
  sourceObject = obj152;
  sourceObject = obj152;
  sourceObject = obj152;
  objclass152 = obj152->class;
  objclass152->definitionModule = modulename;
  objclass152->definitionLine = 225;
  (*(struct UserObject *)self).data[0] = lowerouter152;
  self = oldself152;
  selfslot = oldselfslot152;
  stackframe = oldstackframe152;
  gc_frame_end(frame);
  return obj152;
}
Object meth_collectionsPrelude_iterator191(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_left = getfromclosure(closure, 0);
  Object *var_right = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 243
  setline(243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe192 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe193 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_left (depth = 4)
  Object call194 = callmethodflags(*var_left, "iterator", 0, partcv, params, 0);
  gc_frame_end(callframe193);
// compiled member node returning call194 (depth = 3)
  gc_frame_newslot(call194);
// starting to compile member node (depth = 3)
  int callframe195 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_right (depth = 4)
  Object call196 = callmethodflags(*var_right, "iterator", 0, partcv, params, 0);
  gc_frame_end(callframe195);
// compiled member node returning call196 (depth = 3)
  gc_frame_newslot(call196);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe197 = gc_frame_new();
// call case 3: self.outer request
  Object call198 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe197);
// compiled member node returning call198 (depth = 3)
  params[0] = call194;
  params[1] = call196;
  partcv[0] = 2;
  Object call199 = callmethodflags(call198, "iteratorConcat(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe192);
// compiled call node returning call199 (depth = 2)
  gc_frame_end(frame);
  return call199;
}
Object meth_collectionsPrelude_asDebugString200(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_right = getfromclosure(closure, 0);
  Object *var_left = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 245
  setline(245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit202 == NULL) {
    strlit202 = alloc_String("");
    gc_root(strlit202);
  }
// compiled string node returning strlit202 (depth = 3)
  int op_slot_right_201 = gc_frame_newslot(strlit202);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_right (depth = 4)
  int op_slot_right_204 = gc_frame_newslot(*var_right);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit207 == NULL) {
    strlit207 = alloc_String(" and ");
    gc_root(strlit207);
  }
// compiled string node returning strlit207 (depth = 5)
  int op_slot_right_206 = gc_frame_newslot(strlit207);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_left (depth = 6)
  int op_slot_right_209 = gc_frame_newslot(*var_left);
// starting to compile string node (depth = 6)
  if (strlit211 == NULL) {
    strlit211 = alloc_String("lazy concatenation of ");
    gc_root(strlit211);
  }
// compiled string node returning strlit211 (depth = 6)
  int op_slot_left_209 = gc_frame_newslot(strlit211);
  params[0] = *var_left;
  partcv[0] = 1;
  Object opresult212 = callmethod(strlit211, "++(1)", 1, partcv, params);
// compiled op node returning opresult212 (depth = 5)
  int op_slot_left_206 = gc_frame_newslot(opresult212);
  params[0] = strlit207;
  partcv[0] = 1;
  Object opresult213 = callmethod(opresult212, "++(1)", 1, partcv, params);
// compiled op node returning opresult213 (depth = 4)
  int op_slot_left_204 = gc_frame_newslot(opresult213);
  params[0] = *var_right;
  partcv[0] = 1;
  Object opresult214 = callmethod(opresult213, "++(1)", 1, partcv, params);
// compiled op node returning opresult214 (depth = 3)
  int op_slot_left_201 = gc_frame_newslot(opresult214);
  params[0] = strlit202;
  partcv[0] = 1;
  Object opresult215 = callmethod(opresult214, "++(1)", 1, partcv, params);
// compiled op node returning opresult215 (depth = 2)
  gc_frame_end(frame);
  return opresult215;
}
Object meth_collectionsPrelude_asString216(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 246
  setline(246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe217 = gc_frame_new();
// call case 1: super request
  Object call218 = callmethod4(self, "asString", 0, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe217);
// compiled member node returning call218 (depth = 2)
  gc_frame_end(frame);
  return call218;
}
Object meth_collectionsPrelude_size219(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_right = getfromclosure(closure, 0);
  Object *var_left = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 247
  setline(247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe221 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_right (depth = 4)
  Object call222 = callmethodflags(*var_right, "size", 0, partcv, params, 0);
  gc_frame_end(callframe221);
// compiled member node returning call222 (depth = 3)
  int op_slot_right_220 = gc_frame_newslot(call222);
// starting to compile member node (depth = 3)
  int callframe224 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_left (depth = 4)
  Object call225 = callmethodflags(*var_left, "size", 0, partcv, params, 0);
  gc_frame_end(callframe224);
// compiled member node returning call225 (depth = 3)
  int op_slot_left_220 = gc_frame_newslot(call225);
  params[0] = call222;
  partcv[0] = 1;
  Object sum226 = callmethod(call225, "+(1)", 1, partcv, params);
// compiled op node returning sum226 (depth = 2)
  gc_frame_end(frame);
  return sum226;
}
Object meth_collectionsPrelude_lazyConcatenation_40_2_41_188(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lazyConcatenation(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method lazyConcatenation(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lazyConcatenation(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_left = &(stackframe->slots[0]);
  *var_left = args[curarg];
  curarg++;
  Object *var_right = &(stackframe->slots[1]);
  *var_right = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part lazyConcatenation(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject189 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj189 = alloc_userobj2(4,5, objclass189);
  gc_frame_newslot(obj189);
if (objclass189 == NULL) {
  glfree(obj189->class->name);
  obj189->class->name = "lazyConcatenation(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj189, self, 0);
  addmethodreal(obj189,"outer", &reader_collectionsPrelude_outer_190);
  Object oldself189 = self;
  struct StackFrameObject *oldstackframe189 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe189);
  gc_frame_newslot((Object)stackframe);
  self = obj189;
  Object *oldselfslot189 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter189 = (*(struct UserObject *)self).data[0], lowerouter189 = thisouter189;
  if (inheritingObject189) {
    struct UserObject *inho189 = (struct UserObject *)inheritingObject189;
    while (inho189->super != GraceDefaultObject) inho189 = (struct UserObject *)inho189->super;
    inho189->super = obj189;
    self = inheritingObject189;
    *selfslot = self;
    lowerouter189 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter189;
  }
// method "iterator"
  block_savedest(obj189);
  Object closure191 = createclosure(2, "iterator");
  setclosureframe(closure191, stackframe);
  addtoclosure(closure191, var_left);
  addtoclosure(closure191, var_right);
  struct UserObject *uo191 = (struct UserObject*)obj189;
  uo191->data[1] = (Object)closure191;
  Method *meth_meth_collectionsPrelude_iterator191 = addmethod2pos(obj189, "iterator", &meth_collectionsPrelude_iterator191, 1);
  int argcv_meth_collectionsPrelude_iterator191[] = {0};
  meth_meth_collectionsPrelude_iterator191->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator191);
  meth_meth_collectionsPrelude_iterator191->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator191->definitionLine = 242;
// method "asDebugString"
  block_savedest(obj189);
  Object closure200 = createclosure(2, "asDebugString");
  setclosureframe(closure200, stackframe);
  addtoclosure(closure200, var_right);
  addtoclosure(closure200, var_left);
  struct UserObject *uo200 = (struct UserObject*)obj189;
  uo200->data[2] = (Object)closure200;
  Method *meth_meth_collectionsPrelude_asDebugString200 = addmethod2pos(obj189, "asDebugString", &meth_collectionsPrelude_asDebugString200, 2);
  int argcv_meth_collectionsPrelude_asDebugString200[] = {0};
  meth_meth_collectionsPrelude_asDebugString200->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString200);
  meth_meth_collectionsPrelude_asDebugString200->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString200->definitionLine = 245;
// method "asString"
  struct UserObject *uo216 = (struct UserObject*)obj189;
  uo216->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString216 = addmethod2pos(obj189, "asString", &meth_collectionsPrelude_asString216, 3);
  int argcv_meth_collectionsPrelude_asString216[] = {0};
  meth_meth_collectionsPrelude_asString216->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString216);
  meth_meth_collectionsPrelude_asString216->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString216->definitionLine = 246;
// method "size"
  block_savedest(obj189);
  Object closure219 = createclosure(2, "size");
  setclosureframe(closure219, stackframe);
  addtoclosure(closure219, var_right);
  addtoclosure(closure219, var_left);
  struct UserObject *uo219 = (struct UserObject*)obj189;
  uo219->data[4] = (Object)closure219;
  Method *meth_meth_collectionsPrelude_size219 = addmethod2pos(obj189, "size", &meth_collectionsPrelude_size219, 4);
  int argcv_meth_collectionsPrelude_size219[] = {0};
  meth_meth_collectionsPrelude_size219->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size219);
  meth_meth_collectionsPrelude_size219->definitionModule = modulename;
  meth_meth_collectionsPrelude_size219->definitionLine = 247;
  sourceObject = obj189;
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe227 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call228 = callmethodflags(*var_enumerable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe227);
// compiled call node returning call228 (depth = 2)
  struct UserObject *obj189_uo = (struct UserObject *)obj189;
  obj189_uo->super = call228;
  sourceObject = obj189;
  sourceObject = obj189;
  sourceObject = obj189;
  sourceObject = obj189;
  objclass189 = obj189->class;
  objclass189->definitionModule = modulename;
  objclass189->definitionLine = 240;
  (*(struct UserObject *)self).data[0] = lowerouter189;
  self = oldself189;
  selfslot = oldselfslot189;
  stackframe = oldstackframe189;
  gc_frame_end(frame);
  return obj189;
}
Object meth_collectionsPrelude_lazyConcatenation_40_2_41_188_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lazyConcatenation(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method lazyConcatenation(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lazyConcatenation(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_left = &(stackframe->slots[0]);
  *var_left = args[curarg];
  curarg++;
  Object *var_right = &(stackframe->slots[1]);
  *var_right = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part lazyConcatenation(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject189 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj189 = alloc_userobj2(4,5, objclass189);
  gc_frame_newslot(obj189);
if (objclass189 == NULL) {
  glfree(obj189->class->name);
  obj189->class->name = "lazyConcatenation(_,_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj189, self, 0);
  addmethodreal(obj189,"outer", &reader_collectionsPrelude_outer_190);
  Object oldself189 = self;
  struct StackFrameObject *oldstackframe189 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe189);
  gc_frame_newslot((Object)stackframe);
  self = obj189;
  Object *oldselfslot189 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter189 = (*(struct UserObject *)self).data[0], lowerouter189 = thisouter189;
  if (inheritingObject189) {
    struct UserObject *inho189 = (struct UserObject *)inheritingObject189;
    while (inho189->super != GraceDefaultObject) inho189 = (struct UserObject *)inho189->super;
    inho189->super = obj189;
    self = inheritingObject189;
    *selfslot = self;
    lowerouter189 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter189;
  }
// method "iterator"
  block_savedest(obj189);
  Object closure191 = createclosure(2, "iterator");
  setclosureframe(closure191, stackframe);
  addtoclosure(closure191, var_left);
  addtoclosure(closure191, var_right);
  struct UserObject *uo191 = (struct UserObject*)obj189;
  uo191->data[1] = (Object)closure191;
  Method *meth_meth_collectionsPrelude_iterator191 = addmethod2pos(obj189, "iterator", &meth_collectionsPrelude_iterator191, 1);
  int argcv_meth_collectionsPrelude_iterator191[] = {0};
  meth_meth_collectionsPrelude_iterator191->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator191);
  meth_meth_collectionsPrelude_iterator191->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator191->definitionLine = 242;
// method "asDebugString"
  block_savedest(obj189);
  Object closure200 = createclosure(2, "asDebugString");
  setclosureframe(closure200, stackframe);
  addtoclosure(closure200, var_right);
  addtoclosure(closure200, var_left);
  struct UserObject *uo200 = (struct UserObject*)obj189;
  uo200->data[2] = (Object)closure200;
  Method *meth_meth_collectionsPrelude_asDebugString200 = addmethod2pos(obj189, "asDebugString", &meth_collectionsPrelude_asDebugString200, 2);
  int argcv_meth_collectionsPrelude_asDebugString200[] = {0};
  meth_meth_collectionsPrelude_asDebugString200->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString200);
  meth_meth_collectionsPrelude_asDebugString200->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString200->definitionLine = 245;
// method "asString"
  struct UserObject *uo216 = (struct UserObject*)obj189;
  uo216->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString216 = addmethod2pos(obj189, "asString", &meth_collectionsPrelude_asString216, 3);
  int argcv_meth_collectionsPrelude_asString216[] = {0};
  meth_meth_collectionsPrelude_asString216->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString216);
  meth_meth_collectionsPrelude_asString216->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString216->definitionLine = 246;
// method "size"
  block_savedest(obj189);
  Object closure219 = createclosure(2, "size");
  setclosureframe(closure219, stackframe);
  addtoclosure(closure219, var_right);
  addtoclosure(closure219, var_left);
  struct UserObject *uo219 = (struct UserObject*)obj189;
  uo219->data[4] = (Object)closure219;
  Method *meth_meth_collectionsPrelude_size219 = addmethod2pos(obj189, "size", &meth_collectionsPrelude_size219, 4);
  int argcv_meth_collectionsPrelude_size219[] = {0};
  meth_meth_collectionsPrelude_size219->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size219);
  meth_meth_collectionsPrelude_size219->definitionModule = modulename;
  meth_meth_collectionsPrelude_size219->definitionLine = 247;
  sourceObject = obj189;
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe227 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call228 = callmethodflags(*var_enumerable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe227);
// compiled call node returning call228 (depth = 2)
  struct UserObject *obj189_uo = (struct UserObject *)obj189;
  obj189_uo->super = call228;
  sourceObject = obj189;
  sourceObject = obj189;
  sourceObject = obj189;
  sourceObject = obj189;
  objclass189 = obj189->class;
  objclass189->definitionModule = modulename;
  objclass189->definitionLine = 240;
  (*(struct UserObject *)self).data[0] = lowerouter189;
  self = oldself189;
  selfslot = oldselfslot189;
  stackframe = oldstackframe189;
  gc_frame_end(frame);
  return obj189;
}
Object meth_collectionsPrelude_max_40_2_41_230(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "max(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method max(_,_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for max(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part max(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 428
  setline(428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  int op_slot_right_232 = gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_a (depth = 4)
  int op_slot_left_232 = gc_frame_newslot(*var_a);
  params[0] = *var_b;
  partcv[0] = 1;
  Object opresult234 = callmethod(*var_a, ">(1)", 1, partcv, params);
// compiled op node returning opresult234 (depth = 3)
  Object if231 = done;
  if (istrue(opresult234)) {
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_a (depth = 3)
    gc_frame_newslot(*var_a);
    if231 = *var_a;
  } else {
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_b (depth = 3)
    gc_frame_newslot(*var_b);
    if231 = *var_b;
  }
// compiled if node returning if231 (depth = 2)
  gc_frame_end(frame);
  return if231;
}
Object meth_collectionsPrelude_asString238(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 464
  setline(464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit239 == NULL) {
    strlit239 = alloc_String("a sequence factory");
    gc_root(strlit239);
  }
// compiled string node returning strlit239 (depth = 2)
  gc_frame_end(frame);
  return strlit239;
}
Object meth_collectionsPrelude_empty240(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "empty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 468
  setline(468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_emptySequence (depth = 2)
  gc_frame_end(frame);
  return *var_emptySequence;
}
Object meth_collectionsPrelude__apply245(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sizeCertain = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 475
  setline(475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool246 = alloc_Boolean(0);
// compiled identifier node returning bool246 (depth = 6)
  *var_sizeCertain = bool246;
  if (bool246 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 476
  setline(476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num248 = alloc_Float64(8);
// compiled num node returning num248 (depth = 5)
  gc_frame_end(frame);
  return num248;
}
Object meth_collectionsPrelude__apply_40_1_41_261(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_inner = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 484
  setline(484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe262 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  gc_frame_newslot(*var_ix);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elt (depth = 6)
  gc_frame_newslot(*var_elt);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_inner (depth = 6)
  params[0] = *var_ix;
  params[1] = *var_elt;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call263 = callmethodflags(*var_inner, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe262);
// compiled call node returning call263 (depth = 5)
// Begin line 485
  setline(485);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num265 = alloc_Float64(1);
// compiled num node returning num265 (depth = 7)
  int op_slot_right_264 = gc_frame_newslot(num265);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  int op_slot_left_264 = gc_frame_newslot(*var_ix);
  params[0] = num265;
  partcv[0] = 1;
  Object sum267 = callmethod(*var_ix, "+(1)", 1, partcv, params);
// compiled op node returning sum267 (depth = 6)
  *var_ix = sum267;
  if (sum267 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply_40_1_41_296(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_inner = getfromclosure(closure, 0);
  Object *var_newInner = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 493
  setline(493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe297 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  gc_frame_newslot(*var_i);
// starting to compile call node (depth = 9)
  int callframe298 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_inner (depth = 10)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call299 = callmethodflags(*var_inner, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe298);
// compiled call node returning call299 (depth = 9)
  gc_frame_newslot(call299);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_newInner (depth = 9)
  params[0] = *var_i;
  params[1] = call299;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call300 = callmethodflags(*var_newInner, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe297);
// compiled call node returning call300 (depth = 8)
  gc_frame_end(frame);
  return call300;
}
Object meth_collectionsPrelude__apply_40_1_41_273(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_innerSize = getfromclosure(closure, 1);
  Object *var__prelude = getfromclosure(closure, 2);
  Object *var_inner = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newInner = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newInner");
// Begin line 490
  setline(490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  int op_slot_right_275 = gc_frame_newslot(*var_ix);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_innerSize (depth = 7)
  int op_slot_left_275 = gc_frame_newslot(*var_innerSize);
  params[0] = *var_ix;
  partcv[0] = 1;
  Object opresult277 = callmethod(*var_innerSize, "≤(1)", 1, partcv, params);
// compiled op node returning opresult277 (depth = 6)
  Object if274 = done;
  if (istrue(opresult277)) {
// Begin line 491
  setline(491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe278 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num280 = alloc_Float64(2);
// compiled num node returning num280 (depth = 9)
  int op_slot_right_279 = gc_frame_newslot(num280);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_innerSize (depth = 9)
  int op_slot_left_279 = gc_frame_newslot(*var_innerSize);
  params[0] = num280;
  partcv[0] = 1;
  Object prod282 = callmethod(*var_innerSize, "*(1)", 1, partcv, params);
// compiled op node returning prod282 (depth = 8)
  gc_frame_newslot(prod282);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe283 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var__prelude (depth = 9)
  Object call284 = callmethodflags(*var__prelude, "primitiveArray", 0, partcv, params, 0);
  gc_frame_end(callframe283);
// compiled member node returning call284 (depth = 8)
  params[0] = prod282;
  partcv[0] = 1;
  Object call285 = callmethodflags(call284, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe278);
// compiled call node returning call285 (depth = 7)
  *var_newInner = call285;
  if (call285 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 492
  setline(492);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe286 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num289 = alloc_Float64(1);
// compiled num node returning num289 (depth = 9)
  int op_slot_right_288 = gc_frame_newslot(num289);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_innerSize (depth = 9)
  int op_slot_left_288 = gc_frame_newslot(*var_innerSize);
  params[0] = num289;
  partcv[0] = 1;
  Object diff291 = callmethod(*var_innerSize, "-(1)", 1, partcv, params);
// compiled op node returning diff291 (depth = 8)
  int op_slot_right_287 = gc_frame_newslot(diff291);
// starting to compile num node (depth = 8)
  Object num293 = alloc_Float64(0);
// compiled num node returning num293 (depth = 8)
  int op_slot_left_287 = gc_frame_newslot(num293);
  params[0] = diff291;
  partcv[0] = 1;
  Object opresult294 = callmethod(num293, "..(1)", 1, partcv, params);
// compiled op node returning opresult294 (depth = 7)
  gc_frame_newslot(opresult294);
// starting to compile block node (depth = 7)
  Object block295 = alloc_Block(NULL, NULL, "collectionsPrelude", 492);
  gc_frame_newslot(block295);
// method "_apply(_)"
  block_savedest(block295);
  Object closure296 = createclosure(3, "_apply(1)");
  setclosureframe(closure296, stackframe);
  addtoclosure(closure296, var_inner);
  addtoclosure(closure296, var_newInner);
  addtoclosure(closure296, selfslot);
  struct UserObject *uo296 = (struct UserObject*)block295;
  uo296->data[0] = (Object)closure296;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_296 = addmethod2pos(block295, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_296, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_296[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_296->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_296);
  meth_meth_collectionsPrelude__apply_40_1_41_296->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_296->definitionLine = 1963;
// compiled block node returning block295 (depth = 7)
  gc_frame_newslot(block295);
// call case 5: prelude request
  params[0] = opresult294;
  params[1] = block295;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call302 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe286);
// compiled call node returning call302 (depth = 6)
// Begin line 495
  setline(495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newInner (depth = 7)
  *var_inner = *var_newInner;
  if (*var_newInner == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
// Begin line 496
  setline(496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe304 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_inner (depth = 8)
  Object call305 = callmethodflags(*var_inner, "size", 0, partcv, params, 0);
  gc_frame_end(callframe304);
// compiled member node returning call305 (depth = 7)
  *var_innerSize = call305;
  if (call305 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if274 = done;
  } else {
  }
// compiled if node returning if274 (depth = 5)
// Begin line 498
  setline(498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe307 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  gc_frame_newslot(*var_ix);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elt (depth = 6)
  gc_frame_newslot(*var_elt);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_inner (depth = 6)
  params[0] = *var_ix;
  params[1] = *var_elt;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call308 = callmethodflags(*var_inner, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe307);
// compiled call node returning call308 (depth = 5)
// Begin line 499
  setline(499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num310 = alloc_Float64(1);
// compiled num node returning num310 (depth = 7)
  int op_slot_right_309 = gc_frame_newslot(num310);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  int op_slot_left_309 = gc_frame_newslot(*var_ix);
  params[0] = num310;
  partcv[0] = 1;
  Object sum312 = callmethod(*var_ix, "+(1)", 1, partcv, params);
// compiled op node returning sum312 (depth = 6)
  *var_ix = sum312;
  if (sum312 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_withAll_40_1_41_241(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "withAll(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method withAll(_)");
  Object params[2];
  int partcv[2];
  Object *var__prelude = getfromclosure(closure, 0);
  Object *var_emptySequence = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for withAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sizeCertain = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sizeCertain");
  Object *var_forecastSize = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "forecastSize");
  Object *var_inner = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "inner");
  Object *var_innerSize = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "innerSize");
  Object *var_ix = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "ix");
// Begin line 472
  setline(472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool242 = alloc_Boolean(1);
// compiled identifier node returning bool242 (depth = 3)
  *var_sizeCertain = bool242;
  if (bool242 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 474
  setline(474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe243 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block244 = alloc_Block(NULL, NULL, "collectionsPrelude", 474);
  gc_frame_newslot(block244);
// method "_apply"
  block_savedest(block244);
  Object closure245 = createclosure(2, "_apply");
  setclosureframe(closure245, stackframe);
  addtoclosure(closure245, var_sizeCertain);
  addtoclosure(closure245, selfslot);
  struct UserObject *uo245 = (struct UserObject*)block244;
  uo245->data[0] = (Object)closure245;
  Method *meth_meth_collectionsPrelude__apply245 = addmethod2pos(block244, "_apply", &meth_collectionsPrelude__apply245, 0);
  int argcv_meth_collectionsPrelude__apply245[] = {0};
  meth_meth_collectionsPrelude__apply245->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply245);
  meth_meth_collectionsPrelude__apply245->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply245->definitionLine = 1963;
// compiled block node returning block244 (depth = 4)
  gc_frame_newslot(block244);
// call case 6: other requests
// Begin line 474
  setline(474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_arg (depth = 4)
  params[0] = block244;
  partcv[0] = 1;
  Object call250 = callmethodflags(*var_arg, "sizeIfUnknown(1)", 1, partcv, params, 0);
  gc_frame_end(callframe243);
// compiled call node returning call250 (depth = 3)
  *var_forecastSize = call250;
  if (call250 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 478
  setline(478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe251 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_forecastSize (depth = 4)
  gc_frame_newslot(*var_forecastSize);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe252 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var__prelude (depth = 5)
  Object call253 = callmethodflags(*var__prelude, "primitiveArray", 0, partcv, params, 0);
  gc_frame_end(callframe252);
// compiled member node returning call253 (depth = 4)
  params[0] = *var_forecastSize;
  partcv[0] = 1;
  Object call254 = callmethodflags(call253, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe251);
// compiled call node returning call254 (depth = 3)
  *var_inner = call254;
  if (call254 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 479
  setline(479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe255 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_inner (depth = 4)
  Object call256 = callmethodflags(*var_inner, "size", 0, partcv, params, 0);
  gc_frame_end(callframe255);
// compiled member node returning call256 (depth = 3)
  *var_innerSize = call256;
  if (call256 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 480
  setline(480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num257 = alloc_Float64(0);
// compiled num node returning num257 (depth = 3)
  *var_ix = num257;
  if (num257 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 481
  setline(481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sizeCertain (depth = 3)
  Object if258 = done;
  if (istrue(*var_sizeCertain)) {
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe259 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_arg (depth = 4)
  gc_frame_newslot(*var_arg);
// starting to compile block node (depth = 4)
  Object block260 = alloc_Block(NULL, NULL, "collectionsPrelude", 483);
  gc_frame_newslot(block260);
// method "_apply(_)"
  block_savedest(block260);
  Object closure261 = createclosure(3, "_apply(1)");
  setclosureframe(closure261, stackframe);
  addtoclosure(closure261, var_ix);
  addtoclosure(closure261, var_inner);
  addtoclosure(closure261, selfslot);
  struct UserObject *uo261 = (struct UserObject*)block260;
  uo261->data[0] = (Object)closure261;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_261 = addmethod2pos(block260, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_261, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_261[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_261->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_261);
  meth_meth_collectionsPrelude__apply_40_1_41_261->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_261->definitionLine = 1963;
// compiled block node returning block260 (depth = 4)
  gc_frame_newslot(block260);
// call case 5: prelude request
  params[0] = *var_arg;
  params[1] = block260;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call270 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe259);
// compiled call node returning call270 (depth = 3)
    gc_frame_newslot(call270);
    if258 = call270;
  } else {
// Begin line 489
  setline(489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe271 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_arg (depth = 4)
  gc_frame_newslot(*var_arg);
// starting to compile block node (depth = 4)
  Object block272 = alloc_Block(NULL, NULL, "collectionsPrelude", 489);
  gc_frame_newslot(block272);
// method "_apply(_)"
  block_savedest(block272);
  Object closure273 = createclosure(5, "_apply(1)");
  setclosureframe(closure273, stackframe);
  addtoclosure(closure273, var_ix);
  addtoclosure(closure273, var_innerSize);
  addtoclosure(closure273, var__prelude);
  addtoclosure(closure273, var_inner);
  addtoclosure(closure273, selfslot);
  struct UserObject *uo273 = (struct UserObject*)block272;
  uo273->data[0] = (Object)closure273;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_273 = addmethod2pos(block272, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_273, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_273[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_273->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_273);
  meth_meth_collectionsPrelude__apply_40_1_41_273->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_273->definitionLine = 1963;
// compiled block node returning block272 (depth = 4)
  gc_frame_newslot(block272);
// call case 5: prelude request
  params[0] = *var_arg;
  params[1] = block272;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call315 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe271);
// compiled call node returning call315 (depth = 3)
    gc_frame_newslot(call315);
    if258 = call315;
  }
// compiled if node returning if258 (depth = 2)
// Begin line 502
  setline(502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num318 = alloc_Float64(0);
// compiled num node returning num318 (depth = 4)
  int op_slot_right_317 = gc_frame_newslot(num318);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ix (depth = 4)
  int op_slot_left_317 = gc_frame_newslot(*var_ix);
  params[0] = num318;
  partcv[0] = 1;
  Object opresult320 = callmethod(*var_ix, "==(1)", 1, partcv, params);
// compiled op node returning opresult320 (depth = 3)
  Object if316 = done;
  if (istrue(opresult320)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_emptySequence (depth = 4)
  return *var_emptySequence;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if316 = undefined;
  } else {
  }
// compiled if node returning if316 (depth = 2)
// Begin line 503
  setline(503);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe321 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_inner (depth = 3)
  gc_frame_newslot(*var_inner);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ix (depth = 3)
  gc_frame_newslot(*var_ix);
// call case 4: self request
  params[0] = *var_inner;
  params[1] = *var_ix;
  partcv[0] = 2;
  Object call322 = callmethodflags(self, "fromprimitiveArray(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe321);
// compiled call node returning call322 (depth = 2)
  gc_frame_end(frame);
  return call322;
}
Object meth_collectionsPrelude_boundsCheck_40_1_41_328(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "boundsCheck(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method boundsCheck(_)");
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for boundsCheck(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part boundsCheck(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 514
  setline(514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe331 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe333 = gc_frame_new();
// call case 4: self request
  Object call334 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe333);
// compiled member node returning call334 (depth = 6)
  int op_slot_right_332 = gc_frame_newslot(call334);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_left_332 = gc_frame_newslot(*var_n);
  params[0] = call334;
  partcv[0] = 1;
  Object opresult336 = callmethod(*var_n, "≤(1)", 1, partcv, params);
// compiled op node returning opresult336 (depth = 5)
  partcv[0] = 0;
  Object call337 = callmethodflags(opresult336, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe331);
// compiled call node returning call337 (depth = 4)
  int op_slot_right_330 = gc_frame_newslot(call337);
// starting to compile call node (depth = 4)
  int callframe339 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num341 = alloc_Float64(1);
// compiled num node returning num341 (depth = 6)
  int op_slot_right_340 = gc_frame_newslot(num341);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_left_340 = gc_frame_newslot(*var_n);
  params[0] = num341;
  partcv[0] = 1;
  Object opresult343 = callmethod(*var_n, "≥(1)", 1, partcv, params);
// compiled op node returning opresult343 (depth = 5)
  partcv[0] = 0;
  Object call344 = callmethodflags(opresult343, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe339);
// compiled call node returning call344 (depth = 4)
  int op_slot_left_330 = gc_frame_newslot(call344);
  params[0] = call337;
  partcv[0] = 1;
  Object opresult345 = callmethod(call344, "||(1)", 1, partcv, params);
// compiled op node returning opresult345 (depth = 3)
  Object if329 = done;
  if (istrue(opresult345)) {
// Begin line 517
  setline(517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe346 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit348 == NULL) {
    strlit348 = alloc_String("");
    gc_root(strlit348);
  }
// compiled string node returning strlit348 (depth = 5)
  int op_slot_right_347 = gc_frame_newslot(strlit348);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe351 = gc_frame_new();
// call case 4: self request
  Object call352 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe351);
// compiled member node returning call352 (depth = 6)
  int op_slot_right_350 = gc_frame_newslot(call352);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit355 == NULL) {
    strlit355 = alloc_String(" out of bounds 1..");
    gc_root(strlit355);
  }
// compiled string node returning strlit355 (depth = 7)
  int op_slot_right_354 = gc_frame_newslot(strlit355);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_right_357 = gc_frame_newslot(*var_n);
// starting to compile string node (depth = 8)
  if (strlit359 == NULL) {
    strlit359 = alloc_String("index ");
    gc_root(strlit359);
  }
// compiled string node returning strlit359 (depth = 8)
  int op_slot_left_357 = gc_frame_newslot(strlit359);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult360 = callmethod(strlit359, "++(1)", 1, partcv, params);
// compiled op node returning opresult360 (depth = 7)
  int op_slot_left_354 = gc_frame_newslot(opresult360);
  params[0] = strlit355;
  partcv[0] = 1;
  Object opresult361 = callmethod(opresult360, "++(1)", 1, partcv, params);
// compiled op node returning opresult361 (depth = 6)
  int op_slot_left_350 = gc_frame_newslot(opresult361);
  params[0] = call352;
  partcv[0] = 1;
  Object opresult362 = callmethod(opresult361, "++(1)", 1, partcv, params);
// compiled op node returning opresult362 (depth = 5)
  int op_slot_left_347 = gc_frame_newslot(opresult362);
  params[0] = strlit348;
  partcv[0] = 1;
  Object opresult363 = callmethod(opresult362, "++(1)", 1, partcv, params);
// compiled op node returning opresult363 (depth = 4)
  gc_frame_newslot(opresult363);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult363;
  partcv[0] = 1;
  Object call364 = callmethodflags(*var_BoundsError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe346);
// compiled call node returning call364 (depth = 3)
    gc_frame_newslot(call364);
    if329 = call364;
  } else {
  }
// compiled if node returning if329 (depth = 2)
  gc_frame_end(frame);
  return if329;
}
Object meth_collectionsPrelude_at_40_1_41_365(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 521
  setline(521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe366 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call367 = callmethodflags(self, "boundsCheck(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe366);
// compiled call node returning call367 (depth = 2)
// Begin line 522
  setline(522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe368 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num370 = alloc_Float64(1);
// compiled num node returning num370 (depth = 4)
  int op_slot_right_369 = gc_frame_newslot(num370);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_left_369 = gc_frame_newslot(*var_n);
  params[0] = num370;
  partcv[0] = 1;
  Object diff372 = callmethod(*var_n, "-(1)", 1, partcv, params);
// compiled op node returning diff372 (depth = 3)
  gc_frame_newslot(diff372);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe373 = gc_frame_new();
// call case 4: self request
  Object call374 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe373);
// compiled member node returning call374 (depth = 3)
  params[0] = diff372;
  partcv[0] = 1;
  Object call375 = callmethodflags(call374, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe368);
// compiled call node returning call375 (depth = 2)
  gc_frame_end(frame);
  return call375;
}
Object meth_collectionsPrelude_keys376(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 525
  setline(525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe377 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num378 = alloc_Float64(1);
// compiled num node returning num378 (depth = 3)
  gc_frame_newslot(num378);
// starting to compile member node (depth = 3)
  int callframe379 = gc_frame_new();
// call case 4: self request
  Object call380 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe379);
// compiled member node returning call380 (depth = 3)
  gc_frame_newslot(call380);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe381 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe382 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe383 = gc_frame_new();
// call case 3: self.outer request
  Object call384 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe383);
// compiled member node returning call384 (depth = 5)
  Object call385 = callmethodflags(call384, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe382);
// compiled member node returning call385 (depth = 4)
  Object call386 = callmethodflags(call385, "range", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe381);
// compiled member node returning call386 (depth = 3)
  params[0] = num378;
  params[1] = call380;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call387 = callmethodflags(call386, "from(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe377);
// compiled call node returning call387 (depth = 2)
  gc_frame_end(frame);
  return call387;
}
Object meth_collectionsPrelude_values388(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 528
  setline(528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply393(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe395 = gc_frame_new();
// call case 4: self request
  Object call396 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe395);
// compiled member node returning call396 (depth = 5)
  int op_slot_right_394 = gc_frame_newslot(call396);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  int op_slot_left_394 = gc_frame_newslot(*var_i);
  params[0] = call396;
  partcv[0] = 1;
  Object opresult398 = callmethod(*var_i, "<(1)", 1, partcv, params);
// compiled op node returning opresult398 (depth = 4)
  gc_frame_end(frame);
  return opresult398;
}
Object meth_collectionsPrelude__apply401(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_block2 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 533
  setline(533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe402 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num404 = alloc_Float64(1);
// compiled num node returning num404 (depth = 6)
  int op_slot_right_403 = gc_frame_newslot(num404);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_403 = gc_frame_newslot(*var_i);
  params[0] = num404;
  partcv[0] = 1;
  Object sum406 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum406 (depth = 5)
  gc_frame_newslot(sum406);
// starting to compile call node (depth = 5)
  int callframe407 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe408 = gc_frame_new();
// call case 4: self request
  Object call409 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe408);
// compiled member node returning call409 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call410 = callmethodflags(call409, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe407);
// compiled call node returning call410 (depth = 5)
  gc_frame_newslot(call410);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block2 (depth = 5)
  params[0] = sum406;
  params[1] = call410;
  partcv[0] = 2;
  Object call411 = callmethodflags(*var_block2, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe402);
// compiled call node returning call411 (depth = 4)
// Begin line 534
  setline(534);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num413 = alloc_Float64(1);
// compiled num node returning num413 (depth = 6)
  int op_slot_right_412 = gc_frame_newslot(num413);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_412 = gc_frame_newslot(*var_i);
  params[0] = num413;
  partcv[0] = 1;
  Object sum415 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum415 (depth = 5)
  *var_i = sum415;
  if (sum415 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_keysAndValuesDo_40_1_41_389(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keysAndValuesDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysAndValuesDo(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysAndValuesDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part keysAndValuesDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_i = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "i");
// Begin line 531
  setline(531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num390 = alloc_Float64(0);
// compiled num node returning num390 (depth = 3)
  *var_i = num390;
  if (num390 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 532
  setline(532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe391 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block392 = alloc_Block(NULL, NULL, "collectionsPrelude", 532);
  gc_frame_newslot(block392);
// method "_apply"
  block_savedest(block392);
  Object closure393 = createclosure(2, "_apply");
  setclosureframe(closure393, stackframe);
  addtoclosure(closure393, var_i);
  addtoclosure(closure393, selfslot);
  struct UserObject *uo393 = (struct UserObject*)block392;
  uo393->data[0] = (Object)closure393;
  Method *meth_meth_collectionsPrelude__apply393 = addmethod2pos(block392, "_apply", &meth_collectionsPrelude__apply393, 0);
  int argcv_meth_collectionsPrelude__apply393[] = {0};
  meth_meth_collectionsPrelude__apply393->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply393);
  meth_meth_collectionsPrelude__apply393->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply393->definitionLine = 1963;
// compiled block node returning block392 (depth = 3)
  gc_frame_newslot(block392);
// starting to compile block node (depth = 3)
  Object block400 = alloc_Block(NULL, NULL, "collectionsPrelude", 532);
  gc_frame_newslot(block400);
// method "_apply"
  block_savedest(block400);
  Object closure401 = createclosure(3, "_apply");
  setclosureframe(closure401, stackframe);
  addtoclosure(closure401, var_i);
  addtoclosure(closure401, var_block2);
  addtoclosure(closure401, selfslot);
  struct UserObject *uo401 = (struct UserObject*)block400;
  uo401->data[0] = (Object)closure401;
  Method *meth_meth_collectionsPrelude__apply401 = addmethod2pos(block400, "_apply", &meth_collectionsPrelude__apply401, 0);
  int argcv_meth_collectionsPrelude__apply401[] = {0};
  meth_meth_collectionsPrelude__apply401->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply401);
  meth_meth_collectionsPrelude__apply401->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply401->definitionLine = 1963;
// compiled block node returning block400 (depth = 3)
  gc_frame_newslot(block400);
// call case 5: prelude request
  params[0] = block392;
  params[1] = block400;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call418 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe391);
// compiled call node returning call418 (depth = 2)
  gc_frame_end(frame);
  return call418;
}
Object meth_collectionsPrelude__apply_40_1_41_434(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_freshArray = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 541
  setline(541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe435 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  gc_frame_newslot(*var_ix);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_freshArray (depth = 5)
  params[0] = *var_ix;
  params[1] = *var_each;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call436 = callmethodflags(*var_freshArray, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe435);
// compiled call node returning call436 (depth = 4)
// Begin line 542
  setline(542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num438 = alloc_Float64(1);
// compiled num node returning num438 (depth = 6)
  int op_slot_right_437 = gc_frame_newslot(num438);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  int op_slot_left_437 = gc_frame_newslot(*var_ix);
  params[0] = num438;
  partcv[0] = 1;
  Object diff440 = callmethod(*var_ix, "-(1)", 1, partcv, params);
// compiled op node returning diff440 (depth = 5)
  *var_ix = diff440;
  if (diff440 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_reversed419(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "reversed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var__prelude = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_freshArray = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "freshArray");
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
// Begin line 538
  setline(538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe420 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe421 = gc_frame_new();
// call case 4: self request
  Object call422 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe421);
// compiled member node returning call422 (depth = 4)
  gc_frame_newslot(call422);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe423 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var__prelude (depth = 5)
  Object call424 = callmethodflags(*var__prelude, "primitiveArray", 0, partcv, params, 0);
  gc_frame_end(callframe423);
// compiled member node returning call424 (depth = 4)
  params[0] = call422;
  partcv[0] = 1;
  Object call425 = callmethodflags(call424, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe420);
// compiled call node returning call425 (depth = 3)
  *var_freshArray = call425;
  if (call425 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 539
  setline(539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num427 = alloc_Float64(1);
// compiled num node returning num427 (depth = 4)
  int op_slot_right_426 = gc_frame_newslot(num427);
// starting to compile member node (depth = 4)
  int callframe429 = gc_frame_new();
// call case 4: self request
  Object call430 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe429);
// compiled member node returning call430 (depth = 4)
  int op_slot_left_426 = gc_frame_newslot(call430);
  params[0] = num427;
  partcv[0] = 1;
  Object diff431 = callmethod(call430, "-(1)", 1, partcv, params);
// compiled op node returning diff431 (depth = 3)
  *var_ix = diff431;
  if (diff431 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 540
  setline(540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe432 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block433 = alloc_Block(NULL, NULL, "collectionsPrelude", 540);
  gc_frame_newslot(block433);
// method "_apply(_)"
  block_savedest(block433);
  Object closure434 = createclosure(3, "_apply(1)");
  setclosureframe(closure434, stackframe);
  addtoclosure(closure434, var_ix);
  addtoclosure(closure434, var_freshArray);
  addtoclosure(closure434, selfslot);
  struct UserObject *uo434 = (struct UserObject*)block433;
  uo434->data[0] = (Object)closure434;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_434 = addmethod2pos(block433, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_434, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_434[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_434->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_434);
  meth_meth_collectionsPrelude__apply_40_1_41_434->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_434->definitionLine = 1963;
// compiled block node returning block433 (depth = 3)
  gc_frame_newslot(block433);
// call case 4: self request
  params[0] = block433;
  partcv[0] = 1;
  Object call443 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe432);
// compiled call node returning call443 (depth = 2)
// Begin line 544
  setline(544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe444 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_freshArray (depth = 3)
  gc_frame_newslot(*var_freshArray);
// starting to compile member node (depth = 3)
  int callframe445 = gc_frame_new();
// call case 4: self request
  Object call446 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe445);
// compiled member node returning call446 (depth = 3)
  gc_frame_newslot(call446);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe447 = gc_frame_new();
// call case 3: self.outer request
  Object call448 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe447);
// compiled member node returning call448 (depth = 3)
  params[0] = *var_freshArray;
  params[1] = call446;
  partcv[0] = 2;
  Object call449 = callmethodflags(call448, "fromprimitiveArray(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe444);
// compiled call node returning call449 (depth = 2)
  gc_frame_end(frame);
  return call449;
}
Object meth_collectionsPrelude__43__43__40_1_41_450(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ++(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 547
  setline(547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe451 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe452 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe453 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe454 = gc_frame_new();
// call case 3: self.outer request
  Object call455 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe454);
// compiled member node returning call455 (depth = 5)
  Object call456 = callmethodflags(call455, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe453);
// compiled member node returning call456 (depth = 4)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 2;
  Object call457 = callmethodflags(call456, "lazyConcatenation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe452);
// compiled call node returning call457 (depth = 3)
  gc_frame_newslot(call457);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe458 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe459 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe460 = gc_frame_new();
// call case 3: self.outer request
  Object call461 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe460);
// compiled member node returning call461 (depth = 5)
  Object call462 = callmethodflags(call461, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe459);
// compiled member node returning call462 (depth = 4)
  Object call463 = callmethodflags(call462, "sequence", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe458);
// compiled member node returning call463 (depth = 3)
  params[0] = call457;
  partcv[0] = 1;
  Object call464 = callmethodflags(call463, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe451);
// compiled call node returning call464 (depth = 2)
  gc_frame_end(frame);
  return call464;
}
Object meth_collectionsPrelude__apply_40_1_41_479(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 552
  setline(552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe481 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe482 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe483 = gc_frame_new();
// call case 4: self request
  Object call484 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe483);
// compiled member node returning call484 (depth = 8)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call485 = callmethodflags(call484, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe482);
// compiled call node returning call485 (depth = 7)
  Object call486 = callmethodflags(call485, "asString", 0, partcv, params, 0);
  gc_frame_end(callframe481);
// compiled member node returning call486 (depth = 6)
  int op_slot_right_480 = gc_frame_newslot(call486);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_480 = gc_frame_newslot(*var_s);
  params[0] = call486;
  partcv[0] = 1;
  Object opresult488 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult488 (depth = 5)
  *var_s = opresult488;
  if (opresult488 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 553
  setline(553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num493 = alloc_Float64(1);
// compiled num node returning num493 (depth = 7)
  int op_slot_right_492 = gc_frame_newslot(num493);
// starting to compile member node (depth = 7)
  int callframe495 = gc_frame_new();
// call case 4: self request
  Object call496 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe495);
// compiled member node returning call496 (depth = 7)
  int op_slot_left_492 = gc_frame_newslot(call496);
  params[0] = num493;
  partcv[0] = 1;
  Object diff497 = callmethod(call496, "-(1)", 1, partcv, params);
// compiled op node returning diff497 (depth = 6)
  int op_slot_right_491 = gc_frame_newslot(diff497);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_491 = gc_frame_newslot(*var_i);
  params[0] = diff497;
  partcv[0] = 1;
  Object opresult499 = callmethod(*var_i, "<(1)", 1, partcv, params);
// compiled op node returning opresult499 (depth = 5)
  Object if490 = done;
  if (istrue(opresult499)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit501 == NULL) {
    strlit501 = alloc_String(", ");
    gc_root(strlit501);
  }
// compiled string node returning strlit501 (depth = 7)
  int op_slot_right_500 = gc_frame_newslot(strlit501);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_500 = gc_frame_newslot(*var_s);
  params[0] = strlit501;
  partcv[0] = 1;
  Object opresult503 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult503 (depth = 6)
  *var_s = opresult503;
  if (opresult503 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if490 = done;
  } else {
  }
// compiled if node returning if490 (depth = 4)
  gc_frame_end(frame);
  return if490;
}
Object meth_collectionsPrelude_asString465(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 550
  setline(550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit466 == NULL) {
    strlit466 = alloc_String("""\xe2""""\x9f""""\xa8""");
    gc_root(strlit466);
  }
// compiled string node returning strlit466 (depth = 3)
  *var_s = strlit466;
  if (strlit466 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 551
  setline(551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe467 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num470 = alloc_Float64(1);
// compiled num node returning num470 (depth = 5)
  int op_slot_right_469 = gc_frame_newslot(num470);
// starting to compile member node (depth = 5)
  int callframe472 = gc_frame_new();
// call case 4: self request
  Object call473 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe472);
// compiled member node returning call473 (depth = 5)
  int op_slot_left_469 = gc_frame_newslot(call473);
  params[0] = num470;
  partcv[0] = 1;
  Object diff474 = callmethod(call473, "-(1)", 1, partcv, params);
// compiled op node returning diff474 (depth = 4)
  int op_slot_right_468 = gc_frame_newslot(diff474);
// starting to compile num node (depth = 4)
  Object num476 = alloc_Float64(0);
// compiled num node returning num476 (depth = 4)
  int op_slot_left_468 = gc_frame_newslot(num476);
  params[0] = diff474;
  partcv[0] = 1;
  Object opresult477 = callmethod(num476, "..(1)", 1, partcv, params);
// compiled op node returning opresult477 (depth = 3)
  gc_frame_newslot(opresult477);
// starting to compile block node (depth = 3)
  Object block478 = alloc_Block(NULL, NULL, "collectionsPrelude", 551);
  gc_frame_newslot(block478);
// method "_apply(_)"
  block_savedest(block478);
  Object closure479 = createclosure(2, "_apply(1)");
  setclosureframe(closure479, stackframe);
  addtoclosure(closure479, var_s);
  addtoclosure(closure479, selfslot);
  struct UserObject *uo479 = (struct UserObject*)block478;
  uo479->data[0] = (Object)closure479;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_479 = addmethod2pos(block478, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_479, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_479[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_479->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_479);
  meth_meth_collectionsPrelude__apply_40_1_41_479->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_479->definitionLine = 1963;
// compiled block node returning block478 (depth = 3)
  gc_frame_newslot(block478);
// call case 5: prelude request
  params[0] = opresult477;
  params[1] = block478;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call506 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe467);
// compiled call node returning call506 (depth = 2)
// Begin line 555
  setline(555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit508 == NULL) {
    strlit508 = alloc_String("""\xe2""""\x9f""""\xa9""");
    gc_root(strlit508);
  }
// compiled string node returning strlit508 (depth = 3)
  int op_slot_right_507 = gc_frame_newslot(strlit508);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_507 = gc_frame_newslot(*var_s);
  params[0] = strlit508;
  partcv[0] = 1;
  Object opresult510 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult510 (depth = 2)
  gc_frame_end(frame);
  return opresult510;
}
Object meth_collectionsPrelude__apply_40_1_41_514(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_element = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_element (depth = 6)
  int op_slot_right_516 = gc_frame_newslot(*var_element);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  int op_slot_left_516 = gc_frame_newslot(*var_each);
  params[0] = *var_element;
  partcv[0] = 1;
  Object opresult518 = callmethod(*var_each, "==(1)", 1, partcv, params);
// compiled op node returning opresult518 (depth = 5)
  Object if515 = done;
  if (istrue(opresult518)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool519 = alloc_Boolean(1);
// compiled identifier node returning bool519 (depth = 6)
  block_return(realself, bool519);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if515 = undefined;
  } else {
  }
// compiled if node returning if515 (depth = 4)
  gc_frame_end(frame);
  return if515;
}
Object meth_collectionsPrelude_contains_40_1_41_511(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_element = &(stackframe->slots[0]);
  *var_element = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part contains(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 558
  setline(558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe512 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block513 = alloc_Block(NULL, NULL, "collectionsPrelude", 558);
  gc_frame_newslot(block513);
// method "_apply(_)"
  block_savedest(block513);
  Object closure514 = createclosure(2, "_apply(1)");
  setclosureframe(closure514, stackframe);
  addtoclosure(closure514, var_element);
  addtoclosure(closure514, selfslot);
  struct UserObject *uo514 = (struct UserObject*)block513;
  uo514->data[0] = (Object)closure514;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_514 = addmethod2pos(block513, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_514, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_514[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_514->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_514);
  meth_meth_collectionsPrelude__apply_40_1_41_514->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_514->definitionLine = 1963;
// compiled block node returning block513 (depth = 3)
  gc_frame_newslot(block513);
// call case 4: self request
  params[0] = block513;
  partcv[0] = 1;
  Object call521 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe512);
// compiled call node returning call521 (depth = 2)
// Begin line 559
  setline(559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool522 = alloc_Boolean(0);
// compiled identifier node returning bool522 (depth = 3)
  return bool522;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply527(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe529 = gc_frame_new();
// call case 4: self request
  Object call530 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe529);
// compiled member node returning call530 (depth = 5)
  int op_slot_right_528 = gc_frame_newslot(call530);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  int op_slot_left_528 = gc_frame_newslot(*var_i);
  params[0] = call530;
  partcv[0] = 1;
  Object opresult532 = callmethod(*var_i, "<(1)", 1, partcv, params);
// compiled op node returning opresult532 (depth = 4)
  gc_frame_end(frame);
  return opresult532;
}
Object meth_collectionsPrelude__apply535(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_block1 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 564
  setline(564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe536 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe537 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe538 = gc_frame_new();
// call case 4: self request
  Object call539 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe538);
// compiled member node returning call539 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call540 = callmethodflags(call539, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe537);
// compiled call node returning call540 (depth = 5)
  gc_frame_newslot(call540);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block1 (depth = 5)
  params[0] = call540;
  partcv[0] = 1;
  Object call541 = callmethodflags(*var_block1, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe536);
// compiled call node returning call541 (depth = 4)
// Begin line 565
  setline(565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num543 = alloc_Float64(1);
// compiled num node returning num543 (depth = 6)
  int op_slot_right_542 = gc_frame_newslot(num543);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_542 = gc_frame_newslot(*var_i);
  params[0] = num543;
  partcv[0] = 1;
  Object sum545 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum545 (depth = 5)
  *var_i = sum545;
  if (sum545 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_do_40_1_41_523(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_i = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "i");
// Begin line 562
  setline(562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num524 = alloc_Float64(0);
// compiled num node returning num524 (depth = 3)
  *var_i = num524;
  if (num524 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 563
  setline(563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe525 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block526 = alloc_Block(NULL, NULL, "collectionsPrelude", 563);
  gc_frame_newslot(block526);
// method "_apply"
  block_savedest(block526);
  Object closure527 = createclosure(2, "_apply");
  setclosureframe(closure527, stackframe);
  addtoclosure(closure527, var_i);
  addtoclosure(closure527, selfslot);
  struct UserObject *uo527 = (struct UserObject*)block526;
  uo527->data[0] = (Object)closure527;
  Method *meth_meth_collectionsPrelude__apply527 = addmethod2pos(block526, "_apply", &meth_collectionsPrelude__apply527, 0);
  int argcv_meth_collectionsPrelude__apply527[] = {0};
  meth_meth_collectionsPrelude__apply527->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply527);
  meth_meth_collectionsPrelude__apply527->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply527->definitionLine = 1963;
// compiled block node returning block526 (depth = 3)
  gc_frame_newslot(block526);
// starting to compile block node (depth = 3)
  Object block534 = alloc_Block(NULL, NULL, "collectionsPrelude", 563);
  gc_frame_newslot(block534);
// method "_apply"
  block_savedest(block534);
  Object closure535 = createclosure(3, "_apply");
  setclosureframe(closure535, stackframe);
  addtoclosure(closure535, var_i);
  addtoclosure(closure535, var_block1);
  addtoclosure(closure535, selfslot);
  struct UserObject *uo535 = (struct UserObject*)block534;
  uo535->data[0] = (Object)closure535;
  Method *meth_meth_collectionsPrelude__apply535 = addmethod2pos(block534, "_apply", &meth_collectionsPrelude__apply535, 0);
  int argcv_meth_collectionsPrelude__apply535[] = {0};
  meth_meth_collectionsPrelude__apply535->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply535);
  meth_meth_collectionsPrelude__apply535->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply535->definitionLine = 1963;
// compiled block node returning block534 (depth = 3)
  gc_frame_newslot(block534);
// call case 5: prelude request
  params[0] = block526;
  params[1] = block534;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call548 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe525);
// compiled call node returning call548 (depth = 2)
  gc_frame_end(frame);
  return call548;
}
Object meth_collectionsPrelude__61__61__40_1_41_549(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe550 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe551 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe552 = gc_frame_new();
// call case 3: self.outer request
  Object call553 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe552);
// compiled member node returning call553 (depth = 4)
  Object call554 = callmethodflags(call553, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe551);
// compiled member node returning call554 (depth = 3)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call555 = callmethodflags(call554, "isEqual(1)toIterable(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe550);
// compiled call node returning call555 (depth = 2)
  gc_frame_end(frame);
  return call555;
}
Object meth_collectionsPrelude_asDebugString560(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 574
  setline(574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit562 == NULL) {
    strlit562 = alloc_String("""\xe2""""\x9f""""\xab""");
    gc_root(strlit562);
  }
// compiled string node returning strlit562 (depth = 3)
  int op_slot_right_561 = gc_frame_newslot(strlit562);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe565 = gc_frame_new();
// call case 4: self request
  Object call566 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe565);
// compiled member node returning call566 (depth = 4)
  int op_slot_right_564 = gc_frame_newslot(call566);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit569 == NULL) {
    strlit569 = alloc_String("""\xe2""""\x9f""""\xaa""");
    gc_root(strlit569);
  }
// compiled string node returning strlit569 (depth = 5)
  int op_slot_right_568 = gc_frame_newslot(strlit569);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe572 = gc_frame_new();
// call case 4: self request
  Object call573 = callmethodflags(self, "asString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe572);
// compiled member node returning call573 (depth = 6)
  int op_slot_right_571 = gc_frame_newslot(call573);
// starting to compile string node (depth = 6)
  if (strlit575 == NULL) {
    strlit575 = alloc_String("");
    gc_root(strlit575);
  }
// compiled string node returning strlit575 (depth = 6)
  int op_slot_left_571 = gc_frame_newslot(strlit575);
  params[0] = call573;
  partcv[0] = 1;
  Object opresult576 = callmethod(strlit575, "++(1)", 1, partcv, params);
// compiled op node returning opresult576 (depth = 5)
  int op_slot_left_568 = gc_frame_newslot(opresult576);
  params[0] = strlit569;
  partcv[0] = 1;
  Object opresult577 = callmethod(opresult576, "++(1)", 1, partcv, params);
// compiled op node returning opresult577 (depth = 4)
  int op_slot_left_564 = gc_frame_newslot(opresult577);
  params[0] = call566;
  partcv[0] = 1;
  Object opresult578 = callmethod(opresult577, "++(1)", 1, partcv, params);
// compiled op node returning opresult578 (depth = 3)
  int op_slot_left_561 = gc_frame_newslot(opresult578);
  params[0] = strlit562;
  partcv[0] = 1;
  Object opresult579 = callmethod(opresult578, "++(1)", 1, partcv, params);
// compiled op node returning opresult579 (depth = 2)
  gc_frame_end(frame);
  return opresult579;
}
Object meth_collectionsPrelude_asString580(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 575
  setline(575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit581 == NULL) {
    strlit581 = alloc_String("aSequenceIterator");
    gc_root(strlit581);
  }
// compiled string node returning strlit581 (depth = 2)
  gc_frame_end(frame);
  return strlit581;
}
Object meth_collectionsPrelude_hasNext582(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sz = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 576
  setline(576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sz (depth = 3)
  int op_slot_right_583 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 3)
  int callframe585 = gc_frame_new();
// call case 4: self request
  Object call586 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe585);
// compiled member node returning call586 (depth = 3)
  int op_slot_left_583 = gc_frame_newslot(call586);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult587 = callmethod(call586, "≤(1)", 1, partcv, params);
// compiled op node returning opresult587 (depth = 2)
  gc_frame_end(frame);
  return opresult587;
}
Object meth_collectionsPrelude_next588(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sz = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ret = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "ret");
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sz (depth = 4)
  int op_slot_right_590 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 4)
  int callframe592 = gc_frame_new();
// call case 4: self request
  Object call593 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe592);
// compiled member node returning call593 (depth = 4)
  int op_slot_left_590 = gc_frame_newslot(call593);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult594 = callmethod(call593, ">(1)", 1, partcv, params);
// compiled op node returning opresult594 (depth = 3)
  Object if589 = done;
  if (istrue(opresult594)) {
// starting to compile call node (depth = 3)
  int callframe595 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit597 == NULL) {
    strlit597 = alloc_String("""\xe2""""\x9f""""\xab""");
    gc_root(strlit597);
  }
// compiled string node returning strlit597 (depth = 5)
  int op_slot_right_596 = gc_frame_newslot(strlit597);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe600 = gc_frame_new();
// call case 4: self request
  Object call601 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe600);
// compiled member node returning call601 (depth = 6)
  int op_slot_right_599 = gc_frame_newslot(call601);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit604 == NULL) {
    strlit604 = alloc_String("""\xe2""""\x9f""""\xaa""");
    gc_root(strlit604);
  }
// compiled string node returning strlit604 (depth = 7)
  int op_slot_right_603 = gc_frame_newslot(strlit604);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe607 = gc_frame_new();
// call case 3: self.outer request
  Object call608 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe607);
// compiled member node returning call608 (depth = 8)
  int op_slot_right_606 = gc_frame_newslot(call608);
// starting to compile string node (depth = 8)
  if (strlit610 == NULL) {
    strlit610 = alloc_String("on sequence ");
    gc_root(strlit610);
  }
// compiled string node returning strlit610 (depth = 8)
  int op_slot_left_606 = gc_frame_newslot(strlit610);
  params[0] = call608;
  partcv[0] = 1;
  Object opresult611 = callmethod(strlit610, "++(1)", 1, partcv, params);
// compiled op node returning opresult611 (depth = 7)
  int op_slot_left_603 = gc_frame_newslot(opresult611);
  params[0] = strlit604;
  partcv[0] = 1;
  Object opresult612 = callmethod(opresult611, "++(1)", 1, partcv, params);
// compiled op node returning opresult612 (depth = 6)
  int op_slot_left_599 = gc_frame_newslot(opresult612);
  params[0] = call601;
  partcv[0] = 1;
  Object opresult613 = callmethod(opresult612, "++(1)", 1, partcv, params);
// compiled op node returning opresult613 (depth = 5)
  int op_slot_left_596 = gc_frame_newslot(opresult613);
  params[0] = strlit597;
  partcv[0] = 1;
  Object opresult614 = callmethod(opresult613, "++(1)", 1, partcv, params);
// compiled op node returning opresult614 (depth = 4)
  gc_frame_newslot(opresult614);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_IteratorExhausted (depth = 4)
  params[0] = opresult614;
  partcv[0] = 1;
  Object call615 = callmethodflags(*var_IteratorExhausted, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe595);
// compiled call node returning call615 (depth = 3)
    gc_frame_newslot(call615);
    if589 = call615;
  } else {
  }
// compiled if node returning if589 (depth = 2)
// Begin line 579
  setline(579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe616 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe617 = gc_frame_new();
// call case 4: self request
  Object call618 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe617);
// compiled member node returning call618 (depth = 4)
  gc_frame_newslot(call618);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe619 = gc_frame_new();
// call case 3: self.outer request
  Object call620 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe619);
// compiled member node returning call620 (depth = 4)
  params[0] = call618;
  partcv[0] = 1;
  Object call621 = callmethodflags(call620, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe616);
// compiled call node returning call621 (depth = 3)
  *var_ret = call621;
  if (call621 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 580
  setline(580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe622 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num624 = alloc_Float64(1);
// compiled num node returning num624 (depth = 4)
  int op_slot_right_623 = gc_frame_newslot(num624);
// starting to compile member node (depth = 4)
  int callframe626 = gc_frame_new();
// call case 4: self request
  Object call627 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe626);
// compiled member node returning call627 (depth = 4)
  int op_slot_left_623 = gc_frame_newslot(call627);
  params[0] = num624;
  partcv[0] = 1;
  Object sum628 = callmethod(call627, "+(1)", 1, partcv, params);
// compiled op node returning sum628 (depth = 3)
  gc_frame_newslot(sum628);
// call case 4: self request
  params[0] = sum628;
  partcv[0] = 1;
  Object call629 = callmethodflags(self, "idx:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe622);
// compiled call node returning call629 (depth = 2)
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_ret (depth = 2)
  gc_frame_end(frame);
  return *var_ret;
}
Object meth_collectionsPrelude_iterator556(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sz = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject557 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj557 = alloc_userobj2(6,6, objclass557);
  gc_frame_newslot(obj557);
if (objclass557 == NULL) {
  glfree(obj557->class->name);
  obj557->class->name = "sequence.object.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj557, self, 0);
  addmethodreal(obj557,"outer", &reader_collectionsPrelude_outer_558);
  Object oldself557 = self;
  struct StackFrameObject *oldstackframe557 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe557);
  gc_frame_newslot((Object)stackframe);
  self = obj557;
  Object *oldselfslot557 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter557 = (*(struct UserObject *)self).data[0], lowerouter557 = thisouter557;
  if (inheritingObject557) {
    struct UserObject *inho557 = (struct UserObject *)inheritingObject557;
    while (inho557->super != GraceDefaultObject) inho557 = (struct UserObject *)inho557->super;
    inho557->super = obj557;
    self = inheritingObject557;
    *selfslot = self;
    lowerouter557 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter557;
  }
if (objclass557 == NULL) {
  Method *reader559 = addmethodrealflags(obj557, "idx", &reader_collectionsPrelude_idx_559, MFLAG_CONFIDENTIAL);
  Method *writer559 = addmethodrealflags(obj557, "idx:=(1)", &writer_collectionsPrelude_idx_559, MFLAG_CONFIDENTIAL);
  reader559->definitionModule = modulename;
  writer559->definitionModule = modulename;
  reader559->definitionLine = 573;
  writer559->definitionLine = 573;
}
obj557->flags |= OFLAG_MUTABLE;
adddatum2(obj557, alloc_Undefined(), 1);
// method "asDebugString"
  struct UserObject *uo560 = (struct UserObject*)obj557;
  uo560->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString560 = addmethod2pos(obj557, "asDebugString", &meth_collectionsPrelude_asDebugString560, 2);
  int argcv_meth_collectionsPrelude_asDebugString560[] = {0};
  meth_meth_collectionsPrelude_asDebugString560->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString560);
  meth_meth_collectionsPrelude_asDebugString560->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString560->definitionLine = 574;
// method "asString"
  struct UserObject *uo580 = (struct UserObject*)obj557;
  uo580->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString580 = addmethod2pos(obj557, "asString", &meth_collectionsPrelude_asString580, 3);
  int argcv_meth_collectionsPrelude_asString580[] = {0};
  meth_meth_collectionsPrelude_asString580->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString580);
  meth_meth_collectionsPrelude_asString580->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString580->definitionLine = 575;
// method "hasNext"
  block_savedest(obj557);
  Object closure582 = createclosure(1, "hasNext");
  setclosureframe(closure582, stackframe);
  addtoclosure(closure582, var_sz);
  struct UserObject *uo582 = (struct UserObject*)obj557;
  uo582->data[4] = (Object)closure582;
  Method *meth_meth_collectionsPrelude_hasNext582 = addmethod2pos(obj557, "hasNext", &meth_collectionsPrelude_hasNext582, 4);
  int argcv_meth_collectionsPrelude_hasNext582[] = {0};
  meth_meth_collectionsPrelude_hasNext582->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext582);
  meth_meth_collectionsPrelude_hasNext582->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext582->definitionLine = 576;
// method "next"
  block_savedest(obj557);
  Object closure588 = createclosure(2, "next");
  setclosureframe(closure588, stackframe);
  addtoclosure(closure588, var_sz);
  addtoclosure(closure588, var_IteratorExhausted);
  struct UserObject *uo588 = (struct UserObject*)obj557;
  uo588->data[5] = (Object)closure588;
  Method *meth_meth_collectionsPrelude_next588 = addmethod2pos(obj557, "next", &meth_collectionsPrelude_next588, 5);
  int argcv_meth_collectionsPrelude_next588[] = {0};
  meth_meth_collectionsPrelude_next588->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next588);
  meth_meth_collectionsPrelude_next588->definitionModule = modulename;
  meth_meth_collectionsPrelude_next588->definitionLine = 577;
  sourceObject = obj557;
// Begin line 573
  setline(573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num630 = alloc_Float64(1);
// compiled num node returning num630 (depth = 2)
  adddatum2(obj557, num630, 1);
  sourceObject = obj557;
  sourceObject = obj557;
  sourceObject = obj557;
  sourceObject = obj557;
  objclass557 = obj557->class;
  objclass557->definitionModule = modulename;
  objclass557->definitionLine = 572;
  (*(struct UserObject *)self).data[0] = lowerouter557;
  self = oldself557;
  selfslot = oldselfslot557;
  stackframe = oldstackframe557;
  gc_frame_end(frame);
  return obj557;
}
Object meth_collectionsPrelude_iterator556_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_sz = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject557 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj557 = alloc_userobj2(6,6, objclass557);
  gc_frame_newslot(obj557);
if (objclass557 == NULL) {
  glfree(obj557->class->name);
  obj557->class->name = "sequence.object.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj557, self, 0);
  addmethodreal(obj557,"outer", &reader_collectionsPrelude_outer_558);
  Object oldself557 = self;
  struct StackFrameObject *oldstackframe557 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe557);
  gc_frame_newslot((Object)stackframe);
  self = obj557;
  Object *oldselfslot557 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter557 = (*(struct UserObject *)self).data[0], lowerouter557 = thisouter557;
  if (inheritingObject557) {
    struct UserObject *inho557 = (struct UserObject *)inheritingObject557;
    while (inho557->super != GraceDefaultObject) inho557 = (struct UserObject *)inho557->super;
    inho557->super = obj557;
    self = inheritingObject557;
    *selfslot = self;
    lowerouter557 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter557;
  }
if (objclass557 == NULL) {
  Method *reader559 = addmethodrealflags(obj557, "idx", &reader_collectionsPrelude_idx_559, MFLAG_CONFIDENTIAL);
  Method *writer559 = addmethodrealflags(obj557, "idx:=(1)", &writer_collectionsPrelude_idx_559, MFLAG_CONFIDENTIAL);
  reader559->definitionModule = modulename;
  writer559->definitionModule = modulename;
  reader559->definitionLine = 573;
  writer559->definitionLine = 573;
}
obj557->flags |= OFLAG_MUTABLE;
adddatum2(obj557, alloc_Undefined(), 1);
// method "asDebugString"
  struct UserObject *uo560 = (struct UserObject*)obj557;
  uo560->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString560 = addmethod2pos(obj557, "asDebugString", &meth_collectionsPrelude_asDebugString560, 2);
  int argcv_meth_collectionsPrelude_asDebugString560[] = {0};
  meth_meth_collectionsPrelude_asDebugString560->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString560);
  meth_meth_collectionsPrelude_asDebugString560->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString560->definitionLine = 574;
// method "asString"
  struct UserObject *uo580 = (struct UserObject*)obj557;
  uo580->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString580 = addmethod2pos(obj557, "asString", &meth_collectionsPrelude_asString580, 3);
  int argcv_meth_collectionsPrelude_asString580[] = {0};
  meth_meth_collectionsPrelude_asString580->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString580);
  meth_meth_collectionsPrelude_asString580->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString580->definitionLine = 575;
// method "hasNext"
  block_savedest(obj557);
  Object closure582 = createclosure(1, "hasNext");
  setclosureframe(closure582, stackframe);
  addtoclosure(closure582, var_sz);
  struct UserObject *uo582 = (struct UserObject*)obj557;
  uo582->data[4] = (Object)closure582;
  Method *meth_meth_collectionsPrelude_hasNext582 = addmethod2pos(obj557, "hasNext", &meth_collectionsPrelude_hasNext582, 4);
  int argcv_meth_collectionsPrelude_hasNext582[] = {0};
  meth_meth_collectionsPrelude_hasNext582->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext582);
  meth_meth_collectionsPrelude_hasNext582->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext582->definitionLine = 576;
// method "next"
  block_savedest(obj557);
  Object closure588 = createclosure(2, "next");
  setclosureframe(closure588, stackframe);
  addtoclosure(closure588, var_sz);
  addtoclosure(closure588, var_IteratorExhausted);
  struct UserObject *uo588 = (struct UserObject*)obj557;
  uo588->data[5] = (Object)closure588;
  Method *meth_meth_collectionsPrelude_next588 = addmethod2pos(obj557, "next", &meth_collectionsPrelude_next588, 5);
  int argcv_meth_collectionsPrelude_next588[] = {0};
  meth_meth_collectionsPrelude_next588->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next588);
  meth_meth_collectionsPrelude_next588->definitionModule = modulename;
  meth_meth_collectionsPrelude_next588->definitionLine = 577;
  sourceObject = obj557;
// Begin line 573
  setline(573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num630 = alloc_Float64(1);
// compiled num node returning num630 (depth = 2)
  adddatum2(obj557, num630, 1);
  sourceObject = obj557;
  sourceObject = obj557;
  sourceObject = obj557;
  sourceObject = obj557;
  objclass557 = obj557->class;
  objclass557->definitionModule = modulename;
  objclass557->definitionLine = 572;
  (*(struct UserObject *)self).data[0] = lowerouter557;
  self = oldself557;
  selfslot = oldselfslot557;
  stackframe = oldstackframe557;
  gc_frame_end(frame);
  return obj557;
}
Object meth_collectionsPrelude__apply_40_2_41_636(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[1]);
  *var_r = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 587
  setline(587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_r (depth = 7)
  int op_slot_right_638 = gc_frame_newslot(*var_r);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_l (depth = 7)
  int op_slot_left_638 = gc_frame_newslot(*var_l);
  params[0] = *var_r;
  partcv[0] = 1;
  Object opresult640 = callmethod(*var_l, "==(1)", 1, partcv, params);
// compiled op node returning opresult640 (depth = 6)
  Object if637 = done;
  if (istrue(opresult640)) {
// starting to compile num node (depth = 6)
  Object num641 = alloc_Float64(0);
// compiled num node returning num641 (depth = 6)
    gc_frame_newslot(num641);
    if637 = num641;
  } else {
// Begin line 589
  setline(589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// Begin line 588
  setline(588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_r (depth = 8)
  int op_slot_right_643 = gc_frame_newslot(*var_r);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_l (depth = 8)
  int op_slot_left_643 = gc_frame_newslot(*var_l);
  params[0] = *var_r;
  partcv[0] = 1;
  Object opresult645 = callmethod(*var_l, "<(1)", 1, partcv, params);
// compiled op node returning opresult645 (depth = 7)
  Object if642 = done;
  if (istrue(opresult645)) {
// starting to compile call node (depth = 7)
  int callframe646 = gc_frame_new();
// call case 6: other requests
// starting to compile num node (depth = 8)
  Object num647 = alloc_Float64(1);
// compiled num node returning num647 (depth = 8)
  partcv[0] = 0;
  Object call648 = callmethodflags(num647, "prefix-", 1, partcv, params, 0);
  gc_frame_end(callframe646);
// compiled call node returning call648 (depth = 7)
    gc_frame_newslot(call648);
    if642 = call648;
  } else {
// Begin line 589
  setline(589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 7)
  Object num649 = alloc_Float64(1);
// compiled num node returning num649 (depth = 7)
    gc_frame_newslot(num649);
    if642 = num649;
  }
// compiled if node returning if642 (depth = 6)
    gc_frame_newslot(if642);
    if637 = if642;
  }
// compiled if node returning if637 (depth = 5)
  gc_frame_end(frame);
  return if637;
}
Object meth_collectionsPrelude_sorted632(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 590
  setline(590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe633 = gc_frame_new();
// call case 6: other requests
// Begin line 586
  setline(586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe634 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block635 = alloc_Block(NULL, NULL, "collectionsPrelude", 586);
  gc_frame_newslot(block635);
// method "_apply(_,_)"
  block_savedest(block635);
  Object closure636 = createclosure(1, "_apply(2)");
  setclosureframe(closure636, stackframe);
  addtoclosure(closure636, selfslot);
  struct UserObject *uo636 = (struct UserObject*)block635;
  uo636->data[0] = (Object)closure636;
  Method *meth_meth_collectionsPrelude__apply_40_2_41_636 = addmethod2pos(block635, "_apply(2)", &meth_collectionsPrelude__apply_40_2_41_636, 0);
  int argcv_meth_collectionsPrelude__apply_40_2_41_636[] = {2};
  meth_meth_collectionsPrelude__apply_40_2_41_636->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_2_41_636);
  meth_meth_collectionsPrelude__apply_40_2_41_636->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_2_41_636->definitionLine = 1963;
// compiled block node returning block635 (depth = 4)
  gc_frame_newslot(block635);
// call case 6: other requests
// Begin line 586
  setline(586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe651 = gc_frame_new();
// call case 4: self request
  Object call652 = callmethodflags(self, "asList", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe651);
// compiled member node returning call652 (depth = 4)
  params[0] = block635;
  partcv[0] = 1;
  Object call653 = callmethodflags(call652, "sortBy(1)", 1, partcv, params, 0);
  gc_frame_end(callframe634);
// compiled call node returning call653 (depth = 3)
  Object call654 = callmethodflags(call653, "asSequence", 0, partcv, params, 0);
  gc_frame_end(callframe633);
// compiled member node returning call654 (depth = 2)
  gc_frame_end(frame);
  return call654;
}
Object meth_collectionsPrelude_sortedBy_40_1_41_655(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortedBy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortedBy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sortedBy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 593
  setline(593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe656 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 3)
  int callframe657 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sortBlock (depth = 4)
  gc_frame_newslot(*var_sortBlock);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe658 = gc_frame_new();
// call case 4: self request
  Object call659 = callmethodflags(self, "asList", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe658);
// compiled member node returning call659 (depth = 4)
  params[0] = *var_sortBlock;
  partcv[0] = 1;
  Object call660 = callmethodflags(call659, "sortBy(1)", 1, partcv, params, 0);
  gc_frame_end(callframe657);
// compiled call node returning call660 (depth = 3)
  Object call661 = callmethodflags(call660, "asSequence", 0, partcv, params, 0);
  gc_frame_end(callframe656);
// compiled member node returning call661 (depth = 2)
  gc_frame_end(frame);
  return call661;
}
Object meth_collectionsPrelude_fromprimitiveArray_40_2_41_323(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "fromprimitiveArray(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method fromprimitiveArray(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_BoundsError = getfromclosure(closure, 0);
  Object *var__prelude = getfromclosure(closure, 1);
  Object *var_IteratorExhausted = getfromclosure(closure, 2);
  Object *var_indexable = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for fromprimitiveArray(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_pArray = &(stackframe->slots[0]);
  *var_pArray = args[curarg];
  curarg++;
  Object *var_sz = &(stackframe->slots[1]);
  *var_sz = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part fromprimitiveArray(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject324 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj324 = alloc_userobj2(17,18, objclass324);
  gc_frame_newslot(obj324);
if (objclass324 == NULL) {
  glfree(obj324->class->name);
  obj324->class->name = "sequence.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj324, self, 0);
  addmethodreal(obj324,"outer", &reader_collectionsPrelude_outer_325);
  Object oldself324 = self;
  struct StackFrameObject *oldstackframe324 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe324);
  gc_frame_newslot((Object)stackframe);
  self = obj324;
  Object *oldselfslot324 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter324 = (*(struct UserObject *)self).data[0], lowerouter324 = thisouter324;
  if (inheritingObject324) {
    struct UserObject *inho324 = (struct UserObject *)inheritingObject324;
    while (inho324->super != GraceDefaultObject) inho324 = (struct UserObject *)inho324->super;
    inho324->super = obj324;
    self = inheritingObject324;
    *selfslot = self;
    lowerouter324 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter324;
  }
if (objclass324 == NULL) {
  Method *reader326 = addmethodrealflags(obj324, "size",&reader_collectionsPrelude_size_326, MFLAG_DEF);
  reader326->definitionModule = modulename;
  reader326->definitionLine = 510;
}
adddatum2(obj324, alloc_Undefined(), 1);
if (objclass324 == NULL) {
  Method *reader327 = addmethodrealflags(obj324, "inner",&reader_collectionsPrelude_inner_327, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader327->definitionModule = modulename;
  reader327->definitionLine = 511;
}
adddatum2(obj324, alloc_Undefined(), 2);
// method "boundsCheck(_)"
  block_savedest(obj324);
  Object closure328 = createclosure(1, "boundsCheck(1)");
  setclosureframe(closure328, stackframe);
  addtoclosure(closure328, var_BoundsError);
  struct UserObject *uo328 = (struct UserObject*)obj324;
  uo328->data[3] = (Object)closure328;
  Method *meth_meth_collectionsPrelude_boundsCheck_40_1_41_328 = addmethod2pos(obj324, "boundsCheck(1)", &meth_collectionsPrelude_boundsCheck_40_1_41_328, 3);
  int argcv_meth_collectionsPrelude_boundsCheck_40_1_41_328[] = {1};
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_328->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_boundsCheck_40_1_41_328);
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_328->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_328->definitionModule = modulename;
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_328->definitionLine = 513;
// method "at(_)"
  struct UserObject *uo365 = (struct UserObject*)obj324;
  uo365->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40_1_41_365 = addmethod2pos(obj324, "at(1)", &meth_collectionsPrelude_at_40_1_41_365, 4);
  int argcv_meth_collectionsPrelude_at_40_1_41_365[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_365->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_365);
  meth_meth_collectionsPrelude_at_40_1_41_365->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_365->definitionLine = 520;
// method "keys"
  struct UserObject *uo376 = (struct UserObject*)obj324;
  uo376->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys376 = addmethod2pos(obj324, "keys", &meth_collectionsPrelude_keys376, 5);
  int argcv_meth_collectionsPrelude_keys376[] = {0};
  meth_meth_collectionsPrelude_keys376->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys376);
  meth_meth_collectionsPrelude_keys376->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys376->definitionLine = 524;
// method "values"
  struct UserObject *uo388 = (struct UserObject*)obj324;
  uo388->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values388 = addmethod2pos(obj324, "values", &meth_collectionsPrelude_values388, 6);
  int argcv_meth_collectionsPrelude_values388[] = {0};
  meth_meth_collectionsPrelude_values388->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values388);
  meth_meth_collectionsPrelude_values388->definitionModule = modulename;
  meth_meth_collectionsPrelude_values388->definitionLine = 527;
// method "keysAndValuesDo(_)"
  struct UserObject *uo389 = (struct UserObject*)obj324;
  uo389->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_389 = addmethod2pos(obj324, "keysAndValuesDo(1)", &meth_collectionsPrelude_keysAndValuesDo_40_1_41_389, 7);
  int argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_389[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_389->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_389);
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_389->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_389->definitionLine = 530;
// method "reversed"
  block_savedest(obj324);
  Object closure419 = createclosure(1, "reversed");
  setclosureframe(closure419, stackframe);
  addtoclosure(closure419, var__prelude);
  struct UserObject *uo419 = (struct UserObject*)obj324;
  uo419->data[8] = (Object)closure419;
  Method *meth_meth_collectionsPrelude_reversed419 = addmethod2pos(obj324, "reversed", &meth_collectionsPrelude_reversed419, 8);
  int argcv_meth_collectionsPrelude_reversed419[] = {0};
  meth_meth_collectionsPrelude_reversed419->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed419);
  meth_meth_collectionsPrelude_reversed419->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed419->definitionLine = 537;
// method "++(_)"
  struct UserObject *uo450 = (struct UserObject*)obj324;
  uo450->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_450 = addmethod2pos(obj324, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_450, 9);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_450[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_450->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_450);
  meth_meth_collectionsPrelude__43__43__40_1_41_450->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_450->definitionLine = 546;
// method "asString"
  struct UserObject *uo465 = (struct UserObject*)obj324;
  uo465->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString465 = addmethod2pos(obj324, "asString", &meth_collectionsPrelude_asString465, 10);
  int argcv_meth_collectionsPrelude_asString465[] = {0};
  meth_meth_collectionsPrelude_asString465->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString465);
  meth_meth_collectionsPrelude_asString465->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString465->definitionLine = 549;
// method "contains(_)"
  struct UserObject *uo511 = (struct UserObject*)obj324;
  uo511->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_511 = addmethod2pos(obj324, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_511, 11);
  int argcv_meth_collectionsPrelude_contains_40_1_41_511[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_511->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_511);
  meth_meth_collectionsPrelude_contains_40_1_41_511->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_511->definitionLine = 557;
// method "do(_)"
  struct UserObject *uo523 = (struct UserObject*)obj324;
  uo523->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_523 = addmethod2pos(obj324, "do(1)", &meth_collectionsPrelude_do_40_1_41_523, 12);
  int argcv_meth_collectionsPrelude_do_40_1_41_523[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_523->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_523);
  meth_meth_collectionsPrelude_do_40_1_41_523->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_523->definitionLine = 561;
// method "==(_)"
  struct UserObject *uo549 = (struct UserObject*)obj324;
  uo549->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_549 = addmethod2pos(obj324, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_549, 13);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_549[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_549->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_549);
  meth_meth_collectionsPrelude__61__61__40_1_41_549->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_549->definitionLine = 568;
// method "iterator"
  block_savedest(obj324);
  Object closure556 = createclosure(2, "iterator");
  setclosureframe(closure556, stackframe);
  addtoclosure(closure556, var_sz);
  addtoclosure(closure556, var_IteratorExhausted);
  struct UserObject *uo556 = (struct UserObject*)obj324;
  uo556->data[14] = (Object)closure556;
  Method *meth_meth_collectionsPrelude_iterator556 = addmethod2pos(obj324, "iterator", &meth_collectionsPrelude_iterator556, 14);
  int argcv_meth_collectionsPrelude_iterator556[] = {0};
  meth_meth_collectionsPrelude_iterator556->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator556);
  meth_meth_collectionsPrelude_iterator556->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator556->definitionLine = 571;
  block_savedest(obj324);
  Object closure631 = createclosure(2, "iterator$object(1)");
  setclosureframe(closure631, stackframe);
  addtoclosure(closure631, var_sz);
  addtoclosure(closure631, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_iterator556_object = addmethod2pos(obj324, "iterator$object(1)", &meth_collectionsPrelude_iterator556_object, 14);
  meth_meth_collectionsPrelude_iterator556_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator556_object->definitionLine = 571;
// method "sorted"
  struct UserObject *uo632 = (struct UserObject*)obj324;
  uo632->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted632 = addmethod2pos(obj324, "sorted", &meth_collectionsPrelude_sorted632, 15);
  int argcv_meth_collectionsPrelude_sorted632[] = {0};
  meth_meth_collectionsPrelude_sorted632->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted632);
  meth_meth_collectionsPrelude_sorted632->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted632->definitionLine = 585;
// method "sortedBy(_)"
  struct UserObject *uo655 = (struct UserObject*)obj324;
  uo655->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy_40_1_41_655 = addmethod2pos(obj324, "sortedBy(1)", &meth_collectionsPrelude_sortedBy_40_1_41_655, 16);
  int argcv_meth_collectionsPrelude_sortedBy_40_1_41_655[] = {1};
  meth_meth_collectionsPrelude_sortedBy_40_1_41_655->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy_40_1_41_655);
  meth_meth_collectionsPrelude_sortedBy_40_1_41_655->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy_40_1_41_655->definitionLine = 592;
  sourceObject = obj324;
// Begin line 509
  setline(509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe662 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call663 = callmethodflags(*var_indexable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe662);
// compiled call node returning call663 (depth = 2)
  struct UserObject *obj324_uo = (struct UserObject *)obj324;
  obj324_uo->super = call663;
  sourceObject = obj324;
// Begin line 510
  setline(510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_sz (depth = 2)
  adddatum2(obj324, *var_sz, 1);
  sourceObject = obj324;
// Begin line 511
  setline(511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_pArray (depth = 2)
  adddatum2(obj324, *var_pArray, 2);
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  objclass324 = obj324->class;
  objclass324->definitionModule = modulename;
  objclass324->definitionLine = 508;
  (*(struct UserObject *)self).data[0] = lowerouter324;
  self = oldself324;
  selfslot = oldselfslot324;
  stackframe = oldstackframe324;
  gc_frame_end(frame);
  return obj324;
}
Object meth_collectionsPrelude_fromprimitiveArray_40_2_41_323_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "fromprimitiveArray(2)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments for method fromprimitiveArray(_,_)");
  Object params[1];
  int partcv[2];
  Object *var_BoundsError = getfromclosure(closure, 0);
  Object *var__prelude = getfromclosure(closure, 1);
  Object *var_IteratorExhausted = getfromclosure(closure, 2);
  Object *var_indexable = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for fromprimitiveArray(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_pArray = &(stackframe->slots[0]);
  *var_pArray = args[curarg];
  curarg++;
  Object *var_sz = &(stackframe->slots[1]);
  *var_sz = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part fromprimitiveArray(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject324 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj324 = alloc_userobj2(17,18, objclass324);
  gc_frame_newslot(obj324);
if (objclass324 == NULL) {
  glfree(obj324->class->name);
  obj324->class->name = "sequence.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj324, self, 0);
  addmethodreal(obj324,"outer", &reader_collectionsPrelude_outer_325);
  Object oldself324 = self;
  struct StackFrameObject *oldstackframe324 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe324);
  gc_frame_newslot((Object)stackframe);
  self = obj324;
  Object *oldselfslot324 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter324 = (*(struct UserObject *)self).data[0], lowerouter324 = thisouter324;
  if (inheritingObject324) {
    struct UserObject *inho324 = (struct UserObject *)inheritingObject324;
    while (inho324->super != GraceDefaultObject) inho324 = (struct UserObject *)inho324->super;
    inho324->super = obj324;
    self = inheritingObject324;
    *selfslot = self;
    lowerouter324 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter324;
  }
if (objclass324 == NULL) {
  Method *reader326 = addmethodrealflags(obj324, "size",&reader_collectionsPrelude_size_326, MFLAG_DEF);
  reader326->definitionModule = modulename;
  reader326->definitionLine = 510;
}
adddatum2(obj324, alloc_Undefined(), 1);
if (objclass324 == NULL) {
  Method *reader327 = addmethodrealflags(obj324, "inner",&reader_collectionsPrelude_inner_327, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader327->definitionModule = modulename;
  reader327->definitionLine = 511;
}
adddatum2(obj324, alloc_Undefined(), 2);
// method "boundsCheck(_)"
  block_savedest(obj324);
  Object closure328 = createclosure(1, "boundsCheck(1)");
  setclosureframe(closure328, stackframe);
  addtoclosure(closure328, var_BoundsError);
  struct UserObject *uo328 = (struct UserObject*)obj324;
  uo328->data[3] = (Object)closure328;
  Method *meth_meth_collectionsPrelude_boundsCheck_40_1_41_328 = addmethod2pos(obj324, "boundsCheck(1)", &meth_collectionsPrelude_boundsCheck_40_1_41_328, 3);
  int argcv_meth_collectionsPrelude_boundsCheck_40_1_41_328[] = {1};
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_328->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_boundsCheck_40_1_41_328);
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_328->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_328->definitionModule = modulename;
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_328->definitionLine = 513;
// method "at(_)"
  struct UserObject *uo365 = (struct UserObject*)obj324;
  uo365->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40_1_41_365 = addmethod2pos(obj324, "at(1)", &meth_collectionsPrelude_at_40_1_41_365, 4);
  int argcv_meth_collectionsPrelude_at_40_1_41_365[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_365->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_365);
  meth_meth_collectionsPrelude_at_40_1_41_365->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_365->definitionLine = 520;
// method "keys"
  struct UserObject *uo376 = (struct UserObject*)obj324;
  uo376->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys376 = addmethod2pos(obj324, "keys", &meth_collectionsPrelude_keys376, 5);
  int argcv_meth_collectionsPrelude_keys376[] = {0};
  meth_meth_collectionsPrelude_keys376->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys376);
  meth_meth_collectionsPrelude_keys376->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys376->definitionLine = 524;
// method "values"
  struct UserObject *uo388 = (struct UserObject*)obj324;
  uo388->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values388 = addmethod2pos(obj324, "values", &meth_collectionsPrelude_values388, 6);
  int argcv_meth_collectionsPrelude_values388[] = {0};
  meth_meth_collectionsPrelude_values388->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values388);
  meth_meth_collectionsPrelude_values388->definitionModule = modulename;
  meth_meth_collectionsPrelude_values388->definitionLine = 527;
// method "keysAndValuesDo(_)"
  struct UserObject *uo389 = (struct UserObject*)obj324;
  uo389->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_389 = addmethod2pos(obj324, "keysAndValuesDo(1)", &meth_collectionsPrelude_keysAndValuesDo_40_1_41_389, 7);
  int argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_389[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_389->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_389);
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_389->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_389->definitionLine = 530;
// method "reversed"
  block_savedest(obj324);
  Object closure419 = createclosure(1, "reversed");
  setclosureframe(closure419, stackframe);
  addtoclosure(closure419, var__prelude);
  struct UserObject *uo419 = (struct UserObject*)obj324;
  uo419->data[8] = (Object)closure419;
  Method *meth_meth_collectionsPrelude_reversed419 = addmethod2pos(obj324, "reversed", &meth_collectionsPrelude_reversed419, 8);
  int argcv_meth_collectionsPrelude_reversed419[] = {0};
  meth_meth_collectionsPrelude_reversed419->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed419);
  meth_meth_collectionsPrelude_reversed419->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed419->definitionLine = 537;
// method "++(_)"
  struct UserObject *uo450 = (struct UserObject*)obj324;
  uo450->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_450 = addmethod2pos(obj324, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_450, 9);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_450[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_450->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_450);
  meth_meth_collectionsPrelude__43__43__40_1_41_450->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_450->definitionLine = 546;
// method "asString"
  struct UserObject *uo465 = (struct UserObject*)obj324;
  uo465->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString465 = addmethod2pos(obj324, "asString", &meth_collectionsPrelude_asString465, 10);
  int argcv_meth_collectionsPrelude_asString465[] = {0};
  meth_meth_collectionsPrelude_asString465->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString465);
  meth_meth_collectionsPrelude_asString465->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString465->definitionLine = 549;
// method "contains(_)"
  struct UserObject *uo511 = (struct UserObject*)obj324;
  uo511->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_511 = addmethod2pos(obj324, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_511, 11);
  int argcv_meth_collectionsPrelude_contains_40_1_41_511[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_511->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_511);
  meth_meth_collectionsPrelude_contains_40_1_41_511->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_511->definitionLine = 557;
// method "do(_)"
  struct UserObject *uo523 = (struct UserObject*)obj324;
  uo523->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_523 = addmethod2pos(obj324, "do(1)", &meth_collectionsPrelude_do_40_1_41_523, 12);
  int argcv_meth_collectionsPrelude_do_40_1_41_523[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_523->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_523);
  meth_meth_collectionsPrelude_do_40_1_41_523->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_523->definitionLine = 561;
// method "==(_)"
  struct UserObject *uo549 = (struct UserObject*)obj324;
  uo549->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_549 = addmethod2pos(obj324, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_549, 13);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_549[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_549->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_549);
  meth_meth_collectionsPrelude__61__61__40_1_41_549->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_549->definitionLine = 568;
// method "iterator"
  block_savedest(obj324);
  Object closure556 = createclosure(2, "iterator");
  setclosureframe(closure556, stackframe);
  addtoclosure(closure556, var_sz);
  addtoclosure(closure556, var_IteratorExhausted);
  struct UserObject *uo556 = (struct UserObject*)obj324;
  uo556->data[14] = (Object)closure556;
  Method *meth_meth_collectionsPrelude_iterator556 = addmethod2pos(obj324, "iterator", &meth_collectionsPrelude_iterator556, 14);
  int argcv_meth_collectionsPrelude_iterator556[] = {0};
  meth_meth_collectionsPrelude_iterator556->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator556);
  meth_meth_collectionsPrelude_iterator556->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator556->definitionLine = 571;
  block_savedest(obj324);
  Object closure631 = createclosure(2, "iterator$object(1)");
  setclosureframe(closure631, stackframe);
  addtoclosure(closure631, var_sz);
  addtoclosure(closure631, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_iterator556_object = addmethod2pos(obj324, "iterator$object(1)", &meth_collectionsPrelude_iterator556_object, 14);
  meth_meth_collectionsPrelude_iterator556_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator556_object->definitionLine = 571;
// method "sorted"
  struct UserObject *uo632 = (struct UserObject*)obj324;
  uo632->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted632 = addmethod2pos(obj324, "sorted", &meth_collectionsPrelude_sorted632, 15);
  int argcv_meth_collectionsPrelude_sorted632[] = {0};
  meth_meth_collectionsPrelude_sorted632->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted632);
  meth_meth_collectionsPrelude_sorted632->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted632->definitionLine = 585;
// method "sortedBy(_)"
  struct UserObject *uo655 = (struct UserObject*)obj324;
  uo655->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy_40_1_41_655 = addmethod2pos(obj324, "sortedBy(1)", &meth_collectionsPrelude_sortedBy_40_1_41_655, 16);
  int argcv_meth_collectionsPrelude_sortedBy_40_1_41_655[] = {1};
  meth_meth_collectionsPrelude_sortedBy_40_1_41_655->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy_40_1_41_655);
  meth_meth_collectionsPrelude_sortedBy_40_1_41_655->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy_40_1_41_655->definitionLine = 592;
  sourceObject = obj324;
// Begin line 509
  setline(509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe662 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call663 = callmethodflags(*var_indexable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe662);
// compiled call node returning call663 (depth = 2)
  struct UserObject *obj324_uo = (struct UserObject *)obj324;
  obj324_uo->super = call663;
  sourceObject = obj324;
// Begin line 510
  setline(510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_sz (depth = 2)
  adddatum2(obj324, *var_sz, 1);
  sourceObject = obj324;
// Begin line 511
  setline(511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_pArray (depth = 2)
  adddatum2(obj324, *var_pArray, 2);
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  sourceObject = obj324;
  objclass324 = obj324->class;
  objclass324->definitionModule = modulename;
  objclass324->definitionLine = 508;
  (*(struct UserObject *)self).data[0] = lowerouter324;
  self = oldself324;
  selfslot = oldselfslot324;
  stackframe = oldstackframe324;
  gc_frame_end(frame);
  return obj324;
}
Object meth_collectionsPrelude_sequence235(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "sequence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  Object *var__prelude = getfromclosure(closure, 1);
  Object *var_BoundsError = getfromclosure(closure, 2);
  Object *var_IteratorExhausted = getfromclosure(closure, 3);
  Object *var_indexable = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject236 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj236 = alloc_userobj2(5,6, objclass236);
  gc_frame_newslot(obj236);
if (objclass236 == NULL) {
  glfree(obj236->class->name);
  obj236->class->name = "sequence";
}
// OBJECT OUTER DEC outer
  adddatum2(obj236, self, 0);
  addmethodreal(obj236,"outer", &reader_collectionsPrelude_outer_237);
  Object oldself236 = self;
  struct StackFrameObject *oldstackframe236 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe236);
  gc_frame_newslot((Object)stackframe);
  self = obj236;
  Object *oldselfslot236 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter236 = (*(struct UserObject *)self).data[0], lowerouter236 = thisouter236;
  if (inheritingObject236) {
    struct UserObject *inho236 = (struct UserObject *)inheritingObject236;
    while (inho236->super != GraceDefaultObject) inho236 = (struct UserObject *)inho236->super;
    inho236->super = obj236;
    self = inheritingObject236;
    *selfslot = self;
    lowerouter236 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter236;
  }
// method "asString"
  struct UserObject *uo238 = (struct UserObject*)obj236;
  uo238->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString238 = addmethod2pos(obj236, "asString", &meth_collectionsPrelude_asString238, 1);
  int argcv_meth_collectionsPrelude_asString238[] = {0};
  meth_meth_collectionsPrelude_asString238->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString238);
  meth_meth_collectionsPrelude_asString238->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString238->definitionLine = 464;
// method "empty"
  block_savedest(obj236);
  Object closure240 = createclosure(1, "empty");
  setclosureframe(closure240, stackframe);
  addtoclosure(closure240, var_emptySequence);
  struct UserObject *uo240 = (struct UserObject*)obj236;
  uo240->data[2] = (Object)closure240;
  Method *meth_meth_collectionsPrelude_empty240 = addmethod2pos(obj236, "empty", &meth_collectionsPrelude_empty240, 2);
  int argcv_meth_collectionsPrelude_empty240[] = {0};
  meth_meth_collectionsPrelude_empty240->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_empty240);
  meth_meth_collectionsPrelude_empty240->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty240->definitionLine = 466;
// method "withAll(_)"
  block_savedest(obj236);
  Object closure241 = createclosure(2, "withAll(1)");
  setclosureframe(closure241, stackframe);
  addtoclosure(closure241, var__prelude);
  addtoclosure(closure241, var_emptySequence);
  struct UserObject *uo241 = (struct UserObject*)obj236;
  uo241->data[3] = (Object)closure241;
  Method *meth_meth_collectionsPrelude_withAll_40_1_41_241 = addmethod2pos(obj236, "withAll(1)", &meth_collectionsPrelude_withAll_40_1_41_241, 3);
  int argcv_meth_collectionsPrelude_withAll_40_1_41_241[] = {1};
  meth_meth_collectionsPrelude_withAll_40_1_41_241->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll_40_1_41_241);
  meth_meth_collectionsPrelude_withAll_40_1_41_241->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll_40_1_41_241->definitionLine = 471;
// method "fromprimitiveArray(_,_)"
  block_savedest(obj236);
  Object closure323 = createclosure(4, "fromprimitiveArray(2)");
  setclosureframe(closure323, stackframe);
  addtoclosure(closure323, var_BoundsError);
  addtoclosure(closure323, var__prelude);
  addtoclosure(closure323, var_IteratorExhausted);
  addtoclosure(closure323, var_indexable);
  struct UserObject *uo323 = (struct UserObject*)obj236;
  uo323->data[4] = (Object)closure323;
  Method *meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323 = addmethod2pos(obj236, "fromprimitiveArray(2)", &meth_collectionsPrelude_fromprimitiveArray_40_2_41_323, 4);
  int argcv_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323[] = {2};
  meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323);
  meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323->definitionModule = modulename;
  meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323->definitionLine = 505;
  block_savedest(obj236);
  Object closure664 = createclosure(4, "fromprimitiveArray(2)$object(1)");
  setclosureframe(closure664, stackframe);
  addtoclosure(closure664, var_BoundsError);
  addtoclosure(closure664, var__prelude);
  addtoclosure(closure664, var_IteratorExhausted);
  addtoclosure(closure664, var_indexable);
  Method *meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323_object = addmethod2pos(obj236, "fromprimitiveArray(2)$object(1)", &meth_collectionsPrelude_fromprimitiveArray_40_2_41_323_object, 4);
  meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323_object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323_object->definitionLine = 505;
  sourceObject = obj236;
  sourceObject = obj236;
  sourceObject = obj236;
  sourceObject = obj236;
  objclass236 = obj236->class;
  objclass236->definitionModule = modulename;
  objclass236->definitionLine = 462;
  (*(struct UserObject *)self).data[0] = lowerouter236;
  self = oldself236;
  selfslot = oldselfslot236;
  stackframe = oldstackframe236;
  gc_frame_end(frame);
  return obj236;
}
Object meth_collectionsPrelude_sequence235_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "sequence$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  Object *var__prelude = getfromclosure(closure, 1);
  Object *var_BoundsError = getfromclosure(closure, 2);
  Object *var_IteratorExhausted = getfromclosure(closure, 3);
  Object *var_indexable = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject236 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj236 = alloc_userobj2(5,6, objclass236);
  gc_frame_newslot(obj236);
if (objclass236 == NULL) {
  glfree(obj236->class->name);
  obj236->class->name = "sequence";
}
// OBJECT OUTER DEC outer
  adddatum2(obj236, self, 0);
  addmethodreal(obj236,"outer", &reader_collectionsPrelude_outer_237);
  Object oldself236 = self;
  struct StackFrameObject *oldstackframe236 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe236);
  gc_frame_newslot((Object)stackframe);
  self = obj236;
  Object *oldselfslot236 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter236 = (*(struct UserObject *)self).data[0], lowerouter236 = thisouter236;
  if (inheritingObject236) {
    struct UserObject *inho236 = (struct UserObject *)inheritingObject236;
    while (inho236->super != GraceDefaultObject) inho236 = (struct UserObject *)inho236->super;
    inho236->super = obj236;
    self = inheritingObject236;
    *selfslot = self;
    lowerouter236 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter236;
  }
// method "asString"
  struct UserObject *uo238 = (struct UserObject*)obj236;
  uo238->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString238 = addmethod2pos(obj236, "asString", &meth_collectionsPrelude_asString238, 1);
  int argcv_meth_collectionsPrelude_asString238[] = {0};
  meth_meth_collectionsPrelude_asString238->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString238);
  meth_meth_collectionsPrelude_asString238->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString238->definitionLine = 464;
// method "empty"
  block_savedest(obj236);
  Object closure240 = createclosure(1, "empty");
  setclosureframe(closure240, stackframe);
  addtoclosure(closure240, var_emptySequence);
  struct UserObject *uo240 = (struct UserObject*)obj236;
  uo240->data[2] = (Object)closure240;
  Method *meth_meth_collectionsPrelude_empty240 = addmethod2pos(obj236, "empty", &meth_collectionsPrelude_empty240, 2);
  int argcv_meth_collectionsPrelude_empty240[] = {0};
  meth_meth_collectionsPrelude_empty240->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_empty240);
  meth_meth_collectionsPrelude_empty240->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty240->definitionLine = 466;
// method "withAll(_)"
  block_savedest(obj236);
  Object closure241 = createclosure(2, "withAll(1)");
  setclosureframe(closure241, stackframe);
  addtoclosure(closure241, var__prelude);
  addtoclosure(closure241, var_emptySequence);
  struct UserObject *uo241 = (struct UserObject*)obj236;
  uo241->data[3] = (Object)closure241;
  Method *meth_meth_collectionsPrelude_withAll_40_1_41_241 = addmethod2pos(obj236, "withAll(1)", &meth_collectionsPrelude_withAll_40_1_41_241, 3);
  int argcv_meth_collectionsPrelude_withAll_40_1_41_241[] = {1};
  meth_meth_collectionsPrelude_withAll_40_1_41_241->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll_40_1_41_241);
  meth_meth_collectionsPrelude_withAll_40_1_41_241->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll_40_1_41_241->definitionLine = 471;
// method "fromprimitiveArray(_,_)"
  block_savedest(obj236);
  Object closure323 = createclosure(4, "fromprimitiveArray(2)");
  setclosureframe(closure323, stackframe);
  addtoclosure(closure323, var_BoundsError);
  addtoclosure(closure323, var__prelude);
  addtoclosure(closure323, var_IteratorExhausted);
  addtoclosure(closure323, var_indexable);
  struct UserObject *uo323 = (struct UserObject*)obj236;
  uo323->data[4] = (Object)closure323;
  Method *meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323 = addmethod2pos(obj236, "fromprimitiveArray(2)", &meth_collectionsPrelude_fromprimitiveArray_40_2_41_323, 4);
  int argcv_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323[] = {2};
  meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323);
  meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323->definitionModule = modulename;
  meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323->definitionLine = 505;
  block_savedest(obj236);
  Object closure664 = createclosure(4, "fromprimitiveArray(2)$object(1)");
  setclosureframe(closure664, stackframe);
  addtoclosure(closure664, var_BoundsError);
  addtoclosure(closure664, var__prelude);
  addtoclosure(closure664, var_IteratorExhausted);
  addtoclosure(closure664, var_indexable);
  Method *meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323_object = addmethod2pos(obj236, "fromprimitiveArray(2)$object(1)", &meth_collectionsPrelude_fromprimitiveArray_40_2_41_323_object, 4);
  meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323_object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_fromprimitiveArray_40_2_41_323_object->definitionLine = 505;
  sourceObject = obj236;
  sourceObject = obj236;
  sourceObject = obj236;
  sourceObject = obj236;
  objclass236 = obj236->class;
  objclass236->definitionModule = modulename;
  objclass236->definitionLine = 462;
  (*(struct UserObject *)self).data[0] = lowerouter236;
  self = oldself236;
  selfslot = oldselfslot236;
  stackframe = oldstackframe236;
  gc_frame_end(frame);
  return obj236;
}
Object meth_collectionsPrelude__apply676(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_rightIter = getfromclosure(closure, 0);
  Object *var_leftIter = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe678 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_rightIter (depth = 7)
  Object call679 = callmethodflags(*var_rightIter, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe678);
// compiled member node returning call679 (depth = 6)
  int op_slot_right_677 = gc_frame_newslot(call679);
// starting to compile member node (depth = 6)
  int callframe681 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_leftIter (depth = 7)
  Object call682 = callmethodflags(*var_leftIter, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe681);
// compiled member node returning call682 (depth = 6)
  int op_slot_left_677 = gc_frame_newslot(call682);
  params[0] = call679;
  partcv[0] = 1;
  Object opresult683 = callmethod(call682, "&&(1)", 1, partcv, params);
// compiled op node returning opresult683 (depth = 5)
  gc_frame_end(frame);
  return opresult683;
}
Object meth_collectionsPrelude__apply686(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_rightIter = getfromclosure(closure, 0);
  Object *var_leftIter = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 608
  setline(608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe689 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_rightIter (depth = 8)
  Object call690 = callmethodflags(*var_rightIter, "next", 0, partcv, params, 0);
  gc_frame_end(callframe689);
// compiled member node returning call690 (depth = 7)
  int op_slot_right_688 = gc_frame_newslot(call690);
// starting to compile member node (depth = 7)
  int callframe692 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_leftIter (depth = 8)
  Object call693 = callmethodflags(*var_leftIter, "next", 0, partcv, params, 0);
  gc_frame_end(callframe692);
// compiled member node returning call693 (depth = 7)
  int op_slot_left_688 = gc_frame_newslot(call693);
  params[0] = call690;
  partcv[0] = 1;
  Object opresult694 = callmethod(call693, "≠(1)", 1, partcv, params);
// compiled op node returning opresult694 (depth = 6)
  Object if687 = done;
  if (istrue(opresult694)) {
// Begin line 609
  setline(609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool695 = alloc_Boolean(0);
// compiled identifier node returning bool695 (depth = 7)
  block_return(realself, bool695);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if687 = undefined;
  } else {
  }
// compiled if node returning if687 (depth = 5)
  gc_frame_end(frame);
  return if687;
}
Object meth_collectionsPrelude_isEqual_40_1_41_toIterable_40_1_41_666(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "isEqual(1)toIterable(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method isEqual(_)toIterable(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method isEqual(_)toIterable(_)");
  Object params[2];
  int partcv[2];
  Object *var_MinimalyIterable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for isEqual(_)toIterable(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_left = &(stackframe->slots[0]);
  *var_left = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part isEqual(_)");
  Object *var_right = &(stackframe->slots[1]);
  *var_right = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part toIterable(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_leftIter = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "leftIter");
  Object *var_rightIter = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "rightIter");
// Begin line 604
  setline(604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe668 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_right (depth = 4)
  gc_frame_newslot(*var_right);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_MinimalyIterable (depth = 4)
  params[0] = *var_right;
  partcv[0] = 1;
  Object call669 = callmethodflags(*var_MinimalyIterable, "match(1)", 1, partcv, params, 0);
  gc_frame_end(callframe668);
// compiled call node returning call669 (depth = 3)
  Object if667 = done;
  if (istrue(call669)) {
// Begin line 605
  setline(605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe670 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_left (depth = 5)
  Object call671 = callmethodflags(*var_left, "iterator", 0, partcv, params, 0);
  gc_frame_end(callframe670);
// compiled member node returning call671 (depth = 4)
  *var_leftIter = call671;
  if (call671 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 606
  setline(606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe672 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_right (depth = 5)
  Object call673 = callmethodflags(*var_right, "iterator", 0, partcv, params, 0);
  gc_frame_end(callframe672);
// compiled member node returning call673 (depth = 4)
  *var_rightIter = call673;
  if (call673 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 607
  setline(607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe674 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block675 = alloc_Block(NULL, NULL, "collectionsPrelude", 607);
  gc_frame_newslot(block675);
// method "_apply"
  block_savedest(block675);
  Object closure676 = createclosure(3, "_apply");
  setclosureframe(closure676, stackframe);
  addtoclosure(closure676, var_rightIter);
  addtoclosure(closure676, var_leftIter);
  addtoclosure(closure676, selfslot);
  struct UserObject *uo676 = (struct UserObject*)block675;
  uo676->data[0] = (Object)closure676;
  Method *meth_meth_collectionsPrelude__apply676 = addmethod2pos(block675, "_apply", &meth_collectionsPrelude__apply676, 0);
  int argcv_meth_collectionsPrelude__apply676[] = {0};
  meth_meth_collectionsPrelude__apply676->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply676);
  meth_meth_collectionsPrelude__apply676->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply676->definitionLine = 1963;
// compiled block node returning block675 (depth = 4)
  gc_frame_newslot(block675);
// starting to compile block node (depth = 4)
  Object block685 = alloc_Block(NULL, NULL, "collectionsPrelude", 607);
  gc_frame_newslot(block685);
// method "_apply"
  block_savedest(block685);
  Object closure686 = createclosure(3, "_apply");
  setclosureframe(closure686, stackframe);
  addtoclosure(closure686, var_rightIter);
  addtoclosure(closure686, var_leftIter);
  addtoclosure(closure686, selfslot);
  struct UserObject *uo686 = (struct UserObject*)block685;
  uo686->data[0] = (Object)closure686;
  Method *meth_meth_collectionsPrelude__apply686 = addmethod2pos(block685, "_apply", &meth_collectionsPrelude__apply686, 0);
  int argcv_meth_collectionsPrelude__apply686[] = {0};
  meth_meth_collectionsPrelude__apply686->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply686);
  meth_meth_collectionsPrelude__apply686->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply686->definitionLine = 1963;
// compiled block node returning block685 (depth = 4)
  gc_frame_newslot(block685);
// call case 5: prelude request
  params[0] = block675;
  params[1] = block685;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call697 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe674);
// compiled call node returning call697 (depth = 3)
// Begin line 612
  setline(612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe699 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_rightIter (depth = 5)
  Object call700 = callmethodflags(*var_rightIter, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe699);
// compiled member node returning call700 (depth = 4)
  int op_slot_right_698 = gc_frame_newslot(call700);
// starting to compile member node (depth = 4)
  int callframe702 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_leftIter (depth = 5)
  Object call703 = callmethodflags(*var_leftIter, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe702);
// compiled member node returning call703 (depth = 4)
  int op_slot_left_698 = gc_frame_newslot(call703);
  params[0] = call700;
  partcv[0] = 1;
  Object opresult704 = callmethod(call703, "==(1)", 1, partcv, params);
// compiled op node returning opresult704 (depth = 3)
    gc_frame_newslot(opresult704);
    if667 = opresult704;
  } else {
// Begin line 614
  setline(614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool705 = alloc_Boolean(0);
// compiled identifier node returning bool705 (depth = 3)
    gc_frame_newslot(bool705);
    if667 = bool705;
  }
// compiled if node returning if667 (depth = 2)
  gc_frame_end(frame);
  return if667;
}
Object meth_collectionsPrelude_asString709(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 620
  setline(620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit710 == NULL) {
    strlit710 = alloc_String("a list factory");
    gc_root(strlit710);
  }
// compiled string node returning strlit710 (depth = 2)
  gc_frame_end(frame);
  return strlit710;
}
Object meth_collectionsPrelude_empty711(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "empty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 623
  setline(623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe712 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptySequence (depth = 3)
  gc_frame_newslot(*var_emptySequence);
// call case 4: self request
  params[0] = *var_emptySequence;
  partcv[0] = 1;
  Object call713 = callmethodflags(self, "withAll(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe712);
// compiled call node returning call713 (depth = 2)
  gc_frame_end(frame);
  return call713;
}
Object meth_collectionsPrelude_size728(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 640
  setline(640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
// Begin line 641
  setline(641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe729 = gc_frame_new();
// call case 4: self request
  Object call730 = callmethodflags(self, "sz", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe729);
// compiled member node returning call730 (depth = 6)
  gc_frame_end(frame);
  return call730;
}
Object meth_collectionsPrelude_at_40_1_41_731(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 645
  setline(645);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_at_40_1_41_put_40_1_41_732(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at(1)put(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)put(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)put(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for at(_)put(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *var_x = &(stackframe->slots[1]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part put(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 655
  setline(655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe733 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num735 = alloc_Float64(1);
// compiled num node returning num735 (depth = 8)
  int op_slot_right_734 = gc_frame_newslot(num735);
// starting to compile member node (depth = 8)
  int callframe737 = gc_frame_new();
// call case 4: self request
  Object call738 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe737);
// compiled member node returning call738 (depth = 8)
  int op_slot_left_734 = gc_frame_newslot(call738);
  params[0] = num735;
  partcv[0] = 1;
  Object sum739 = callmethod(call738, "+(1)", 1, partcv, params);
// compiled op node returning sum739 (depth = 7)
  gc_frame_newslot(sum739);
// call case 4: self request
  params[0] = sum739;
  partcv[0] = 1;
  Object call740 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe733);
// compiled call node returning call740 (depth = 6)
// Begin line 656
  setline(656);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_add_40_1_41_741(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "add(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method add(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for add(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part add(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 667
  setline(667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe742 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num744 = alloc_Float64(1);
// compiled num node returning num744 (depth = 8)
  int op_slot_right_743 = gc_frame_newslot(num744);
// starting to compile member node (depth = 8)
  int callframe746 = gc_frame_new();
// call case 4: self request
  Object call747 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe746);
// compiled member node returning call747 (depth = 8)
  int op_slot_left_743 = gc_frame_newslot(call747);
  params[0] = num744;
  partcv[0] = 1;
  Object sum748 = callmethod(call747, "+(1)", 1, partcv, params);
// compiled op node returning sum748 (depth = 7)
  gc_frame_newslot(sum748);
// call case 4: self request
  params[0] = sum748;
  partcv[0] = 1;
  Object call749 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe742);
// compiled call node returning call749 (depth = 6)
// Begin line 668
  setline(668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_push_40_1_41_750(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "push(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method push(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for push(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part push(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 673
  setline(673);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe751 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num753 = alloc_Float64(1);
// compiled num node returning num753 (depth = 8)
  int op_slot_right_752 = gc_frame_newslot(num753);
// starting to compile member node (depth = 8)
  int callframe755 = gc_frame_new();
// call case 4: self request
  Object call756 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe755);
// compiled member node returning call756 (depth = 8)
  int op_slot_left_752 = gc_frame_newslot(call756);
  params[0] = num753;
  partcv[0] = 1;
  Object sum757 = callmethod(call756, "+(1)", 1, partcv, params);
// compiled op node returning sum757 (depth = 7)
  gc_frame_newslot(sum757);
// call case 4: self request
  params[0] = sum757;
  partcv[0] = 1;
  Object call758 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe751);
// compiled call node returning call758 (depth = 6)
// Begin line 674
  setline(674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_removeLast759(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeLast");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 679
  setline(679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe760 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num762 = alloc_Float64(1);
// compiled num node returning num762 (depth = 8)
  int op_slot_right_761 = gc_frame_newslot(num762);
// starting to compile member node (depth = 8)
  int callframe764 = gc_frame_new();
// call case 4: self request
  Object call765 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe764);
// compiled member node returning call765 (depth = 8)
  int op_slot_left_761 = gc_frame_newslot(call765);
  params[0] = num762;
  partcv[0] = 1;
  Object sum766 = callmethod(call765, "+(1)", 1, partcv, params);
// compiled op node returning sum766 (depth = 7)
  gc_frame_newslot(sum766);
// call case 4: self request
  params[0] = sum766;
  partcv[0] = 1;
  Object call767 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe760);
// compiled call node returning call767 (depth = 6)
// Begin line 680
  setline(680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply781(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ix = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num783 = alloc_Float64(0);
// compiled num node returning num783 (depth = 9)
  int op_slot_right_782 = gc_frame_newslot(num783);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  int op_slot_left_782 = gc_frame_newslot(*var_ix);
  params[0] = num783;
  partcv[0] = 1;
  Object opresult785 = callmethod(*var_ix, ">(1)", 1, partcv, params);
// compiled op node returning opresult785 (depth = 8)
  gc_frame_end(frame);
  return opresult785;
}
Object meth_collectionsPrelude__apply788(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_l = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_each = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "each");
// Begin line 692
  setline(692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe789 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ix (depth = 10)
  gc_frame_newslot(*var_ix);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_l (depth = 10)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call790 = callmethodflags(*var_l, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe789);
// compiled call node returning call790 (depth = 9)
  *var_each = call790;
  if (call790 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num792 = alloc_Float64(1);
// compiled num node returning num792 (depth = 10)
  int op_slot_right_791 = gc_frame_newslot(num792);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ix (depth = 10)
  int op_slot_left_791 = gc_frame_newslot(*var_ix);
  params[0] = num792;
  partcv[0] = 1;
  Object diff794 = callmethod(*var_ix, "-(1)", 1, partcv, params);
// compiled op node returning diff794 (depth = 9)
  *var_ix = diff794;
  if (diff794 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 694
  setline(694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
// compiled call node returning done (depth = 8)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_addAllFirst_40_1_41_768(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addAllFirst(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addAllFirst(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addAllFirst(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addAllFirst(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
// Begin line 689
  setline(689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe769 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num771 = alloc_Float64(1);
// compiled num node returning num771 (depth = 8)
  int op_slot_right_770 = gc_frame_newslot(num771);
// starting to compile member node (depth = 8)
  int callframe773 = gc_frame_new();
// call case 4: self request
  Object call774 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe773);
// compiled member node returning call774 (depth = 8)
  int op_slot_left_770 = gc_frame_newslot(call774);
  params[0] = num771;
  partcv[0] = 1;
  Object sum775 = callmethod(call774, "+(1)", 1, partcv, params);
// compiled op node returning sum775 (depth = 7)
  gc_frame_newslot(sum775);
// call case 4: self request
  params[0] = sum775;
  partcv[0] = 1;
  Object call776 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe769);
// compiled call node returning call776 (depth = 6)
// Begin line 690
  setline(690);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe777 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_l (depth = 8)
  Object call778 = callmethodflags(*var_l, "size", 0, partcv, params, 0);
  gc_frame_end(callframe777);
// compiled member node returning call778 (depth = 7)
  *var_ix = call778;
  if (call778 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 691
  setline(691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe779 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block780 = alloc_Block(NULL, NULL, "collectionsPrelude", 691);
  gc_frame_newslot(block780);
// method "_apply"
  block_savedest(block780);
  Object closure781 = createclosure(2, "_apply");
  setclosureframe(closure781, stackframe);
  addtoclosure(closure781, var_ix);
  addtoclosure(closure781, selfslot);
  struct UserObject *uo781 = (struct UserObject*)block780;
  uo781->data[0] = (Object)closure781;
  Method *meth_meth_collectionsPrelude__apply781 = addmethod2pos(block780, "_apply", &meth_collectionsPrelude__apply781, 0);
  int argcv_meth_collectionsPrelude__apply781[] = {0};
  meth_meth_collectionsPrelude__apply781->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply781);
  meth_meth_collectionsPrelude__apply781->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply781->definitionLine = 1963;
// compiled block node returning block780 (depth = 7)
  gc_frame_newslot(block780);
// starting to compile block node (depth = 7)
  Object block787 = alloc_Block(NULL, NULL, "collectionsPrelude", 691);
  gc_frame_newslot(block787);
// method "_apply"
  block_savedest(block787);
  Object closure788 = createclosure(3, "_apply");
  setclosureframe(closure788, stackframe);
  addtoclosure(closure788, var_ix);
  addtoclosure(closure788, var_l);
  addtoclosure(closure788, selfslot);
  struct UserObject *uo788 = (struct UserObject*)block787;
  uo788->data[0] = (Object)closure788;
  Method *meth_meth_collectionsPrelude__apply788 = addmethod2pos(block787, "_apply", &meth_collectionsPrelude__apply788, 0);
  int argcv_meth_collectionsPrelude__apply788[] = {0};
  meth_meth_collectionsPrelude__apply788->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply788);
  meth_meth_collectionsPrelude__apply788->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply788->definitionLine = 1963;
// compiled block node returning block787 (depth = 7)
  gc_frame_newslot(block787);
// call case 5: prelude request
  params[0] = block780;
  params[1] = block787;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call797 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe779);
// compiled call node returning call797 (depth = 6)
// Begin line 696
  setline(696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_removeAt_40_1_41_798(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeAt(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAt(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeAt(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeAt(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_removed = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "removed");
// Begin line 700
  setline(700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe799 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num801 = alloc_Float64(1);
// compiled num node returning num801 (depth = 8)
  int op_slot_right_800 = gc_frame_newslot(num801);
// starting to compile member node (depth = 8)
  int callframe803 = gc_frame_new();
// call case 4: self request
  Object call804 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe803);
// compiled member node returning call804 (depth = 8)
  int op_slot_left_800 = gc_frame_newslot(call804);
  params[0] = num801;
  partcv[0] = 1;
  Object sum805 = callmethod(call804, "+(1)", 1, partcv, params);
// compiled op node returning sum805 (depth = 7)
  gc_frame_newslot(sum805);
// call case 4: self request
  params[0] = sum805;
  partcv[0] = 1;
  Object call806 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe799);
// compiled call node returning call806 (depth = 6)
// Begin line 701
  setline(701);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe807 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call808 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe807);
// compiled call node returning call808 (depth = 7)
  *var_removed = call808;
  if (call808 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 702
  setline(702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
// Begin line 703
  setline(703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  return *var_removed;
// compiled return node returning undefined (depth = 6)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_sortBy_40_1_41_809(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortBy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortBy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sortBy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 707
  setline(707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe810 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num812 = alloc_Float64(1);
// compiled num node returning num812 (depth = 8)
  int op_slot_right_811 = gc_frame_newslot(num812);
// starting to compile member node (depth = 8)
  int callframe814 = gc_frame_new();
// call case 4: self request
  Object call815 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe814);
// compiled member node returning call815 (depth = 8)
  int op_slot_left_811 = gc_frame_newslot(call815);
  params[0] = num812;
  partcv[0] = 1;
  Object sum816 = callmethod(call815, "+(1)", 1, partcv, params);
// compiled op node returning sum816 (depth = 7)
  gc_frame_newslot(sum816);
// call case 4: self request
  params[0] = sum816;
  partcv[0] = 1;
  Object call817 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe810);
// compiled call node returning call817 (depth = 6)
// Begin line 708
  setline(708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
// Begin line 715
  setline(715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_addLast_40_1_41_818(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addLast(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addLast(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addLast(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addLast(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 720
  setline(720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe819 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_x (depth = 7)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call820 = callmethodflags(self, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe819);
// compiled call node returning call820 (depth = 6)
  gc_frame_end(frame);
  return call820;
}
Object meth_collectionsPrelude__apply_40_1_41_824(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe825 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  gc_frame_newslot(*var_each);
// call case 4: self request
  params[0] = *var_each;
  partcv[0] = 1;
  Object call826 = callmethodflags(self, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe825);
// compiled call node returning call826 (depth = 8)
  gc_frame_end(frame);
  return call826;
}
Object meth_collectionsPrelude_addAll_40_1_41_821(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addAll(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addAll(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 722
  setline(722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe822 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_l (depth = 7)
  gc_frame_newslot(*var_l);
// starting to compile block node (depth = 7)
  Object block823 = alloc_Block(NULL, NULL, "collectionsPrelude", 722);
  gc_frame_newslot(block823);
// method "_apply(_)"
  block_savedest(block823);
  Object closure824 = createclosure(1, "_apply(1)");
  setclosureframe(closure824, stackframe);
  addtoclosure(closure824, selfslot);
  struct UserObject *uo824 = (struct UserObject*)block823;
  uo824->data[0] = (Object)closure824;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_824 = addmethod2pos(block823, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_824, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_824[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_824->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_824);
  meth_meth_collectionsPrelude__apply_40_1_41_824->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_824->definitionLine = 1963;
// compiled block node returning block823 (depth = 7)
  gc_frame_newslot(block823);
// call case 5: prelude request
  params[0] = *var_l;
  params[1] = block823;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call828 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe822);
// compiled call node returning call828 (depth = 6)
// Begin line 723
  setline(723);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_addFirst_40_1_41_829(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addFirst(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addFirst(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addFirst(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elem = &(stackframe->slots[0]);
  *var_elem = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addFirst(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 727
  setline(727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe830 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num832 = alloc_Float64(1);
// compiled num node returning num832 (depth = 8)
  int op_slot_right_831 = gc_frame_newslot(num832);
// starting to compile member node (depth = 8)
  int callframe834 = gc_frame_new();
// call case 4: self request
  Object call835 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe834);
// compiled member node returning call835 (depth = 8)
  int op_slot_left_831 = gc_frame_newslot(call835);
  params[0] = num832;
  partcv[0] = 1;
  Object sum836 = callmethod(call835, "+(1)", 1, partcv, params);
// compiled op node returning sum836 (depth = 7)
  gc_frame_newslot(sum836);
// call case 4: self request
  params[0] = sum836;
  partcv[0] = 1;
  Object call837 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe830);
// compiled call node returning call837 (depth = 6)
// Begin line 728
  setline(728);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
// Begin line 729
  setline(729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_removeFirst838(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeFirst");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 733
  setline(733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe839 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num840 = alloc_Float64(1);
// compiled num node returning num840 (depth = 7)
  gc_frame_newslot(num840);
// call case 4: self request
  params[0] = num840;
  partcv[0] = 1;
  Object call841 = callmethodflags(self, "removeAt(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe839);
// compiled call node returning call841 (depth = 6)
  gc_frame_end(frame);
  return call841;
}
Object meth_collectionsPrelude__apply845(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_elt = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 739
  setline(739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe846 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit848 == NULL) {
    strlit848 = alloc_String("");
    gc_root(strlit848);
  }
// compiled string node returning strlit848 (depth = 11)
  int op_slot_right_847 = gc_frame_newslot(strlit848);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_elt (depth = 12)
  int op_slot_right_850 = gc_frame_newslot(*var_elt);
// starting to compile string node (depth = 12)
  if (strlit852 == NULL) {
    strlit852 = alloc_String("list does not contain object ");
    gc_root(strlit852);
  }
// compiled string node returning strlit852 (depth = 12)
  int op_slot_left_850 = gc_frame_newslot(strlit852);
  params[0] = *var_elt;
  partcv[0] = 1;
  Object opresult853 = callmethod(strlit852, "++(1)", 1, partcv, params);
// compiled op node returning opresult853 (depth = 11)
  int op_slot_left_847 = gc_frame_newslot(opresult853);
  params[0] = strlit848;
  partcv[0] = 1;
  Object opresult854 = callmethod(opresult853, "++(1)", 1, partcv, params);
// compiled op node returning opresult854 (depth = 10)
  gc_frame_newslot(opresult854);
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_NoSuchObject (depth = 10)
  params[0] = opresult854;
  partcv[0] = 1;
  Object call855 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe846);
// compiled call node returning call855 (depth = 9)
  gc_frame_end(frame);
  return call855;
}
Object meth_collectionsPrelude_remove_40_1_41_842(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "remove(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove(_)");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for remove(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part remove(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
// Begin line 738
  setline(738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe843 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_elt (depth = 8)
  gc_frame_newslot(*var_elt);
// starting to compile block node (depth = 8)
  Object block844 = alloc_Block(NULL, NULL, "collectionsPrelude", 738);
  gc_frame_newslot(block844);
// method "_apply"
  block_savedest(block844);
  Object closure845 = createclosure(3, "_apply");
  setclosureframe(closure845, stackframe);
  addtoclosure(closure845, var_elt);
  addtoclosure(closure845, var_NoSuchObject);
  addtoclosure(closure845, selfslot);
  struct UserObject *uo845 = (struct UserObject*)block844;
  uo845->data[0] = (Object)closure845;
  Method *meth_meth_collectionsPrelude__apply845 = addmethod2pos(block844, "_apply", &meth_collectionsPrelude__apply845, 0);
  int argcv_meth_collectionsPrelude__apply845[] = {0};
  meth_meth_collectionsPrelude__apply845->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply845);
  meth_meth_collectionsPrelude__apply845->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply845->definitionLine = 1963;
// compiled block node returning block844 (depth = 8)
  gc_frame_newslot(block844);
// call case 4: self request
  params[0] = *var_elt;
  params[1] = block844;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call857 = callmethodflags(self, "indexOf(1)ifAbsent(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe843);
// compiled call node returning call857 (depth = 7)
  *var_ix = call857;
  if (call857 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 741
  setline(741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe858 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  gc_frame_newslot(*var_ix);
// call case 4: self request
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call859 = callmethodflags(self, "removeAt(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe858);
// compiled call node returning call859 (depth = 6)
// Begin line 742
  setline(742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply863(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 748
  setline(748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe864 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_action (depth = 11)
  Object call865 = callmethodflags(*var_action, "apply", 0, partcv, params, 0);
  gc_frame_end(callframe864);
// compiled member node returning call865 (depth = 10)
  block_return(realself, call865);
// compiled return node returning undefined (depth = 9)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_860(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "remove(1)ifAbsent(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove(_)ifAbsent(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove(_)ifAbsent(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for remove(_)ifAbsent(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part remove(_)");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifAbsent(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ix = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "ix");
// Begin line 747
  setline(747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe861 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_elt (depth = 8)
  gc_frame_newslot(*var_elt);
// starting to compile block node (depth = 8)
  Object block862 = alloc_Block(NULL, NULL, "collectionsPrelude", 747);
  gc_frame_newslot(block862);
// method "_apply"
  block_savedest(block862);
  Object closure863 = createclosure(2, "_apply");
  setclosureframe(closure863, stackframe);
  addtoclosure(closure863, var_action);
  addtoclosure(closure863, selfslot);
  struct UserObject *uo863 = (struct UserObject*)block862;
  uo863->data[0] = (Object)closure863;
  Method *meth_meth_collectionsPrelude__apply863 = addmethod2pos(block862, "_apply", &meth_collectionsPrelude__apply863, 0);
  int argcv_meth_collectionsPrelude__apply863[] = {0};
  meth_meth_collectionsPrelude__apply863->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply863);
  meth_meth_collectionsPrelude__apply863->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply863->definitionLine = 1963;
// compiled block node returning block862 (depth = 8)
  gc_frame_newslot(block862);
// call case 4: self request
  params[0] = *var_elt;
  params[1] = block862;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call867 = callmethodflags(self, "indexOf(1)ifAbsent(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe861);
// compiled call node returning call867 (depth = 7)
  *var_ix = call867;
  if (call867 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 750
  setline(750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe868 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  gc_frame_newslot(*var_ix);
// call case 4: self request
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call869 = callmethodflags(self, "removeAt(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe868);
// compiled call node returning call869 (depth = 6)
// Begin line 751
  setline(751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply873(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe874 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit875 == NULL) {
    strlit875 = alloc_String("list does not contain object");
    gc_root(strlit875);
  }
// compiled string node returning strlit875 (depth = 9)
  gc_frame_newslot(strlit875);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_NoSuchObject (depth = 9)
  params[0] = strlit875;
  partcv[0] = 1;
  Object call876 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe874);
// compiled call node returning call876 (depth = 8)
  gc_frame_end(frame);
  return call876;
}
Object meth_collectionsPrelude_removeAll_40_1_41_870(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeAll(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll(_)");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_vs = &(stackframe->slots[0]);
  *var_vs = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 755
  setline(755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe871 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_vs (depth = 7)
  gc_frame_newslot(*var_vs);
// starting to compile block node (depth = 7)
  Object block872 = alloc_Block(NULL, NULL, "collectionsPrelude", 755);
  gc_frame_newslot(block872);
// method "_apply"
  block_savedest(block872);
  Object closure873 = createclosure(2, "_apply");
  setclosureframe(closure873, stackframe);
  addtoclosure(closure873, var_NoSuchObject);
  addtoclosure(closure873, selfslot);
  struct UserObject *uo873 = (struct UserObject*)block872;
  uo873->data[0] = (Object)closure873;
  Method *meth_meth_collectionsPrelude__apply873 = addmethod2pos(block872, "_apply", &meth_collectionsPrelude__apply873, 0);
  int argcv_meth_collectionsPrelude__apply873[] = {0};
  meth_meth_collectionsPrelude__apply873->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply873);
  meth_meth_collectionsPrelude__apply873->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply873->definitionLine = 1963;
// compiled block node returning block872 (depth = 7)
  gc_frame_newslot(block872);
// call case 4: self request
  params[0] = *var_vs;
  params[1] = block872;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call878 = callmethodflags(self, "removeAll(1)ifAbsent(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe871);
// compiled call node returning call878 (depth = 6)
  gc_frame_end(frame);
  return call878;
}
Object meth_collectionsPrelude__apply885(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile num node (depth = 11)
  Object num886 = alloc_Float64(0);
// compiled num node returning num886 (depth = 11)
  gc_frame_end(frame);
  return num886;
}
Object meth_collectionsPrelude__apply_40_1_41_882(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
// Begin line 761
  setline(761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe883 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_each (depth = 10)
  gc_frame_newslot(*var_each);
// starting to compile block node (depth = 10)
  Object block884 = alloc_Block(NULL, NULL, "collectionsPrelude", 761);
  gc_frame_newslot(block884);
// method "_apply"
  block_savedest(block884);
  Object closure885 = createclosure(1, "_apply");
  setclosureframe(closure885, stackframe);
  addtoclosure(closure885, selfslot);
  struct UserObject *uo885 = (struct UserObject*)block884;
  uo885->data[0] = (Object)closure885;
  Method *meth_meth_collectionsPrelude__apply885 = addmethod2pos(block884, "_apply", &meth_collectionsPrelude__apply885, 0);
  int argcv_meth_collectionsPrelude__apply885[] = {0};
  meth_meth_collectionsPrelude__apply885->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply885);
  meth_meth_collectionsPrelude__apply885->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply885->definitionLine = 1963;
// compiled block node returning block884 (depth = 10)
  gc_frame_newslot(block884);
// call case 4: self request
  params[0] = *var_each;
  params[1] = block884;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call888 = callmethodflags(self, "indexOf(1)ifAbsent(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe883);
// compiled call node returning call888 (depth = 9)
  *var_ix = call888;
  if (call888 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 762
  setline(762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num891 = alloc_Float64(0);
// compiled num node returning num891 (depth = 10)
  int op_slot_right_890 = gc_frame_newslot(num891);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ix (depth = 10)
  int op_slot_left_890 = gc_frame_newslot(*var_ix);
  params[0] = num891;
  partcv[0] = 1;
  Object opresult893 = callmethod(*var_ix, "≠(1)", 1, partcv, params);
// compiled op node returning opresult893 (depth = 9)
  Object if889 = done;
  if (istrue(opresult893)) {
// Begin line 763
  setline(763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe894 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ix (depth = 10)
  gc_frame_newslot(*var_ix);
// call case 4: self request
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call895 = callmethodflags(self, "removeAt(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe894);
// compiled call node returning call895 (depth = 9)
    gc_frame_newslot(call895);
    if889 = call895;
  } else {
// Begin line 765
  setline(765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
  int callframe896 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_action (depth = 10)
  Object call897 = callmethodflags(*var_action, "apply", 0, partcv, params, 0);
  gc_frame_end(callframe896);
// compiled member node returning call897 (depth = 9)
    gc_frame_newslot(call897);
    if889 = call897;
  }
// compiled if node returning if889 (depth = 8)
  gc_frame_end(frame);
  return if889;
}
Object meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_879(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeAll(1)ifAbsent(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll(_)ifAbsent(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll(_)ifAbsent(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for removeAll(_)ifAbsent(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_vs = &(stackframe->slots[0]);
  *var_vs = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeAll(_)");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifAbsent(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 760
  setline(760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe880 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_vs (depth = 7)
  gc_frame_newslot(*var_vs);
// starting to compile block node (depth = 7)
  Object block881 = alloc_Block(NULL, NULL, "collectionsPrelude", 760);
  gc_frame_newslot(block881);
// method "_apply(_)"
  block_savedest(block881);
  Object closure882 = createclosure(2, "_apply(1)");
  setclosureframe(closure882, stackframe);
  addtoclosure(closure882, var_action);
  addtoclosure(closure882, selfslot);
  struct UserObject *uo882 = (struct UserObject*)block881;
  uo882->data[0] = (Object)closure882;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_882 = addmethod2pos(block881, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_882, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_882[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_882->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_882);
  meth_meth_collectionsPrelude__apply_40_1_41_882->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_882->definitionLine = 1963;
// compiled block node returning block881 (depth = 7)
  gc_frame_newslot(block881);
// call case 5: prelude request
  params[0] = *var_vs;
  params[1] = block881;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call899 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe880);
// compiled call node returning call899 (depth = 6)
// Begin line 768
  setline(768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_pop900(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pop");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 771
  setline(771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe901 = gc_frame_new();
// call case 4: self request
  Object call902 = callmethodflags(self, "removeLast", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe901);
// compiled member node returning call902 (depth = 6)
  gc_frame_end(frame);
  return call902;
}
Object meth_collectionsPrelude__apply_40_1_41_914(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe915 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_result (depth = 9)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call916 = callmethodflags(*var_result, "addFirst(1)", 1, partcv, params, 0);
  gc_frame_end(callframe915);
// compiled call node returning call916 (depth = 8)
  gc_frame_end(frame);
  return call916;
}
Object meth_collectionsPrelude_reversed903(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "reversed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 774
  setline(774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe904 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe905 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe906 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe907 = gc_frame_new();
// call case 3: self.outer request
  Object call908 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe907);
// compiled member node returning call908 (depth = 10)
  Object call909 = callmethodflags(call908, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe906);
// compiled member node returning call909 (depth = 9)
  Object call910 = callmethodflags(call909, "list", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe905);
// compiled member node returning call910 (depth = 8)
  Object call911 = callmethodflags(call910, "empty", 0, partcv, params, 0);
  gc_frame_end(callframe904);
// compiled member node returning call911 (depth = 7)
  *var_result = call911;
  if (call911 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 775
  setline(775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe912 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block913 = alloc_Block(NULL, NULL, "collectionsPrelude", 775);
  gc_frame_newslot(block913);
// method "_apply(_)"
  block_savedest(block913);
  Object closure914 = createclosure(2, "_apply(1)");
  setclosureframe(closure914, stackframe);
  addtoclosure(closure914, var_result);
  addtoclosure(closure914, selfslot);
  struct UserObject *uo914 = (struct UserObject*)block913;
  uo914->data[0] = (Object)closure914;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_914 = addmethod2pos(block913, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_914, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_914[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_914->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_914);
  meth_meth_collectionsPrelude__apply_40_1_41_914->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_914->definitionLine = 1963;
// compiled block node returning block913 (depth = 7)
  gc_frame_newslot(block913);
// call case 4: self request
  params[0] = block913;
  partcv[0] = 1;
  Object call918 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe912);
// compiled call node returning call918 (depth = 6)
// Begin line 776
  setline(776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_result (depth = 6)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude__apply933(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_hiIx = getfromclosure(closure, 0);
  Object *var_loIx = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_hiIx (depth = 9)
  int op_slot_right_934 = gc_frame_newslot(*var_hiIx);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_loIx (depth = 9)
  int op_slot_left_934 = gc_frame_newslot(*var_loIx);
  params[0] = *var_hiIx;
  partcv[0] = 1;
  Object opresult936 = callmethod(*var_loIx, "<(1)", 1, partcv, params);
// compiled op node returning opresult936 (depth = 8)
  gc_frame_end(frame);
  return opresult936;
}
Object meth_collectionsPrelude__apply939(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_hiIx = getfromclosure(closure, 0);
  Object *var_loIx = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_hiVal = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "hiVal");
// Begin line 783
  setline(783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe940 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_hiIx (depth = 10)
  gc_frame_newslot(*var_hiIx);
// call case 4: self request
  params[0] = *var_hiIx;
  partcv[0] = 1;
  Object call941 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe940);
// compiled call node returning call941 (depth = 9)
  *var_hiVal = call941;
  if (call941 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 8)
// Begin line 784
  setline(784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe942 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_hiIx (depth = 9)
  gc_frame_newslot(*var_hiIx);
// starting to compile call node (depth = 9)
  int callframe943 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_loIx (depth = 10)
  gc_frame_newslot(*var_loIx);
// call case 4: self request
  params[0] = *var_loIx;
  partcv[0] = 1;
  Object call944 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe943);
// compiled call node returning call944 (depth = 9)
  gc_frame_newslot(call944);
// call case 4: self request
  params[0] = *var_hiIx;
  params[1] = call944;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call945 = callmethodflags(self, "at(1)put(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe942);
// compiled call node returning call945 (depth = 8)
// Begin line 785
  setline(785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe946 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_loIx (depth = 9)
  gc_frame_newslot(*var_loIx);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_hiVal (depth = 9)
  gc_frame_newslot(*var_hiVal);
// call case 4: self request
  params[0] = *var_loIx;
  params[1] = *var_hiVal;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call947 = callmethodflags(self, "at(1)put(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe946);
// compiled call node returning call947 (depth = 8)
// Begin line 786
  setline(786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num949 = alloc_Float64(1);
// compiled num node returning num949 (depth = 10)
  int op_slot_right_948 = gc_frame_newslot(num949);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_hiIx (depth = 10)
  int op_slot_left_948 = gc_frame_newslot(*var_hiIx);
  params[0] = num949;
  partcv[0] = 1;
  Object diff951 = callmethod(*var_hiIx, "-(1)", 1, partcv, params);
// compiled op node returning diff951 (depth = 9)
  *var_hiIx = diff951;
  if (diff951 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 787
  setline(787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num954 = alloc_Float64(1);
// compiled num node returning num954 (depth = 10)
  int op_slot_right_953 = gc_frame_newslot(num954);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_loIx (depth = 10)
  int op_slot_left_953 = gc_frame_newslot(*var_loIx);
  params[0] = num954;
  partcv[0] = 1;
  Object sum956 = callmethod(*var_loIx, "+(1)", 1, partcv, params);
// compiled op node returning sum956 (depth = 9)
  *var_loIx = sum956;
  if (sum956 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_reverse919(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "reverse");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_hiIx = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "hiIx");
  Object *var_loIx = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "loIx");
// Begin line 779
  setline(779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe920 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num922 = alloc_Float64(1);
// compiled num node returning num922 (depth = 8)
  int op_slot_right_921 = gc_frame_newslot(num922);
// starting to compile member node (depth = 8)
  int callframe924 = gc_frame_new();
// call case 4: self request
  Object call925 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe924);
// compiled member node returning call925 (depth = 8)
  int op_slot_left_921 = gc_frame_newslot(call925);
  params[0] = num922;
  partcv[0] = 1;
  Object sum926 = callmethod(call925, "+(1)", 1, partcv, params);
// compiled op node returning sum926 (depth = 7)
  gc_frame_newslot(sum926);
// call case 4: self request
  params[0] = sum926;
  partcv[0] = 1;
  Object call927 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe920);
// compiled call node returning call927 (depth = 6)
// Begin line 780
  setline(780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe928 = gc_frame_new();
// call case 4: self request
  Object call929 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe928);
// compiled member node returning call929 (depth = 7)
  *var_hiIx = call929;
  if (call929 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 781
  setline(781);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile num node (depth = 7)
  Object num930 = alloc_Float64(1);
// compiled num node returning num930 (depth = 7)
  *var_loIx = num930;
  if (num930 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 782
  setline(782);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe931 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block932 = alloc_Block(NULL, NULL, "collectionsPrelude", 782);
  gc_frame_newslot(block932);
// method "_apply"
  block_savedest(block932);
  Object closure933 = createclosure(3, "_apply");
  setclosureframe(closure933, stackframe);
  addtoclosure(closure933, var_hiIx);
  addtoclosure(closure933, var_loIx);
  addtoclosure(closure933, selfslot);
  struct UserObject *uo933 = (struct UserObject*)block932;
  uo933->data[0] = (Object)closure933;
  Method *meth_meth_collectionsPrelude__apply933 = addmethod2pos(block932, "_apply", &meth_collectionsPrelude__apply933, 0);
  int argcv_meth_collectionsPrelude__apply933[] = {0};
  meth_meth_collectionsPrelude__apply933->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply933);
  meth_meth_collectionsPrelude__apply933->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply933->definitionLine = 1963;
// compiled block node returning block932 (depth = 7)
  gc_frame_newslot(block932);
// starting to compile block node (depth = 7)
  Object block938 = alloc_Block(NULL, NULL, "collectionsPrelude", 782);
  gc_frame_newslot(block938);
// method "_apply"
  block_savedest(block938);
  Object closure939 = createclosure(3, "_apply");
  setclosureframe(closure939, stackframe);
  addtoclosure(closure939, var_hiIx);
  addtoclosure(closure939, var_loIx);
  addtoclosure(closure939, selfslot);
  struct UserObject *uo939 = (struct UserObject*)block938;
  uo939->data[0] = (Object)closure939;
  Method *meth_meth_collectionsPrelude__apply939 = addmethod2pos(block938, "_apply", &meth_collectionsPrelude__apply939, 0);
  int argcv_meth_collectionsPrelude__apply939[] = {0};
  meth_meth_collectionsPrelude__apply939->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply939);
  meth_meth_collectionsPrelude__apply939->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply939->definitionLine = 1963;
// compiled block node returning block938 (depth = 7)
  gc_frame_newslot(block938);
// call case 5: prelude request
  params[0] = block932;
  params[1] = block938;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call959 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe931);
// compiled call node returning call959 (depth = 6)
// Begin line 789
  setline(789);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__43__43__40_1_41_960(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ++(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_l = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "l");
// Begin line 793
  setline(793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe961 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning self (depth = 8)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe962 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe963 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe964 = gc_frame_new();
// call case 3: self.outer request
  Object call965 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe964);
// compiled member node returning call965 (depth = 10)
  Object call966 = callmethodflags(call965, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe963);
// compiled member node returning call966 (depth = 9)
  Object call967 = callmethodflags(call966, "list", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe962);
// compiled member node returning call967 (depth = 8)
  params[0] = self;
  partcv[0] = 1;
  Object call968 = callmethodflags(call967, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe961);
// compiled call node returning call968 (depth = 7)
  *var_l = call968;
  if (call968 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 794
  setline(794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe969 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_l (depth = 7)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call970 = callmethodflags(*var_l, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe969);
// compiled call node returning call970 (depth = 6)
  gc_frame_end(frame);
  return call970;
}
Object meth_collectionsPrelude__apply_40_1_41_981(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_curSize = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 802
  setline(802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe983 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 11)
  int callframe984 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_i (depth = 12)
  gc_frame_newslot(*var_i);
// call case 4: self request
  params[0] = *var_i;
  partcv[0] = 1;
  Object call985 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe984);
// compiled call node returning call985 (depth = 11)
  Object call986 = callmethodflags(call985, "asString", 0, partcv, params, 0);
  gc_frame_end(callframe983);
// compiled member node returning call986 (depth = 10)
  int op_slot_right_982 = gc_frame_newslot(call986);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_982 = gc_frame_newslot(*var_s);
  params[0] = call986;
  partcv[0] = 1;
  Object opresult988 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult988 (depth = 9)
  *var_s = opresult988;
  if (opresult988 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 803
  setline(803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_curSize (depth = 10)
  int op_slot_right_991 = gc_frame_newslot(*var_curSize);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  int op_slot_left_991 = gc_frame_newslot(*var_i);
  params[0] = *var_curSize;
  partcv[0] = 1;
  Object opresult993 = callmethod(*var_i, "<(1)", 1, partcv, params);
// compiled op node returning opresult993 (depth = 9)
  Object if990 = done;
  if (istrue(opresult993)) {
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit995 == NULL) {
    strlit995 = alloc_String(", ");
    gc_root(strlit995);
  }
// compiled string node returning strlit995 (depth = 11)
  int op_slot_right_994 = gc_frame_newslot(strlit995);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_994 = gc_frame_newslot(*var_s);
  params[0] = strlit995;
  partcv[0] = 1;
  Object opresult997 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult997 (depth = 10)
  *var_s = opresult997;
  if (opresult997 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if990 = done;
  } else {
  }
// compiled if node returning if990 (depth = 8)
  gc_frame_end(frame);
  return if990;
}
Object meth_collectionsPrelude_asString971(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
  Object *var_curSize = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "curSize");
// Begin line 799
  setline(799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit972 == NULL) {
    strlit972 = alloc_String("[");
    gc_root(strlit972);
  }
// compiled string node returning strlit972 (depth = 7)
  *var_s = strlit972;
  if (strlit972 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 800
  setline(800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe973 = gc_frame_new();
// call case 4: self request
  Object call974 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe973);
// compiled member node returning call974 (depth = 7)
  *var_curSize = call974;
  if (call974 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 801
  setline(801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe975 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_curSize (depth = 8)
  int op_slot_right_976 = gc_frame_newslot(*var_curSize);
// starting to compile num node (depth = 8)
  Object num978 = alloc_Float64(1);
// compiled num node returning num978 (depth = 8)
  int op_slot_left_976 = gc_frame_newslot(num978);
  params[0] = *var_curSize;
  partcv[0] = 1;
  Object opresult979 = callmethod(num978, "..(1)", 1, partcv, params);
// compiled op node returning opresult979 (depth = 7)
  gc_frame_newslot(opresult979);
// starting to compile block node (depth = 7)
  Object block980 = alloc_Block(NULL, NULL, "collectionsPrelude", 801);
  gc_frame_newslot(block980);
// method "_apply(_)"
  block_savedest(block980);
  Object closure981 = createclosure(3, "_apply(1)");
  setclosureframe(closure981, stackframe);
  addtoclosure(closure981, var_s);
  addtoclosure(closure981, var_curSize);
  addtoclosure(closure981, selfslot);
  struct UserObject *uo981 = (struct UserObject*)block980;
  uo981->data[0] = (Object)closure981;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_981 = addmethod2pos(block980, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_981, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_981[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_981->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_981);
  meth_meth_collectionsPrelude__apply_40_1_41_981->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_981->definitionLine = 1963;
// compiled block node returning block980 (depth = 7)
  gc_frame_newslot(block980);
// call case 5: prelude request
  params[0] = opresult979;
  params[1] = block980;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1000 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe975);
// compiled call node returning call1000 (depth = 6)
// Begin line 805
  setline(805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1002 == NULL) {
    strlit1002 = alloc_String("]");
    gc_root(strlit1002);
  }
// compiled string node returning strlit1002 (depth = 7)
  int op_slot_right_1001 = gc_frame_newslot(strlit1002);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1001 = gc_frame_newslot(*var_s);
  params[0] = strlit1002;
  partcv[0] = 1;
  Object opresult1004 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1004 (depth = 6)
  gc_frame_end(frame);
  return opresult1004;
}
Object meth_collectionsPrelude__apply_40_1_41_1015(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_curSize = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 812
  setline(812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe1017 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 11)
  int callframe1018 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_i (depth = 12)
  gc_frame_newslot(*var_i);
// call case 4: self request
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1019 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1018);
// compiled call node returning call1019 (depth = 11)
  Object call1020 = callmethodflags(call1019, "asDebugString", 0, partcv, params, 0);
  gc_frame_end(callframe1017);
// compiled member node returning call1020 (depth = 10)
  int op_slot_right_1016 = gc_frame_newslot(call1020);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1016 = gc_frame_newslot(*var_s);
  params[0] = call1020;
  partcv[0] = 1;
  Object opresult1022 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1022 (depth = 9)
  *var_s = opresult1022;
  if (opresult1022 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
// Begin line 813
  setline(813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_curSize (depth = 10)
  int op_slot_right_1025 = gc_frame_newslot(*var_curSize);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  int op_slot_left_1025 = gc_frame_newslot(*var_i);
  params[0] = *var_curSize;
  partcv[0] = 1;
  Object opresult1027 = callmethod(*var_i, "<(1)", 1, partcv, params);
// compiled op node returning opresult1027 (depth = 9)
  Object if1024 = done;
  if (istrue(opresult1027)) {
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1029 == NULL) {
    strlit1029 = alloc_String(", ");
    gc_root(strlit1029);
  }
// compiled string node returning strlit1029 (depth = 11)
  int op_slot_right_1028 = gc_frame_newslot(strlit1029);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_1028 = gc_frame_newslot(*var_s);
  params[0] = strlit1029;
  partcv[0] = 1;
  Object opresult1031 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1031 (depth = 10)
  *var_s = opresult1031;
  if (opresult1031 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if1024 = done;
  } else {
  }
// compiled if node returning if1024 (depth = 8)
  gc_frame_end(frame);
  return if1024;
}
Object meth_collectionsPrelude_asDebugString1005(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
  Object *var_curSize = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "curSize");
// Begin line 809
  setline(809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1006 == NULL) {
    strlit1006 = alloc_String("[");
    gc_root(strlit1006);
  }
// compiled string node returning strlit1006 (depth = 7)
  *var_s = strlit1006;
  if (strlit1006 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 810
  setline(810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe1007 = gc_frame_new();
// call case 4: self request
  Object call1008 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1007);
// compiled member node returning call1008 (depth = 7)
  *var_curSize = call1008;
  if (call1008 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 811
  setline(811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1009 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_curSize (depth = 8)
  int op_slot_right_1010 = gc_frame_newslot(*var_curSize);
// starting to compile num node (depth = 8)
  Object num1012 = alloc_Float64(1);
// compiled num node returning num1012 (depth = 8)
  int op_slot_left_1010 = gc_frame_newslot(num1012);
  params[0] = *var_curSize;
  partcv[0] = 1;
  Object opresult1013 = callmethod(num1012, "..(1)", 1, partcv, params);
// compiled op node returning opresult1013 (depth = 7)
  gc_frame_newslot(opresult1013);
// starting to compile block node (depth = 7)
  Object block1014 = alloc_Block(NULL, NULL, "collectionsPrelude", 811);
  gc_frame_newslot(block1014);
// method "_apply(_)"
  block_savedest(block1014);
  Object closure1015 = createclosure(3, "_apply(1)");
  setclosureframe(closure1015, stackframe);
  addtoclosure(closure1015, var_s);
  addtoclosure(closure1015, var_curSize);
  addtoclosure(closure1015, selfslot);
  struct UserObject *uo1015 = (struct UserObject*)block1014;
  uo1015->data[0] = (Object)closure1015;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_1015 = addmethod2pos(block1014, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_1015, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_1015[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_1015->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_1015);
  meth_meth_collectionsPrelude__apply_40_1_41_1015->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_1015->definitionLine = 1963;
// compiled block node returning block1014 (depth = 7)
  gc_frame_newslot(block1014);
// call case 5: prelude request
  params[0] = opresult1013;
  params[1] = block1014;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1034 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1009);
// compiled call node returning call1034 (depth = 6)
// Begin line 815
  setline(815);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1036 == NULL) {
    strlit1036 = alloc_String("]");
    gc_root(strlit1036);
  }
// compiled string node returning strlit1036 (depth = 7)
  int op_slot_right_1035 = gc_frame_newslot(strlit1036);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1035 = gc_frame_newslot(*var_s);
  params[0] = strlit1036;
  partcv[0] = 1;
  Object opresult1038 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1038 (depth = 6)
  gc_frame_end(frame);
  return opresult1038;
}
Object meth_collectionsPrelude_extend_40_1_41_1039(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "extend(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method extend(_)");
  Object params[1];
  int partcv[1];
  Object *var_done = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for extend(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part extend(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 818
  setline(818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1040 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_l (depth = 7)
  gc_frame_newslot(*var_l);
// call case 4: self request
  params[0] = *var_l;
  partcv[0] = 1;
  Object call1041 = callmethodflags(self, "addAll(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1040);
// compiled call node returning call1041 (depth = 6)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_done (depth = 6)
  gc_frame_end(frame);
  return *var_done;
}
Object meth_collectionsPrelude__apply_40_1_41_1045(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_element = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_element (depth = 10)
  int op_slot_right_1047 = gc_frame_newslot(*var_element);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_each (depth = 10)
  int op_slot_left_1047 = gc_frame_newslot(*var_each);
  params[0] = *var_element;
  partcv[0] = 1;
  Object opresult1049 = callmethod(*var_each, "==(1)", 1, partcv, params);
// compiled op node returning opresult1049 (depth = 9)
  Object if1046 = done;
  if (istrue(opresult1049)) {
// starting to compile return node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool1050 = alloc_Boolean(1);
// compiled identifier node returning bool1050 (depth = 10)
  block_return(realself, bool1050);
// compiled return node returning undefined (depth = 9)
    gc_frame_newslot(undefined);
    if1046 = undefined;
  } else {
  }
// compiled if node returning if1046 (depth = 8)
  gc_frame_end(frame);
  return if1046;
}
Object meth_collectionsPrelude_contains_40_1_41_1042(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_element = &(stackframe->slots[0]);
  *var_element = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part contains(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 822
  setline(822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1043 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block1044 = alloc_Block(NULL, NULL, "collectionsPrelude", 822);
  gc_frame_newslot(block1044);
// method "_apply(_)"
  block_savedest(block1044);
  Object closure1045 = createclosure(2, "_apply(1)");
  setclosureframe(closure1045, stackframe);
  addtoclosure(closure1045, var_element);
  addtoclosure(closure1045, selfslot);
  struct UserObject *uo1045 = (struct UserObject*)block1044;
  uo1045->data[0] = (Object)closure1045;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_1045 = addmethod2pos(block1044, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_1045, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_1045[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_1045->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_1045);
  meth_meth_collectionsPrelude__apply_40_1_41_1045->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_1045->definitionLine = 1963;
// compiled block node returning block1044 (depth = 7)
  gc_frame_newslot(block1044);
// call case 4: self request
  params[0] = block1044;
  partcv[0] = 1;
  Object call1052 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1043);
// compiled call node returning call1052 (depth = 6)
// Begin line 823
  setline(823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool1053 = alloc_Boolean(0);
// compiled identifier node returning bool1053 (depth = 7)
  return bool1053;
// compiled return node returning undefined (depth = 6)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply1060(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_curSize = getfromclosure(closure, 0);
  Object *var_i = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_curSize (depth = 9)
  int op_slot_right_1061 = gc_frame_newslot(*var_curSize);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_left_1061 = gc_frame_newslot(*var_i);
  params[0] = *var_curSize;
  partcv[0] = 1;
  Object opresult1063 = callmethod(*var_i, "≤(1)", 1, partcv, params);
// compiled op node returning opresult1063 (depth = 8)
  gc_frame_end(frame);
  return opresult1063;
}
Object meth_collectionsPrelude__apply1066(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_block1 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 830
  setline(830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1067 = gc_frame_new();
// starting to compile call node (depth = 9)
  int callframe1068 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  gc_frame_newslot(*var_i);
// call case 4: self request
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1069 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1068);
// compiled call node returning call1069 (depth = 9)
  gc_frame_newslot(call1069);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_block1 (depth = 9)
  params[0] = call1069;
  partcv[0] = 1;
  Object call1070 = callmethodflags(*var_block1, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1067);
// compiled call node returning call1070 (depth = 8)
// Begin line 831
  setline(831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1072 = alloc_Float64(1);
// compiled num node returning num1072 (depth = 10)
  int op_slot_right_1071 = gc_frame_newslot(num1072);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  int op_slot_left_1071 = gc_frame_newslot(*var_i);
  params[0] = num1072;
  partcv[0] = 1;
  Object sum1074 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum1074 (depth = 9)
  *var_i = sum1074;
  if (sum1074 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 8)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_do_40_1_41_1054(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_i = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "i");
  Object *var_curSize = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "curSize");
// Begin line 827
  setline(827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1055 = alloc_Float64(1);
// compiled num node returning num1055 (depth = 7)
  *var_i = num1055;
  if (num1055 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 828
  setline(828);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe1056 = gc_frame_new();
// call case 4: self request
  Object call1057 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1056);
// compiled member node returning call1057 (depth = 7)
  *var_curSize = call1057;
  if (call1057 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 829
  setline(829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1058 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block1059 = alloc_Block(NULL, NULL, "collectionsPrelude", 829);
  gc_frame_newslot(block1059);
// method "_apply"
  block_savedest(block1059);
  Object closure1060 = createclosure(3, "_apply");
  setclosureframe(closure1060, stackframe);
  addtoclosure(closure1060, var_curSize);
  addtoclosure(closure1060, var_i);
  addtoclosure(closure1060, selfslot);
  struct UserObject *uo1060 = (struct UserObject*)block1059;
  uo1060->data[0] = (Object)closure1060;
  Method *meth_meth_collectionsPrelude__apply1060 = addmethod2pos(block1059, "_apply", &meth_collectionsPrelude__apply1060, 0);
  int argcv_meth_collectionsPrelude__apply1060[] = {0};
  meth_meth_collectionsPrelude__apply1060->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1060);
  meth_meth_collectionsPrelude__apply1060->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1060->definitionLine = 1963;
// compiled block node returning block1059 (depth = 7)
  gc_frame_newslot(block1059);
// starting to compile block node (depth = 7)
  Object block1065 = alloc_Block(NULL, NULL, "collectionsPrelude", 829);
  gc_frame_newslot(block1065);
// method "_apply"
  block_savedest(block1065);
  Object closure1066 = createclosure(3, "_apply");
  setclosureframe(closure1066, stackframe);
  addtoclosure(closure1066, var_i);
  addtoclosure(closure1066, var_block1);
  addtoclosure(closure1066, selfslot);
  struct UserObject *uo1066 = (struct UserObject*)block1065;
  uo1066->data[0] = (Object)closure1066;
  Method *meth_meth_collectionsPrelude__apply1066 = addmethod2pos(block1065, "_apply", &meth_collectionsPrelude__apply1066, 0);
  int argcv_meth_collectionsPrelude__apply1066[] = {0};
  meth_meth_collectionsPrelude__apply1066->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1066);
  meth_meth_collectionsPrelude__apply1066->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1066->definitionLine = 1963;
// compiled block node returning block1065 (depth = 7)
  gc_frame_newslot(block1065);
// call case 5: prelude request
  params[0] = block1059;
  params[1] = block1065;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1077 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1058);
// compiled call node returning call1077 (depth = 6)
  gc_frame_end(frame);
  return call1077;
}
Object meth_collectionsPrelude__61__61__40_1_41_1078(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 836
  setline(836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1079 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1080 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1081 = gc_frame_new();
// call case 3: self.outer request
  Object call1082 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1081);
// compiled member node returning call1082 (depth = 8)
  Object call1083 = callmethodflags(call1082, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe1080);
// compiled member node returning call1083 (depth = 7)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1084 = callmethodflags(call1083, "isEqual(1)toIterable(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1079);
// compiled call node returning call1084 (depth = 6)
  gc_frame_end(frame);
  return call1084;
}
Object meth_collectionsPrelude_asDebugString1090(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 843
  setline(843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1092 == NULL) {
    strlit1092 = alloc_String("""\xe2""""\x9f""""\xab""");
    gc_root(strlit1092);
  }
// compiled string node returning strlit1092 (depth = 7)
  int op_slot_right_1091 = gc_frame_newslot(strlit1092);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe1095 = gc_frame_new();
// call case 4: self request
  Object call1096 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1095);
// compiled member node returning call1096 (depth = 8)
  int op_slot_right_1094 = gc_frame_newslot(call1096);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1099 == NULL) {
    strlit1099 = alloc_String("""\xe2""""\x9f""""\xaa""");
    gc_root(strlit1099);
  }
// compiled string node returning strlit1099 (depth = 9)
  int op_slot_right_1098 = gc_frame_newslot(strlit1099);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
  int callframe1102 = gc_frame_new();
// call case 4: self request
  Object call1103 = callmethodflags(self, "asString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1102);
// compiled member node returning call1103 (depth = 10)
  int op_slot_right_1101 = gc_frame_newslot(call1103);
// starting to compile string node (depth = 10)
  if (strlit1105 == NULL) {
    strlit1105 = alloc_String("");
    gc_root(strlit1105);
  }
// compiled string node returning strlit1105 (depth = 10)
  int op_slot_left_1101 = gc_frame_newslot(strlit1105);
  params[0] = call1103;
  partcv[0] = 1;
  Object opresult1106 = callmethod(strlit1105, "++(1)", 1, partcv, params);
// compiled op node returning opresult1106 (depth = 9)
  int op_slot_left_1098 = gc_frame_newslot(opresult1106);
  params[0] = strlit1099;
  partcv[0] = 1;
  Object opresult1107 = callmethod(opresult1106, "++(1)", 1, partcv, params);
// compiled op node returning opresult1107 (depth = 8)
  int op_slot_left_1094 = gc_frame_newslot(opresult1107);
  params[0] = call1096;
  partcv[0] = 1;
  Object opresult1108 = callmethod(opresult1107, "++(1)", 1, partcv, params);
// compiled op node returning opresult1108 (depth = 7)
  int op_slot_left_1091 = gc_frame_newslot(opresult1108);
  params[0] = strlit1092;
  partcv[0] = 1;
  Object opresult1109 = callmethod(opresult1108, "++(1)", 1, partcv, params);
// compiled op node returning opresult1109 (depth = 6)
  gc_frame_end(frame);
  return opresult1109;
}
Object meth_collectionsPrelude_asString1110(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 844
  setline(844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1111 == NULL) {
    strlit1111 = alloc_String("aListIterator");
    gc_root(strlit1111);
  }
// compiled string node returning strlit1111 (depth = 6)
  gc_frame_end(frame);
  return strlit1111;
}
Object meth_collectionsPrelude_hasNext1112(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 845
  setline(845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe1114 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1115 = gc_frame_new();
// call case 3: self.outer request
  Object call1116 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1115);
// compiled member node returning call1116 (depth = 8)
  Object call1117 = callmethodflags(call1116, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1114);
// compiled member node returning call1117 (depth = 7)
  int op_slot_right_1113 = gc_frame_newslot(call1117);
// starting to compile member node (depth = 7)
  int callframe1119 = gc_frame_new();
// call case 4: self request
  Object call1120 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1119);
// compiled member node returning call1120 (depth = 7)
  int op_slot_left_1113 = gc_frame_newslot(call1120);
  params[0] = call1117;
  partcv[0] = 1;
  Object opresult1121 = callmethod(call1120, "≤(1)", 1, partcv, params);
// compiled op node returning opresult1121 (depth = 6)
  gc_frame_end(frame);
  return opresult1121;
}
Object meth_collectionsPrelude_next1122(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ret = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "ret");
// Begin line 847
  setline(847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe1125 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe1126 = gc_frame_new();
// call case 3: self.outer request
  Object call1127 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1126);
// compiled member node returning call1127 (depth = 9)
  Object call1128 = callmethodflags(call1127, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1125);
// compiled member node returning call1128 (depth = 8)
  int op_slot_right_1124 = gc_frame_newslot(call1128);
// starting to compile member node (depth = 8)
  int callframe1130 = gc_frame_new();
// call case 4: self request
  Object call1131 = callmethodflags(self, "imods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1130);
// compiled member node returning call1131 (depth = 8)
  int op_slot_left_1124 = gc_frame_newslot(call1131);
  params[0] = call1128;
  partcv[0] = 1;
  Object opresult1132 = callmethod(call1131, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1132 (depth = 7)
  Object if1123 = done;
  if (istrue(opresult1132)) {
// Begin line 848
  setline(848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1133 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe1134 = gc_frame_new();
// call case 4: self request
  Object call1135 = callmethodflags(self, "asDebugString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1134);
// compiled member node returning call1135 (depth = 8)
  gc_frame_newslot(call1135);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ConcurrentModification (depth = 8)
  params[0] = call1135;
  partcv[0] = 1;
  Object call1136 = callmethodflags(*var_ConcurrentModification, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1133);
// compiled call node returning call1136 (depth = 7)
    gc_frame_newslot(call1136);
    if1123 = call1136;
  } else {
  }
// compiled if node returning if1123 (depth = 6)
// Begin line 850
  setline(850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe1139 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe1140 = gc_frame_new();
// call case 3: self.outer request
  Object call1141 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1140);
// compiled member node returning call1141 (depth = 9)
  Object call1142 = callmethodflags(call1141, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1139);
// compiled member node returning call1142 (depth = 8)
  int op_slot_right_1138 = gc_frame_newslot(call1142);
// starting to compile member node (depth = 8)
  int callframe1144 = gc_frame_new();
// call case 4: self request
  Object call1145 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1144);
// compiled member node returning call1145 (depth = 8)
  int op_slot_left_1138 = gc_frame_newslot(call1145);
  params[0] = call1142;
  partcv[0] = 1;
  Object opresult1146 = callmethod(call1145, ">(1)", 1, partcv, params);
// compiled op node returning opresult1146 (depth = 7)
  Object if1137 = done;
  if (istrue(opresult1146)) {
// starting to compile call node (depth = 7)
  int callframe1147 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1148 == NULL) {
    strlit1148 = alloc_String("on list");
    gc_root(strlit1148);
  }
// compiled string node returning strlit1148 (depth = 8)
  gc_frame_newslot(strlit1148);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_IteratorExhausted (depth = 8)
  params[0] = strlit1148;
  partcv[0] = 1;
  Object call1149 = callmethodflags(*var_IteratorExhausted, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1147);
// compiled call node returning call1149 (depth = 7)
    gc_frame_newslot(call1149);
    if1137 = call1149;
  } else {
  }
// compiled if node returning if1137 (depth = 6)
// Begin line 851
  setline(851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1150 = gc_frame_new();
// starting to compile member node (depth = 8)
  int callframe1151 = gc_frame_new();
// call case 4: self request
  Object call1152 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1151);
// compiled member node returning call1152 (depth = 8)
  gc_frame_newslot(call1152);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1153 = gc_frame_new();
// call case 3: self.outer request
  Object call1154 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1153);
// compiled member node returning call1154 (depth = 8)
  params[0] = call1152;
  partcv[0] = 1;
  Object call1155 = callmethodflags(call1154, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1150);
// compiled call node returning call1155 (depth = 7)
  *var_ret = call1155;
  if (call1155 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 852
  setline(852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1156 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1158 = alloc_Float64(1);
// compiled num node returning num1158 (depth = 8)
  int op_slot_right_1157 = gc_frame_newslot(num1158);
// starting to compile member node (depth = 8)
  int callframe1160 = gc_frame_new();
// call case 4: self request
  Object call1161 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1160);
// compiled member node returning call1161 (depth = 8)
  int op_slot_left_1157 = gc_frame_newslot(call1161);
  params[0] = num1158;
  partcv[0] = 1;
  Object sum1162 = callmethod(call1161, "+(1)", 1, partcv, params);
// compiled op node returning sum1162 (depth = 7)
  gc_frame_newslot(sum1162);
// call case 4: self request
  params[0] = sum1162;
  partcv[0] = 1;
  Object call1163 = callmethodflags(self, "idx:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1156);
// compiled call node returning call1163 (depth = 6)
// Begin line 853
  setline(853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ret (depth = 6)
  gc_frame_end(frame);
  return *var_ret;
}
Object meth_collectionsPrelude_iterator1085(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1086 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1086 = alloc_userobj2(8,7, objclass1086);
  gc_frame_newslot(obj1086);
if (objclass1086 == NULL) {
  glfree(obj1086->class->name);
  obj1086->class->name = "obj723.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1086, self, 0);
  addmethodreal(obj1086,"outer", &reader_collectionsPrelude_outer_1087);
  Object oldself1086 = self;
  struct StackFrameObject *oldstackframe1086 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1086);
  gc_frame_newslot((Object)stackframe);
  self = obj1086;
  Object *oldselfslot1086 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1086 = (*(struct UserObject *)self).data[0], lowerouter1086 = thisouter1086;
  if (inheritingObject1086) {
    struct UserObject *inho1086 = (struct UserObject *)inheritingObject1086;
    while (inho1086->super != GraceDefaultObject) inho1086 = (struct UserObject *)inho1086->super;
    inho1086->super = obj1086;
    self = inheritingObject1086;
    *selfslot = self;
    lowerouter1086 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1086;
  }
if (objclass1086 == NULL) {
  Method *reader1088 = addmethodrealflags(obj1086, "imods", &reader_collectionsPrelude_imods_1088, MFLAG_CONFIDENTIAL);
  Method *writer1088 = addmethodrealflags(obj1086, "imods:=(1)", &writer_collectionsPrelude_imods_1088, MFLAG_CONFIDENTIAL);
  reader1088->definitionModule = modulename;
  writer1088->definitionModule = modulename;
  reader1088->definitionLine = 841;
  writer1088->definitionLine = 841;
}
obj1086->flags |= OFLAG_MUTABLE;
adddatum2(obj1086, alloc_Undefined(), 1);
if (objclass1086 == NULL) {
  Method *reader1089 = addmethodrealflags(obj1086, "idx", &reader_collectionsPrelude_idx_1089, MFLAG_CONFIDENTIAL);
  Method *writer1089 = addmethodrealflags(obj1086, "idx:=(1)", &writer_collectionsPrelude_idx_1089, MFLAG_CONFIDENTIAL);
  reader1089->definitionModule = modulename;
  writer1089->definitionModule = modulename;
  reader1089->definitionLine = 842;
  writer1089->definitionLine = 842;
}
obj1086->flags |= OFLAG_MUTABLE;
adddatum2(obj1086, alloc_Undefined(), 2);
// method "asDebugString"
  struct UserObject *uo1090 = (struct UserObject*)obj1086;
  uo1090->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString1090 = addmethod2pos(obj1086, "asDebugString", &meth_collectionsPrelude_asDebugString1090, 3);
  int argcv_meth_collectionsPrelude_asDebugString1090[] = {0};
  meth_meth_collectionsPrelude_asDebugString1090->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString1090);
  meth_meth_collectionsPrelude_asDebugString1090->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString1090->definitionLine = 843;
// method "asString"
  struct UserObject *uo1110 = (struct UserObject*)obj1086;
  uo1110->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString1110 = addmethod2pos(obj1086, "asString", &meth_collectionsPrelude_asString1110, 4);
  int argcv_meth_collectionsPrelude_asString1110[] = {0};
  meth_meth_collectionsPrelude_asString1110->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString1110);
  meth_meth_collectionsPrelude_asString1110->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString1110->definitionLine = 844;
// method "hasNext"
  struct UserObject *uo1112 = (struct UserObject*)obj1086;
  uo1112->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext1112 = addmethod2pos(obj1086, "hasNext", &meth_collectionsPrelude_hasNext1112, 5);
  int argcv_meth_collectionsPrelude_hasNext1112[] = {0};
  meth_meth_collectionsPrelude_hasNext1112->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext1112);
  meth_meth_collectionsPrelude_hasNext1112->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext1112->definitionLine = 845;
// method "next"
  block_savedest(obj1086);
  Object closure1122 = createclosure(2, "next");
  setclosureframe(closure1122, stackframe);
  addtoclosure(closure1122, var_ConcurrentModification);
  addtoclosure(closure1122, var_IteratorExhausted);
  struct UserObject *uo1122 = (struct UserObject*)obj1086;
  uo1122->data[6] = (Object)closure1122;
  Method *meth_meth_collectionsPrelude_next1122 = addmethod2pos(obj1086, "next", &meth_collectionsPrelude_next1122, 6);
  int argcv_meth_collectionsPrelude_next1122[] = {0};
  meth_meth_collectionsPrelude_next1122->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next1122);
  meth_meth_collectionsPrelude_next1122->definitionModule = modulename;
  meth_meth_collectionsPrelude_next1122->definitionLine = 846;
  sourceObject = obj1086;
// Begin line 841
  setline(841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe1164 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1165 = gc_frame_new();
// call case 3: self.outer request
  Object call1166 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1165);
// compiled member node returning call1166 (depth = 7)
  Object call1167 = callmethodflags(call1166, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1164);
// compiled member node returning call1167 (depth = 6)
  adddatum2(obj1086, call1167, 1);
  sourceObject = obj1086;
// Begin line 842
  setline(842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num1168 = alloc_Float64(1);
// compiled num node returning num1168 (depth = 6)
  adddatum2(obj1086, num1168, 2);
  sourceObject = obj1086;
  sourceObject = obj1086;
  sourceObject = obj1086;
  sourceObject = obj1086;
  objclass1086 = obj1086->class;
  objclass1086->definitionModule = modulename;
  objclass1086->definitionLine = 840;
  (*(struct UserObject *)self).data[0] = lowerouter1086;
  self = oldself1086;
  selfslot = oldselfslot1086;
  stackframe = oldstackframe1086;
  gc_frame_end(frame);
  return obj1086;
}
Object meth_collectionsPrelude_iterator1085_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1086 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1086 = alloc_userobj2(8,7, objclass1086);
  gc_frame_newslot(obj1086);
if (objclass1086 == NULL) {
  glfree(obj1086->class->name);
  obj1086->class->name = "obj723.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1086, self, 0);
  addmethodreal(obj1086,"outer", &reader_collectionsPrelude_outer_1087);
  Object oldself1086 = self;
  struct StackFrameObject *oldstackframe1086 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1086);
  gc_frame_newslot((Object)stackframe);
  self = obj1086;
  Object *oldselfslot1086 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1086 = (*(struct UserObject *)self).data[0], lowerouter1086 = thisouter1086;
  if (inheritingObject1086) {
    struct UserObject *inho1086 = (struct UserObject *)inheritingObject1086;
    while (inho1086->super != GraceDefaultObject) inho1086 = (struct UserObject *)inho1086->super;
    inho1086->super = obj1086;
    self = inheritingObject1086;
    *selfslot = self;
    lowerouter1086 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1086;
  }
if (objclass1086 == NULL) {
  Method *reader1088 = addmethodrealflags(obj1086, "imods", &reader_collectionsPrelude_imods_1088, MFLAG_CONFIDENTIAL);
  Method *writer1088 = addmethodrealflags(obj1086, "imods:=(1)", &writer_collectionsPrelude_imods_1088, MFLAG_CONFIDENTIAL);
  reader1088->definitionModule = modulename;
  writer1088->definitionModule = modulename;
  reader1088->definitionLine = 841;
  writer1088->definitionLine = 841;
}
obj1086->flags |= OFLAG_MUTABLE;
adddatum2(obj1086, alloc_Undefined(), 1);
if (objclass1086 == NULL) {
  Method *reader1089 = addmethodrealflags(obj1086, "idx", &reader_collectionsPrelude_idx_1089, MFLAG_CONFIDENTIAL);
  Method *writer1089 = addmethodrealflags(obj1086, "idx:=(1)", &writer_collectionsPrelude_idx_1089, MFLAG_CONFIDENTIAL);
  reader1089->definitionModule = modulename;
  writer1089->definitionModule = modulename;
  reader1089->definitionLine = 842;
  writer1089->definitionLine = 842;
}
obj1086->flags |= OFLAG_MUTABLE;
adddatum2(obj1086, alloc_Undefined(), 2);
// method "asDebugString"
  struct UserObject *uo1090 = (struct UserObject*)obj1086;
  uo1090->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString1090 = addmethod2pos(obj1086, "asDebugString", &meth_collectionsPrelude_asDebugString1090, 3);
  int argcv_meth_collectionsPrelude_asDebugString1090[] = {0};
  meth_meth_collectionsPrelude_asDebugString1090->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString1090);
  meth_meth_collectionsPrelude_asDebugString1090->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString1090->definitionLine = 843;
// method "asString"
  struct UserObject *uo1110 = (struct UserObject*)obj1086;
  uo1110->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString1110 = addmethod2pos(obj1086, "asString", &meth_collectionsPrelude_asString1110, 4);
  int argcv_meth_collectionsPrelude_asString1110[] = {0};
  meth_meth_collectionsPrelude_asString1110->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString1110);
  meth_meth_collectionsPrelude_asString1110->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString1110->definitionLine = 844;
// method "hasNext"
  struct UserObject *uo1112 = (struct UserObject*)obj1086;
  uo1112->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext1112 = addmethod2pos(obj1086, "hasNext", &meth_collectionsPrelude_hasNext1112, 5);
  int argcv_meth_collectionsPrelude_hasNext1112[] = {0};
  meth_meth_collectionsPrelude_hasNext1112->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext1112);
  meth_meth_collectionsPrelude_hasNext1112->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext1112->definitionLine = 845;
// method "next"
  block_savedest(obj1086);
  Object closure1122 = createclosure(2, "next");
  setclosureframe(closure1122, stackframe);
  addtoclosure(closure1122, var_ConcurrentModification);
  addtoclosure(closure1122, var_IteratorExhausted);
  struct UserObject *uo1122 = (struct UserObject*)obj1086;
  uo1122->data[6] = (Object)closure1122;
  Method *meth_meth_collectionsPrelude_next1122 = addmethod2pos(obj1086, "next", &meth_collectionsPrelude_next1122, 6);
  int argcv_meth_collectionsPrelude_next1122[] = {0};
  meth_meth_collectionsPrelude_next1122->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next1122);
  meth_meth_collectionsPrelude_next1122->definitionModule = modulename;
  meth_meth_collectionsPrelude_next1122->definitionLine = 846;
  sourceObject = obj1086;
// Begin line 841
  setline(841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe1164 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1165 = gc_frame_new();
// call case 3: self.outer request
  Object call1166 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1165);
// compiled member node returning call1166 (depth = 7)
  Object call1167 = callmethodflags(call1166, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1164);
// compiled member node returning call1167 (depth = 6)
  adddatum2(obj1086, call1167, 1);
  sourceObject = obj1086;
// Begin line 842
  setline(842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num1168 = alloc_Float64(1);
// compiled num node returning num1168 (depth = 6)
  adddatum2(obj1086, num1168, 2);
  sourceObject = obj1086;
  sourceObject = obj1086;
  sourceObject = obj1086;
  sourceObject = obj1086;
  objclass1086 = obj1086->class;
  objclass1086->definitionModule = modulename;
  objclass1086->definitionLine = 840;
  (*(struct UserObject *)self).data[0] = lowerouter1086;
  self = oldself1086;
  selfslot = oldselfslot1086;
  stackframe = oldstackframe1086;
  gc_frame_end(frame);
  return obj1086;
}
Object meth_collectionsPrelude_values1170(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 859
  setline(859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_keys1171(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 863
  setline(863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe1172 = gc_frame_new();
// call case 4: self request
  Object call1173 = callmethodflags(self, "indices", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1172);
// compiled member node returning call1173 (depth = 6)
  gc_frame_end(frame);
  return call1173;
}
Object meth_collectionsPrelude__apply_40_2_41_1185(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[1]);
  *var_r = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 869
  setline(869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_r (depth = 10)
  int op_slot_right_1187 = gc_frame_newslot(*var_r);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_l (depth = 10)
  int op_slot_left_1187 = gc_frame_newslot(*var_l);
  params[0] = *var_r;
  partcv[0] = 1;
  Object opresult1189 = callmethod(*var_l, "==(1)", 1, partcv, params);
// compiled op node returning opresult1189 (depth = 9)
  Object if1186 = done;
  if (istrue(opresult1189)) {
// starting to compile num node (depth = 9)
  Object num1190 = alloc_Float64(0);
// compiled num node returning num1190 (depth = 9)
    gc_frame_newslot(num1190);
    if1186 = num1190;
  } else {
// Begin line 871
  setline(871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 870
  setline(870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_r (depth = 11)
  int op_slot_right_1192 = gc_frame_newslot(*var_r);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_l (depth = 11)
  int op_slot_left_1192 = gc_frame_newslot(*var_l);
  params[0] = *var_r;
  partcv[0] = 1;
  Object opresult1194 = callmethod(*var_l, "<(1)", 1, partcv, params);
// compiled op node returning opresult1194 (depth = 10)
  Object if1191 = done;
  if (istrue(opresult1194)) {
// starting to compile call node (depth = 10)
  int callframe1195 = gc_frame_new();
// call case 6: other requests
// starting to compile num node (depth = 11)
  Object num1196 = alloc_Float64(1);
// compiled num node returning num1196 (depth = 11)
  partcv[0] = 0;
  Object call1197 = callmethodflags(num1196, "prefix-", 1, partcv, params, 0);
  gc_frame_end(callframe1195);
// compiled call node returning call1197 (depth = 10)
    gc_frame_newslot(call1197);
    if1191 = call1197;
  } else {
// Begin line 871
  setline(871);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 10)
  Object num1198 = alloc_Float64(1);
// compiled num node returning num1198 (depth = 10)
    gc_frame_newslot(num1198);
    if1191 = num1198;
  }
// compiled if node returning if1191 (depth = 9)
    gc_frame_newslot(if1191);
    if1186 = if1191;
  }
// compiled if node returning if1186 (depth = 8)
  gc_frame_end(frame);
  return if1186;
}
Object meth_collectionsPrelude_sort1174(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sort");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 867
  setline(867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1175 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1177 = alloc_Float64(1);
// compiled num node returning num1177 (depth = 8)
  int op_slot_right_1176 = gc_frame_newslot(num1177);
// starting to compile member node (depth = 8)
  int callframe1179 = gc_frame_new();
// call case 4: self request
  Object call1180 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1179);
// compiled member node returning call1180 (depth = 8)
  int op_slot_left_1176 = gc_frame_newslot(call1180);
  params[0] = num1177;
  partcv[0] = 1;
  Object sum1181 = callmethod(call1180, "+(1)", 1, partcv, params);
// compiled op node returning sum1181 (depth = 7)
  gc_frame_newslot(sum1181);
// call case 4: self request
  params[0] = sum1181;
  partcv[0] = 1;
  Object call1182 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1175);
// compiled call node returning call1182 (depth = 6)
// Begin line 868
  setline(868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1183 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block1184 = alloc_Block(NULL, NULL, "collectionsPrelude", 868);
  gc_frame_newslot(block1184);
// method "_apply(_,_)"
  block_savedest(block1184);
  Object closure1185 = createclosure(1, "_apply(2)");
  setclosureframe(closure1185, stackframe);
  addtoclosure(closure1185, selfslot);
  struct UserObject *uo1185 = (struct UserObject*)block1184;
  uo1185->data[0] = (Object)closure1185;
  Method *meth_meth_collectionsPrelude__apply_40_2_41_1185 = addmethod2pos(block1184, "_apply(2)", &meth_collectionsPrelude__apply_40_2_41_1185, 0);
  int argcv_meth_collectionsPrelude__apply_40_2_41_1185[] = {2};
  meth_meth_collectionsPrelude__apply_40_2_41_1185->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_2_41_1185);
  meth_meth_collectionsPrelude__apply_40_2_41_1185->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_2_41_1185->definitionLine = 1963;
// compiled block node returning block1184 (depth = 7)
  gc_frame_newslot(block1184);
// call case 4: self request
  params[0] = block1184;
  partcv[0] = 1;
  Object call1200 = callmethodflags(self, "sortBy(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1183);
// compiled call node returning call1200 (depth = 6)
  gc_frame_end(frame);
  return call1200;
}
Object meth_collectionsPrelude_sortedBy_40_1_41_1201(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortedBy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortedBy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sortedBy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 875
  setline(875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1202 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sortBlock (depth = 7)
  gc_frame_newslot(*var_sortBlock);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1203 = gc_frame_new();
// call case 4: self request
  Object call1204 = callmethodflags(self, "copy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1203);
// compiled member node returning call1204 (depth = 7)
  params[0] = *var_sortBlock;
  partcv[0] = 1;
  Object call1205 = callmethodflags(call1204, "sortBy(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1202);
// compiled call node returning call1205 (depth = 6)
  gc_frame_end(frame);
  return call1205;
}
Object meth_collectionsPrelude_sorted1206(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 878
  setline(878);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe1207 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1208 = gc_frame_new();
// call case 4: self request
  Object call1209 = callmethodflags(self, "copy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1208);
// compiled member node returning call1209 (depth = 7)
  Object call1210 = callmethodflags(call1209, "sort", 0, partcv, params, 0);
  gc_frame_end(callframe1207);
// compiled member node returning call1210 (depth = 6)
  gc_frame_end(frame);
  return call1210;
}
Object meth_collectionsPrelude_copy1211(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "copy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 881
  setline(881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1212 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe1213 = gc_frame_new();
// call case 3: self.outer request
  Object call1214 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1213);
// compiled member node returning call1214 (depth = 7)
  params[0] = self;
  partcv[0] = 1;
  Object call1215 = callmethodflags(call1214, "withAll(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1212);
// compiled call node returning call1215 (depth = 6)
  gc_frame_end(frame);
  return call1215;
}
Object meth_collectionsPrelude__apply_40_1_41_1222(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 636
  setline(636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
// compiled call node returning done (depth = 8)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_boundsCheck_40_1_41_1232(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "boundsCheck(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method boundsCheck(_)");
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for boundsCheck(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part boundsCheck(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 920
  setline(920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1235 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1237 = gc_frame_new();
// call case 4: self request
  Object call1238 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1237);
// compiled member node returning call1238 (depth = 6)
  int op_slot_right_1236 = gc_frame_newslot(call1238);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_left_1236 = gc_frame_newslot(*var_n);
  params[0] = call1238;
  partcv[0] = 1;
  Object opresult1240 = callmethod(*var_n, "≤(1)", 1, partcv, params);
// compiled op node returning opresult1240 (depth = 5)
  partcv[0] = 0;
  Object call1241 = callmethodflags(opresult1240, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe1235);
// compiled call node returning call1241 (depth = 4)
  int op_slot_right_1234 = gc_frame_newslot(call1241);
// starting to compile call node (depth = 4)
  int callframe1243 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1245 = alloc_Float64(1);
// compiled num node returning num1245 (depth = 6)
  int op_slot_right_1244 = gc_frame_newslot(num1245);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_left_1244 = gc_frame_newslot(*var_n);
  params[0] = num1245;
  partcv[0] = 1;
  Object opresult1247 = callmethod(*var_n, "≥(1)", 1, partcv, params);
// compiled op node returning opresult1247 (depth = 5)
  partcv[0] = 0;
  Object call1248 = callmethodflags(opresult1247, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe1243);
// compiled call node returning call1248 (depth = 4)
  int op_slot_left_1234 = gc_frame_newslot(call1248);
  params[0] = call1241;
  partcv[0] = 1;
  Object opresult1249 = callmethod(call1248, "||(1)", 1, partcv, params);
// compiled op node returning opresult1249 (depth = 3)
  Object if1233 = done;
  if (istrue(opresult1249)) {
// Begin line 921
  setline(921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1250 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1252 == NULL) {
    strlit1252 = alloc_String("");
    gc_root(strlit1252);
  }
// compiled string node returning strlit1252 (depth = 5)
  int op_slot_right_1251 = gc_frame_newslot(strlit1252);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1255 = gc_frame_new();
// call case 4: self request
  Object call1256 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1255);
// compiled member node returning call1256 (depth = 6)
  int op_slot_right_1254 = gc_frame_newslot(call1256);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1259 == NULL) {
    strlit1259 = alloc_String(" out of bounds 1..");
    gc_root(strlit1259);
  }
// compiled string node returning strlit1259 (depth = 7)
  int op_slot_right_1258 = gc_frame_newslot(strlit1259);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_right_1261 = gc_frame_newslot(*var_n);
// starting to compile string node (depth = 8)
  if (strlit1263 == NULL) {
    strlit1263 = alloc_String("index ");
    gc_root(strlit1263);
  }
// compiled string node returning strlit1263 (depth = 8)
  int op_slot_left_1261 = gc_frame_newslot(strlit1263);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult1264 = callmethod(strlit1263, "++(1)", 1, partcv, params);
// compiled op node returning opresult1264 (depth = 7)
  int op_slot_left_1258 = gc_frame_newslot(opresult1264);
  params[0] = strlit1259;
  partcv[0] = 1;
  Object opresult1265 = callmethod(opresult1264, "++(1)", 1, partcv, params);
// compiled op node returning opresult1265 (depth = 6)
  int op_slot_left_1254 = gc_frame_newslot(opresult1265);
  params[0] = call1256;
  partcv[0] = 1;
  Object opresult1266 = callmethod(opresult1265, "++(1)", 1, partcv, params);
// compiled op node returning opresult1266 (depth = 5)
  int op_slot_left_1251 = gc_frame_newslot(opresult1266);
  params[0] = strlit1252;
  partcv[0] = 1;
  Object opresult1267 = callmethod(opresult1266, "++(1)", 1, partcv, params);
// compiled op node returning opresult1267 (depth = 4)
  gc_frame_newslot(opresult1267);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult1267;
  partcv[0] = 1;
  Object call1268 = callmethodflags(*var_BoundsError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1250);
// compiled call node returning call1268 (depth = 3)
    gc_frame_newslot(call1268);
    if1233 = call1268;
  } else {
  }
// compiled if node returning if1233 (depth = 2)
  gc_frame_end(frame);
  return if1233;
}
Object meth_collectionsPrelude_at_40_1_41_1269(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 925
  setline(925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1270 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1271 = callmethodflags(self, "boundsCheck(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1270);
// compiled call node returning call1271 (depth = 2)
// Begin line 926
  setline(926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1272 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1274 = alloc_Float64(1);
// compiled num node returning num1274 (depth = 4)
  int op_slot_right_1273 = gc_frame_newslot(num1274);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_left_1273 = gc_frame_newslot(*var_n);
  params[0] = num1274;
  partcv[0] = 1;
  Object diff1276 = callmethod(*var_n, "-(1)", 1, partcv, params);
// compiled op node returning diff1276 (depth = 3)
  gc_frame_newslot(diff1276);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe1277 = gc_frame_new();
// call case 4: self request
  Object call1278 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1277);
// compiled member node returning call1278 (depth = 3)
  params[0] = diff1276;
  partcv[0] = 1;
  Object call1279 = callmethodflags(call1278, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1272);
// compiled call node returning call1279 (depth = 2)
  gc_frame_end(frame);
  return call1279;
}
Object meth_collectionsPrelude_at_40_1_41_put_40_1_41_1280(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at(1)put(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)put(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)put(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for at(_)put(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *var_x = &(stackframe->slots[1]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part put(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 929
  setline(929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1281 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1283 = alloc_Float64(1);
// compiled num node returning num1283 (depth = 4)
  int op_slot_right_1282 = gc_frame_newslot(num1283);
// starting to compile member node (depth = 4)
  int callframe1285 = gc_frame_new();
// call case 4: self request
  Object call1286 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1285);
// compiled member node returning call1286 (depth = 4)
  int op_slot_left_1282 = gc_frame_newslot(call1286);
  params[0] = num1283;
  partcv[0] = 1;
  Object sum1287 = callmethod(call1286, "+(1)", 1, partcv, params);
// compiled op node returning sum1287 (depth = 3)
  gc_frame_newslot(sum1287);
// call case 4: self request
  params[0] = sum1287;
  partcv[0] = 1;
  Object call1288 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1281);
// compiled call node returning call1288 (depth = 2)
// Begin line 930
  setline(930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1292 = alloc_Float64(1);
// compiled num node returning num1292 (depth = 5)
  int op_slot_right_1291 = gc_frame_newslot(num1292);
// starting to compile member node (depth = 5)
  int callframe1294 = gc_frame_new();
// call case 4: self request
  Object call1295 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1294);
// compiled member node returning call1295 (depth = 5)
  int op_slot_left_1291 = gc_frame_newslot(call1295);
  params[0] = num1292;
  partcv[0] = 1;
  Object sum1296 = callmethod(call1295, "+(1)", 1, partcv, params);
// compiled op node returning sum1296 (depth = 4)
  int op_slot_right_1290 = gc_frame_newslot(sum1296);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_left_1290 = gc_frame_newslot(*var_n);
  params[0] = sum1296;
  partcv[0] = 1;
  Object opresult1298 = callmethod(*var_n, "==(1)", 1, partcv, params);
// compiled op node returning opresult1298 (depth = 3)
  Object if1289 = done;
  if (istrue(opresult1298)) {
// Begin line 931
  setline(931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1299 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call1300 = callmethodflags(self, "addLast(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1299);
// compiled call node returning call1300 (depth = 3)
    gc_frame_newslot(call1300);
    if1289 = call1300;
  } else {
// Begin line 933
  setline(933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1301 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1302 = callmethodflags(self, "boundsCheck(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1301);
// compiled call node returning call1302 (depth = 3)
// Begin line 934
  setline(934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1303 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1305 = alloc_Float64(1);
// compiled num node returning num1305 (depth = 5)
  int op_slot_right_1304 = gc_frame_newslot(num1305);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  int op_slot_left_1304 = gc_frame_newslot(*var_n);
  params[0] = num1305;
  partcv[0] = 1;
  Object diff1307 = callmethod(*var_n, "-(1)", 1, partcv, params);
// compiled op node returning diff1307 (depth = 4)
  gc_frame_newslot(diff1307);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  gc_frame_newslot(*var_x);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1308 = gc_frame_new();
// call case 4: self request
  Object call1309 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1308);
// compiled member node returning call1309 (depth = 4)
  params[0] = diff1307;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1310 = callmethodflags(call1309, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1303);
// compiled call node returning call1310 (depth = 3)
    gc_frame_newslot(call1310);
    if1289 = call1310;
  }
// compiled if node returning if1289 (depth = 2)
// Begin line 936
  setline(936);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_add_40_1_41_1311(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "add(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method add(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for add(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part add(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 939
  setline(939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1312 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1314 = alloc_Float64(1);
// compiled num node returning num1314 (depth = 4)
  int op_slot_right_1313 = gc_frame_newslot(num1314);
// starting to compile member node (depth = 4)
  int callframe1316 = gc_frame_new();
// call case 4: self request
  Object call1317 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1316);
// compiled member node returning call1317 (depth = 4)
  int op_slot_left_1313 = gc_frame_newslot(call1317);
  params[0] = num1314;
  partcv[0] = 1;
  Object sum1318 = callmethod(call1317, "+(1)", 1, partcv, params);
// compiled op node returning sum1318 (depth = 3)
  gc_frame_newslot(sum1318);
// call case 4: self request
  params[0] = sum1318;
  partcv[0] = 1;
  Object call1319 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1312);
// compiled call node returning call1319 (depth = 2)
// Begin line 940
  setline(940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1322 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1323 = gc_frame_new();
// call case 4: self request
  Object call1324 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1323);
// compiled member node returning call1324 (depth = 5)
  Object call1325 = callmethodflags(call1324, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1322);
// compiled member node returning call1325 (depth = 4)
  int op_slot_right_1321 = gc_frame_newslot(call1325);
// starting to compile member node (depth = 4)
  int callframe1327 = gc_frame_new();
// call case 4: self request
  Object call1328 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1327);
// compiled member node returning call1328 (depth = 4)
  int op_slot_left_1321 = gc_frame_newslot(call1328);
  params[0] = call1325;
  partcv[0] = 1;
  Object opresult1329 = callmethod(call1328, "==(1)", 1, partcv, params);
// compiled op node returning opresult1329 (depth = 3)
  Object if1320 = done;
  if (istrue(opresult1329)) {
// starting to compile call node (depth = 3)
  int callframe1330 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1332 = alloc_Float64(2);
// compiled num node returning num1332 (depth = 5)
  int op_slot_right_1331 = gc_frame_newslot(num1332);
// starting to compile member node (depth = 5)
  int callframe1334 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1335 = gc_frame_new();
// call case 4: self request
  Object call1336 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1335);
// compiled member node returning call1336 (depth = 6)
  Object call1337 = callmethodflags(call1336, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1334);
// compiled member node returning call1337 (depth = 5)
  int op_slot_left_1331 = gc_frame_newslot(call1337);
  params[0] = num1332;
  partcv[0] = 1;
  Object prod1338 = callmethod(call1337, "*(1)", 1, partcv, params);
// compiled op node returning prod1338 (depth = 4)
  gc_frame_newslot(prod1338);
// call case 4: self request
  params[0] = prod1338;
  partcv[0] = 1;
  Object call1339 = callmethodflags(self, "expandTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1330);
// compiled call node returning call1339 (depth = 3)
    gc_frame_newslot(call1339);
    if1320 = call1339;
  } else {
  }
// compiled if node returning if1320 (depth = 2)
// Begin line 941
  setline(941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1340 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe1341 = gc_frame_new();
// call case 4: self request
  Object call1342 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1341);
// compiled member node returning call1342 (depth = 3)
  gc_frame_newslot(call1342);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_x (depth = 3)
  gc_frame_newslot(*var_x);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe1343 = gc_frame_new();
// call case 4: self request
  Object call1344 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1343);
// compiled member node returning call1344 (depth = 3)
  params[0] = call1342;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1345 = callmethodflags(call1344, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1340);
// compiled call node returning call1345 (depth = 2)
// Begin line 942
  setline(942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1346 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1348 = alloc_Float64(1);
// compiled num node returning num1348 (depth = 4)
  int op_slot_right_1347 = gc_frame_newslot(num1348);
// starting to compile member node (depth = 4)
  int callframe1350 = gc_frame_new();
// call case 4: self request
  Object call1351 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1350);
// compiled member node returning call1351 (depth = 4)
  int op_slot_left_1347 = gc_frame_newslot(call1351);
  params[0] = num1348;
  partcv[0] = 1;
  Object sum1352 = callmethod(call1351, "+(1)", 1, partcv, params);
// compiled op node returning sum1352 (depth = 3)
  gc_frame_newslot(sum1352);
// call case 4: self request
  params[0] = sum1352;
  partcv[0] = 1;
  Object call1353 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1346);
// compiled call node returning call1353 (depth = 2)
// Begin line 943
  setline(943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply_40_1_41_1401(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 951
  setline(951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1402 = gc_frame_new();
// starting to compile member node (depth = 5)
  int callframe1403 = gc_frame_new();
// call case 4: self request
  Object call1404 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1403);
// compiled member node returning call1404 (depth = 5)
  gc_frame_newslot(call1404);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1405 = gc_frame_new();
// call case 4: self request
  Object call1406 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1405);
// compiled member node returning call1406 (depth = 5)
  params[0] = call1404;
  params[1] = *var_each;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1407 = callmethodflags(call1406, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1402);
// compiled call node returning call1407 (depth = 4)
// Begin line 952
  setline(952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1408 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1410 = alloc_Float64(1);
// compiled num node returning num1410 (depth = 6)
  int op_slot_right_1409 = gc_frame_newslot(num1410);
// starting to compile member node (depth = 6)
  int callframe1412 = gc_frame_new();
// call case 4: self request
  Object call1413 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1412);
// compiled member node returning call1413 (depth = 6)
  int op_slot_left_1409 = gc_frame_newslot(call1413);
  params[0] = num1410;
  partcv[0] = 1;
  Object sum1414 = callmethod(call1413, "+(1)", 1, partcv, params);
// compiled op node returning sum1414 (depth = 5)
  gc_frame_newslot(sum1414);
// call case 4: self request
  params[0] = sum1414;
  partcv[0] = 1;
  Object call1415 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1408);
// compiled call node returning call1415 (depth = 4)
  gc_frame_end(frame);
  return call1415;
}
Object meth_collectionsPrelude_addAll_40_1_41_1354(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addAll(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addAll(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 946
  setline(946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1355 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1357 = alloc_Float64(1);
// compiled num node returning num1357 (depth = 4)
  int op_slot_right_1356 = gc_frame_newslot(num1357);
// starting to compile member node (depth = 4)
  int callframe1359 = gc_frame_new();
// call case 4: self request
  Object call1360 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1359);
// compiled member node returning call1360 (depth = 4)
  int op_slot_left_1356 = gc_frame_newslot(call1360);
  params[0] = num1357;
  partcv[0] = 1;
  Object sum1361 = callmethod(call1360, "+(1)", 1, partcv, params);
// compiled op node returning sum1361 (depth = 3)
  gc_frame_newslot(sum1361);
// call case 4: self request
  params[0] = sum1361;
  partcv[0] = 1;
  Object call1362 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1355);
// compiled call node returning call1362 (depth = 2)
// Begin line 947
  setline(947);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1365 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1366 = gc_frame_new();
// call case 4: self request
  Object call1367 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1366);
// compiled member node returning call1367 (depth = 5)
  Object call1368 = callmethodflags(call1367, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1365);
// compiled member node returning call1368 (depth = 4)
  int op_slot_right_1364 = gc_frame_newslot(call1368);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1371 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_l (depth = 6)
  Object call1372 = callmethodflags(*var_l, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1371);
// compiled member node returning call1372 (depth = 5)
  int op_slot_right_1370 = gc_frame_newslot(call1372);
// starting to compile member node (depth = 5)
  int callframe1374 = gc_frame_new();
// call case 4: self request
  Object call1375 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1374);
// compiled member node returning call1375 (depth = 5)
  int op_slot_left_1370 = gc_frame_newslot(call1375);
  params[0] = call1372;
  partcv[0] = 1;
  Object sum1376 = callmethod(call1375, "+(1)", 1, partcv, params);
// compiled op node returning sum1376 (depth = 4)
  int op_slot_left_1364 = gc_frame_newslot(sum1376);
  params[0] = call1368;
  partcv[0] = 1;
  Object opresult1377 = callmethod(sum1376, ">(1)", 1, partcv, params);
// compiled op node returning opresult1377 (depth = 3)
  Object if1363 = done;
  if (istrue(opresult1377)) {
// Begin line 948
  setline(948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1378 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1379 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1381 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_l (depth = 7)
  Object call1382 = callmethodflags(*var_l, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1381);
// compiled member node returning call1382 (depth = 6)
  int op_slot_right_1380 = gc_frame_newslot(call1382);
// starting to compile member node (depth = 6)
  int callframe1384 = gc_frame_new();
// call case 4: self request
  Object call1385 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1384);
// compiled member node returning call1385 (depth = 6)
  int op_slot_left_1380 = gc_frame_newslot(call1385);
  params[0] = call1382;
  partcv[0] = 1;
  Object sum1386 = callmethod(call1385, "+(1)", 1, partcv, params);
// compiled op node returning sum1386 (depth = 5)
  gc_frame_newslot(sum1386);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1388 = alloc_Float64(2);
// compiled num node returning num1388 (depth = 6)
  int op_slot_right_1387 = gc_frame_newslot(num1388);
// starting to compile member node (depth = 6)
  int callframe1390 = gc_frame_new();
// call case 4: self request
  Object call1391 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1390);
// compiled member node returning call1391 (depth = 6)
  int op_slot_left_1387 = gc_frame_newslot(call1391);
  params[0] = num1388;
  partcv[0] = 1;
  Object prod1392 = callmethod(call1391, "*(1)", 1, partcv, params);
// compiled op node returning prod1392 (depth = 5)
  gc_frame_newslot(prod1392);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1393 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1394 = gc_frame_new();
// call case 3: self.outer request
  Object call1395 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1394);
// compiled member node returning call1395 (depth = 6)
  Object call1396 = callmethodflags(call1395, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe1393);
// compiled member node returning call1396 (depth = 5)
  params[0] = sum1386;
  params[1] = prod1392;
  partcv[0] = 2;
  Object call1397 = callmethodflags(call1396, "max(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1379);
// compiled call node returning call1397 (depth = 4)
  gc_frame_newslot(call1397);
// call case 4: self request
  params[0] = call1397;
  partcv[0] = 1;
  Object call1398 = callmethodflags(self, "expandTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1378);
// compiled call node returning call1398 (depth = 3)
    gc_frame_newslot(call1398);
    if1363 = call1398;
  } else {
  }
// compiled if node returning if1363 (depth = 2)
// Begin line 950
  setline(950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1399 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  gc_frame_newslot(*var_l);
// starting to compile block node (depth = 3)
  Object block1400 = alloc_Block(NULL, NULL, "collectionsPrelude", 950);
  gc_frame_newslot(block1400);
// method "_apply(_)"
  block_savedest(block1400);
  Object closure1401 = createclosure(1, "_apply(1)");
  setclosureframe(closure1401, stackframe);
  addtoclosure(closure1401, selfslot);
  struct UserObject *uo1401 = (struct UserObject*)block1400;
  uo1401->data[0] = (Object)closure1401;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_1401 = addmethod2pos(block1400, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_1401, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_1401[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_1401->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_1401);
  meth_meth_collectionsPrelude__apply_40_1_41_1401->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_1401->definitionLine = 1963;
// compiled block node returning block1400 (depth = 3)
  gc_frame_newslot(block1400);
// call case 5: prelude request
  params[0] = *var_l;
  params[1] = block1400;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1417 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1399);
// compiled call node returning call1417 (depth = 2)
// Begin line 954
  setline(954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_push_40_1_41_1418(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "push(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method push(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for push(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part push(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 957
  setline(957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1419 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1421 = alloc_Float64(1);
// compiled num node returning num1421 (depth = 4)
  int op_slot_right_1420 = gc_frame_newslot(num1421);
// starting to compile member node (depth = 4)
  int callframe1423 = gc_frame_new();
// call case 4: self request
  Object call1424 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1423);
// compiled member node returning call1424 (depth = 4)
  int op_slot_left_1420 = gc_frame_newslot(call1424);
  params[0] = num1421;
  partcv[0] = 1;
  Object sum1425 = callmethod(call1424, "+(1)", 1, partcv, params);
// compiled op node returning sum1425 (depth = 3)
  gc_frame_newslot(sum1425);
// call case 4: self request
  params[0] = sum1425;
  partcv[0] = 1;
  Object call1426 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1419);
// compiled call node returning call1426 (depth = 2)
// Begin line 958
  setline(958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1429 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1430 = gc_frame_new();
// call case 4: self request
  Object call1431 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1430);
// compiled member node returning call1431 (depth = 5)
  Object call1432 = callmethodflags(call1431, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1429);
// compiled member node returning call1432 (depth = 4)
  int op_slot_right_1428 = gc_frame_newslot(call1432);
// starting to compile member node (depth = 4)
  int callframe1434 = gc_frame_new();
// call case 4: self request
  Object call1435 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1434);
// compiled member node returning call1435 (depth = 4)
  int op_slot_left_1428 = gc_frame_newslot(call1435);
  params[0] = call1432;
  partcv[0] = 1;
  Object opresult1436 = callmethod(call1435, "==(1)", 1, partcv, params);
// compiled op node returning opresult1436 (depth = 3)
  Object if1427 = done;
  if (istrue(opresult1436)) {
// starting to compile call node (depth = 3)
  int callframe1437 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1439 = alloc_Float64(2);
// compiled num node returning num1439 (depth = 5)
  int op_slot_right_1438 = gc_frame_newslot(num1439);
// starting to compile member node (depth = 5)
  int callframe1441 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1442 = gc_frame_new();
// call case 4: self request
  Object call1443 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1442);
// compiled member node returning call1443 (depth = 6)
  Object call1444 = callmethodflags(call1443, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1441);
// compiled member node returning call1444 (depth = 5)
  int op_slot_left_1438 = gc_frame_newslot(call1444);
  params[0] = num1439;
  partcv[0] = 1;
  Object prod1445 = callmethod(call1444, "*(1)", 1, partcv, params);
// compiled op node returning prod1445 (depth = 4)
  gc_frame_newslot(prod1445);
// call case 4: self request
  params[0] = prod1445;
  partcv[0] = 1;
  Object call1446 = callmethodflags(self, "expandTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1437);
// compiled call node returning call1446 (depth = 3)
    gc_frame_newslot(call1446);
    if1427 = call1446;
  } else {
  }
// compiled if node returning if1427 (depth = 2)
// Begin line 959
  setline(959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1447 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe1448 = gc_frame_new();
// call case 4: self request
  Object call1449 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1448);
// compiled member node returning call1449 (depth = 3)
  gc_frame_newslot(call1449);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_x (depth = 3)
  gc_frame_newslot(*var_x);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe1450 = gc_frame_new();
// call case 4: self request
  Object call1451 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1450);
// compiled member node returning call1451 (depth = 3)
  params[0] = call1449;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1452 = callmethodflags(call1451, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1447);
// compiled call node returning call1452 (depth = 2)
// Begin line 960
  setline(960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1453 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1455 = alloc_Float64(1);
// compiled num node returning num1455 (depth = 4)
  int op_slot_right_1454 = gc_frame_newslot(num1455);
// starting to compile member node (depth = 4)
  int callframe1457 = gc_frame_new();
// call case 4: self request
  Object call1458 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1457);
// compiled member node returning call1458 (depth = 4)
  int op_slot_left_1454 = gc_frame_newslot(call1458);
  params[0] = num1455;
  partcv[0] = 1;
  Object sum1459 = callmethod(call1458, "+(1)", 1, partcv, params);
// compiled op node returning sum1459 (depth = 3)
  gc_frame_newslot(sum1459);
// call case 4: self request
  params[0] = sum1459;
  partcv[0] = 1;
  Object call1460 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1453);
// compiled call node returning call1460 (depth = 2)
// Begin line 961
  setline(961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_addLast_40_1_41_1461(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addLast(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addLast(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addLast(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addLast(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 963
  setline(963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1462 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_x (depth = 3)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call1463 = callmethodflags(self, "push(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1462);
// compiled call node returning call1463 (depth = 2)
  gc_frame_end(frame);
  return call1463;
}
Object meth_collectionsPrelude_removeLast1464(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeLast");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 965
  setline(965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1465 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1467 = alloc_Float64(1);
// compiled num node returning num1467 (depth = 4)
  int op_slot_right_1466 = gc_frame_newslot(num1467);
// starting to compile member node (depth = 4)
  int callframe1469 = gc_frame_new();
// call case 4: self request
  Object call1470 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1469);
// compiled member node returning call1470 (depth = 4)
  int op_slot_left_1466 = gc_frame_newslot(call1470);
  params[0] = num1467;
  partcv[0] = 1;
  Object sum1471 = callmethod(call1470, "+(1)", 1, partcv, params);
// compiled op node returning sum1471 (depth = 3)
  gc_frame_newslot(sum1471);
// call case 4: self request
  params[0] = sum1471;
  partcv[0] = 1;
  Object call1472 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1465);
// compiled call node returning call1472 (depth = 2)
// Begin line 966
  setline(966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1473 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1475 = alloc_Float64(1);
// compiled num node returning num1475 (depth = 5)
  int op_slot_right_1474 = gc_frame_newslot(num1475);
// starting to compile member node (depth = 5)
  int callframe1477 = gc_frame_new();
// call case 4: self request
  Object call1478 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1477);
// compiled member node returning call1478 (depth = 5)
  int op_slot_left_1474 = gc_frame_newslot(call1478);
  params[0] = num1475;
  partcv[0] = 1;
  Object diff1479 = callmethod(call1478, "-(1)", 1, partcv, params);
// compiled op node returning diff1479 (depth = 4)
  gc_frame_newslot(diff1479);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1480 = gc_frame_new();
// call case 4: self request
  Object call1481 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1480);
// compiled member node returning call1481 (depth = 4)
  params[0] = diff1479;
  partcv[0] = 1;
  Object call1482 = callmethodflags(call1481, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1473);
// compiled call node returning call1482 (depth = 3)
  *var_result = call1482;
  if (call1482 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 967
  setline(967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1483 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1485 = alloc_Float64(1);
// compiled num node returning num1485 (depth = 4)
  int op_slot_right_1484 = gc_frame_newslot(num1485);
// starting to compile member node (depth = 4)
  int callframe1487 = gc_frame_new();
// call case 4: self request
  Object call1488 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1487);
// compiled member node returning call1488 (depth = 4)
  int op_slot_left_1484 = gc_frame_newslot(call1488);
  params[0] = num1485;
  partcv[0] = 1;
  Object diff1489 = callmethod(call1488, "-(1)", 1, partcv, params);
// compiled op node returning diff1489 (depth = 3)
  gc_frame_newslot(diff1489);
// call case 4: self request
  params[0] = diff1489;
  partcv[0] = 1;
  Object call1490 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1483);
// compiled call node returning call1490 (depth = 2)
// Begin line 968
  setline(968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude__apply_40_1_41_1551(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_increase = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 977
  setline(977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1552 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_increase (depth = 6)
  int op_slot_right_1553 = gc_frame_newslot(*var_increase);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1553 = gc_frame_newslot(*var_i);
  params[0] = *var_increase;
  partcv[0] = 1;
  Object sum1555 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum1555 (depth = 5)
  gc_frame_newslot(sum1555);
// starting to compile call node (depth = 5)
  int callframe1556 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1557 = gc_frame_new();
// call case 4: self request
  Object call1558 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1557);
// compiled member node returning call1558 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1559 = callmethodflags(call1558, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1556);
// compiled call node returning call1559 (depth = 5)
  gc_frame_newslot(call1559);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1560 = gc_frame_new();
// call case 4: self request
  Object call1561 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1560);
// compiled member node returning call1561 (depth = 5)
  params[0] = sum1555;
  params[1] = call1559;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1562 = callmethodflags(call1561, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1552);
// compiled call node returning call1562 (depth = 4)
  gc_frame_end(frame);
  return call1562;
}
Object meth_collectionsPrelude__apply_40_1_41_1568(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_insertionIndex = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 981
  setline(981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1569 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_insertionIndex (depth = 5)
  gc_frame_newslot(*var_insertionIndex);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1570 = gc_frame_new();
// call case 4: self request
  Object call1571 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1570);
// compiled member node returning call1571 (depth = 5)
  params[0] = *var_insertionIndex;
  params[1] = *var_each;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1572 = callmethodflags(call1571, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1569);
// compiled call node returning call1572 (depth = 4)
// Begin line 982
  setline(982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1574 = alloc_Float64(1);
// compiled num node returning num1574 (depth = 6)
  int op_slot_right_1573 = gc_frame_newslot(num1574);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_insertionIndex (depth = 6)
  int op_slot_left_1573 = gc_frame_newslot(*var_insertionIndex);
  params[0] = num1574;
  partcv[0] = 1;
  Object sum1576 = callmethod(*var_insertionIndex, "+(1)", 1, partcv, params);
// compiled op node returning sum1576 (depth = 5)
  *var_insertionIndex = sum1576;
  if (sum1576 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_addAllFirst_40_1_41_1491(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addAllFirst(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addAllFirst(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addAllFirst(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addAllFirst(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_increase = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "increase");
  Object *var_insertionIndex = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "insertionIndex");
// Begin line 971
  setline(971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1492 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1494 = alloc_Float64(1);
// compiled num node returning num1494 (depth = 4)
  int op_slot_right_1493 = gc_frame_newslot(num1494);
// starting to compile member node (depth = 4)
  int callframe1496 = gc_frame_new();
// call case 4: self request
  Object call1497 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1496);
// compiled member node returning call1497 (depth = 4)
  int op_slot_left_1493 = gc_frame_newslot(call1497);
  params[0] = num1494;
  partcv[0] = 1;
  Object sum1498 = callmethod(call1497, "+(1)", 1, partcv, params);
// compiled op node returning sum1498 (depth = 3)
  gc_frame_newslot(sum1498);
// call case 4: self request
  params[0] = sum1498;
  partcv[0] = 1;
  Object call1499 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1492);
// compiled call node returning call1499 (depth = 2)
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe1500 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_l (depth = 4)
  Object call1501 = callmethodflags(*var_l, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1500);
// compiled member node returning call1501 (depth = 3)
  *var_increase = call1501;
  if (call1501 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 973
  setline(973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1504 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1505 = gc_frame_new();
// call case 4: self request
  Object call1506 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1505);
// compiled member node returning call1506 (depth = 5)
  Object call1507 = callmethodflags(call1506, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1504);
// compiled member node returning call1507 (depth = 4)
  int op_slot_right_1503 = gc_frame_newslot(call1507);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_increase (depth = 5)
  int op_slot_right_1509 = gc_frame_newslot(*var_increase);
// starting to compile member node (depth = 5)
  int callframe1511 = gc_frame_new();
// call case 4: self request
  Object call1512 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1511);
// compiled member node returning call1512 (depth = 5)
  int op_slot_left_1509 = gc_frame_newslot(call1512);
  params[0] = *var_increase;
  partcv[0] = 1;
  Object sum1513 = callmethod(call1512, "+(1)", 1, partcv, params);
// compiled op node returning sum1513 (depth = 4)
  int op_slot_left_1503 = gc_frame_newslot(sum1513);
  params[0] = call1507;
  partcv[0] = 1;
  Object opresult1514 = callmethod(sum1513, ">(1)", 1, partcv, params);
// compiled op node returning opresult1514 (depth = 3)
  Object if1502 = done;
  if (istrue(opresult1514)) {
// Begin line 974
  setline(974);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1515 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1516 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_increase (depth = 6)
  int op_slot_right_1517 = gc_frame_newslot(*var_increase);
// starting to compile member node (depth = 6)
  int callframe1519 = gc_frame_new();
// call case 4: self request
  Object call1520 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1519);
// compiled member node returning call1520 (depth = 6)
  int op_slot_left_1517 = gc_frame_newslot(call1520);
  params[0] = *var_increase;
  partcv[0] = 1;
  Object sum1521 = callmethod(call1520, "+(1)", 1, partcv, params);
// compiled op node returning sum1521 (depth = 5)
  gc_frame_newslot(sum1521);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1523 = alloc_Float64(2);
// compiled num node returning num1523 (depth = 6)
  int op_slot_right_1522 = gc_frame_newslot(num1523);
// starting to compile member node (depth = 6)
  int callframe1525 = gc_frame_new();
// call case 4: self request
  Object call1526 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1525);
// compiled member node returning call1526 (depth = 6)
  int op_slot_left_1522 = gc_frame_newslot(call1526);
  params[0] = num1523;
  partcv[0] = 1;
  Object prod1527 = callmethod(call1526, "*(1)", 1, partcv, params);
// compiled op node returning prod1527 (depth = 5)
  gc_frame_newslot(prod1527);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1528 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1529 = gc_frame_new();
// call case 3: self.outer request
  Object call1530 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1529);
// compiled member node returning call1530 (depth = 6)
  Object call1531 = callmethodflags(call1530, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe1528);
// compiled member node returning call1531 (depth = 5)
  params[0] = sum1521;
  params[1] = prod1527;
  partcv[0] = 2;
  Object call1532 = callmethodflags(call1531, "max(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1516);
// compiled call node returning call1532 (depth = 4)
  gc_frame_newslot(call1532);
// call case 4: self request
  params[0] = call1532;
  partcv[0] = 1;
  Object call1533 = callmethodflags(self, "expandTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1515);
// compiled call node returning call1533 (depth = 3)
    gc_frame_newslot(call1533);
    if1502 = call1533;
  } else {
  }
// compiled if node returning if1502 (depth = 2)
// Begin line 976
  setline(976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1534 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe1535 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1537 = alloc_Float64(1);
// compiled num node returning num1537 (depth = 5)
  int op_slot_right_1536 = gc_frame_newslot(num1537);
// starting to compile member node (depth = 5)
  int callframe1539 = gc_frame_new();
// call case 4: self request
  Object call1540 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1539);
// compiled member node returning call1540 (depth = 5)
  int op_slot_left_1536 = gc_frame_newslot(call1540);
  params[0] = num1537;
  partcv[0] = 1;
  Object diff1541 = callmethod(call1540, "-(1)", 1, partcv, params);
// compiled op node returning diff1541 (depth = 4)
  gc_frame_newslot(diff1541);
// starting to compile num node (depth = 4)
  Object num1542 = alloc_Float64(0);
// compiled num node returning num1542 (depth = 4)
  gc_frame_newslot(num1542);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1543 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1544 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1545 = gc_frame_new();
// call case 3: self.outer request
  Object call1546 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1545);
// compiled member node returning call1546 (depth = 6)
  Object call1547 = callmethodflags(call1546, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe1544);
// compiled member node returning call1547 (depth = 5)
  Object call1548 = callmethodflags(call1547, "range", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1543);
// compiled member node returning call1548 (depth = 4)
  params[0] = diff1541;
  params[1] = num1542;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1549 = callmethodflags(call1548, "from(1)downTo(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1535);
// compiled call node returning call1549 (depth = 3)
  gc_frame_newslot(call1549);
// starting to compile block node (depth = 3)
  Object block1550 = alloc_Block(NULL, NULL, "collectionsPrelude", 976);
  gc_frame_newslot(block1550);
// method "_apply(_)"
  block_savedest(block1550);
  Object closure1551 = createclosure(2, "_apply(1)");
  setclosureframe(closure1551, stackframe);
  addtoclosure(closure1551, var_increase);
  addtoclosure(closure1551, selfslot);
  struct UserObject *uo1551 = (struct UserObject*)block1550;
  uo1551->data[0] = (Object)closure1551;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_1551 = addmethod2pos(block1550, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_1551, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_1551[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_1551->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_1551);
  meth_meth_collectionsPrelude__apply_40_1_41_1551->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_1551->definitionLine = 1963;
// compiled block node returning block1550 (depth = 3)
  gc_frame_newslot(block1550);
// call case 5: prelude request
  params[0] = call1549;
  params[1] = block1550;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1564 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1534);
// compiled call node returning call1564 (depth = 2)
// Begin line 979
  setline(979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num1565 = alloc_Float64(0);
// compiled num node returning num1565 (depth = 3)
  *var_insertionIndex = num1565;
  if (num1565 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 980
  setline(980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1566 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  gc_frame_newslot(*var_l);
// starting to compile block node (depth = 3)
  Object block1567 = alloc_Block(NULL, NULL, "collectionsPrelude", 980);
  gc_frame_newslot(block1567);
// method "_apply(_)"
  block_savedest(block1567);
  Object closure1568 = createclosure(2, "_apply(1)");
  setclosureframe(closure1568, stackframe);
  addtoclosure(closure1568, var_insertionIndex);
  addtoclosure(closure1568, selfslot);
  struct UserObject *uo1568 = (struct UserObject*)block1567;
  uo1568->data[0] = (Object)closure1568;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_1568 = addmethod2pos(block1567, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_1568, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_1568[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_1568->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_1568);
  meth_meth_collectionsPrelude__apply_40_1_41_1568->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_1568->definitionLine = 1963;
// compiled block node returning block1567 (depth = 3)
  gc_frame_newslot(block1567);
// call case 5: prelude request
  params[0] = *var_l;
  params[1] = block1567;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1579 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1566);
// compiled call node returning call1579 (depth = 2)
// Begin line 984
  setline(984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1580 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_increase (depth = 4)
  int op_slot_right_1581 = gc_frame_newslot(*var_increase);
// starting to compile member node (depth = 4)
  int callframe1583 = gc_frame_new();
// call case 4: self request
  Object call1584 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1583);
// compiled member node returning call1584 (depth = 4)
  int op_slot_left_1581 = gc_frame_newslot(call1584);
  params[0] = *var_increase;
  partcv[0] = 1;
  Object sum1585 = callmethod(call1584, "+(1)", 1, partcv, params);
// compiled op node returning sum1585 (depth = 3)
  gc_frame_newslot(sum1585);
// call case 4: self request
  params[0] = sum1585;
  partcv[0] = 1;
  Object call1586 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1580);
// compiled call node returning call1586 (depth = 2)
// Begin line 985
  setline(985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply_40_1_41_1635(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 993
  setline(993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1636 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1638 = alloc_Float64(1);
// compiled num node returning num1638 (depth = 6)
  int op_slot_right_1637 = gc_frame_newslot(num1638);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1637 = gc_frame_newslot(*var_i);
  params[0] = num1638;
  partcv[0] = 1;
  Object sum1640 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum1640 (depth = 5)
  gc_frame_newslot(sum1640);
// starting to compile call node (depth = 5)
  int callframe1641 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1642 = gc_frame_new();
// call case 4: self request
  Object call1643 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1642);
// compiled member node returning call1643 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1644 = callmethodflags(call1643, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1641);
// compiled call node returning call1644 (depth = 5)
  gc_frame_newslot(call1644);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1645 = gc_frame_new();
// call case 4: self request
  Object call1646 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1645);
// compiled member node returning call1646 (depth = 5)
  params[0] = sum1640;
  params[1] = call1644;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1647 = callmethodflags(call1646, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1636);
// compiled call node returning call1647 (depth = 4)
  gc_frame_end(frame);
  return call1647;
}
Object meth_collectionsPrelude_addFirst_40_1_41_1587(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addFirst(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addFirst(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addFirst(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addFirst(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 988
  setline(988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1588 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1590 = alloc_Float64(1);
// compiled num node returning num1590 (depth = 4)
  int op_slot_right_1589 = gc_frame_newslot(num1590);
// starting to compile member node (depth = 4)
  int callframe1592 = gc_frame_new();
// call case 4: self request
  Object call1593 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1592);
// compiled member node returning call1593 (depth = 4)
  int op_slot_left_1589 = gc_frame_newslot(call1593);
  params[0] = num1590;
  partcv[0] = 1;
  Object sum1594 = callmethod(call1593, "+(1)", 1, partcv, params);
// compiled op node returning sum1594 (depth = 3)
  gc_frame_newslot(sum1594);
// call case 4: self request
  params[0] = sum1594;
  partcv[0] = 1;
  Object call1595 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1588);
// compiled call node returning call1595 (depth = 2)
// Begin line 989
  setline(989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1598 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1599 = gc_frame_new();
// call case 4: self request
  Object call1600 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1599);
// compiled member node returning call1600 (depth = 5)
  Object call1601 = callmethodflags(call1600, "size", 0, partcv, params, 0);
  gc_frame_end(callframe1598);
// compiled member node returning call1601 (depth = 4)
  int op_slot_right_1597 = gc_frame_newslot(call1601);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1604 = alloc_Float64(1);
// compiled num node returning num1604 (depth = 5)
  int op_slot_right_1603 = gc_frame_newslot(num1604);
// starting to compile member node (depth = 5)
  int callframe1606 = gc_frame_new();
// call case 4: self request
  Object call1607 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1606);
// compiled member node returning call1607 (depth = 5)
  int op_slot_left_1603 = gc_frame_newslot(call1607);
  params[0] = num1604;
  partcv[0] = 1;
  Object sum1608 = callmethod(call1607, "+(1)", 1, partcv, params);
// compiled op node returning sum1608 (depth = 4)
  int op_slot_left_1597 = gc_frame_newslot(sum1608);
  params[0] = call1601;
  partcv[0] = 1;
  Object opresult1609 = callmethod(sum1608, ">(1)", 1, partcv, params);
// compiled op node returning opresult1609 (depth = 3)
  Object if1596 = done;
  if (istrue(opresult1609)) {
// Begin line 990
  setline(990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1610 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1612 = alloc_Float64(2);
// compiled num node returning num1612 (depth = 5)
  int op_slot_right_1611 = gc_frame_newslot(num1612);
// starting to compile member node (depth = 5)
  int callframe1614 = gc_frame_new();
// call case 4: self request
  Object call1615 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1614);
// compiled member node returning call1615 (depth = 5)
  int op_slot_left_1611 = gc_frame_newslot(call1615);
  params[0] = num1612;
  partcv[0] = 1;
  Object prod1616 = callmethod(call1615, "*(1)", 1, partcv, params);
// compiled op node returning prod1616 (depth = 4)
  gc_frame_newslot(prod1616);
// call case 4: self request
  params[0] = prod1616;
  partcv[0] = 1;
  Object call1617 = callmethodflags(self, "expandTo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1610);
// compiled call node returning call1617 (depth = 3)
    gc_frame_newslot(call1617);
    if1596 = call1617;
  } else {
  }
// compiled if node returning if1596 (depth = 2)
// Begin line 992
  setline(992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1618 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe1619 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1621 = alloc_Float64(1);
// compiled num node returning num1621 (depth = 5)
  int op_slot_right_1620 = gc_frame_newslot(num1621);
// starting to compile member node (depth = 5)
  int callframe1623 = gc_frame_new();
// call case 4: self request
  Object call1624 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1623);
// compiled member node returning call1624 (depth = 5)
  int op_slot_left_1620 = gc_frame_newslot(call1624);
  params[0] = num1621;
  partcv[0] = 1;
  Object diff1625 = callmethod(call1624, "-(1)", 1, partcv, params);
// compiled op node returning diff1625 (depth = 4)
  gc_frame_newslot(diff1625);
// starting to compile num node (depth = 4)
  Object num1626 = alloc_Float64(0);
// compiled num node returning num1626 (depth = 4)
  gc_frame_newslot(num1626);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1627 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1628 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1629 = gc_frame_new();
// call case 3: self.outer request
  Object call1630 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1629);
// compiled member node returning call1630 (depth = 6)
  Object call1631 = callmethodflags(call1630, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe1628);
// compiled member node returning call1631 (depth = 5)
  Object call1632 = callmethodflags(call1631, "range", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1627);
// compiled member node returning call1632 (depth = 4)
  params[0] = diff1625;
  params[1] = num1626;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1633 = callmethodflags(call1632, "from(1)downTo(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1619);
// compiled call node returning call1633 (depth = 3)
  gc_frame_newslot(call1633);
// starting to compile block node (depth = 3)
  Object block1634 = alloc_Block(NULL, NULL, "collectionsPrelude", 992);
  gc_frame_newslot(block1634);
// method "_apply(_)"
  block_savedest(block1634);
  Object closure1635 = createclosure(1, "_apply(1)");
  setclosureframe(closure1635, stackframe);
  addtoclosure(closure1635, selfslot);
  struct UserObject *uo1635 = (struct UserObject*)block1634;
  uo1635->data[0] = (Object)closure1635;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_1635 = addmethod2pos(block1634, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_1635, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_1635[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_1635->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_1635);
  meth_meth_collectionsPrelude__apply_40_1_41_1635->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_1635->definitionLine = 1963;
// compiled block node returning block1634 (depth = 3)
  gc_frame_newslot(block1634);
// call case 5: prelude request
  params[0] = call1633;
  params[1] = block1634;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1649 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1618);
// compiled call node returning call1649 (depth = 2)
// Begin line 995
  setline(995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1650 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num1651 = alloc_Float64(0);
// compiled num node returning num1651 (depth = 3)
  gc_frame_newslot(num1651);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elt (depth = 3)
  gc_frame_newslot(*var_elt);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe1652 = gc_frame_new();
// call case 4: self request
  Object call1653 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1652);
// compiled member node returning call1653 (depth = 3)
  params[0] = num1651;
  params[1] = *var_elt;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1654 = callmethodflags(call1653, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1650);
// compiled call node returning call1654 (depth = 2)
// Begin line 996
  setline(996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1655 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1657 = alloc_Float64(1);
// compiled num node returning num1657 (depth = 4)
  int op_slot_right_1656 = gc_frame_newslot(num1657);
// starting to compile member node (depth = 4)
  int callframe1659 = gc_frame_new();
// call case 4: self request
  Object call1660 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1659);
// compiled member node returning call1660 (depth = 4)
  int op_slot_left_1656 = gc_frame_newslot(call1660);
  params[0] = num1657;
  partcv[0] = 1;
  Object sum1661 = callmethod(call1660, "+(1)", 1, partcv, params);
// compiled op node returning sum1661 (depth = 3)
  gc_frame_newslot(sum1661);
// call case 4: self request
  params[0] = sum1661;
  partcv[0] = 1;
  Object call1662 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1655);
// compiled call node returning call1662 (depth = 2)
// Begin line 997
  setline(997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_removeFirst1663(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeFirst");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1000
  setline(1000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1664 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num1665 = alloc_Float64(1);
// compiled num node returning num1665 (depth = 3)
  gc_frame_newslot(num1665);
// call case 4: self request
  params[0] = num1665;
  partcv[0] = 1;
  Object call1666 = callmethodflags(self, "removeAt(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1664);
// compiled call node returning call1666 (depth = 2)
  gc_frame_end(frame);
  return call1666;
}
Object meth_collectionsPrelude__apply_40_1_41_1697(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1007
  setline(1007);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1698 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1700 = alloc_Float64(1);
// compiled num node returning num1700 (depth = 6)
  int op_slot_right_1699 = gc_frame_newslot(num1700);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1699 = gc_frame_newslot(*var_i);
  params[0] = num1700;
  partcv[0] = 1;
  Object diff1702 = callmethod(*var_i, "-(1)", 1, partcv, params);
// compiled op node returning diff1702 (depth = 5)
  gc_frame_newslot(diff1702);
// starting to compile call node (depth = 5)
  int callframe1703 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1704 = gc_frame_new();
// call case 4: self request
  Object call1705 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1704);
// compiled member node returning call1705 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1706 = callmethodflags(call1705, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1703);
// compiled call node returning call1706 (depth = 5)
  gc_frame_newslot(call1706);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1707 = gc_frame_new();
// call case 4: self request
  Object call1708 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1707);
// compiled member node returning call1708 (depth = 5)
  params[0] = diff1702;
  params[1] = call1706;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1709 = callmethodflags(call1708, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1698);
// compiled call node returning call1709 (depth = 4)
  gc_frame_end(frame);
  return call1709;
}
Object meth_collectionsPrelude_removeAt_40_1_41_1667(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeAt(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAt(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeAt(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeAt(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_removed = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "removed");
// Begin line 1003
  setline(1003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1668 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1670 = alloc_Float64(1);
// compiled num node returning num1670 (depth = 4)
  int op_slot_right_1669 = gc_frame_newslot(num1670);
// starting to compile member node (depth = 4)
  int callframe1672 = gc_frame_new();
// call case 4: self request
  Object call1673 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1672);
// compiled member node returning call1673 (depth = 4)
  int op_slot_left_1669 = gc_frame_newslot(call1673);
  params[0] = num1670;
  partcv[0] = 1;
  Object sum1674 = callmethod(call1673, "+(1)", 1, partcv, params);
// compiled op node returning sum1674 (depth = 3)
  gc_frame_newslot(sum1674);
// call case 4: self request
  params[0] = sum1674;
  partcv[0] = 1;
  Object call1675 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1668);
// compiled call node returning call1675 (depth = 2)
// Begin line 1004
  setline(1004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1676 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1677 = callmethodflags(self, "boundsCheck(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1676);
// compiled call node returning call1677 (depth = 2)
// Begin line 1005
  setline(1005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1678 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1680 = alloc_Float64(1);
// compiled num node returning num1680 (depth = 5)
  int op_slot_right_1679 = gc_frame_newslot(num1680);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  int op_slot_left_1679 = gc_frame_newslot(*var_n);
  params[0] = num1680;
  partcv[0] = 1;
  Object diff1682 = callmethod(*var_n, "-(1)", 1, partcv, params);
// compiled op node returning diff1682 (depth = 4)
  gc_frame_newslot(diff1682);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1683 = gc_frame_new();
// call case 4: self request
  Object call1684 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1683);
// compiled member node returning call1684 (depth = 4)
  params[0] = diff1682;
  partcv[0] = 1;
  Object call1685 = callmethodflags(call1684, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1678);
// compiled call node returning call1685 (depth = 3)
  *var_removed = call1685;
  if (call1685 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1006
  setline(1006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1686 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1689 = alloc_Float64(1);
// compiled num node returning num1689 (depth = 5)
  int op_slot_right_1688 = gc_frame_newslot(num1689);
// starting to compile member node (depth = 5)
  int callframe1691 = gc_frame_new();
// call case 4: self request
  Object call1692 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1691);
// compiled member node returning call1692 (depth = 5)
  int op_slot_left_1688 = gc_frame_newslot(call1692);
  params[0] = num1689;
  partcv[0] = 1;
  Object diff1693 = callmethod(call1692, "-(1)", 1, partcv, params);
// compiled op node returning diff1693 (depth = 4)
  int op_slot_right_1687 = gc_frame_newslot(diff1693);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_left_1687 = gc_frame_newslot(*var_n);
  params[0] = diff1693;
  partcv[0] = 1;
  Object opresult1695 = callmethod(*var_n, "..(1)", 1, partcv, params);
// compiled op node returning opresult1695 (depth = 3)
  gc_frame_newslot(opresult1695);
// starting to compile block node (depth = 3)
  Object block1696 = alloc_Block(NULL, NULL, "collectionsPrelude", 1006);
  gc_frame_newslot(block1696);
// method "_apply(_)"
  block_savedest(block1696);
  Object closure1697 = createclosure(1, "_apply(1)");
  setclosureframe(closure1697, stackframe);
  addtoclosure(closure1697, selfslot);
  struct UserObject *uo1697 = (struct UserObject*)block1696;
  uo1697->data[0] = (Object)closure1697;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_1697 = addmethod2pos(block1696, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_1697, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_1697[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_1697->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_1697);
  meth_meth_collectionsPrelude__apply_40_1_41_1697->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_1697->definitionLine = 1963;
// compiled block node returning block1696 (depth = 3)
  gc_frame_newslot(block1696);
// call case 5: prelude request
  params[0] = opresult1695;
  params[1] = block1696;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1711 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1686);
// compiled call node returning call1711 (depth = 2)
// Begin line 1009
  setline(1009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1712 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1714 = alloc_Float64(1);
// compiled num node returning num1714 (depth = 4)
  int op_slot_right_1713 = gc_frame_newslot(num1714);
// starting to compile member node (depth = 4)
  int callframe1716 = gc_frame_new();
// call case 4: self request
  Object call1717 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1716);
// compiled member node returning call1717 (depth = 4)
  int op_slot_left_1713 = gc_frame_newslot(call1717);
  params[0] = num1714;
  partcv[0] = 1;
  Object diff1718 = callmethod(call1717, "-(1)", 1, partcv, params);
// compiled op node returning diff1718 (depth = 3)
  gc_frame_newslot(diff1718);
// call case 4: self request
  params[0] = diff1718;
  partcv[0] = 1;
  Object call1719 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1712);
// compiled call node returning call1719 (depth = 2)
// Begin line 1010
  setline(1010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_removed (depth = 3)
  return *var_removed;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply1723(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_elt = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1015
  setline(1015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1724 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1726 == NULL) {
    strlit1726 = alloc_String("");
    gc_root(strlit1726);
  }
// compiled string node returning strlit1726 (depth = 7)
  int op_slot_right_1725 = gc_frame_newslot(strlit1726);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_elt (depth = 8)
  int op_slot_right_1728 = gc_frame_newslot(*var_elt);
// starting to compile string node (depth = 8)
  if (strlit1730 == NULL) {
    strlit1730 = alloc_String("list does not contain ");
    gc_root(strlit1730);
  }
// compiled string node returning strlit1730 (depth = 8)
  int op_slot_left_1728 = gc_frame_newslot(strlit1730);
  params[0] = *var_elt;
  partcv[0] = 1;
  Object opresult1731 = callmethod(strlit1730, "++(1)", 1, partcv, params);
// compiled op node returning opresult1731 (depth = 7)
  int op_slot_left_1725 = gc_frame_newslot(opresult1731);
  params[0] = strlit1726;
  partcv[0] = 1;
  Object opresult1732 = callmethod(opresult1731, "++(1)", 1, partcv, params);
// compiled op node returning opresult1732 (depth = 6)
  gc_frame_newslot(opresult1732);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_NoSuchObject (depth = 6)
  params[0] = opresult1732;
  partcv[0] = 1;
  Object call1733 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1724);
// compiled call node returning call1733 (depth = 5)
  gc_frame_end(frame);
  return call1733;
}
Object meth_collectionsPrelude_remove_40_1_41_1720(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "remove(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove(_)");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for remove(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part remove(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
// Begin line 1014
  setline(1014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1721 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elt (depth = 4)
  gc_frame_newslot(*var_elt);
// starting to compile block node (depth = 4)
  Object block1722 = alloc_Block(NULL, NULL, "collectionsPrelude", 1014);
  gc_frame_newslot(block1722);
// method "_apply"
  block_savedest(block1722);
  Object closure1723 = createclosure(3, "_apply");
  setclosureframe(closure1723, stackframe);
  addtoclosure(closure1723, var_elt);
  addtoclosure(closure1723, var_NoSuchObject);
  addtoclosure(closure1723, selfslot);
  struct UserObject *uo1723 = (struct UserObject*)block1722;
  uo1723->data[0] = (Object)closure1723;
  Method *meth_meth_collectionsPrelude__apply1723 = addmethod2pos(block1722, "_apply", &meth_collectionsPrelude__apply1723, 0);
  int argcv_meth_collectionsPrelude__apply1723[] = {0};
  meth_meth_collectionsPrelude__apply1723->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1723);
  meth_meth_collectionsPrelude__apply1723->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1723->definitionLine = 1963;
// compiled block node returning block1722 (depth = 4)
  gc_frame_newslot(block1722);
// call case 4: self request
  params[0] = *var_elt;
  params[1] = block1722;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1735 = callmethodflags(self, "indexOf(1)ifAbsent(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1721);
// compiled call node returning call1735 (depth = 3)
  *var_ix = call1735;
  if (call1735 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1017
  setline(1017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1736 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ix (depth = 3)
  gc_frame_newslot(*var_ix);
// call case 4: self request
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call1737 = callmethodflags(self, "removeAt(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1736);
// compiled call node returning call1737 (depth = 2)
// Begin line 1018
  setline(1018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply1741(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1023
  setline(1023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1742 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_action (depth = 6)
  Object call1743 = callmethodflags(*var_action, "apply", 0, partcv, params, 0);
  gc_frame_end(callframe1742);
// compiled member node returning call1743 (depth = 5)
// Begin line 1024
  setline(1024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  block_return(realself, self);
// compiled return node returning undefined (depth = 5)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1738(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "remove(1)ifAbsent(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove(_)ifAbsent(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove(_)ifAbsent(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for remove(_)ifAbsent(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part remove(_)");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifAbsent(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ix = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "ix");
// Begin line 1022
  setline(1022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1739 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elt (depth = 4)
  gc_frame_newslot(*var_elt);
// starting to compile block node (depth = 4)
  Object block1740 = alloc_Block(NULL, NULL, "collectionsPrelude", 1022);
  gc_frame_newslot(block1740);
// method "_apply"
  block_savedest(block1740);
  Object closure1741 = createclosure(2, "_apply");
  setclosureframe(closure1741, stackframe);
  addtoclosure(closure1741, var_action);
  addtoclosure(closure1741, selfslot);
  struct UserObject *uo1741 = (struct UserObject*)block1740;
  uo1741->data[0] = (Object)closure1741;
  Method *meth_meth_collectionsPrelude__apply1741 = addmethod2pos(block1740, "_apply", &meth_collectionsPrelude__apply1741, 0);
  int argcv_meth_collectionsPrelude__apply1741[] = {0};
  meth_meth_collectionsPrelude__apply1741->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1741);
  meth_meth_collectionsPrelude__apply1741->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1741->definitionLine = 1963;
// compiled block node returning block1740 (depth = 4)
  gc_frame_newslot(block1740);
// call case 4: self request
  params[0] = *var_elt;
  params[1] = block1740;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1745 = callmethodflags(self, "indexOf(1)ifAbsent(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1739);
// compiled call node returning call1745 (depth = 3)
  *var_ix = call1745;
  if (call1745 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1026
  setline(1026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1746 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ix (depth = 3)
  gc_frame_newslot(*var_ix);
// call case 4: self request
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call1747 = callmethodflags(self, "removeAt(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1746);
// compiled call node returning call1747 (depth = 2)
// Begin line 1027
  setline(1027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply1751(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe1752 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1753 == NULL) {
    strlit1753 = alloc_String("list does not contain object");
    gc_root(strlit1753);
  }
// compiled string node returning strlit1753 (depth = 5)
  gc_frame_newslot(strlit1753);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_NoSuchObject (depth = 5)
  params[0] = strlit1753;
  partcv[0] = 1;
  Object call1754 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1752);
// compiled call node returning call1754 (depth = 4)
  gc_frame_end(frame);
  return call1754;
}
Object meth_collectionsPrelude_removeAll_40_1_41_1748(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeAll(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll(_)");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_vs = &(stackframe->slots[0]);
  *var_vs = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1031
  setline(1031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1749 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_vs (depth = 3)
  gc_frame_newslot(*var_vs);
// starting to compile block node (depth = 3)
  Object block1750 = alloc_Block(NULL, NULL, "collectionsPrelude", 1031);
  gc_frame_newslot(block1750);
// method "_apply"
  block_savedest(block1750);
  Object closure1751 = createclosure(2, "_apply");
  setclosureframe(closure1751, stackframe);
  addtoclosure(closure1751, var_NoSuchObject);
  addtoclosure(closure1751, selfslot);
  struct UserObject *uo1751 = (struct UserObject*)block1750;
  uo1751->data[0] = (Object)closure1751;
  Method *meth_meth_collectionsPrelude__apply1751 = addmethod2pos(block1750, "_apply", &meth_collectionsPrelude__apply1751, 0);
  int argcv_meth_collectionsPrelude__apply1751[] = {0};
  meth_meth_collectionsPrelude__apply1751->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1751);
  meth_meth_collectionsPrelude__apply1751->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1751->definitionLine = 1963;
// compiled block node returning block1750 (depth = 3)
  gc_frame_newslot(block1750);
// call case 4: self request
  params[0] = *var_vs;
  params[1] = block1750;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1756 = callmethodflags(self, "removeAll(1)ifAbsent(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1749);
// compiled call node returning call1756 (depth = 2)
// Begin line 1032
  setline(1032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply1763(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile num node (depth = 7)
  Object num1764 = alloc_Float64(0);
// compiled num node returning num1764 (depth = 7)
  gc_frame_end(frame);
  return num1764;
}
Object meth_collectionsPrelude__apply_40_1_41_1760(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
// Begin line 1036
  setline(1036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1761 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  gc_frame_newslot(*var_each);
// starting to compile block node (depth = 6)
  Object block1762 = alloc_Block(NULL, NULL, "collectionsPrelude", 1036);
  gc_frame_newslot(block1762);
// method "_apply"
  block_savedest(block1762);
  Object closure1763 = createclosure(1, "_apply");
  setclosureframe(closure1763, stackframe);
  addtoclosure(closure1763, selfslot);
  struct UserObject *uo1763 = (struct UserObject*)block1762;
  uo1763->data[0] = (Object)closure1763;
  Method *meth_meth_collectionsPrelude__apply1763 = addmethod2pos(block1762, "_apply", &meth_collectionsPrelude__apply1763, 0);
  int argcv_meth_collectionsPrelude__apply1763[] = {0};
  meth_meth_collectionsPrelude__apply1763->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1763);
  meth_meth_collectionsPrelude__apply1763->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1763->definitionLine = 1963;
// compiled block node returning block1762 (depth = 6)
  gc_frame_newslot(block1762);
// call case 4: self request
  params[0] = *var_each;
  params[1] = block1762;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1766 = callmethodflags(self, "indexOf(1)ifAbsent(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1761);
// compiled call node returning call1766 (depth = 5)
  *var_ix = call1766;
  if (call1766 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1037
  setline(1037);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1769 = alloc_Float64(0);
// compiled num node returning num1769 (depth = 6)
  int op_slot_right_1768 = gc_frame_newslot(num1769);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  int op_slot_left_1768 = gc_frame_newslot(*var_ix);
  params[0] = num1769;
  partcv[0] = 1;
  Object opresult1771 = callmethod(*var_ix, "≠(1)", 1, partcv, params);
// compiled op node returning opresult1771 (depth = 5)
  Object if1767 = done;
  if (istrue(opresult1771)) {
// Begin line 1038
  setline(1038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1772 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  gc_frame_newslot(*var_ix);
// call case 4: self request
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call1773 = callmethodflags(self, "removeAt(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1772);
// compiled call node returning call1773 (depth = 5)
    gc_frame_newslot(call1773);
    if1767 = call1773;
  } else {
// Begin line 1040
  setline(1040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe1774 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_action (depth = 6)
  Object call1775 = callmethodflags(*var_action, "apply", 0, partcv, params, 0);
  gc_frame_end(callframe1774);
// compiled member node returning call1775 (depth = 5)
    gc_frame_newslot(call1775);
    if1767 = call1775;
  }
// compiled if node returning if1767 (depth = 4)
  gc_frame_end(frame);
  return if1767;
}
Object meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1757(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeAll(1)ifAbsent(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll(_)ifAbsent(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll(_)ifAbsent(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for removeAll(_)ifAbsent(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_vs = &(stackframe->slots[0]);
  *var_vs = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeAll(_)");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifAbsent(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1035
  setline(1035);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1758 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_vs (depth = 3)
  gc_frame_newslot(*var_vs);
// starting to compile block node (depth = 3)
  Object block1759 = alloc_Block(NULL, NULL, "collectionsPrelude", 1035);
  gc_frame_newslot(block1759);
// method "_apply(_)"
  block_savedest(block1759);
  Object closure1760 = createclosure(2, "_apply(1)");
  setclosureframe(closure1760, stackframe);
  addtoclosure(closure1760, var_action);
  addtoclosure(closure1760, selfslot);
  struct UserObject *uo1760 = (struct UserObject*)block1759;
  uo1760->data[0] = (Object)closure1760;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_1760 = addmethod2pos(block1759, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_1760, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_1760[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_1760->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_1760);
  meth_meth_collectionsPrelude__apply_40_1_41_1760->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_1760->definitionLine = 1963;
// compiled block node returning block1759 (depth = 3)
  gc_frame_newslot(block1759);
// call case 5: prelude request
  params[0] = *var_vs;
  params[1] = block1759;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1777 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1758);
// compiled call node returning call1777 (depth = 2)
// Begin line 1043
  setline(1043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_pop1778(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pop");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1045
  setline(1045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe1779 = gc_frame_new();
// call case 4: self request
  Object call1780 = callmethodflags(self, "removeLast", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1779);
// compiled member node returning call1780 (depth = 2)
  gc_frame_end(frame);
  return call1780;
}
Object meth_collectionsPrelude__apply_40_1_41_1792(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe1793 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call1794 = callmethodflags(*var_result, "addFirst(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1793);
// compiled call node returning call1794 (depth = 4)
  gc_frame_end(frame);
  return call1794;
}
Object meth_collectionsPrelude_reversed1781(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "reversed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 1047
  setline(1047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe1782 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1783 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1784 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1785 = gc_frame_new();
// call case 3: self.outer request
  Object call1786 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1785);
// compiled member node returning call1786 (depth = 6)
  Object call1787 = callmethodflags(call1786, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe1784);
// compiled member node returning call1787 (depth = 5)
  Object call1788 = callmethodflags(call1787, "list", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1783);
// compiled member node returning call1788 (depth = 4)
  Object call1789 = callmethodflags(call1788, "empty", 0, partcv, params, 0);
  gc_frame_end(callframe1782);
// compiled member node returning call1789 (depth = 3)
  *var_result = call1789;
  if (call1789 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1048
  setline(1048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1790 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block1791 = alloc_Block(NULL, NULL, "collectionsPrelude", 1048);
  gc_frame_newslot(block1791);
// method "_apply(_)"
  block_savedest(block1791);
  Object closure1792 = createclosure(2, "_apply(1)");
  setclosureframe(closure1792, stackframe);
  addtoclosure(closure1792, var_result);
  addtoclosure(closure1792, selfslot);
  struct UserObject *uo1792 = (struct UserObject*)block1791;
  uo1792->data[0] = (Object)closure1792;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_1792 = addmethod2pos(block1791, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_1792, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_1792[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_1792->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_1792);
  meth_meth_collectionsPrelude__apply_40_1_41_1792->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_1792->definitionLine = 1963;
// compiled block node returning block1791 (depth = 3)
  gc_frame_newslot(block1791);
// call case 4: self request
  params[0] = block1791;
  partcv[0] = 1;
  Object call1796 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1790);
// compiled call node returning call1796 (depth = 2)
// Begin line 1049
  setline(1049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude__apply1811(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_hiIx = getfromclosure(closure, 0);
  Object *var_loIx = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_hiIx (depth = 5)
  int op_slot_right_1812 = gc_frame_newslot(*var_hiIx);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_loIx (depth = 5)
  int op_slot_left_1812 = gc_frame_newslot(*var_loIx);
  params[0] = *var_hiIx;
  partcv[0] = 1;
  Object opresult1814 = callmethod(*var_loIx, "<(1)", 1, partcv, params);
// compiled op node returning opresult1814 (depth = 4)
  gc_frame_end(frame);
  return opresult1814;
}
Object meth_collectionsPrelude__apply1817(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_hiIx = getfromclosure(closure, 0);
  Object *var_loIx = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_hiVal = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "hiVal");
// Begin line 1056
  setline(1056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1818 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_hiIx (depth = 6)
  gc_frame_newslot(*var_hiIx);
// call case 4: self request
  params[0] = *var_hiIx;
  partcv[0] = 1;
  Object call1819 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1818);
// compiled call node returning call1819 (depth = 5)
  *var_hiVal = call1819;
  if (call1819 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1057
  setline(1057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1820 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_hiIx (depth = 5)
  gc_frame_newslot(*var_hiIx);
// starting to compile call node (depth = 5)
  int callframe1821 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_loIx (depth = 6)
  gc_frame_newslot(*var_loIx);
// call case 4: self request
  params[0] = *var_loIx;
  partcv[0] = 1;
  Object call1822 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1821);
// compiled call node returning call1822 (depth = 5)
  gc_frame_newslot(call1822);
// call case 4: self request
  params[0] = *var_hiIx;
  params[1] = call1822;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1823 = callmethodflags(self, "at(1)put(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1820);
// compiled call node returning call1823 (depth = 4)
// Begin line 1058
  setline(1058);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1824 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_loIx (depth = 5)
  gc_frame_newslot(*var_loIx);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_hiVal (depth = 5)
  gc_frame_newslot(*var_hiVal);
// call case 4: self request
  params[0] = *var_loIx;
  params[1] = *var_hiVal;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1825 = callmethodflags(self, "at(1)put(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1824);
// compiled call node returning call1825 (depth = 4)
// Begin line 1059
  setline(1059);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1827 = alloc_Float64(1);
// compiled num node returning num1827 (depth = 6)
  int op_slot_right_1826 = gc_frame_newslot(num1827);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_hiIx (depth = 6)
  int op_slot_left_1826 = gc_frame_newslot(*var_hiIx);
  params[0] = num1827;
  partcv[0] = 1;
  Object diff1829 = callmethod(*var_hiIx, "-(1)", 1, partcv, params);
// compiled op node returning diff1829 (depth = 5)
  *var_hiIx = diff1829;
  if (diff1829 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1060
  setline(1060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1832 = alloc_Float64(1);
// compiled num node returning num1832 (depth = 6)
  int op_slot_right_1831 = gc_frame_newslot(num1832);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_loIx (depth = 6)
  int op_slot_left_1831 = gc_frame_newslot(*var_loIx);
  params[0] = num1832;
  partcv[0] = 1;
  Object sum1834 = callmethod(*var_loIx, "+(1)", 1, partcv, params);
// compiled op node returning sum1834 (depth = 5)
  *var_loIx = sum1834;
  if (sum1834 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_reverse1797(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "reverse");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_hiIx = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "hiIx");
  Object *var_loIx = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "loIx");
// Begin line 1052
  setline(1052);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1798 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1800 = alloc_Float64(1);
// compiled num node returning num1800 (depth = 4)
  int op_slot_right_1799 = gc_frame_newslot(num1800);
// starting to compile member node (depth = 4)
  int callframe1802 = gc_frame_new();
// call case 4: self request
  Object call1803 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1802);
// compiled member node returning call1803 (depth = 4)
  int op_slot_left_1799 = gc_frame_newslot(call1803);
  params[0] = num1800;
  partcv[0] = 1;
  Object sum1804 = callmethod(call1803, "+(1)", 1, partcv, params);
// compiled op node returning sum1804 (depth = 3)
  gc_frame_newslot(sum1804);
// call case 4: self request
  params[0] = sum1804;
  partcv[0] = 1;
  Object call1805 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1798);
// compiled call node returning call1805 (depth = 2)
// Begin line 1053
  setline(1053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe1806 = gc_frame_new();
// call case 4: self request
  Object call1807 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1806);
// compiled member node returning call1807 (depth = 3)
  *var_hiIx = call1807;
  if (call1807 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1054
  setline(1054);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num1808 = alloc_Float64(1);
// compiled num node returning num1808 (depth = 3)
  *var_loIx = num1808;
  if (num1808 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1055
  setline(1055);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1809 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block1810 = alloc_Block(NULL, NULL, "collectionsPrelude", 1055);
  gc_frame_newslot(block1810);
// method "_apply"
  block_savedest(block1810);
  Object closure1811 = createclosure(3, "_apply");
  setclosureframe(closure1811, stackframe);
  addtoclosure(closure1811, var_hiIx);
  addtoclosure(closure1811, var_loIx);
  addtoclosure(closure1811, selfslot);
  struct UserObject *uo1811 = (struct UserObject*)block1810;
  uo1811->data[0] = (Object)closure1811;
  Method *meth_meth_collectionsPrelude__apply1811 = addmethod2pos(block1810, "_apply", &meth_collectionsPrelude__apply1811, 0);
  int argcv_meth_collectionsPrelude__apply1811[] = {0};
  meth_meth_collectionsPrelude__apply1811->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1811);
  meth_meth_collectionsPrelude__apply1811->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1811->definitionLine = 1963;
// compiled block node returning block1810 (depth = 3)
  gc_frame_newslot(block1810);
// starting to compile block node (depth = 3)
  Object block1816 = alloc_Block(NULL, NULL, "collectionsPrelude", 1055);
  gc_frame_newslot(block1816);
// method "_apply"
  block_savedest(block1816);
  Object closure1817 = createclosure(3, "_apply");
  setclosureframe(closure1817, stackframe);
  addtoclosure(closure1817, var_hiIx);
  addtoclosure(closure1817, var_loIx);
  addtoclosure(closure1817, selfslot);
  struct UserObject *uo1817 = (struct UserObject*)block1816;
  uo1817->data[0] = (Object)closure1817;
  Method *meth_meth_collectionsPrelude__apply1817 = addmethod2pos(block1816, "_apply", &meth_collectionsPrelude__apply1817, 0);
  int argcv_meth_collectionsPrelude__apply1817[] = {0};
  meth_meth_collectionsPrelude__apply1817->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1817);
  meth_meth_collectionsPrelude__apply1817->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1817->definitionLine = 1963;
// compiled block node returning block1816 (depth = 3)
  gc_frame_newslot(block1816);
// call case 5: prelude request
  params[0] = block1810;
  params[1] = block1816;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1837 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1809);
// compiled call node returning call1837 (depth = 2)
// Begin line 1062
  setline(1062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__43__43__40_1_41_1838(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ++(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_l = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "l");
// Begin line 1065
  setline(1065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1839 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1840 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe1841 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1842 = gc_frame_new();
// call case 3: self.outer request
  Object call1843 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1842);
// compiled member node returning call1843 (depth = 6)
  Object call1844 = callmethodflags(call1843, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe1841);
// compiled member node returning call1844 (depth = 5)
  Object call1845 = callmethodflags(call1844, "list", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1840);
// compiled member node returning call1845 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call1846 = callmethodflags(call1845, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1839);
// compiled call node returning call1846 (depth = 3)
  *var_l = call1846;
  if (call1846 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1066
  setline(1066);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1847 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1848 = callmethodflags(*var_l, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1847);
// compiled call node returning call1848 (depth = 2)
  gc_frame_end(frame);
  return call1848;
}
Object meth_collectionsPrelude__apply_40_1_41_1863(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1071
  setline(1071);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1865 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe1866 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1867 = gc_frame_new();
// call case 4: self request
  Object call1868 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1867);
// compiled member node returning call1868 (depth = 8)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1869 = callmethodflags(call1868, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1866);
// compiled call node returning call1869 (depth = 7)
  Object call1870 = callmethodflags(call1869, "asString", 0, partcv, params, 0);
  gc_frame_end(callframe1865);
// compiled member node returning call1870 (depth = 6)
  int op_slot_right_1864 = gc_frame_newslot(call1870);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1864 = gc_frame_newslot(*var_s);
  params[0] = call1870;
  partcv[0] = 1;
  Object opresult1872 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1872 (depth = 5)
  *var_s = opresult1872;
  if (opresult1872 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1072
  setline(1072);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1877 = alloc_Float64(1);
// compiled num node returning num1877 (depth = 7)
  int op_slot_right_1876 = gc_frame_newslot(num1877);
// starting to compile member node (depth = 7)
  int callframe1879 = gc_frame_new();
// call case 4: self request
  Object call1880 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1879);
// compiled member node returning call1880 (depth = 7)
  int op_slot_left_1876 = gc_frame_newslot(call1880);
  params[0] = num1877;
  partcv[0] = 1;
  Object diff1881 = callmethod(call1880, "-(1)", 1, partcv, params);
// compiled op node returning diff1881 (depth = 6)
  int op_slot_right_1875 = gc_frame_newslot(diff1881);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1875 = gc_frame_newslot(*var_i);
  params[0] = diff1881;
  partcv[0] = 1;
  Object opresult1883 = callmethod(*var_i, "<(1)", 1, partcv, params);
// compiled op node returning opresult1883 (depth = 5)
  Object if1874 = done;
  if (istrue(opresult1883)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1885 == NULL) {
    strlit1885 = alloc_String(", ");
    gc_root(strlit1885);
  }
// compiled string node returning strlit1885 (depth = 7)
  int op_slot_right_1884 = gc_frame_newslot(strlit1885);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1884 = gc_frame_newslot(*var_s);
  params[0] = strlit1885;
  partcv[0] = 1;
  Object opresult1887 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1887 (depth = 6)
  *var_s = opresult1887;
  if (opresult1887 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1874 = done;
  } else {
  }
// compiled if node returning if1874 (depth = 4)
  gc_frame_end(frame);
  return if1874;
}
Object meth_collectionsPrelude_asString1849(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 1069
  setline(1069);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit1850 == NULL) {
    strlit1850 = alloc_String("[");
    gc_root(strlit1850);
  }
// compiled string node returning strlit1850 (depth = 3)
  *var_s = strlit1850;
  if (strlit1850 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1070
  setline(1070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1851 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1854 = alloc_Float64(1);
// compiled num node returning num1854 (depth = 5)
  int op_slot_right_1853 = gc_frame_newslot(num1854);
// starting to compile member node (depth = 5)
  int callframe1856 = gc_frame_new();
// call case 4: self request
  Object call1857 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1856);
// compiled member node returning call1857 (depth = 5)
  int op_slot_left_1853 = gc_frame_newslot(call1857);
  params[0] = num1854;
  partcv[0] = 1;
  Object diff1858 = callmethod(call1857, "-(1)", 1, partcv, params);
// compiled op node returning diff1858 (depth = 4)
  int op_slot_right_1852 = gc_frame_newslot(diff1858);
// starting to compile num node (depth = 4)
  Object num1860 = alloc_Float64(0);
// compiled num node returning num1860 (depth = 4)
  int op_slot_left_1852 = gc_frame_newslot(num1860);
  params[0] = diff1858;
  partcv[0] = 1;
  Object opresult1861 = callmethod(num1860, "..(1)", 1, partcv, params);
// compiled op node returning opresult1861 (depth = 3)
  gc_frame_newslot(opresult1861);
// starting to compile block node (depth = 3)
  Object block1862 = alloc_Block(NULL, NULL, "collectionsPrelude", 1070);
  gc_frame_newslot(block1862);
// method "_apply(_)"
  block_savedest(block1862);
  Object closure1863 = createclosure(2, "_apply(1)");
  setclosureframe(closure1863, stackframe);
  addtoclosure(closure1863, var_s);
  addtoclosure(closure1863, selfslot);
  struct UserObject *uo1863 = (struct UserObject*)block1862;
  uo1863->data[0] = (Object)closure1863;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_1863 = addmethod2pos(block1862, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_1863, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_1863[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_1863->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_1863);
  meth_meth_collectionsPrelude__apply_40_1_41_1863->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_1863->definitionLine = 1963;
// compiled block node returning block1862 (depth = 3)
  gc_frame_newslot(block1862);
// call case 5: prelude request
  params[0] = opresult1861;
  params[1] = block1862;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1890 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1851);
// compiled call node returning call1890 (depth = 2)
// Begin line 1074
  setline(1074);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit1892 == NULL) {
    strlit1892 = alloc_String("]");
    gc_root(strlit1892);
  }
// compiled string node returning strlit1892 (depth = 3)
  int op_slot_right_1891 = gc_frame_newslot(strlit1892);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_1891 = gc_frame_newslot(*var_s);
  params[0] = strlit1892;
  partcv[0] = 1;
  Object opresult1894 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1894 (depth = 2)
  gc_frame_end(frame);
  return opresult1894;
}
Object meth_collectionsPrelude__apply_40_1_41_1909(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1079
  setline(1079);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe1911 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe1912 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe1913 = gc_frame_new();
// call case 4: self request
  Object call1914 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1913);
// compiled member node returning call1914 (depth = 8)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1915 = callmethodflags(call1914, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1912);
// compiled call node returning call1915 (depth = 7)
  Object call1916 = callmethodflags(call1915, "asDebugString", 0, partcv, params, 0);
  gc_frame_end(callframe1911);
// compiled member node returning call1916 (depth = 6)
  int op_slot_right_1910 = gc_frame_newslot(call1916);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1910 = gc_frame_newslot(*var_s);
  params[0] = call1916;
  partcv[0] = 1;
  Object opresult1918 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1918 (depth = 5)
  *var_s = opresult1918;
  if (opresult1918 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1080
  setline(1080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1923 = alloc_Float64(1);
// compiled num node returning num1923 (depth = 7)
  int op_slot_right_1922 = gc_frame_newslot(num1923);
// starting to compile member node (depth = 7)
  int callframe1925 = gc_frame_new();
// call case 4: self request
  Object call1926 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1925);
// compiled member node returning call1926 (depth = 7)
  int op_slot_left_1922 = gc_frame_newslot(call1926);
  params[0] = num1923;
  partcv[0] = 1;
  Object diff1927 = callmethod(call1926, "-(1)", 1, partcv, params);
// compiled op node returning diff1927 (depth = 6)
  int op_slot_right_1921 = gc_frame_newslot(diff1927);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1921 = gc_frame_newslot(*var_i);
  params[0] = diff1927;
  partcv[0] = 1;
  Object opresult1929 = callmethod(*var_i, "<(1)", 1, partcv, params);
// compiled op node returning opresult1929 (depth = 5)
  Object if1920 = done;
  if (istrue(opresult1929)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1931 == NULL) {
    strlit1931 = alloc_String(", ");
    gc_root(strlit1931);
  }
// compiled string node returning strlit1931 (depth = 7)
  int op_slot_right_1930 = gc_frame_newslot(strlit1931);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1930 = gc_frame_newslot(*var_s);
  params[0] = strlit1931;
  partcv[0] = 1;
  Object opresult1933 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1933 (depth = 6)
  *var_s = opresult1933;
  if (opresult1933 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1920 = done;
  } else {
  }
// compiled if node returning if1920 (depth = 4)
  gc_frame_end(frame);
  return if1920;
}
Object meth_collectionsPrelude_asDebugString1895(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 1077
  setline(1077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit1896 == NULL) {
    strlit1896 = alloc_String("[");
    gc_root(strlit1896);
  }
// compiled string node returning strlit1896 (depth = 3)
  *var_s = strlit1896;
  if (strlit1896 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1078
  setline(1078);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1897 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1900 = alloc_Float64(1);
// compiled num node returning num1900 (depth = 5)
  int op_slot_right_1899 = gc_frame_newslot(num1900);
// starting to compile member node (depth = 5)
  int callframe1902 = gc_frame_new();
// call case 4: self request
  Object call1903 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1902);
// compiled member node returning call1903 (depth = 5)
  int op_slot_left_1899 = gc_frame_newslot(call1903);
  params[0] = num1900;
  partcv[0] = 1;
  Object diff1904 = callmethod(call1903, "-(1)", 1, partcv, params);
// compiled op node returning diff1904 (depth = 4)
  int op_slot_right_1898 = gc_frame_newslot(diff1904);
// starting to compile num node (depth = 4)
  Object num1906 = alloc_Float64(0);
// compiled num node returning num1906 (depth = 4)
  int op_slot_left_1898 = gc_frame_newslot(num1906);
  params[0] = diff1904;
  partcv[0] = 1;
  Object opresult1907 = callmethod(num1906, "..(1)", 1, partcv, params);
// compiled op node returning opresult1907 (depth = 3)
  gc_frame_newslot(opresult1907);
// starting to compile block node (depth = 3)
  Object block1908 = alloc_Block(NULL, NULL, "collectionsPrelude", 1078);
  gc_frame_newslot(block1908);
// method "_apply(_)"
  block_savedest(block1908);
  Object closure1909 = createclosure(2, "_apply(1)");
  setclosureframe(closure1909, stackframe);
  addtoclosure(closure1909, var_s);
  addtoclosure(closure1909, selfslot);
  struct UserObject *uo1909 = (struct UserObject*)block1908;
  uo1909->data[0] = (Object)closure1909;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_1909 = addmethod2pos(block1908, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_1909, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_1909[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_1909->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_1909);
  meth_meth_collectionsPrelude__apply_40_1_41_1909->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_1909->definitionLine = 1963;
// compiled block node returning block1908 (depth = 3)
  gc_frame_newslot(block1908);
// call case 5: prelude request
  params[0] = opresult1907;
  params[1] = block1908;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1936 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1897);
// compiled call node returning call1936 (depth = 2)
// Begin line 1082
  setline(1082);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit1938 == NULL) {
    strlit1938 = alloc_String("]");
    gc_root(strlit1938);
  }
// compiled string node returning strlit1938 (depth = 3)
  int op_slot_right_1937 = gc_frame_newslot(strlit1938);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_1937 = gc_frame_newslot(*var_s);
  params[0] = strlit1938;
  partcv[0] = 1;
  Object opresult1940 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult1940 (depth = 2)
  gc_frame_end(frame);
  return opresult1940;
}
Object meth_collectionsPrelude__apply_40_1_41_1944(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_element = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_element (depth = 6)
  int op_slot_right_1946 = gc_frame_newslot(*var_element);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  int op_slot_left_1946 = gc_frame_newslot(*var_each);
  params[0] = *var_element;
  partcv[0] = 1;
  Object opresult1948 = callmethod(*var_each, "==(1)", 1, partcv, params);
// compiled op node returning opresult1948 (depth = 5)
  Object if1945 = done;
  if (istrue(opresult1948)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool1949 = alloc_Boolean(1);
// compiled identifier node returning bool1949 (depth = 6)
  block_return(realself, bool1949);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if1945 = undefined;
  } else {
  }
// compiled if node returning if1945 (depth = 4)
  gc_frame_end(frame);
  return if1945;
}
Object meth_collectionsPrelude_contains_40_1_41_1941(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_element = &(stackframe->slots[0]);
  *var_element = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part contains(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1085
  setline(1085);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1942 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block1943 = alloc_Block(NULL, NULL, "collectionsPrelude", 1085);
  gc_frame_newslot(block1943);
// method "_apply(_)"
  block_savedest(block1943);
  Object closure1944 = createclosure(2, "_apply(1)");
  setclosureframe(closure1944, stackframe);
  addtoclosure(closure1944, var_element);
  addtoclosure(closure1944, selfslot);
  struct UserObject *uo1944 = (struct UserObject*)block1943;
  uo1944->data[0] = (Object)closure1944;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_1944 = addmethod2pos(block1943, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_1944, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_1944[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_1944->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_1944);
  meth_meth_collectionsPrelude__apply_40_1_41_1944->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_1944->definitionLine = 1963;
// compiled block node returning block1943 (depth = 3)
  gc_frame_newslot(block1943);
// call case 4: self request
  params[0] = block1943;
  partcv[0] = 1;
  Object call1951 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1942);
// compiled call node returning call1951 (depth = 2)
// Begin line 1086
  setline(1086);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool1952 = alloc_Boolean(0);
// compiled identifier node returning bool1952 (depth = 3)
  return bool1952;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply1957(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe1959 = gc_frame_new();
// call case 4: self request
  Object call1960 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1959);
// compiled member node returning call1960 (depth = 5)
  int op_slot_right_1958 = gc_frame_newslot(call1960);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  int op_slot_left_1958 = gc_frame_newslot(*var_i);
  params[0] = call1960;
  partcv[0] = 1;
  Object opresult1962 = callmethod(*var_i, "<(1)", 1, partcv, params);
// compiled op node returning opresult1962 (depth = 4)
  gc_frame_end(frame);
  return opresult1962;
}
Object meth_collectionsPrelude__apply1965(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_block1 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1091
  setline(1091);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1966 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe1967 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe1968 = gc_frame_new();
// call case 4: self request
  Object call1969 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1968);
// compiled member node returning call1969 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1970 = callmethodflags(call1969, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1967);
// compiled call node returning call1970 (depth = 5)
  gc_frame_newslot(call1970);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block1 (depth = 5)
  params[0] = call1970;
  partcv[0] = 1;
  Object call1971 = callmethodflags(*var_block1, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1966);
// compiled call node returning call1971 (depth = 4)
// Begin line 1092
  setline(1092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1973 = alloc_Float64(1);
// compiled num node returning num1973 (depth = 6)
  int op_slot_right_1972 = gc_frame_newslot(num1973);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1972 = gc_frame_newslot(*var_i);
  params[0] = num1973;
  partcv[0] = 1;
  Object sum1975 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum1975 (depth = 5)
  *var_i = sum1975;
  if (sum1975 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_do_40_1_41_1953(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_i = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "i");
// Begin line 1089
  setline(1089);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num1954 = alloc_Float64(0);
// compiled num node returning num1954 (depth = 3)
  *var_i = num1954;
  if (num1954 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1090
  setline(1090);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1955 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block1956 = alloc_Block(NULL, NULL, "collectionsPrelude", 1090);
  gc_frame_newslot(block1956);
// method "_apply"
  block_savedest(block1956);
  Object closure1957 = createclosure(2, "_apply");
  setclosureframe(closure1957, stackframe);
  addtoclosure(closure1957, var_i);
  addtoclosure(closure1957, selfslot);
  struct UserObject *uo1957 = (struct UserObject*)block1956;
  uo1957->data[0] = (Object)closure1957;
  Method *meth_meth_collectionsPrelude__apply1957 = addmethod2pos(block1956, "_apply", &meth_collectionsPrelude__apply1957, 0);
  int argcv_meth_collectionsPrelude__apply1957[] = {0};
  meth_meth_collectionsPrelude__apply1957->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1957);
  meth_meth_collectionsPrelude__apply1957->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1957->definitionLine = 1963;
// compiled block node returning block1956 (depth = 3)
  gc_frame_newslot(block1956);
// starting to compile block node (depth = 3)
  Object block1964 = alloc_Block(NULL, NULL, "collectionsPrelude", 1090);
  gc_frame_newslot(block1964);
// method "_apply"
  block_savedest(block1964);
  Object closure1965 = createclosure(3, "_apply");
  setclosureframe(closure1965, stackframe);
  addtoclosure(closure1965, var_i);
  addtoclosure(closure1965, var_block1);
  addtoclosure(closure1965, selfslot);
  struct UserObject *uo1965 = (struct UserObject*)block1964;
  uo1965->data[0] = (Object)closure1965;
  Method *meth_meth_collectionsPrelude__apply1965 = addmethod2pos(block1964, "_apply", &meth_collectionsPrelude__apply1965, 0);
  int argcv_meth_collectionsPrelude__apply1965[] = {0};
  meth_meth_collectionsPrelude__apply1965->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1965);
  meth_meth_collectionsPrelude__apply1965->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1965->definitionLine = 1963;
// compiled block node returning block1964 (depth = 3)
  gc_frame_newslot(block1964);
// call case 5: prelude request
  params[0] = block1956;
  params[1] = block1964;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1978 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1955);
// compiled call node returning call1978 (depth = 2)
  gc_frame_end(frame);
  return call1978;
}
Object meth_collectionsPrelude__61__61__40_1_41_1979(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1097
  setline(1097);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1980 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe1981 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe1982 = gc_frame_new();
// call case 3: self.outer request
  Object call1983 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1982);
// compiled member node returning call1983 (depth = 4)
  Object call1984 = callmethodflags(call1983, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe1981);
// compiled member node returning call1984 (depth = 3)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1985 = callmethodflags(call1984, "isEqual(1)toIterable(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1980);
// compiled call node returning call1985 (depth = 2)
  gc_frame_end(frame);
  return call1985;
}
Object meth_collectionsPrelude_asDebugString1991(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1103
  setline(1103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit1993 == NULL) {
    strlit1993 = alloc_String("""\xe2""""\x9f""""\xab""");
    gc_root(strlit1993);
  }
// compiled string node returning strlit1993 (depth = 3)
  int op_slot_right_1992 = gc_frame_newslot(strlit1993);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe1996 = gc_frame_new();
// call case 4: self request
  Object call1997 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1996);
// compiled member node returning call1997 (depth = 4)
  int op_slot_right_1995 = gc_frame_newslot(call1997);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit2000 == NULL) {
    strlit2000 = alloc_String("""\xe2""""\x9f""""\xaa""");
    gc_root(strlit2000);
  }
// compiled string node returning strlit2000 (depth = 5)
  int op_slot_right_1999 = gc_frame_newslot(strlit2000);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2003 = gc_frame_new();
// call case 4: self request
  Object call2004 = callmethodflags(self, "asString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2003);
// compiled member node returning call2004 (depth = 6)
  int op_slot_right_2002 = gc_frame_newslot(call2004);
// starting to compile string node (depth = 6)
  if (strlit2006 == NULL) {
    strlit2006 = alloc_String("");
    gc_root(strlit2006);
  }
// compiled string node returning strlit2006 (depth = 6)
  int op_slot_left_2002 = gc_frame_newslot(strlit2006);
  params[0] = call2004;
  partcv[0] = 1;
  Object opresult2007 = callmethod(strlit2006, "++(1)", 1, partcv, params);
// compiled op node returning opresult2007 (depth = 5)
  int op_slot_left_1999 = gc_frame_newslot(opresult2007);
  params[0] = strlit2000;
  partcv[0] = 1;
  Object opresult2008 = callmethod(opresult2007, "++(1)", 1, partcv, params);
// compiled op node returning opresult2008 (depth = 4)
  int op_slot_left_1995 = gc_frame_newslot(opresult2008);
  params[0] = call1997;
  partcv[0] = 1;
  Object opresult2009 = callmethod(opresult2008, "++(1)", 1, partcv, params);
// compiled op node returning opresult2009 (depth = 3)
  int op_slot_left_1992 = gc_frame_newslot(opresult2009);
  params[0] = strlit1993;
  partcv[0] = 1;
  Object opresult2010 = callmethod(opresult2009, "++(1)", 1, partcv, params);
// compiled op node returning opresult2010 (depth = 2)
  gc_frame_end(frame);
  return opresult2010;
}
Object meth_collectionsPrelude_asString2011(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1104
  setline(1104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit2012 == NULL) {
    strlit2012 = alloc_String("aListIterator");
    gc_root(strlit2012);
  }
// compiled string node returning strlit2012 (depth = 2)
  gc_frame_end(frame);
  return strlit2012;
}
Object meth_collectionsPrelude_hasNext2013(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1105
  setline(1105);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2015 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2016 = gc_frame_new();
// call case 3: self.outer request
  Object call2017 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2016);
// compiled member node returning call2017 (depth = 4)
  Object call2018 = callmethodflags(call2017, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2015);
// compiled member node returning call2018 (depth = 3)
  int op_slot_right_2014 = gc_frame_newslot(call2018);
// starting to compile member node (depth = 3)
  int callframe2020 = gc_frame_new();
// call case 4: self request
  Object call2021 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2020);
// compiled member node returning call2021 (depth = 3)
  int op_slot_left_2014 = gc_frame_newslot(call2021);
  params[0] = call2018;
  partcv[0] = 1;
  Object opresult2022 = callmethod(call2021, "≤(1)", 1, partcv, params);
// compiled op node returning opresult2022 (depth = 2)
  gc_frame_end(frame);
  return opresult2022;
}
Object meth_collectionsPrelude_next2023(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ret = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "ret");
// Begin line 1107
  setline(1107);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2026 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2027 = gc_frame_new();
// call case 3: self.outer request
  Object call2028 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2027);
// compiled member node returning call2028 (depth = 5)
  Object call2029 = callmethodflags(call2028, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2026);
// compiled member node returning call2029 (depth = 4)
  int op_slot_right_2025 = gc_frame_newslot(call2029);
// starting to compile member node (depth = 4)
  int callframe2031 = gc_frame_new();
// call case 4: self request
  Object call2032 = callmethodflags(self, "imods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2031);
// compiled member node returning call2032 (depth = 4)
  int op_slot_left_2025 = gc_frame_newslot(call2032);
  params[0] = call2029;
  partcv[0] = 1;
  Object opresult2033 = callmethod(call2032, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2033 (depth = 3)
  Object if2024 = done;
  if (istrue(opresult2033)) {
// Begin line 1108
  setline(1108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2034 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe2035 = gc_frame_new();
// call case 4: self request
  Object call2036 = callmethodflags(self, "asDebugString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2035);
// compiled member node returning call2036 (depth = 4)
  gc_frame_newslot(call2036);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ConcurrentModification (depth = 4)
  params[0] = call2036;
  partcv[0] = 1;
  Object call2037 = callmethodflags(*var_ConcurrentModification, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2034);
// compiled call node returning call2037 (depth = 3)
    gc_frame_newslot(call2037);
    if2024 = call2037;
  } else {
  }
// compiled if node returning if2024 (depth = 2)
// Begin line 1110
  setline(1110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2040 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2041 = gc_frame_new();
// call case 3: self.outer request
  Object call2042 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2041);
// compiled member node returning call2042 (depth = 5)
  Object call2043 = callmethodflags(call2042, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2040);
// compiled member node returning call2043 (depth = 4)
  int op_slot_right_2039 = gc_frame_newslot(call2043);
// starting to compile member node (depth = 4)
  int callframe2045 = gc_frame_new();
// call case 4: self request
  Object call2046 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2045);
// compiled member node returning call2046 (depth = 4)
  int op_slot_left_2039 = gc_frame_newslot(call2046);
  params[0] = call2043;
  partcv[0] = 1;
  Object opresult2047 = callmethod(call2046, ">(1)", 1, partcv, params);
// compiled op node returning opresult2047 (depth = 3)
  Object if2038 = done;
  if (istrue(opresult2047)) {
// starting to compile call node (depth = 3)
  int callframe2048 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit2049 == NULL) {
    strlit2049 = alloc_String("on list");
    gc_root(strlit2049);
  }
// compiled string node returning strlit2049 (depth = 4)
  gc_frame_newslot(strlit2049);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_IteratorExhausted (depth = 4)
  params[0] = strlit2049;
  partcv[0] = 1;
  Object call2050 = callmethodflags(*var_IteratorExhausted, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2048);
// compiled call node returning call2050 (depth = 3)
    gc_frame_newslot(call2050);
    if2038 = call2050;
  } else {
  }
// compiled if node returning if2038 (depth = 2)
// Begin line 1111
  setline(1111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2051 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe2052 = gc_frame_new();
// call case 4: self request
  Object call2053 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2052);
// compiled member node returning call2053 (depth = 4)
  gc_frame_newslot(call2053);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2054 = gc_frame_new();
// call case 3: self.outer request
  Object call2055 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2054);
// compiled member node returning call2055 (depth = 4)
  params[0] = call2053;
  partcv[0] = 1;
  Object call2056 = callmethodflags(call2055, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2051);
// compiled call node returning call2056 (depth = 3)
  *var_ret = call2056;
  if (call2056 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1112
  setline(1112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2057 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2059 = alloc_Float64(1);
// compiled num node returning num2059 (depth = 4)
  int op_slot_right_2058 = gc_frame_newslot(num2059);
// starting to compile member node (depth = 4)
  int callframe2061 = gc_frame_new();
// call case 4: self request
  Object call2062 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2061);
// compiled member node returning call2062 (depth = 4)
  int op_slot_left_2058 = gc_frame_newslot(call2062);
  params[0] = num2059;
  partcv[0] = 1;
  Object sum2063 = callmethod(call2062, "+(1)", 1, partcv, params);
// compiled op node returning sum2063 (depth = 3)
  gc_frame_newslot(sum2063);
// call case 4: self request
  params[0] = sum2063;
  partcv[0] = 1;
  Object call2064 = callmethodflags(self, "idx:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2057);
// compiled call node returning call2064 (depth = 2)
// Begin line 1113
  setline(1113);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_ret (depth = 2)
  gc_frame_end(frame);
  return *var_ret;
}
Object meth_collectionsPrelude_iterator1986(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1987 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1987 = alloc_userobj2(8,7, objclass1987);
  gc_frame_newslot(obj1987);
if (objclass1987 == NULL) {
  glfree(obj1987->class->name);
  obj1987->class->name = "list.object.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1987, self, 0);
  addmethodreal(obj1987,"outer", &reader_collectionsPrelude_outer_1988);
  Object oldself1987 = self;
  struct StackFrameObject *oldstackframe1987 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1987);
  gc_frame_newslot((Object)stackframe);
  self = obj1987;
  Object *oldselfslot1987 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1987 = (*(struct UserObject *)self).data[0], lowerouter1987 = thisouter1987;
  if (inheritingObject1987) {
    struct UserObject *inho1987 = (struct UserObject *)inheritingObject1987;
    while (inho1987->super != GraceDefaultObject) inho1987 = (struct UserObject *)inho1987->super;
    inho1987->super = obj1987;
    self = inheritingObject1987;
    *selfslot = self;
    lowerouter1987 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1987;
  }
if (objclass1987 == NULL) {
  Method *reader1989 = addmethodrealflags(obj1987, "imods", &reader_collectionsPrelude_imods_1989, MFLAG_CONFIDENTIAL);
  Method *writer1989 = addmethodrealflags(obj1987, "imods:=(1)", &writer_collectionsPrelude_imods_1989, MFLAG_CONFIDENTIAL);
  reader1989->definitionModule = modulename;
  writer1989->definitionModule = modulename;
  reader1989->definitionLine = 1101;
  writer1989->definitionLine = 1101;
}
obj1987->flags |= OFLAG_MUTABLE;
adddatum2(obj1987, alloc_Undefined(), 1);
if (objclass1987 == NULL) {
  Method *reader1990 = addmethodrealflags(obj1987, "idx", &reader_collectionsPrelude_idx_1990, MFLAG_CONFIDENTIAL);
  Method *writer1990 = addmethodrealflags(obj1987, "idx:=(1)", &writer_collectionsPrelude_idx_1990, MFLAG_CONFIDENTIAL);
  reader1990->definitionModule = modulename;
  writer1990->definitionModule = modulename;
  reader1990->definitionLine = 1102;
  writer1990->definitionLine = 1102;
}
obj1987->flags |= OFLAG_MUTABLE;
adddatum2(obj1987, alloc_Undefined(), 2);
// method "asDebugString"
  struct UserObject *uo1991 = (struct UserObject*)obj1987;
  uo1991->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString1991 = addmethod2pos(obj1987, "asDebugString", &meth_collectionsPrelude_asDebugString1991, 3);
  int argcv_meth_collectionsPrelude_asDebugString1991[] = {0};
  meth_meth_collectionsPrelude_asDebugString1991->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString1991);
  meth_meth_collectionsPrelude_asDebugString1991->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString1991->definitionLine = 1103;
// method "asString"
  struct UserObject *uo2011 = (struct UserObject*)obj1987;
  uo2011->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString2011 = addmethod2pos(obj1987, "asString", &meth_collectionsPrelude_asString2011, 4);
  int argcv_meth_collectionsPrelude_asString2011[] = {0};
  meth_meth_collectionsPrelude_asString2011->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString2011);
  meth_meth_collectionsPrelude_asString2011->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString2011->definitionLine = 1104;
// method "hasNext"
  struct UserObject *uo2013 = (struct UserObject*)obj1987;
  uo2013->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext2013 = addmethod2pos(obj1987, "hasNext", &meth_collectionsPrelude_hasNext2013, 5);
  int argcv_meth_collectionsPrelude_hasNext2013[] = {0};
  meth_meth_collectionsPrelude_hasNext2013->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext2013);
  meth_meth_collectionsPrelude_hasNext2013->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext2013->definitionLine = 1105;
// method "next"
  block_savedest(obj1987);
  Object closure2023 = createclosure(2, "next");
  setclosureframe(closure2023, stackframe);
  addtoclosure(closure2023, var_ConcurrentModification);
  addtoclosure(closure2023, var_IteratorExhausted);
  struct UserObject *uo2023 = (struct UserObject*)obj1987;
  uo2023->data[6] = (Object)closure2023;
  Method *meth_meth_collectionsPrelude_next2023 = addmethod2pos(obj1987, "next", &meth_collectionsPrelude_next2023, 6);
  int argcv_meth_collectionsPrelude_next2023[] = {0};
  meth_meth_collectionsPrelude_next2023->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next2023);
  meth_meth_collectionsPrelude_next2023->definitionModule = modulename;
  meth_meth_collectionsPrelude_next2023->definitionLine = 1106;
  sourceObject = obj1987;
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe2065 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2066 = gc_frame_new();
// call case 3: self.outer request
  Object call2067 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2066);
// compiled member node returning call2067 (depth = 3)
  Object call2068 = callmethodflags(call2067, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2065);
// compiled member node returning call2068 (depth = 2)
  adddatum2(obj1987, call2068, 1);
  sourceObject = obj1987;
// Begin line 1102
  setline(1102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2069 = alloc_Float64(1);
// compiled num node returning num2069 (depth = 2)
  adddatum2(obj1987, num2069, 2);
  sourceObject = obj1987;
  sourceObject = obj1987;
  sourceObject = obj1987;
  sourceObject = obj1987;
  objclass1987 = obj1987->class;
  objclass1987->definitionModule = modulename;
  objclass1987->definitionLine = 1100;
  (*(struct UserObject *)self).data[0] = lowerouter1987;
  self = oldself1987;
  selfslot = oldselfslot1987;
  stackframe = oldstackframe1987;
  gc_frame_end(frame);
  return obj1987;
}
Object meth_collectionsPrelude_iterator1986_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1987 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1987 = alloc_userobj2(8,7, objclass1987);
  gc_frame_newslot(obj1987);
if (objclass1987 == NULL) {
  glfree(obj1987->class->name);
  obj1987->class->name = "list.object.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1987, self, 0);
  addmethodreal(obj1987,"outer", &reader_collectionsPrelude_outer_1988);
  Object oldself1987 = self;
  struct StackFrameObject *oldstackframe1987 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1987);
  gc_frame_newslot((Object)stackframe);
  self = obj1987;
  Object *oldselfslot1987 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1987 = (*(struct UserObject *)self).data[0], lowerouter1987 = thisouter1987;
  if (inheritingObject1987) {
    struct UserObject *inho1987 = (struct UserObject *)inheritingObject1987;
    while (inho1987->super != GraceDefaultObject) inho1987 = (struct UserObject *)inho1987->super;
    inho1987->super = obj1987;
    self = inheritingObject1987;
    *selfslot = self;
    lowerouter1987 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1987;
  }
if (objclass1987 == NULL) {
  Method *reader1989 = addmethodrealflags(obj1987, "imods", &reader_collectionsPrelude_imods_1989, MFLAG_CONFIDENTIAL);
  Method *writer1989 = addmethodrealflags(obj1987, "imods:=(1)", &writer_collectionsPrelude_imods_1989, MFLAG_CONFIDENTIAL);
  reader1989->definitionModule = modulename;
  writer1989->definitionModule = modulename;
  reader1989->definitionLine = 1101;
  writer1989->definitionLine = 1101;
}
obj1987->flags |= OFLAG_MUTABLE;
adddatum2(obj1987, alloc_Undefined(), 1);
if (objclass1987 == NULL) {
  Method *reader1990 = addmethodrealflags(obj1987, "idx", &reader_collectionsPrelude_idx_1990, MFLAG_CONFIDENTIAL);
  Method *writer1990 = addmethodrealflags(obj1987, "idx:=(1)", &writer_collectionsPrelude_idx_1990, MFLAG_CONFIDENTIAL);
  reader1990->definitionModule = modulename;
  writer1990->definitionModule = modulename;
  reader1990->definitionLine = 1102;
  writer1990->definitionLine = 1102;
}
obj1987->flags |= OFLAG_MUTABLE;
adddatum2(obj1987, alloc_Undefined(), 2);
// method "asDebugString"
  struct UserObject *uo1991 = (struct UserObject*)obj1987;
  uo1991->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString1991 = addmethod2pos(obj1987, "asDebugString", &meth_collectionsPrelude_asDebugString1991, 3);
  int argcv_meth_collectionsPrelude_asDebugString1991[] = {0};
  meth_meth_collectionsPrelude_asDebugString1991->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString1991);
  meth_meth_collectionsPrelude_asDebugString1991->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString1991->definitionLine = 1103;
// method "asString"
  struct UserObject *uo2011 = (struct UserObject*)obj1987;
  uo2011->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString2011 = addmethod2pos(obj1987, "asString", &meth_collectionsPrelude_asString2011, 4);
  int argcv_meth_collectionsPrelude_asString2011[] = {0};
  meth_meth_collectionsPrelude_asString2011->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString2011);
  meth_meth_collectionsPrelude_asString2011->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString2011->definitionLine = 1104;
// method "hasNext"
  struct UserObject *uo2013 = (struct UserObject*)obj1987;
  uo2013->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext2013 = addmethod2pos(obj1987, "hasNext", &meth_collectionsPrelude_hasNext2013, 5);
  int argcv_meth_collectionsPrelude_hasNext2013[] = {0};
  meth_meth_collectionsPrelude_hasNext2013->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext2013);
  meth_meth_collectionsPrelude_hasNext2013->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext2013->definitionLine = 1105;
// method "next"
  block_savedest(obj1987);
  Object closure2023 = createclosure(2, "next");
  setclosureframe(closure2023, stackframe);
  addtoclosure(closure2023, var_ConcurrentModification);
  addtoclosure(closure2023, var_IteratorExhausted);
  struct UserObject *uo2023 = (struct UserObject*)obj1987;
  uo2023->data[6] = (Object)closure2023;
  Method *meth_meth_collectionsPrelude_next2023 = addmethod2pos(obj1987, "next", &meth_collectionsPrelude_next2023, 6);
  int argcv_meth_collectionsPrelude_next2023[] = {0};
  meth_meth_collectionsPrelude_next2023->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next2023);
  meth_meth_collectionsPrelude_next2023->definitionModule = modulename;
  meth_meth_collectionsPrelude_next2023->definitionLine = 1106;
  sourceObject = obj1987;
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe2065 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2066 = gc_frame_new();
// call case 3: self.outer request
  Object call2067 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2066);
// compiled member node returning call2067 (depth = 3)
  Object call2068 = callmethodflags(call2067, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2065);
// compiled member node returning call2068 (depth = 2)
  adddatum2(obj1987, call2068, 1);
  sourceObject = obj1987;
// Begin line 1102
  setline(1102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2069 = alloc_Float64(1);
// compiled num node returning num2069 (depth = 2)
  adddatum2(obj1987, num2069, 2);
  sourceObject = obj1987;
  sourceObject = obj1987;
  sourceObject = obj1987;
  sourceObject = obj1987;
  objclass1987 = obj1987->class;
  objclass1987->definitionModule = modulename;
  objclass1987->definitionLine = 1100;
  (*(struct UserObject *)self).data[0] = lowerouter1987;
  self = oldself1987;
  selfslot = oldselfslot1987;
  stackframe = oldstackframe1987;
  gc_frame_end(frame);
  return obj1987;
}
Object meth_collectionsPrelude_values2071(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1118
  setline(1118);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_keys2072(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1121
  setline(1121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe2073 = gc_frame_new();
// call case 4: self request
  Object call2074 = callmethodflags(self, "indices", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2073);
// compiled member node returning call2074 (depth = 2)
  gc_frame_end(frame);
  return call2074;
}
Object meth_collectionsPrelude__apply_40_1_41_2092(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_newInner = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1126
  setline(1126);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2093 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile call node (depth = 5)
  int callframe2094 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2095 = gc_frame_new();
// call case 4: self request
  Object call2096 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2095);
// compiled member node returning call2096 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2097 = callmethodflags(call2096, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2094);
// compiled call node returning call2097 (depth = 5)
  gc_frame_newslot(call2097);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newInner (depth = 5)
  params[0] = *var_i;
  params[1] = call2097;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2098 = callmethodflags(*var_newInner, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2093);
// compiled call node returning call2098 (depth = 4)
  gc_frame_end(frame);
  return call2098;
}
Object meth_collectionsPrelude_expandTo_40_1_41_2075(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 34, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expandTo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method expandTo(_)");
  Object params[2];
  int partcv[2];
  Object *var__prelude = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for expandTo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_newSize = &(stackframe->slots[0]);
  *var_newSize = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part expandTo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newInner = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newInner");
// Begin line 1124
  setline(1124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2076 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_newSize (depth = 4)
  gc_frame_newslot(*var_newSize);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2077 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var__prelude (depth = 5)
  Object call2078 = callmethodflags(*var__prelude, "primitiveArray", 0, partcv, params, 0);
  gc_frame_end(callframe2077);
// compiled member node returning call2078 (depth = 4)
  params[0] = *var_newSize;
  partcv[0] = 1;
  Object call2079 = callmethodflags(call2078, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2076);
// compiled call node returning call2079 (depth = 3)
  *var_newInner = call2079;
  if (call2079 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1125
  setline(1125);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2080 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2083 = alloc_Float64(1);
// compiled num node returning num2083 (depth = 5)
  int op_slot_right_2082 = gc_frame_newslot(num2083);
// starting to compile member node (depth = 5)
  int callframe2085 = gc_frame_new();
// call case 4: self request
  Object call2086 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2085);
// compiled member node returning call2086 (depth = 5)
  int op_slot_left_2082 = gc_frame_newslot(call2086);
  params[0] = num2083;
  partcv[0] = 1;
  Object diff2087 = callmethod(call2086, "-(1)", 1, partcv, params);
// compiled op node returning diff2087 (depth = 4)
  int op_slot_right_2081 = gc_frame_newslot(diff2087);
// starting to compile num node (depth = 4)
  Object num2089 = alloc_Float64(0);
// compiled num node returning num2089 (depth = 4)
  int op_slot_left_2081 = gc_frame_newslot(num2089);
  params[0] = diff2087;
  partcv[0] = 1;
  Object opresult2090 = callmethod(num2089, "..(1)", 1, partcv, params);
// compiled op node returning opresult2090 (depth = 3)
  gc_frame_newslot(opresult2090);
// starting to compile block node (depth = 3)
  Object block2091 = alloc_Block(NULL, NULL, "collectionsPrelude", 1125);
  gc_frame_newslot(block2091);
// method "_apply(_)"
  block_savedest(block2091);
  Object closure2092 = createclosure(2, "_apply(1)");
  setclosureframe(closure2092, stackframe);
  addtoclosure(closure2092, var_newInner);
  addtoclosure(closure2092, selfslot);
  struct UserObject *uo2092 = (struct UserObject*)block2091;
  uo2092->data[0] = (Object)closure2092;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2092 = addmethod2pos(block2091, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2092, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2092[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2092->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2092);
  meth_meth_collectionsPrelude__apply_40_1_41_2092->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2092->definitionLine = 1963;
// compiled block node returning block2091 (depth = 3)
  gc_frame_newslot(block2091);
// call case 5: prelude request
  params[0] = opresult2090;
  params[1] = block2091;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2100 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2080);
// compiled call node returning call2100 (depth = 2)
// Begin line 1128
  setline(1128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2101 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_newInner (depth = 3)
  gc_frame_newslot(*var_newInner);
// call case 4: self request
  params[0] = *var_newInner;
  partcv[0] = 1;
  Object call2102 = callmethodflags(self, "inner:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2101);
// compiled call node returning call2102 (depth = 2)
  gc_frame_end(frame);
  return call2102;
}
Object meth_collectionsPrelude_sortBy_40_1_41_2103(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortBy(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortBy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sortBy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1131
  setline(1131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2104 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2106 = alloc_Float64(1);
// compiled num node returning num2106 (depth = 4)
  int op_slot_right_2105 = gc_frame_newslot(num2106);
// starting to compile member node (depth = 4)
  int callframe2108 = gc_frame_new();
// call case 4: self request
  Object call2109 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2108);
// compiled member node returning call2109 (depth = 4)
  int op_slot_left_2105 = gc_frame_newslot(call2109);
  params[0] = num2106;
  partcv[0] = 1;
  Object sum2110 = callmethod(call2109, "+(1)", 1, partcv, params);
// compiled op node returning sum2110 (depth = 3)
  gc_frame_newslot(sum2110);
// call case 4: self request
  params[0] = sum2110;
  partcv[0] = 1;
  Object call2111 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2104);
// compiled call node returning call2111 (depth = 2)
// Begin line 1132
  setline(1132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2112 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe2113 = gc_frame_new();
// call case 4: self request
  Object call2114 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2113);
// compiled member node returning call2114 (depth = 3)
  gc_frame_newslot(call2114);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sortBlock (depth = 3)
  gc_frame_newslot(*var_sortBlock);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2115 = gc_frame_new();
// call case 4: self request
  Object call2116 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2115);
// compiled member node returning call2116 (depth = 3)
  params[0] = call2114;
  params[1] = *var_sortBlock;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2117 = callmethodflags(call2116, "sortInitial(1)by(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2112);
// compiled call node returning call2117 (depth = 2)
// Begin line 1133
  setline(1133);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply_40_2_41_2121(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[1]);
  *var_r = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1137
  setline(1137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_r (depth = 6)
  int op_slot_right_2123 = gc_frame_newslot(*var_r);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_l (depth = 6)
  int op_slot_left_2123 = gc_frame_newslot(*var_l);
  params[0] = *var_r;
  partcv[0] = 1;
  Object opresult2125 = callmethod(*var_l, "==(1)", 1, partcv, params);
// compiled op node returning opresult2125 (depth = 5)
  Object if2122 = done;
  if (istrue(opresult2125)) {
// starting to compile num node (depth = 5)
  Object num2126 = alloc_Float64(0);
// compiled num node returning num2126 (depth = 5)
    gc_frame_newslot(num2126);
    if2122 = num2126;
  } else {
// Begin line 1139
  setline(1139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1138
  setline(1138);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_r (depth = 7)
  int op_slot_right_2128 = gc_frame_newslot(*var_r);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_l (depth = 7)
  int op_slot_left_2128 = gc_frame_newslot(*var_l);
  params[0] = *var_r;
  partcv[0] = 1;
  Object opresult2130 = callmethod(*var_l, "<(1)", 1, partcv, params);
// compiled op node returning opresult2130 (depth = 6)
  Object if2127 = done;
  if (istrue(opresult2130)) {
// starting to compile call node (depth = 6)
  int callframe2131 = gc_frame_new();
// call case 6: other requests
// starting to compile num node (depth = 7)
  Object num2132 = alloc_Float64(1);
// compiled num node returning num2132 (depth = 7)
  partcv[0] = 0;
  Object call2133 = callmethodflags(num2132, "prefix-", 1, partcv, params, 0);
  gc_frame_end(callframe2131);
// compiled call node returning call2133 (depth = 6)
    gc_frame_newslot(call2133);
    if2127 = call2133;
  } else {
// Begin line 1139
  setline(1139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num2134 = alloc_Float64(1);
// compiled num node returning num2134 (depth = 6)
    gc_frame_newslot(num2134);
    if2127 = num2134;
  }
// compiled if node returning if2127 (depth = 5)
    gc_frame_newslot(if2127);
    if2122 = if2127;
  }
// compiled if node returning if2122 (depth = 4)
  gc_frame_end(frame);
  return if2122;
}
Object meth_collectionsPrelude_sort2118(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sort");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1136
  setline(1136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2119 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2120 = alloc_Block(NULL, NULL, "collectionsPrelude", 1136);
  gc_frame_newslot(block2120);
// method "_apply(_,_)"
  block_savedest(block2120);
  Object closure2121 = createclosure(1, "_apply(2)");
  setclosureframe(closure2121, stackframe);
  addtoclosure(closure2121, selfslot);
  struct UserObject *uo2121 = (struct UserObject*)block2120;
  uo2121->data[0] = (Object)closure2121;
  Method *meth_meth_collectionsPrelude__apply_40_2_41_2121 = addmethod2pos(block2120, "_apply(2)", &meth_collectionsPrelude__apply_40_2_41_2121, 0);
  int argcv_meth_collectionsPrelude__apply_40_2_41_2121[] = {2};
  meth_meth_collectionsPrelude__apply_40_2_41_2121->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_2_41_2121);
  meth_meth_collectionsPrelude__apply_40_2_41_2121->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_2_41_2121->definitionLine = 1963;
// compiled block node returning block2120 (depth = 3)
  gc_frame_newslot(block2120);
// call case 4: self request
  params[0] = block2120;
  partcv[0] = 1;
  Object call2136 = callmethodflags(self, "sortBy(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2119);
// compiled call node returning call2136 (depth = 2)
  gc_frame_end(frame);
  return call2136;
}
Object meth_collectionsPrelude_sortedBy_40_1_41_2137(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortedBy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortedBy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sortedBy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1143
  setline(1143);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2138 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sortBlock (depth = 3)
  gc_frame_newslot(*var_sortBlock);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2139 = gc_frame_new();
// call case 4: self request
  Object call2140 = callmethodflags(self, "copy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2139);
// compiled member node returning call2140 (depth = 3)
  params[0] = *var_sortBlock;
  partcv[0] = 1;
  Object call2141 = callmethodflags(call2140, "sortBy(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2138);
// compiled call node returning call2141 (depth = 2)
  gc_frame_end(frame);
  return call2141;
}
Object meth_collectionsPrelude_sorted2142(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1146
  setline(1146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe2143 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2144 = gc_frame_new();
// call case 4: self request
  Object call2145 = callmethodflags(self, "copy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2144);
// compiled member node returning call2145 (depth = 3)
  Object call2146 = callmethodflags(call2145, "sort", 0, partcv, params, 0);
  gc_frame_end(callframe2143);
// compiled member node returning call2146 (depth = 2)
  gc_frame_end(frame);
  return call2146;
}
Object meth_collectionsPrelude_copy2147(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "copy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1149
  setline(1149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2148 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2149 = gc_frame_new();
// call case 3: self.outer request
  Object call2150 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2149);
// compiled member node returning call2150 (depth = 3)
  params[0] = self;
  partcv[0] = 1;
  Object call2151 = callmethodflags(call2150, "withAll(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2148);
// compiled call node returning call2151 (depth = 2)
  gc_frame_end(frame);
  return call2151;
}
Object meth_collectionsPrelude__apply2164(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe2165 = gc_frame_new();
// starting to compile identifier node (depth = 7)
  Object bool2166 = alloc_Boolean(0);
// compiled identifier node returning bool2166 (depth = 7)
  gc_frame_newslot(bool2166);
// call case 4: self request
  params[0] = bool2166;
  partcv[0] = 1;
  Object call2167 = callmethodflags(self, "sizeCertain:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2165);
// compiled call node returning call2167 (depth = 6)
// starting to compile num node (depth = 6)
  Object num2168 = alloc_Float64(4);
// compiled num node returning num2168 (depth = 6)
  gc_frame_end(frame);
  return num2168;
}
Object meth_collectionsPrelude__apply_40_1_41_2185(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 900
  setline(900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2186 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe2187 = gc_frame_new();
// call case 4: self request
  Object call2188 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2187);
// compiled member node returning call2188 (depth = 6)
  gc_frame_newslot(call2188);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  gc_frame_newslot(*var_x);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2189 = gc_frame_new();
// call case 4: self request
  Object call2190 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2189);
// compiled member node returning call2190 (depth = 6)
  params[0] = call2188;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2191 = callmethodflags(call2190, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2186);
// compiled call node returning call2191 (depth = 5)
// Begin line 901
  setline(901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2192 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2194 = alloc_Float64(1);
// compiled num node returning num2194 (depth = 7)
  int op_slot_right_2193 = gc_frame_newslot(num2194);
// starting to compile member node (depth = 7)
  int callframe2196 = gc_frame_new();
// call case 4: self request
  Object call2197 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2196);
// compiled member node returning call2197 (depth = 7)
  int op_slot_left_2193 = gc_frame_newslot(call2197);
  params[0] = num2194;
  partcv[0] = 1;
  Object sum2198 = callmethod(call2197, "+(1)", 1, partcv, params);
// compiled op node returning sum2198 (depth = 6)
  gc_frame_newslot(sum2198);
// call case 4: self request
  params[0] = sum2198;
  partcv[0] = 1;
  Object call2199 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2192);
// compiled call node returning call2199 (depth = 5)
  gc_frame_end(frame);
  return call2199;
}
Object meth_collectionsPrelude__apply_40_1_41_2231(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_newInner = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 910
  setline(910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2232 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  gc_frame_newslot(*var_i);
// starting to compile call node (depth = 9)
  int callframe2233 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 10)
  int callframe2234 = gc_frame_new();
// call case 4: self request
  Object call2235 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2234);
// compiled member node returning call2235 (depth = 10)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2236 = callmethodflags(call2235, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2233);
// compiled call node returning call2236 (depth = 9)
  gc_frame_newslot(call2236);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_newInner (depth = 9)
  params[0] = *var_i;
  params[1] = call2236;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2237 = callmethodflags(*var_newInner, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2232);
// compiled call node returning call2237 (depth = 8)
  gc_frame_end(frame);
  return call2237;
}
Object meth_collectionsPrelude__apply_40_1_41_2206(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_innerSize = getfromclosure(closure, 0);
  Object *var__prelude = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newInner = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newInner");
// Begin line 907
  setline(907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe2209 = gc_frame_new();
// call case 4: self request
  Object call2210 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2209);
// compiled member node returning call2210 (depth = 7)
  int op_slot_right_2208 = gc_frame_newslot(call2210);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_innerSize (depth = 7)
  int op_slot_left_2208 = gc_frame_newslot(*var_innerSize);
  params[0] = call2210;
  partcv[0] = 1;
  Object opresult2212 = callmethod(*var_innerSize, "≤(1)", 1, partcv, params);
// compiled op node returning opresult2212 (depth = 6)
  Object if2207 = done;
  if (istrue(opresult2212)) {
// Begin line 908
  setline(908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2213 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2215 = alloc_Float64(2);
// compiled num node returning num2215 (depth = 9)
  int op_slot_right_2214 = gc_frame_newslot(num2215);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_innerSize (depth = 9)
  int op_slot_left_2214 = gc_frame_newslot(*var_innerSize);
  params[0] = num2215;
  partcv[0] = 1;
  Object prod2217 = callmethod(*var_innerSize, "*(1)", 1, partcv, params);
// compiled op node returning prod2217 (depth = 8)
  gc_frame_newslot(prod2217);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe2218 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var__prelude (depth = 9)
  Object call2219 = callmethodflags(*var__prelude, "primitiveArray", 0, partcv, params, 0);
  gc_frame_end(callframe2218);
// compiled member node returning call2219 (depth = 8)
  params[0] = prod2217;
  partcv[0] = 1;
  Object call2220 = callmethodflags(call2219, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2213);
// compiled call node returning call2220 (depth = 7)
  *var_newInner = call2220;
  if (call2220 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 6)
// Begin line 909
  setline(909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2221 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2224 = alloc_Float64(1);
// compiled num node returning num2224 (depth = 9)
  int op_slot_right_2223 = gc_frame_newslot(num2224);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_innerSize (depth = 9)
  int op_slot_left_2223 = gc_frame_newslot(*var_innerSize);
  params[0] = num2224;
  partcv[0] = 1;
  Object diff2226 = callmethod(*var_innerSize, "-(1)", 1, partcv, params);
// compiled op node returning diff2226 (depth = 8)
  int op_slot_right_2222 = gc_frame_newslot(diff2226);
// starting to compile num node (depth = 8)
  Object num2228 = alloc_Float64(0);
// compiled num node returning num2228 (depth = 8)
  int op_slot_left_2222 = gc_frame_newslot(num2228);
  params[0] = diff2226;
  partcv[0] = 1;
  Object opresult2229 = callmethod(num2228, "..(1)", 1, partcv, params);
// compiled op node returning opresult2229 (depth = 7)
  gc_frame_newslot(opresult2229);
// starting to compile block node (depth = 7)
  Object block2230 = alloc_Block(NULL, NULL, "collectionsPrelude", 909);
  gc_frame_newslot(block2230);
// method "_apply(_)"
  block_savedest(block2230);
  Object closure2231 = createclosure(2, "_apply(1)");
  setclosureframe(closure2231, stackframe);
  addtoclosure(closure2231, var_newInner);
  addtoclosure(closure2231, selfslot);
  struct UserObject *uo2231 = (struct UserObject*)block2230;
  uo2231->data[0] = (Object)closure2231;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2231 = addmethod2pos(block2230, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2231, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2231[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2231->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2231);
  meth_meth_collectionsPrelude__apply_40_1_41_2231->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2231->definitionLine = 1963;
// compiled block node returning block2230 (depth = 7)
  gc_frame_newslot(block2230);
// call case 5: prelude request
  params[0] = opresult2229;
  params[1] = block2230;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2239 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2221);
// compiled call node returning call2239 (depth = 6)
// Begin line 912
  setline(912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2240 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newInner (depth = 7)
  gc_frame_newslot(*var_newInner);
// call case 4: self request
  params[0] = *var_newInner;
  partcv[0] = 1;
  Object call2241 = callmethodflags(self, "inner:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2240);
// compiled call node returning call2241 (depth = 6)
// Begin line 913
  setline(913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe2242 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe2243 = gc_frame_new();
// call case 4: self request
  Object call2244 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2243);
// compiled member node returning call2244 (depth = 8)
  Object call2245 = callmethodflags(call2244, "size", 0, partcv, params, 0);
  gc_frame_end(callframe2242);
// compiled member node returning call2245 (depth = 7)
  *var_innerSize = call2245;
  if (call2245 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if2207 = done;
  } else {
  }
// compiled if node returning if2207 (depth = 5)
// Begin line 915
  setline(915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2247 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe2248 = gc_frame_new();
// call case 4: self request
  Object call2249 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2248);
// compiled member node returning call2249 (depth = 6)
  gc_frame_newslot(call2249);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  gc_frame_newslot(*var_x);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2250 = gc_frame_new();
// call case 4: self request
  Object call2251 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2250);
// compiled member node returning call2251 (depth = 6)
  params[0] = call2249;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2252 = callmethodflags(call2251, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2247);
// compiled call node returning call2252 (depth = 5)
// Begin line 916
  setline(916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2253 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2255 = alloc_Float64(1);
// compiled num node returning num2255 (depth = 7)
  int op_slot_right_2254 = gc_frame_newslot(num2255);
// starting to compile member node (depth = 7)
  int callframe2257 = gc_frame_new();
// call case 4: self request
  Object call2258 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2257);
// compiled member node returning call2258 (depth = 7)
  int op_slot_left_2254 = gc_frame_newslot(call2258);
  params[0] = num2255;
  partcv[0] = 1;
  Object sum2259 = callmethod(call2258, "+(1)", 1, partcv, params);
// compiled op node returning sum2259 (depth = 6)
  gc_frame_newslot(sum2259);
// call case 4: self request
  params[0] = sum2259;
  partcv[0] = 1;
  Object call2260 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2253);
// compiled call node returning call2260 (depth = 5)
  gc_frame_end(frame);
  return call2260;
}
Object meth_collectionsPrelude_withAll_40_1_41_714(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "withAll(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method withAll(_)");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_done = getfromclosure(closure, 1);
  Object *var_ConcurrentModification = getfromclosure(closure, 2);
  Object *var_IteratorExhausted = getfromclosure(closure, 3);
  Object *var_indexable = getfromclosure(closure, 4);
  Object *var_BoundsError = getfromclosure(closure, 5);
  Object *var__prelude = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for withAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 627
  setline(627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit717 == NULL) {
    strlit717 = alloc_String("js");
    gc_root(strlit717);
  }
// compiled string node returning strlit717 (depth = 4)
  int op_slot_right_716 = gc_frame_newslot(strlit717);
// starting to compile member node (depth = 4)
  int callframe719 = gc_frame_new();
// call case 5: prelude request
  Object call720 = callmethodflags(prelude, "engine", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe719);
// compiled member node returning call720 (depth = 4)
  int op_slot_left_716 = gc_frame_newslot(call720);
  params[0] = strlit717;
  partcv[0] = 1;
  Object opresult721 = callmethod(call720, "==(1)", 1, partcv, params);
// compiled op node returning opresult721 (depth = 3)
  Object if715 = done;
  if (istrue(opresult721)) {
// Begin line 628
  setline(628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
// compiled call node returning done (depth = 4)
  Object if722 = done;
  if (istrue(done)) {
// Begin line 629
  setline(629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject723 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj723 = alloc_userobj2(42,40, objclass723);
  gc_frame_newslot(obj723);
// OBJECT OUTER DEC outer
  adddatum2(obj723, self, 0);
  addmethodreal(obj723,"outer", &reader_collectionsPrelude_outer_724);
  Object oldself723 = self;
  struct StackFrameObject *oldstackframe723 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe723);
  gc_frame_newslot((Object)stackframe);
  self = obj723;
  Object *oldselfslot723 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter723 = (*(struct UserObject *)self).data[0], lowerouter723 = thisouter723;
  if (inheritingObject723) {
    struct UserObject *inho723 = (struct UserObject *)inheritingObject723;
    while (inho723->super != GraceDefaultObject) inho723 = (struct UserObject *)inho723->super;
    inho723->super = obj723;
    self = inheritingObject723;
    *selfslot = self;
    lowerouter723 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter723;
  }
if (objclass723 == NULL) {
  Method *reader725 = addmethodrealflags(obj723, "mods", &reader_collectionsPrelude_mods_725, 0);
  Method *writer725 = addmethodrealflags(obj723, "mods:=(1)", &writer_collectionsPrelude_mods_725, MFLAG_CONFIDENTIAL);
  reader725->definitionModule = modulename;
  writer725->definitionModule = modulename;
  reader725->definitionLine = 632;
  writer725->definitionLine = 632;
}
obj723->flags |= OFLAG_MUTABLE;
adddatum2(obj723, alloc_Undefined(), 1);
if (objclass723 == NULL) {
  Method *reader726 = addmethodrealflags(obj723, "sz", &reader_collectionsPrelude_sz_726, MFLAG_CONFIDENTIAL);
  Method *writer726 = addmethodrealflags(obj723, "sz:=(1)", &writer_collectionsPrelude_sz_726, MFLAG_CONFIDENTIAL);
  reader726->definitionModule = modulename;
  writer726->definitionModule = modulename;
  reader726->definitionLine = 633;
  writer726->definitionLine = 633;
}
obj723->flags |= OFLAG_MUTABLE;
adddatum2(obj723, alloc_Undefined(), 2);
if (objclass723 == NULL) {
  Method *reader727 = addmethodrealflags(obj723, "jsArray", &reader_collectionsPrelude_jsArray_727, MFLAG_CONFIDENTIAL);
  Method *writer727 = addmethodrealflags(obj723, "jsArray:=(1)", &writer_collectionsPrelude_jsArray_727, MFLAG_CONFIDENTIAL);
  reader727->definitionModule = modulename;
  writer727->definitionModule = modulename;
  reader727->definitionLine = 634;
  writer727->definitionLine = 634;
}
obj723->flags |= OFLAG_MUTABLE;
adddatum2(obj723, alloc_Undefined(), 3);
// method "size"
  struct UserObject *uo728 = (struct UserObject*)obj723;
  uo728->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_size728 = addmethod2pos(obj723, "size", &meth_collectionsPrelude_size728, 4);
  int argcv_meth_collectionsPrelude_size728[] = {0};
  meth_meth_collectionsPrelude_size728->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size728);
  meth_meth_collectionsPrelude_size728->definitionModule = modulename;
  meth_meth_collectionsPrelude_size728->definitionLine = 639;
// method "at(_)"
  struct UserObject *uo731 = (struct UserObject*)obj723;
  uo731->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40_1_41_731 = addmethod2pos(obj723, "at(1)", &meth_collectionsPrelude_at_40_1_41_731, 5);
  int argcv_meth_collectionsPrelude_at_40_1_41_731[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_731->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_731);
  meth_meth_collectionsPrelude_at_40_1_41_731->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_731->definitionLine = 644;
// method "at(_)put(_)"
  struct UserObject *uo732 = (struct UserObject*)obj723;
  uo732->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_732 = addmethod2pos(obj723, "at(1)put(1)", &meth_collectionsPrelude_at_40_1_41_put_40_1_41_732, 6);
  int argcv_meth_collectionsPrelude_at_40_1_41_put_40_1_41_732[] = {1, 1};
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_732->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40_1_41_put_40_1_41_732);
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_732->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_732->definitionLine = 654;
// method "add(_)"
  struct UserObject *uo741 = (struct UserObject*)obj723;
  uo741->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_add_40_1_41_741 = addmethod2pos(obj723, "add(1)", &meth_collectionsPrelude_add_40_1_41_741, 7);
  int argcv_meth_collectionsPrelude_add_40_1_41_741[] = {1};
  meth_meth_collectionsPrelude_add_40_1_41_741->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add_40_1_41_741);
  meth_meth_collectionsPrelude_add_40_1_41_741->definitionModule = modulename;
  meth_meth_collectionsPrelude_add_40_1_41_741->definitionLine = 666;
// method "push(_)"
  struct UserObject *uo750 = (struct UserObject*)obj723;
  uo750->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_push_40_1_41_750 = addmethod2pos(obj723, "push(1)", &meth_collectionsPrelude_push_40_1_41_750, 8);
  int argcv_meth_collectionsPrelude_push_40_1_41_750[] = {1};
  meth_meth_collectionsPrelude_push_40_1_41_750->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_push_40_1_41_750);
  meth_meth_collectionsPrelude_push_40_1_41_750->definitionModule = modulename;
  meth_meth_collectionsPrelude_push_40_1_41_750->definitionLine = 672;
// method "removeLast"
  struct UserObject *uo759 = (struct UserObject*)obj723;
  uo759->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeLast759 = addmethod2pos(obj723, "removeLast", &meth_collectionsPrelude_removeLast759, 9);
  int argcv_meth_collectionsPrelude_removeLast759[] = {0};
  meth_meth_collectionsPrelude_removeLast759->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeLast759);
  meth_meth_collectionsPrelude_removeLast759->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeLast759->definitionLine = 678;
// method "addAllFirst(_)"
  struct UserObject *uo768 = (struct UserObject*)obj723;
  uo768->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAllFirst_40_1_41_768 = addmethod2pos(obj723, "addAllFirst(1)", &meth_collectionsPrelude_addAllFirst_40_1_41_768, 10);
  int argcv_meth_collectionsPrelude_addAllFirst_40_1_41_768[] = {1};
  meth_meth_collectionsPrelude_addAllFirst_40_1_41_768->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAllFirst_40_1_41_768);
  meth_meth_collectionsPrelude_addAllFirst_40_1_41_768->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAllFirst_40_1_41_768->definitionLine = 688;
// method "removeAt(_)"
  struct UserObject *uo798 = (struct UserObject*)obj723;
  uo798->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAt_40_1_41_798 = addmethod2pos(obj723, "removeAt(1)", &meth_collectionsPrelude_removeAt_40_1_41_798, 11);
  int argcv_meth_collectionsPrelude_removeAt_40_1_41_798[] = {1};
  meth_meth_collectionsPrelude_removeAt_40_1_41_798->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAt_40_1_41_798);
  meth_meth_collectionsPrelude_removeAt_40_1_41_798->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAt_40_1_41_798->definitionLine = 699;
// method "sortBy(_)"
  struct UserObject *uo809 = (struct UserObject*)obj723;
  uo809->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortBy_40_1_41_809 = addmethod2pos(obj723, "sortBy(1)", &meth_collectionsPrelude_sortBy_40_1_41_809, 12);
  int argcv_meth_collectionsPrelude_sortBy_40_1_41_809[] = {1};
  meth_meth_collectionsPrelude_sortBy_40_1_41_809->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortBy_40_1_41_809);
  meth_meth_collectionsPrelude_sortBy_40_1_41_809->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortBy_40_1_41_809->definitionLine = 706;
// method "addLast(_)"
  struct UserObject *uo818 = (struct UserObject*)obj723;
  uo818->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addLast_40_1_41_818 = addmethod2pos(obj723, "addLast(1)", &meth_collectionsPrelude_addLast_40_1_41_818, 13);
  int argcv_meth_collectionsPrelude_addLast_40_1_41_818[] = {1};
  meth_meth_collectionsPrelude_addLast_40_1_41_818->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addLast_40_1_41_818);
  meth_meth_collectionsPrelude_addLast_40_1_41_818->definitionModule = modulename;
  meth_meth_collectionsPrelude_addLast_40_1_41_818->definitionLine = 720;
// method "addAll(_)"
  struct UserObject *uo821 = (struct UserObject*)obj723;
  uo821->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAll_40_1_41_821 = addmethod2pos(obj723, "addAll(1)", &meth_collectionsPrelude_addAll_40_1_41_821, 14);
  int argcv_meth_collectionsPrelude_addAll_40_1_41_821[] = {1};
  meth_meth_collectionsPrelude_addAll_40_1_41_821->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAll_40_1_41_821);
  meth_meth_collectionsPrelude_addAll_40_1_41_821->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAll_40_1_41_821->definitionLine = 721;
// method "addFirst(_)"
  struct UserObject *uo829 = (struct UserObject*)obj723;
  uo829->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addFirst_40_1_41_829 = addmethod2pos(obj723, "addFirst(1)", &meth_collectionsPrelude_addFirst_40_1_41_829, 15);
  int argcv_meth_collectionsPrelude_addFirst_40_1_41_829[] = {1};
  meth_meth_collectionsPrelude_addFirst_40_1_41_829->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addFirst_40_1_41_829);
  meth_meth_collectionsPrelude_addFirst_40_1_41_829->definitionModule = modulename;
  meth_meth_collectionsPrelude_addFirst_40_1_41_829->definitionLine = 726;
// method "removeFirst"
  struct UserObject *uo838 = (struct UserObject*)obj723;
  uo838->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeFirst838 = addmethod2pos(obj723, "removeFirst", &meth_collectionsPrelude_removeFirst838, 16);
  int argcv_meth_collectionsPrelude_removeFirst838[] = {0};
  meth_meth_collectionsPrelude_removeFirst838->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeFirst838);
  meth_meth_collectionsPrelude_removeFirst838->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeFirst838->definitionLine = 732;
// method "remove(_)"
  block_savedest(obj723);
  Object closure842 = createclosure(1, "remove(1)");
  setclosureframe(closure842, stackframe);
  addtoclosure(closure842, var_NoSuchObject);
  struct UserObject *uo842 = (struct UserObject*)obj723;
  uo842->data[17] = (Object)closure842;
  Method *meth_meth_collectionsPrelude_remove_40_1_41_842 = addmethod2pos(obj723, "remove(1)", &meth_collectionsPrelude_remove_40_1_41_842, 17);
  int argcv_meth_collectionsPrelude_remove_40_1_41_842[] = {1};
  meth_meth_collectionsPrelude_remove_40_1_41_842->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_remove_40_1_41_842);
  meth_meth_collectionsPrelude_remove_40_1_41_842->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40_1_41_842->definitionLine = 737;
// method "remove(_)ifAbsent(_)"
  struct UserObject *uo860 = (struct UserObject*)obj723;
  uo860->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_860 = addmethod2pos(obj723, "remove(1)ifAbsent(1)", &meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_860, 18);
  int argcv_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_860[] = {1, 1};
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_860->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_860);
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_860->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_860->definitionLine = 746;
// method "removeAll(_)"
  block_savedest(obj723);
  Object closure870 = createclosure(1, "removeAll(1)");
  setclosureframe(closure870, stackframe);
  addtoclosure(closure870, var_NoSuchObject);
  struct UserObject *uo870 = (struct UserObject*)obj723;
  uo870->data[19] = (Object)closure870;
  Method *meth_meth_collectionsPrelude_removeAll_40_1_41_870 = addmethod2pos(obj723, "removeAll(1)", &meth_collectionsPrelude_removeAll_40_1_41_870, 19);
  int argcv_meth_collectionsPrelude_removeAll_40_1_41_870[] = {1};
  meth_meth_collectionsPrelude_removeAll_40_1_41_870->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAll_40_1_41_870);
  meth_meth_collectionsPrelude_removeAll_40_1_41_870->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40_1_41_870->definitionLine = 754;
// method "removeAll(_)ifAbsent(_)"
  struct UserObject *uo879 = (struct UserObject*)obj723;
  uo879->data[20] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_879 = addmethod2pos(obj723, "removeAll(1)ifAbsent(1)", &meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_879, 20);
  int argcv_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_879[] = {1, 1};
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_879->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_879);
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_879->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_879->definitionLine = 759;
// method "pop"
  struct UserObject *uo900 = (struct UserObject*)obj723;
  uo900->data[21] = emptyclosure;
  Method *meth_meth_collectionsPrelude_pop900 = addmethod2pos(obj723, "pop", &meth_collectionsPrelude_pop900, 21);
  int argcv_meth_collectionsPrelude_pop900[] = {0};
  meth_meth_collectionsPrelude_pop900->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_pop900);
  meth_meth_collectionsPrelude_pop900->definitionModule = modulename;
  meth_meth_collectionsPrelude_pop900->definitionLine = 771;
// method "reversed"
  struct UserObject *uo903 = (struct UserObject*)obj723;
  uo903->data[22] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reversed903 = addmethod2pos(obj723, "reversed", &meth_collectionsPrelude_reversed903, 22);
  int argcv_meth_collectionsPrelude_reversed903[] = {0};
  meth_meth_collectionsPrelude_reversed903->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed903);
  meth_meth_collectionsPrelude_reversed903->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed903->definitionLine = 773;
// method "reverse"
  struct UserObject *uo919 = (struct UserObject*)obj723;
  uo919->data[23] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reverse919 = addmethod2pos(obj723, "reverse", &meth_collectionsPrelude_reverse919, 23);
  int argcv_meth_collectionsPrelude_reverse919[] = {0};
  meth_meth_collectionsPrelude_reverse919->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reverse919);
  meth_meth_collectionsPrelude_reverse919->definitionModule = modulename;
  meth_meth_collectionsPrelude_reverse919->definitionLine = 778;
// method "++(_)"
  struct UserObject *uo960 = (struct UserObject*)obj723;
  uo960->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_960 = addmethod2pos(obj723, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_960, 24);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_960[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_960->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_960);
  meth_meth_collectionsPrelude__43__43__40_1_41_960->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_960->definitionLine = 792;
// method "asString"
  struct UserObject *uo971 = (struct UserObject*)obj723;
  uo971->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString971 = addmethod2pos(obj723, "asString", &meth_collectionsPrelude_asString971, 25);
  int argcv_meth_collectionsPrelude_asString971[] = {0};
  meth_meth_collectionsPrelude_asString971->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString971);
  meth_meth_collectionsPrelude_asString971->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString971->definitionLine = 798;
// method "asDebugString"
  struct UserObject *uo1005 = (struct UserObject*)obj723;
  uo1005->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString1005 = addmethod2pos(obj723, "asDebugString", &meth_collectionsPrelude_asDebugString1005, 26);
  int argcv_meth_collectionsPrelude_asDebugString1005[] = {0};
  meth_meth_collectionsPrelude_asDebugString1005->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString1005);
  meth_meth_collectionsPrelude_asDebugString1005->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString1005->definitionLine = 808;
// method "extend(_)"
  block_savedest(obj723);
  Object closure1039 = createclosure(1, "extend(1)");
  setclosureframe(closure1039, stackframe);
  addtoclosure(closure1039, var_done);
  struct UserObject *uo1039 = (struct UserObject*)obj723;
  uo1039->data[27] = (Object)closure1039;
  Method *meth_meth_collectionsPrelude_extend_40_1_41_1039 = addmethod2pos(obj723, "extend(1)", &meth_collectionsPrelude_extend_40_1_41_1039, 27);
  int argcv_meth_collectionsPrelude_extend_40_1_41_1039[] = {1};
  meth_meth_collectionsPrelude_extend_40_1_41_1039->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_extend_40_1_41_1039);
  meth_meth_collectionsPrelude_extend_40_1_41_1039->definitionModule = modulename;
  meth_meth_collectionsPrelude_extend_40_1_41_1039->definitionLine = 818;
// method "contains(_)"
  struct UserObject *uo1042 = (struct UserObject*)obj723;
  uo1042->data[28] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_1042 = addmethod2pos(obj723, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_1042, 28);
  int argcv_meth_collectionsPrelude_contains_40_1_41_1042[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_1042->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_1042);
  meth_meth_collectionsPrelude_contains_40_1_41_1042->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_1042->definitionLine = 821;
// method "do(_)"
  struct UserObject *uo1054 = (struct UserObject*)obj723;
  uo1054->data[29] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_1054 = addmethod2pos(obj723, "do(1)", &meth_collectionsPrelude_do_40_1_41_1054, 29);
  int argcv_meth_collectionsPrelude_do_40_1_41_1054[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_1054->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_1054);
  meth_meth_collectionsPrelude_do_40_1_41_1054->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_1054->definitionLine = 826;
// method "==(_)"
  struct UserObject *uo1078 = (struct UserObject*)obj723;
  uo1078->data[30] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_1078 = addmethod2pos(obj723, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_1078, 30);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_1078[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_1078->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_1078);
  meth_meth_collectionsPrelude__61__61__40_1_41_1078->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_1078->definitionLine = 835;
// method "iterator"
  block_savedest(obj723);
  Object closure1085 = createclosure(2, "iterator");
  setclosureframe(closure1085, stackframe);
  addtoclosure(closure1085, var_ConcurrentModification);
  addtoclosure(closure1085, var_IteratorExhausted);
  struct UserObject *uo1085 = (struct UserObject*)obj723;
  uo1085->data[31] = (Object)closure1085;
  Method *meth_meth_collectionsPrelude_iterator1085 = addmethod2pos(obj723, "iterator", &meth_collectionsPrelude_iterator1085, 31);
  int argcv_meth_collectionsPrelude_iterator1085[] = {0};
  meth_meth_collectionsPrelude_iterator1085->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator1085);
  meth_meth_collectionsPrelude_iterator1085->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator1085->definitionLine = 839;
  block_savedest(obj723);
  Object closure1169 = createclosure(2, "iterator$object(1)");
  setclosureframe(closure1169, stackframe);
  addtoclosure(closure1169, var_ConcurrentModification);
  addtoclosure(closure1169, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_iterator1085_object = addmethod2pos(obj723, "iterator$object(1)", &meth_collectionsPrelude_iterator1085_object, 31);
  meth_meth_collectionsPrelude_iterator1085_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator1085_object->definitionLine = 839;
// method "values"
  struct UserObject *uo1170 = (struct UserObject*)obj723;
  uo1170->data[32] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values1170 = addmethod2pos(obj723, "values", &meth_collectionsPrelude_values1170, 32);
  int argcv_meth_collectionsPrelude_values1170[] = {0};
  meth_meth_collectionsPrelude_values1170->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values1170);
  meth_meth_collectionsPrelude_values1170->definitionModule = modulename;
  meth_meth_collectionsPrelude_values1170->definitionLine = 858;
// method "keys"
  struct UserObject *uo1171 = (struct UserObject*)obj723;
  uo1171->data[33] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys1171 = addmethod2pos(obj723, "keys", &meth_collectionsPrelude_keys1171, 33);
  int argcv_meth_collectionsPrelude_keys1171[] = {0};
  meth_meth_collectionsPrelude_keys1171->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys1171);
  meth_meth_collectionsPrelude_keys1171->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys1171->definitionLine = 862;
// method "sort"
  struct UserObject *uo1174 = (struct UserObject*)obj723;
  uo1174->data[34] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sort1174 = addmethod2pos(obj723, "sort", &meth_collectionsPrelude_sort1174, 34);
  int argcv_meth_collectionsPrelude_sort1174[] = {0};
  meth_meth_collectionsPrelude_sort1174->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sort1174);
  meth_meth_collectionsPrelude_sort1174->definitionModule = modulename;
  meth_meth_collectionsPrelude_sort1174->definitionLine = 866;
// method "sortedBy(_)"
  struct UserObject *uo1201 = (struct UserObject*)obj723;
  uo1201->data[35] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy_40_1_41_1201 = addmethod2pos(obj723, "sortedBy(1)", &meth_collectionsPrelude_sortedBy_40_1_41_1201, 35);
  int argcv_meth_collectionsPrelude_sortedBy_40_1_41_1201[] = {1};
  meth_meth_collectionsPrelude_sortedBy_40_1_41_1201->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy_40_1_41_1201);
  meth_meth_collectionsPrelude_sortedBy_40_1_41_1201->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy_40_1_41_1201->definitionLine = 874;
// method "sorted"
  struct UserObject *uo1206 = (struct UserObject*)obj723;
  uo1206->data[36] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted1206 = addmethod2pos(obj723, "sorted", &meth_collectionsPrelude_sorted1206, 36);
  int argcv_meth_collectionsPrelude_sorted1206[] = {0};
  meth_meth_collectionsPrelude_sorted1206->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted1206);
  meth_meth_collectionsPrelude_sorted1206->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted1206->definitionLine = 877;
// method "copy"
  struct UserObject *uo1211 = (struct UserObject*)obj723;
  uo1211->data[37] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy1211 = addmethod2pos(obj723, "copy", &meth_collectionsPrelude_copy1211, 37);
  int argcv_meth_collectionsPrelude_copy1211[] = {0};
  meth_meth_collectionsPrelude_copy1211->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy1211);
  meth_meth_collectionsPrelude_copy1211->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy1211->definitionLine = 880;
  sourceObject = obj723;
// Begin line 630
  setline(630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1216 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_indexable (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1217 = callmethodflags(*var_indexable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1216);
// compiled call node returning call1217 (depth = 6)
  struct UserObject *obj723_uo = (struct UserObject *)obj723;
  obj723_uo->super = call1217;
  sourceObject = obj723;
// Begin line 632
  setline(632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num1218 = alloc_Float64(0);
// compiled num node returning num1218 (depth = 6)
  adddatum2(obj723, num1218, 1);
  sourceObject = obj723;
// Begin line 633
  setline(633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num1219 = alloc_Float64(0);
// compiled num node returning num1219 (depth = 6)
  adddatum2(obj723, num1219, 2);
  sourceObject = obj723;
// Begin line 634
  setline(634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
  adddatum2(obj723, done, 3);
  sourceObject = obj723;
// Begin line 635
  setline(635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1220 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block1221 = alloc_Block(NULL, NULL, "collectionsPrelude", 635);
  gc_frame_newslot(block1221);
// method "_apply(_)"
  block_savedest(block1221);
  Object closure1222 = createclosure(1, "_apply(1)");
  setclosureframe(closure1222, stackframe);
  addtoclosure(closure1222, selfslot);
  struct UserObject *uo1222 = (struct UserObject*)block1221;
  uo1222->data[0] = (Object)closure1222;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_1222 = addmethod2pos(block1221, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_1222, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_1222[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_1222->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_1222);
  meth_meth_collectionsPrelude__apply_40_1_41_1222->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_1222->definitionLine = 1963;
// compiled block node returning block1221 (depth = 7)
  gc_frame_newslot(block1221);
// call case 6: other requests
// Begin line 635
  setline(635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  params[0] = block1221;
  partcv[0] = 1;
  Object call1224 = callmethodflags(*var_a, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1220);
// compiled call node returning call1224 (depth = 6)
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  objclass723 = obj723->class;
  objclass723->definitionModule = modulename;
  objclass723->definitionLine = 629;
  (*(struct UserObject *)self).data[0] = lowerouter723;
  self = oldself723;
  selfslot = oldselfslot723;
  stackframe = oldstackframe723;
// compiled object node returning obj723 (depth = 5)
  return obj723;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if722 = undefined;
  } else {
  }
// compiled if node returning if722 (depth = 3)
    gc_frame_newslot(if722);
    if715 = if722;
  } else {
  }
// compiled if node returning if715 (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1225 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1225 = alloc_userobj2(45,42, objclass1225);
  gc_frame_newslot(obj1225);
if (objclass1225 == NULL) {
  glfree(obj1225->class->name);
  obj1225->class->name = "list.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1225, self, 0);
  addmethodreal(obj1225,"outer", &reader_collectionsPrelude_outer_1226);
  Object oldself1225 = self;
  struct StackFrameObject *oldstackframe1225 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1225);
  gc_frame_newslot((Object)stackframe);
  self = obj1225;
  Object *oldselfslot1225 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1225 = (*(struct UserObject *)self).data[0], lowerouter1225 = thisouter1225;
  if (inheritingObject1225) {
    struct UserObject *inho1225 = (struct UserObject *)inheritingObject1225;
    while (inho1225->super != GraceDefaultObject) inho1225 = (struct UserObject *)inho1225->super;
    inho1225->super = obj1225;
    self = inheritingObject1225;
    *selfslot = self;
    lowerouter1225 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1225;
  }
if (objclass1225 == NULL) {
  Method *reader1227 = addmethodrealflags(obj1225, "mods", &reader_collectionsPrelude_mods_1227, 0);
  Method *writer1227 = addmethodrealflags(obj1225, "mods:=(1)", &writer_collectionsPrelude_mods_1227, MFLAG_CONFIDENTIAL);
  reader1227->definitionModule = modulename;
  writer1227->definitionModule = modulename;
  reader1227->definitionLine = 891;
  writer1227->definitionLine = 891;
}
obj1225->flags |= OFLAG_MUTABLE;
adddatum2(obj1225, alloc_Undefined(), 1);
if (objclass1225 == NULL) {
  Method *reader1228 = addmethodrealflags(obj1225, "sizeCertain", &reader_collectionsPrelude_sizeCertain_1228, MFLAG_CONFIDENTIAL);
  Method *writer1228 = addmethodrealflags(obj1225, "sizeCertain:=(1)", &writer_collectionsPrelude_sizeCertain_1228, MFLAG_CONFIDENTIAL);
  reader1228->definitionModule = modulename;
  writer1228->definitionModule = modulename;
  reader1228->definitionLine = 892;
  writer1228->definitionLine = 892;
}
obj1225->flags |= OFLAG_MUTABLE;
adddatum2(obj1225, alloc_Undefined(), 2);
if (objclass1225 == NULL) {
  Method *reader1229 = addmethodrealflags(obj1225, "initialSize",&reader_collectionsPrelude_initialSize_1229, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader1229->definitionModule = modulename;
  reader1229->definitionLine = 894;
}
adddatum2(obj1225, alloc_Undefined(), 3);
if (objclass1225 == NULL) {
  Method *reader1230 = addmethodrealflags(obj1225, "inner", &reader_collectionsPrelude_inner_1230, MFLAG_CONFIDENTIAL);
  Method *writer1230 = addmethodrealflags(obj1225, "inner:=(1)", &writer_collectionsPrelude_inner_1230, MFLAG_CONFIDENTIAL);
  reader1230->definitionModule = modulename;
  writer1230->definitionModule = modulename;
  reader1230->definitionLine = 895;
  writer1230->definitionLine = 895;
}
obj1225->flags |= OFLAG_MUTABLE;
adddatum2(obj1225, alloc_Undefined(), 4);
if (objclass1225 == NULL) {
  Method *reader1231 = addmethodrealflags(obj1225, "size", &reader_collectionsPrelude_size_1231, 0);
  Method *writer1231 = addmethodrealflags(obj1225, "size:=(1)", &writer_collectionsPrelude_size_1231, MFLAG_CONFIDENTIAL);
  reader1231->definitionModule = modulename;
  writer1231->definitionModule = modulename;
  reader1231->definitionLine = 896;
  writer1231->definitionLine = 896;
}
obj1225->flags |= OFLAG_MUTABLE;
adddatum2(obj1225, alloc_Undefined(), 5);
// method "boundsCheck(_)"
  block_savedest(obj1225);
  Object closure1232 = createclosure(1, "boundsCheck(1)");
  setclosureframe(closure1232, stackframe);
  addtoclosure(closure1232, var_BoundsError);
  struct UserObject *uo1232 = (struct UserObject*)obj1225;
  uo1232->data[6] = (Object)closure1232;
  Method *meth_meth_collectionsPrelude_boundsCheck_40_1_41_1232 = addmethod2pos(obj1225, "boundsCheck(1)", &meth_collectionsPrelude_boundsCheck_40_1_41_1232, 6);
  int argcv_meth_collectionsPrelude_boundsCheck_40_1_41_1232[] = {1};
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_1232->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_boundsCheck_40_1_41_1232);
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_1232->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_1232->definitionModule = modulename;
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_1232->definitionLine = 919;
// method "at(_)"
  struct UserObject *uo1269 = (struct UserObject*)obj1225;
  uo1269->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40_1_41_1269 = addmethod2pos(obj1225, "at(1)", &meth_collectionsPrelude_at_40_1_41_1269, 7);
  int argcv_meth_collectionsPrelude_at_40_1_41_1269[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_1269->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_1269);
  meth_meth_collectionsPrelude_at_40_1_41_1269->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_1269->definitionLine = 924;
// method "at(_)put(_)"
  struct UserObject *uo1280 = (struct UserObject*)obj1225;
  uo1280->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_1280 = addmethod2pos(obj1225, "at(1)put(1)", &meth_collectionsPrelude_at_40_1_41_put_40_1_41_1280, 8);
  int argcv_meth_collectionsPrelude_at_40_1_41_put_40_1_41_1280[] = {1, 1};
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_1280->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40_1_41_put_40_1_41_1280);
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_1280->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_1280->definitionLine = 928;
// method "add(_)"
  struct UserObject *uo1311 = (struct UserObject*)obj1225;
  uo1311->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_add_40_1_41_1311 = addmethod2pos(obj1225, "add(1)", &meth_collectionsPrelude_add_40_1_41_1311, 9);
  int argcv_meth_collectionsPrelude_add_40_1_41_1311[] = {1};
  meth_meth_collectionsPrelude_add_40_1_41_1311->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add_40_1_41_1311);
  meth_meth_collectionsPrelude_add_40_1_41_1311->definitionModule = modulename;
  meth_meth_collectionsPrelude_add_40_1_41_1311->definitionLine = 938;
// method "addAll(_)"
  struct UserObject *uo1354 = (struct UserObject*)obj1225;
  uo1354->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAll_40_1_41_1354 = addmethod2pos(obj1225, "addAll(1)", &meth_collectionsPrelude_addAll_40_1_41_1354, 10);
  int argcv_meth_collectionsPrelude_addAll_40_1_41_1354[] = {1};
  meth_meth_collectionsPrelude_addAll_40_1_41_1354->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAll_40_1_41_1354);
  meth_meth_collectionsPrelude_addAll_40_1_41_1354->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAll_40_1_41_1354->definitionLine = 945;
// method "push(_)"
  struct UserObject *uo1418 = (struct UserObject*)obj1225;
  uo1418->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_push_40_1_41_1418 = addmethod2pos(obj1225, "push(1)", &meth_collectionsPrelude_push_40_1_41_1418, 11);
  int argcv_meth_collectionsPrelude_push_40_1_41_1418[] = {1};
  meth_meth_collectionsPrelude_push_40_1_41_1418->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_push_40_1_41_1418);
  meth_meth_collectionsPrelude_push_40_1_41_1418->definitionModule = modulename;
  meth_meth_collectionsPrelude_push_40_1_41_1418->definitionLine = 956;
// method "addLast(_)"
  struct UserObject *uo1461 = (struct UserObject*)obj1225;
  uo1461->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addLast_40_1_41_1461 = addmethod2pos(obj1225, "addLast(1)", &meth_collectionsPrelude_addLast_40_1_41_1461, 12);
  int argcv_meth_collectionsPrelude_addLast_40_1_41_1461[] = {1};
  meth_meth_collectionsPrelude_addLast_40_1_41_1461->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addLast_40_1_41_1461);
  meth_meth_collectionsPrelude_addLast_40_1_41_1461->definitionModule = modulename;
  meth_meth_collectionsPrelude_addLast_40_1_41_1461->definitionLine = 963;
// method "removeLast"
  struct UserObject *uo1464 = (struct UserObject*)obj1225;
  uo1464->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeLast1464 = addmethod2pos(obj1225, "removeLast", &meth_collectionsPrelude_removeLast1464, 13);
  int argcv_meth_collectionsPrelude_removeLast1464[] = {0};
  meth_meth_collectionsPrelude_removeLast1464->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeLast1464);
  meth_meth_collectionsPrelude_removeLast1464->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeLast1464->definitionLine = 964;
// method "addAllFirst(_)"
  struct UserObject *uo1491 = (struct UserObject*)obj1225;
  uo1491->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAllFirst_40_1_41_1491 = addmethod2pos(obj1225, "addAllFirst(1)", &meth_collectionsPrelude_addAllFirst_40_1_41_1491, 14);
  int argcv_meth_collectionsPrelude_addAllFirst_40_1_41_1491[] = {1};
  meth_meth_collectionsPrelude_addAllFirst_40_1_41_1491->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAllFirst_40_1_41_1491);
  meth_meth_collectionsPrelude_addAllFirst_40_1_41_1491->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAllFirst_40_1_41_1491->definitionLine = 970;
// method "addFirst(_)"
  struct UserObject *uo1587 = (struct UserObject*)obj1225;
  uo1587->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addFirst_40_1_41_1587 = addmethod2pos(obj1225, "addFirst(1)", &meth_collectionsPrelude_addFirst_40_1_41_1587, 15);
  int argcv_meth_collectionsPrelude_addFirst_40_1_41_1587[] = {1};
  meth_meth_collectionsPrelude_addFirst_40_1_41_1587->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addFirst_40_1_41_1587);
  meth_meth_collectionsPrelude_addFirst_40_1_41_1587->definitionModule = modulename;
  meth_meth_collectionsPrelude_addFirst_40_1_41_1587->definitionLine = 987;
// method "removeFirst"
  struct UserObject *uo1663 = (struct UserObject*)obj1225;
  uo1663->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeFirst1663 = addmethod2pos(obj1225, "removeFirst", &meth_collectionsPrelude_removeFirst1663, 16);
  int argcv_meth_collectionsPrelude_removeFirst1663[] = {0};
  meth_meth_collectionsPrelude_removeFirst1663->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeFirst1663);
  meth_meth_collectionsPrelude_removeFirst1663->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeFirst1663->definitionLine = 999;
// method "removeAt(_)"
  struct UserObject *uo1667 = (struct UserObject*)obj1225;
  uo1667->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAt_40_1_41_1667 = addmethod2pos(obj1225, "removeAt(1)", &meth_collectionsPrelude_removeAt_40_1_41_1667, 17);
  int argcv_meth_collectionsPrelude_removeAt_40_1_41_1667[] = {1};
  meth_meth_collectionsPrelude_removeAt_40_1_41_1667->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAt_40_1_41_1667);
  meth_meth_collectionsPrelude_removeAt_40_1_41_1667->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAt_40_1_41_1667->definitionLine = 1002;
// method "remove(_)"
  block_savedest(obj1225);
  Object closure1720 = createclosure(1, "remove(1)");
  setclosureframe(closure1720, stackframe);
  addtoclosure(closure1720, var_NoSuchObject);
  struct UserObject *uo1720 = (struct UserObject*)obj1225;
  uo1720->data[18] = (Object)closure1720;
  Method *meth_meth_collectionsPrelude_remove_40_1_41_1720 = addmethod2pos(obj1225, "remove(1)", &meth_collectionsPrelude_remove_40_1_41_1720, 18);
  int argcv_meth_collectionsPrelude_remove_40_1_41_1720[] = {1};
  meth_meth_collectionsPrelude_remove_40_1_41_1720->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_remove_40_1_41_1720);
  meth_meth_collectionsPrelude_remove_40_1_41_1720->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40_1_41_1720->definitionLine = 1013;
// method "remove(_)ifAbsent(_)"
  struct UserObject *uo1738 = (struct UserObject*)obj1225;
  uo1738->data[19] = emptyclosure;
  Method *meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1738 = addmethod2pos(obj1225, "remove(1)ifAbsent(1)", &meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1738, 19);
  int argcv_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1738[] = {1, 1};
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1738->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1738);
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1738->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1738->definitionLine = 1021;
// method "removeAll(_)"
  block_savedest(obj1225);
  Object closure1748 = createclosure(1, "removeAll(1)");
  setclosureframe(closure1748, stackframe);
  addtoclosure(closure1748, var_NoSuchObject);
  struct UserObject *uo1748 = (struct UserObject*)obj1225;
  uo1748->data[20] = (Object)closure1748;
  Method *meth_meth_collectionsPrelude_removeAll_40_1_41_1748 = addmethod2pos(obj1225, "removeAll(1)", &meth_collectionsPrelude_removeAll_40_1_41_1748, 20);
  int argcv_meth_collectionsPrelude_removeAll_40_1_41_1748[] = {1};
  meth_meth_collectionsPrelude_removeAll_40_1_41_1748->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAll_40_1_41_1748);
  meth_meth_collectionsPrelude_removeAll_40_1_41_1748->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40_1_41_1748->definitionLine = 1030;
// method "removeAll(_)ifAbsent(_)"
  struct UserObject *uo1757 = (struct UserObject*)obj1225;
  uo1757->data[21] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1757 = addmethod2pos(obj1225, "removeAll(1)ifAbsent(1)", &meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1757, 21);
  int argcv_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1757[] = {1, 1};
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1757->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1757);
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1757->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1757->definitionLine = 1034;
// method "pop"
  struct UserObject *uo1778 = (struct UserObject*)obj1225;
  uo1778->data[22] = emptyclosure;
  Method *meth_meth_collectionsPrelude_pop1778 = addmethod2pos(obj1225, "pop", &meth_collectionsPrelude_pop1778, 22);
  int argcv_meth_collectionsPrelude_pop1778[] = {0};
  meth_meth_collectionsPrelude_pop1778->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_pop1778);
  meth_meth_collectionsPrelude_pop1778->definitionModule = modulename;
  meth_meth_collectionsPrelude_pop1778->definitionLine = 1045;
// method "reversed"
  struct UserObject *uo1781 = (struct UserObject*)obj1225;
  uo1781->data[23] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reversed1781 = addmethod2pos(obj1225, "reversed", &meth_collectionsPrelude_reversed1781, 23);
  int argcv_meth_collectionsPrelude_reversed1781[] = {0};
  meth_meth_collectionsPrelude_reversed1781->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed1781);
  meth_meth_collectionsPrelude_reversed1781->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed1781->definitionLine = 1046;
// method "reverse"
  struct UserObject *uo1797 = (struct UserObject*)obj1225;
  uo1797->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reverse1797 = addmethod2pos(obj1225, "reverse", &meth_collectionsPrelude_reverse1797, 24);
  int argcv_meth_collectionsPrelude_reverse1797[] = {0};
  meth_meth_collectionsPrelude_reverse1797->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reverse1797);
  meth_meth_collectionsPrelude_reverse1797->definitionModule = modulename;
  meth_meth_collectionsPrelude_reverse1797->definitionLine = 1051;
// method "++(_)"
  struct UserObject *uo1838 = (struct UserObject*)obj1225;
  uo1838->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_1838 = addmethod2pos(obj1225, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_1838, 25);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_1838[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_1838->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_1838);
  meth_meth_collectionsPrelude__43__43__40_1_41_1838->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_1838->definitionLine = 1064;
// method "asString"
  struct UserObject *uo1849 = (struct UserObject*)obj1225;
  uo1849->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString1849 = addmethod2pos(obj1225, "asString", &meth_collectionsPrelude_asString1849, 26);
  int argcv_meth_collectionsPrelude_asString1849[] = {0};
  meth_meth_collectionsPrelude_asString1849->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString1849);
  meth_meth_collectionsPrelude_asString1849->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString1849->definitionLine = 1068;
// method "asDebugString"
  struct UserObject *uo1895 = (struct UserObject*)obj1225;
  uo1895->data[27] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString1895 = addmethod2pos(obj1225, "asDebugString", &meth_collectionsPrelude_asDebugString1895, 27);
  int argcv_meth_collectionsPrelude_asDebugString1895[] = {0};
  meth_meth_collectionsPrelude_asDebugString1895->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString1895);
  meth_meth_collectionsPrelude_asDebugString1895->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString1895->definitionLine = 1076;
// method "contains(_)"
  struct UserObject *uo1941 = (struct UserObject*)obj1225;
  uo1941->data[28] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_1941 = addmethod2pos(obj1225, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_1941, 28);
  int argcv_meth_collectionsPrelude_contains_40_1_41_1941[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_1941->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_1941);
  meth_meth_collectionsPrelude_contains_40_1_41_1941->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_1941->definitionLine = 1084;
// method "do(_)"
  struct UserObject *uo1953 = (struct UserObject*)obj1225;
  uo1953->data[29] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_1953 = addmethod2pos(obj1225, "do(1)", &meth_collectionsPrelude_do_40_1_41_1953, 29);
  int argcv_meth_collectionsPrelude_do_40_1_41_1953[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_1953->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_1953);
  meth_meth_collectionsPrelude_do_40_1_41_1953->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_1953->definitionLine = 1088;
// method "==(_)"
  struct UserObject *uo1979 = (struct UserObject*)obj1225;
  uo1979->data[30] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_1979 = addmethod2pos(obj1225, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_1979, 30);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_1979[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_1979->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_1979);
  meth_meth_collectionsPrelude__61__61__40_1_41_1979->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_1979->definitionLine = 1096;
// method "iterator"
  block_savedest(obj1225);
  Object closure1986 = createclosure(2, "iterator");
  setclosureframe(closure1986, stackframe);
  addtoclosure(closure1986, var_ConcurrentModification);
  addtoclosure(closure1986, var_IteratorExhausted);
  struct UserObject *uo1986 = (struct UserObject*)obj1225;
  uo1986->data[31] = (Object)closure1986;
  Method *meth_meth_collectionsPrelude_iterator1986 = addmethod2pos(obj1225, "iterator", &meth_collectionsPrelude_iterator1986, 31);
  int argcv_meth_collectionsPrelude_iterator1986[] = {0};
  meth_meth_collectionsPrelude_iterator1986->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator1986);
  meth_meth_collectionsPrelude_iterator1986->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator1986->definitionLine = 1099;
  block_savedest(obj1225);
  Object closure2070 = createclosure(2, "iterator$object(1)");
  setclosureframe(closure2070, stackframe);
  addtoclosure(closure2070, var_ConcurrentModification);
  addtoclosure(closure2070, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_iterator1986_object = addmethod2pos(obj1225, "iterator$object(1)", &meth_collectionsPrelude_iterator1986_object, 31);
  meth_meth_collectionsPrelude_iterator1986_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator1986_object->definitionLine = 1099;
// method "values"
  struct UserObject *uo2071 = (struct UserObject*)obj1225;
  uo2071->data[32] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values2071 = addmethod2pos(obj1225, "values", &meth_collectionsPrelude_values2071, 32);
  int argcv_meth_collectionsPrelude_values2071[] = {0};
  meth_meth_collectionsPrelude_values2071->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values2071);
  meth_meth_collectionsPrelude_values2071->definitionModule = modulename;
  meth_meth_collectionsPrelude_values2071->definitionLine = 1117;
// method "keys"
  struct UserObject *uo2072 = (struct UserObject*)obj1225;
  uo2072->data[33] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys2072 = addmethod2pos(obj1225, "keys", &meth_collectionsPrelude_keys2072, 33);
  int argcv_meth_collectionsPrelude_keys2072[] = {0};
  meth_meth_collectionsPrelude_keys2072->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys2072);
  meth_meth_collectionsPrelude_keys2072->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys2072->definitionLine = 1120;
// method "expandTo(_)"
  block_savedest(obj1225);
  Object closure2075 = createclosure(1, "expandTo(1)");
  setclosureframe(closure2075, stackframe);
  addtoclosure(closure2075, var__prelude);
  struct UserObject *uo2075 = (struct UserObject*)obj1225;
  uo2075->data[34] = (Object)closure2075;
  Method *meth_meth_collectionsPrelude_expandTo_40_1_41_2075 = addmethod2pos(obj1225, "expandTo(1)", &meth_collectionsPrelude_expandTo_40_1_41_2075, 34);
  int argcv_meth_collectionsPrelude_expandTo_40_1_41_2075[] = {1};
  meth_meth_collectionsPrelude_expandTo_40_1_41_2075->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_expandTo_40_1_41_2075);
  meth_meth_collectionsPrelude_expandTo_40_1_41_2075->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_expandTo_40_1_41_2075->definitionModule = modulename;
  meth_meth_collectionsPrelude_expandTo_40_1_41_2075->definitionLine = 1123;
// method "sortBy(_)"
  struct UserObject *uo2103 = (struct UserObject*)obj1225;
  uo2103->data[35] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortBy_40_1_41_2103 = addmethod2pos(obj1225, "sortBy(1)", &meth_collectionsPrelude_sortBy_40_1_41_2103, 35);
  int argcv_meth_collectionsPrelude_sortBy_40_1_41_2103[] = {1};
  meth_meth_collectionsPrelude_sortBy_40_1_41_2103->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortBy_40_1_41_2103);
  meth_meth_collectionsPrelude_sortBy_40_1_41_2103->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortBy_40_1_41_2103->definitionLine = 1130;
// method "sort"
  struct UserObject *uo2118 = (struct UserObject*)obj1225;
  uo2118->data[36] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sort2118 = addmethod2pos(obj1225, "sort", &meth_collectionsPrelude_sort2118, 36);
  int argcv_meth_collectionsPrelude_sort2118[] = {0};
  meth_meth_collectionsPrelude_sort2118->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sort2118);
  meth_meth_collectionsPrelude_sort2118->definitionModule = modulename;
  meth_meth_collectionsPrelude_sort2118->definitionLine = 1135;
// method "sortedBy(_)"
  struct UserObject *uo2137 = (struct UserObject*)obj1225;
  uo2137->data[37] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy_40_1_41_2137 = addmethod2pos(obj1225, "sortedBy(1)", &meth_collectionsPrelude_sortedBy_40_1_41_2137, 37);
  int argcv_meth_collectionsPrelude_sortedBy_40_1_41_2137[] = {1};
  meth_meth_collectionsPrelude_sortedBy_40_1_41_2137->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy_40_1_41_2137);
  meth_meth_collectionsPrelude_sortedBy_40_1_41_2137->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy_40_1_41_2137->definitionLine = 1142;
// method "sorted"
  struct UserObject *uo2142 = (struct UserObject*)obj1225;
  uo2142->data[38] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted2142 = addmethod2pos(obj1225, "sorted", &meth_collectionsPrelude_sorted2142, 38);
  int argcv_meth_collectionsPrelude_sorted2142[] = {0};
  meth_meth_collectionsPrelude_sorted2142->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted2142);
  meth_meth_collectionsPrelude_sorted2142->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted2142->definitionLine = 1145;
// method "copy"
  struct UserObject *uo2147 = (struct UserObject*)obj1225;
  uo2147->data[39] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy2147 = addmethod2pos(obj1225, "copy", &meth_collectionsPrelude_copy2147, 39);
  int argcv_meth_collectionsPrelude_copy2147[] = {0};
  meth_meth_collectionsPrelude_copy2147->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy2147);
  meth_meth_collectionsPrelude_copy2147->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy2147->definitionLine = 1148;
  sourceObject = obj1225;
// Begin line 889
  setline(889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2152 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2153 = callmethodflags(*var_indexable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2152);
// compiled call node returning call2153 (depth = 2)
  struct UserObject *obj1225_uo = (struct UserObject *)obj1225;
  obj1225_uo->super = call2153;
  sourceObject = obj1225;
// Begin line 891
  setline(891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2154 = alloc_Float64(0);
// compiled num node returning num2154 (depth = 2)
  adddatum2(obj1225, num2154, 1);
  sourceObject = obj1225;
// Begin line 892
  setline(892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool2155 = alloc_Boolean(1);
// compiled identifier node returning bool2155 (depth = 2)
  adddatum2(obj1225, bool2155, 2);
  sourceObject = obj1225;
// Begin line 894
  setline(894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2157 = alloc_Float64(1);
// compiled num node returning num2157 (depth = 3)
  int op_slot_right_2156 = gc_frame_newslot(num2157);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2160 = alloc_Float64(2);
// compiled num node returning num2160 (depth = 4)
  int op_slot_right_2159 = gc_frame_newslot(num2160);
// starting to compile call node (depth = 4)
  int callframe2162 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block2163 = alloc_Block(NULL, NULL, "collectionsPrelude", 894);
  gc_frame_newslot(block2163);
// method "_apply"
  block_savedest(block2163);
  Object closure2164 = createclosure(1, "_apply");
  setclosureframe(closure2164, stackframe);
  addtoclosure(closure2164, selfslot);
  struct UserObject *uo2164 = (struct UserObject*)block2163;
  uo2164->data[0] = (Object)closure2164;
  Method *meth_meth_collectionsPrelude__apply2164 = addmethod2pos(block2163, "_apply", &meth_collectionsPrelude__apply2164, 0);
  int argcv_meth_collectionsPrelude__apply2164[] = {0};
  meth_meth_collectionsPrelude__apply2164->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2164);
  meth_meth_collectionsPrelude__apply2164->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2164->definitionLine = 1963;
// compiled block node returning block2163 (depth = 5)
  gc_frame_newslot(block2163);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_a (depth = 5)
  params[0] = block2163;
  partcv[0] = 1;
  Object call2170 = callmethodflags(*var_a, "sizeIfUnknown(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2162);
// compiled call node returning call2170 (depth = 4)
  int op_slot_left_2159 = gc_frame_newslot(call2170);
  params[0] = num2160;
  partcv[0] = 1;
  Object prod2171 = callmethod(call2170, "*(1)", 1, partcv, params);
// compiled op node returning prod2171 (depth = 3)
  int op_slot_left_2156 = gc_frame_newslot(prod2171);
  params[0] = num2157;
  partcv[0] = 1;
  Object sum2172 = callmethod(prod2171, "+(1)", 1, partcv, params);
// compiled op node returning sum2172 (depth = 2)
  adddatum2(obj1225, sum2172, 3);
  sourceObject = obj1225;
// Begin line 895
  setline(895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2173 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe2174 = gc_frame_new();
// call case 4: self request
  Object call2175 = callmethodflags(self, "initialSize", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2174);
// compiled member node returning call2175 (depth = 3)
  gc_frame_newslot(call2175);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2176 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__prelude (depth = 4)
  Object call2177 = callmethodflags(*var__prelude, "primitiveArray", 0, partcv, params, 0);
  gc_frame_end(callframe2176);
// compiled member node returning call2177 (depth = 3)
  params[0] = call2175;
  partcv[0] = 1;
  Object call2178 = callmethodflags(call2177, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2173);
// compiled call node returning call2178 (depth = 2)
  adddatum2(obj1225, call2178, 4);
  sourceObject = obj1225;
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2179 = alloc_Float64(0);
// compiled num node returning num2179 (depth = 2)
  adddatum2(obj1225, num2179, 5);
  sourceObject = obj1225;
// Begin line 897
  setline(897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2181 = gc_frame_new();
// call case 4: self request
  Object call2182 = callmethodflags(self, "sizeCertain", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2181);
// compiled member node returning call2182 (depth = 3)
  Object if2180 = done;
struct StackFrameObject *iftmpstackframe2180 = stackframe;
  if (istrue(call2182)) {
stackframe = alloc_StackFrame(0, iftmpstackframe2180);
gc_frame_newslot((Object)stackframe);
// Begin line 899
  setline(899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2183 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_a (depth = 4)
  gc_frame_newslot(*var_a);
// starting to compile block node (depth = 4)
  Object block2184 = alloc_Block(NULL, NULL, "collectionsPrelude", 899);
  gc_frame_newslot(block2184);
// method "_apply(_)"
  block_savedest(block2184);
  Object closure2185 = createclosure(1, "_apply(1)");
  setclosureframe(closure2185, stackframe);
  addtoclosure(closure2185, selfslot);
  struct UserObject *uo2185 = (struct UserObject*)block2184;
  uo2185->data[0] = (Object)closure2185;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2185 = addmethod2pos(block2184, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2185, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2185[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2185->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2185);
  meth_meth_collectionsPrelude__apply_40_1_41_2185->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2185->definitionLine = 1963;
// compiled block node returning block2184 (depth = 4)
  gc_frame_newslot(block2184);
// call case 5: prelude request
  params[0] = *var_a;
  params[1] = block2184;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2201 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2183);
// compiled call node returning call2201 (depth = 3)
    gc_frame_newslot(call2201);
    if2180 = call2201;
  } else {
  stackframe = alloc_StackFrame(1, iftmpstackframe2180);
  gc_frame_newslot((Object)stackframe);
  Object *var_innerSize = &(stackframe->slots[0]);
  setframeelementname(stackframe, 0, "innerSize");
// Begin line 905
  setline(905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2202 = gc_frame_new();
// call case 4: self request
  Object call2203 = callmethodflags(self, "initialSize", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2202);
// compiled member node returning call2203 (depth = 4)
  *var_innerSize = call2203;
  if (call2203 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 906
  setline(906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2204 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_a (depth = 4)
  gc_frame_newslot(*var_a);
// starting to compile block node (depth = 4)
  Object block2205 = alloc_Block(NULL, NULL, "collectionsPrelude", 906);
  gc_frame_newslot(block2205);
// method "_apply(_)"
  block_savedest(block2205);
  Object closure2206 = createclosure(3, "_apply(1)");
  setclosureframe(closure2206, stackframe);
  addtoclosure(closure2206, var_innerSize);
  addtoclosure(closure2206, var__prelude);
  addtoclosure(closure2206, selfslot);
  struct UserObject *uo2206 = (struct UserObject*)block2205;
  uo2206->data[0] = (Object)closure2206;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2206 = addmethod2pos(block2205, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2206, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2206[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2206->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2206);
  meth_meth_collectionsPrelude__apply_40_1_41_2206->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2206->definitionLine = 1963;
// compiled block node returning block2205 (depth = 4)
  gc_frame_newslot(block2205);
// call case 5: prelude request
  params[0] = *var_a;
  params[1] = block2205;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2262 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2204);
// compiled call node returning call2262 (depth = 3)
    gc_frame_newslot(call2262);
    if2180 = call2262;
  }
stackframe = iftmpstackframe2180;
// compiled if node returning if2180 (depth = 2)
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  objclass1225 = obj1225->class;
  objclass1225->definitionModule = modulename;
  objclass1225->definitionLine = 887;
  (*(struct UserObject *)self).data[0] = lowerouter1225;
  self = oldself1225;
  selfslot = oldselfslot1225;
  stackframe = oldstackframe1225;
  gc_frame_end(frame);
  return obj1225;
}
Object meth_collectionsPrelude_withAll_40_1_41_714_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "withAll(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method withAll(_)");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_done = getfromclosure(closure, 1);
  Object *var_ConcurrentModification = getfromclosure(closure, 2);
  Object *var_IteratorExhausted = getfromclosure(closure, 3);
  Object *var_indexable = getfromclosure(closure, 4);
  Object *var_BoundsError = getfromclosure(closure, 5);
  Object *var__prelude = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for withAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 627
  setline(627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit717 == NULL) {
    strlit717 = alloc_String("js");
    gc_root(strlit717);
  }
// compiled string node returning strlit717 (depth = 4)
  int op_slot_right_716 = gc_frame_newslot(strlit717);
// starting to compile member node (depth = 4)
  int callframe719 = gc_frame_new();
// call case 5: prelude request
  Object call720 = callmethodflags(prelude, "engine", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe719);
// compiled member node returning call720 (depth = 4)
  int op_slot_left_716 = gc_frame_newslot(call720);
  params[0] = strlit717;
  partcv[0] = 1;
  Object opresult721 = callmethod(call720, "==(1)", 1, partcv, params);
// compiled op node returning opresult721 (depth = 3)
  Object if715 = done;
  if (istrue(opresult721)) {
// Begin line 628
  setline(628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
// compiled call node returning done (depth = 4)
  Object if722 = done;
  if (istrue(done)) {
// Begin line 629
  setline(629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject723 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj723 = alloc_userobj2(42,40, objclass723);
  gc_frame_newslot(obj723);
// OBJECT OUTER DEC outer
  adddatum2(obj723, self, 0);
  addmethodreal(obj723,"outer", &reader_collectionsPrelude_outer_724);
  Object oldself723 = self;
  struct StackFrameObject *oldstackframe723 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe723);
  gc_frame_newslot((Object)stackframe);
  self = obj723;
  Object *oldselfslot723 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter723 = (*(struct UserObject *)self).data[0], lowerouter723 = thisouter723;
  if (inheritingObject723) {
    struct UserObject *inho723 = (struct UserObject *)inheritingObject723;
    while (inho723->super != GraceDefaultObject) inho723 = (struct UserObject *)inho723->super;
    inho723->super = obj723;
    self = inheritingObject723;
    *selfslot = self;
    lowerouter723 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter723;
  }
if (objclass723 == NULL) {
  Method *reader725 = addmethodrealflags(obj723, "mods", &reader_collectionsPrelude_mods_725, 0);
  Method *writer725 = addmethodrealflags(obj723, "mods:=(1)", &writer_collectionsPrelude_mods_725, MFLAG_CONFIDENTIAL);
  reader725->definitionModule = modulename;
  writer725->definitionModule = modulename;
  reader725->definitionLine = 632;
  writer725->definitionLine = 632;
}
obj723->flags |= OFLAG_MUTABLE;
adddatum2(obj723, alloc_Undefined(), 1);
if (objclass723 == NULL) {
  Method *reader726 = addmethodrealflags(obj723, "sz", &reader_collectionsPrelude_sz_726, MFLAG_CONFIDENTIAL);
  Method *writer726 = addmethodrealflags(obj723, "sz:=(1)", &writer_collectionsPrelude_sz_726, MFLAG_CONFIDENTIAL);
  reader726->definitionModule = modulename;
  writer726->definitionModule = modulename;
  reader726->definitionLine = 633;
  writer726->definitionLine = 633;
}
obj723->flags |= OFLAG_MUTABLE;
adddatum2(obj723, alloc_Undefined(), 2);
if (objclass723 == NULL) {
  Method *reader727 = addmethodrealflags(obj723, "jsArray", &reader_collectionsPrelude_jsArray_727, MFLAG_CONFIDENTIAL);
  Method *writer727 = addmethodrealflags(obj723, "jsArray:=(1)", &writer_collectionsPrelude_jsArray_727, MFLAG_CONFIDENTIAL);
  reader727->definitionModule = modulename;
  writer727->definitionModule = modulename;
  reader727->definitionLine = 634;
  writer727->definitionLine = 634;
}
obj723->flags |= OFLAG_MUTABLE;
adddatum2(obj723, alloc_Undefined(), 3);
// method "size"
  struct UserObject *uo728 = (struct UserObject*)obj723;
  uo728->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_size728 = addmethod2pos(obj723, "size", &meth_collectionsPrelude_size728, 4);
  int argcv_meth_collectionsPrelude_size728[] = {0};
  meth_meth_collectionsPrelude_size728->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size728);
  meth_meth_collectionsPrelude_size728->definitionModule = modulename;
  meth_meth_collectionsPrelude_size728->definitionLine = 639;
// method "at(_)"
  struct UserObject *uo731 = (struct UserObject*)obj723;
  uo731->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40_1_41_731 = addmethod2pos(obj723, "at(1)", &meth_collectionsPrelude_at_40_1_41_731, 5);
  int argcv_meth_collectionsPrelude_at_40_1_41_731[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_731->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_731);
  meth_meth_collectionsPrelude_at_40_1_41_731->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_731->definitionLine = 644;
// method "at(_)put(_)"
  struct UserObject *uo732 = (struct UserObject*)obj723;
  uo732->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_732 = addmethod2pos(obj723, "at(1)put(1)", &meth_collectionsPrelude_at_40_1_41_put_40_1_41_732, 6);
  int argcv_meth_collectionsPrelude_at_40_1_41_put_40_1_41_732[] = {1, 1};
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_732->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40_1_41_put_40_1_41_732);
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_732->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_732->definitionLine = 654;
// method "add(_)"
  struct UserObject *uo741 = (struct UserObject*)obj723;
  uo741->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_add_40_1_41_741 = addmethod2pos(obj723, "add(1)", &meth_collectionsPrelude_add_40_1_41_741, 7);
  int argcv_meth_collectionsPrelude_add_40_1_41_741[] = {1};
  meth_meth_collectionsPrelude_add_40_1_41_741->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add_40_1_41_741);
  meth_meth_collectionsPrelude_add_40_1_41_741->definitionModule = modulename;
  meth_meth_collectionsPrelude_add_40_1_41_741->definitionLine = 666;
// method "push(_)"
  struct UserObject *uo750 = (struct UserObject*)obj723;
  uo750->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_push_40_1_41_750 = addmethod2pos(obj723, "push(1)", &meth_collectionsPrelude_push_40_1_41_750, 8);
  int argcv_meth_collectionsPrelude_push_40_1_41_750[] = {1};
  meth_meth_collectionsPrelude_push_40_1_41_750->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_push_40_1_41_750);
  meth_meth_collectionsPrelude_push_40_1_41_750->definitionModule = modulename;
  meth_meth_collectionsPrelude_push_40_1_41_750->definitionLine = 672;
// method "removeLast"
  struct UserObject *uo759 = (struct UserObject*)obj723;
  uo759->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeLast759 = addmethod2pos(obj723, "removeLast", &meth_collectionsPrelude_removeLast759, 9);
  int argcv_meth_collectionsPrelude_removeLast759[] = {0};
  meth_meth_collectionsPrelude_removeLast759->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeLast759);
  meth_meth_collectionsPrelude_removeLast759->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeLast759->definitionLine = 678;
// method "addAllFirst(_)"
  struct UserObject *uo768 = (struct UserObject*)obj723;
  uo768->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAllFirst_40_1_41_768 = addmethod2pos(obj723, "addAllFirst(1)", &meth_collectionsPrelude_addAllFirst_40_1_41_768, 10);
  int argcv_meth_collectionsPrelude_addAllFirst_40_1_41_768[] = {1};
  meth_meth_collectionsPrelude_addAllFirst_40_1_41_768->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAllFirst_40_1_41_768);
  meth_meth_collectionsPrelude_addAllFirst_40_1_41_768->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAllFirst_40_1_41_768->definitionLine = 688;
// method "removeAt(_)"
  struct UserObject *uo798 = (struct UserObject*)obj723;
  uo798->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAt_40_1_41_798 = addmethod2pos(obj723, "removeAt(1)", &meth_collectionsPrelude_removeAt_40_1_41_798, 11);
  int argcv_meth_collectionsPrelude_removeAt_40_1_41_798[] = {1};
  meth_meth_collectionsPrelude_removeAt_40_1_41_798->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAt_40_1_41_798);
  meth_meth_collectionsPrelude_removeAt_40_1_41_798->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAt_40_1_41_798->definitionLine = 699;
// method "sortBy(_)"
  struct UserObject *uo809 = (struct UserObject*)obj723;
  uo809->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortBy_40_1_41_809 = addmethod2pos(obj723, "sortBy(1)", &meth_collectionsPrelude_sortBy_40_1_41_809, 12);
  int argcv_meth_collectionsPrelude_sortBy_40_1_41_809[] = {1};
  meth_meth_collectionsPrelude_sortBy_40_1_41_809->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortBy_40_1_41_809);
  meth_meth_collectionsPrelude_sortBy_40_1_41_809->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortBy_40_1_41_809->definitionLine = 706;
// method "addLast(_)"
  struct UserObject *uo818 = (struct UserObject*)obj723;
  uo818->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addLast_40_1_41_818 = addmethod2pos(obj723, "addLast(1)", &meth_collectionsPrelude_addLast_40_1_41_818, 13);
  int argcv_meth_collectionsPrelude_addLast_40_1_41_818[] = {1};
  meth_meth_collectionsPrelude_addLast_40_1_41_818->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addLast_40_1_41_818);
  meth_meth_collectionsPrelude_addLast_40_1_41_818->definitionModule = modulename;
  meth_meth_collectionsPrelude_addLast_40_1_41_818->definitionLine = 720;
// method "addAll(_)"
  struct UserObject *uo821 = (struct UserObject*)obj723;
  uo821->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAll_40_1_41_821 = addmethod2pos(obj723, "addAll(1)", &meth_collectionsPrelude_addAll_40_1_41_821, 14);
  int argcv_meth_collectionsPrelude_addAll_40_1_41_821[] = {1};
  meth_meth_collectionsPrelude_addAll_40_1_41_821->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAll_40_1_41_821);
  meth_meth_collectionsPrelude_addAll_40_1_41_821->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAll_40_1_41_821->definitionLine = 721;
// method "addFirst(_)"
  struct UserObject *uo829 = (struct UserObject*)obj723;
  uo829->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addFirst_40_1_41_829 = addmethod2pos(obj723, "addFirst(1)", &meth_collectionsPrelude_addFirst_40_1_41_829, 15);
  int argcv_meth_collectionsPrelude_addFirst_40_1_41_829[] = {1};
  meth_meth_collectionsPrelude_addFirst_40_1_41_829->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addFirst_40_1_41_829);
  meth_meth_collectionsPrelude_addFirst_40_1_41_829->definitionModule = modulename;
  meth_meth_collectionsPrelude_addFirst_40_1_41_829->definitionLine = 726;
// method "removeFirst"
  struct UserObject *uo838 = (struct UserObject*)obj723;
  uo838->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeFirst838 = addmethod2pos(obj723, "removeFirst", &meth_collectionsPrelude_removeFirst838, 16);
  int argcv_meth_collectionsPrelude_removeFirst838[] = {0};
  meth_meth_collectionsPrelude_removeFirst838->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeFirst838);
  meth_meth_collectionsPrelude_removeFirst838->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeFirst838->definitionLine = 732;
// method "remove(_)"
  block_savedest(obj723);
  Object closure842 = createclosure(1, "remove(1)");
  setclosureframe(closure842, stackframe);
  addtoclosure(closure842, var_NoSuchObject);
  struct UserObject *uo842 = (struct UserObject*)obj723;
  uo842->data[17] = (Object)closure842;
  Method *meth_meth_collectionsPrelude_remove_40_1_41_842 = addmethod2pos(obj723, "remove(1)", &meth_collectionsPrelude_remove_40_1_41_842, 17);
  int argcv_meth_collectionsPrelude_remove_40_1_41_842[] = {1};
  meth_meth_collectionsPrelude_remove_40_1_41_842->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_remove_40_1_41_842);
  meth_meth_collectionsPrelude_remove_40_1_41_842->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40_1_41_842->definitionLine = 737;
// method "remove(_)ifAbsent(_)"
  struct UserObject *uo860 = (struct UserObject*)obj723;
  uo860->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_860 = addmethod2pos(obj723, "remove(1)ifAbsent(1)", &meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_860, 18);
  int argcv_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_860[] = {1, 1};
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_860->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_860);
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_860->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_860->definitionLine = 746;
// method "removeAll(_)"
  block_savedest(obj723);
  Object closure870 = createclosure(1, "removeAll(1)");
  setclosureframe(closure870, stackframe);
  addtoclosure(closure870, var_NoSuchObject);
  struct UserObject *uo870 = (struct UserObject*)obj723;
  uo870->data[19] = (Object)closure870;
  Method *meth_meth_collectionsPrelude_removeAll_40_1_41_870 = addmethod2pos(obj723, "removeAll(1)", &meth_collectionsPrelude_removeAll_40_1_41_870, 19);
  int argcv_meth_collectionsPrelude_removeAll_40_1_41_870[] = {1};
  meth_meth_collectionsPrelude_removeAll_40_1_41_870->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAll_40_1_41_870);
  meth_meth_collectionsPrelude_removeAll_40_1_41_870->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40_1_41_870->definitionLine = 754;
// method "removeAll(_)ifAbsent(_)"
  struct UserObject *uo879 = (struct UserObject*)obj723;
  uo879->data[20] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_879 = addmethod2pos(obj723, "removeAll(1)ifAbsent(1)", &meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_879, 20);
  int argcv_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_879[] = {1, 1};
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_879->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_879);
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_879->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_879->definitionLine = 759;
// method "pop"
  struct UserObject *uo900 = (struct UserObject*)obj723;
  uo900->data[21] = emptyclosure;
  Method *meth_meth_collectionsPrelude_pop900 = addmethod2pos(obj723, "pop", &meth_collectionsPrelude_pop900, 21);
  int argcv_meth_collectionsPrelude_pop900[] = {0};
  meth_meth_collectionsPrelude_pop900->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_pop900);
  meth_meth_collectionsPrelude_pop900->definitionModule = modulename;
  meth_meth_collectionsPrelude_pop900->definitionLine = 771;
// method "reversed"
  struct UserObject *uo903 = (struct UserObject*)obj723;
  uo903->data[22] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reversed903 = addmethod2pos(obj723, "reversed", &meth_collectionsPrelude_reversed903, 22);
  int argcv_meth_collectionsPrelude_reversed903[] = {0};
  meth_meth_collectionsPrelude_reversed903->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed903);
  meth_meth_collectionsPrelude_reversed903->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed903->definitionLine = 773;
// method "reverse"
  struct UserObject *uo919 = (struct UserObject*)obj723;
  uo919->data[23] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reverse919 = addmethod2pos(obj723, "reverse", &meth_collectionsPrelude_reverse919, 23);
  int argcv_meth_collectionsPrelude_reverse919[] = {0};
  meth_meth_collectionsPrelude_reverse919->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reverse919);
  meth_meth_collectionsPrelude_reverse919->definitionModule = modulename;
  meth_meth_collectionsPrelude_reverse919->definitionLine = 778;
// method "++(_)"
  struct UserObject *uo960 = (struct UserObject*)obj723;
  uo960->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_960 = addmethod2pos(obj723, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_960, 24);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_960[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_960->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_960);
  meth_meth_collectionsPrelude__43__43__40_1_41_960->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_960->definitionLine = 792;
// method "asString"
  struct UserObject *uo971 = (struct UserObject*)obj723;
  uo971->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString971 = addmethod2pos(obj723, "asString", &meth_collectionsPrelude_asString971, 25);
  int argcv_meth_collectionsPrelude_asString971[] = {0};
  meth_meth_collectionsPrelude_asString971->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString971);
  meth_meth_collectionsPrelude_asString971->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString971->definitionLine = 798;
// method "asDebugString"
  struct UserObject *uo1005 = (struct UserObject*)obj723;
  uo1005->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString1005 = addmethod2pos(obj723, "asDebugString", &meth_collectionsPrelude_asDebugString1005, 26);
  int argcv_meth_collectionsPrelude_asDebugString1005[] = {0};
  meth_meth_collectionsPrelude_asDebugString1005->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString1005);
  meth_meth_collectionsPrelude_asDebugString1005->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString1005->definitionLine = 808;
// method "extend(_)"
  block_savedest(obj723);
  Object closure1039 = createclosure(1, "extend(1)");
  setclosureframe(closure1039, stackframe);
  addtoclosure(closure1039, var_done);
  struct UserObject *uo1039 = (struct UserObject*)obj723;
  uo1039->data[27] = (Object)closure1039;
  Method *meth_meth_collectionsPrelude_extend_40_1_41_1039 = addmethod2pos(obj723, "extend(1)", &meth_collectionsPrelude_extend_40_1_41_1039, 27);
  int argcv_meth_collectionsPrelude_extend_40_1_41_1039[] = {1};
  meth_meth_collectionsPrelude_extend_40_1_41_1039->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_extend_40_1_41_1039);
  meth_meth_collectionsPrelude_extend_40_1_41_1039->definitionModule = modulename;
  meth_meth_collectionsPrelude_extend_40_1_41_1039->definitionLine = 818;
// method "contains(_)"
  struct UserObject *uo1042 = (struct UserObject*)obj723;
  uo1042->data[28] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_1042 = addmethod2pos(obj723, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_1042, 28);
  int argcv_meth_collectionsPrelude_contains_40_1_41_1042[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_1042->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_1042);
  meth_meth_collectionsPrelude_contains_40_1_41_1042->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_1042->definitionLine = 821;
// method "do(_)"
  struct UserObject *uo1054 = (struct UserObject*)obj723;
  uo1054->data[29] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_1054 = addmethod2pos(obj723, "do(1)", &meth_collectionsPrelude_do_40_1_41_1054, 29);
  int argcv_meth_collectionsPrelude_do_40_1_41_1054[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_1054->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_1054);
  meth_meth_collectionsPrelude_do_40_1_41_1054->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_1054->definitionLine = 826;
// method "==(_)"
  struct UserObject *uo1078 = (struct UserObject*)obj723;
  uo1078->data[30] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_1078 = addmethod2pos(obj723, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_1078, 30);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_1078[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_1078->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_1078);
  meth_meth_collectionsPrelude__61__61__40_1_41_1078->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_1078->definitionLine = 835;
// method "iterator"
  block_savedest(obj723);
  Object closure1085 = createclosure(2, "iterator");
  setclosureframe(closure1085, stackframe);
  addtoclosure(closure1085, var_ConcurrentModification);
  addtoclosure(closure1085, var_IteratorExhausted);
  struct UserObject *uo1085 = (struct UserObject*)obj723;
  uo1085->data[31] = (Object)closure1085;
  Method *meth_meth_collectionsPrelude_iterator1085 = addmethod2pos(obj723, "iterator", &meth_collectionsPrelude_iterator1085, 31);
  int argcv_meth_collectionsPrelude_iterator1085[] = {0};
  meth_meth_collectionsPrelude_iterator1085->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator1085);
  meth_meth_collectionsPrelude_iterator1085->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator1085->definitionLine = 839;
  block_savedest(obj723);
  Object closure1169 = createclosure(2, "iterator$object(1)");
  setclosureframe(closure1169, stackframe);
  addtoclosure(closure1169, var_ConcurrentModification);
  addtoclosure(closure1169, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_iterator1085_object = addmethod2pos(obj723, "iterator$object(1)", &meth_collectionsPrelude_iterator1085_object, 31);
  meth_meth_collectionsPrelude_iterator1085_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator1085_object->definitionLine = 839;
// method "values"
  struct UserObject *uo1170 = (struct UserObject*)obj723;
  uo1170->data[32] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values1170 = addmethod2pos(obj723, "values", &meth_collectionsPrelude_values1170, 32);
  int argcv_meth_collectionsPrelude_values1170[] = {0};
  meth_meth_collectionsPrelude_values1170->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values1170);
  meth_meth_collectionsPrelude_values1170->definitionModule = modulename;
  meth_meth_collectionsPrelude_values1170->definitionLine = 858;
// method "keys"
  struct UserObject *uo1171 = (struct UserObject*)obj723;
  uo1171->data[33] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys1171 = addmethod2pos(obj723, "keys", &meth_collectionsPrelude_keys1171, 33);
  int argcv_meth_collectionsPrelude_keys1171[] = {0};
  meth_meth_collectionsPrelude_keys1171->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys1171);
  meth_meth_collectionsPrelude_keys1171->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys1171->definitionLine = 862;
// method "sort"
  struct UserObject *uo1174 = (struct UserObject*)obj723;
  uo1174->data[34] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sort1174 = addmethod2pos(obj723, "sort", &meth_collectionsPrelude_sort1174, 34);
  int argcv_meth_collectionsPrelude_sort1174[] = {0};
  meth_meth_collectionsPrelude_sort1174->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sort1174);
  meth_meth_collectionsPrelude_sort1174->definitionModule = modulename;
  meth_meth_collectionsPrelude_sort1174->definitionLine = 866;
// method "sortedBy(_)"
  struct UserObject *uo1201 = (struct UserObject*)obj723;
  uo1201->data[35] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy_40_1_41_1201 = addmethod2pos(obj723, "sortedBy(1)", &meth_collectionsPrelude_sortedBy_40_1_41_1201, 35);
  int argcv_meth_collectionsPrelude_sortedBy_40_1_41_1201[] = {1};
  meth_meth_collectionsPrelude_sortedBy_40_1_41_1201->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy_40_1_41_1201);
  meth_meth_collectionsPrelude_sortedBy_40_1_41_1201->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy_40_1_41_1201->definitionLine = 874;
// method "sorted"
  struct UserObject *uo1206 = (struct UserObject*)obj723;
  uo1206->data[36] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted1206 = addmethod2pos(obj723, "sorted", &meth_collectionsPrelude_sorted1206, 36);
  int argcv_meth_collectionsPrelude_sorted1206[] = {0};
  meth_meth_collectionsPrelude_sorted1206->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted1206);
  meth_meth_collectionsPrelude_sorted1206->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted1206->definitionLine = 877;
// method "copy"
  struct UserObject *uo1211 = (struct UserObject*)obj723;
  uo1211->data[37] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy1211 = addmethod2pos(obj723, "copy", &meth_collectionsPrelude_copy1211, 37);
  int argcv_meth_collectionsPrelude_copy1211[] = {0};
  meth_meth_collectionsPrelude_copy1211->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy1211);
  meth_meth_collectionsPrelude_copy1211->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy1211->definitionLine = 880;
  sourceObject = obj723;
// Begin line 630
  setline(630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1216 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_indexable (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1217 = callmethodflags(*var_indexable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe1216);
// compiled call node returning call1217 (depth = 6)
  struct UserObject *obj723_uo = (struct UserObject *)obj723;
  obj723_uo->super = call1217;
  sourceObject = obj723;
// Begin line 632
  setline(632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num1218 = alloc_Float64(0);
// compiled num node returning num1218 (depth = 6)
  adddatum2(obj723, num1218, 1);
  sourceObject = obj723;
// Begin line 633
  setline(633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num1219 = alloc_Float64(0);
// compiled num node returning num1219 (depth = 6)
  adddatum2(obj723, num1219, 2);
  sourceObject = obj723;
// Begin line 634
  setline(634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
  adddatum2(obj723, done, 3);
  sourceObject = obj723;
// Begin line 635
  setline(635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1220 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block1221 = alloc_Block(NULL, NULL, "collectionsPrelude", 635);
  gc_frame_newslot(block1221);
// method "_apply(_)"
  block_savedest(block1221);
  Object closure1222 = createclosure(1, "_apply(1)");
  setclosureframe(closure1222, stackframe);
  addtoclosure(closure1222, selfslot);
  struct UserObject *uo1222 = (struct UserObject*)block1221;
  uo1222->data[0] = (Object)closure1222;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_1222 = addmethod2pos(block1221, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_1222, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_1222[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_1222->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_1222);
  meth_meth_collectionsPrelude__apply_40_1_41_1222->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_1222->definitionLine = 1963;
// compiled block node returning block1221 (depth = 7)
  gc_frame_newslot(block1221);
// call case 6: other requests
// Begin line 635
  setline(635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  params[0] = block1221;
  partcv[0] = 1;
  Object call1224 = callmethodflags(*var_a, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe1220);
// compiled call node returning call1224 (depth = 6)
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  sourceObject = obj723;
  objclass723 = obj723->class;
  objclass723->definitionModule = modulename;
  objclass723->definitionLine = 629;
  (*(struct UserObject *)self).data[0] = lowerouter723;
  self = oldself723;
  selfslot = oldselfslot723;
  stackframe = oldstackframe723;
// compiled object node returning obj723 (depth = 5)
  return obj723;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if722 = undefined;
  } else {
  }
// compiled if node returning if722 (depth = 3)
    gc_frame_newslot(if722);
    if715 = if722;
  } else {
  }
// compiled if node returning if715 (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1225 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1225 = alloc_userobj2(45,42, objclass1225);
  gc_frame_newslot(obj1225);
if (objclass1225 == NULL) {
  glfree(obj1225->class->name);
  obj1225->class->name = "list.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1225, self, 0);
  addmethodreal(obj1225,"outer", &reader_collectionsPrelude_outer_1226);
  Object oldself1225 = self;
  struct StackFrameObject *oldstackframe1225 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1225);
  gc_frame_newslot((Object)stackframe);
  self = obj1225;
  Object *oldselfslot1225 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1225 = (*(struct UserObject *)self).data[0], lowerouter1225 = thisouter1225;
  if (inheritingObject1225) {
    struct UserObject *inho1225 = (struct UserObject *)inheritingObject1225;
    while (inho1225->super != GraceDefaultObject) inho1225 = (struct UserObject *)inho1225->super;
    inho1225->super = obj1225;
    self = inheritingObject1225;
    *selfslot = self;
    lowerouter1225 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1225;
  }
if (objclass1225 == NULL) {
  Method *reader1227 = addmethodrealflags(obj1225, "mods", &reader_collectionsPrelude_mods_1227, 0);
  Method *writer1227 = addmethodrealflags(obj1225, "mods:=(1)", &writer_collectionsPrelude_mods_1227, MFLAG_CONFIDENTIAL);
  reader1227->definitionModule = modulename;
  writer1227->definitionModule = modulename;
  reader1227->definitionLine = 891;
  writer1227->definitionLine = 891;
}
obj1225->flags |= OFLAG_MUTABLE;
adddatum2(obj1225, alloc_Undefined(), 1);
if (objclass1225 == NULL) {
  Method *reader1228 = addmethodrealflags(obj1225, "sizeCertain", &reader_collectionsPrelude_sizeCertain_1228, MFLAG_CONFIDENTIAL);
  Method *writer1228 = addmethodrealflags(obj1225, "sizeCertain:=(1)", &writer_collectionsPrelude_sizeCertain_1228, MFLAG_CONFIDENTIAL);
  reader1228->definitionModule = modulename;
  writer1228->definitionModule = modulename;
  reader1228->definitionLine = 892;
  writer1228->definitionLine = 892;
}
obj1225->flags |= OFLAG_MUTABLE;
adddatum2(obj1225, alloc_Undefined(), 2);
if (objclass1225 == NULL) {
  Method *reader1229 = addmethodrealflags(obj1225, "initialSize",&reader_collectionsPrelude_initialSize_1229, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader1229->definitionModule = modulename;
  reader1229->definitionLine = 894;
}
adddatum2(obj1225, alloc_Undefined(), 3);
if (objclass1225 == NULL) {
  Method *reader1230 = addmethodrealflags(obj1225, "inner", &reader_collectionsPrelude_inner_1230, MFLAG_CONFIDENTIAL);
  Method *writer1230 = addmethodrealflags(obj1225, "inner:=(1)", &writer_collectionsPrelude_inner_1230, MFLAG_CONFIDENTIAL);
  reader1230->definitionModule = modulename;
  writer1230->definitionModule = modulename;
  reader1230->definitionLine = 895;
  writer1230->definitionLine = 895;
}
obj1225->flags |= OFLAG_MUTABLE;
adddatum2(obj1225, alloc_Undefined(), 4);
if (objclass1225 == NULL) {
  Method *reader1231 = addmethodrealflags(obj1225, "size", &reader_collectionsPrelude_size_1231, 0);
  Method *writer1231 = addmethodrealflags(obj1225, "size:=(1)", &writer_collectionsPrelude_size_1231, MFLAG_CONFIDENTIAL);
  reader1231->definitionModule = modulename;
  writer1231->definitionModule = modulename;
  reader1231->definitionLine = 896;
  writer1231->definitionLine = 896;
}
obj1225->flags |= OFLAG_MUTABLE;
adddatum2(obj1225, alloc_Undefined(), 5);
// method "boundsCheck(_)"
  block_savedest(obj1225);
  Object closure1232 = createclosure(1, "boundsCheck(1)");
  setclosureframe(closure1232, stackframe);
  addtoclosure(closure1232, var_BoundsError);
  struct UserObject *uo1232 = (struct UserObject*)obj1225;
  uo1232->data[6] = (Object)closure1232;
  Method *meth_meth_collectionsPrelude_boundsCheck_40_1_41_1232 = addmethod2pos(obj1225, "boundsCheck(1)", &meth_collectionsPrelude_boundsCheck_40_1_41_1232, 6);
  int argcv_meth_collectionsPrelude_boundsCheck_40_1_41_1232[] = {1};
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_1232->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_boundsCheck_40_1_41_1232);
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_1232->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_1232->definitionModule = modulename;
  meth_meth_collectionsPrelude_boundsCheck_40_1_41_1232->definitionLine = 919;
// method "at(_)"
  struct UserObject *uo1269 = (struct UserObject*)obj1225;
  uo1269->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40_1_41_1269 = addmethod2pos(obj1225, "at(1)", &meth_collectionsPrelude_at_40_1_41_1269, 7);
  int argcv_meth_collectionsPrelude_at_40_1_41_1269[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_1269->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_1269);
  meth_meth_collectionsPrelude_at_40_1_41_1269->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_1269->definitionLine = 924;
// method "at(_)put(_)"
  struct UserObject *uo1280 = (struct UserObject*)obj1225;
  uo1280->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_1280 = addmethod2pos(obj1225, "at(1)put(1)", &meth_collectionsPrelude_at_40_1_41_put_40_1_41_1280, 8);
  int argcv_meth_collectionsPrelude_at_40_1_41_put_40_1_41_1280[] = {1, 1};
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_1280->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40_1_41_put_40_1_41_1280);
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_1280->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_1280->definitionLine = 928;
// method "add(_)"
  struct UserObject *uo1311 = (struct UserObject*)obj1225;
  uo1311->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_add_40_1_41_1311 = addmethod2pos(obj1225, "add(1)", &meth_collectionsPrelude_add_40_1_41_1311, 9);
  int argcv_meth_collectionsPrelude_add_40_1_41_1311[] = {1};
  meth_meth_collectionsPrelude_add_40_1_41_1311->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add_40_1_41_1311);
  meth_meth_collectionsPrelude_add_40_1_41_1311->definitionModule = modulename;
  meth_meth_collectionsPrelude_add_40_1_41_1311->definitionLine = 938;
// method "addAll(_)"
  struct UserObject *uo1354 = (struct UserObject*)obj1225;
  uo1354->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAll_40_1_41_1354 = addmethod2pos(obj1225, "addAll(1)", &meth_collectionsPrelude_addAll_40_1_41_1354, 10);
  int argcv_meth_collectionsPrelude_addAll_40_1_41_1354[] = {1};
  meth_meth_collectionsPrelude_addAll_40_1_41_1354->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAll_40_1_41_1354);
  meth_meth_collectionsPrelude_addAll_40_1_41_1354->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAll_40_1_41_1354->definitionLine = 945;
// method "push(_)"
  struct UserObject *uo1418 = (struct UserObject*)obj1225;
  uo1418->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_push_40_1_41_1418 = addmethod2pos(obj1225, "push(1)", &meth_collectionsPrelude_push_40_1_41_1418, 11);
  int argcv_meth_collectionsPrelude_push_40_1_41_1418[] = {1};
  meth_meth_collectionsPrelude_push_40_1_41_1418->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_push_40_1_41_1418);
  meth_meth_collectionsPrelude_push_40_1_41_1418->definitionModule = modulename;
  meth_meth_collectionsPrelude_push_40_1_41_1418->definitionLine = 956;
// method "addLast(_)"
  struct UserObject *uo1461 = (struct UserObject*)obj1225;
  uo1461->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addLast_40_1_41_1461 = addmethod2pos(obj1225, "addLast(1)", &meth_collectionsPrelude_addLast_40_1_41_1461, 12);
  int argcv_meth_collectionsPrelude_addLast_40_1_41_1461[] = {1};
  meth_meth_collectionsPrelude_addLast_40_1_41_1461->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addLast_40_1_41_1461);
  meth_meth_collectionsPrelude_addLast_40_1_41_1461->definitionModule = modulename;
  meth_meth_collectionsPrelude_addLast_40_1_41_1461->definitionLine = 963;
// method "removeLast"
  struct UserObject *uo1464 = (struct UserObject*)obj1225;
  uo1464->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeLast1464 = addmethod2pos(obj1225, "removeLast", &meth_collectionsPrelude_removeLast1464, 13);
  int argcv_meth_collectionsPrelude_removeLast1464[] = {0};
  meth_meth_collectionsPrelude_removeLast1464->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeLast1464);
  meth_meth_collectionsPrelude_removeLast1464->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeLast1464->definitionLine = 964;
// method "addAllFirst(_)"
  struct UserObject *uo1491 = (struct UserObject*)obj1225;
  uo1491->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAllFirst_40_1_41_1491 = addmethod2pos(obj1225, "addAllFirst(1)", &meth_collectionsPrelude_addAllFirst_40_1_41_1491, 14);
  int argcv_meth_collectionsPrelude_addAllFirst_40_1_41_1491[] = {1};
  meth_meth_collectionsPrelude_addAllFirst_40_1_41_1491->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAllFirst_40_1_41_1491);
  meth_meth_collectionsPrelude_addAllFirst_40_1_41_1491->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAllFirst_40_1_41_1491->definitionLine = 970;
// method "addFirst(_)"
  struct UserObject *uo1587 = (struct UserObject*)obj1225;
  uo1587->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addFirst_40_1_41_1587 = addmethod2pos(obj1225, "addFirst(1)", &meth_collectionsPrelude_addFirst_40_1_41_1587, 15);
  int argcv_meth_collectionsPrelude_addFirst_40_1_41_1587[] = {1};
  meth_meth_collectionsPrelude_addFirst_40_1_41_1587->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addFirst_40_1_41_1587);
  meth_meth_collectionsPrelude_addFirst_40_1_41_1587->definitionModule = modulename;
  meth_meth_collectionsPrelude_addFirst_40_1_41_1587->definitionLine = 987;
// method "removeFirst"
  struct UserObject *uo1663 = (struct UserObject*)obj1225;
  uo1663->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeFirst1663 = addmethod2pos(obj1225, "removeFirst", &meth_collectionsPrelude_removeFirst1663, 16);
  int argcv_meth_collectionsPrelude_removeFirst1663[] = {0};
  meth_meth_collectionsPrelude_removeFirst1663->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeFirst1663);
  meth_meth_collectionsPrelude_removeFirst1663->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeFirst1663->definitionLine = 999;
// method "removeAt(_)"
  struct UserObject *uo1667 = (struct UserObject*)obj1225;
  uo1667->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAt_40_1_41_1667 = addmethod2pos(obj1225, "removeAt(1)", &meth_collectionsPrelude_removeAt_40_1_41_1667, 17);
  int argcv_meth_collectionsPrelude_removeAt_40_1_41_1667[] = {1};
  meth_meth_collectionsPrelude_removeAt_40_1_41_1667->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAt_40_1_41_1667);
  meth_meth_collectionsPrelude_removeAt_40_1_41_1667->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAt_40_1_41_1667->definitionLine = 1002;
// method "remove(_)"
  block_savedest(obj1225);
  Object closure1720 = createclosure(1, "remove(1)");
  setclosureframe(closure1720, stackframe);
  addtoclosure(closure1720, var_NoSuchObject);
  struct UserObject *uo1720 = (struct UserObject*)obj1225;
  uo1720->data[18] = (Object)closure1720;
  Method *meth_meth_collectionsPrelude_remove_40_1_41_1720 = addmethod2pos(obj1225, "remove(1)", &meth_collectionsPrelude_remove_40_1_41_1720, 18);
  int argcv_meth_collectionsPrelude_remove_40_1_41_1720[] = {1};
  meth_meth_collectionsPrelude_remove_40_1_41_1720->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_remove_40_1_41_1720);
  meth_meth_collectionsPrelude_remove_40_1_41_1720->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40_1_41_1720->definitionLine = 1013;
// method "remove(_)ifAbsent(_)"
  struct UserObject *uo1738 = (struct UserObject*)obj1225;
  uo1738->data[19] = emptyclosure;
  Method *meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1738 = addmethod2pos(obj1225, "remove(1)ifAbsent(1)", &meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1738, 19);
  int argcv_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1738[] = {1, 1};
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1738->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1738);
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1738->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_1738->definitionLine = 1021;
// method "removeAll(_)"
  block_savedest(obj1225);
  Object closure1748 = createclosure(1, "removeAll(1)");
  setclosureframe(closure1748, stackframe);
  addtoclosure(closure1748, var_NoSuchObject);
  struct UserObject *uo1748 = (struct UserObject*)obj1225;
  uo1748->data[20] = (Object)closure1748;
  Method *meth_meth_collectionsPrelude_removeAll_40_1_41_1748 = addmethod2pos(obj1225, "removeAll(1)", &meth_collectionsPrelude_removeAll_40_1_41_1748, 20);
  int argcv_meth_collectionsPrelude_removeAll_40_1_41_1748[] = {1};
  meth_meth_collectionsPrelude_removeAll_40_1_41_1748->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAll_40_1_41_1748);
  meth_meth_collectionsPrelude_removeAll_40_1_41_1748->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40_1_41_1748->definitionLine = 1030;
// method "removeAll(_)ifAbsent(_)"
  struct UserObject *uo1757 = (struct UserObject*)obj1225;
  uo1757->data[21] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1757 = addmethod2pos(obj1225, "removeAll(1)ifAbsent(1)", &meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1757, 21);
  int argcv_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1757[] = {1, 1};
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1757->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1757);
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1757->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_1757->definitionLine = 1034;
// method "pop"
  struct UserObject *uo1778 = (struct UserObject*)obj1225;
  uo1778->data[22] = emptyclosure;
  Method *meth_meth_collectionsPrelude_pop1778 = addmethod2pos(obj1225, "pop", &meth_collectionsPrelude_pop1778, 22);
  int argcv_meth_collectionsPrelude_pop1778[] = {0};
  meth_meth_collectionsPrelude_pop1778->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_pop1778);
  meth_meth_collectionsPrelude_pop1778->definitionModule = modulename;
  meth_meth_collectionsPrelude_pop1778->definitionLine = 1045;
// method "reversed"
  struct UserObject *uo1781 = (struct UserObject*)obj1225;
  uo1781->data[23] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reversed1781 = addmethod2pos(obj1225, "reversed", &meth_collectionsPrelude_reversed1781, 23);
  int argcv_meth_collectionsPrelude_reversed1781[] = {0};
  meth_meth_collectionsPrelude_reversed1781->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed1781);
  meth_meth_collectionsPrelude_reversed1781->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed1781->definitionLine = 1046;
// method "reverse"
  struct UserObject *uo1797 = (struct UserObject*)obj1225;
  uo1797->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reverse1797 = addmethod2pos(obj1225, "reverse", &meth_collectionsPrelude_reverse1797, 24);
  int argcv_meth_collectionsPrelude_reverse1797[] = {0};
  meth_meth_collectionsPrelude_reverse1797->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reverse1797);
  meth_meth_collectionsPrelude_reverse1797->definitionModule = modulename;
  meth_meth_collectionsPrelude_reverse1797->definitionLine = 1051;
// method "++(_)"
  struct UserObject *uo1838 = (struct UserObject*)obj1225;
  uo1838->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_1838 = addmethod2pos(obj1225, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_1838, 25);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_1838[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_1838->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_1838);
  meth_meth_collectionsPrelude__43__43__40_1_41_1838->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_1838->definitionLine = 1064;
// method "asString"
  struct UserObject *uo1849 = (struct UserObject*)obj1225;
  uo1849->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString1849 = addmethod2pos(obj1225, "asString", &meth_collectionsPrelude_asString1849, 26);
  int argcv_meth_collectionsPrelude_asString1849[] = {0};
  meth_meth_collectionsPrelude_asString1849->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString1849);
  meth_meth_collectionsPrelude_asString1849->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString1849->definitionLine = 1068;
// method "asDebugString"
  struct UserObject *uo1895 = (struct UserObject*)obj1225;
  uo1895->data[27] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString1895 = addmethod2pos(obj1225, "asDebugString", &meth_collectionsPrelude_asDebugString1895, 27);
  int argcv_meth_collectionsPrelude_asDebugString1895[] = {0};
  meth_meth_collectionsPrelude_asDebugString1895->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString1895);
  meth_meth_collectionsPrelude_asDebugString1895->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString1895->definitionLine = 1076;
// method "contains(_)"
  struct UserObject *uo1941 = (struct UserObject*)obj1225;
  uo1941->data[28] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_1941 = addmethod2pos(obj1225, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_1941, 28);
  int argcv_meth_collectionsPrelude_contains_40_1_41_1941[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_1941->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_1941);
  meth_meth_collectionsPrelude_contains_40_1_41_1941->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_1941->definitionLine = 1084;
// method "do(_)"
  struct UserObject *uo1953 = (struct UserObject*)obj1225;
  uo1953->data[29] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_1953 = addmethod2pos(obj1225, "do(1)", &meth_collectionsPrelude_do_40_1_41_1953, 29);
  int argcv_meth_collectionsPrelude_do_40_1_41_1953[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_1953->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_1953);
  meth_meth_collectionsPrelude_do_40_1_41_1953->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_1953->definitionLine = 1088;
// method "==(_)"
  struct UserObject *uo1979 = (struct UserObject*)obj1225;
  uo1979->data[30] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_1979 = addmethod2pos(obj1225, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_1979, 30);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_1979[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_1979->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_1979);
  meth_meth_collectionsPrelude__61__61__40_1_41_1979->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_1979->definitionLine = 1096;
// method "iterator"
  block_savedest(obj1225);
  Object closure1986 = createclosure(2, "iterator");
  setclosureframe(closure1986, stackframe);
  addtoclosure(closure1986, var_ConcurrentModification);
  addtoclosure(closure1986, var_IteratorExhausted);
  struct UserObject *uo1986 = (struct UserObject*)obj1225;
  uo1986->data[31] = (Object)closure1986;
  Method *meth_meth_collectionsPrelude_iterator1986 = addmethod2pos(obj1225, "iterator", &meth_collectionsPrelude_iterator1986, 31);
  int argcv_meth_collectionsPrelude_iterator1986[] = {0};
  meth_meth_collectionsPrelude_iterator1986->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator1986);
  meth_meth_collectionsPrelude_iterator1986->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator1986->definitionLine = 1099;
  block_savedest(obj1225);
  Object closure2070 = createclosure(2, "iterator$object(1)");
  setclosureframe(closure2070, stackframe);
  addtoclosure(closure2070, var_ConcurrentModification);
  addtoclosure(closure2070, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_iterator1986_object = addmethod2pos(obj1225, "iterator$object(1)", &meth_collectionsPrelude_iterator1986_object, 31);
  meth_meth_collectionsPrelude_iterator1986_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator1986_object->definitionLine = 1099;
// method "values"
  struct UserObject *uo2071 = (struct UserObject*)obj1225;
  uo2071->data[32] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values2071 = addmethod2pos(obj1225, "values", &meth_collectionsPrelude_values2071, 32);
  int argcv_meth_collectionsPrelude_values2071[] = {0};
  meth_meth_collectionsPrelude_values2071->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values2071);
  meth_meth_collectionsPrelude_values2071->definitionModule = modulename;
  meth_meth_collectionsPrelude_values2071->definitionLine = 1117;
// method "keys"
  struct UserObject *uo2072 = (struct UserObject*)obj1225;
  uo2072->data[33] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys2072 = addmethod2pos(obj1225, "keys", &meth_collectionsPrelude_keys2072, 33);
  int argcv_meth_collectionsPrelude_keys2072[] = {0};
  meth_meth_collectionsPrelude_keys2072->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys2072);
  meth_meth_collectionsPrelude_keys2072->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys2072->definitionLine = 1120;
// method "expandTo(_)"
  block_savedest(obj1225);
  Object closure2075 = createclosure(1, "expandTo(1)");
  setclosureframe(closure2075, stackframe);
  addtoclosure(closure2075, var__prelude);
  struct UserObject *uo2075 = (struct UserObject*)obj1225;
  uo2075->data[34] = (Object)closure2075;
  Method *meth_meth_collectionsPrelude_expandTo_40_1_41_2075 = addmethod2pos(obj1225, "expandTo(1)", &meth_collectionsPrelude_expandTo_40_1_41_2075, 34);
  int argcv_meth_collectionsPrelude_expandTo_40_1_41_2075[] = {1};
  meth_meth_collectionsPrelude_expandTo_40_1_41_2075->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_expandTo_40_1_41_2075);
  meth_meth_collectionsPrelude_expandTo_40_1_41_2075->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_expandTo_40_1_41_2075->definitionModule = modulename;
  meth_meth_collectionsPrelude_expandTo_40_1_41_2075->definitionLine = 1123;
// method "sortBy(_)"
  struct UserObject *uo2103 = (struct UserObject*)obj1225;
  uo2103->data[35] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortBy_40_1_41_2103 = addmethod2pos(obj1225, "sortBy(1)", &meth_collectionsPrelude_sortBy_40_1_41_2103, 35);
  int argcv_meth_collectionsPrelude_sortBy_40_1_41_2103[] = {1};
  meth_meth_collectionsPrelude_sortBy_40_1_41_2103->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortBy_40_1_41_2103);
  meth_meth_collectionsPrelude_sortBy_40_1_41_2103->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortBy_40_1_41_2103->definitionLine = 1130;
// method "sort"
  struct UserObject *uo2118 = (struct UserObject*)obj1225;
  uo2118->data[36] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sort2118 = addmethod2pos(obj1225, "sort", &meth_collectionsPrelude_sort2118, 36);
  int argcv_meth_collectionsPrelude_sort2118[] = {0};
  meth_meth_collectionsPrelude_sort2118->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sort2118);
  meth_meth_collectionsPrelude_sort2118->definitionModule = modulename;
  meth_meth_collectionsPrelude_sort2118->definitionLine = 1135;
// method "sortedBy(_)"
  struct UserObject *uo2137 = (struct UserObject*)obj1225;
  uo2137->data[37] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy_40_1_41_2137 = addmethod2pos(obj1225, "sortedBy(1)", &meth_collectionsPrelude_sortedBy_40_1_41_2137, 37);
  int argcv_meth_collectionsPrelude_sortedBy_40_1_41_2137[] = {1};
  meth_meth_collectionsPrelude_sortedBy_40_1_41_2137->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy_40_1_41_2137);
  meth_meth_collectionsPrelude_sortedBy_40_1_41_2137->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy_40_1_41_2137->definitionLine = 1142;
// method "sorted"
  struct UserObject *uo2142 = (struct UserObject*)obj1225;
  uo2142->data[38] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted2142 = addmethod2pos(obj1225, "sorted", &meth_collectionsPrelude_sorted2142, 38);
  int argcv_meth_collectionsPrelude_sorted2142[] = {0};
  meth_meth_collectionsPrelude_sorted2142->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted2142);
  meth_meth_collectionsPrelude_sorted2142->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted2142->definitionLine = 1145;
// method "copy"
  struct UserObject *uo2147 = (struct UserObject*)obj1225;
  uo2147->data[39] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy2147 = addmethod2pos(obj1225, "copy", &meth_collectionsPrelude_copy2147, 39);
  int argcv_meth_collectionsPrelude_copy2147[] = {0};
  meth_meth_collectionsPrelude_copy2147->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy2147);
  meth_meth_collectionsPrelude_copy2147->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy2147->definitionLine = 1148;
  sourceObject = obj1225;
// Begin line 889
  setline(889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2152 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2153 = callmethodflags(*var_indexable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2152);
// compiled call node returning call2153 (depth = 2)
  struct UserObject *obj1225_uo = (struct UserObject *)obj1225;
  obj1225_uo->super = call2153;
  sourceObject = obj1225;
// Begin line 891
  setline(891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2154 = alloc_Float64(0);
// compiled num node returning num2154 (depth = 2)
  adddatum2(obj1225, num2154, 1);
  sourceObject = obj1225;
// Begin line 892
  setline(892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool2155 = alloc_Boolean(1);
// compiled identifier node returning bool2155 (depth = 2)
  adddatum2(obj1225, bool2155, 2);
  sourceObject = obj1225;
// Begin line 894
  setline(894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2157 = alloc_Float64(1);
// compiled num node returning num2157 (depth = 3)
  int op_slot_right_2156 = gc_frame_newslot(num2157);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2160 = alloc_Float64(2);
// compiled num node returning num2160 (depth = 4)
  int op_slot_right_2159 = gc_frame_newslot(num2160);
// starting to compile call node (depth = 4)
  int callframe2162 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block2163 = alloc_Block(NULL, NULL, "collectionsPrelude", 894);
  gc_frame_newslot(block2163);
// method "_apply"
  block_savedest(block2163);
  Object closure2164 = createclosure(1, "_apply");
  setclosureframe(closure2164, stackframe);
  addtoclosure(closure2164, selfslot);
  struct UserObject *uo2164 = (struct UserObject*)block2163;
  uo2164->data[0] = (Object)closure2164;
  Method *meth_meth_collectionsPrelude__apply2164 = addmethod2pos(block2163, "_apply", &meth_collectionsPrelude__apply2164, 0);
  int argcv_meth_collectionsPrelude__apply2164[] = {0};
  meth_meth_collectionsPrelude__apply2164->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2164);
  meth_meth_collectionsPrelude__apply2164->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2164->definitionLine = 1963;
// compiled block node returning block2163 (depth = 5)
  gc_frame_newslot(block2163);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_a (depth = 5)
  params[0] = block2163;
  partcv[0] = 1;
  Object call2170 = callmethodflags(*var_a, "sizeIfUnknown(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2162);
// compiled call node returning call2170 (depth = 4)
  int op_slot_left_2159 = gc_frame_newslot(call2170);
  params[0] = num2160;
  partcv[0] = 1;
  Object prod2171 = callmethod(call2170, "*(1)", 1, partcv, params);
// compiled op node returning prod2171 (depth = 3)
  int op_slot_left_2156 = gc_frame_newslot(prod2171);
  params[0] = num2157;
  partcv[0] = 1;
  Object sum2172 = callmethod(prod2171, "+(1)", 1, partcv, params);
// compiled op node returning sum2172 (depth = 2)
  adddatum2(obj1225, sum2172, 3);
  sourceObject = obj1225;
// Begin line 895
  setline(895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2173 = gc_frame_new();
// starting to compile member node (depth = 3)
  int callframe2174 = gc_frame_new();
// call case 4: self request
  Object call2175 = callmethodflags(self, "initialSize", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2174);
// compiled member node returning call2175 (depth = 3)
  gc_frame_newslot(call2175);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2176 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__prelude (depth = 4)
  Object call2177 = callmethodflags(*var__prelude, "primitiveArray", 0, partcv, params, 0);
  gc_frame_end(callframe2176);
// compiled member node returning call2177 (depth = 3)
  params[0] = call2175;
  partcv[0] = 1;
  Object call2178 = callmethodflags(call2177, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2173);
// compiled call node returning call2178 (depth = 2)
  adddatum2(obj1225, call2178, 4);
  sourceObject = obj1225;
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2179 = alloc_Float64(0);
// compiled num node returning num2179 (depth = 2)
  adddatum2(obj1225, num2179, 5);
  sourceObject = obj1225;
// Begin line 897
  setline(897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2181 = gc_frame_new();
// call case 4: self request
  Object call2182 = callmethodflags(self, "sizeCertain", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2181);
// compiled member node returning call2182 (depth = 3)
  Object if2180 = done;
struct StackFrameObject *iftmpstackframe2180 = stackframe;
  if (istrue(call2182)) {
stackframe = alloc_StackFrame(0, iftmpstackframe2180);
gc_frame_newslot((Object)stackframe);
// Begin line 899
  setline(899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2183 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_a (depth = 4)
  gc_frame_newslot(*var_a);
// starting to compile block node (depth = 4)
  Object block2184 = alloc_Block(NULL, NULL, "collectionsPrelude", 899);
  gc_frame_newslot(block2184);
// method "_apply(_)"
  block_savedest(block2184);
  Object closure2185 = createclosure(1, "_apply(1)");
  setclosureframe(closure2185, stackframe);
  addtoclosure(closure2185, selfslot);
  struct UserObject *uo2185 = (struct UserObject*)block2184;
  uo2185->data[0] = (Object)closure2185;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2185 = addmethod2pos(block2184, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2185, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2185[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2185->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2185);
  meth_meth_collectionsPrelude__apply_40_1_41_2185->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2185->definitionLine = 1963;
// compiled block node returning block2184 (depth = 4)
  gc_frame_newslot(block2184);
// call case 5: prelude request
  params[0] = *var_a;
  params[1] = block2184;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2201 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2183);
// compiled call node returning call2201 (depth = 3)
    gc_frame_newslot(call2201);
    if2180 = call2201;
  } else {
  stackframe = alloc_StackFrame(1, iftmpstackframe2180);
  gc_frame_newslot((Object)stackframe);
  Object *var_innerSize = &(stackframe->slots[0]);
  setframeelementname(stackframe, 0, "innerSize");
// Begin line 905
  setline(905);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2202 = gc_frame_new();
// call case 4: self request
  Object call2203 = callmethodflags(self, "initialSize", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2202);
// compiled member node returning call2203 (depth = 4)
  *var_innerSize = call2203;
  if (call2203 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 906
  setline(906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2204 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_a (depth = 4)
  gc_frame_newslot(*var_a);
// starting to compile block node (depth = 4)
  Object block2205 = alloc_Block(NULL, NULL, "collectionsPrelude", 906);
  gc_frame_newslot(block2205);
// method "_apply(_)"
  block_savedest(block2205);
  Object closure2206 = createclosure(3, "_apply(1)");
  setclosureframe(closure2206, stackframe);
  addtoclosure(closure2206, var_innerSize);
  addtoclosure(closure2206, var__prelude);
  addtoclosure(closure2206, selfslot);
  struct UserObject *uo2206 = (struct UserObject*)block2205;
  uo2206->data[0] = (Object)closure2206;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2206 = addmethod2pos(block2205, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2206, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2206[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2206->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2206);
  meth_meth_collectionsPrelude__apply_40_1_41_2206->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2206->definitionLine = 1963;
// compiled block node returning block2205 (depth = 4)
  gc_frame_newslot(block2205);
// call case 5: prelude request
  params[0] = *var_a;
  params[1] = block2205;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2262 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2204);
// compiled call node returning call2262 (depth = 3)
    gc_frame_newslot(call2262);
    if2180 = call2262;
  }
stackframe = iftmpstackframe2180;
// compiled if node returning if2180 (depth = 2)
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  sourceObject = obj1225;
  objclass1225 = obj1225->class;
  objclass1225->definitionModule = modulename;
  objclass1225->definitionLine = 887;
  (*(struct UserObject *)self).data[0] = lowerouter1225;
  self = oldself1225;
  selfslot = oldselfslot1225;
  stackframe = oldstackframe1225;
  gc_frame_end(frame);
  return obj1225;
}
Object meth_collectionsPrelude_list706(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "list");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object *var_done = getfromclosure(closure, 2);
  Object *var_ConcurrentModification = getfromclosure(closure, 3);
  Object *var_IteratorExhausted = getfromclosure(closure, 4);
  Object *var_indexable = getfromclosure(closure, 5);
  Object *var_BoundsError = getfromclosure(closure, 6);
  Object *var__prelude = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject707 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj707 = alloc_userobj2(4,5, objclass707);
  gc_frame_newslot(obj707);
if (objclass707 == NULL) {
  glfree(obj707->class->name);
  obj707->class->name = "list";
}
// OBJECT OUTER DEC outer
  adddatum2(obj707, self, 0);
  addmethodreal(obj707,"outer", &reader_collectionsPrelude_outer_708);
  Object oldself707 = self;
  struct StackFrameObject *oldstackframe707 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe707);
  gc_frame_newslot((Object)stackframe);
  self = obj707;
  Object *oldselfslot707 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter707 = (*(struct UserObject *)self).data[0], lowerouter707 = thisouter707;
  if (inheritingObject707) {
    struct UserObject *inho707 = (struct UserObject *)inheritingObject707;
    while (inho707->super != GraceDefaultObject) inho707 = (struct UserObject *)inho707->super;
    inho707->super = obj707;
    self = inheritingObject707;
    *selfslot = self;
    lowerouter707 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter707;
  }
// method "asString"
  struct UserObject *uo709 = (struct UserObject*)obj707;
  uo709->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString709 = addmethod2pos(obj707, "asString", &meth_collectionsPrelude_asString709, 1);
  int argcv_meth_collectionsPrelude_asString709[] = {0};
  meth_meth_collectionsPrelude_asString709->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString709);
  meth_meth_collectionsPrelude_asString709->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString709->definitionLine = 620;
// method "empty"
  block_savedest(obj707);
  Object closure711 = createclosure(1, "empty");
  setclosureframe(closure711, stackframe);
  addtoclosure(closure711, var_emptySequence);
  struct UserObject *uo711 = (struct UserObject*)obj707;
  uo711->data[2] = (Object)closure711;
  Method *meth_meth_collectionsPrelude_empty711 = addmethod2pos(obj707, "empty", &meth_collectionsPrelude_empty711, 2);
  int argcv_meth_collectionsPrelude_empty711[] = {0};
  meth_meth_collectionsPrelude_empty711->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_empty711);
  meth_meth_collectionsPrelude_empty711->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty711->definitionLine = 622;
// method "withAll(_)"
  block_savedest(obj707);
  Object closure714 = createclosure(7, "withAll(1)");
  setclosureframe(closure714, stackframe);
  addtoclosure(closure714, var_NoSuchObject);
  addtoclosure(closure714, var_done);
  addtoclosure(closure714, var_ConcurrentModification);
  addtoclosure(closure714, var_IteratorExhausted);
  addtoclosure(closure714, var_indexable);
  addtoclosure(closure714, var_BoundsError);
  addtoclosure(closure714, var__prelude);
  struct UserObject *uo714 = (struct UserObject*)obj707;
  uo714->data[3] = (Object)closure714;
  Method *meth_meth_collectionsPrelude_withAll_40_1_41_714 = addmethod2pos(obj707, "withAll(1)", &meth_collectionsPrelude_withAll_40_1_41_714, 3);
  int argcv_meth_collectionsPrelude_withAll_40_1_41_714[] = {1};
  meth_meth_collectionsPrelude_withAll_40_1_41_714->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll_40_1_41_714);
  meth_meth_collectionsPrelude_withAll_40_1_41_714->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll_40_1_41_714->definitionLine = 626;
  block_savedest(obj707);
  Object closure2263 = createclosure(7, "withAll(1)$object(1)");
  setclosureframe(closure2263, stackframe);
  addtoclosure(closure2263, var_NoSuchObject);
  addtoclosure(closure2263, var_done);
  addtoclosure(closure2263, var_ConcurrentModification);
  addtoclosure(closure2263, var_IteratorExhausted);
  addtoclosure(closure2263, var_indexable);
  addtoclosure(closure2263, var_BoundsError);
  addtoclosure(closure2263, var__prelude);
  Method *meth_meth_collectionsPrelude_withAll_40_1_41_714_object = addmethod2pos(obj707, "withAll(1)$object(1)", &meth_collectionsPrelude_withAll_40_1_41_714_object, 3);
  meth_meth_collectionsPrelude_withAll_40_1_41_714_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll_40_1_41_714_object->definitionLine = 626;
  sourceObject = obj707;
  sourceObject = obj707;
  sourceObject = obj707;
  objclass707 = obj707->class;
  objclass707->definitionModule = modulename;
  objclass707->definitionLine = 618;
  (*(struct UserObject *)self).data[0] = lowerouter707;
  self = oldself707;
  selfslot = oldselfslot707;
  stackframe = oldstackframe707;
  gc_frame_end(frame);
  return obj707;
}
Object meth_collectionsPrelude_list706_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "list$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object *var_done = getfromclosure(closure, 2);
  Object *var_ConcurrentModification = getfromclosure(closure, 3);
  Object *var_IteratorExhausted = getfromclosure(closure, 4);
  Object *var_indexable = getfromclosure(closure, 5);
  Object *var_BoundsError = getfromclosure(closure, 6);
  Object *var__prelude = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject707 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj707 = alloc_userobj2(4,5, objclass707);
  gc_frame_newslot(obj707);
if (objclass707 == NULL) {
  glfree(obj707->class->name);
  obj707->class->name = "list";
}
// OBJECT OUTER DEC outer
  adddatum2(obj707, self, 0);
  addmethodreal(obj707,"outer", &reader_collectionsPrelude_outer_708);
  Object oldself707 = self;
  struct StackFrameObject *oldstackframe707 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe707);
  gc_frame_newslot((Object)stackframe);
  self = obj707;
  Object *oldselfslot707 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter707 = (*(struct UserObject *)self).data[0], lowerouter707 = thisouter707;
  if (inheritingObject707) {
    struct UserObject *inho707 = (struct UserObject *)inheritingObject707;
    while (inho707->super != GraceDefaultObject) inho707 = (struct UserObject *)inho707->super;
    inho707->super = obj707;
    self = inheritingObject707;
    *selfslot = self;
    lowerouter707 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter707;
  }
// method "asString"
  struct UserObject *uo709 = (struct UserObject*)obj707;
  uo709->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString709 = addmethod2pos(obj707, "asString", &meth_collectionsPrelude_asString709, 1);
  int argcv_meth_collectionsPrelude_asString709[] = {0};
  meth_meth_collectionsPrelude_asString709->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString709);
  meth_meth_collectionsPrelude_asString709->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString709->definitionLine = 620;
// method "empty"
  block_savedest(obj707);
  Object closure711 = createclosure(1, "empty");
  setclosureframe(closure711, stackframe);
  addtoclosure(closure711, var_emptySequence);
  struct UserObject *uo711 = (struct UserObject*)obj707;
  uo711->data[2] = (Object)closure711;
  Method *meth_meth_collectionsPrelude_empty711 = addmethod2pos(obj707, "empty", &meth_collectionsPrelude_empty711, 2);
  int argcv_meth_collectionsPrelude_empty711[] = {0};
  meth_meth_collectionsPrelude_empty711->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_empty711);
  meth_meth_collectionsPrelude_empty711->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty711->definitionLine = 622;
// method "withAll(_)"
  block_savedest(obj707);
  Object closure714 = createclosure(7, "withAll(1)");
  setclosureframe(closure714, stackframe);
  addtoclosure(closure714, var_NoSuchObject);
  addtoclosure(closure714, var_done);
  addtoclosure(closure714, var_ConcurrentModification);
  addtoclosure(closure714, var_IteratorExhausted);
  addtoclosure(closure714, var_indexable);
  addtoclosure(closure714, var_BoundsError);
  addtoclosure(closure714, var__prelude);
  struct UserObject *uo714 = (struct UserObject*)obj707;
  uo714->data[3] = (Object)closure714;
  Method *meth_meth_collectionsPrelude_withAll_40_1_41_714 = addmethod2pos(obj707, "withAll(1)", &meth_collectionsPrelude_withAll_40_1_41_714, 3);
  int argcv_meth_collectionsPrelude_withAll_40_1_41_714[] = {1};
  meth_meth_collectionsPrelude_withAll_40_1_41_714->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll_40_1_41_714);
  meth_meth_collectionsPrelude_withAll_40_1_41_714->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll_40_1_41_714->definitionLine = 626;
  block_savedest(obj707);
  Object closure2263 = createclosure(7, "withAll(1)$object(1)");
  setclosureframe(closure2263, stackframe);
  addtoclosure(closure2263, var_NoSuchObject);
  addtoclosure(closure2263, var_done);
  addtoclosure(closure2263, var_ConcurrentModification);
  addtoclosure(closure2263, var_IteratorExhausted);
  addtoclosure(closure2263, var_indexable);
  addtoclosure(closure2263, var_BoundsError);
  addtoclosure(closure2263, var__prelude);
  Method *meth_meth_collectionsPrelude_withAll_40_1_41_714_object = addmethod2pos(obj707, "withAll(1)$object(1)", &meth_collectionsPrelude_withAll_40_1_41_714_object, 3);
  meth_meth_collectionsPrelude_withAll_40_1_41_714_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll_40_1_41_714_object->definitionLine = 626;
  sourceObject = obj707;
  sourceObject = obj707;
  sourceObject = obj707;
  objclass707 = obj707->class;
  objclass707->definitionModule = modulename;
  objclass707->definitionLine = 618;
  (*(struct UserObject *)self).data[0] = lowerouter707;
  self = oldself707;
  selfslot = oldselfslot707;
  stackframe = oldstackframe707;
  gc_frame_end(frame);
  return obj707;
}
Object meth_collectionsPrelude_asString2268(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1174
  setline(1174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit2269 == NULL) {
    strlit2269 = alloc_String("a set factory");
    gc_root(strlit2269);
  }
// compiled string node returning strlit2269 (depth = 2)
  gc_frame_end(frame);
  return strlit2269;
}
Object meth_collectionsPrelude__apply2280(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile num node (depth = 8)
  Object num2281 = alloc_Float64(2);
// compiled num node returning num2281 (depth = 8)
  gc_frame_end(frame);
  return num2281;
}
Object meth_collectionsPrelude__apply_40_1_41_2294(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe2295 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_x (depth = 5)
  gc_frame_newslot(*var_x);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2296 = callmethodflags(*var_result, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2295);
// compiled call node returning call2296 (depth = 4)
  gc_frame_end(frame);
  return call2296;
}
Object meth_collectionsPrelude_withAll_40_1_41_2270(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "withAll(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method withAll(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for withAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_cap = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "cap");
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 1177
  setline(1177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2271 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2273 = alloc_Float64(1);
// compiled num node returning num2273 (depth = 5)
  int op_slot_right_2272 = gc_frame_newslot(num2273);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2276 = alloc_Float64(3);
// compiled num node returning num2276 (depth = 6)
  int op_slot_right_2275 = gc_frame_newslot(num2276);
// starting to compile call node (depth = 6)
  int callframe2278 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block2279 = alloc_Block(NULL, NULL, "collectionsPrelude", 1177);
  gc_frame_newslot(block2279);
// method "_apply"
  block_savedest(block2279);
  Object closure2280 = createclosure(1, "_apply");
  setclosureframe(closure2280, stackframe);
  addtoclosure(closure2280, selfslot);
  struct UserObject *uo2280 = (struct UserObject*)block2279;
  uo2280->data[0] = (Object)closure2280;
  Method *meth_meth_collectionsPrelude__apply2280 = addmethod2pos(block2279, "_apply", &meth_collectionsPrelude__apply2280, 0);
  int argcv_meth_collectionsPrelude__apply2280[] = {0};
  meth_meth_collectionsPrelude__apply2280->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2280);
  meth_meth_collectionsPrelude__apply2280->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2280->definitionLine = 1963;
// compiled block node returning block2279 (depth = 7)
  gc_frame_newslot(block2279);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  params[0] = block2279;
  partcv[0] = 1;
  Object call2283 = callmethodflags(*var_a, "sizeIfUnknown(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2278);
// compiled call node returning call2283 (depth = 6)
  int op_slot_left_2275 = gc_frame_newslot(call2283);
  params[0] = num2276;
  partcv[0] = 1;
  Object prod2284 = callmethod(call2283, "*(1)", 1, partcv, params);
// compiled op node returning prod2284 (depth = 5)
  int op_slot_left_2272 = gc_frame_newslot(prod2284);
  params[0] = num2273;
  partcv[0] = 1;
  Object sum2285 = callmethod(prod2284, "+(1)", 1, partcv, params);
// compiled op node returning sum2285 (depth = 4)
  gc_frame_newslot(sum2285);
// starting to compile num node (depth = 4)
  Object num2286 = alloc_Float64(8);
// compiled num node returning num2286 (depth = 4)
  gc_frame_newslot(num2286);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2287 = gc_frame_new();
// call case 3: self.outer request
  Object call2288 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2287);
// compiled member node returning call2288 (depth = 4)
  params[0] = sum2285;
  params[1] = num2286;
  partcv[0] = 2;
  Object call2289 = callmethodflags(call2288, "max(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2271);
// compiled call node returning call2289 (depth = 3)
  *var_cap = call2289;
  if (call2289 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1178
  setline(1178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2290 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cap (depth = 4)
  gc_frame_newslot(*var_cap);
// call case 4: self request
  params[0] = *var_cap;
  partcv[0] = 1;
  Object call2291 = callmethodflags(self, "ofCapacity(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2290);
// compiled call node returning call2291 (depth = 3)
  *var_result = call2291;
  if (call2291 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1179
  setline(1179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2292 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2293 = alloc_Block(NULL, NULL, "collectionsPrelude", 1179);
  gc_frame_newslot(block2293);
// method "_apply(_)"
  block_savedest(block2293);
  Object closure2294 = createclosure(2, "_apply(1)");
  setclosureframe(closure2294, stackframe);
  addtoclosure(closure2294, var_result);
  addtoclosure(closure2294, selfslot);
  struct UserObject *uo2294 = (struct UserObject*)block2293;
  uo2294->data[0] = (Object)closure2294;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2294 = addmethod2pos(block2293, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2294, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2294[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2294->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2294);
  meth_meth_collectionsPrelude__apply_40_1_41_2294->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2294->definitionLine = 1963;
// compiled block node returning block2293 (depth = 3)
  gc_frame_newslot(block2293);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_a (depth = 3)
  params[0] = block2293;
  partcv[0] = 1;
  Object call2298 = callmethodflags(*var_a, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2292);
// compiled call node returning call2298 (depth = 2)
// Begin line 1180
  setline(1180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude_empty2299(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "empty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1184
  setline(1184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2300 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num2301 = alloc_Float64(8);
// compiled num node returning num2301 (depth = 3)
  gc_frame_newslot(num2301);
// call case 4: self request
  params[0] = num2301;
  partcv[0] = 1;
  Object call2302 = callmethodflags(self, "ofCapacity(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2300);
// compiled call node returning call2302 (depth = 2)
  gc_frame_end(frame);
  return call2302;
}
Object meth_collectionsPrelude__apply_40_1_41_2320(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 1199
  setline(1199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2322 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe2323 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_x (depth = 7)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2324 = callmethodflags(self, "contains(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2323);
// compiled call node returning call2324 (depth = 6)
  partcv[0] = 0;
  Object call2325 = callmethodflags(call2324, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe2322);
// compiled call node returning call2325 (depth = 5)
  Object if2321 = done;
  if (istrue(call2325)) {
// Begin line 1200
  setline(1200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2326 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_x (depth = 7)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2327 = callmethodflags(self, "findPositionForAdd(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2326);
// compiled call node returning call2327 (depth = 6)
  *var_t = call2327;
  if (call2327 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 5)
// Begin line 1201
  setline(1201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2328 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  gc_frame_newslot(*var_x);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2329 = gc_frame_new();
// call case 4: self request
  Object call2330 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2329);
// compiled member node returning call2330 (depth = 6)
  params[0] = *var_t;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2331 = callmethodflags(call2330, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2328);
// compiled call node returning call2331 (depth = 5)
// Begin line 1202
  setline(1202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2332 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2334 = alloc_Float64(1);
// compiled num node returning num2334 (depth = 7)
  int op_slot_right_2333 = gc_frame_newslot(num2334);
// starting to compile member node (depth = 7)
  int callframe2336 = gc_frame_new();
// call case 4: self request
  Object call2337 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2336);
// compiled member node returning call2337 (depth = 7)
  int op_slot_left_2333 = gc_frame_newslot(call2337);
  params[0] = num2334;
  partcv[0] = 1;
  Object sum2338 = callmethod(call2337, "+(1)", 1, partcv, params);
// compiled op node returning sum2338 (depth = 6)
  gc_frame_newslot(sum2338);
// call case 4: self request
  params[0] = sum2338;
  partcv[0] = 1;
  Object call2339 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2332);
// compiled call node returning call2339 (depth = 5)
// Begin line 1203
  setline(1203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2343 = alloc_Float64(2);
// compiled num node returning num2343 (depth = 8)
  int op_slot_right_2342 = gc_frame_newslot(num2343);
// starting to compile member node (depth = 8)
  int callframe2345 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2346 = gc_frame_new();
// call case 4: self request
  Object call2347 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2346);
// compiled member node returning call2347 (depth = 9)
  Object call2348 = callmethodflags(call2347, "size", 0, partcv, params, 0);
  gc_frame_end(callframe2345);
// compiled member node returning call2348 (depth = 8)
  int op_slot_left_2342 = gc_frame_newslot(call2348);
  params[0] = num2343;
  partcv[0] = 1;
  Object quotient2349 = callmethod(call2348, "/(1)", 1, partcv, params);
// compiled op node returning quotient2349 (depth = 7)
  int op_slot_right_2341 = gc_frame_newslot(quotient2349);
// starting to compile member node (depth = 7)
  int callframe2351 = gc_frame_new();
// call case 4: self request
  Object call2352 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2351);
// compiled member node returning call2352 (depth = 7)
  int op_slot_left_2341 = gc_frame_newslot(call2352);
  params[0] = quotient2349;
  partcv[0] = 1;
  Object opresult2353 = callmethod(call2352, ">(1)", 1, partcv, params);
// compiled op node returning opresult2353 (depth = 6)
  Object if2340 = done;
  if (istrue(opresult2353)) {
// Begin line 1204
  setline(1204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe2354 = gc_frame_new();
// call case 4: self request
  Object call2355 = callmethodflags(self, "expand", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2354);
// compiled member node returning call2355 (depth = 6)
    gc_frame_newslot(call2355);
    if2340 = call2355;
  } else {
  }
// compiled if node returning if2340 (depth = 5)
    gc_frame_newslot(if2340);
    if2321 = if2340;
  } else {
  }
// compiled if node returning if2321 (depth = 4)
  gc_frame_end(frame);
  return if2321;
}
Object meth_collectionsPrelude_addAll_40_1_41_2309(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addAll(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addAll(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elements = &(stackframe->slots[0]);
  *var_elements = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part addAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1197
  setline(1197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2310 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2312 = alloc_Float64(1);
// compiled num node returning num2312 (depth = 4)
  int op_slot_right_2311 = gc_frame_newslot(num2312);
// starting to compile member node (depth = 4)
  int callframe2314 = gc_frame_new();
// call case 4: self request
  Object call2315 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2314);
// compiled member node returning call2315 (depth = 4)
  int op_slot_left_2311 = gc_frame_newslot(call2315);
  params[0] = num2312;
  partcv[0] = 1;
  Object sum2316 = callmethod(call2315, "+(1)", 1, partcv, params);
// compiled op node returning sum2316 (depth = 3)
  gc_frame_newslot(sum2316);
// call case 4: self request
  params[0] = sum2316;
  partcv[0] = 1;
  Object call2317 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2310);
// compiled call node returning call2317 (depth = 2)
// Begin line 1198
  setline(1198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2318 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elements (depth = 3)
  gc_frame_newslot(*var_elements);
// starting to compile block node (depth = 3)
  Object block2319 = alloc_Block(NULL, NULL, "collectionsPrelude", 1198);
  gc_frame_newslot(block2319);
// method "_apply(_)"
  block_savedest(block2319);
  Object closure2320 = createclosure(1, "_apply(1)");
  setclosureframe(closure2320, stackframe);
  addtoclosure(closure2320, selfslot);
  struct UserObject *uo2320 = (struct UserObject*)block2319;
  uo2320->data[0] = (Object)closure2320;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2320 = addmethod2pos(block2319, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2320, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2320[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2320->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2320);
  meth_meth_collectionsPrelude__apply_40_1_41_2320->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2320->definitionLine = 1963;
// compiled block node returning block2319 (depth = 3)
  gc_frame_newslot(block2319);
// call case 5: prelude request
  params[0] = *var_elements;
  params[1] = block2319;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2357 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2318);
// compiled call node returning call2357 (depth = 2)
// Begin line 1208
  setline(1208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_add_40_1_41_2358(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "add(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method add(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for add(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part add(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 1212
  setline(1212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2360 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 4)
  int callframe2361 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_x (depth = 5)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2362 = callmethodflags(self, "contains(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2361);
// compiled call node returning call2362 (depth = 4)
  partcv[0] = 0;
  Object call2363 = callmethodflags(call2362, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe2360);
// compiled call node returning call2363 (depth = 3)
  Object if2359 = done;
  if (istrue(call2363)) {
// Begin line 1213
  setline(1213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2364 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2366 = alloc_Float64(1);
// compiled num node returning num2366 (depth = 5)
  int op_slot_right_2365 = gc_frame_newslot(num2366);
// starting to compile member node (depth = 5)
  int callframe2368 = gc_frame_new();
// call case 4: self request
  Object call2369 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2368);
// compiled member node returning call2369 (depth = 5)
  int op_slot_left_2365 = gc_frame_newslot(call2369);
  params[0] = num2366;
  partcv[0] = 1;
  Object sum2370 = callmethod(call2369, "+(1)", 1, partcv, params);
// compiled op node returning sum2370 (depth = 4)
  gc_frame_newslot(sum2370);
// call case 4: self request
  params[0] = sum2370;
  partcv[0] = 1;
  Object call2371 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2364);
// compiled call node returning call2371 (depth = 3)
// Begin line 1214
  setline(1214);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2372 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_x (depth = 5)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2373 = callmethodflags(self, "findPositionForAdd(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2372);
// compiled call node returning call2373 (depth = 4)
  *var_t = call2373;
  if (call2373 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 1215
  setline(1215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2374 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  gc_frame_newslot(*var_x);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2375 = gc_frame_new();
// call case 4: self request
  Object call2376 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2375);
// compiled member node returning call2376 (depth = 4)
  params[0] = *var_t;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2377 = callmethodflags(call2376, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2374);
// compiled call node returning call2377 (depth = 3)
// Begin line 1216
  setline(1216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2378 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2380 = alloc_Float64(1);
// compiled num node returning num2380 (depth = 5)
  int op_slot_right_2379 = gc_frame_newslot(num2380);
// starting to compile member node (depth = 5)
  int callframe2382 = gc_frame_new();
// call case 4: self request
  Object call2383 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2382);
// compiled member node returning call2383 (depth = 5)
  int op_slot_left_2379 = gc_frame_newslot(call2383);
  params[0] = num2380;
  partcv[0] = 1;
  Object sum2384 = callmethod(call2383, "+(1)", 1, partcv, params);
// compiled op node returning sum2384 (depth = 4)
  gc_frame_newslot(sum2384);
// call case 4: self request
  params[0] = sum2384;
  partcv[0] = 1;
  Object call2385 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2378);
// compiled call node returning call2385 (depth = 3)
// Begin line 1217
  setline(1217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2389 = alloc_Float64(2);
// compiled num node returning num2389 (depth = 6)
  int op_slot_right_2388 = gc_frame_newslot(num2389);
// starting to compile member node (depth = 6)
  int callframe2391 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2392 = gc_frame_new();
// call case 4: self request
  Object call2393 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2392);
// compiled member node returning call2393 (depth = 7)
  Object call2394 = callmethodflags(call2393, "size", 0, partcv, params, 0);
  gc_frame_end(callframe2391);
// compiled member node returning call2394 (depth = 6)
  int op_slot_left_2388 = gc_frame_newslot(call2394);
  params[0] = num2389;
  partcv[0] = 1;
  Object quotient2395 = callmethod(call2394, "/(1)", 1, partcv, params);
// compiled op node returning quotient2395 (depth = 5)
  int op_slot_right_2387 = gc_frame_newslot(quotient2395);
// starting to compile member node (depth = 5)
  int callframe2397 = gc_frame_new();
// call case 4: self request
  Object call2398 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2397);
// compiled member node returning call2398 (depth = 5)
  int op_slot_left_2387 = gc_frame_newslot(call2398);
  params[0] = quotient2395;
  partcv[0] = 1;
  Object opresult2399 = callmethod(call2398, ">(1)", 1, partcv, params);
// compiled op node returning opresult2399 (depth = 4)
  Object if2386 = done;
  if (istrue(opresult2399)) {
// Begin line 1218
  setline(1218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe2400 = gc_frame_new();
// call case 4: self request
  Object call2401 = callmethodflags(self, "expand", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2400);
// compiled member node returning call2401 (depth = 4)
    gc_frame_newslot(call2401);
    if2386 = call2401;
  } else {
  }
// compiled if node returning if2386 (depth = 3)
    gc_frame_newslot(if2386);
    if2359 = if2386;
  } else {
  }
// compiled if node returning if2359 (depth = 2)
// Begin line 1221
  setline(1221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply2408(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_x = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1227
  setline(1227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2409 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2411 == NULL) {
    strlit2411 = alloc_String("");
    gc_root(strlit2411);
  }
// compiled string node returning strlit2411 (depth = 8)
  int op_slot_right_2410 = gc_frame_newslot(strlit2411);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_x (depth = 9)
  int op_slot_right_2413 = gc_frame_newslot(*var_x);
// starting to compile string node (depth = 9)
  if (strlit2415 == NULL) {
    strlit2415 = alloc_String("set does not contain ");
    gc_root(strlit2415);
  }
// compiled string node returning strlit2415 (depth = 9)
  int op_slot_left_2413 = gc_frame_newslot(strlit2415);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult2416 = callmethod(strlit2415, "++(1)", 1, partcv, params);
// compiled op node returning opresult2416 (depth = 8)
  int op_slot_left_2410 = gc_frame_newslot(opresult2416);
  params[0] = strlit2411;
  partcv[0] = 1;
  Object opresult2417 = callmethod(opresult2416, "++(1)", 1, partcv, params);
// compiled op node returning opresult2417 (depth = 7)
  gc_frame_newslot(opresult2417);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_NoSuchObject (depth = 7)
  params[0] = opresult2417;
  partcv[0] = 1;
  Object call2418 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2409);
// compiled call node returning call2418 (depth = 6)
  gc_frame_end(frame);
  return call2418;
}
Object meth_collectionsPrelude__apply_40_1_41_2405(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1226
  setline(1226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2406 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_x (depth = 5)
  gc_frame_newslot(*var_x);
// starting to compile block node (depth = 5)
  Object block2407 = alloc_Block(NULL, NULL, "collectionsPrelude", 1226);
  gc_frame_newslot(block2407);
// method "_apply"
  block_savedest(block2407);
  Object closure2408 = createclosure(3, "_apply");
  setclosureframe(closure2408, stackframe);
  addtoclosure(closure2408, var_x);
  addtoclosure(closure2408, var_NoSuchObject);
  addtoclosure(closure2408, selfslot);
  struct UserObject *uo2408 = (struct UserObject*)block2407;
  uo2408->data[0] = (Object)closure2408;
  Method *meth_meth_collectionsPrelude__apply2408 = addmethod2pos(block2407, "_apply", &meth_collectionsPrelude__apply2408, 0);
  int argcv_meth_collectionsPrelude__apply2408[] = {0};
  meth_meth_collectionsPrelude__apply2408->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2408);
  meth_meth_collectionsPrelude__apply2408->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2408->definitionLine = 1963;
// compiled block node returning block2407 (depth = 5)
  gc_frame_newslot(block2407);
// call case 4: self request
  params[0] = *var_x;
  params[1] = block2407;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2420 = callmethodflags(self, "remove(1)ifAbsent(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2406);
// compiled call node returning call2420 (depth = 4)
  gc_frame_end(frame);
  return call2420;
}
Object meth_collectionsPrelude_removeAll_40_1_41_2402(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeAll(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll(_)");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elements = &(stackframe->slots[0]);
  *var_elements = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1225
  setline(1225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2403 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elements (depth = 3)
  gc_frame_newslot(*var_elements);
// starting to compile block node (depth = 3)
  Object block2404 = alloc_Block(NULL, NULL, "collectionsPrelude", 1225);
  gc_frame_newslot(block2404);
// method "_apply(_)"
  block_savedest(block2404);
  Object closure2405 = createclosure(2, "_apply(1)");
  setclosureframe(closure2405, stackframe);
  addtoclosure(closure2405, var_NoSuchObject);
  addtoclosure(closure2405, selfslot);
  struct UserObject *uo2405 = (struct UserObject*)block2404;
  uo2405->data[0] = (Object)closure2405;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2405 = addmethod2pos(block2404, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2405, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2405[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2405->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2405);
  meth_meth_collectionsPrelude__apply_40_1_41_2405->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2405->definitionLine = 1963;
// compiled block node returning block2404 (depth = 3)
  gc_frame_newslot(block2404);
// call case 5: prelude request
  params[0] = *var_elements;
  params[1] = block2404;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2422 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2403);
// compiled call node returning call2422 (depth = 2)
// Begin line 1230
  setline(1230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply_40_1_41_2434(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_block = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 1235
  setline(1235);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2435 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2436 = callmethodflags(self, "findPosition(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2435);
// compiled call node returning call2436 (depth = 5)
  *var_t = call2436;
  if (call2436 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1236
  setline(1236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  int op_slot_right_2438 = gc_frame_newslot(*var_x);
// starting to compile call node (depth = 6)
  int callframe2440 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2441 = gc_frame_new();
// call case 4: self request
  Object call2442 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2441);
// compiled member node returning call2442 (depth = 7)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call2443 = callmethodflags(call2442, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2440);
// compiled call node returning call2443 (depth = 6)
  int op_slot_left_2438 = gc_frame_newslot(call2443);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult2444 = callmethod(call2443, "==(1)", 1, partcv, params);
// compiled op node returning opresult2444 (depth = 5)
  Object if2437 = done;
  if (istrue(opresult2444)) {
// Begin line 1237
  setline(1237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2445 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  gc_frame_newslot(*var_removed);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2446 = gc_frame_new();
// call case 4: self request
  Object call2447 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2446);
// compiled member node returning call2447 (depth = 6)
  params[0] = *var_t;
  params[1] = *var_removed;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2448 = callmethodflags(call2447, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2445);
// compiled call node returning call2448 (depth = 5)
// Begin line 1238
  setline(1238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2449 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2451 = alloc_Float64(1);
// compiled num node returning num2451 (depth = 7)
  int op_slot_right_2450 = gc_frame_newslot(num2451);
// starting to compile member node (depth = 7)
  int callframe2453 = gc_frame_new();
// call case 4: self request
  Object call2454 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2453);
// compiled member node returning call2454 (depth = 7)
  int op_slot_left_2450 = gc_frame_newslot(call2454);
  params[0] = num2451;
  partcv[0] = 1;
  Object diff2455 = callmethod(call2454, "-(1)", 1, partcv, params);
// compiled op node returning diff2455 (depth = 6)
  gc_frame_newslot(diff2455);
// call case 4: self request
  params[0] = diff2455;
  partcv[0] = 1;
  Object call2456 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2449);
// compiled call node returning call2456 (depth = 5)
    gc_frame_newslot(call2456);
    if2437 = call2456;
  } else {
// Begin line 1240
  setline(1240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2457 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  gc_frame_newslot(*var_x);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block (depth = 6)
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2458 = callmethodflags(*var_block, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2457);
// compiled call node returning call2458 (depth = 5)
    gc_frame_newslot(call2458);
    if2437 = call2458;
  }
// compiled if node returning if2437 (depth = 4)
  gc_frame_end(frame);
  return if2437;
}
Object meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2423(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeAll(1)ifAbsent(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll(_)ifAbsent(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll(_)ifAbsent(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for removeAll(_)ifAbsent(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_elements = &(stackframe->slots[0]);
  *var_elements = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeAll(_)");
  Object *var_block = &(stackframe->slots[1]);
  *var_block = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifAbsent(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1233
  setline(1233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2424 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2426 = alloc_Float64(1);
// compiled num node returning num2426 (depth = 4)
  int op_slot_right_2425 = gc_frame_newslot(num2426);
// starting to compile member node (depth = 4)
  int callframe2428 = gc_frame_new();
// call case 4: self request
  Object call2429 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2428);
// compiled member node returning call2429 (depth = 4)
  int op_slot_left_2425 = gc_frame_newslot(call2429);
  params[0] = num2426;
  partcv[0] = 1;
  Object sum2430 = callmethod(call2429, "+(1)", 1, partcv, params);
// compiled op node returning sum2430 (depth = 3)
  gc_frame_newslot(sum2430);
// call case 4: self request
  params[0] = sum2430;
  partcv[0] = 1;
  Object call2431 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2424);
// compiled call node returning call2431 (depth = 2)
// Begin line 1234
  setline(1234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2432 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elements (depth = 3)
  gc_frame_newslot(*var_elements);
// starting to compile block node (depth = 3)
  Object block2433 = alloc_Block(NULL, NULL, "collectionsPrelude", 1234);
  gc_frame_newslot(block2433);
// method "_apply(_)"
  block_savedest(block2433);
  Object closure2434 = createclosure(3, "_apply(1)");
  setclosureframe(closure2434, stackframe);
  addtoclosure(closure2434, var_removed);
  addtoclosure(closure2434, var_block);
  addtoclosure(closure2434, selfslot);
  struct UserObject *uo2434 = (struct UserObject*)block2433;
  uo2434->data[0] = (Object)closure2434;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2434 = addmethod2pos(block2433, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2434, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2434[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2434->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2434);
  meth_meth_collectionsPrelude__apply_40_1_41_2434->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2434->definitionLine = 1963;
// compiled block node returning block2433 (depth = 3)
  gc_frame_newslot(block2433);
// call case 5: prelude request
  params[0] = *var_elements;
  params[1] = block2433;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2460 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2432);
// compiled call node returning call2460 (depth = 2)
// Begin line 1243
  setline(1243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2461(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "remove(1)ifAbsent(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove(_)ifAbsent(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove(_)ifAbsent(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for remove(_)ifAbsent(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part remove(_)");
  Object *var_block = &(stackframe->slots[1]);
  *var_block = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifAbsent(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "t");
// Begin line 1247
  setline(1247);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2462 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elt (depth = 4)
  gc_frame_newslot(*var_elt);
// call case 4: self request
  params[0] = *var_elt;
  partcv[0] = 1;
  Object call2463 = callmethodflags(self, "findPosition(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2462);
// compiled call node returning call2463 (depth = 3)
  *var_t = call2463;
  if (call2463 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1248
  setline(1248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elt (depth = 4)
  int op_slot_right_2465 = gc_frame_newslot(*var_elt);
// starting to compile call node (depth = 4)
  int callframe2467 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_t (depth = 5)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2468 = gc_frame_new();
// call case 4: self request
  Object call2469 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2468);
// compiled member node returning call2469 (depth = 5)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call2470 = callmethodflags(call2469, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2467);
// compiled call node returning call2470 (depth = 4)
  int op_slot_left_2465 = gc_frame_newslot(call2470);
  params[0] = *var_elt;
  partcv[0] = 1;
  Object opresult2471 = callmethod(call2470, "==(1)", 1, partcv, params);
// compiled op node returning opresult2471 (depth = 3)
  Object if2464 = done;
  if (istrue(opresult2471)) {
// Begin line 1249
  setline(1249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2472 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_removed (depth = 4)
  gc_frame_newslot(*var_removed);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2473 = gc_frame_new();
// call case 4: self request
  Object call2474 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2473);
// compiled member node returning call2474 (depth = 4)
  params[0] = *var_t;
  params[1] = *var_removed;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2475 = callmethodflags(call2474, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2472);
// compiled call node returning call2475 (depth = 3)
// Begin line 1250
  setline(1250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2476 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2478 = alloc_Float64(1);
// compiled num node returning num2478 (depth = 5)
  int op_slot_right_2477 = gc_frame_newslot(num2478);
// starting to compile member node (depth = 5)
  int callframe2480 = gc_frame_new();
// call case 4: self request
  Object call2481 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2480);
// compiled member node returning call2481 (depth = 5)
  int op_slot_left_2477 = gc_frame_newslot(call2481);
  params[0] = num2478;
  partcv[0] = 1;
  Object sum2482 = callmethod(call2481, "+(1)", 1, partcv, params);
// compiled op node returning sum2482 (depth = 4)
  gc_frame_newslot(sum2482);
// call case 4: self request
  params[0] = sum2482;
  partcv[0] = 1;
  Object call2483 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2476);
// compiled call node returning call2483 (depth = 3)
// Begin line 1251
  setline(1251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2484 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2486 = alloc_Float64(1);
// compiled num node returning num2486 (depth = 5)
  int op_slot_right_2485 = gc_frame_newslot(num2486);
// starting to compile member node (depth = 5)
  int callframe2488 = gc_frame_new();
// call case 4: self request
  Object call2489 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2488);
// compiled member node returning call2489 (depth = 5)
  int op_slot_left_2485 = gc_frame_newslot(call2489);
  params[0] = num2486;
  partcv[0] = 1;
  Object diff2490 = callmethod(call2489, "-(1)", 1, partcv, params);
// compiled op node returning diff2490 (depth = 4)
  gc_frame_newslot(diff2490);
// call case 4: self request
  params[0] = diff2490;
  partcv[0] = 1;
  Object call2491 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2484);
// compiled call node returning call2491 (depth = 3)
    gc_frame_newslot(call2491);
    if2464 = call2491;
  } else {
// Begin line 1253
  setline(1253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe2492 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_block (depth = 4)
  Object call2493 = callmethodflags(*var_block, "apply", 0, partcv, params, 0);
  gc_frame_end(callframe2492);
// compiled member node returning call2493 (depth = 3)
    gc_frame_newslot(call2493);
    if2464 = call2493;
  }
// compiled if node returning if2464 (depth = 2)
// Begin line 1255
  setline(1255);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply2497(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_elt = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1260
  setline(1260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2498 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2500 == NULL) {
    strlit2500 = alloc_String("");
    gc_root(strlit2500);
  }
// compiled string node returning strlit2500 (depth = 6)
  int op_slot_right_2499 = gc_frame_newslot(strlit2500);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_elt (depth = 7)
  int op_slot_right_2502 = gc_frame_newslot(*var_elt);
// starting to compile string node (depth = 7)
  if (strlit2504 == NULL) {
    strlit2504 = alloc_String("set does not contain ");
    gc_root(strlit2504);
  }
// compiled string node returning strlit2504 (depth = 7)
  int op_slot_left_2502 = gc_frame_newslot(strlit2504);
  params[0] = *var_elt;
  partcv[0] = 1;
  Object opresult2505 = callmethod(strlit2504, "++(1)", 1, partcv, params);
// compiled op node returning opresult2505 (depth = 6)
  int op_slot_left_2499 = gc_frame_newslot(opresult2505);
  params[0] = strlit2500;
  partcv[0] = 1;
  Object opresult2506 = callmethod(opresult2505, "++(1)", 1, partcv, params);
// compiled op node returning opresult2506 (depth = 5)
  gc_frame_newslot(opresult2506);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_NoSuchObject (depth = 5)
  params[0] = opresult2506;
  partcv[0] = 1;
  Object call2507 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2498);
// compiled call node returning call2507 (depth = 4)
  gc_frame_end(frame);
  return call2507;
}
Object meth_collectionsPrelude_remove_40_1_41_2494(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "remove(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove(_)");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for remove(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part remove(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1259
  setline(1259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2495 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elt (depth = 3)
  gc_frame_newslot(*var_elt);
// starting to compile block node (depth = 3)
  Object block2496 = alloc_Block(NULL, NULL, "collectionsPrelude", 1259);
  gc_frame_newslot(block2496);
// method "_apply"
  block_savedest(block2496);
  Object closure2497 = createclosure(3, "_apply");
  setclosureframe(closure2497, stackframe);
  addtoclosure(closure2497, var_elt);
  addtoclosure(closure2497, var_NoSuchObject);
  addtoclosure(closure2497, selfslot);
  struct UserObject *uo2497 = (struct UserObject*)block2496;
  uo2497->data[0] = (Object)closure2497;
  Method *meth_meth_collectionsPrelude__apply2497 = addmethod2pos(block2496, "_apply", &meth_collectionsPrelude__apply2497, 0);
  int argcv_meth_collectionsPrelude__apply2497[] = {0};
  meth_meth_collectionsPrelude__apply2497->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2497);
  meth_meth_collectionsPrelude__apply2497->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2497->definitionLine = 1963;
// compiled block node returning block2496 (depth = 3)
  gc_frame_newslot(block2496);
// call case 4: self request
  params[0] = *var_elt;
  params[1] = block2496;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2509 = callmethodflags(self, "remove(1)ifAbsent(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2495);
// compiled call node returning call2509 (depth = 2)
// Begin line 1262
  setline(1262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_contains_40_1_41_2510(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part contains(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 1266
  setline(1266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2511 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2512 = callmethodflags(self, "findPosition(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2511);
// compiled call node returning call2512 (depth = 3)
  *var_t = call2512;
  if (call2512 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1267
  setline(1267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  int op_slot_right_2514 = gc_frame_newslot(*var_x);
// starting to compile call node (depth = 4)
  int callframe2516 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_t (depth = 5)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2517 = gc_frame_new();
// call case 4: self request
  Object call2518 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2517);
// compiled member node returning call2518 (depth = 5)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call2519 = callmethodflags(call2518, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2516);
// compiled call node returning call2519 (depth = 4)
  int op_slot_left_2514 = gc_frame_newslot(call2519);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult2520 = callmethod(call2519, "==(1)", 1, partcv, params);
// compiled op node returning opresult2520 (depth = 3)
  Object if2513 = done;
  if (istrue(opresult2520)) {
// Begin line 1268
  setline(1268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool2521 = alloc_Boolean(1);
// compiled identifier node returning bool2521 (depth = 4)
  return bool2521;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if2513 = undefined;
  } else {
  }
// compiled if node returning if2513 (depth = 2)
// Begin line 1270
  setline(1270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool2522 = alloc_Boolean(0);
// compiled identifier node returning bool2522 (depth = 3)
  return bool2522;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply_40_1_41_2526(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_booleanBlock = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1274
  setline(1274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2528 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_booleanBlock (depth = 6)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call2529 = callmethodflags(*var_booleanBlock, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2528);
// compiled call node returning call2529 (depth = 5)
  Object if2527 = done;
  if (istrue(call2529)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool2530 = alloc_Boolean(1);
// compiled identifier node returning bool2530 (depth = 6)
  block_return(realself, bool2530);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if2527 = undefined;
  } else {
  }
// compiled if node returning if2527 (depth = 4)
  gc_frame_end(frame);
  return if2527;
}
Object meth_collectionsPrelude_includes_40_1_41_2523(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "includes(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method includes(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for includes(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_booleanBlock = &(stackframe->slots[0]);
  *var_booleanBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part includes(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1273
  setline(1273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2524 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2525 = alloc_Block(NULL, NULL, "collectionsPrelude", 1273);
  gc_frame_newslot(block2525);
// method "_apply(_)"
  block_savedest(block2525);
  Object closure2526 = createclosure(2, "_apply(1)");
  setclosureframe(closure2526, stackframe);
  addtoclosure(closure2526, var_booleanBlock);
  addtoclosure(closure2526, selfslot);
  struct UserObject *uo2526 = (struct UserObject*)block2525;
  uo2526->data[0] = (Object)closure2526;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2526 = addmethod2pos(block2525, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2526, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2526[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2526->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2526);
  meth_meth_collectionsPrelude__apply_40_1_41_2526->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2526->definitionLine = 1963;
// compiled block node returning block2525 (depth = 3)
  gc_frame_newslot(block2525);
// call case 4: self request
  params[0] = block2525;
  partcv[0] = 1;
  Object call2532 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2524);
// compiled call node returning call2532 (depth = 2)
// Begin line 1276
  setline(1276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool2533 = alloc_Boolean(0);
// compiled identifier node returning bool2533 (depth = 3)
  return bool2533;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply_40_1_41_2537(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_booleanBlock = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1280
  setline(1280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2539 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_booleanBlock (depth = 6)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call2540 = callmethodflags(*var_booleanBlock, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2539);
// compiled call node returning call2540 (depth = 5)
  Object if2538 = done;
  if (istrue(call2540)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  block_return(realself, *var_each);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if2538 = undefined;
  } else {
  }
// compiled if node returning if2538 (depth = 4)
  gc_frame_end(frame);
  return if2538;
}
Object meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2534(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "find(1)ifNone(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method find(_)ifNone(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method find(_)ifNone(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for find(_)ifNone(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_booleanBlock = &(stackframe->slots[0]);
  *var_booleanBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part find(_)");
  Object *var_notFoundBlock = &(stackframe->slots[1]);
  *var_notFoundBlock = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifNone(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1279
  setline(1279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2535 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2536 = alloc_Block(NULL, NULL, "collectionsPrelude", 1279);
  gc_frame_newslot(block2536);
// method "_apply(_)"
  block_savedest(block2536);
  Object closure2537 = createclosure(2, "_apply(1)");
  setclosureframe(closure2537, stackframe);
  addtoclosure(closure2537, var_booleanBlock);
  addtoclosure(closure2537, selfslot);
  struct UserObject *uo2537 = (struct UserObject*)block2536;
  uo2537->data[0] = (Object)closure2537;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2537 = addmethod2pos(block2536, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2537, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2537[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2537->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2537);
  meth_meth_collectionsPrelude__apply_40_1_41_2537->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2537->definitionLine = 1963;
// compiled block node returning block2536 (depth = 3)
  gc_frame_newslot(block2536);
// call case 4: self request
  params[0] = block2536;
  partcv[0] = 1;
  Object call2542 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2535);
// compiled call node returning call2542 (depth = 2)
// Begin line 1282
  setline(1282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2543 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_notFoundBlock (depth = 4)
  Object call2544 = callmethodflags(*var_notFoundBlock, "apply", 0, partcv, params, 0);
  gc_frame_end(callframe2543);
// compiled member node returning call2544 (depth = 3)
  return call2544;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply2558(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_t = getfromclosure(closure, 0);
  Object *var_candidate = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 1291
  setline(1291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2559 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2560 = gc_frame_new();
// call case 4: self request
  Object call2561 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2560);
// compiled member node returning call2561 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call2562 = callmethodflags(call2561, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2559);
// compiled call node returning call2562 (depth = 5)
  *var_candidate = call2562;
  if (call2562 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1292
  setline(1292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_candidate (depth = 5)
  int op_slot_right_2564 = gc_frame_newslot(*var_candidate);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  int op_slot_left_2564 = gc_frame_newslot(*var_unused);
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object opresult2566 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2566 (depth = 4)
  gc_frame_end(frame);
  return opresult2566;
}
Object meth_collectionsPrelude__apply2569(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_x = getfromclosure(closure, 0);
  Object *var_candidate = getfromclosure(closure, 1);
  Object *var_t = getfromclosure(closure, 2);
  Object *var_jump = getfromclosure(closure, 3);
  Object *var_s = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1294
  setline(1294);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  int op_slot_right_2571 = gc_frame_newslot(*var_x);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  int op_slot_left_2571 = gc_frame_newslot(*var_candidate);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult2573 = callmethod(*var_candidate, "==(1)", 1, partcv, params);
// compiled op node returning opresult2573 (depth = 5)
  Object if2570 = done;
  if (istrue(opresult2573)) {
// Begin line 1295
  setline(1295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  block_return(realself, *var_t);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if2570 = undefined;
  } else {
  }
// compiled if node returning if2570 (depth = 4)
// Begin line 1297
  setline(1297);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2576 = alloc_Float64(0);
// compiled num node returning num2576 (depth = 6)
  int op_slot_right_2575 = gc_frame_newslot(num2576);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_jump (depth = 6)
  int op_slot_left_2575 = gc_frame_newslot(*var_jump);
  params[0] = num2576;
  partcv[0] = 1;
  Object opresult2578 = callmethod(*var_jump, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2578 (depth = 5)
  Object if2574 = done;
  if (istrue(opresult2578)) {
// Begin line 1298
  setline(1298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_2579 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2582 = alloc_Float64(1);
// compiled num node returning num2582 (depth = 8)
  int op_slot_right_2581 = gc_frame_newslot(num2582);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2585 = alloc_Float64(3);
// compiled num node returning num2585 (depth = 9)
  int op_slot_right_2584 = gc_frame_newslot(num2585);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  int op_slot_left_2584 = gc_frame_newslot(*var_t);
  params[0] = num2585;
  partcv[0] = 1;
  Object prod2587 = callmethod(*var_t, "*(1)", 1, partcv, params);
// compiled op node returning prod2587 (depth = 8)
  int op_slot_left_2581 = gc_frame_newslot(prod2587);
  params[0] = num2582;
  partcv[0] = 1;
  Object sum2588 = callmethod(prod2587, "+(1)", 1, partcv, params);
// compiled op node returning sum2588 (depth = 7)
  int op_slot_left_2579 = gc_frame_newslot(sum2588);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2589 = callmethod(sum2588, "%(1)", 1, partcv, params);
// compiled op node returning modulus2589 (depth = 6)
  *var_t = modulus2589;
  if (modulus2589 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1299
  setline(1299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2592 = alloc_Float64(1);
// compiled num node returning num2592 (depth = 7)
  int op_slot_right_2591 = gc_frame_newslot(num2592);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_jump (depth = 7)
  int op_slot_left_2591 = gc_frame_newslot(*var_jump);
  params[0] = num2592;
  partcv[0] = 1;
  Object diff2594 = callmethod(*var_jump, "-(1)", 1, partcv, params);
// compiled op node returning diff2594 (depth = 6)
  *var_jump = diff2594;
  if (diff2594 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2574 = done;
  } else {
// Begin line 1301
  setline(1301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_2596 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2599 = alloc_Float64(1);
// compiled num node returning num2599 (depth = 8)
  int op_slot_right_2598 = gc_frame_newslot(num2599);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  int op_slot_left_2598 = gc_frame_newslot(*var_t);
  params[0] = num2599;
  partcv[0] = 1;
  Object sum2601 = callmethod(*var_t, "+(1)", 1, partcv, params);
// compiled op node returning sum2601 (depth = 7)
  int op_slot_left_2596 = gc_frame_newslot(sum2601);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2602 = callmethod(sum2601, "%(1)", 1, partcv, params);
// compiled op node returning modulus2602 (depth = 6)
  *var_t = modulus2602;
  if (modulus2602 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2574 = done;
  }
// compiled if node returning if2574 (depth = 4)
  gc_frame_end(frame);
  return if2574;
}
Object meth_collectionsPrelude_findPosition_40_1_41_2545(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findPosition(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findPosition(_)");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findPosition(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part findPosition(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_h = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "h");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_t = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "t");
  Object *var_jump = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "jump");
  Object *var_candidate = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "candidate");
// Begin line 1285
  setline(1285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2546 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  Object call2547 = callmethodflags(*var_x, "hash", 0, partcv, params, 0);
  gc_frame_end(callframe2546);
// compiled member node returning call2547 (depth = 3)
  *var_h = call2547;
  if (call2547 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1286
  setline(1286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2548 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2549 = gc_frame_new();
// call case 4: self request
  Object call2550 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2549);
// compiled member node returning call2550 (depth = 4)
  Object call2551 = callmethodflags(call2550, "size", 0, partcv, params, 0);
  gc_frame_end(callframe2548);
// compiled member node returning call2551 (depth = 3)
  *var_s = call2551;
  if (call2551 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1287
  setline(1287);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_right_2552 = gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_h (depth = 4)
  int op_slot_left_2552 = gc_frame_newslot(*var_h);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2554 = callmethod(*var_h, "%(1)", 1, partcv, params);
// compiled op node returning modulus2554 (depth = 3)
  *var_t = modulus2554;
  if (modulus2554 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1288
  setline(1288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2555 = alloc_Float64(5);
// compiled num node returning num2555 (depth = 3)
  *var_jump = num2555;
  if (num2555 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1289
  setline(1289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_candidate = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1290
  setline(1290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2556 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2557 = alloc_Block(NULL, NULL, "collectionsPrelude", 1290);
  gc_frame_newslot(block2557);
// method "_apply"
  block_savedest(block2557);
  Object closure2558 = createclosure(4, "_apply");
  setclosureframe(closure2558, stackframe);
  addtoclosure(closure2558, var_t);
  addtoclosure(closure2558, var_candidate);
  addtoclosure(closure2558, var_unused);
  addtoclosure(closure2558, selfslot);
  struct UserObject *uo2558 = (struct UserObject*)block2557;
  uo2558->data[0] = (Object)closure2558;
  Method *meth_meth_collectionsPrelude__apply2558 = addmethod2pos(block2557, "_apply", &meth_collectionsPrelude__apply2558, 0);
  int argcv_meth_collectionsPrelude__apply2558[] = {0};
  meth_meth_collectionsPrelude__apply2558->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2558);
  meth_meth_collectionsPrelude__apply2558->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2558->definitionLine = 1963;
// compiled block node returning block2557 (depth = 3)
  gc_frame_newslot(block2557);
// Begin line 1293
  setline(1293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2568 = alloc_Block(NULL, NULL, "collectionsPrelude", 1293);
  gc_frame_newslot(block2568);
// method "_apply"
  block_savedest(block2568);
  Object closure2569 = createclosure(6, "_apply");
  setclosureframe(closure2569, stackframe);
  addtoclosure(closure2569, var_x);
  addtoclosure(closure2569, var_candidate);
  addtoclosure(closure2569, var_t);
  addtoclosure(closure2569, var_jump);
  addtoclosure(closure2569, var_s);
  addtoclosure(closure2569, selfslot);
  struct UserObject *uo2569 = (struct UserObject*)block2568;
  uo2569->data[0] = (Object)closure2569;
  Method *meth_meth_collectionsPrelude__apply2569 = addmethod2pos(block2568, "_apply", &meth_collectionsPrelude__apply2569, 0);
  int argcv_meth_collectionsPrelude__apply2569[] = {0};
  meth_meth_collectionsPrelude__apply2569->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2569);
  meth_meth_collectionsPrelude__apply2569->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2569->definitionLine = 1963;
// compiled block node returning block2568 (depth = 3)
  gc_frame_newslot(block2568);
// call case 5: prelude request
  params[0] = block2557;
  params[1] = block2568;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2605 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2556);
// compiled call node returning call2605 (depth = 2)
// Begin line 1304
  setline(1304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  return *var_t;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply2619(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_t = getfromclosure(closure, 0);
  Object *var_candidate = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 1313
  setline(1313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2620 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2621 = gc_frame_new();
// call case 4: self request
  Object call2622 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2621);
// compiled member node returning call2622 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call2623 = callmethodflags(call2622, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2620);
// compiled call node returning call2623 (depth = 5)
  *var_candidate = call2623;
  if (call2623 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1314
  setline(1314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  int op_slot_right_2626 = gc_frame_newslot(*var_candidate);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  int op_slot_left_2626 = gc_frame_newslot(*var_removed);
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object opresult2628 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2628 (depth = 5)
  int op_slot_right_2625 = gc_frame_newslot(opresult2628);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  int op_slot_right_2630 = gc_frame_newslot(*var_candidate);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_unused (depth = 6)
  int op_slot_left_2630 = gc_frame_newslot(*var_unused);
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object opresult2632 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2632 (depth = 5)
  int op_slot_left_2625 = gc_frame_newslot(opresult2632);
  params[0] = opresult2628;
  partcv[0] = 1;
  Object opresult2633 = callmethod(opresult2632, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2633 (depth = 4)
  gc_frame_end(frame);
  return opresult2633;
}
Object meth_collectionsPrelude__apply2636(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_x = getfromclosure(closure, 0);
  Object *var_candidate = getfromclosure(closure, 1);
  Object *var_t = getfromclosure(closure, 2);
  Object *var_jump = getfromclosure(closure, 3);
  Object *var_s = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1316
  setline(1316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  int op_slot_right_2638 = gc_frame_newslot(*var_x);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  int op_slot_left_2638 = gc_frame_newslot(*var_candidate);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult2640 = callmethod(*var_candidate, "==(1)", 1, partcv, params);
// compiled op node returning opresult2640 (depth = 5)
  Object if2637 = done;
  if (istrue(opresult2640)) {
// Begin line 1317
  setline(1317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  block_return(realself, *var_t);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if2637 = undefined;
  } else {
  }
// compiled if node returning if2637 (depth = 4)
// Begin line 1319
  setline(1319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2643 = alloc_Float64(0);
// compiled num node returning num2643 (depth = 6)
  int op_slot_right_2642 = gc_frame_newslot(num2643);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_jump (depth = 6)
  int op_slot_left_2642 = gc_frame_newslot(*var_jump);
  params[0] = num2643;
  partcv[0] = 1;
  Object opresult2645 = callmethod(*var_jump, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2645 (depth = 5)
  Object if2641 = done;
  if (istrue(opresult2645)) {
// Begin line 1320
  setline(1320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_2646 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2649 = alloc_Float64(1);
// compiled num node returning num2649 (depth = 8)
  int op_slot_right_2648 = gc_frame_newslot(num2649);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2652 = alloc_Float64(3);
// compiled num node returning num2652 (depth = 9)
  int op_slot_right_2651 = gc_frame_newslot(num2652);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  int op_slot_left_2651 = gc_frame_newslot(*var_t);
  params[0] = num2652;
  partcv[0] = 1;
  Object prod2654 = callmethod(*var_t, "*(1)", 1, partcv, params);
// compiled op node returning prod2654 (depth = 8)
  int op_slot_left_2648 = gc_frame_newslot(prod2654);
  params[0] = num2649;
  partcv[0] = 1;
  Object sum2655 = callmethod(prod2654, "+(1)", 1, partcv, params);
// compiled op node returning sum2655 (depth = 7)
  int op_slot_left_2646 = gc_frame_newslot(sum2655);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2656 = callmethod(sum2655, "%(1)", 1, partcv, params);
// compiled op node returning modulus2656 (depth = 6)
  *var_t = modulus2656;
  if (modulus2656 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1321
  setline(1321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2659 = alloc_Float64(1);
// compiled num node returning num2659 (depth = 7)
  int op_slot_right_2658 = gc_frame_newslot(num2659);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_jump (depth = 7)
  int op_slot_left_2658 = gc_frame_newslot(*var_jump);
  params[0] = num2659;
  partcv[0] = 1;
  Object diff2661 = callmethod(*var_jump, "-(1)", 1, partcv, params);
// compiled op node returning diff2661 (depth = 6)
  *var_jump = diff2661;
  if (diff2661 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2641 = done;
  } else {
// Begin line 1323
  setline(1323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_2663 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2666 = alloc_Float64(1);
// compiled num node returning num2666 (depth = 8)
  int op_slot_right_2665 = gc_frame_newslot(num2666);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  int op_slot_left_2665 = gc_frame_newslot(*var_t);
  params[0] = num2666;
  partcv[0] = 1;
  Object sum2668 = callmethod(*var_t, "+(1)", 1, partcv, params);
// compiled op node returning sum2668 (depth = 7)
  int op_slot_left_2663 = gc_frame_newslot(sum2668);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2669 = callmethod(sum2668, "%(1)", 1, partcv, params);
// compiled op node returning modulus2669 (depth = 6)
  *var_t = modulus2669;
  if (modulus2669 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2641 = done;
  }
// compiled if node returning if2641 (depth = 4)
  gc_frame_end(frame);
  return if2641;
}
Object meth_collectionsPrelude_findPositionForAdd_40_1_41_2606(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findPositionForAdd(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findPositionForAdd(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findPositionForAdd(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part findPositionForAdd(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_h = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "h");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_t = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "t");
  Object *var_jump = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "jump");
  Object *var_candidate = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "candidate");
// Begin line 1307
  setline(1307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2607 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  Object call2608 = callmethodflags(*var_x, "hash", 0, partcv, params, 0);
  gc_frame_end(callframe2607);
// compiled member node returning call2608 (depth = 3)
  *var_h = call2608;
  if (call2608 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1308
  setline(1308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2609 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2610 = gc_frame_new();
// call case 4: self request
  Object call2611 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2610);
// compiled member node returning call2611 (depth = 4)
  Object call2612 = callmethodflags(call2611, "size", 0, partcv, params, 0);
  gc_frame_end(callframe2609);
// compiled member node returning call2612 (depth = 3)
  *var_s = call2612;
  if (call2612 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1309
  setline(1309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_right_2613 = gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_h (depth = 4)
  int op_slot_left_2613 = gc_frame_newslot(*var_h);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2615 = callmethod(*var_h, "%(1)", 1, partcv, params);
// compiled op node returning modulus2615 (depth = 3)
  *var_t = modulus2615;
  if (modulus2615 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1310
  setline(1310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2616 = alloc_Float64(5);
// compiled num node returning num2616 (depth = 3)
  *var_jump = num2616;
  if (num2616 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1311
  setline(1311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_candidate = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1312
  setline(1312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2617 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2618 = alloc_Block(NULL, NULL, "collectionsPrelude", 1312);
  gc_frame_newslot(block2618);
// method "_apply"
  block_savedest(block2618);
  Object closure2619 = createclosure(5, "_apply");
  setclosureframe(closure2619, stackframe);
  addtoclosure(closure2619, var_t);
  addtoclosure(closure2619, var_candidate);
  addtoclosure(closure2619, var_removed);
  addtoclosure(closure2619, var_unused);
  addtoclosure(closure2619, selfslot);
  struct UserObject *uo2619 = (struct UserObject*)block2618;
  uo2619->data[0] = (Object)closure2619;
  Method *meth_meth_collectionsPrelude__apply2619 = addmethod2pos(block2618, "_apply", &meth_collectionsPrelude__apply2619, 0);
  int argcv_meth_collectionsPrelude__apply2619[] = {0};
  meth_meth_collectionsPrelude__apply2619->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2619);
  meth_meth_collectionsPrelude__apply2619->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2619->definitionLine = 1963;
// compiled block node returning block2618 (depth = 3)
  gc_frame_newslot(block2618);
// Begin line 1315
  setline(1315);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2635 = alloc_Block(NULL, NULL, "collectionsPrelude", 1315);
  gc_frame_newslot(block2635);
// method "_apply"
  block_savedest(block2635);
  Object closure2636 = createclosure(6, "_apply");
  setclosureframe(closure2636, stackframe);
  addtoclosure(closure2636, var_x);
  addtoclosure(closure2636, var_candidate);
  addtoclosure(closure2636, var_t);
  addtoclosure(closure2636, var_jump);
  addtoclosure(closure2636, var_s);
  addtoclosure(closure2636, selfslot);
  struct UserObject *uo2636 = (struct UserObject*)block2635;
  uo2636->data[0] = (Object)closure2636;
  Method *meth_meth_collectionsPrelude__apply2636 = addmethod2pos(block2635, "_apply", &meth_collectionsPrelude__apply2636, 0);
  int argcv_meth_collectionsPrelude__apply2636[] = {0};
  meth_meth_collectionsPrelude__apply2636->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2636);
  meth_meth_collectionsPrelude__apply2636->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2636->definitionLine = 1963;
// compiled block node returning block2635 (depth = 3)
  gc_frame_newslot(block2635);
// call case 5: prelude request
  params[0] = block2618;
  params[1] = block2635;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2672 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2617);
// compiled call node returning call2672 (depth = 2)
// Begin line 1326
  setline(1326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  return *var_t;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply_40_1_41_2677(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2679 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  Object call2680 = callmethodflags(*var_each, "asString", 0, partcv, params, 0);
  gc_frame_end(callframe2679);
// compiled member node returning call2680 (depth = 6)
  int op_slot_right_2678 = gc_frame_newslot(call2680);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2678 = gc_frame_newslot(*var_s);
  params[0] = call2680;
  partcv[0] = 1;
  Object opresult2682 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2682 (depth = 5)
  *var_s = opresult2682;
  if (opresult2682 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply2686(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2688 == NULL) {
    strlit2688 = alloc_String(", ");
    gc_root(strlit2688);
  }
// compiled string node returning strlit2688 (depth = 6)
  int op_slot_right_2687 = gc_frame_newslot(strlit2688);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2687 = gc_frame_newslot(*var_s);
  params[0] = strlit2688;
  partcv[0] = 1;
  Object opresult2690 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2690 (depth = 5)
  *var_s = opresult2690;
  if (opresult2690 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_asString2673(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 1330
  setline(1330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit2674 == NULL) {
    strlit2674 = alloc_String("set{");
    gc_root(strlit2674);
  }
// compiled string node returning strlit2674 (depth = 3)
  *var_s = strlit2674;
  if (strlit2674 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1331
  setline(1331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2675 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2676 = alloc_Block(NULL, NULL, "collectionsPrelude", 1331);
  gc_frame_newslot(block2676);
// method "_apply(_)"
  block_savedest(block2676);
  Object closure2677 = createclosure(2, "_apply(1)");
  setclosureframe(closure2677, stackframe);
  addtoclosure(closure2677, var_s);
  addtoclosure(closure2677, selfslot);
  struct UserObject *uo2677 = (struct UserObject*)block2676;
  uo2677->data[0] = (Object)closure2677;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2677 = addmethod2pos(block2676, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2677, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2677[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2677->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2677);
  meth_meth_collectionsPrelude__apply_40_1_41_2677->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2677->definitionLine = 1963;
// compiled block node returning block2676 (depth = 3)
  gc_frame_newslot(block2676);
// Begin line 1332
  setline(1332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2685 = alloc_Block(NULL, NULL, "collectionsPrelude", 1332);
  gc_frame_newslot(block2685);
// method "_apply"
  block_savedest(block2685);
  Object closure2686 = createclosure(2, "_apply");
  setclosureframe(closure2686, stackframe);
  addtoclosure(closure2686, var_s);
  addtoclosure(closure2686, selfslot);
  struct UserObject *uo2686 = (struct UserObject*)block2685;
  uo2686->data[0] = (Object)closure2686;
  Method *meth_meth_collectionsPrelude__apply2686 = addmethod2pos(block2685, "_apply", &meth_collectionsPrelude__apply2686, 0);
  int argcv_meth_collectionsPrelude__apply2686[] = {0};
  meth_meth_collectionsPrelude__apply2686->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2686);
  meth_meth_collectionsPrelude__apply2686->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2686->definitionLine = 1963;
// compiled block node returning block2685 (depth = 3)
  gc_frame_newslot(block2685);
// call case 4: self request
  params[0] = block2676;
  params[1] = block2685;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2693 = callmethodflags(self, "do(1)separatedBy(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2675);
// compiled call node returning call2693 (depth = 2)
// Begin line 1333
  setline(1333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit2695 == NULL) {
    strlit2695 = alloc_String("}");
    gc_root(strlit2695);
  }
// compiled string node returning strlit2695 (depth = 3)
  int op_slot_right_2694 = gc_frame_newslot(strlit2695);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_2694 = gc_frame_newslot(*var_s);
  params[0] = strlit2695;
  partcv[0] = 1;
  Object opresult2697 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2697 (depth = 2)
  gc_frame_end(frame);
  return opresult2697;
}
Object meth_collectionsPrelude__apply_40_1_41_2702(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2704 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  Object call2705 = callmethodflags(*var_each, "asDebugString", 0, partcv, params, 0);
  gc_frame_end(callframe2704);
// compiled member node returning call2705 (depth = 6)
  int op_slot_right_2703 = gc_frame_newslot(call2705);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2703 = gc_frame_newslot(*var_s);
  params[0] = call2705;
  partcv[0] = 1;
  Object opresult2707 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2707 (depth = 5)
  *var_s = opresult2707;
  if (opresult2707 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply2711(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2713 == NULL) {
    strlit2713 = alloc_String(", ");
    gc_root(strlit2713);
  }
// compiled string node returning strlit2713 (depth = 6)
  int op_slot_right_2712 = gc_frame_newslot(strlit2713);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2712 = gc_frame_newslot(*var_s);
  params[0] = strlit2713;
  partcv[0] = 1;
  Object opresult2715 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2715 (depth = 5)
  *var_s = opresult2715;
  if (opresult2715 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_asDebugString2698(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 1336
  setline(1336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit2699 == NULL) {
    strlit2699 = alloc_String("set{");
    gc_root(strlit2699);
  }
// compiled string node returning strlit2699 (depth = 3)
  *var_s = strlit2699;
  if (strlit2699 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1337
  setline(1337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2700 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2701 = alloc_Block(NULL, NULL, "collectionsPrelude", 1337);
  gc_frame_newslot(block2701);
// method "_apply(_)"
  block_savedest(block2701);
  Object closure2702 = createclosure(2, "_apply(1)");
  setclosureframe(closure2702, stackframe);
  addtoclosure(closure2702, var_s);
  addtoclosure(closure2702, selfslot);
  struct UserObject *uo2702 = (struct UserObject*)block2701;
  uo2702->data[0] = (Object)closure2702;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2702 = addmethod2pos(block2701, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2702, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2702[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2702->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2702);
  meth_meth_collectionsPrelude__apply_40_1_41_2702->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2702->definitionLine = 1963;
// compiled block node returning block2701 (depth = 3)
  gc_frame_newslot(block2701);
// Begin line 1338
  setline(1338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2710 = alloc_Block(NULL, NULL, "collectionsPrelude", 1338);
  gc_frame_newslot(block2710);
// method "_apply"
  block_savedest(block2710);
  Object closure2711 = createclosure(2, "_apply");
  setclosureframe(closure2711, stackframe);
  addtoclosure(closure2711, var_s);
  addtoclosure(closure2711, selfslot);
  struct UserObject *uo2711 = (struct UserObject*)block2710;
  uo2711->data[0] = (Object)closure2711;
  Method *meth_meth_collectionsPrelude__apply2711 = addmethod2pos(block2710, "_apply", &meth_collectionsPrelude__apply2711, 0);
  int argcv_meth_collectionsPrelude__apply2711[] = {0};
  meth_meth_collectionsPrelude__apply2711->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2711);
  meth_meth_collectionsPrelude__apply2711->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2711->definitionLine = 1963;
// compiled block node returning block2710 (depth = 3)
  gc_frame_newslot(block2710);
// call case 4: self request
  params[0] = block2701;
  params[1] = block2710;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2718 = callmethodflags(self, "do(1)separatedBy(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2700);
// compiled call node returning call2718 (depth = 2)
// Begin line 1339
  setline(1339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit2720 == NULL) {
    strlit2720 = alloc_String("}");
    gc_root(strlit2720);
  }
// compiled string node returning strlit2720 (depth = 3)
  int op_slot_right_2719 = gc_frame_newslot(strlit2720);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_2719 = gc_frame_newslot(*var_s);
  params[0] = strlit2720;
  partcv[0] = 1;
  Object opresult2722 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult2722 (depth = 2)
  gc_frame_end(frame);
  return opresult2722;
}
Object meth_collectionsPrelude__apply_40_1_41_2726(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1343
  setline(1343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2727 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// call case 4: self request
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2728 = callmethodflags(self, "add(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2727);
// compiled call node returning call2728 (depth = 4)
  gc_frame_end(frame);
  return call2728;
}
Object meth_collectionsPrelude_extend_40_1_41_2723(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "extend(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method extend(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for extend(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part extend(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1342
  setline(1342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2724 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  gc_frame_newslot(*var_l);
// starting to compile block node (depth = 3)
  Object block2725 = alloc_Block(NULL, NULL, "collectionsPrelude", 1342);
  gc_frame_newslot(block2725);
// method "_apply(_)"
  block_savedest(block2725);
  Object closure2726 = createclosure(1, "_apply(1)");
  setclosureframe(closure2726, stackframe);
  addtoclosure(closure2726, selfslot);
  struct UserObject *uo2726 = (struct UserObject*)block2725;
  uo2726->data[0] = (Object)closure2726;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2726 = addmethod2pos(block2725, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2726, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2726[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2726->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2726);
  meth_meth_collectionsPrelude__apply_40_1_41_2726->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2726->definitionLine = 1963;
// compiled block node returning block2725 (depth = 3)
  gc_frame_newslot(block2725);
// call case 5: prelude request
  params[0] = *var_l;
  params[1] = block2725;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2730 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2724);
// compiled call node returning call2730 (depth = 2)
  gc_frame_end(frame);
  return call2730;
}
Object meth_collectionsPrelude__apply2736(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_found = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe2738 = gc_frame_new();
// call case 4: self request
  Object call2739 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2738);
// compiled member node returning call2739 (depth = 5)
  int op_slot_right_2737 = gc_frame_newslot(call2739);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_found (depth = 5)
  int op_slot_left_2737 = gc_frame_newslot(*var_found);
  params[0] = call2739;
  partcv[0] = 1;
  Object opresult2741 = callmethod(*var_found, "<(1)", 1, partcv, params);
// compiled op node returning opresult2741 (depth = 4)
  gc_frame_end(frame);
  return opresult2741;
}
Object meth_collectionsPrelude__apply2744(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_candidate = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  Object *var_found = getfromclosure(closure, 4);
  Object *var_block1 = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 1351
  setline(1351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2745 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2746 = gc_frame_new();
// call case 4: self request
  Object call2747 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2746);
// compiled member node returning call2747 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2748 = callmethodflags(call2747, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2745);
// compiled call node returning call2748 (depth = 5)
  *var_candidate = call2748;
  if (call2748 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1352
  setline(1352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_candidate (depth = 7)
  int op_slot_right_2752 = gc_frame_newslot(*var_candidate);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_2752 = gc_frame_newslot(*var_removed);
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object opresult2754 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2754 (depth = 6)
  int op_slot_right_2751 = gc_frame_newslot(opresult2754);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_candidate (depth = 7)
  int op_slot_right_2756 = gc_frame_newslot(*var_candidate);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_2756 = gc_frame_newslot(*var_unused);
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object opresult2758 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2758 (depth = 6)
  int op_slot_left_2751 = gc_frame_newslot(opresult2758);
  params[0] = opresult2754;
  partcv[0] = 1;
  Object opresult2759 = callmethod(opresult2758, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2759 (depth = 5)
  Object if2750 = done;
  if (istrue(opresult2759)) {
// Begin line 1353
  setline(1353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2761 = alloc_Float64(1);
// compiled num node returning num2761 (depth = 7)
  int op_slot_right_2760 = gc_frame_newslot(num2761);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_found (depth = 7)
  int op_slot_left_2760 = gc_frame_newslot(*var_found);
  params[0] = num2761;
  partcv[0] = 1;
  Object sum2763 = callmethod(*var_found, "+(1)", 1, partcv, params);
// compiled op node returning sum2763 (depth = 6)
  *var_found = sum2763;
  if (sum2763 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1354
  setline(1354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2765 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  gc_frame_newslot(*var_candidate);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block1 (depth = 6)
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object call2766 = callmethodflags(*var_block1, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2765);
// compiled call node returning call2766 (depth = 5)
    gc_frame_newslot(call2766);
    if2750 = call2766;
  } else {
  }
// compiled if node returning if2750 (depth = 4)
// Begin line 1356
  setline(1356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2768 = alloc_Float64(1);
// compiled num node returning num2768 (depth = 6)
  int op_slot_right_2767 = gc_frame_newslot(num2768);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_2767 = gc_frame_newslot(*var_i);
  params[0] = num2768;
  partcv[0] = 1;
  Object sum2770 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum2770 (depth = 5)
  *var_i = sum2770;
  if (sum2770 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_do_40_1_41_2731(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_i = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "i");
  Object *var_found = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "found");
  Object *var_candidate = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "candidate");
// Begin line 1347
  setline(1347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2732 = alloc_Float64(0);
// compiled num node returning num2732 (depth = 3)
  *var_i = num2732;
  if (num2732 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1348
  setline(1348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2733 = alloc_Float64(0);
// compiled num node returning num2733 (depth = 3)
  *var_found = num2733;
  if (num2733 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1349
  setline(1349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_candidate = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1350
  setline(1350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2734 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2735 = alloc_Block(NULL, NULL, "collectionsPrelude", 1350);
  gc_frame_newslot(block2735);
// method "_apply"
  block_savedest(block2735);
  Object closure2736 = createclosure(2, "_apply");
  setclosureframe(closure2736, stackframe);
  addtoclosure(closure2736, var_found);
  addtoclosure(closure2736, selfslot);
  struct UserObject *uo2736 = (struct UserObject*)block2735;
  uo2736->data[0] = (Object)closure2736;
  Method *meth_meth_collectionsPrelude__apply2736 = addmethod2pos(block2735, "_apply", &meth_collectionsPrelude__apply2736, 0);
  int argcv_meth_collectionsPrelude__apply2736[] = {0};
  meth_meth_collectionsPrelude__apply2736->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2736);
  meth_meth_collectionsPrelude__apply2736->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2736->definitionLine = 1963;
// compiled block node returning block2735 (depth = 3)
  gc_frame_newslot(block2735);
// starting to compile block node (depth = 3)
  Object block2743 = alloc_Block(NULL, NULL, "collectionsPrelude", 1350);
  gc_frame_newslot(block2743);
// method "_apply"
  block_savedest(block2743);
  Object closure2744 = createclosure(7, "_apply");
  setclosureframe(closure2744, stackframe);
  addtoclosure(closure2744, var_i);
  addtoclosure(closure2744, var_candidate);
  addtoclosure(closure2744, var_removed);
  addtoclosure(closure2744, var_unused);
  addtoclosure(closure2744, var_found);
  addtoclosure(closure2744, var_block1);
  addtoclosure(closure2744, selfslot);
  struct UserObject *uo2744 = (struct UserObject*)block2743;
  uo2744->data[0] = (Object)closure2744;
  Method *meth_meth_collectionsPrelude__apply2744 = addmethod2pos(block2743, "_apply", &meth_collectionsPrelude__apply2744, 0);
  int argcv_meth_collectionsPrelude__apply2744[] = {0};
  meth_meth_collectionsPrelude__apply2744->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2744);
  meth_meth_collectionsPrelude__apply2744->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2744->definitionLine = 1963;
// compiled block node returning block2743 (depth = 3)
  gc_frame_newslot(block2743);
// call case 5: prelude request
  params[0] = block2735;
  params[1] = block2743;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2773 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2734);
// compiled call node returning call2773 (depth = 2)
  gc_frame_end(frame);
  return call2773;
}
Object meth_collectionsPrelude_hasNext2780(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1364
  setline(1364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2782 = gc_frame_new();
// call case 4: self request
  Object call2783 = callmethodflags(self, "count", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2782);
// compiled member node returning call2783 (depth = 3)
  int op_slot_right_2781 = gc_frame_newslot(call2783);
// starting to compile member node (depth = 3)
  int callframe2785 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2786 = gc_frame_new();
// call case 3: self.outer request
  Object call2787 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2786);
// compiled member node returning call2787 (depth = 4)
  Object call2788 = callmethodflags(call2787, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2785);
// compiled member node returning call2788 (depth = 3)
  int op_slot_left_2781 = gc_frame_newslot(call2788);
  params[0] = call2783;
  partcv[0] = 1;
  Object opresult2789 = callmethod(call2788, "≥(1)", 1, partcv, params);
// compiled op node returning opresult2789 (depth = 2)
  gc_frame_end(frame);
  return opresult2789;
}
Object meth_collectionsPrelude__apply2799(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_innerSize = getfromclosure(closure, 1);
  Object *var_IteratorExhausted = getfromclosure(closure, 2);
  Object *var_candidate = getfromclosure(closure, 3);
  Object *var_removed = getfromclosure(closure, 4);
  Object *var_unused = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe2800 = gc_frame_new();
// Begin line 1369
  setline(1369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2802 = alloc_Float64(1);
// compiled num node returning num2802 (depth = 6)
  int op_slot_right_2801 = gc_frame_newslot(num2802);
// starting to compile member node (depth = 6)
  int callframe2804 = gc_frame_new();
// call case 4: self request
  Object call2805 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2804);
// compiled member node returning call2805 (depth = 6)
  int op_slot_left_2801 = gc_frame_newslot(call2805);
  params[0] = num2802;
  partcv[0] = 1;
  Object sum2806 = callmethod(call2805, "+(1)", 1, partcv, params);
// compiled op node returning sum2806 (depth = 5)
  gc_frame_newslot(sum2806);
// call case 4: self request
  params[0] = sum2806;
  partcv[0] = 1;
  Object call2807 = callmethodflags(self, "idx:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2800);
// compiled call node returning call2807 (depth = 4)
// Begin line 1370
  setline(1370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe2810 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2811 = gc_frame_new();
// call case 3: self.outer request
  Object call2812 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2811);
// compiled member node returning call2812 (depth = 7)
  Object call2813 = callmethodflags(call2812, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2810);
// compiled member node returning call2813 (depth = 6)
  int op_slot_right_2809 = gc_frame_newslot(call2813);
// starting to compile member node (depth = 6)
  int callframe2815 = gc_frame_new();
// call case 4: self request
  Object call2816 = callmethodflags(self, "imods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2815);
// compiled member node returning call2816 (depth = 6)
  int op_slot_left_2809 = gc_frame_newslot(call2816);
  params[0] = call2813;
  partcv[0] = 1;
  Object opresult2817 = callmethod(call2816, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2817 (depth = 5)
  Object if2808 = done;
  if (istrue(opresult2817)) {
// Begin line 1371
  setline(1371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2818 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe2819 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2820 = gc_frame_new();
// call case 3: self.outer request
  Object call2821 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2820);
// compiled member node returning call2821 (depth = 7)
  Object call2822 = callmethodflags(call2821, "asString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2819);
// compiled member node returning call2822 (depth = 6)
  gc_frame_newslot(call2822);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ConcurrentModification (depth = 6)
  params[0] = call2822;
  partcv[0] = 1;
  Object call2823 = callmethodflags(*var_ConcurrentModification, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2818);
// compiled call node returning call2823 (depth = 5)
    gc_frame_newslot(call2823);
    if2808 = call2823;
  } else {
  }
// compiled if node returning if2808 (depth = 4)
// Begin line 1373
  setline(1373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_innerSize (depth = 6)
  int op_slot_right_2825 = gc_frame_newslot(*var_innerSize);
// starting to compile member node (depth = 6)
  int callframe2827 = gc_frame_new();
// call case 4: self request
  Object call2828 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2827);
// compiled member node returning call2828 (depth = 6)
  int op_slot_left_2825 = gc_frame_newslot(call2828);
  params[0] = *var_innerSize;
  partcv[0] = 1;
  Object opresult2829 = callmethod(call2828, "≥(1)", 1, partcv, params);
// compiled op node returning opresult2829 (depth = 5)
  Object if2824 = done;
  if (istrue(opresult2829)) {
// Begin line 1374
  setline(1374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2830 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2832 == NULL) {
    strlit2832 = alloc_String("");
    gc_root(strlit2832);
  }
// compiled string node returning strlit2832 (depth = 7)
  int op_slot_right_2831 = gc_frame_newslot(strlit2832);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe2835 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 9)
  int callframe2836 = gc_frame_new();
// call case 3: self.outer request
  Object call2837 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2836);
// compiled member node returning call2837 (depth = 9)
  Object call2838 = callmethodflags(call2837, "asString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2835);
// compiled member node returning call2838 (depth = 8)
  int op_slot_right_2834 = gc_frame_newslot(call2838);
// starting to compile string node (depth = 8)
  if (strlit2840 == NULL) {
    strlit2840 = alloc_String("iterator over ");
    gc_root(strlit2840);
  }
// compiled string node returning strlit2840 (depth = 8)
  int op_slot_left_2834 = gc_frame_newslot(strlit2840);
  params[0] = call2838;
  partcv[0] = 1;
  Object opresult2841 = callmethod(strlit2840, "++(1)", 1, partcv, params);
// compiled op node returning opresult2841 (depth = 7)
  int op_slot_left_2831 = gc_frame_newslot(opresult2841);
  params[0] = strlit2832;
  partcv[0] = 1;
  Object opresult2842 = callmethod(opresult2841, "++(1)", 1, partcv, params);
// compiled op node returning opresult2842 (depth = 6)
  gc_frame_newslot(opresult2842);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_IteratorExhausted (depth = 6)
  params[0] = opresult2842;
  partcv[0] = 1;
  Object call2843 = callmethodflags(*var_IteratorExhausted, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2830);
// compiled call node returning call2843 (depth = 5)
    gc_frame_newslot(call2843);
    if2824 = call2843;
  } else {
  }
// compiled if node returning if2824 (depth = 4)
// Begin line 1376
  setline(1376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2844 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe2845 = gc_frame_new();
// call case 4: self request
  Object call2846 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2845);
// compiled member node returning call2846 (depth = 6)
  gc_frame_newslot(call2846);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2847 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe2848 = gc_frame_new();
// call case 3: self.outer request
  Object call2849 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2848);
// compiled member node returning call2849 (depth = 7)
  Object call2850 = callmethodflags(call2849, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2847);
// compiled member node returning call2850 (depth = 6)
  params[0] = call2846;
  partcv[0] = 1;
  Object call2851 = callmethodflags(call2850, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2844);
// compiled call node returning call2851 (depth = 5)
  *var_candidate = call2851;
  if (call2851 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1377
  setline(1377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  int op_slot_right_2854 = gc_frame_newslot(*var_candidate);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  int op_slot_left_2854 = gc_frame_newslot(*var_removed);
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object opresult2856 = callmethod(*var_removed, "==(1)", 1, partcv, params);
// compiled op node returning opresult2856 (depth = 5)
  int op_slot_right_2853 = gc_frame_newslot(opresult2856);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  int op_slot_right_2858 = gc_frame_newslot(*var_candidate);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_unused (depth = 6)
  int op_slot_left_2858 = gc_frame_newslot(*var_unused);
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object opresult2860 = callmethod(*var_unused, "==(1)", 1, partcv, params);
// compiled op node returning opresult2860 (depth = 5)
  int op_slot_left_2853 = gc_frame_newslot(opresult2860);
  params[0] = opresult2856;
  partcv[0] = 1;
  Object opresult2861 = callmethod(opresult2860, "||(1)", 1, partcv, params);
// compiled op node returning opresult2861 (depth = 4)
  gc_frame_end(frame);
  return opresult2861;
}
Object meth_collectionsPrelude__apply2864(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_next2790(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_candidate = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "candidate");
  Object *var_innerSize = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "innerSize");
// Begin line 1366
  setline(1366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_candidate = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1367
  setline(1367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2791 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2792 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2793 = gc_frame_new();
// call case 3: self.outer request
  Object call2794 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2793);
// compiled member node returning call2794 (depth = 5)
  Object call2795 = callmethodflags(call2794, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2792);
// compiled member node returning call2795 (depth = 4)
  Object call2796 = callmethodflags(call2795, "size", 0, partcv, params, 0);
  gc_frame_end(callframe2791);
// compiled member node returning call2796 (depth = 3)
  *var_innerSize = call2796;
  if (call2796 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1368
  setline(1368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2797 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2798 = alloc_Block(NULL, NULL, "collectionsPrelude", 1368);
  gc_frame_newslot(block2798);
// method "_apply"
  block_savedest(block2798);
  Object closure2799 = createclosure(7, "_apply");
  setclosureframe(closure2799, stackframe);
  addtoclosure(closure2799, var_ConcurrentModification);
  addtoclosure(closure2799, var_innerSize);
  addtoclosure(closure2799, var_IteratorExhausted);
  addtoclosure(closure2799, var_candidate);
  addtoclosure(closure2799, var_removed);
  addtoclosure(closure2799, var_unused);
  addtoclosure(closure2799, selfslot);
  struct UserObject *uo2799 = (struct UserObject*)block2798;
  uo2799->data[0] = (Object)closure2799;
  Method *meth_meth_collectionsPrelude__apply2799 = addmethod2pos(block2798, "_apply", &meth_collectionsPrelude__apply2799, 0);
  int argcv_meth_collectionsPrelude__apply2799[] = {0};
  meth_meth_collectionsPrelude__apply2799->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2799);
  meth_meth_collectionsPrelude__apply2799->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2799->definitionLine = 1963;
// compiled block node returning block2798 (depth = 3)
  gc_frame_newslot(block2798);
// Begin line 1378
  setline(1378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2863 = alloc_Block(NULL, NULL, "collectionsPrelude", 1378);
  gc_frame_newslot(block2863);
// method "_apply"
  block_savedest(block2863);
  Object closure2864 = createclosure(1, "_apply");
  setclosureframe(closure2864, stackframe);
  addtoclosure(closure2864, selfslot);
  struct UserObject *uo2864 = (struct UserObject*)block2863;
  uo2864->data[0] = (Object)closure2864;
  Method *meth_meth_collectionsPrelude__apply2864 = addmethod2pos(block2863, "_apply", &meth_collectionsPrelude__apply2864, 0);
  int argcv_meth_collectionsPrelude__apply2864[] = {0};
  meth_meth_collectionsPrelude__apply2864->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2864);
  meth_meth_collectionsPrelude__apply2864->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2864->definitionLine = 1963;
// compiled block node returning block2863 (depth = 3)
  gc_frame_newslot(block2863);
// call case 5: prelude request
  params[0] = block2798;
  params[1] = block2863;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2866 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2797);
// compiled call node returning call2866 (depth = 2)
// Begin line 1379
  setline(1379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2867 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2869 = alloc_Float64(1);
// compiled num node returning num2869 (depth = 4)
  int op_slot_right_2868 = gc_frame_newslot(num2869);
// starting to compile member node (depth = 4)
  int callframe2871 = gc_frame_new();
// call case 4: self request
  Object call2872 = callmethodflags(self, "count", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2871);
// compiled member node returning call2872 (depth = 4)
  int op_slot_left_2868 = gc_frame_newslot(call2872);
  params[0] = num2869;
  partcv[0] = 1;
  Object sum2873 = callmethod(call2872, "+(1)", 1, partcv, params);
// compiled op node returning sum2873 (depth = 3)
  gc_frame_newslot(sum2873);
// call case 4: self request
  params[0] = sum2873;
  partcv[0] = 1;
  Object call2874 = callmethodflags(self, "count:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2867);
// compiled call node returning call2874 (depth = 2)
// Begin line 1380
  setline(1380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_candidate (depth = 2)
  gc_frame_end(frame);
  return *var_candidate;
}
Object meth_collectionsPrelude_iterator2774(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2775 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2775 = alloc_userobj2(8,6, objclass2775);
  gc_frame_newslot(obj2775);
if (objclass2775 == NULL) {
  glfree(obj2775->class->name);
  obj2775->class->name = "set.ofCapacity(_).object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2775, self, 0);
  addmethodreal(obj2775,"outer", &reader_collectionsPrelude_outer_2776);
  Object oldself2775 = self;
  struct StackFrameObject *oldstackframe2775 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2775);
  gc_frame_newslot((Object)stackframe);
  self = obj2775;
  Object *oldselfslot2775 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2775 = (*(struct UserObject *)self).data[0], lowerouter2775 = thisouter2775;
  if (inheritingObject2775) {
    struct UserObject *inho2775 = (struct UserObject *)inheritingObject2775;
    while (inho2775->super != GraceDefaultObject) inho2775 = (struct UserObject *)inho2775->super;
    inho2775->super = obj2775;
    self = inheritingObject2775;
    *selfslot = self;
    lowerouter2775 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2775;
  }
if (objclass2775 == NULL) {
  Method *reader2777 = addmethodrealflags(obj2775, "imods", &reader_collectionsPrelude_imods_2777, MFLAG_CONFIDENTIAL);
  Method *writer2777 = addmethodrealflags(obj2775, "imods:=(1)", &writer_collectionsPrelude_imods_2777, MFLAG_CONFIDENTIAL);
  reader2777->definitionModule = modulename;
  writer2777->definitionModule = modulename;
  reader2777->definitionLine = 1361;
  writer2777->definitionLine = 1361;
}
obj2775->flags |= OFLAG_MUTABLE;
adddatum2(obj2775, alloc_Undefined(), 1);
if (objclass2775 == NULL) {
  Method *reader2778 = addmethodrealflags(obj2775, "count", &reader_collectionsPrelude_count_2778, MFLAG_CONFIDENTIAL);
  Method *writer2778 = addmethodrealflags(obj2775, "count:=(1)", &writer_collectionsPrelude_count_2778, MFLAG_CONFIDENTIAL);
  reader2778->definitionModule = modulename;
  writer2778->definitionModule = modulename;
  reader2778->definitionLine = 1362;
  writer2778->definitionLine = 1362;
}
obj2775->flags |= OFLAG_MUTABLE;
adddatum2(obj2775, alloc_Undefined(), 2);
if (objclass2775 == NULL) {
  Method *reader2779 = addmethodrealflags(obj2775, "idx", &reader_collectionsPrelude_idx_2779, MFLAG_CONFIDENTIAL);
  Method *writer2779 = addmethodrealflags(obj2775, "idx:=(1)", &writer_collectionsPrelude_idx_2779, MFLAG_CONFIDENTIAL);
  reader2779->definitionModule = modulename;
  writer2779->definitionModule = modulename;
  reader2779->definitionLine = 1363;
  writer2779->definitionLine = 1363;
}
obj2775->flags |= OFLAG_MUTABLE;
adddatum2(obj2775, alloc_Undefined(), 3);
// method "hasNext"
  struct UserObject *uo2780 = (struct UserObject*)obj2775;
  uo2780->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext2780 = addmethod2pos(obj2775, "hasNext", &meth_collectionsPrelude_hasNext2780, 4);
  int argcv_meth_collectionsPrelude_hasNext2780[] = {0};
  meth_meth_collectionsPrelude_hasNext2780->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext2780);
  meth_meth_collectionsPrelude_hasNext2780->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext2780->definitionLine = 1364;
// method "next"
  block_savedest(obj2775);
  Object closure2790 = createclosure(4, "next");
  setclosureframe(closure2790, stackframe);
  addtoclosure(closure2790, var_ConcurrentModification);
  addtoclosure(closure2790, var_IteratorExhausted);
  addtoclosure(closure2790, var_removed);
  addtoclosure(closure2790, var_unused);
  struct UserObject *uo2790 = (struct UserObject*)obj2775;
  uo2790->data[5] = (Object)closure2790;
  Method *meth_meth_collectionsPrelude_next2790 = addmethod2pos(obj2775, "next", &meth_collectionsPrelude_next2790, 5);
  int argcv_meth_collectionsPrelude_next2790[] = {0};
  meth_meth_collectionsPrelude_next2790->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next2790);
  meth_meth_collectionsPrelude_next2790->definitionModule = modulename;
  meth_meth_collectionsPrelude_next2790->definitionLine = 1365;
  sourceObject = obj2775;
// Begin line 1361
  setline(1361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe2875 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2876 = gc_frame_new();
// call case 3: self.outer request
  Object call2877 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2876);
// compiled member node returning call2877 (depth = 3)
  Object call2878 = callmethodflags(call2877, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2875);
// compiled member node returning call2878 (depth = 2)
  adddatum2(obj2775, call2878, 1);
  sourceObject = obj2775;
// Begin line 1362
  setline(1362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2879 = alloc_Float64(1);
// compiled num node returning num2879 (depth = 2)
  adddatum2(obj2775, num2879, 2);
  sourceObject = obj2775;
// Begin line 1364
  setline(1364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2880 = gc_frame_new();
// call case 6: other requests
// Begin line 1363
  setline(1363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num2881 = alloc_Float64(1);
// compiled num node returning num2881 (depth = 3)
  partcv[0] = 0;
  Object call2882 = callmethodflags(num2881, "prefix-", 1, partcv, params, 0);
  gc_frame_end(callframe2880);
// compiled call node returning call2882 (depth = 2)
  adddatum2(obj2775, call2882, 3);
  sourceObject = obj2775;
  sourceObject = obj2775;
  objclass2775 = obj2775->class;
  objclass2775->definitionModule = modulename;
  objclass2775->definitionLine = 1360;
  (*(struct UserObject *)self).data[0] = lowerouter2775;
  self = oldself2775;
  selfslot = oldselfslot2775;
  stackframe = oldstackframe2775;
  gc_frame_end(frame);
  return obj2775;
}
Object meth_collectionsPrelude_iterator2774_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2775 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2775 = alloc_userobj2(8,6, objclass2775);
  gc_frame_newslot(obj2775);
if (objclass2775 == NULL) {
  glfree(obj2775->class->name);
  obj2775->class->name = "set.ofCapacity(_).object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2775, self, 0);
  addmethodreal(obj2775,"outer", &reader_collectionsPrelude_outer_2776);
  Object oldself2775 = self;
  struct StackFrameObject *oldstackframe2775 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2775);
  gc_frame_newslot((Object)stackframe);
  self = obj2775;
  Object *oldselfslot2775 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2775 = (*(struct UserObject *)self).data[0], lowerouter2775 = thisouter2775;
  if (inheritingObject2775) {
    struct UserObject *inho2775 = (struct UserObject *)inheritingObject2775;
    while (inho2775->super != GraceDefaultObject) inho2775 = (struct UserObject *)inho2775->super;
    inho2775->super = obj2775;
    self = inheritingObject2775;
    *selfslot = self;
    lowerouter2775 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2775;
  }
if (objclass2775 == NULL) {
  Method *reader2777 = addmethodrealflags(obj2775, "imods", &reader_collectionsPrelude_imods_2777, MFLAG_CONFIDENTIAL);
  Method *writer2777 = addmethodrealflags(obj2775, "imods:=(1)", &writer_collectionsPrelude_imods_2777, MFLAG_CONFIDENTIAL);
  reader2777->definitionModule = modulename;
  writer2777->definitionModule = modulename;
  reader2777->definitionLine = 1361;
  writer2777->definitionLine = 1361;
}
obj2775->flags |= OFLAG_MUTABLE;
adddatum2(obj2775, alloc_Undefined(), 1);
if (objclass2775 == NULL) {
  Method *reader2778 = addmethodrealflags(obj2775, "count", &reader_collectionsPrelude_count_2778, MFLAG_CONFIDENTIAL);
  Method *writer2778 = addmethodrealflags(obj2775, "count:=(1)", &writer_collectionsPrelude_count_2778, MFLAG_CONFIDENTIAL);
  reader2778->definitionModule = modulename;
  writer2778->definitionModule = modulename;
  reader2778->definitionLine = 1362;
  writer2778->definitionLine = 1362;
}
obj2775->flags |= OFLAG_MUTABLE;
adddatum2(obj2775, alloc_Undefined(), 2);
if (objclass2775 == NULL) {
  Method *reader2779 = addmethodrealflags(obj2775, "idx", &reader_collectionsPrelude_idx_2779, MFLAG_CONFIDENTIAL);
  Method *writer2779 = addmethodrealflags(obj2775, "idx:=(1)", &writer_collectionsPrelude_idx_2779, MFLAG_CONFIDENTIAL);
  reader2779->definitionModule = modulename;
  writer2779->definitionModule = modulename;
  reader2779->definitionLine = 1363;
  writer2779->definitionLine = 1363;
}
obj2775->flags |= OFLAG_MUTABLE;
adddatum2(obj2775, alloc_Undefined(), 3);
// method "hasNext"
  struct UserObject *uo2780 = (struct UserObject*)obj2775;
  uo2780->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext2780 = addmethod2pos(obj2775, "hasNext", &meth_collectionsPrelude_hasNext2780, 4);
  int argcv_meth_collectionsPrelude_hasNext2780[] = {0};
  meth_meth_collectionsPrelude_hasNext2780->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext2780);
  meth_meth_collectionsPrelude_hasNext2780->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext2780->definitionLine = 1364;
// method "next"
  block_savedest(obj2775);
  Object closure2790 = createclosure(4, "next");
  setclosureframe(closure2790, stackframe);
  addtoclosure(closure2790, var_ConcurrentModification);
  addtoclosure(closure2790, var_IteratorExhausted);
  addtoclosure(closure2790, var_removed);
  addtoclosure(closure2790, var_unused);
  struct UserObject *uo2790 = (struct UserObject*)obj2775;
  uo2790->data[5] = (Object)closure2790;
  Method *meth_meth_collectionsPrelude_next2790 = addmethod2pos(obj2775, "next", &meth_collectionsPrelude_next2790, 5);
  int argcv_meth_collectionsPrelude_next2790[] = {0};
  meth_meth_collectionsPrelude_next2790->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next2790);
  meth_meth_collectionsPrelude_next2790->definitionModule = modulename;
  meth_meth_collectionsPrelude_next2790->definitionLine = 1365;
  sourceObject = obj2775;
// Begin line 1361
  setline(1361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe2875 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2876 = gc_frame_new();
// call case 3: self.outer request
  Object call2877 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2876);
// compiled member node returning call2877 (depth = 3)
  Object call2878 = callmethodflags(call2877, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2875);
// compiled member node returning call2878 (depth = 2)
  adddatum2(obj2775, call2878, 1);
  sourceObject = obj2775;
// Begin line 1362
  setline(1362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2879 = alloc_Float64(1);
// compiled num node returning num2879 (depth = 2)
  adddatum2(obj2775, num2879, 2);
  sourceObject = obj2775;
// Begin line 1364
  setline(1364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2880 = gc_frame_new();
// call case 6: other requests
// Begin line 1363
  setline(1363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num2881 = alloc_Float64(1);
// compiled num node returning num2881 (depth = 3)
  partcv[0] = 0;
  Object call2882 = callmethodflags(num2881, "prefix-", 1, partcv, params, 0);
  gc_frame_end(callframe2880);
// compiled call node returning call2882 (depth = 2)
  adddatum2(obj2775, call2882, 3);
  sourceObject = obj2775;
  sourceObject = obj2775;
  objclass2775 = obj2775->class;
  objclass2775->definitionModule = modulename;
  objclass2775->definitionLine = 1360;
  (*(struct UserObject *)self).data[0] = lowerouter2775;
  self = oldself2775;
  selfslot = oldselfslot2775;
  stackframe = oldstackframe2775;
  gc_frame_end(frame);
  return obj2775;
}
Object meth_collectionsPrelude__apply_40_1_41_2918(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1392
  setline(1392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2919 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  gc_frame_newslot(*var_unused);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2920 = gc_frame_new();
// call case 4: self request
  Object call2921 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2920);
// compiled member node returning call2921 (depth = 5)
  params[0] = *var_i;
  params[1] = *var_unused;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2922 = callmethodflags(call2921, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe2919);
// compiled call node returning call2922 (depth = 4)
  gc_frame_end(frame);
  return call2922;
}
Object meth_collectionsPrelude__apply_40_1_41_2937(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_oldInner = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1395
  setline(1395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2941 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_oldInner (depth = 8)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2942 = callmethodflags(*var_oldInner, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2941);
// compiled call node returning call2942 (depth = 7)
  int op_slot_right_2940 = gc_frame_newslot(call2942);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_2940 = gc_frame_newslot(*var_removed);
  params[0] = call2942;
  partcv[0] = 1;
  Object opresult2944 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2944 (depth = 6)
  int op_slot_right_2939 = gc_frame_newslot(opresult2944);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2947 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_oldInner (depth = 8)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2948 = callmethodflags(*var_oldInner, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2947);
// compiled call node returning call2948 (depth = 7)
  int op_slot_right_2946 = gc_frame_newslot(call2948);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_2946 = gc_frame_newslot(*var_unused);
  params[0] = call2948;
  partcv[0] = 1;
  Object opresult2950 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult2950 (depth = 6)
  int op_slot_left_2939 = gc_frame_newslot(opresult2950);
  params[0] = opresult2944;
  partcv[0] = 1;
  Object opresult2951 = callmethod(opresult2950, "&&(1)", 1, partcv, params);
// compiled op node returning opresult2951 (depth = 5)
  Object if2938 = done;
  if (istrue(opresult2951)) {
// Begin line 1396
  setline(1396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2952 = gc_frame_new();
// starting to compile call node (depth = 6)
  int callframe2953 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_oldInner (depth = 7)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2954 = callmethodflags(*var_oldInner, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2953);
// compiled call node returning call2954 (depth = 6)
  gc_frame_newslot(call2954);
// call case 4: self request
  params[0] = call2954;
  partcv[0] = 1;
  Object call2955 = callmethodflags(self, "add(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2952);
// compiled call node returning call2955 (depth = 5)
    gc_frame_newslot(call2955);
    if2938 = call2955;
  } else {
  }
// compiled if node returning if2938 (depth = 4)
  gc_frame_end(frame);
  return if2938;
}
Object meth_collectionsPrelude_expand2884(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expand");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var__prelude = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_c = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "c");
  Object *var_n = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "n");
  Object *var_oldInner = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "oldInner");
// Begin line 1386
  setline(1386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2885 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2886 = gc_frame_new();
// call case 4: self request
  Object call2887 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2886);
// compiled member node returning call2887 (depth = 4)
  Object call2888 = callmethodflags(call2887, "size", 0, partcv, params, 0);
  gc_frame_end(callframe2885);
// compiled member node returning call2888 (depth = 3)
  *var_c = call2888;
  if (call2888 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1387
  setline(1387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2890 = alloc_Float64(2);
// compiled num node returning num2890 (depth = 4)
  int op_slot_right_2889 = gc_frame_newslot(num2890);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  int op_slot_left_2889 = gc_frame_newslot(*var_c);
  params[0] = num2890;
  partcv[0] = 1;
  Object prod2892 = callmethod(*var_c, "*(1)", 1, partcv, params);
// compiled op node returning prod2892 (depth = 3)
  *var_n = prod2892;
  if (prod2892 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1388
  setline(1388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2893 = gc_frame_new();
// call case 4: self request
  Object call2894 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2893);
// compiled member node returning call2894 (depth = 3)
  *var_oldInner = call2894;
  if (call2894 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1389
  setline(1389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2895 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num2896 = alloc_Float64(0);
// compiled num node returning num2896 (depth = 3)
  gc_frame_newslot(num2896);
// call case 4: self request
  params[0] = num2896;
  partcv[0] = 1;
  Object call2897 = callmethodflags(self, "size:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2895);
// compiled call node returning call2897 (depth = 2)
// Begin line 1390
  setline(1390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2898 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe2899 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2900 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var__prelude (depth = 5)
  Object call2901 = callmethodflags(*var__prelude, "primitiveArray", 0, partcv, params, 0);
  gc_frame_end(callframe2900);
// compiled member node returning call2901 (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2902 = callmethodflags(call2901, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2899);
// compiled call node returning call2902 (depth = 3)
  gc_frame_newslot(call2902);
// call case 4: self request
  params[0] = call2902;
  partcv[0] = 1;
  Object call2903 = callmethodflags(self, "inner:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2898);
// compiled call node returning call2903 (depth = 2)
// Begin line 1391
  setline(1391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2904 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2907 = alloc_Float64(1);
// compiled num node returning num2907 (depth = 5)
  int op_slot_right_2906 = gc_frame_newslot(num2907);
// starting to compile member node (depth = 5)
  int callframe2909 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2910 = gc_frame_new();
// call case 4: self request
  Object call2911 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2910);
// compiled member node returning call2911 (depth = 6)
  Object call2912 = callmethodflags(call2911, "size", 0, partcv, params, 0);
  gc_frame_end(callframe2909);
// compiled member node returning call2912 (depth = 5)
  int op_slot_left_2906 = gc_frame_newslot(call2912);
  params[0] = num2907;
  partcv[0] = 1;
  Object diff2913 = callmethod(call2912, "-(1)", 1, partcv, params);
// compiled op node returning diff2913 (depth = 4)
  int op_slot_right_2905 = gc_frame_newslot(diff2913);
// starting to compile num node (depth = 4)
  Object num2915 = alloc_Float64(0);
// compiled num node returning num2915 (depth = 4)
  int op_slot_left_2905 = gc_frame_newslot(num2915);
  params[0] = diff2913;
  partcv[0] = 1;
  Object opresult2916 = callmethod(num2915, "..(1)", 1, partcv, params);
// compiled op node returning opresult2916 (depth = 3)
  gc_frame_newslot(opresult2916);
// starting to compile block node (depth = 3)
  Object block2917 = alloc_Block(NULL, NULL, "collectionsPrelude", 1391);
  gc_frame_newslot(block2917);
// method "_apply(_)"
  block_savedest(block2917);
  Object closure2918 = createclosure(2, "_apply(1)");
  setclosureframe(closure2918, stackframe);
  addtoclosure(closure2918, var_unused);
  addtoclosure(closure2918, selfslot);
  struct UserObject *uo2918 = (struct UserObject*)block2917;
  uo2918->data[0] = (Object)closure2918;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2918 = addmethod2pos(block2917, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2918, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2918[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2918->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2918);
  meth_meth_collectionsPrelude__apply_40_1_41_2918->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2918->definitionLine = 1963;
// compiled block node returning block2917 (depth = 3)
  gc_frame_newslot(block2917);
// call case 5: prelude request
  params[0] = opresult2916;
  params[1] = block2917;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2924 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2904);
// compiled call node returning call2924 (depth = 2)
// Begin line 1394
  setline(1394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2925 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2928 = alloc_Float64(1);
// compiled num node returning num2928 (depth = 5)
  int op_slot_right_2927 = gc_frame_newslot(num2928);
// starting to compile member node (depth = 5)
  int callframe2930 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_oldInner (depth = 6)
  Object call2931 = callmethodflags(*var_oldInner, "size", 0, partcv, params, 0);
  gc_frame_end(callframe2930);
// compiled member node returning call2931 (depth = 5)
  int op_slot_left_2927 = gc_frame_newslot(call2931);
  params[0] = num2928;
  partcv[0] = 1;
  Object diff2932 = callmethod(call2931, "-(1)", 1, partcv, params);
// compiled op node returning diff2932 (depth = 4)
  int op_slot_right_2926 = gc_frame_newslot(diff2932);
// starting to compile num node (depth = 4)
  Object num2934 = alloc_Float64(0);
// compiled num node returning num2934 (depth = 4)
  int op_slot_left_2926 = gc_frame_newslot(num2934);
  params[0] = diff2932;
  partcv[0] = 1;
  Object opresult2935 = callmethod(num2934, "..(1)", 1, partcv, params);
// compiled op node returning opresult2935 (depth = 3)
  gc_frame_newslot(opresult2935);
// starting to compile block node (depth = 3)
  Object block2936 = alloc_Block(NULL, NULL, "collectionsPrelude", 1394);
  gc_frame_newslot(block2936);
// method "_apply(_)"
  block_savedest(block2936);
  Object closure2937 = createclosure(4, "_apply(1)");
  setclosureframe(closure2937, stackframe);
  addtoclosure(closure2937, var_oldInner);
  addtoclosure(closure2937, var_removed);
  addtoclosure(closure2937, var_unused);
  addtoclosure(closure2937, selfslot);
  struct UserObject *uo2937 = (struct UserObject*)block2936;
  uo2937->data[0] = (Object)closure2937;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2937 = addmethod2pos(block2936, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2937, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2937[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2937->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2937);
  meth_meth_collectionsPrelude__apply_40_1_41_2937->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2937->definitionLine = 1963;
// compiled block node returning block2936 (depth = 3)
  gc_frame_newslot(block2936);
// call case 5: prelude request
  params[0] = opresult2935;
  params[1] = block2936;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2957 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2925);
// compiled call node returning call2957 (depth = 2)
  gc_frame_end(frame);
  return call2957;
}
Object meth_collectionsPrelude__apply_40_1_41_2965(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_otherSize = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1404
  setline(1404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2967 = alloc_Float64(1);
// compiled num node returning num2967 (depth = 7)
  int op_slot_right_2966 = gc_frame_newslot(num2967);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_otherSize (depth = 7)
  int op_slot_left_2966 = gc_frame_newslot(*var_otherSize);
  params[0] = num2967;
  partcv[0] = 1;
  Object sum2969 = callmethod(*var_otherSize, "+(1)", 1, partcv, params);
// compiled op node returning sum2969 (depth = 6)
  *var_otherSize = sum2969;
  if (sum2969 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1405
  setline(1405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2972 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe2973 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  gc_frame_newslot(*var_each);
// call case 4: self request
  params[0] = *var_each;
  partcv[0] = 1;
  Object call2974 = callmethodflags(self, "contains(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2973);
// compiled call node returning call2974 (depth = 7)
  partcv[0] = 0;
  Object call2975 = callmethodflags(call2974, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe2972);
// compiled call node returning call2975 (depth = 6)
  Object if2971 = done;
  if (istrue(call2975)) {
// Begin line 1406
  setline(1406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool2976 = alloc_Boolean(0);
// compiled identifier node returning bool2976 (depth = 7)
  block_return(realself, bool2976);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if2971 = undefined;
  } else {
  }
// compiled if node returning if2971 (depth = 5)
  gc_frame_end(frame);
  return if2971;
}
Object meth_collectionsPrelude__61__61__40_1_41_2958(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[1];
  int partcv[1];
  Object *var_Iterable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_otherSize = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "otherSize");
// Begin line 1401
  setline(1401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2960 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_Iterable (depth = 4)
  params[0] = *var_other;
  partcv[0] = 1;
  Object call2961 = callmethodflags(*var_Iterable, "match(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2960);
// compiled call node returning call2961 (depth = 3)
  Object if2959 = done;
  if (istrue(call2961)) {
// Begin line 1402
  setline(1402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2962 = alloc_Float64(0);
// compiled num node returning num2962 (depth = 4)
  *var_otherSize = num2962;
  if (num2962 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1403
  setline(1403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2963 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block2964 = alloc_Block(NULL, NULL, "collectionsPrelude", 1403);
  gc_frame_newslot(block2964);
// method "_apply(_)"
  block_savedest(block2964);
  Object closure2965 = createclosure(2, "_apply(1)");
  setclosureframe(closure2965, stackframe);
  addtoclosure(closure2965, var_otherSize);
  addtoclosure(closure2965, selfslot);
  struct UserObject *uo2965 = (struct UserObject*)block2964;
  uo2965->data[0] = (Object)closure2965;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_2965 = addmethod2pos(block2964, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_2965, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_2965[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_2965->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_2965);
  meth_meth_collectionsPrelude__apply_40_1_41_2965->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_2965->definitionLine = 1963;
// compiled block node returning block2964 (depth = 4)
  gc_frame_newslot(block2964);
// call case 6: other requests
// Begin line 1403
  setline(1403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  params[0] = block2964;
  partcv[0] = 1;
  Object call2978 = callmethodflags(*var_other, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2963);
// compiled call node returning call2978 (depth = 3)
// Begin line 1409
  setline(1409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe2980 = gc_frame_new();
// call case 4: self request
  Object call2981 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2980);
// compiled member node returning call2981 (depth = 4)
  int op_slot_right_2979 = gc_frame_newslot(call2981);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_otherSize (depth = 4)
  int op_slot_left_2979 = gc_frame_newslot(*var_otherSize);
  params[0] = call2981;
  partcv[0] = 1;
  Object opresult2983 = callmethod(*var_otherSize, "==(1)", 1, partcv, params);
// compiled op node returning opresult2983 (depth = 3)
    gc_frame_newslot(opresult2983);
    if2959 = opresult2983;
  } else {
// Begin line 1411
  setline(1411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2984 = alloc_Boolean(0);
// compiled identifier node returning bool2984 (depth = 3)
    gc_frame_newslot(bool2984);
    if2959 = bool2984;
  }
// compiled if node returning if2959 (depth = 2)
  gc_frame_end(frame);
  return if2959;
}
Object meth_collectionsPrelude_copy2985(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "copy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1415
  setline(1415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2986 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2987 = gc_frame_new();
// call case 3: self.outer request
  Object call2988 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2987);
// compiled member node returning call2988 (depth = 3)
  params[0] = self;
  partcv[0] = 1;
  Object call2989 = callmethodflags(call2988, "withAll(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2986);
// compiled call node returning call2989 (depth = 2)
  gc_frame_end(frame);
  return call2989;
}
Object meth_collectionsPrelude__43__43__40_1_41_2990(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ++(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1419
  setline(1419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2991 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe2992 = gc_frame_new();
// call case 4: self request
  Object call2993 = callmethodflags(self, "copy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2992);
// compiled member node returning call2993 (depth = 3)
  params[0] = *var_other;
  partcv[0] = 1;
  Object call2994 = callmethodflags(call2993, "addAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe2991);
// compiled call node returning call2994 (depth = 2)
  gc_frame_end(frame);
  return call2994;
}
Object meth_collectionsPrelude__apply_40_1_41_3006(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_other = getfromclosure(closure, 0);
  Object *var_result = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1425
  setline(1425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3008 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe3009 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call3010 = callmethodflags(*var_other, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3009);
// compiled call node returning call3010 (depth = 6)
  partcv[0] = 0;
  Object call3011 = callmethodflags(call3010, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe3008);
// compiled call node returning call3011 (depth = 5)
  Object if3007 = done;
  if (istrue(call3011)) {
// Begin line 1426
  setline(1426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3012 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_result (depth = 6)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call3013 = callmethodflags(*var_result, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3012);
// compiled call node returning call3013 (depth = 5)
    gc_frame_newslot(call3013);
    if3007 = call3013;
  } else {
  }
// compiled if node returning if3007 (depth = 4)
  gc_frame_end(frame);
  return if3007;
}
Object meth_collectionsPrelude__45__45__40_1_41_2995(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "--(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method --(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for --(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part --(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "result");
// Begin line 1423
  setline(1423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe2996 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe2997 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe2998 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe2999 = gc_frame_new();
// call case 3: self.outer request
  Object call3000 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2999);
// compiled member node returning call3000 (depth = 6)
  Object call3001 = callmethodflags(call3000, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe2998);
// compiled member node returning call3001 (depth = 5)
  Object call3002 = callmethodflags(call3001, "set", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2997);
// compiled member node returning call3002 (depth = 4)
  Object call3003 = callmethodflags(call3002, "empty", 0, partcv, params, 0);
  gc_frame_end(callframe2996);
// compiled member node returning call3003 (depth = 3)
  *var_result = call3003;
  if (call3003 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1424
  setline(1424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3004 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile block node (depth = 3)
  Object block3005 = alloc_Block(NULL, NULL, "collectionsPrelude", 1424);
  gc_frame_newslot(block3005);
// method "_apply(_)"
  block_savedest(block3005);
  Object closure3006 = createclosure(3, "_apply(1)");
  setclosureframe(closure3006, stackframe);
  addtoclosure(closure3006, var_other);
  addtoclosure(closure3006, var_result);
  addtoclosure(closure3006, selfslot);
  struct UserObject *uo3006 = (struct UserObject*)block3005;
  uo3006->data[0] = (Object)closure3006;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3006 = addmethod2pos(block3005, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3006, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3006[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3006->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3006);
  meth_meth_collectionsPrelude__apply_40_1_41_3006->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3006->definitionLine = 1963;
// compiled block node returning block3005 (depth = 3)
  gc_frame_newslot(block3005);
// call case 5: prelude request
  params[0] = self;
  params[1] = block3005;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3015 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3004);
// compiled call node returning call3015 (depth = 2)
// Begin line 1429
  setline(1429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude__apply_40_1_41_3020(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_other = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe3021 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_other (depth = 6)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call3022 = callmethodflags(*var_other, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3021);
// compiled call node returning call3022 (depth = 5)
  gc_frame_end(frame);
  return call3022;
}
Object meth_collectionsPrelude__42__42__40_1_41_3016(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "**(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method **(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for **(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part **(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1433
  setline(1433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3017 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 3)
  int callframe3018 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block3019 = alloc_Block(NULL, NULL, "collectionsPrelude", 1433);
  gc_frame_newslot(block3019);
// method "_apply(_)"
  block_savedest(block3019);
  Object closure3020 = createclosure(2, "_apply(1)");
  setclosureframe(closure3020, stackframe);
  addtoclosure(closure3020, var_other);
  addtoclosure(closure3020, selfslot);
  struct UserObject *uo3020 = (struct UserObject*)block3019;
  uo3020->data[0] = (Object)closure3020;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3020 = addmethod2pos(block3019, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3020, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3020[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3020->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3020);
  meth_meth_collectionsPrelude__apply_40_1_41_3020->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3020->definitionLine = 1963;
// compiled block node returning block3019 (depth = 4)
  gc_frame_newslot(block3019);
// call case 4: self request
  params[0] = block3019;
  partcv[0] = 1;
  Object call3024 = callmethodflags(self, "filter(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3018);
// compiled call node returning call3024 (depth = 3)
  Object call3025 = callmethodflags(call3024, "asSet", 0, partcv, params, 0);
  gc_frame_end(callframe3017);
// compiled member node returning call3025 (depth = 2)
  gc_frame_end(frame);
  return call3025;
}
Object meth_collectionsPrelude__apply_40_1_41_3029(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s2 = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1437
  setline(1437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3031 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe3032 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s2 (depth = 7)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call3033 = callmethodflags(*var_s2, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3032);
// compiled call node returning call3033 (depth = 6)
  Object call3034 = callmethodflags(call3033, "not", 0, partcv, params, 0);
  gc_frame_end(callframe3031);
// compiled member node returning call3034 (depth = 5)
  Object if3030 = done;
  if (istrue(call3034)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool3035 = alloc_Boolean(0);
// compiled identifier node returning bool3035 (depth = 6)
  block_return(realself, bool3035);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if3030 = undefined;
  } else {
  }
// compiled if node returning if3030 (depth = 4)
  gc_frame_end(frame);
  return if3030;
}
Object meth_collectionsPrelude_isSubset_40_1_41_3026(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSubset(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method isSubset(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isSubset(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s2 = &(stackframe->slots[0]);
  *var_s2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part isSubset(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1436
  setline(1436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3027 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3028 = alloc_Block(NULL, NULL, "collectionsPrelude", 1436);
  gc_frame_newslot(block3028);
// method "_apply(_)"
  block_savedest(block3028);
  Object closure3029 = createclosure(2, "_apply(1)");
  setclosureframe(closure3029, stackframe);
  addtoclosure(closure3029, var_s2);
  addtoclosure(closure3029, selfslot);
  struct UserObject *uo3029 = (struct UserObject*)block3028;
  uo3029->data[0] = (Object)closure3029;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3029 = addmethod2pos(block3028, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3029, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3029[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3029->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3029);
  meth_meth_collectionsPrelude__apply_40_1_41_3029->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3029->definitionLine = 1963;
// compiled block node returning block3028 (depth = 3)
  gc_frame_newslot(block3028);
// call case 4: self request
  params[0] = block3028;
  partcv[0] = 1;
  Object call3037 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3027);
// compiled call node returning call3037 (depth = 2)
// Begin line 1439
  setline(1439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool3038 = alloc_Boolean(1);
// compiled identifier node returning bool3038 (depth = 3)
  return bool3038;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply_40_1_41_3042(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1444
  setline(1444);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe3044 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe3045 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  gc_frame_newslot(*var_each);
// call case 4: self request
  params[0] = *var_each;
  partcv[0] = 1;
  Object call3046 = callmethodflags(self, "contains(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3045);
// compiled call node returning call3046 (depth = 6)
  Object call3047 = callmethodflags(call3046, "not", 0, partcv, params, 0);
  gc_frame_end(callframe3044);
// compiled member node returning call3047 (depth = 5)
  Object if3043 = done;
  if (istrue(call3047)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool3048 = alloc_Boolean(0);
// compiled identifier node returning bool3048 (depth = 6)
  block_return(realself, bool3048);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if3043 = undefined;
  } else {
  }
// compiled if node returning if3043 (depth = 4)
  gc_frame_end(frame);
  return if3043;
}
Object meth_collectionsPrelude_isSuperset_40_1_41_3039(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSuperset(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method isSuperset(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isSuperset(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s2 = &(stackframe->slots[0]);
  *var_s2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part isSuperset(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1443
  setline(1443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3040 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3041 = alloc_Block(NULL, NULL, "collectionsPrelude", 1443);
  gc_frame_newslot(block3041);
// method "_apply(_)"
  block_savedest(block3041);
  Object closure3042 = createclosure(1, "_apply(1)");
  setclosureframe(closure3042, stackframe);
  addtoclosure(closure3042, selfslot);
  struct UserObject *uo3042 = (struct UserObject*)block3041;
  uo3042->data[0] = (Object)closure3042;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3042 = addmethod2pos(block3041, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3042, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3042[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3042->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3042);
  meth_meth_collectionsPrelude__apply_40_1_41_3042->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3042->definitionLine = 1963;
// compiled block node returning block3041 (depth = 3)
  gc_frame_newslot(block3041);
// call case 6: other requests
// Begin line 1443
  setline(1443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s2 (depth = 3)
  params[0] = block3041;
  partcv[0] = 1;
  Object call3050 = callmethodflags(*var_s2, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3040);
// compiled call node returning call3050 (depth = 2)
// Begin line 1446
  setline(1446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool3051 = alloc_Boolean(1);
// compiled identifier node returning bool3051 (depth = 3)
  return bool3051;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply_40_1_41_3055(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_existing = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe3056 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_existing (depth = 5)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call3057 = callmethodflags(*var_existing, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3056);
// compiled call node returning call3057 (depth = 4)
  gc_frame_end(frame);
  return call3057;
}
Object meth_collectionsPrelude_into_40_1_41_3052(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "into(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method into(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for into(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_existing = &(stackframe->slots[0]);
  *var_existing = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part into(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1449
  setline(1449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3053 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3054 = alloc_Block(NULL, NULL, "collectionsPrelude", 1449);
  gc_frame_newslot(block3054);
// method "_apply(_)"
  block_savedest(block3054);
  Object closure3055 = createclosure(2, "_apply(1)");
  setclosureframe(closure3055, stackframe);
  addtoclosure(closure3055, var_existing);
  addtoclosure(closure3055, selfslot);
  struct UserObject *uo3055 = (struct UserObject*)block3054;
  uo3055->data[0] = (Object)closure3055;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3055 = addmethod2pos(block3054, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3055, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3055[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3055->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3055);
  meth_meth_collectionsPrelude__apply_40_1_41_3055->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3055->definitionLine = 1963;
// compiled block node returning block3054 (depth = 3)
  gc_frame_newslot(block3054);
// call case 4: self request
  params[0] = block3054;
  partcv[0] = 1;
  Object call3059 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3053);
// compiled call node returning call3059 (depth = 2)
// Begin line 1450
  setline(1450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_existing (depth = 2)
  gc_frame_end(frame);
  return *var_existing;
}
Object meth_collectionsPrelude__apply_40_1_41_3070(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1193
  setline(1193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3071 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  gc_frame_newslot(*var_unused);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3072 = gc_frame_new();
// call case 4: self request
  Object call3073 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3072);
// compiled member node returning call3073 (depth = 5)
  params[0] = *var_i;
  params[1] = *var_unused;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3074 = callmethodflags(call3073, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3071);
// compiled call node returning call3074 (depth = 4)
  gc_frame_end(frame);
  return call3074;
}
Object meth_collectionsPrelude_ofCapacity_40_1_41_2303(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ofCapacity(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ofCapacity(_)");
  Object params[1];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object *var_ConcurrentModification = getfromclosure(closure, 3);
  Object *var_IteratorExhausted = getfromclosure(closure, 4);
  Object *var__prelude = getfromclosure(closure, 5);
  Object *var_Iterable = getfromclosure(closure, 6);
  Object *var_collection = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ofCapacity(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cap = &(stackframe->slots[0]);
  *var_cap = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ofCapacity(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2304 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2304 = alloc_userobj2(33,31, objclass2304);
  gc_frame_newslot(obj2304);
if (objclass2304 == NULL) {
  glfree(obj2304->class->name);
  obj2304->class->name = "set.ofCapacity(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2304, self, 0);
  addmethodreal(obj2304,"outer", &reader_collectionsPrelude_outer_2305);
  Object oldself2304 = self;
  struct StackFrameObject *oldstackframe2304 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2304);
  gc_frame_newslot((Object)stackframe);
  self = obj2304;
  Object *oldselfslot2304 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2304 = (*(struct UserObject *)self).data[0], lowerouter2304 = thisouter2304;
  if (inheritingObject2304) {
    struct UserObject *inho2304 = (struct UserObject *)inheritingObject2304;
    while (inho2304->super != GraceDefaultObject) inho2304 = (struct UserObject *)inho2304->super;
    inho2304->super = obj2304;
    self = inheritingObject2304;
    *selfslot = self;
    lowerouter2304 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2304;
  }
if (objclass2304 == NULL) {
  Method *reader2306 = addmethodrealflags(obj2304, "mods", &reader_collectionsPrelude_mods_2306, 0);
  Method *writer2306 = addmethodrealflags(obj2304, "mods:=(1)", &writer_collectionsPrelude_mods_2306, MFLAG_CONFIDENTIAL);
  reader2306->definitionModule = modulename;
  writer2306->definitionModule = modulename;
  reader2306->definitionLine = 1189;
  writer2306->definitionLine = 1189;
}
obj2304->flags |= OFLAG_MUTABLE;
adddatum2(obj2304, alloc_Undefined(), 1);
if (objclass2304 == NULL) {
  Method *reader2307 = addmethodrealflags(obj2304, "inner", &reader_collectionsPrelude_inner_2307, MFLAG_CONFIDENTIAL);
  Method *writer2307 = addmethodrealflags(obj2304, "inner:=(1)", &writer_collectionsPrelude_inner_2307, MFLAG_CONFIDENTIAL);
  reader2307->definitionModule = modulename;
  writer2307->definitionModule = modulename;
  reader2307->definitionLine = 1190;
  writer2307->definitionLine = 1190;
}
obj2304->flags |= OFLAG_MUTABLE;
adddatum2(obj2304, alloc_Undefined(), 2);
if (objclass2304 == NULL) {
  Method *reader2308 = addmethodrealflags(obj2304, "size", &reader_collectionsPrelude_size_2308, 0);
  Method *writer2308 = addmethodrealflags(obj2304, "size:=(1)", &writer_collectionsPrelude_size_2308, MFLAG_CONFIDENTIAL);
  reader2308->definitionModule = modulename;
  writer2308->definitionModule = modulename;
  reader2308->definitionLine = 1191;
  writer2308->definitionLine = 1191;
}
obj2304->flags |= OFLAG_MUTABLE;
adddatum2(obj2304, alloc_Undefined(), 3);
// method "addAll(_)"
  struct UserObject *uo2309 = (struct UserObject*)obj2304;
  uo2309->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAll_40_1_41_2309 = addmethod2pos(obj2304, "addAll(1)", &meth_collectionsPrelude_addAll_40_1_41_2309, 4);
  int argcv_meth_collectionsPrelude_addAll_40_1_41_2309[] = {1};
  meth_meth_collectionsPrelude_addAll_40_1_41_2309->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAll_40_1_41_2309);
  meth_meth_collectionsPrelude_addAll_40_1_41_2309->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAll_40_1_41_2309->definitionLine = 1196;
// method "add(_)"
  struct UserObject *uo2358 = (struct UserObject*)obj2304;
  uo2358->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_add_40_1_41_2358 = addmethod2pos(obj2304, "add(1)", &meth_collectionsPrelude_add_40_1_41_2358, 5);
  int argcv_meth_collectionsPrelude_add_40_1_41_2358[] = {1};
  meth_meth_collectionsPrelude_add_40_1_41_2358->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add_40_1_41_2358);
  meth_meth_collectionsPrelude_add_40_1_41_2358->definitionModule = modulename;
  meth_meth_collectionsPrelude_add_40_1_41_2358->definitionLine = 1211;
// method "removeAll(_)"
  block_savedest(obj2304);
  Object closure2402 = createclosure(1, "removeAll(1)");
  setclosureframe(closure2402, stackframe);
  addtoclosure(closure2402, var_NoSuchObject);
  struct UserObject *uo2402 = (struct UserObject*)obj2304;
  uo2402->data[6] = (Object)closure2402;
  Method *meth_meth_collectionsPrelude_removeAll_40_1_41_2402 = addmethod2pos(obj2304, "removeAll(1)", &meth_collectionsPrelude_removeAll_40_1_41_2402, 6);
  int argcv_meth_collectionsPrelude_removeAll_40_1_41_2402[] = {1};
  meth_meth_collectionsPrelude_removeAll_40_1_41_2402->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAll_40_1_41_2402);
  meth_meth_collectionsPrelude_removeAll_40_1_41_2402->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40_1_41_2402->definitionLine = 1224;
// method "removeAll(_)ifAbsent(_)"
  block_savedest(obj2304);
  Object closure2423 = createclosure(1, "removeAll(1)ifAbsent(1)");
  setclosureframe(closure2423, stackframe);
  addtoclosure(closure2423, var_removed);
  struct UserObject *uo2423 = (struct UserObject*)obj2304;
  uo2423->data[7] = (Object)closure2423;
  Method *meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2423 = addmethod2pos(obj2304, "removeAll(1)ifAbsent(1)", &meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2423, 7);
  int argcv_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2423[] = {1, 1};
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2423->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2423);
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2423->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2423->definitionLine = 1232;
// method "remove(_)ifAbsent(_)"
  block_savedest(obj2304);
  Object closure2461 = createclosure(1, "remove(1)ifAbsent(1)");
  setclosureframe(closure2461, stackframe);
  addtoclosure(closure2461, var_removed);
  struct UserObject *uo2461 = (struct UserObject*)obj2304;
  uo2461->data[8] = (Object)closure2461;
  Method *meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2461 = addmethod2pos(obj2304, "remove(1)ifAbsent(1)", &meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2461, 8);
  int argcv_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2461[] = {1, 1};
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2461->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2461);
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2461->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2461->definitionLine = 1246;
// method "remove(_)"
  block_savedest(obj2304);
  Object closure2494 = createclosure(1, "remove(1)");
  setclosureframe(closure2494, stackframe);
  addtoclosure(closure2494, var_NoSuchObject);
  struct UserObject *uo2494 = (struct UserObject*)obj2304;
  uo2494->data[9] = (Object)closure2494;
  Method *meth_meth_collectionsPrelude_remove_40_1_41_2494 = addmethod2pos(obj2304, "remove(1)", &meth_collectionsPrelude_remove_40_1_41_2494, 9);
  int argcv_meth_collectionsPrelude_remove_40_1_41_2494[] = {1};
  meth_meth_collectionsPrelude_remove_40_1_41_2494->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_remove_40_1_41_2494);
  meth_meth_collectionsPrelude_remove_40_1_41_2494->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40_1_41_2494->definitionLine = 1258;
// method "contains(_)"
  struct UserObject *uo2510 = (struct UserObject*)obj2304;
  uo2510->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_2510 = addmethod2pos(obj2304, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_2510, 10);
  int argcv_meth_collectionsPrelude_contains_40_1_41_2510[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_2510->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_2510);
  meth_meth_collectionsPrelude_contains_40_1_41_2510->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_2510->definitionLine = 1265;
// method "includes(_)"
  struct UserObject *uo2523 = (struct UserObject*)obj2304;
  uo2523->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_includes_40_1_41_2523 = addmethod2pos(obj2304, "includes(1)", &meth_collectionsPrelude_includes_40_1_41_2523, 11);
  int argcv_meth_collectionsPrelude_includes_40_1_41_2523[] = {1};
  meth_meth_collectionsPrelude_includes_40_1_41_2523->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_includes_40_1_41_2523);
  meth_meth_collectionsPrelude_includes_40_1_41_2523->definitionModule = modulename;
  meth_meth_collectionsPrelude_includes_40_1_41_2523->definitionLine = 1272;
// method "find(_)ifNone(_)"
  struct UserObject *uo2534 = (struct UserObject*)obj2304;
  uo2534->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2534 = addmethod2pos(obj2304, "find(1)ifNone(1)", &meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2534, 12);
  int argcv_meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2534[] = {1, 1};
  meth_meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2534->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2534);
  meth_meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2534->definitionModule = modulename;
  meth_meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2534->definitionLine = 1278;
// method "findPosition(_)"
  block_savedest(obj2304);
  Object closure2545 = createclosure(1, "findPosition(1)");
  setclosureframe(closure2545, stackframe);
  addtoclosure(closure2545, var_unused);
  struct UserObject *uo2545 = (struct UserObject*)obj2304;
  uo2545->data[13] = (Object)closure2545;
  Method *meth_meth_collectionsPrelude_findPosition_40_1_41_2545 = addmethod2pos(obj2304, "findPosition(1)", &meth_collectionsPrelude_findPosition_40_1_41_2545, 13);
  int argcv_meth_collectionsPrelude_findPosition_40_1_41_2545[] = {1};
  meth_meth_collectionsPrelude_findPosition_40_1_41_2545->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPosition_40_1_41_2545);
  meth_meth_collectionsPrelude_findPosition_40_1_41_2545->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPosition_40_1_41_2545->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPosition_40_1_41_2545->definitionLine = 1284;
// method "findPositionForAdd(_)"
  block_savedest(obj2304);
  Object closure2606 = createclosure(2, "findPositionForAdd(1)");
  setclosureframe(closure2606, stackframe);
  addtoclosure(closure2606, var_removed);
  addtoclosure(closure2606, var_unused);
  struct UserObject *uo2606 = (struct UserObject*)obj2304;
  uo2606->data[14] = (Object)closure2606;
  Method *meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_2606 = addmethod2pos(obj2304, "findPositionForAdd(1)", &meth_collectionsPrelude_findPositionForAdd_40_1_41_2606, 14);
  int argcv_meth_collectionsPrelude_findPositionForAdd_40_1_41_2606[] = {1};
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_2606->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPositionForAdd_40_1_41_2606);
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_2606->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_2606->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_2606->definitionLine = 1306;
// method "asString"
  struct UserObject *uo2673 = (struct UserObject*)obj2304;
  uo2673->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString2673 = addmethod2pos(obj2304, "asString", &meth_collectionsPrelude_asString2673, 15);
  int argcv_meth_collectionsPrelude_asString2673[] = {0};
  meth_meth_collectionsPrelude_asString2673->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString2673);
  meth_meth_collectionsPrelude_asString2673->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString2673->definitionLine = 1329;
// method "asDebugString"
  struct UserObject *uo2698 = (struct UserObject*)obj2304;
  uo2698->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString2698 = addmethod2pos(obj2304, "asDebugString", &meth_collectionsPrelude_asDebugString2698, 16);
  int argcv_meth_collectionsPrelude_asDebugString2698[] = {0};
  meth_meth_collectionsPrelude_asDebugString2698->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString2698);
  meth_meth_collectionsPrelude_asDebugString2698->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString2698->definitionLine = 1335;
// method "extend(_)"
  struct UserObject *uo2723 = (struct UserObject*)obj2304;
  uo2723->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_extend_40_1_41_2723 = addmethod2pos(obj2304, "extend(1)", &meth_collectionsPrelude_extend_40_1_41_2723, 17);
  int argcv_meth_collectionsPrelude_extend_40_1_41_2723[] = {1};
  meth_meth_collectionsPrelude_extend_40_1_41_2723->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_extend_40_1_41_2723);
  meth_meth_collectionsPrelude_extend_40_1_41_2723->definitionModule = modulename;
  meth_meth_collectionsPrelude_extend_40_1_41_2723->definitionLine = 1341;
// method "do(_)"
  block_savedest(obj2304);
  Object closure2731 = createclosure(2, "do(1)");
  setclosureframe(closure2731, stackframe);
  addtoclosure(closure2731, var_removed);
  addtoclosure(closure2731, var_unused);
  struct UserObject *uo2731 = (struct UserObject*)obj2304;
  uo2731->data[18] = (Object)closure2731;
  Method *meth_meth_collectionsPrelude_do_40_1_41_2731 = addmethod2pos(obj2304, "do(1)", &meth_collectionsPrelude_do_40_1_41_2731, 18);
  int argcv_meth_collectionsPrelude_do_40_1_41_2731[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_2731->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_2731);
  meth_meth_collectionsPrelude_do_40_1_41_2731->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_2731->definitionLine = 1346;
// method "iterator"
  block_savedest(obj2304);
  Object closure2774 = createclosure(4, "iterator");
  setclosureframe(closure2774, stackframe);
  addtoclosure(closure2774, var_ConcurrentModification);
  addtoclosure(closure2774, var_IteratorExhausted);
  addtoclosure(closure2774, var_removed);
  addtoclosure(closure2774, var_unused);
  struct UserObject *uo2774 = (struct UserObject*)obj2304;
  uo2774->data[19] = (Object)closure2774;
  Method *meth_meth_collectionsPrelude_iterator2774 = addmethod2pos(obj2304, "iterator", &meth_collectionsPrelude_iterator2774, 19);
  int argcv_meth_collectionsPrelude_iterator2774[] = {0};
  meth_meth_collectionsPrelude_iterator2774->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator2774);
  meth_meth_collectionsPrelude_iterator2774->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator2774->definitionLine = 1359;
  block_savedest(obj2304);
  Object closure2883 = createclosure(4, "iterator$object(1)");
  setclosureframe(closure2883, stackframe);
  addtoclosure(closure2883, var_ConcurrentModification);
  addtoclosure(closure2883, var_IteratorExhausted);
  addtoclosure(closure2883, var_removed);
  addtoclosure(closure2883, var_unused);
  Method *meth_meth_collectionsPrelude_iterator2774_object = addmethod2pos(obj2304, "iterator$object(1)", &meth_collectionsPrelude_iterator2774_object, 19);
  meth_meth_collectionsPrelude_iterator2774_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator2774_object->definitionLine = 1359;
// method "expand"
  block_savedest(obj2304);
  Object closure2884 = createclosure(3, "expand");
  setclosureframe(closure2884, stackframe);
  addtoclosure(closure2884, var__prelude);
  addtoclosure(closure2884, var_unused);
  addtoclosure(closure2884, var_removed);
  struct UserObject *uo2884 = (struct UserObject*)obj2304;
  uo2884->data[20] = (Object)closure2884;
  Method *meth_meth_collectionsPrelude_expand2884 = addmethod2pos(obj2304, "expand", &meth_collectionsPrelude_expand2884, 20);
  int argcv_meth_collectionsPrelude_expand2884[] = {0};
  meth_meth_collectionsPrelude_expand2884->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_expand2884);
  meth_meth_collectionsPrelude_expand2884->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_expand2884->definitionModule = modulename;
  meth_meth_collectionsPrelude_expand2884->definitionLine = 1385;
// method "==(_)"
  block_savedest(obj2304);
  Object closure2958 = createclosure(1, "==(1)");
  setclosureframe(closure2958, stackframe);
  addtoclosure(closure2958, var_Iterable);
  struct UserObject *uo2958 = (struct UserObject*)obj2304;
  uo2958->data[21] = (Object)closure2958;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_2958 = addmethod2pos(obj2304, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_2958, 21);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_2958[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_2958->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_2958);
  meth_meth_collectionsPrelude__61__61__40_1_41_2958->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_2958->definitionLine = 1400;
// method "copy"
  struct UserObject *uo2985 = (struct UserObject*)obj2304;
  uo2985->data[22] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy2985 = addmethod2pos(obj2304, "copy", &meth_collectionsPrelude_copy2985, 22);
  int argcv_meth_collectionsPrelude_copy2985[] = {0};
  meth_meth_collectionsPrelude_copy2985->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy2985);
  meth_meth_collectionsPrelude_copy2985->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy2985->definitionLine = 1414;
// method "++(_)"
  struct UserObject *uo2990 = (struct UserObject*)obj2304;
  uo2990->data[23] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_2990 = addmethod2pos(obj2304, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_2990, 23);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_2990[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_2990->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_2990);
  meth_meth_collectionsPrelude__43__43__40_1_41_2990->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_2990->definitionLine = 1417;
// method "--(_)"
  struct UserObject *uo2995 = (struct UserObject*)obj2304;
  uo2995->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude__45__45__40_1_41_2995 = addmethod2pos(obj2304, "--(1)", &meth_collectionsPrelude__45__45__40_1_41_2995, 24);
  int argcv_meth_collectionsPrelude__45__45__40_1_41_2995[] = {1};
  meth_meth_collectionsPrelude__45__45__40_1_41_2995->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__45__45__40_1_41_2995);
  meth_meth_collectionsPrelude__45__45__40_1_41_2995->definitionModule = modulename;
  meth_meth_collectionsPrelude__45__45__40_1_41_2995->definitionLine = 1421;
// method "**(_)"
  struct UserObject *uo3016 = (struct UserObject*)obj2304;
  uo3016->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude__42__42__40_1_41_3016 = addmethod2pos(obj2304, "**(1)", &meth_collectionsPrelude__42__42__40_1_41_3016, 25);
  int argcv_meth_collectionsPrelude__42__42__40_1_41_3016[] = {1};
  meth_meth_collectionsPrelude__42__42__40_1_41_3016->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__42__42__40_1_41_3016);
  meth_meth_collectionsPrelude__42__42__40_1_41_3016->definitionModule = modulename;
  meth_meth_collectionsPrelude__42__42__40_1_41_3016->definitionLine = 1431;
// method "isSubset(_)"
  struct UserObject *uo3026 = (struct UserObject*)obj2304;
  uo3026->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isSubset_40_1_41_3026 = addmethod2pos(obj2304, "isSubset(1)", &meth_collectionsPrelude_isSubset_40_1_41_3026, 26);
  int argcv_meth_collectionsPrelude_isSubset_40_1_41_3026[] = {1};
  meth_meth_collectionsPrelude_isSubset_40_1_41_3026->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isSubset_40_1_41_3026);
  meth_meth_collectionsPrelude_isSubset_40_1_41_3026->definitionModule = modulename;
  meth_meth_collectionsPrelude_isSubset_40_1_41_3026->definitionLine = 1435;
// method "isSuperset(_)"
  struct UserObject *uo3039 = (struct UserObject*)obj2304;
  uo3039->data[27] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isSuperset_40_1_41_3039 = addmethod2pos(obj2304, "isSuperset(1)", &meth_collectionsPrelude_isSuperset_40_1_41_3039, 27);
  int argcv_meth_collectionsPrelude_isSuperset_40_1_41_3039[] = {1};
  meth_meth_collectionsPrelude_isSuperset_40_1_41_3039->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isSuperset_40_1_41_3039);
  meth_meth_collectionsPrelude_isSuperset_40_1_41_3039->definitionModule = modulename;
  meth_meth_collectionsPrelude_isSuperset_40_1_41_3039->definitionLine = 1442;
// method "into(_)"
  struct UserObject *uo3052 = (struct UserObject*)obj2304;
  uo3052->data[28] = emptyclosure;
  Method *meth_meth_collectionsPrelude_into_40_1_41_3052 = addmethod2pos(obj2304, "into(1)", &meth_collectionsPrelude_into_40_1_41_3052, 28);
  int argcv_meth_collectionsPrelude_into_40_1_41_3052[] = {1};
  meth_meth_collectionsPrelude_into_40_1_41_3052->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_into_40_1_41_3052);
  meth_meth_collectionsPrelude_into_40_1_41_3052->definitionModule = modulename;
  meth_meth_collectionsPrelude_into_40_1_41_3052->definitionLine = 1448;
  sourceObject = obj2304;
// Begin line 1188
  setline(1188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3060 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_collection (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3061 = callmethodflags(*var_collection, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3060);
// compiled call node returning call3061 (depth = 2)
  struct UserObject *obj2304_uo = (struct UserObject *)obj2304;
  obj2304_uo->super = call3061;
  sourceObject = obj2304;
// Begin line 1189
  setline(1189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num3062 = alloc_Float64(0);
// compiled num node returning num3062 (depth = 2)
  adddatum2(obj2304, num3062, 1);
  sourceObject = obj2304;
// Begin line 1190
  setline(1190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3063 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cap (depth = 3)
  gc_frame_newslot(*var_cap);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3064 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__prelude (depth = 4)
  Object call3065 = callmethodflags(*var__prelude, "primitiveArray", 0, partcv, params, 0);
  gc_frame_end(callframe3064);
// compiled member node returning call3065 (depth = 3)
  params[0] = *var_cap;
  partcv[0] = 1;
  Object call3066 = callmethodflags(call3065, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3063);
// compiled call node returning call3066 (depth = 2)
  adddatum2(obj2304, call3066, 2);
  sourceObject = obj2304;
// Begin line 1191
  setline(1191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num3067 = alloc_Float64(0);
// compiled num node returning num3067 (depth = 2)
  adddatum2(obj2304, num3067, 3);
  sourceObject = obj2304;
// Begin line 1192
  setline(1192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3068 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3069 = alloc_Block(NULL, NULL, "collectionsPrelude", 1192);
  gc_frame_newslot(block3069);
// method "_apply(_)"
  block_savedest(block3069);
  Object closure3070 = createclosure(2, "_apply(1)");
  setclosureframe(closure3070, stackframe);
  addtoclosure(closure3070, var_unused);
  addtoclosure(closure3070, selfslot);
  struct UserObject *uo3070 = (struct UserObject*)block3069;
  uo3070->data[0] = (Object)closure3070;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3070 = addmethod2pos(block3069, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3070, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3070[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3070->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3070);
  meth_meth_collectionsPrelude__apply_40_1_41_3070->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3070->definitionLine = 1963;
// compiled block node returning block3069 (depth = 3)
  gc_frame_newslot(block3069);
// call case 6: other requests
// Begin line 1192
  setline(1192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3078 = alloc_Float64(1);
// compiled num node returning num3078 (depth = 5)
  int op_slot_right_3077 = gc_frame_newslot(num3078);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cap (depth = 5)
  int op_slot_left_3077 = gc_frame_newslot(*var_cap);
  params[0] = num3078;
  partcv[0] = 1;
  Object diff3080 = callmethod(*var_cap, "-(1)", 1, partcv, params);
// compiled op node returning diff3080 (depth = 4)
  int op_slot_right_3076 = gc_frame_newslot(diff3080);
// starting to compile num node (depth = 4)
  Object num3082 = alloc_Float64(0);
// compiled num node returning num3082 (depth = 4)
  int op_slot_left_3076 = gc_frame_newslot(num3082);
  params[0] = diff3080;
  partcv[0] = 1;
  Object opresult3083 = callmethod(num3082, "..(1)", 1, partcv, params);
// compiled op node returning opresult3083 (depth = 3)
  params[0] = block3069;
  partcv[0] = 1;
  Object call3084 = callmethodflags(opresult3083, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3068);
// compiled call node returning call3084 (depth = 2)
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  objclass2304 = obj2304->class;
  objclass2304->definitionModule = modulename;
  objclass2304->definitionLine = 1187;
  (*(struct UserObject *)self).data[0] = lowerouter2304;
  self = oldself2304;
  selfslot = oldselfslot2304;
  stackframe = oldstackframe2304;
  gc_frame_end(frame);
  return obj2304;
}
Object meth_collectionsPrelude_ofCapacity_40_1_41_2303_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ofCapacity(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method ofCapacity(_)");
  Object params[1];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object *var_ConcurrentModification = getfromclosure(closure, 3);
  Object *var_IteratorExhausted = getfromclosure(closure, 4);
  Object *var__prelude = getfromclosure(closure, 5);
  Object *var_Iterable = getfromclosure(closure, 6);
  Object *var_collection = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ofCapacity(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cap = &(stackframe->slots[0]);
  *var_cap = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ofCapacity(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2304 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2304 = alloc_userobj2(33,31, objclass2304);
  gc_frame_newslot(obj2304);
if (objclass2304 == NULL) {
  glfree(obj2304->class->name);
  obj2304->class->name = "set.ofCapacity(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2304, self, 0);
  addmethodreal(obj2304,"outer", &reader_collectionsPrelude_outer_2305);
  Object oldself2304 = self;
  struct StackFrameObject *oldstackframe2304 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2304);
  gc_frame_newslot((Object)stackframe);
  self = obj2304;
  Object *oldselfslot2304 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2304 = (*(struct UserObject *)self).data[0], lowerouter2304 = thisouter2304;
  if (inheritingObject2304) {
    struct UserObject *inho2304 = (struct UserObject *)inheritingObject2304;
    while (inho2304->super != GraceDefaultObject) inho2304 = (struct UserObject *)inho2304->super;
    inho2304->super = obj2304;
    self = inheritingObject2304;
    *selfslot = self;
    lowerouter2304 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2304;
  }
if (objclass2304 == NULL) {
  Method *reader2306 = addmethodrealflags(obj2304, "mods", &reader_collectionsPrelude_mods_2306, 0);
  Method *writer2306 = addmethodrealflags(obj2304, "mods:=(1)", &writer_collectionsPrelude_mods_2306, MFLAG_CONFIDENTIAL);
  reader2306->definitionModule = modulename;
  writer2306->definitionModule = modulename;
  reader2306->definitionLine = 1189;
  writer2306->definitionLine = 1189;
}
obj2304->flags |= OFLAG_MUTABLE;
adddatum2(obj2304, alloc_Undefined(), 1);
if (objclass2304 == NULL) {
  Method *reader2307 = addmethodrealflags(obj2304, "inner", &reader_collectionsPrelude_inner_2307, MFLAG_CONFIDENTIAL);
  Method *writer2307 = addmethodrealflags(obj2304, "inner:=(1)", &writer_collectionsPrelude_inner_2307, MFLAG_CONFIDENTIAL);
  reader2307->definitionModule = modulename;
  writer2307->definitionModule = modulename;
  reader2307->definitionLine = 1190;
  writer2307->definitionLine = 1190;
}
obj2304->flags |= OFLAG_MUTABLE;
adddatum2(obj2304, alloc_Undefined(), 2);
if (objclass2304 == NULL) {
  Method *reader2308 = addmethodrealflags(obj2304, "size", &reader_collectionsPrelude_size_2308, 0);
  Method *writer2308 = addmethodrealflags(obj2304, "size:=(1)", &writer_collectionsPrelude_size_2308, MFLAG_CONFIDENTIAL);
  reader2308->definitionModule = modulename;
  writer2308->definitionModule = modulename;
  reader2308->definitionLine = 1191;
  writer2308->definitionLine = 1191;
}
obj2304->flags |= OFLAG_MUTABLE;
adddatum2(obj2304, alloc_Undefined(), 3);
// method "addAll(_)"
  struct UserObject *uo2309 = (struct UserObject*)obj2304;
  uo2309->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAll_40_1_41_2309 = addmethod2pos(obj2304, "addAll(1)", &meth_collectionsPrelude_addAll_40_1_41_2309, 4);
  int argcv_meth_collectionsPrelude_addAll_40_1_41_2309[] = {1};
  meth_meth_collectionsPrelude_addAll_40_1_41_2309->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAll_40_1_41_2309);
  meth_meth_collectionsPrelude_addAll_40_1_41_2309->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAll_40_1_41_2309->definitionLine = 1196;
// method "add(_)"
  struct UserObject *uo2358 = (struct UserObject*)obj2304;
  uo2358->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_add_40_1_41_2358 = addmethod2pos(obj2304, "add(1)", &meth_collectionsPrelude_add_40_1_41_2358, 5);
  int argcv_meth_collectionsPrelude_add_40_1_41_2358[] = {1};
  meth_meth_collectionsPrelude_add_40_1_41_2358->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add_40_1_41_2358);
  meth_meth_collectionsPrelude_add_40_1_41_2358->definitionModule = modulename;
  meth_meth_collectionsPrelude_add_40_1_41_2358->definitionLine = 1211;
// method "removeAll(_)"
  block_savedest(obj2304);
  Object closure2402 = createclosure(1, "removeAll(1)");
  setclosureframe(closure2402, stackframe);
  addtoclosure(closure2402, var_NoSuchObject);
  struct UserObject *uo2402 = (struct UserObject*)obj2304;
  uo2402->data[6] = (Object)closure2402;
  Method *meth_meth_collectionsPrelude_removeAll_40_1_41_2402 = addmethod2pos(obj2304, "removeAll(1)", &meth_collectionsPrelude_removeAll_40_1_41_2402, 6);
  int argcv_meth_collectionsPrelude_removeAll_40_1_41_2402[] = {1};
  meth_meth_collectionsPrelude_removeAll_40_1_41_2402->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAll_40_1_41_2402);
  meth_meth_collectionsPrelude_removeAll_40_1_41_2402->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40_1_41_2402->definitionLine = 1224;
// method "removeAll(_)ifAbsent(_)"
  block_savedest(obj2304);
  Object closure2423 = createclosure(1, "removeAll(1)ifAbsent(1)");
  setclosureframe(closure2423, stackframe);
  addtoclosure(closure2423, var_removed);
  struct UserObject *uo2423 = (struct UserObject*)obj2304;
  uo2423->data[7] = (Object)closure2423;
  Method *meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2423 = addmethod2pos(obj2304, "removeAll(1)ifAbsent(1)", &meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2423, 7);
  int argcv_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2423[] = {1, 1};
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2423->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2423);
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2423->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40_1_41_ifAbsent_40_1_41_2423->definitionLine = 1232;
// method "remove(_)ifAbsent(_)"
  block_savedest(obj2304);
  Object closure2461 = createclosure(1, "remove(1)ifAbsent(1)");
  setclosureframe(closure2461, stackframe);
  addtoclosure(closure2461, var_removed);
  struct UserObject *uo2461 = (struct UserObject*)obj2304;
  uo2461->data[8] = (Object)closure2461;
  Method *meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2461 = addmethod2pos(obj2304, "remove(1)ifAbsent(1)", &meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2461, 8);
  int argcv_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2461[] = {1, 1};
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2461->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2461);
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2461->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40_1_41_ifAbsent_40_1_41_2461->definitionLine = 1246;
// method "remove(_)"
  block_savedest(obj2304);
  Object closure2494 = createclosure(1, "remove(1)");
  setclosureframe(closure2494, stackframe);
  addtoclosure(closure2494, var_NoSuchObject);
  struct UserObject *uo2494 = (struct UserObject*)obj2304;
  uo2494->data[9] = (Object)closure2494;
  Method *meth_meth_collectionsPrelude_remove_40_1_41_2494 = addmethod2pos(obj2304, "remove(1)", &meth_collectionsPrelude_remove_40_1_41_2494, 9);
  int argcv_meth_collectionsPrelude_remove_40_1_41_2494[] = {1};
  meth_meth_collectionsPrelude_remove_40_1_41_2494->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_remove_40_1_41_2494);
  meth_meth_collectionsPrelude_remove_40_1_41_2494->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40_1_41_2494->definitionLine = 1258;
// method "contains(_)"
  struct UserObject *uo2510 = (struct UserObject*)obj2304;
  uo2510->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_2510 = addmethod2pos(obj2304, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_2510, 10);
  int argcv_meth_collectionsPrelude_contains_40_1_41_2510[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_2510->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_2510);
  meth_meth_collectionsPrelude_contains_40_1_41_2510->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_2510->definitionLine = 1265;
// method "includes(_)"
  struct UserObject *uo2523 = (struct UserObject*)obj2304;
  uo2523->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_includes_40_1_41_2523 = addmethod2pos(obj2304, "includes(1)", &meth_collectionsPrelude_includes_40_1_41_2523, 11);
  int argcv_meth_collectionsPrelude_includes_40_1_41_2523[] = {1};
  meth_meth_collectionsPrelude_includes_40_1_41_2523->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_includes_40_1_41_2523);
  meth_meth_collectionsPrelude_includes_40_1_41_2523->definitionModule = modulename;
  meth_meth_collectionsPrelude_includes_40_1_41_2523->definitionLine = 1272;
// method "find(_)ifNone(_)"
  struct UserObject *uo2534 = (struct UserObject*)obj2304;
  uo2534->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2534 = addmethod2pos(obj2304, "find(1)ifNone(1)", &meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2534, 12);
  int argcv_meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2534[] = {1, 1};
  meth_meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2534->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2534);
  meth_meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2534->definitionModule = modulename;
  meth_meth_collectionsPrelude_find_40_1_41_ifNone_40_1_41_2534->definitionLine = 1278;
// method "findPosition(_)"
  block_savedest(obj2304);
  Object closure2545 = createclosure(1, "findPosition(1)");
  setclosureframe(closure2545, stackframe);
  addtoclosure(closure2545, var_unused);
  struct UserObject *uo2545 = (struct UserObject*)obj2304;
  uo2545->data[13] = (Object)closure2545;
  Method *meth_meth_collectionsPrelude_findPosition_40_1_41_2545 = addmethod2pos(obj2304, "findPosition(1)", &meth_collectionsPrelude_findPosition_40_1_41_2545, 13);
  int argcv_meth_collectionsPrelude_findPosition_40_1_41_2545[] = {1};
  meth_meth_collectionsPrelude_findPosition_40_1_41_2545->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPosition_40_1_41_2545);
  meth_meth_collectionsPrelude_findPosition_40_1_41_2545->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPosition_40_1_41_2545->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPosition_40_1_41_2545->definitionLine = 1284;
// method "findPositionForAdd(_)"
  block_savedest(obj2304);
  Object closure2606 = createclosure(2, "findPositionForAdd(1)");
  setclosureframe(closure2606, stackframe);
  addtoclosure(closure2606, var_removed);
  addtoclosure(closure2606, var_unused);
  struct UserObject *uo2606 = (struct UserObject*)obj2304;
  uo2606->data[14] = (Object)closure2606;
  Method *meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_2606 = addmethod2pos(obj2304, "findPositionForAdd(1)", &meth_collectionsPrelude_findPositionForAdd_40_1_41_2606, 14);
  int argcv_meth_collectionsPrelude_findPositionForAdd_40_1_41_2606[] = {1};
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_2606->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPositionForAdd_40_1_41_2606);
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_2606->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_2606->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_2606->definitionLine = 1306;
// method "asString"
  struct UserObject *uo2673 = (struct UserObject*)obj2304;
  uo2673->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString2673 = addmethod2pos(obj2304, "asString", &meth_collectionsPrelude_asString2673, 15);
  int argcv_meth_collectionsPrelude_asString2673[] = {0};
  meth_meth_collectionsPrelude_asString2673->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString2673);
  meth_meth_collectionsPrelude_asString2673->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString2673->definitionLine = 1329;
// method "asDebugString"
  struct UserObject *uo2698 = (struct UserObject*)obj2304;
  uo2698->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString2698 = addmethod2pos(obj2304, "asDebugString", &meth_collectionsPrelude_asDebugString2698, 16);
  int argcv_meth_collectionsPrelude_asDebugString2698[] = {0};
  meth_meth_collectionsPrelude_asDebugString2698->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString2698);
  meth_meth_collectionsPrelude_asDebugString2698->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString2698->definitionLine = 1335;
// method "extend(_)"
  struct UserObject *uo2723 = (struct UserObject*)obj2304;
  uo2723->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_extend_40_1_41_2723 = addmethod2pos(obj2304, "extend(1)", &meth_collectionsPrelude_extend_40_1_41_2723, 17);
  int argcv_meth_collectionsPrelude_extend_40_1_41_2723[] = {1};
  meth_meth_collectionsPrelude_extend_40_1_41_2723->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_extend_40_1_41_2723);
  meth_meth_collectionsPrelude_extend_40_1_41_2723->definitionModule = modulename;
  meth_meth_collectionsPrelude_extend_40_1_41_2723->definitionLine = 1341;
// method "do(_)"
  block_savedest(obj2304);
  Object closure2731 = createclosure(2, "do(1)");
  setclosureframe(closure2731, stackframe);
  addtoclosure(closure2731, var_removed);
  addtoclosure(closure2731, var_unused);
  struct UserObject *uo2731 = (struct UserObject*)obj2304;
  uo2731->data[18] = (Object)closure2731;
  Method *meth_meth_collectionsPrelude_do_40_1_41_2731 = addmethod2pos(obj2304, "do(1)", &meth_collectionsPrelude_do_40_1_41_2731, 18);
  int argcv_meth_collectionsPrelude_do_40_1_41_2731[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_2731->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_2731);
  meth_meth_collectionsPrelude_do_40_1_41_2731->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_2731->definitionLine = 1346;
// method "iterator"
  block_savedest(obj2304);
  Object closure2774 = createclosure(4, "iterator");
  setclosureframe(closure2774, stackframe);
  addtoclosure(closure2774, var_ConcurrentModification);
  addtoclosure(closure2774, var_IteratorExhausted);
  addtoclosure(closure2774, var_removed);
  addtoclosure(closure2774, var_unused);
  struct UserObject *uo2774 = (struct UserObject*)obj2304;
  uo2774->data[19] = (Object)closure2774;
  Method *meth_meth_collectionsPrelude_iterator2774 = addmethod2pos(obj2304, "iterator", &meth_collectionsPrelude_iterator2774, 19);
  int argcv_meth_collectionsPrelude_iterator2774[] = {0};
  meth_meth_collectionsPrelude_iterator2774->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator2774);
  meth_meth_collectionsPrelude_iterator2774->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator2774->definitionLine = 1359;
  block_savedest(obj2304);
  Object closure2883 = createclosure(4, "iterator$object(1)");
  setclosureframe(closure2883, stackframe);
  addtoclosure(closure2883, var_ConcurrentModification);
  addtoclosure(closure2883, var_IteratorExhausted);
  addtoclosure(closure2883, var_removed);
  addtoclosure(closure2883, var_unused);
  Method *meth_meth_collectionsPrelude_iterator2774_object = addmethod2pos(obj2304, "iterator$object(1)", &meth_collectionsPrelude_iterator2774_object, 19);
  meth_meth_collectionsPrelude_iterator2774_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator2774_object->definitionLine = 1359;
// method "expand"
  block_savedest(obj2304);
  Object closure2884 = createclosure(3, "expand");
  setclosureframe(closure2884, stackframe);
  addtoclosure(closure2884, var__prelude);
  addtoclosure(closure2884, var_unused);
  addtoclosure(closure2884, var_removed);
  struct UserObject *uo2884 = (struct UserObject*)obj2304;
  uo2884->data[20] = (Object)closure2884;
  Method *meth_meth_collectionsPrelude_expand2884 = addmethod2pos(obj2304, "expand", &meth_collectionsPrelude_expand2884, 20);
  int argcv_meth_collectionsPrelude_expand2884[] = {0};
  meth_meth_collectionsPrelude_expand2884->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_expand2884);
  meth_meth_collectionsPrelude_expand2884->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_expand2884->definitionModule = modulename;
  meth_meth_collectionsPrelude_expand2884->definitionLine = 1385;
// method "==(_)"
  block_savedest(obj2304);
  Object closure2958 = createclosure(1, "==(1)");
  setclosureframe(closure2958, stackframe);
  addtoclosure(closure2958, var_Iterable);
  struct UserObject *uo2958 = (struct UserObject*)obj2304;
  uo2958->data[21] = (Object)closure2958;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_2958 = addmethod2pos(obj2304, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_2958, 21);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_2958[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_2958->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_2958);
  meth_meth_collectionsPrelude__61__61__40_1_41_2958->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_2958->definitionLine = 1400;
// method "copy"
  struct UserObject *uo2985 = (struct UserObject*)obj2304;
  uo2985->data[22] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy2985 = addmethod2pos(obj2304, "copy", &meth_collectionsPrelude_copy2985, 22);
  int argcv_meth_collectionsPrelude_copy2985[] = {0};
  meth_meth_collectionsPrelude_copy2985->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy2985);
  meth_meth_collectionsPrelude_copy2985->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy2985->definitionLine = 1414;
// method "++(_)"
  struct UserObject *uo2990 = (struct UserObject*)obj2304;
  uo2990->data[23] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_2990 = addmethod2pos(obj2304, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_2990, 23);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_2990[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_2990->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_2990);
  meth_meth_collectionsPrelude__43__43__40_1_41_2990->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_2990->definitionLine = 1417;
// method "--(_)"
  struct UserObject *uo2995 = (struct UserObject*)obj2304;
  uo2995->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude__45__45__40_1_41_2995 = addmethod2pos(obj2304, "--(1)", &meth_collectionsPrelude__45__45__40_1_41_2995, 24);
  int argcv_meth_collectionsPrelude__45__45__40_1_41_2995[] = {1};
  meth_meth_collectionsPrelude__45__45__40_1_41_2995->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__45__45__40_1_41_2995);
  meth_meth_collectionsPrelude__45__45__40_1_41_2995->definitionModule = modulename;
  meth_meth_collectionsPrelude__45__45__40_1_41_2995->definitionLine = 1421;
// method "**(_)"
  struct UserObject *uo3016 = (struct UserObject*)obj2304;
  uo3016->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude__42__42__40_1_41_3016 = addmethod2pos(obj2304, "**(1)", &meth_collectionsPrelude__42__42__40_1_41_3016, 25);
  int argcv_meth_collectionsPrelude__42__42__40_1_41_3016[] = {1};
  meth_meth_collectionsPrelude__42__42__40_1_41_3016->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__42__42__40_1_41_3016);
  meth_meth_collectionsPrelude__42__42__40_1_41_3016->definitionModule = modulename;
  meth_meth_collectionsPrelude__42__42__40_1_41_3016->definitionLine = 1431;
// method "isSubset(_)"
  struct UserObject *uo3026 = (struct UserObject*)obj2304;
  uo3026->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isSubset_40_1_41_3026 = addmethod2pos(obj2304, "isSubset(1)", &meth_collectionsPrelude_isSubset_40_1_41_3026, 26);
  int argcv_meth_collectionsPrelude_isSubset_40_1_41_3026[] = {1};
  meth_meth_collectionsPrelude_isSubset_40_1_41_3026->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isSubset_40_1_41_3026);
  meth_meth_collectionsPrelude_isSubset_40_1_41_3026->definitionModule = modulename;
  meth_meth_collectionsPrelude_isSubset_40_1_41_3026->definitionLine = 1435;
// method "isSuperset(_)"
  struct UserObject *uo3039 = (struct UserObject*)obj2304;
  uo3039->data[27] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isSuperset_40_1_41_3039 = addmethod2pos(obj2304, "isSuperset(1)", &meth_collectionsPrelude_isSuperset_40_1_41_3039, 27);
  int argcv_meth_collectionsPrelude_isSuperset_40_1_41_3039[] = {1};
  meth_meth_collectionsPrelude_isSuperset_40_1_41_3039->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isSuperset_40_1_41_3039);
  meth_meth_collectionsPrelude_isSuperset_40_1_41_3039->definitionModule = modulename;
  meth_meth_collectionsPrelude_isSuperset_40_1_41_3039->definitionLine = 1442;
// method "into(_)"
  struct UserObject *uo3052 = (struct UserObject*)obj2304;
  uo3052->data[28] = emptyclosure;
  Method *meth_meth_collectionsPrelude_into_40_1_41_3052 = addmethod2pos(obj2304, "into(1)", &meth_collectionsPrelude_into_40_1_41_3052, 28);
  int argcv_meth_collectionsPrelude_into_40_1_41_3052[] = {1};
  meth_meth_collectionsPrelude_into_40_1_41_3052->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_into_40_1_41_3052);
  meth_meth_collectionsPrelude_into_40_1_41_3052->definitionModule = modulename;
  meth_meth_collectionsPrelude_into_40_1_41_3052->definitionLine = 1448;
  sourceObject = obj2304;
// Begin line 1188
  setline(1188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3060 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_collection (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3061 = callmethodflags(*var_collection, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3060);
// compiled call node returning call3061 (depth = 2)
  struct UserObject *obj2304_uo = (struct UserObject *)obj2304;
  obj2304_uo->super = call3061;
  sourceObject = obj2304;
// Begin line 1189
  setline(1189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num3062 = alloc_Float64(0);
// compiled num node returning num3062 (depth = 2)
  adddatum2(obj2304, num3062, 1);
  sourceObject = obj2304;
// Begin line 1190
  setline(1190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3063 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cap (depth = 3)
  gc_frame_newslot(*var_cap);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3064 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__prelude (depth = 4)
  Object call3065 = callmethodflags(*var__prelude, "primitiveArray", 0, partcv, params, 0);
  gc_frame_end(callframe3064);
// compiled member node returning call3065 (depth = 3)
  params[0] = *var_cap;
  partcv[0] = 1;
  Object call3066 = callmethodflags(call3065, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3063);
// compiled call node returning call3066 (depth = 2)
  adddatum2(obj2304, call3066, 2);
  sourceObject = obj2304;
// Begin line 1191
  setline(1191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num3067 = alloc_Float64(0);
// compiled num node returning num3067 (depth = 2)
  adddatum2(obj2304, num3067, 3);
  sourceObject = obj2304;
// Begin line 1192
  setline(1192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3068 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3069 = alloc_Block(NULL, NULL, "collectionsPrelude", 1192);
  gc_frame_newslot(block3069);
// method "_apply(_)"
  block_savedest(block3069);
  Object closure3070 = createclosure(2, "_apply(1)");
  setclosureframe(closure3070, stackframe);
  addtoclosure(closure3070, var_unused);
  addtoclosure(closure3070, selfslot);
  struct UserObject *uo3070 = (struct UserObject*)block3069;
  uo3070->data[0] = (Object)closure3070;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3070 = addmethod2pos(block3069, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3070, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3070[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3070->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3070);
  meth_meth_collectionsPrelude__apply_40_1_41_3070->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3070->definitionLine = 1963;
// compiled block node returning block3069 (depth = 3)
  gc_frame_newslot(block3069);
// call case 6: other requests
// Begin line 1192
  setline(1192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3078 = alloc_Float64(1);
// compiled num node returning num3078 (depth = 5)
  int op_slot_right_3077 = gc_frame_newslot(num3078);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cap (depth = 5)
  int op_slot_left_3077 = gc_frame_newslot(*var_cap);
  params[0] = num3078;
  partcv[0] = 1;
  Object diff3080 = callmethod(*var_cap, "-(1)", 1, partcv, params);
// compiled op node returning diff3080 (depth = 4)
  int op_slot_right_3076 = gc_frame_newslot(diff3080);
// starting to compile num node (depth = 4)
  Object num3082 = alloc_Float64(0);
// compiled num node returning num3082 (depth = 4)
  int op_slot_left_3076 = gc_frame_newslot(num3082);
  params[0] = diff3080;
  partcv[0] = 1;
  Object opresult3083 = callmethod(num3082, "..(1)", 1, partcv, params);
// compiled op node returning opresult3083 (depth = 3)
  params[0] = block3069;
  partcv[0] = 1;
  Object call3084 = callmethodflags(opresult3083, "do(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3068);
// compiled call node returning call3084 (depth = 2)
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  sourceObject = obj2304;
  objclass2304 = obj2304->class;
  objclass2304->definitionModule = modulename;
  objclass2304->definitionLine = 1187;
  (*(struct UserObject *)self).data[0] = lowerouter2304;
  self = oldself2304;
  selfslot = oldselfslot2304;
  stackframe = oldstackframe2304;
  gc_frame_end(frame);
  return obj2304;
}
Object meth_collectionsPrelude_set2265(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "set");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object *var_ConcurrentModification = getfromclosure(closure, 3);
  Object *var_IteratorExhausted = getfromclosure(closure, 4);
  Object *var__prelude = getfromclosure(closure, 5);
  Object *var_Iterable = getfromclosure(closure, 6);
  Object *var_collection = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2266 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2266 = alloc_userobj2(5,6, objclass2266);
  gc_frame_newslot(obj2266);
if (objclass2266 == NULL) {
  glfree(obj2266->class->name);
  obj2266->class->name = "set";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2266, self, 0);
  addmethodreal(obj2266,"outer", &reader_collectionsPrelude_outer_2267);
  Object oldself2266 = self;
  struct StackFrameObject *oldstackframe2266 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2266);
  gc_frame_newslot((Object)stackframe);
  self = obj2266;
  Object *oldselfslot2266 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2266 = (*(struct UserObject *)self).data[0], lowerouter2266 = thisouter2266;
  if (inheritingObject2266) {
    struct UserObject *inho2266 = (struct UserObject *)inheritingObject2266;
    while (inho2266->super != GraceDefaultObject) inho2266 = (struct UserObject *)inho2266->super;
    inho2266->super = obj2266;
    self = inheritingObject2266;
    *selfslot = self;
    lowerouter2266 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2266;
  }
// method "asString"
  struct UserObject *uo2268 = (struct UserObject*)obj2266;
  uo2268->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString2268 = addmethod2pos(obj2266, "asString", &meth_collectionsPrelude_asString2268, 1);
  int argcv_meth_collectionsPrelude_asString2268[] = {0};
  meth_meth_collectionsPrelude_asString2268->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString2268);
  meth_meth_collectionsPrelude_asString2268->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString2268->definitionLine = 1174;
// method "withAll(_)"
  struct UserObject *uo2270 = (struct UserObject*)obj2266;
  uo2270->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_withAll_40_1_41_2270 = addmethod2pos(obj2266, "withAll(1)", &meth_collectionsPrelude_withAll_40_1_41_2270, 2);
  int argcv_meth_collectionsPrelude_withAll_40_1_41_2270[] = {1};
  meth_meth_collectionsPrelude_withAll_40_1_41_2270->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll_40_1_41_2270);
  meth_meth_collectionsPrelude_withAll_40_1_41_2270->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll_40_1_41_2270->definitionLine = 1176;
// method "empty"
  struct UserObject *uo2299 = (struct UserObject*)obj2266;
  uo2299->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_empty2299 = addmethod2pos(obj2266, "empty", &meth_collectionsPrelude_empty2299, 3);
  int argcv_meth_collectionsPrelude_empty2299[] = {0};
  meth_meth_collectionsPrelude_empty2299->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_empty2299);
  meth_meth_collectionsPrelude_empty2299->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty2299->definitionLine = 1183;
// method "ofCapacity(_)"
  block_savedest(obj2266);
  Object closure2303 = createclosure(8, "ofCapacity(1)");
  setclosureframe(closure2303, stackframe);
  addtoclosure(closure2303, var_NoSuchObject);
  addtoclosure(closure2303, var_removed);
  addtoclosure(closure2303, var_unused);
  addtoclosure(closure2303, var_ConcurrentModification);
  addtoclosure(closure2303, var_IteratorExhausted);
  addtoclosure(closure2303, var__prelude);
  addtoclosure(closure2303, var_Iterable);
  addtoclosure(closure2303, var_collection);
  struct UserObject *uo2303 = (struct UserObject*)obj2266;
  uo2303->data[4] = (Object)closure2303;
  Method *meth_meth_collectionsPrelude_ofCapacity_40_1_41_2303 = addmethod2pos(obj2266, "ofCapacity(1)", &meth_collectionsPrelude_ofCapacity_40_1_41_2303, 4);
  int argcv_meth_collectionsPrelude_ofCapacity_40_1_41_2303[] = {1};
  meth_meth_collectionsPrelude_ofCapacity_40_1_41_2303->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_ofCapacity_40_1_41_2303);
  meth_meth_collectionsPrelude_ofCapacity_40_1_41_2303->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_ofCapacity_40_1_41_2303->definitionModule = modulename;
  meth_meth_collectionsPrelude_ofCapacity_40_1_41_2303->definitionLine = 1187;
  block_savedest(obj2266);
  Object closure3085 = createclosure(8, "ofCapacity(1)$object(1)");
  setclosureframe(closure3085, stackframe);
  addtoclosure(closure3085, var_NoSuchObject);
  addtoclosure(closure3085, var_removed);
  addtoclosure(closure3085, var_unused);
  addtoclosure(closure3085, var_ConcurrentModification);
  addtoclosure(closure3085, var_IteratorExhausted);
  addtoclosure(closure3085, var__prelude);
  addtoclosure(closure3085, var_Iterable);
  addtoclosure(closure3085, var_collection);
  Method *meth_meth_collectionsPrelude_ofCapacity_40_1_41_2303_object = addmethod2pos(obj2266, "ofCapacity(1)$object(1)", &meth_collectionsPrelude_ofCapacity_40_1_41_2303_object, 4);
  meth_meth_collectionsPrelude_ofCapacity_40_1_41_2303_object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_ofCapacity_40_1_41_2303_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_ofCapacity_40_1_41_2303_object->definitionLine = 1187;
  sourceObject = obj2266;
  sourceObject = obj2266;
  sourceObject = obj2266;
  sourceObject = obj2266;
  objclass2266 = obj2266->class;
  objclass2266->definitionModule = modulename;
  objclass2266->definitionLine = 1172;
  (*(struct UserObject *)self).data[0] = lowerouter2266;
  self = oldself2266;
  selfslot = oldselfslot2266;
  stackframe = oldstackframe2266;
  gc_frame_end(frame);
  return obj2266;
}
Object meth_collectionsPrelude_set2265_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "set$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object *var_ConcurrentModification = getfromclosure(closure, 3);
  Object *var_IteratorExhausted = getfromclosure(closure, 4);
  Object *var__prelude = getfromclosure(closure, 5);
  Object *var_Iterable = getfromclosure(closure, 6);
  Object *var_collection = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2266 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2266 = alloc_userobj2(5,6, objclass2266);
  gc_frame_newslot(obj2266);
if (objclass2266 == NULL) {
  glfree(obj2266->class->name);
  obj2266->class->name = "set";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2266, self, 0);
  addmethodreal(obj2266,"outer", &reader_collectionsPrelude_outer_2267);
  Object oldself2266 = self;
  struct StackFrameObject *oldstackframe2266 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2266);
  gc_frame_newslot((Object)stackframe);
  self = obj2266;
  Object *oldselfslot2266 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2266 = (*(struct UserObject *)self).data[0], lowerouter2266 = thisouter2266;
  if (inheritingObject2266) {
    struct UserObject *inho2266 = (struct UserObject *)inheritingObject2266;
    while (inho2266->super != GraceDefaultObject) inho2266 = (struct UserObject *)inho2266->super;
    inho2266->super = obj2266;
    self = inheritingObject2266;
    *selfslot = self;
    lowerouter2266 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2266;
  }
// method "asString"
  struct UserObject *uo2268 = (struct UserObject*)obj2266;
  uo2268->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString2268 = addmethod2pos(obj2266, "asString", &meth_collectionsPrelude_asString2268, 1);
  int argcv_meth_collectionsPrelude_asString2268[] = {0};
  meth_meth_collectionsPrelude_asString2268->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString2268);
  meth_meth_collectionsPrelude_asString2268->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString2268->definitionLine = 1174;
// method "withAll(_)"
  struct UserObject *uo2270 = (struct UserObject*)obj2266;
  uo2270->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_withAll_40_1_41_2270 = addmethod2pos(obj2266, "withAll(1)", &meth_collectionsPrelude_withAll_40_1_41_2270, 2);
  int argcv_meth_collectionsPrelude_withAll_40_1_41_2270[] = {1};
  meth_meth_collectionsPrelude_withAll_40_1_41_2270->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll_40_1_41_2270);
  meth_meth_collectionsPrelude_withAll_40_1_41_2270->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll_40_1_41_2270->definitionLine = 1176;
// method "empty"
  struct UserObject *uo2299 = (struct UserObject*)obj2266;
  uo2299->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_empty2299 = addmethod2pos(obj2266, "empty", &meth_collectionsPrelude_empty2299, 3);
  int argcv_meth_collectionsPrelude_empty2299[] = {0};
  meth_meth_collectionsPrelude_empty2299->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_empty2299);
  meth_meth_collectionsPrelude_empty2299->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty2299->definitionLine = 1183;
// method "ofCapacity(_)"
  block_savedest(obj2266);
  Object closure2303 = createclosure(8, "ofCapacity(1)");
  setclosureframe(closure2303, stackframe);
  addtoclosure(closure2303, var_NoSuchObject);
  addtoclosure(closure2303, var_removed);
  addtoclosure(closure2303, var_unused);
  addtoclosure(closure2303, var_ConcurrentModification);
  addtoclosure(closure2303, var_IteratorExhausted);
  addtoclosure(closure2303, var__prelude);
  addtoclosure(closure2303, var_Iterable);
  addtoclosure(closure2303, var_collection);
  struct UserObject *uo2303 = (struct UserObject*)obj2266;
  uo2303->data[4] = (Object)closure2303;
  Method *meth_meth_collectionsPrelude_ofCapacity_40_1_41_2303 = addmethod2pos(obj2266, "ofCapacity(1)", &meth_collectionsPrelude_ofCapacity_40_1_41_2303, 4);
  int argcv_meth_collectionsPrelude_ofCapacity_40_1_41_2303[] = {1};
  meth_meth_collectionsPrelude_ofCapacity_40_1_41_2303->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_ofCapacity_40_1_41_2303);
  meth_meth_collectionsPrelude_ofCapacity_40_1_41_2303->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_ofCapacity_40_1_41_2303->definitionModule = modulename;
  meth_meth_collectionsPrelude_ofCapacity_40_1_41_2303->definitionLine = 1187;
  block_savedest(obj2266);
  Object closure3085 = createclosure(8, "ofCapacity(1)$object(1)");
  setclosureframe(closure3085, stackframe);
  addtoclosure(closure3085, var_NoSuchObject);
  addtoclosure(closure3085, var_removed);
  addtoclosure(closure3085, var_unused);
  addtoclosure(closure3085, var_ConcurrentModification);
  addtoclosure(closure3085, var_IteratorExhausted);
  addtoclosure(closure3085, var__prelude);
  addtoclosure(closure3085, var_Iterable);
  addtoclosure(closure3085, var_collection);
  Method *meth_meth_collectionsPrelude_ofCapacity_40_1_41_2303_object = addmethod2pos(obj2266, "ofCapacity(1)$object(1)", &meth_collectionsPrelude_ofCapacity_40_1_41_2303_object, 4);
  meth_meth_collectionsPrelude_ofCapacity_40_1_41_2303_object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_ofCapacity_40_1_41_2303_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_ofCapacity_40_1_41_2303_object->definitionLine = 1187;
  sourceObject = obj2266;
  sourceObject = obj2266;
  sourceObject = obj2266;
  sourceObject = obj2266;
  objclass2266 = obj2266->class;
  objclass2266->definitionModule = modulename;
  objclass2266->definitionLine = 1172;
  (*(struct UserObject *)self).data[0] = lowerouter2266;
  self = oldself2266;
  selfslot = oldselfslot2266;
  stackframe = oldstackframe2266;
  gc_frame_end(frame);
  return obj2266;
}
Object meth_collectionsPrelude_asString3090(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1486
  setline(1486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit3091 == NULL) {
    strlit3091 = alloc_String("a dictionary factory");
    gc_root(strlit3091);
  }
// compiled string node returning strlit3091 (depth = 2)
  gc_frame_end(frame);
  return strlit3091;
}
Object meth_collectionsPrelude__apply_40_1_41_3097(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe3098 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  gc_frame_newslot(*var_b);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_b;
  partcv[0] = 1;
  Object call3099 = callmethodflags(*var_result, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3098);
// compiled call node returning call3099 (depth = 4)
  gc_frame_end(frame);
  return call3099;
}
Object meth_collectionsPrelude_withAll_40_1_41_3092(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "withAll(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method withAll(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for withAll(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_initialBindings = &(stackframe->slots[0]);
  *var_initialBindings = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part withAll(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "result");
// Begin line 1489
  setline(1489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe3093 = gc_frame_new();
// call case 4: self request
  Object call3094 = callmethodflags(self, "empty", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3093);
// compiled member node returning call3094 (depth = 3)
  *var_result = call3094;
  if (call3094 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1490
  setline(1490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3095 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_initialBindings (depth = 3)
  gc_frame_newslot(*var_initialBindings);
// starting to compile block node (depth = 3)
  Object block3096 = alloc_Block(NULL, NULL, "collectionsPrelude", 1490);
  gc_frame_newslot(block3096);
// method "_apply(_)"
  block_savedest(block3096);
  Object closure3097 = createclosure(2, "_apply(1)");
  setclosureframe(closure3097, stackframe);
  addtoclosure(closure3097, var_result);
  addtoclosure(closure3097, selfslot);
  struct UserObject *uo3097 = (struct UserObject*)block3096;
  uo3097->data[0] = (Object)closure3097;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3097 = addmethod2pos(block3096, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3097, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3097[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3097->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3097);
  meth_meth_collectionsPrelude__apply_40_1_41_3097->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3097->definitionLine = 1963;
// compiled block node returning block3096 (depth = 3)
  gc_frame_newslot(block3096);
// call case 5: prelude request
  params[0] = *var_initialBindings;
  params[1] = block3096;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3101 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3095);
// compiled call node returning call3101 (depth = 2)
// Begin line 1491
  setline(1491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude_size3108(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1502
  setline(1502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3109 = gc_frame_new();
// call case 4: self request
  Object call3110 = callmethodflags(self, "numBindings", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3109);
// compiled member node returning call3110 (depth = 2)
  gc_frame_end(frame);
  return call3110;
}
Object meth_collectionsPrelude_at_40_1_41_put_40_1_41_3111(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "at(1)put(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)put(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)put(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_binding = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for at(_)put(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_key_39_ = &(stackframe->slots[0]);
  *var_key_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *var_value_39_ = &(stackframe->slots[1]);
  *var_value_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part put(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "t");
// Begin line 1504
  setline(1504);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3112 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3114 = alloc_Float64(1);
// compiled num node returning num3114 (depth = 4)
  int op_slot_right_3113 = gc_frame_newslot(num3114);
// starting to compile member node (depth = 4)
  int callframe3116 = gc_frame_new();
// call case 4: self request
  Object call3117 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3116);
// compiled member node returning call3117 (depth = 4)
  int op_slot_left_3113 = gc_frame_newslot(call3117);
  params[0] = num3114;
  partcv[0] = 1;
  Object sum3118 = callmethod(call3117, "+(1)", 1, partcv, params);
// compiled op node returning sum3118 (depth = 3)
  gc_frame_newslot(sum3118);
// call case 4: self request
  params[0] = sum3118;
  partcv[0] = 1;
  Object call3119 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3112);
// compiled call node returning call3119 (depth = 2)
// Begin line 1505
  setline(1505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3120 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_key_39_ (depth = 4)
  gc_frame_newslot(*var_key_39_);
// call case 4: self request
  params[0] = *var_key_39_;
  partcv[0] = 1;
  Object call3121 = callmethodflags(self, "findPositionForAdd(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3120);
// compiled call node returning call3121 (depth = 3)
  *var_t = call3121;
  if (call3121 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1506
  setline(1506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3125 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3126 = gc_frame_new();
// call case 4: self request
  Object call3127 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3126);
// compiled member node returning call3127 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3128 = callmethodflags(call3127, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3125);
// compiled call node returning call3128 (depth = 5)
  int op_slot_right_3124 = gc_frame_newslot(call3128);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_removed (depth = 5)
  int op_slot_left_3124 = gc_frame_newslot(*var_removed);
  params[0] = call3128;
  partcv[0] = 1;
  Object opresult3130 = callmethod(*var_removed, "==(1)", 1, partcv, params);
// compiled op node returning opresult3130 (depth = 4)
  int op_slot_right_3123 = gc_frame_newslot(opresult3130);
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3133 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3134 = gc_frame_new();
// call case 4: self request
  Object call3135 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3134);
// compiled member node returning call3135 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3136 = callmethodflags(call3135, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3133);
// compiled call node returning call3136 (depth = 5)
  int op_slot_right_3132 = gc_frame_newslot(call3136);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  int op_slot_left_3132 = gc_frame_newslot(*var_unused);
  params[0] = call3136;
  partcv[0] = 1;
  Object opresult3138 = callmethod(*var_unused, "==(1)", 1, partcv, params);
// compiled op node returning opresult3138 (depth = 4)
  int op_slot_left_3123 = gc_frame_newslot(opresult3138);
  params[0] = opresult3130;
  partcv[0] = 1;
  Object opresult3139 = callmethod(opresult3138, "||(1)", 1, partcv, params);
// compiled op node returning opresult3139 (depth = 3)
  Object if3122 = done;
  if (istrue(opresult3139)) {
// Begin line 1507
  setline(1507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3140 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3142 = alloc_Float64(1);
// compiled num node returning num3142 (depth = 5)
  int op_slot_right_3141 = gc_frame_newslot(num3142);
// starting to compile member node (depth = 5)
  int callframe3144 = gc_frame_new();
// call case 4: self request
  Object call3145 = callmethodflags(self, "numBindings", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3144);
// compiled member node returning call3145 (depth = 5)
  int op_slot_left_3141 = gc_frame_newslot(call3145);
  params[0] = num3142;
  partcv[0] = 1;
  Object sum3146 = callmethod(call3145, "+(1)", 1, partcv, params);
// compiled op node returning sum3146 (depth = 4)
  gc_frame_newslot(sum3146);
// call case 4: self request
  params[0] = sum3146;
  partcv[0] = 1;
  Object call3147 = callmethodflags(self, "numBindings:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3140);
// compiled call node returning call3147 (depth = 3)
    gc_frame_newslot(call3147);
    if3122 = call3147;
  } else {
  }
// compiled if node returning if3122 (depth = 2)
// Begin line 1509
  setline(1509);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3148 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  gc_frame_newslot(*var_t);
// starting to compile call node (depth = 3)
  int callframe3149 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_key_39_ (depth = 4)
  gc_frame_newslot(*var_key_39_);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_value_39_ (depth = 4)
  gc_frame_newslot(*var_value_39_);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_binding (depth = 4)
  params[0] = *var_key_39_;
  params[1] = *var_value_39_;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3150 = callmethodflags(*var_binding, "key(1)value(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3149);
// compiled call node returning call3150 (depth = 3)
  gc_frame_newslot(call3150);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3151 = gc_frame_new();
// call case 4: self request
  Object call3152 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3151);
// compiled member node returning call3152 (depth = 3)
  params[0] = *var_t;
  params[1] = call3150;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3153 = callmethodflags(call3152, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3148);
// compiled call node returning call3153 (depth = 2)
// Begin line 1510
  setline(1510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3156 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3157 = gc_frame_new();
// call case 4: self request
  Object call3158 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3157);
// compiled member node returning call3158 (depth = 5)
  Object call3159 = callmethodflags(call3158, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3156);
// compiled member node returning call3159 (depth = 4)
  int op_slot_right_3155 = gc_frame_newslot(call3159);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3162 = alloc_Float64(2);
// compiled num node returning num3162 (depth = 5)
  int op_slot_right_3161 = gc_frame_newslot(num3162);
// starting to compile member node (depth = 5)
  int callframe3164 = gc_frame_new();
// call case 4: self request
  Object call3165 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3164);
// compiled member node returning call3165 (depth = 5)
  int op_slot_left_3161 = gc_frame_newslot(call3165);
  params[0] = num3162;
  partcv[0] = 1;
  Object prod3166 = callmethod(call3165, "*(1)", 1, partcv, params);
// compiled op node returning prod3166 (depth = 4)
  int op_slot_left_3155 = gc_frame_newslot(prod3166);
  params[0] = call3159;
  partcv[0] = 1;
  Object opresult3167 = callmethod(prod3166, ">(1)", 1, partcv, params);
// compiled op node returning opresult3167 (depth = 3)
  Object if3154 = done;
  if (istrue(opresult3167)) {
// starting to compile member node (depth = 3)
  int callframe3168 = gc_frame_new();
// call case 4: self request
  Object call3169 = callmethodflags(self, "expand", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3168);
// compiled member node returning call3169 (depth = 3)
    gc_frame_newslot(call3169);
    if3154 = call3169;
  } else {
  }
// compiled if node returning if3154 (depth = 2)
// Begin line 1511
  setline(1511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_add_40_1_41_3170(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "add(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method add(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for add(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aBinding = &(stackframe->slots[0]);
  *var_aBinding = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part add(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 1514
  setline(1514);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3171 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3173 = alloc_Float64(1);
// compiled num node returning num3173 (depth = 4)
  int op_slot_right_3172 = gc_frame_newslot(num3173);
// starting to compile member node (depth = 4)
  int callframe3175 = gc_frame_new();
// call case 4: self request
  Object call3176 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3175);
// compiled member node returning call3176 (depth = 4)
  int op_slot_left_3172 = gc_frame_newslot(call3176);
  params[0] = num3173;
  partcv[0] = 1;
  Object sum3177 = callmethod(call3176, "+(1)", 1, partcv, params);
// compiled op node returning sum3177 (depth = 3)
  gc_frame_newslot(sum3177);
// call case 4: self request
  params[0] = sum3177;
  partcv[0] = 1;
  Object call3178 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3171);
// compiled call node returning call3178 (depth = 2)
// Begin line 1515
  setline(1515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3179 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe3180 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_aBinding (depth = 5)
  Object call3181 = callmethodflags(*var_aBinding, "key", 0, partcv, params, 0);
  gc_frame_end(callframe3180);
// compiled member node returning call3181 (depth = 4)
  gc_frame_newslot(call3181);
// call case 4: self request
  params[0] = call3181;
  partcv[0] = 1;
  Object call3182 = callmethodflags(self, "findPositionForAdd(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3179);
// compiled call node returning call3182 (depth = 3)
  *var_t = call3182;
  if (call3182 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1516
  setline(1516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3186 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3187 = gc_frame_new();
// call case 4: self request
  Object call3188 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3187);
// compiled member node returning call3188 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3189 = callmethodflags(call3188, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3186);
// compiled call node returning call3189 (depth = 5)
  int op_slot_right_3185 = gc_frame_newslot(call3189);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_removed (depth = 5)
  int op_slot_left_3185 = gc_frame_newslot(*var_removed);
  params[0] = call3189;
  partcv[0] = 1;
  Object opresult3191 = callmethod(*var_removed, "==(1)", 1, partcv, params);
// compiled op node returning opresult3191 (depth = 4)
  int op_slot_right_3184 = gc_frame_newslot(opresult3191);
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3194 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3195 = gc_frame_new();
// call case 4: self request
  Object call3196 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3195);
// compiled member node returning call3196 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3197 = callmethodflags(call3196, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3194);
// compiled call node returning call3197 (depth = 5)
  int op_slot_right_3193 = gc_frame_newslot(call3197);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  int op_slot_left_3193 = gc_frame_newslot(*var_unused);
  params[0] = call3197;
  partcv[0] = 1;
  Object opresult3199 = callmethod(*var_unused, "==(1)", 1, partcv, params);
// compiled op node returning opresult3199 (depth = 4)
  int op_slot_left_3184 = gc_frame_newslot(opresult3199);
  params[0] = opresult3191;
  partcv[0] = 1;
  Object opresult3200 = callmethod(opresult3199, "||(1)", 1, partcv, params);
// compiled op node returning opresult3200 (depth = 3)
  Object if3183 = done;
  if (istrue(opresult3200)) {
// Begin line 1517
  setline(1517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3201 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3203 = alloc_Float64(1);
// compiled num node returning num3203 (depth = 5)
  int op_slot_right_3202 = gc_frame_newslot(num3203);
// starting to compile member node (depth = 5)
  int callframe3205 = gc_frame_new();
// call case 4: self request
  Object call3206 = callmethodflags(self, "numBindings", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3205);
// compiled member node returning call3206 (depth = 5)
  int op_slot_left_3202 = gc_frame_newslot(call3206);
  params[0] = num3203;
  partcv[0] = 1;
  Object sum3207 = callmethod(call3206, "+(1)", 1, partcv, params);
// compiled op node returning sum3207 (depth = 4)
  gc_frame_newslot(sum3207);
// call case 4: self request
  params[0] = sum3207;
  partcv[0] = 1;
  Object call3208 = callmethodflags(self, "numBindings:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3201);
// compiled call node returning call3208 (depth = 3)
    gc_frame_newslot(call3208);
    if3183 = call3208;
  } else {
  }
// compiled if node returning if3183 (depth = 2)
// Begin line 1519
  setline(1519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3209 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_aBinding (depth = 3)
  gc_frame_newslot(*var_aBinding);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3210 = gc_frame_new();
// call case 4: self request
  Object call3211 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3210);
// compiled member node returning call3211 (depth = 3)
  params[0] = *var_t;
  params[1] = *var_aBinding;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3212 = callmethodflags(call3211, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3209);
// compiled call node returning call3212 (depth = 2)
// Begin line 1520
  setline(1520);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3215 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe3216 = gc_frame_new();
// call case 4: self request
  Object call3217 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3216);
// compiled member node returning call3217 (depth = 5)
  Object call3218 = callmethodflags(call3217, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3215);
// compiled member node returning call3218 (depth = 4)
  int op_slot_right_3214 = gc_frame_newslot(call3218);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3221 = alloc_Float64(2);
// compiled num node returning num3221 (depth = 5)
  int op_slot_right_3220 = gc_frame_newslot(num3221);
// starting to compile member node (depth = 5)
  int callframe3223 = gc_frame_new();
// call case 4: self request
  Object call3224 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3223);
// compiled member node returning call3224 (depth = 5)
  int op_slot_left_3220 = gc_frame_newslot(call3224);
  params[0] = num3221;
  partcv[0] = 1;
  Object prod3225 = callmethod(call3224, "*(1)", 1, partcv, params);
// compiled op node returning prod3225 (depth = 4)
  int op_slot_left_3214 = gc_frame_newslot(prod3225);
  params[0] = call3218;
  partcv[0] = 1;
  Object opresult3226 = callmethod(prod3225, ">(1)", 1, partcv, params);
// compiled op node returning opresult3226 (depth = 3)
  Object if3213 = done;
  if (istrue(opresult3226)) {
// starting to compile member node (depth = 3)
  int callframe3227 = gc_frame_new();
// call case 4: self request
  Object call3228 = callmethodflags(self, "expand", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3227);
// compiled member node returning call3228 (depth = 3)
    gc_frame_newslot(call3228);
    if3213 = call3228;
  } else {
  }
// compiled if node returning if3213 (depth = 2)
// Begin line 1521
  setline(1521);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_at_40_1_41_3229(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "at(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)");
  Object params[1];
  int partcv[1];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_b = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "b");
// Begin line 1524
  setline(1524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3230 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3231 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call3232 = callmethodflags(self, "findPosition(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3231);
// compiled call node returning call3232 (depth = 4)
  gc_frame_newslot(call3232);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3233 = gc_frame_new();
// call case 4: self request
  Object call3234 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3233);
// compiled member node returning call3234 (depth = 4)
  params[0] = call3232;
  partcv[0] = 1;
  Object call3235 = callmethodflags(call3234, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3230);
// compiled call node returning call3235 (depth = 3)
  *var_b = call3235;
  if (call3235 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1525
  setline(1525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  int op_slot_right_3237 = gc_frame_newslot(*var_k);
// starting to compile member node (depth = 4)
  int callframe3239 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  Object call3240 = callmethodflags(*var_b, "key", 0, partcv, params, 0);
  gc_frame_end(callframe3239);
// compiled member node returning call3240 (depth = 4)
  int op_slot_left_3237 = gc_frame_newslot(call3240);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3241 = callmethod(call3240, "==(1)", 1, partcv, params);
// compiled op node returning opresult3241 (depth = 3)
  Object if3236 = done;
  if (istrue(opresult3241)) {
// Begin line 1526
  setline(1526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3242 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  Object call3243 = callmethodflags(*var_b, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3242);
// compiled member node returning call3243 (depth = 4)
  return call3243;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if3236 = undefined;
  } else {
  }
// compiled if node returning if3236 (depth = 2)
// Begin line 1528
  setline(1528);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3244 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3246 == NULL) {
    strlit3246 = alloc_String("");
    gc_root(strlit3246);
  }
// compiled string node returning strlit3246 (depth = 4)
  int op_slot_right_3245 = gc_frame_newslot(strlit3246);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  int op_slot_right_3248 = gc_frame_newslot(*var_k);
// starting to compile string node (depth = 5)
  if (strlit3250 == NULL) {
    strlit3250 = alloc_String("dictionary does not contain entry with key ");
    gc_root(strlit3250);
  }
// compiled string node returning strlit3250 (depth = 5)
  int op_slot_left_3248 = gc_frame_newslot(strlit3250);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3251 = callmethod(strlit3250, "++(1)", 1, partcv, params);
// compiled op node returning opresult3251 (depth = 4)
  int op_slot_left_3245 = gc_frame_newslot(opresult3251);
  params[0] = strlit3246;
  partcv[0] = 1;
  Object opresult3252 = callmethod(opresult3251, "++(1)", 1, partcv, params);
// compiled op node returning opresult3252 (depth = 3)
  gc_frame_newslot(opresult3252);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_NoSuchObject (depth = 3)
  params[0] = opresult3252;
  partcv[0] = 1;
  Object call3253 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3244);
// compiled call node returning call3253 (depth = 2)
  gc_frame_end(frame);
  return call3253;
}
Object meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3254(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at(1)ifAbsent(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)ifAbsent(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)ifAbsent(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for at(_)ifAbsent(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifAbsent(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_b = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "b");
// Begin line 1531
  setline(1531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3255 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3256 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call3257 = callmethodflags(self, "findPosition(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3256);
// compiled call node returning call3257 (depth = 4)
  gc_frame_newslot(call3257);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3258 = gc_frame_new();
// call case 4: self request
  Object call3259 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3258);
// compiled member node returning call3259 (depth = 4)
  params[0] = call3257;
  partcv[0] = 1;
  Object call3260 = callmethodflags(call3259, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3255);
// compiled call node returning call3260 (depth = 3)
  *var_b = call3260;
  if (call3260 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1532
  setline(1532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  int op_slot_right_3262 = gc_frame_newslot(*var_k);
// starting to compile member node (depth = 4)
  int callframe3264 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  Object call3265 = callmethodflags(*var_b, "key", 0, partcv, params, 0);
  gc_frame_end(callframe3264);
// compiled member node returning call3265 (depth = 4)
  int op_slot_left_3262 = gc_frame_newslot(call3265);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3266 = callmethod(call3265, "==(1)", 1, partcv, params);
// compiled op node returning opresult3266 (depth = 3)
  Object if3261 = done;
  if (istrue(opresult3266)) {
// Begin line 1533
  setline(1533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe3267 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  Object call3268 = callmethodflags(*var_b, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3267);
// compiled member node returning call3268 (depth = 4)
  return call3268;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if3261 = undefined;
  } else {
  }
// compiled if node returning if3261 (depth = 2)
// Begin line 1535
  setline(1535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3269 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_action (depth = 3)
  Object call3270 = callmethodflags(*var_action, "apply", 0, partcv, params, 0);
  gc_frame_end(callframe3269);
// compiled member node returning call3270 (depth = 2)
  gc_frame_end(frame);
  return call3270;
}
Object meth_collectionsPrelude_containsKey_40_1_41_3271(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "containsKey(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method containsKey(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for containsKey(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part containsKey(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 1538
  setline(1538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3272 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call3273 = callmethodflags(self, "findPosition(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3272);
// compiled call node returning call3273 (depth = 3)
  *var_t = call3273;
  if (call3273 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1539
  setline(1539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  int op_slot_right_3275 = gc_frame_newslot(*var_k);
// starting to compile member node (depth = 4)
  int callframe3277 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe3278 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3279 = gc_frame_new();
// call case 4: self request
  Object call3280 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3279);
// compiled member node returning call3280 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3281 = callmethodflags(call3280, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3278);
// compiled call node returning call3281 (depth = 5)
  Object call3282 = callmethodflags(call3281, "key", 0, partcv, params, 0);
  gc_frame_end(callframe3277);
// compiled member node returning call3282 (depth = 4)
  int op_slot_left_3275 = gc_frame_newslot(call3282);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3283 = callmethod(call3282, "==(1)", 1, partcv, params);
// compiled op node returning opresult3283 (depth = 3)
  Object if3274 = done;
  if (istrue(opresult3283)) {
// Begin line 1540
  setline(1540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool3284 = alloc_Boolean(1);
// compiled identifier node returning bool3284 (depth = 4)
  return bool3284;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if3274 = undefined;
  } else {
  }
// compiled if node returning if3274 (depth = 2)
// Begin line 1542
  setline(1542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool3285 = alloc_Boolean(0);
// compiled identifier node returning bool3285 (depth = 2)
  gc_frame_end(frame);
  return bool3285;
}
Object meth_collectionsPrelude__apply_40_1_41_3297(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 1547
  setline(1547);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3298 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call3299 = callmethodflags(self, "findPosition(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3298);
// compiled call node returning call3299 (depth = 5)
  *var_t = call3299;
  if (call3299 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1548
  setline(1548);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  int op_slot_right_3301 = gc_frame_newslot(*var_k);
// starting to compile member node (depth = 6)
  int callframe3303 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe3304 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3305 = gc_frame_new();
// call case 4: self request
  Object call3306 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3305);
// compiled member node returning call3306 (depth = 8)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3307 = callmethodflags(call3306, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3304);
// compiled call node returning call3307 (depth = 7)
  Object call3308 = callmethodflags(call3307, "key", 0, partcv, params, 0);
  gc_frame_end(callframe3303);
// compiled member node returning call3308 (depth = 6)
  int op_slot_left_3301 = gc_frame_newslot(call3308);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3309 = callmethod(call3308, "==(1)", 1, partcv, params);
// compiled op node returning opresult3309 (depth = 5)
  Object if3300 = done;
  if (istrue(opresult3309)) {
// Begin line 1549
  setline(1549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3310 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  gc_frame_newslot(*var_removed);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3311 = gc_frame_new();
// call case 4: self request
  Object call3312 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3311);
// compiled member node returning call3312 (depth = 6)
  params[0] = *var_t;
  params[1] = *var_removed;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3313 = callmethodflags(call3312, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3310);
// compiled call node returning call3313 (depth = 5)
// Begin line 1550
  setline(1550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3314 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3316 = alloc_Float64(1);
// compiled num node returning num3316 (depth = 7)
  int op_slot_right_3315 = gc_frame_newslot(num3316);
// starting to compile member node (depth = 7)
  int callframe3318 = gc_frame_new();
// call case 4: self request
  Object call3319 = callmethodflags(self, "numBindings", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3318);
// compiled member node returning call3319 (depth = 7)
  int op_slot_left_3315 = gc_frame_newslot(call3319);
  params[0] = num3316;
  partcv[0] = 1;
  Object diff3320 = callmethod(call3319, "-(1)", 1, partcv, params);
// compiled op node returning diff3320 (depth = 6)
  gc_frame_newslot(diff3320);
// call case 4: self request
  params[0] = diff3320;
  partcv[0] = 1;
  Object call3321 = callmethodflags(self, "numBindings:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3314);
// compiled call node returning call3321 (depth = 5)
    gc_frame_newslot(call3321);
    if3300 = call3321;
  } else {
// Begin line 1552
  setline(1552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3322 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3324 == NULL) {
    strlit3324 = alloc_String("");
    gc_root(strlit3324);
  }
// compiled string node returning strlit3324 (depth = 7)
  int op_slot_right_3323 = gc_frame_newslot(strlit3324);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_k (depth = 8)
  int op_slot_right_3326 = gc_frame_newslot(*var_k);
// starting to compile string node (depth = 8)
  if (strlit3328 == NULL) {
    strlit3328 = alloc_String("dictionary does not contain entry with key ");
    gc_root(strlit3328);
  }
// compiled string node returning strlit3328 (depth = 8)
  int op_slot_left_3326 = gc_frame_newslot(strlit3328);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3329 = callmethod(strlit3328, "++(1)", 1, partcv, params);
// compiled op node returning opresult3329 (depth = 7)
  int op_slot_left_3323 = gc_frame_newslot(opresult3329);
  params[0] = strlit3324;
  partcv[0] = 1;
  Object opresult3330 = callmethod(opresult3329, "++(1)", 1, partcv, params);
// compiled op node returning opresult3330 (depth = 6)
  gc_frame_newslot(opresult3330);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_NoSuchObject (depth = 6)
  params[0] = opresult3330;
  partcv[0] = 1;
  Object call3331 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3322);
// compiled call node returning call3331 (depth = 5)
    gc_frame_newslot(call3331);
    if3300 = call3331;
  }
// compiled if node returning if3300 (depth = 4)
  gc_frame_end(frame);
  return if3300;
}
Object meth_collectionsPrelude_removeAllKeys_40_1_41_3286(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeAllKeys(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAllKeys(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeAllKeys(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_keys = &(stackframe->slots[0]);
  *var_keys = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeAllKeys(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1545
  setline(1545);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3287 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3289 = alloc_Float64(1);
// compiled num node returning num3289 (depth = 4)
  int op_slot_right_3288 = gc_frame_newslot(num3289);
// starting to compile member node (depth = 4)
  int callframe3291 = gc_frame_new();
// call case 4: self request
  Object call3292 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3291);
// compiled member node returning call3292 (depth = 4)
  int op_slot_left_3288 = gc_frame_newslot(call3292);
  params[0] = num3289;
  partcv[0] = 1;
  Object sum3293 = callmethod(call3292, "+(1)", 1, partcv, params);
// compiled op node returning sum3293 (depth = 3)
  gc_frame_newslot(sum3293);
// call case 4: self request
  params[0] = sum3293;
  partcv[0] = 1;
  Object call3294 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3287);
// compiled call node returning call3294 (depth = 2)
// Begin line 1546
  setline(1546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3295 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_keys (depth = 3)
  gc_frame_newslot(*var_keys);
// starting to compile block node (depth = 3)
  Object block3296 = alloc_Block(NULL, NULL, "collectionsPrelude", 1546);
  gc_frame_newslot(block3296);
// method "_apply(_)"
  block_savedest(block3296);
  Object closure3297 = createclosure(3, "_apply(1)");
  setclosureframe(closure3297, stackframe);
  addtoclosure(closure3297, var_removed);
  addtoclosure(closure3297, var_NoSuchObject);
  addtoclosure(closure3297, selfslot);
  struct UserObject *uo3297 = (struct UserObject*)block3296;
  uo3297->data[0] = (Object)closure3297;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3297 = addmethod2pos(block3296, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3297, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3297[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3297->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3297);
  meth_meth_collectionsPrelude__apply_40_1_41_3297->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3297->definitionLine = 1963;
// compiled block node returning block3296 (depth = 3)
  gc_frame_newslot(block3296);
// call case 5: prelude request
  params[0] = *var_keys;
  params[1] = block3296;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3333 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3295);
// compiled call node returning call3333 (depth = 2)
// Begin line 1555
  setline(1555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_removeKey_40_1_41_3334(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeKey(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeKey(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeKey(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeKey(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 1558
  setline(1558);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3335 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3337 = alloc_Float64(1);
// compiled num node returning num3337 (depth = 4)
  int op_slot_right_3336 = gc_frame_newslot(num3337);
// starting to compile member node (depth = 4)
  int callframe3339 = gc_frame_new();
// call case 4: self request
  Object call3340 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3339);
// compiled member node returning call3340 (depth = 4)
  int op_slot_left_3336 = gc_frame_newslot(call3340);
  params[0] = num3337;
  partcv[0] = 1;
  Object sum3341 = callmethod(call3340, "+(1)", 1, partcv, params);
// compiled op node returning sum3341 (depth = 3)
  gc_frame_newslot(sum3341);
// call case 4: self request
  params[0] = sum3341;
  partcv[0] = 1;
  Object call3342 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3335);
// compiled call node returning call3342 (depth = 2)
// Begin line 1559
  setline(1559);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3343 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call3344 = callmethodflags(self, "findPosition(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3343);
// compiled call node returning call3344 (depth = 3)
  *var_t = call3344;
  if (call3344 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1560
  setline(1560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  int op_slot_right_3346 = gc_frame_newslot(*var_k);
// starting to compile member node (depth = 4)
  int callframe3348 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 5)
  int callframe3349 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3350 = gc_frame_new();
// call case 4: self request
  Object call3351 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3350);
// compiled member node returning call3351 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3352 = callmethodflags(call3351, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3349);
// compiled call node returning call3352 (depth = 5)
  Object call3353 = callmethodflags(call3352, "key", 0, partcv, params, 0);
  gc_frame_end(callframe3348);
// compiled member node returning call3353 (depth = 4)
  int op_slot_left_3346 = gc_frame_newslot(call3353);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3354 = callmethod(call3353, "==(1)", 1, partcv, params);
// compiled op node returning opresult3354 (depth = 3)
  Object if3345 = done;
  if (istrue(opresult3354)) {
// Begin line 1561
  setline(1561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3355 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_removed (depth = 4)
  gc_frame_newslot(*var_removed);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3356 = gc_frame_new();
// call case 4: self request
  Object call3357 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3356);
// compiled member node returning call3357 (depth = 4)
  params[0] = *var_t;
  params[1] = *var_removed;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3358 = callmethodflags(call3357, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3355);
// compiled call node returning call3358 (depth = 3)
// Begin line 1562
  setline(1562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3359 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3361 = alloc_Float64(1);
// compiled num node returning num3361 (depth = 5)
  int op_slot_right_3360 = gc_frame_newslot(num3361);
// starting to compile member node (depth = 5)
  int callframe3363 = gc_frame_new();
// call case 4: self request
  Object call3364 = callmethodflags(self, "numBindings", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3363);
// compiled member node returning call3364 (depth = 5)
  int op_slot_left_3360 = gc_frame_newslot(call3364);
  params[0] = num3361;
  partcv[0] = 1;
  Object diff3365 = callmethod(call3364, "-(1)", 1, partcv, params);
// compiled op node returning diff3365 (depth = 4)
  gc_frame_newslot(diff3365);
// call case 4: self request
  params[0] = diff3365;
  partcv[0] = 1;
  Object call3366 = callmethodflags(self, "numBindings:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3359);
// compiled call node returning call3366 (depth = 3)
    gc_frame_newslot(call3366);
    if3345 = call3366;
  } else {
// Begin line 1564
  setline(1564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3367 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3369 == NULL) {
    strlit3369 = alloc_String("");
    gc_root(strlit3369);
  }
// compiled string node returning strlit3369 (depth = 5)
  int op_slot_right_3368 = gc_frame_newslot(strlit3369);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  int op_slot_right_3371 = gc_frame_newslot(*var_k);
// starting to compile string node (depth = 6)
  if (strlit3373 == NULL) {
    strlit3373 = alloc_String("dictionary does not contain entry with key ");
    gc_root(strlit3373);
  }
// compiled string node returning strlit3373 (depth = 6)
  int op_slot_left_3371 = gc_frame_newslot(strlit3373);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3374 = callmethod(strlit3373, "++(1)", 1, partcv, params);
// compiled op node returning opresult3374 (depth = 5)
  int op_slot_left_3368 = gc_frame_newslot(opresult3374);
  params[0] = strlit3369;
  partcv[0] = 1;
  Object opresult3375 = callmethod(opresult3374, "++(1)", 1, partcv, params);
// compiled op node returning opresult3375 (depth = 4)
  gc_frame_newslot(opresult3375);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_NoSuchObject (depth = 4)
  params[0] = opresult3375;
  partcv[0] = 1;
  Object call3376 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3367);
// compiled call node returning call3376 (depth = 3)
    gc_frame_newslot(call3376);
    if3345 = call3376;
  }
// compiled if node returning if3345 (depth = 2)
// Begin line 1566
  setline(1566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply_40_1_41_3400(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_removals = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1571
  setline(1571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3401 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3402 = gc_frame_new();
// call case 4: self request
  Object call3403 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3402);
// compiled member node returning call3403 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call3404 = callmethodflags(call3403, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3401);
// compiled call node returning call3404 (depth = 5)
  *var_a = call3404;
  if (call3404 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1572
  setline(1572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3406 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe3407 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  Object call3408 = callmethodflags(*var_a, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3407);
// compiled member node returning call3408 (depth = 6)
  gc_frame_newslot(call3408);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removals (depth = 6)
  params[0] = call3408;
  partcv[0] = 1;
  Object call3409 = callmethodflags(*var_removals, "contains(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3406);
// compiled call node returning call3409 (depth = 5)
  Object if3405 = done;
  if (istrue(call3409)) {
// Begin line 1573
  setline(1573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3410 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  gc_frame_newslot(*var_removed);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3411 = gc_frame_new();
// call case 4: self request
  Object call3412 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3411);
// compiled member node returning call3412 (depth = 6)
  params[0] = *var_i;
  params[1] = *var_removed;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3413 = callmethodflags(call3412, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3410);
// compiled call node returning call3413 (depth = 5)
// Begin line 1574
  setline(1574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3414 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3416 = alloc_Float64(1);
// compiled num node returning num3416 (depth = 7)
  int op_slot_right_3415 = gc_frame_newslot(num3416);
// starting to compile member node (depth = 7)
  int callframe3418 = gc_frame_new();
// call case 4: self request
  Object call3419 = callmethodflags(self, "numBindings", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3418);
// compiled member node returning call3419 (depth = 7)
  int op_slot_left_3415 = gc_frame_newslot(call3419);
  params[0] = num3416;
  partcv[0] = 1;
  Object diff3420 = callmethod(call3419, "-(1)", 1, partcv, params);
// compiled op node returning diff3420 (depth = 6)
  gc_frame_newslot(diff3420);
// call case 4: self request
  params[0] = diff3420;
  partcv[0] = 1;
  Object call3421 = callmethodflags(self, "numBindings:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3414);
// compiled call node returning call3421 (depth = 5)
    gc_frame_newslot(call3421);
    if3405 = call3421;
  } else {
  }
// compiled if node returning if3405 (depth = 4)
  gc_frame_end(frame);
  return if3405;
}
Object meth_collectionsPrelude_removeAllValues_40_1_41_3377(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeAllValues(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAllValues(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeAllValues(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_removals = &(stackframe->slots[0]);
  *var_removals = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeAllValues(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1569
  setline(1569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3378 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3380 = alloc_Float64(1);
// compiled num node returning num3380 (depth = 4)
  int op_slot_right_3379 = gc_frame_newslot(num3380);
// starting to compile member node (depth = 4)
  int callframe3382 = gc_frame_new();
// call case 4: self request
  Object call3383 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3382);
// compiled member node returning call3383 (depth = 4)
  int op_slot_left_3379 = gc_frame_newslot(call3383);
  params[0] = num3380;
  partcv[0] = 1;
  Object sum3384 = callmethod(call3383, "+(1)", 1, partcv, params);
// compiled op node returning sum3384 (depth = 3)
  gc_frame_newslot(sum3384);
// call case 4: self request
  params[0] = sum3384;
  partcv[0] = 1;
  Object call3385 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3378);
// compiled call node returning call3385 (depth = 2)
// Begin line 1570
  setline(1570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3386 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3389 = alloc_Float64(1);
// compiled num node returning num3389 (depth = 5)
  int op_slot_right_3388 = gc_frame_newslot(num3389);
// starting to compile member node (depth = 5)
  int callframe3391 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3392 = gc_frame_new();
// call case 4: self request
  Object call3393 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3392);
// compiled member node returning call3393 (depth = 6)
  Object call3394 = callmethodflags(call3393, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3391);
// compiled member node returning call3394 (depth = 5)
  int op_slot_left_3388 = gc_frame_newslot(call3394);
  params[0] = num3389;
  partcv[0] = 1;
  Object diff3395 = callmethod(call3394, "-(1)", 1, partcv, params);
// compiled op node returning diff3395 (depth = 4)
  int op_slot_right_3387 = gc_frame_newslot(diff3395);
// starting to compile num node (depth = 4)
  Object num3397 = alloc_Float64(0);
// compiled num node returning num3397 (depth = 4)
  int op_slot_left_3387 = gc_frame_newslot(num3397);
  params[0] = diff3395;
  partcv[0] = 1;
  Object opresult3398 = callmethod(num3397, "..(1)", 1, partcv, params);
// compiled op node returning opresult3398 (depth = 3)
  gc_frame_newslot(opresult3398);
// starting to compile block node (depth = 3)
  Object block3399 = alloc_Block(NULL, NULL, "collectionsPrelude", 1570);
  gc_frame_newslot(block3399);
// method "_apply(_)"
  block_savedest(block3399);
  Object closure3400 = createclosure(3, "_apply(1)");
  setclosureframe(closure3400, stackframe);
  addtoclosure(closure3400, var_removals);
  addtoclosure(closure3400, var_removed);
  addtoclosure(closure3400, selfslot);
  struct UserObject *uo3400 = (struct UserObject*)block3399;
  uo3400->data[0] = (Object)closure3400;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3400 = addmethod2pos(block3399, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3400, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3400[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3400->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3400);
  meth_meth_collectionsPrelude__apply_40_1_41_3400->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3400->definitionLine = 1963;
// compiled block node returning block3399 (depth = 3)
  gc_frame_newslot(block3399);
// call case 5: prelude request
  params[0] = opresult3398;
  params[1] = block3399;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3423 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3386);
// compiled call node returning call3423 (depth = 2)
// Begin line 1577
  setline(1577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply_40_1_41_3449(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1584
  setline(1584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3450 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3451 = gc_frame_new();
// call case 4: self request
  Object call3452 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3451);
// compiled member node returning call3452 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call3453 = callmethodflags(call3452, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3450);
// compiled call node returning call3453 (depth = 5)
  *var_a = call3453;
  if (call3453 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1585
  setline(1585);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3456 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  Object call3457 = callmethodflags(*var_a, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3456);
// compiled member node returning call3457 (depth = 6)
  int op_slot_right_3455 = gc_frame_newslot(call3457);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  int op_slot_left_3455 = gc_frame_newslot(*var_v);
  params[0] = call3457;
  partcv[0] = 1;
  Object opresult3459 = callmethod(*var_v, "==(1)", 1, partcv, params);
// compiled op node returning opresult3459 (depth = 5)
  Object if3454 = done;
  if (istrue(opresult3459)) {
// Begin line 1586
  setline(1586);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3460 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  gc_frame_newslot(*var_removed);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3461 = gc_frame_new();
// call case 4: self request
  Object call3462 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3461);
// compiled member node returning call3462 (depth = 6)
  params[0] = *var_i;
  params[1] = *var_removed;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3463 = callmethodflags(call3462, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3460);
// compiled call node returning call3463 (depth = 5)
// Begin line 1587
  setline(1587);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3464 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3466 = alloc_Float64(1);
// compiled num node returning num3466 (depth = 7)
  int op_slot_right_3465 = gc_frame_newslot(num3466);
// starting to compile member node (depth = 7)
  int callframe3468 = gc_frame_new();
// call case 4: self request
  Object call3469 = callmethodflags(self, "numBindings", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3468);
// compiled member node returning call3469 (depth = 7)
  int op_slot_left_3465 = gc_frame_newslot(call3469);
  params[0] = num3466;
  partcv[0] = 1;
  Object diff3470 = callmethod(call3469, "-(1)", 1, partcv, params);
// compiled op node returning diff3470 (depth = 6)
  gc_frame_newslot(diff3470);
// call case 4: self request
  params[0] = diff3470;
  partcv[0] = 1;
  Object call3471 = callmethodflags(self, "numBindings:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3464);
// compiled call node returning call3471 (depth = 5)
    gc_frame_newslot(call3471);
    if3454 = call3471;
  } else {
  }
// compiled if node returning if3454 (depth = 4)
  gc_frame_end(frame);
  return if3454;
}
Object meth_collectionsPrelude_removeValue_40_1_41_3424(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeValue(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeValue(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeValue(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeValue(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_initialNumBindings = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "initialNumBindings");
// Begin line 1581
  setline(1581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3425 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3427 = alloc_Float64(1);
// compiled num node returning num3427 (depth = 4)
  int op_slot_right_3426 = gc_frame_newslot(num3427);
// starting to compile member node (depth = 4)
  int callframe3429 = gc_frame_new();
// call case 4: self request
  Object call3430 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3429);
// compiled member node returning call3430 (depth = 4)
  int op_slot_left_3426 = gc_frame_newslot(call3430);
  params[0] = num3427;
  partcv[0] = 1;
  Object sum3431 = callmethod(call3430, "+(1)", 1, partcv, params);
// compiled op node returning sum3431 (depth = 3)
  gc_frame_newslot(sum3431);
// call case 4: self request
  params[0] = sum3431;
  partcv[0] = 1;
  Object call3432 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3425);
// compiled call node returning call3432 (depth = 2)
// Begin line 1582
  setline(1582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe3433 = gc_frame_new();
// call case 4: self request
  Object call3434 = callmethodflags(self, "numBindings", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3433);
// compiled member node returning call3434 (depth = 3)
  *var_initialNumBindings = call3434;
  if (call3434 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1583
  setline(1583);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3435 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3438 = alloc_Float64(1);
// compiled num node returning num3438 (depth = 5)
  int op_slot_right_3437 = gc_frame_newslot(num3438);
// starting to compile member node (depth = 5)
  int callframe3440 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3441 = gc_frame_new();
// call case 4: self request
  Object call3442 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3441);
// compiled member node returning call3442 (depth = 6)
  Object call3443 = callmethodflags(call3442, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3440);
// compiled member node returning call3443 (depth = 5)
  int op_slot_left_3437 = gc_frame_newslot(call3443);
  params[0] = num3438;
  partcv[0] = 1;
  Object diff3444 = callmethod(call3443, "-(1)", 1, partcv, params);
// compiled op node returning diff3444 (depth = 4)
  int op_slot_right_3436 = gc_frame_newslot(diff3444);
// starting to compile num node (depth = 4)
  Object num3446 = alloc_Float64(0);
// compiled num node returning num3446 (depth = 4)
  int op_slot_left_3436 = gc_frame_newslot(num3446);
  params[0] = diff3444;
  partcv[0] = 1;
  Object opresult3447 = callmethod(num3446, "..(1)", 1, partcv, params);
// compiled op node returning opresult3447 (depth = 3)
  gc_frame_newslot(opresult3447);
// starting to compile block node (depth = 3)
  Object block3448 = alloc_Block(NULL, NULL, "collectionsPrelude", 1583);
  gc_frame_newslot(block3448);
// method "_apply(_)"
  block_savedest(block3448);
  Object closure3449 = createclosure(3, "_apply(1)");
  setclosureframe(closure3449, stackframe);
  addtoclosure(closure3449, var_v);
  addtoclosure(closure3449, var_removed);
  addtoclosure(closure3449, selfslot);
  struct UserObject *uo3449 = (struct UserObject*)block3448;
  uo3449->data[0] = (Object)closure3449;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3449 = addmethod2pos(block3448, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3449, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3449[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3449->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3449);
  meth_meth_collectionsPrelude__apply_40_1_41_3449->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3449->definitionLine = 1963;
// compiled block node returning block3448 (depth = 3)
  gc_frame_newslot(block3448);
// call case 5: prelude request
  params[0] = opresult3447;
  params[1] = block3448;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3473 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3435);
// compiled call node returning call3473 (depth = 2)
// Begin line 1590
  setline(1590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_initialNumBindings (depth = 4)
  int op_slot_right_3475 = gc_frame_newslot(*var_initialNumBindings);
// starting to compile member node (depth = 4)
  int callframe3477 = gc_frame_new();
// call case 4: self request
  Object call3478 = callmethodflags(self, "numBindings", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3477);
// compiled member node returning call3478 (depth = 4)
  int op_slot_left_3475 = gc_frame_newslot(call3478);
  params[0] = *var_initialNumBindings;
  partcv[0] = 1;
  Object opresult3479 = callmethod(call3478, "==(1)", 1, partcv, params);
// compiled op node returning opresult3479 (depth = 3)
  Object if3474 = done;
  if (istrue(opresult3479)) {
// Begin line 1591
  setline(1591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3480 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3482 == NULL) {
    strlit3482 = alloc_String("");
    gc_root(strlit3482);
  }
// compiled string node returning strlit3482 (depth = 5)
  int op_slot_right_3481 = gc_frame_newslot(strlit3482);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  int op_slot_right_3484 = gc_frame_newslot(*var_v);
// starting to compile string node (depth = 6)
  if (strlit3486 == NULL) {
    strlit3486 = alloc_String("dictionary does not contain entry with value ");
    gc_root(strlit3486);
  }
// compiled string node returning strlit3486 (depth = 6)
  int op_slot_left_3484 = gc_frame_newslot(strlit3486);
  params[0] = *var_v;
  partcv[0] = 1;
  Object opresult3487 = callmethod(strlit3486, "++(1)", 1, partcv, params);
// compiled op node returning opresult3487 (depth = 5)
  int op_slot_left_3481 = gc_frame_newslot(opresult3487);
  params[0] = strlit3482;
  partcv[0] = 1;
  Object opresult3488 = callmethod(opresult3487, "++(1)", 1, partcv, params);
// compiled op node returning opresult3488 (depth = 4)
  gc_frame_newslot(opresult3488);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_NoSuchObject (depth = 4)
  params[0] = opresult3488;
  partcv[0] = 1;
  Object call3489 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3480);
// compiled call node returning call3489 (depth = 3)
    gc_frame_newslot(call3489);
    if3474 = call3489;
  } else {
  }
// compiled if node returning if3474 (depth = 2)
// Begin line 1593
  setline(1593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply_40_1_41_3515(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1600
  setline(1600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3516 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3517 = gc_frame_new();
// call case 4: self request
  Object call3518 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3517);
// compiled member node returning call3518 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call3519 = callmethodflags(call3518, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3516);
// compiled call node returning call3519 (depth = 5)
  *var_a = call3519;
  if (call3519 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1601
  setline(1601);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe3522 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  Object call3523 = callmethodflags(*var_a, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3522);
// compiled member node returning call3523 (depth = 6)
  int op_slot_right_3521 = gc_frame_newslot(call3523);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  int op_slot_left_3521 = gc_frame_newslot(*var_v);
  params[0] = call3523;
  partcv[0] = 1;
  Object opresult3525 = callmethod(*var_v, "==(1)", 1, partcv, params);
// compiled op node returning opresult3525 (depth = 5)
  Object if3520 = done;
  if (istrue(opresult3525)) {
// Begin line 1602
  setline(1602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3526 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  gc_frame_newslot(*var_removed);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3527 = gc_frame_new();
// call case 4: self request
  Object call3528 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3527);
// compiled member node returning call3528 (depth = 6)
  params[0] = *var_i;
  params[1] = *var_removed;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3529 = callmethodflags(call3528, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3526);
// compiled call node returning call3529 (depth = 5)
// Begin line 1603
  setline(1603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3530 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3532 = alloc_Float64(1);
// compiled num node returning num3532 (depth = 7)
  int op_slot_right_3531 = gc_frame_newslot(num3532);
// starting to compile member node (depth = 7)
  int callframe3534 = gc_frame_new();
// call case 4: self request
  Object call3535 = callmethodflags(self, "numBindings", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3534);
// compiled member node returning call3535 (depth = 7)
  int op_slot_left_3531 = gc_frame_newslot(call3535);
  params[0] = num3532;
  partcv[0] = 1;
  Object diff3536 = callmethod(call3535, "-(1)", 1, partcv, params);
// compiled op node returning diff3536 (depth = 6)
  gc_frame_newslot(diff3536);
// call case 4: self request
  params[0] = diff3536;
  partcv[0] = 1;
  Object call3537 = callmethodflags(self, "numBindings:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3530);
// compiled call node returning call3537 (depth = 5)
    gc_frame_newslot(call3537);
    if3520 = call3537;
  } else {
  }
// compiled if node returning if3520 (depth = 4)
  gc_frame_end(frame);
  return if3520;
}
Object meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3490(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeValue(1)ifAbsent(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeValue(_)ifAbsent(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeValue(_)ifAbsent(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for removeValue(_)ifAbsent(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part removeValue(_)");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifAbsent(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_initialNumBindings = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "initialNumBindings");
// Begin line 1597
  setline(1597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3491 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3493 = alloc_Float64(1);
// compiled num node returning num3493 (depth = 4)
  int op_slot_right_3492 = gc_frame_newslot(num3493);
// starting to compile member node (depth = 4)
  int callframe3495 = gc_frame_new();
// call case 4: self request
  Object call3496 = callmethodflags(self, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3495);
// compiled member node returning call3496 (depth = 4)
  int op_slot_left_3492 = gc_frame_newslot(call3496);
  params[0] = num3493;
  partcv[0] = 1;
  Object sum3497 = callmethod(call3496, "+(1)", 1, partcv, params);
// compiled op node returning sum3497 (depth = 3)
  gc_frame_newslot(sum3497);
// call case 4: self request
  params[0] = sum3497;
  partcv[0] = 1;
  Object call3498 = callmethodflags(self, "mods:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3491);
// compiled call node returning call3498 (depth = 2)
// Begin line 1598
  setline(1598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe3499 = gc_frame_new();
// call case 4: self request
  Object call3500 = callmethodflags(self, "numBindings", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3499);
// compiled member node returning call3500 (depth = 3)
  *var_initialNumBindings = call3500;
  if (call3500 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1599
  setline(1599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3501 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3504 = alloc_Float64(1);
// compiled num node returning num3504 (depth = 5)
  int op_slot_right_3503 = gc_frame_newslot(num3504);
// starting to compile member node (depth = 5)
  int callframe3506 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3507 = gc_frame_new();
// call case 4: self request
  Object call3508 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3507);
// compiled member node returning call3508 (depth = 6)
  Object call3509 = callmethodflags(call3508, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3506);
// compiled member node returning call3509 (depth = 5)
  int op_slot_left_3503 = gc_frame_newslot(call3509);
  params[0] = num3504;
  partcv[0] = 1;
  Object diff3510 = callmethod(call3509, "-(1)", 1, partcv, params);
// compiled op node returning diff3510 (depth = 4)
  int op_slot_right_3502 = gc_frame_newslot(diff3510);
// starting to compile num node (depth = 4)
  Object num3512 = alloc_Float64(0);
// compiled num node returning num3512 (depth = 4)
  int op_slot_left_3502 = gc_frame_newslot(num3512);
  params[0] = diff3510;
  partcv[0] = 1;
  Object opresult3513 = callmethod(num3512, "..(1)", 1, partcv, params);
// compiled op node returning opresult3513 (depth = 3)
  gc_frame_newslot(opresult3513);
// starting to compile block node (depth = 3)
  Object block3514 = alloc_Block(NULL, NULL, "collectionsPrelude", 1599);
  gc_frame_newslot(block3514);
// method "_apply(_)"
  block_savedest(block3514);
  Object closure3515 = createclosure(3, "_apply(1)");
  setclosureframe(closure3515, stackframe);
  addtoclosure(closure3515, var_v);
  addtoclosure(closure3515, var_removed);
  addtoclosure(closure3515, selfslot);
  struct UserObject *uo3515 = (struct UserObject*)block3514;
  uo3515->data[0] = (Object)closure3515;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3515 = addmethod2pos(block3514, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3515, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3515[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3515->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3515);
  meth_meth_collectionsPrelude__apply_40_1_41_3515->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3515->definitionLine = 1963;
// compiled block node returning block3514 (depth = 3)
  gc_frame_newslot(block3514);
// call case 5: prelude request
  params[0] = opresult3513;
  params[1] = block3514;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3539 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3501);
// compiled call node returning call3539 (depth = 2)
// Begin line 1606
  setline(1606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_initialNumBindings (depth = 4)
  int op_slot_right_3541 = gc_frame_newslot(*var_initialNumBindings);
// starting to compile member node (depth = 4)
  int callframe3543 = gc_frame_new();
// call case 4: self request
  Object call3544 = callmethodflags(self, "numBindings", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3543);
// compiled member node returning call3544 (depth = 4)
  int op_slot_left_3541 = gc_frame_newslot(call3544);
  params[0] = *var_initialNumBindings;
  partcv[0] = 1;
  Object opresult3545 = callmethod(call3544, "==(1)", 1, partcv, params);
// compiled op node returning opresult3545 (depth = 3)
  Object if3540 = done;
  if (istrue(opresult3545)) {
// Begin line 1607
  setline(1607);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe3546 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_action (depth = 4)
  Object call3547 = callmethodflags(*var_action, "apply", 0, partcv, params, 0);
  gc_frame_end(callframe3546);
// compiled member node returning call3547 (depth = 3)
    gc_frame_newslot(call3547);
    if3540 = call3547;
  } else {
  }
// compiled if node returning if3540 (depth = 2)
// Begin line 1609
  setline(1609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply_40_1_41_3551(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1613
  setline(1613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  int op_slot_right_3553 = gc_frame_newslot(*var_each);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  int op_slot_left_3553 = gc_frame_newslot(*var_v);
  params[0] = *var_each;
  partcv[0] = 1;
  Object opresult3555 = callmethod(*var_v, "==(1)", 1, partcv, params);
// compiled op node returning opresult3555 (depth = 5)
  Object if3552 = done;
  if (istrue(opresult3555)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool3556 = alloc_Boolean(1);
// compiled identifier node returning bool3556 (depth = 6)
  block_return(realself, bool3556);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if3552 = undefined;
  } else {
  }
// compiled if node returning if3552 (depth = 4)
  gc_frame_end(frame);
  return if3552;
}
Object meth_collectionsPrelude_containsValue_40_1_41_3548(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "containsValue(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method containsValue(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for containsValue(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part containsValue(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1612
  setline(1612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3549 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3550 = alloc_Block(NULL, NULL, "collectionsPrelude", 1612);
  gc_frame_newslot(block3550);
// method "_apply(_)"
  block_savedest(block3550);
  Object closure3551 = createclosure(2, "_apply(1)");
  setclosureframe(closure3551, stackframe);
  addtoclosure(closure3551, var_v);
  addtoclosure(closure3551, selfslot);
  struct UserObject *uo3551 = (struct UserObject*)block3550;
  uo3551->data[0] = (Object)closure3551;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3551 = addmethod2pos(block3550, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3551, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3551[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3551->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3551);
  meth_meth_collectionsPrelude__apply_40_1_41_3551->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3551->definitionLine = 1963;
// compiled block node returning block3550 (depth = 3)
  gc_frame_newslot(block3550);
// call case 4: self request
  params[0] = block3550;
  partcv[0] = 1;
  Object call3558 = callmethodflags(self, "valuesDo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3549);
// compiled call node returning call3558 (depth = 2)
// Begin line 1615
  setline(1615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool3559 = alloc_Boolean(0);
// compiled identifier node returning bool3559 (depth = 2)
  gc_frame_end(frame);
  return bool3559;
}
Object meth_collectionsPrelude_contains_40_1_41_3560(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part contains(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1617
  setline(1617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3561 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  gc_frame_newslot(*var_v);
// call case 4: self request
  params[0] = *var_v;
  partcv[0] = 1;
  Object call3562 = callmethodflags(self, "containsValue(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3561);
// compiled call node returning call3562 (depth = 2)
  gc_frame_end(frame);
  return call3562;
}
Object meth_collectionsPrelude__apply3576(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_t = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3578 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3579 = gc_frame_new();
// call case 4: self request
  Object call3580 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3579);
// compiled member node returning call3580 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3581 = callmethodflags(call3580, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3578);
// compiled call node returning call3581 (depth = 5)
  int op_slot_right_3577 = gc_frame_newslot(call3581);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  int op_slot_left_3577 = gc_frame_newslot(*var_unused);
  params[0] = call3581;
  partcv[0] = 1;
  Object opresult3583 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3583 (depth = 4)
  gc_frame_end(frame);
  return opresult3583;
}
Object meth_collectionsPrelude__apply3586(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_x = getfromclosure(closure, 0);
  Object *var_t = getfromclosure(closure, 1);
  Object *var_jump = getfromclosure(closure, 2);
  Object *var_s = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1625
  setline(1625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  int op_slot_right_3588 = gc_frame_newslot(*var_x);
// starting to compile member node (depth = 6)
  int callframe3590 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe3591 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3592 = gc_frame_new();
// call case 4: self request
  Object call3593 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3592);
// compiled member node returning call3593 (depth = 8)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3594 = callmethodflags(call3593, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3591);
// compiled call node returning call3594 (depth = 7)
  Object call3595 = callmethodflags(call3594, "key", 0, partcv, params, 0);
  gc_frame_end(callframe3590);
// compiled member node returning call3595 (depth = 6)
  int op_slot_left_3588 = gc_frame_newslot(call3595);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult3596 = callmethod(call3595, "==(1)", 1, partcv, params);
// compiled op node returning opresult3596 (depth = 5)
  Object if3587 = done;
  if (istrue(opresult3596)) {
// Begin line 1626
  setline(1626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  block_return(realself, *var_t);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if3587 = undefined;
  } else {
  }
// compiled if node returning if3587 (depth = 4)
// Begin line 1628
  setline(1628);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3599 = alloc_Float64(0);
// compiled num node returning num3599 (depth = 6)
  int op_slot_right_3598 = gc_frame_newslot(num3599);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_jump (depth = 6)
  int op_slot_left_3598 = gc_frame_newslot(*var_jump);
  params[0] = num3599;
  partcv[0] = 1;
  Object opresult3601 = callmethod(*var_jump, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3601 (depth = 5)
  Object if3597 = done;
  if (istrue(opresult3601)) {
// Begin line 1629
  setline(1629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_3602 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3605 = alloc_Float64(1);
// compiled num node returning num3605 (depth = 8)
  int op_slot_right_3604 = gc_frame_newslot(num3605);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3608 = alloc_Float64(3);
// compiled num node returning num3608 (depth = 9)
  int op_slot_right_3607 = gc_frame_newslot(num3608);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  int op_slot_left_3607 = gc_frame_newslot(*var_t);
  params[0] = num3608;
  partcv[0] = 1;
  Object prod3610 = callmethod(*var_t, "*(1)", 1, partcv, params);
// compiled op node returning prod3610 (depth = 8)
  int op_slot_left_3604 = gc_frame_newslot(prod3610);
  params[0] = num3605;
  partcv[0] = 1;
  Object sum3611 = callmethod(prod3610, "+(1)", 1, partcv, params);
// compiled op node returning sum3611 (depth = 7)
  int op_slot_left_3602 = gc_frame_newslot(sum3611);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3612 = callmethod(sum3611, "%(1)", 1, partcv, params);
// compiled op node returning modulus3612 (depth = 6)
  *var_t = modulus3612;
  if (modulus3612 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1630
  setline(1630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3615 = alloc_Float64(1);
// compiled num node returning num3615 (depth = 7)
  int op_slot_right_3614 = gc_frame_newslot(num3615);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_jump (depth = 7)
  int op_slot_left_3614 = gc_frame_newslot(*var_jump);
  params[0] = num3615;
  partcv[0] = 1;
  Object diff3617 = callmethod(*var_jump, "-(1)", 1, partcv, params);
// compiled op node returning diff3617 (depth = 6)
  *var_jump = diff3617;
  if (diff3617 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3597 = done;
  } else {
// Begin line 1632
  setline(1632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_3619 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3622 = alloc_Float64(1);
// compiled num node returning num3622 (depth = 8)
  int op_slot_right_3621 = gc_frame_newslot(num3622);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  int op_slot_left_3621 = gc_frame_newslot(*var_t);
  params[0] = num3622;
  partcv[0] = 1;
  Object sum3624 = callmethod(*var_t, "+(1)", 1, partcv, params);
// compiled op node returning sum3624 (depth = 7)
  int op_slot_left_3619 = gc_frame_newslot(sum3624);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3625 = callmethod(sum3624, "%(1)", 1, partcv, params);
// compiled op node returning modulus3625 (depth = 6)
  *var_t = modulus3625;
  if (modulus3625 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3597 = done;
  }
// compiled if node returning if3597 (depth = 4)
  gc_frame_end(frame);
  return if3597;
}
Object meth_collectionsPrelude_findPosition_40_1_41_3563(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findPosition(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findPosition(_)");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findPosition(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part findPosition(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_h = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "h");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_t = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "t");
  Object *var_jump = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "jump");
// Begin line 1620
  setline(1620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe3564 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  Object call3565 = callmethodflags(*var_x, "hash", 0, partcv, params, 0);
  gc_frame_end(callframe3564);
// compiled member node returning call3565 (depth = 3)
  *var_h = call3565;
  if (call3565 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1621
  setline(1621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe3566 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3567 = gc_frame_new();
// call case 4: self request
  Object call3568 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3567);
// compiled member node returning call3568 (depth = 4)
  Object call3569 = callmethodflags(call3568, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3566);
// compiled member node returning call3569 (depth = 3)
  *var_s = call3569;
  if (call3569 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1622
  setline(1622);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_right_3570 = gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_h (depth = 4)
  int op_slot_left_3570 = gc_frame_newslot(*var_h);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3572 = callmethod(*var_h, "%(1)", 1, partcv, params);
// compiled op node returning modulus3572 (depth = 3)
  *var_t = modulus3572;
  if (modulus3572 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1623
  setline(1623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num3573 = alloc_Float64(5);
// compiled num node returning num3573 (depth = 3)
  *var_jump = num3573;
  if (num3573 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1624
  setline(1624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3574 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3575 = alloc_Block(NULL, NULL, "collectionsPrelude", 1624);
  gc_frame_newslot(block3575);
// method "_apply"
  block_savedest(block3575);
  Object closure3576 = createclosure(3, "_apply");
  setclosureframe(closure3576, stackframe);
  addtoclosure(closure3576, var_t);
  addtoclosure(closure3576, var_unused);
  addtoclosure(closure3576, selfslot);
  struct UserObject *uo3576 = (struct UserObject*)block3575;
  uo3576->data[0] = (Object)closure3576;
  Method *meth_meth_collectionsPrelude__apply3576 = addmethod2pos(block3575, "_apply", &meth_collectionsPrelude__apply3576, 0);
  int argcv_meth_collectionsPrelude__apply3576[] = {0};
  meth_meth_collectionsPrelude__apply3576->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3576);
  meth_meth_collectionsPrelude__apply3576->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3576->definitionLine = 1963;
// compiled block node returning block3575 (depth = 3)
  gc_frame_newslot(block3575);
// starting to compile block node (depth = 3)
  Object block3585 = alloc_Block(NULL, NULL, "collectionsPrelude", 1624);
  gc_frame_newslot(block3585);
// method "_apply"
  block_savedest(block3585);
  Object closure3586 = createclosure(5, "_apply");
  setclosureframe(closure3586, stackframe);
  addtoclosure(closure3586, var_x);
  addtoclosure(closure3586, var_t);
  addtoclosure(closure3586, var_jump);
  addtoclosure(closure3586, var_s);
  addtoclosure(closure3586, selfslot);
  struct UserObject *uo3586 = (struct UserObject*)block3585;
  uo3586->data[0] = (Object)closure3586;
  Method *meth_meth_collectionsPrelude__apply3586 = addmethod2pos(block3585, "_apply", &meth_collectionsPrelude__apply3586, 0);
  int argcv_meth_collectionsPrelude__apply3586[] = {0};
  meth_meth_collectionsPrelude__apply3586->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3586);
  meth_meth_collectionsPrelude__apply3586->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3586->definitionLine = 1963;
// compiled block node returning block3585 (depth = 3)
  gc_frame_newslot(block3585);
// call case 5: prelude request
  params[0] = block3575;
  params[1] = block3585;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3628 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3574);
// compiled call node returning call3628 (depth = 2)
// Begin line 1635
  setline(1635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  return *var_t;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply3642(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_t = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3645 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3646 = gc_frame_new();
// call case 4: self request
  Object call3647 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3646);
// compiled member node returning call3647 (depth = 7)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3648 = callmethodflags(call3647, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3645);
// compiled call node returning call3648 (depth = 6)
  int op_slot_right_3644 = gc_frame_newslot(call3648);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  int op_slot_left_3644 = gc_frame_newslot(*var_removed);
  params[0] = call3648;
  partcv[0] = 1;
  Object opresult3650 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3650 (depth = 5)
  int op_slot_right_3643 = gc_frame_newslot(opresult3650);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3653 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe3654 = gc_frame_new();
// call case 4: self request
  Object call3655 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3654);
// compiled member node returning call3655 (depth = 7)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3656 = callmethodflags(call3655, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3653);
// compiled call node returning call3656 (depth = 6)
  int op_slot_right_3652 = gc_frame_newslot(call3656);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_unused (depth = 6)
  int op_slot_left_3652 = gc_frame_newslot(*var_unused);
  params[0] = call3656;
  partcv[0] = 1;
  Object opresult3658 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3658 (depth = 5)
  int op_slot_left_3643 = gc_frame_newslot(opresult3658);
  params[0] = opresult3650;
  partcv[0] = 1;
  Object opresult3659 = callmethod(opresult3658, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3659 (depth = 4)
  gc_frame_end(frame);
  return opresult3659;
}
Object meth_collectionsPrelude__apply3662(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_x = getfromclosure(closure, 0);
  Object *var_t = getfromclosure(closure, 1);
  Object *var_jump = getfromclosure(closure, 2);
  Object *var_s = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1643
  setline(1643);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  int op_slot_right_3664 = gc_frame_newslot(*var_x);
// starting to compile member node (depth = 6)
  int callframe3666 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 7)
  int callframe3667 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  gc_frame_newslot(*var_t);
// call case 6: other requests
// starting to compile member node (depth = 8)
  int callframe3668 = gc_frame_new();
// call case 4: self request
  Object call3669 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3668);
// compiled member node returning call3669 (depth = 8)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3670 = callmethodflags(call3669, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3667);
// compiled call node returning call3670 (depth = 7)
  Object call3671 = callmethodflags(call3670, "key", 0, partcv, params, 0);
  gc_frame_end(callframe3666);
// compiled member node returning call3671 (depth = 6)
  int op_slot_left_3664 = gc_frame_newslot(call3671);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult3672 = callmethod(call3671, "==(1)", 1, partcv, params);
// compiled op node returning opresult3672 (depth = 5)
  Object if3663 = done;
  if (istrue(opresult3672)) {
// Begin line 1644
  setline(1644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  block_return(realself, *var_t);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if3663 = undefined;
  } else {
  }
// compiled if node returning if3663 (depth = 4)
// Begin line 1646
  setline(1646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3675 = alloc_Float64(0);
// compiled num node returning num3675 (depth = 6)
  int op_slot_right_3674 = gc_frame_newslot(num3675);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_jump (depth = 6)
  int op_slot_left_3674 = gc_frame_newslot(*var_jump);
  params[0] = num3675;
  partcv[0] = 1;
  Object opresult3677 = callmethod(*var_jump, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3677 (depth = 5)
  Object if3673 = done;
  if (istrue(opresult3677)) {
// Begin line 1647
  setline(1647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_3678 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3681 = alloc_Float64(1);
// compiled num node returning num3681 (depth = 8)
  int op_slot_right_3680 = gc_frame_newslot(num3681);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3684 = alloc_Float64(3);
// compiled num node returning num3684 (depth = 9)
  int op_slot_right_3683 = gc_frame_newslot(num3684);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  int op_slot_left_3683 = gc_frame_newslot(*var_t);
  params[0] = num3684;
  partcv[0] = 1;
  Object prod3686 = callmethod(*var_t, "*(1)", 1, partcv, params);
// compiled op node returning prod3686 (depth = 8)
  int op_slot_left_3680 = gc_frame_newslot(prod3686);
  params[0] = num3681;
  partcv[0] = 1;
  Object sum3687 = callmethod(prod3686, "+(1)", 1, partcv, params);
// compiled op node returning sum3687 (depth = 7)
  int op_slot_left_3678 = gc_frame_newslot(sum3687);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3688 = callmethod(sum3687, "%(1)", 1, partcv, params);
// compiled op node returning modulus3688 (depth = 6)
  *var_t = modulus3688;
  if (modulus3688 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 1648
  setline(1648);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3691 = alloc_Float64(1);
// compiled num node returning num3691 (depth = 7)
  int op_slot_right_3690 = gc_frame_newslot(num3691);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_jump (depth = 7)
  int op_slot_left_3690 = gc_frame_newslot(*var_jump);
  params[0] = num3691;
  partcv[0] = 1;
  Object diff3693 = callmethod(*var_jump, "-(1)", 1, partcv, params);
// compiled op node returning diff3693 (depth = 6)
  *var_jump = diff3693;
  if (diff3693 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3673 = done;
  } else {
// Begin line 1650
  setline(1650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_3695 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3698 = alloc_Float64(1);
// compiled num node returning num3698 (depth = 8)
  int op_slot_right_3697 = gc_frame_newslot(num3698);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  int op_slot_left_3697 = gc_frame_newslot(*var_t);
  params[0] = num3698;
  partcv[0] = 1;
  Object sum3700 = callmethod(*var_t, "+(1)", 1, partcv, params);
// compiled op node returning sum3700 (depth = 7)
  int op_slot_left_3695 = gc_frame_newslot(sum3700);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3701 = callmethod(sum3700, "%(1)", 1, partcv, params);
// compiled op node returning modulus3701 (depth = 6)
  *var_t = modulus3701;
  if (modulus3701 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3673 = done;
  }
// compiled if node returning if3673 (depth = 4)
  gc_frame_end(frame);
  return if3673;
}
Object meth_collectionsPrelude_findPositionForAdd_40_1_41_3629(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findPositionForAdd(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findPositionForAdd(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findPositionForAdd(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part findPositionForAdd(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_h = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "h");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_t = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "t");
  Object *var_jump = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "jump");
// Begin line 1638
  setline(1638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe3630 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  Object call3631 = callmethodflags(*var_x, "hash", 0, partcv, params, 0);
  gc_frame_end(callframe3630);
// compiled member node returning call3631 (depth = 3)
  *var_h = call3631;
  if (call3631 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1639
  setline(1639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe3632 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3633 = gc_frame_new();
// call case 4: self request
  Object call3634 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3633);
// compiled member node returning call3634 (depth = 4)
  Object call3635 = callmethodflags(call3634, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3632);
// compiled member node returning call3635 (depth = 3)
  *var_s = call3635;
  if (call3635 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1640
  setline(1640);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_right_3636 = gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_h (depth = 4)
  int op_slot_left_3636 = gc_frame_newslot(*var_h);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3638 = callmethod(*var_h, "%(1)", 1, partcv, params);
// compiled op node returning modulus3638 (depth = 3)
  *var_t = modulus3638;
  if (modulus3638 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1641
  setline(1641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num3639 = alloc_Float64(5);
// compiled num node returning num3639 (depth = 3)
  *var_jump = num3639;
  if (num3639 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1642
  setline(1642);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3640 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3641 = alloc_Block(NULL, NULL, "collectionsPrelude", 1642);
  gc_frame_newslot(block3641);
// method "_apply"
  block_savedest(block3641);
  Object closure3642 = createclosure(4, "_apply");
  setclosureframe(closure3642, stackframe);
  addtoclosure(closure3642, var_t);
  addtoclosure(closure3642, var_removed);
  addtoclosure(closure3642, var_unused);
  addtoclosure(closure3642, selfslot);
  struct UserObject *uo3642 = (struct UserObject*)block3641;
  uo3642->data[0] = (Object)closure3642;
  Method *meth_meth_collectionsPrelude__apply3642 = addmethod2pos(block3641, "_apply", &meth_collectionsPrelude__apply3642, 0);
  int argcv_meth_collectionsPrelude__apply3642[] = {0};
  meth_meth_collectionsPrelude__apply3642->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3642);
  meth_meth_collectionsPrelude__apply3642->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3642->definitionLine = 1963;
// compiled block node returning block3641 (depth = 3)
  gc_frame_newslot(block3641);
// starting to compile block node (depth = 3)
  Object block3661 = alloc_Block(NULL, NULL, "collectionsPrelude", 1642);
  gc_frame_newslot(block3661);
// method "_apply"
  block_savedest(block3661);
  Object closure3662 = createclosure(5, "_apply");
  setclosureframe(closure3662, stackframe);
  addtoclosure(closure3662, var_x);
  addtoclosure(closure3662, var_t);
  addtoclosure(closure3662, var_jump);
  addtoclosure(closure3662, var_s);
  addtoclosure(closure3662, selfslot);
  struct UserObject *uo3662 = (struct UserObject*)block3661;
  uo3662->data[0] = (Object)closure3662;
  Method *meth_meth_collectionsPrelude__apply3662 = addmethod2pos(block3661, "_apply", &meth_collectionsPrelude__apply3662, 0);
  int argcv_meth_collectionsPrelude__apply3662[] = {0};
  meth_meth_collectionsPrelude__apply3662->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3662);
  meth_meth_collectionsPrelude__apply3662->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3662->definitionLine = 1963;
// compiled block node returning block3661 (depth = 3)
  gc_frame_newslot(block3661);
// call case 5: prelude request
  params[0] = block3641;
  params[1] = block3661;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3704 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3640);
// compiled call node returning call3704 (depth = 2)
// Begin line 1653
  setline(1653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  return *var_t;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply_40_1_41_3722(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_firstElement = getfromclosure(closure, 2);
  Object *var_s = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1661
  setline(1661);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3723 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3724 = gc_frame_new();
// call case 4: self request
  Object call3725 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3724);
// compiled member node returning call3725 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call3726 = callmethodflags(call3725, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3723);
// compiled call node returning call3726 (depth = 5)
  *var_a = call3726;
  if (call3726 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1662
  setline(1662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_3729 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_3729 = gc_frame_newslot(*var_removed);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult3731 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3731 (depth = 6)
  int op_slot_right_3728 = gc_frame_newslot(opresult3731);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_3733 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_3733 = gc_frame_newslot(*var_unused);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult3735 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3735 (depth = 6)
  int op_slot_left_3728 = gc_frame_newslot(opresult3735);
  params[0] = opresult3731;
  partcv[0] = 1;
  Object opresult3736 = callmethod(opresult3735, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3736 (depth = 5)
  Object if3727 = done;
  if (istrue(opresult3736)) {
// Begin line 1663
  setline(1663);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3738 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_firstElement (depth = 7)
  partcv[0] = 0;
  Object call3739 = callmethodflags(*var_firstElement, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe3738);
// compiled call node returning call3739 (depth = 6)
  Object if3737 = done;
  if (istrue(call3739)) {
// Begin line 1664
  setline(1664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3741 == NULL) {
    strlit3741 = alloc_String(", ");
    gc_root(strlit3741);
  }
// compiled string node returning strlit3741 (depth = 8)
  int op_slot_right_3740 = gc_frame_newslot(strlit3741);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_3740 = gc_frame_newslot(*var_s);
  params[0] = strlit3741;
  partcv[0] = 1;
  Object opresult3743 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3743 (depth = 7)
  *var_s = opresult3743;
  if (opresult3743 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if3737 = done;
  } else {
// Begin line 1666
  setline(1666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool3745 = alloc_Boolean(0);
// compiled identifier node returning bool3745 (depth = 7)
  *var_firstElement = bool3745;
  if (bool3745 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if3737 = done;
  }
// compiled if node returning if3737 (depth = 5)
// Begin line 1668
  setline(1668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3749 == NULL) {
    strlit3749 = alloc_String("");
    gc_root(strlit3749);
  }
// compiled string node returning strlit3749 (depth = 8)
  int op_slot_right_3748 = gc_frame_newslot(strlit3749);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe3752 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_a (depth = 10)
  Object call3753 = callmethodflags(*var_a, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3752);
// compiled member node returning call3753 (depth = 9)
  int op_slot_right_3751 = gc_frame_newslot(call3753);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3756 == NULL) {
    strlit3756 = alloc_String("::");
    gc_root(strlit3756);
  }
// compiled string node returning strlit3756 (depth = 10)
  int op_slot_right_3755 = gc_frame_newslot(strlit3756);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
  int callframe3759 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_a (depth = 12)
  Object call3760 = callmethodflags(*var_a, "key", 0, partcv, params, 0);
  gc_frame_end(callframe3759);
// compiled member node returning call3760 (depth = 11)
  int op_slot_right_3758 = gc_frame_newslot(call3760);
// starting to compile string node (depth = 11)
  if (strlit3762 == NULL) {
    strlit3762 = alloc_String("");
    gc_root(strlit3762);
  }
// compiled string node returning strlit3762 (depth = 11)
  int op_slot_left_3758 = gc_frame_newslot(strlit3762);
  params[0] = call3760;
  partcv[0] = 1;
  Object opresult3763 = callmethod(strlit3762, "++(1)", 1, partcv, params);
// compiled op node returning opresult3763 (depth = 10)
  int op_slot_left_3755 = gc_frame_newslot(opresult3763);
  params[0] = strlit3756;
  partcv[0] = 1;
  Object opresult3764 = callmethod(opresult3763, "++(1)", 1, partcv, params);
// compiled op node returning opresult3764 (depth = 9)
  int op_slot_left_3751 = gc_frame_newslot(opresult3764);
  params[0] = call3753;
  partcv[0] = 1;
  Object opresult3765 = callmethod(opresult3764, "++(1)", 1, partcv, params);
// compiled op node returning opresult3765 (depth = 8)
  int op_slot_left_3748 = gc_frame_newslot(opresult3765);
  params[0] = strlit3749;
  partcv[0] = 1;
  Object opresult3766 = callmethod(opresult3765, "++(1)", 1, partcv, params);
// compiled op node returning opresult3766 (depth = 7)
  int op_slot_right_3747 = gc_frame_newslot(opresult3766);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3747 = gc_frame_newslot(*var_s);
  params[0] = opresult3766;
  partcv[0] = 1;
  Object opresult3768 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3768 (depth = 6)
  *var_s = opresult3768;
  if (opresult3768 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3727 = done;
  } else {
  }
// compiled if node returning if3727 (depth = 4)
  gc_frame_end(frame);
  return if3727;
}
Object meth_collectionsPrelude_asString3705(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
  Object *var_firstElement = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "firstElement");
// Begin line 1658
  setline(1658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3706 == NULL) {
    strlit3706 = alloc_String("dict""\xe2""""\x9f""""\xac""");
    gc_root(strlit3706);
  }
// compiled string node returning strlit3706 (depth = 3)
  *var_s = strlit3706;
  if (strlit3706 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1659
  setline(1659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool3707 = alloc_Boolean(1);
// compiled identifier node returning bool3707 (depth = 3)
  *var_firstElement = bool3707;
  if (bool3707 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1660
  setline(1660);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3708 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3711 = alloc_Float64(1);
// compiled num node returning num3711 (depth = 5)
  int op_slot_right_3710 = gc_frame_newslot(num3711);
// starting to compile member node (depth = 5)
  int callframe3713 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3714 = gc_frame_new();
// call case 4: self request
  Object call3715 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3714);
// compiled member node returning call3715 (depth = 6)
  Object call3716 = callmethodflags(call3715, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3713);
// compiled member node returning call3716 (depth = 5)
  int op_slot_left_3710 = gc_frame_newslot(call3716);
  params[0] = num3711;
  partcv[0] = 1;
  Object diff3717 = callmethod(call3716, "-(1)", 1, partcv, params);
// compiled op node returning diff3717 (depth = 4)
  int op_slot_right_3709 = gc_frame_newslot(diff3717);
// starting to compile num node (depth = 4)
  Object num3719 = alloc_Float64(0);
// compiled num node returning num3719 (depth = 4)
  int op_slot_left_3709 = gc_frame_newslot(num3719);
  params[0] = diff3717;
  partcv[0] = 1;
  Object opresult3720 = callmethod(num3719, "..(1)", 1, partcv, params);
// compiled op node returning opresult3720 (depth = 3)
  gc_frame_newslot(opresult3720);
// starting to compile block node (depth = 3)
  Object block3721 = alloc_Block(NULL, NULL, "collectionsPrelude", 1660);
  gc_frame_newslot(block3721);
// method "_apply(_)"
  block_savedest(block3721);
  Object closure3722 = createclosure(5, "_apply(1)");
  setclosureframe(closure3722, stackframe);
  addtoclosure(closure3722, var_removed);
  addtoclosure(closure3722, var_unused);
  addtoclosure(closure3722, var_firstElement);
  addtoclosure(closure3722, var_s);
  addtoclosure(closure3722, selfslot);
  struct UserObject *uo3722 = (struct UserObject*)block3721;
  uo3722->data[0] = (Object)closure3722;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3722 = addmethod2pos(block3721, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3722, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3722[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3722->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3722);
  meth_meth_collectionsPrelude__apply_40_1_41_3722->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3722->definitionLine = 1963;
// compiled block node returning block3721 (depth = 3)
  gc_frame_newslot(block3721);
// call case 5: prelude request
  params[0] = opresult3720;
  params[1] = block3721;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3771 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3708);
// compiled call node returning call3771 (depth = 2)
// Begin line 1671
  setline(1671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3773 == NULL) {
    strlit3773 = alloc_String("""\xe2""""\x9f""""\xad""");
    gc_root(strlit3773);
  }
// compiled string node returning strlit3773 (depth = 3)
  int op_slot_right_3772 = gc_frame_newslot(strlit3773);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_3772 = gc_frame_newslot(*var_s);
  params[0] = strlit3773;
  partcv[0] = 1;
  Object opresult3775 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3775 (depth = 2)
  gc_frame_end(frame);
  return opresult3775;
}
Object meth_collectionsPrelude__apply_40_1_41_3792(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1676
  setline(1676);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3795 = alloc_Float64(0);
// compiled num node returning num3795 (depth = 6)
  int op_slot_right_3794 = gc_frame_newslot(num3795);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_3794 = gc_frame_newslot(*var_i);
  params[0] = num3795;
  partcv[0] = 1;
  Object opresult3797 = callmethod(*var_i, ">(1)", 1, partcv, params);
// compiled op node returning opresult3797 (depth = 5)
  Object if3793 = done;
  if (istrue(opresult3797)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3799 == NULL) {
    strlit3799 = alloc_String(", ");
    gc_root(strlit3799);
  }
// compiled string node returning strlit3799 (depth = 7)
  int op_slot_right_3798 = gc_frame_newslot(strlit3799);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3798 = gc_frame_newslot(*var_s);
  params[0] = strlit3799;
  partcv[0] = 1;
  Object opresult3801 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3801 (depth = 6)
  *var_s = opresult3801;
  if (opresult3801 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3793 = done;
  } else {
  }
// compiled if node returning if3793 (depth = 4)
// Begin line 1677
  setline(1677);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3803 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3804 = gc_frame_new();
// call case 4: self request
  Object call3805 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3804);
// compiled member node returning call3805 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call3806 = callmethodflags(call3805, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe3803);
// compiled call node returning call3806 (depth = 5)
  *var_a = call3806;
  if (call3806 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1678
  setline(1678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_3809 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_3809 = gc_frame_newslot(*var_removed);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult3811 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3811 (depth = 6)
  int op_slot_right_3808 = gc_frame_newslot(opresult3811);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_3813 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_3813 = gc_frame_newslot(*var_unused);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult3815 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult3815 (depth = 6)
  int op_slot_left_3808 = gc_frame_newslot(opresult3815);
  params[0] = opresult3811;
  partcv[0] = 1;
  Object opresult3816 = callmethod(opresult3815, "&&(1)", 1, partcv, params);
// compiled op node returning opresult3816 (depth = 5)
  Object if3807 = done;
  if (istrue(opresult3816)) {
// Begin line 1679
  setline(1679);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3819 == NULL) {
    strlit3819 = alloc_String("");
    gc_root(strlit3819);
  }
// compiled string node returning strlit3819 (depth = 8)
  int op_slot_right_3818 = gc_frame_newslot(strlit3819);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe3822 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_a (depth = 10)
  Object call3823 = callmethodflags(*var_a, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3822);
// compiled member node returning call3823 (depth = 9)
  int op_slot_right_3821 = gc_frame_newslot(call3823);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3826 == NULL) {
    strlit3826 = alloc_String("::");
    gc_root(strlit3826);
  }
// compiled string node returning strlit3826 (depth = 10)
  int op_slot_right_3825 = gc_frame_newslot(strlit3826);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
  int callframe3829 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_a (depth = 12)
  Object call3830 = callmethodflags(*var_a, "key", 0, partcv, params, 0);
  gc_frame_end(callframe3829);
// compiled member node returning call3830 (depth = 11)
  int op_slot_right_3828 = gc_frame_newslot(call3830);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit3833 == NULL) {
    strlit3833 = alloc_String("""\xe2""""\x86""""\x92""");
    gc_root(strlit3833);
  }
// compiled string node returning strlit3833 (depth = 12)
  int op_slot_right_3832 = gc_frame_newslot(strlit3833);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_i (depth = 13)
  int op_slot_right_3835 = gc_frame_newslot(*var_i);
// starting to compile string node (depth = 13)
  if (strlit3837 == NULL) {
    strlit3837 = alloc_String("");
    gc_root(strlit3837);
  }
// compiled string node returning strlit3837 (depth = 13)
  int op_slot_left_3835 = gc_frame_newslot(strlit3837);
  params[0] = *var_i;
  partcv[0] = 1;
  Object opresult3838 = callmethod(strlit3837, "++(1)", 1, partcv, params);
// compiled op node returning opresult3838 (depth = 12)
  int op_slot_left_3832 = gc_frame_newslot(opresult3838);
  params[0] = strlit3833;
  partcv[0] = 1;
  Object opresult3839 = callmethod(opresult3838, "++(1)", 1, partcv, params);
// compiled op node returning opresult3839 (depth = 11)
  int op_slot_left_3828 = gc_frame_newslot(opresult3839);
  params[0] = call3830;
  partcv[0] = 1;
  Object opresult3840 = callmethod(opresult3839, "++(1)", 1, partcv, params);
// compiled op node returning opresult3840 (depth = 10)
  int op_slot_left_3825 = gc_frame_newslot(opresult3840);
  params[0] = strlit3826;
  partcv[0] = 1;
  Object opresult3841 = callmethod(opresult3840, "++(1)", 1, partcv, params);
// compiled op node returning opresult3841 (depth = 9)
  int op_slot_left_3821 = gc_frame_newslot(opresult3841);
  params[0] = call3823;
  partcv[0] = 1;
  Object opresult3842 = callmethod(opresult3841, "++(1)", 1, partcv, params);
// compiled op node returning opresult3842 (depth = 8)
  int op_slot_left_3818 = gc_frame_newslot(opresult3842);
  params[0] = strlit3819;
  partcv[0] = 1;
  Object opresult3843 = callmethod(opresult3842, "++(1)", 1, partcv, params);
// compiled op node returning opresult3843 (depth = 7)
  int op_slot_right_3817 = gc_frame_newslot(opresult3843);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3817 = gc_frame_newslot(*var_s);
  params[0] = opresult3843;
  partcv[0] = 1;
  Object opresult3845 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3845 (depth = 6)
  *var_s = opresult3845;
  if (opresult3845 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3807 = done;
  } else {
// Begin line 1681
  setline(1681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3849 == NULL) {
    strlit3849 = alloc_String("");
    gc_root(strlit3849);
  }
// compiled string node returning strlit3849 (depth = 8)
  int op_slot_right_3848 = gc_frame_newslot(strlit3849);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
  int callframe3852 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_a (depth = 10)
  Object call3853 = callmethodflags(*var_a, "asDebugString", 0, partcv, params, 0);
  gc_frame_end(callframe3852);
// compiled member node returning call3853 (depth = 9)
  int op_slot_right_3851 = gc_frame_newslot(call3853);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3856 == NULL) {
    strlit3856 = alloc_String("""\xe2""""\x86""""\x92""");
    gc_root(strlit3856);
  }
// compiled string node returning strlit3856 (depth = 10)
  int op_slot_right_3855 = gc_frame_newslot(strlit3856);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_i (depth = 11)
  int op_slot_right_3858 = gc_frame_newslot(*var_i);
// starting to compile string node (depth = 11)
  if (strlit3860 == NULL) {
    strlit3860 = alloc_String("");
    gc_root(strlit3860);
  }
// compiled string node returning strlit3860 (depth = 11)
  int op_slot_left_3858 = gc_frame_newslot(strlit3860);
  params[0] = *var_i;
  partcv[0] = 1;
  Object opresult3861 = callmethod(strlit3860, "++(1)", 1, partcv, params);
// compiled op node returning opresult3861 (depth = 10)
  int op_slot_left_3855 = gc_frame_newslot(opresult3861);
  params[0] = strlit3856;
  partcv[0] = 1;
  Object opresult3862 = callmethod(opresult3861, "++(1)", 1, partcv, params);
// compiled op node returning opresult3862 (depth = 9)
  int op_slot_left_3851 = gc_frame_newslot(opresult3862);
  params[0] = call3853;
  partcv[0] = 1;
  Object opresult3863 = callmethod(opresult3862, "++(1)", 1, partcv, params);
// compiled op node returning opresult3863 (depth = 8)
  int op_slot_left_3848 = gc_frame_newslot(opresult3863);
  params[0] = strlit3849;
  partcv[0] = 1;
  Object opresult3864 = callmethod(opresult3863, "++(1)", 1, partcv, params);
// compiled op node returning opresult3864 (depth = 7)
  int op_slot_right_3847 = gc_frame_newslot(opresult3864);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3847 = gc_frame_newslot(*var_s);
  params[0] = opresult3864;
  partcv[0] = 1;
  Object opresult3866 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3866 (depth = 6)
  *var_s = opresult3866;
  if (opresult3866 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3807 = done;
  }
// compiled if node returning if3807 (depth = 4)
  gc_frame_end(frame);
  return if3807;
}
Object meth_collectionsPrelude_asDebugString3776(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 1674
  setline(1674);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3777 == NULL) {
    strlit3777 = alloc_String("dict""\xe2""""\x9f""""\xac""");
    gc_root(strlit3777);
  }
// compiled string node returning strlit3777 (depth = 3)
  *var_s = strlit3777;
  if (strlit3777 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1675
  setline(1675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3778 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3781 = alloc_Float64(1);
// compiled num node returning num3781 (depth = 5)
  int op_slot_right_3780 = gc_frame_newslot(num3781);
// starting to compile member node (depth = 5)
  int callframe3783 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe3784 = gc_frame_new();
// call case 4: self request
  Object call3785 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3784);
// compiled member node returning call3785 (depth = 6)
  Object call3786 = callmethodflags(call3785, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3783);
// compiled member node returning call3786 (depth = 5)
  int op_slot_left_3780 = gc_frame_newslot(call3786);
  params[0] = num3781;
  partcv[0] = 1;
  Object diff3787 = callmethod(call3786, "-(1)", 1, partcv, params);
// compiled op node returning diff3787 (depth = 4)
  int op_slot_right_3779 = gc_frame_newslot(diff3787);
// starting to compile num node (depth = 4)
  Object num3789 = alloc_Float64(0);
// compiled num node returning num3789 (depth = 4)
  int op_slot_left_3779 = gc_frame_newslot(num3789);
  params[0] = diff3787;
  partcv[0] = 1;
  Object opresult3790 = callmethod(num3789, "..(1)", 1, partcv, params);
// compiled op node returning opresult3790 (depth = 3)
  gc_frame_newslot(opresult3790);
// starting to compile block node (depth = 3)
  Object block3791 = alloc_Block(NULL, NULL, "collectionsPrelude", 1675);
  gc_frame_newslot(block3791);
// method "_apply(_)"
  block_savedest(block3791);
  Object closure3792 = createclosure(4, "_apply(1)");
  setclosureframe(closure3792, stackframe);
  addtoclosure(closure3792, var_s);
  addtoclosure(closure3792, var_removed);
  addtoclosure(closure3792, var_unused);
  addtoclosure(closure3792, selfslot);
  struct UserObject *uo3792 = (struct UserObject*)block3791;
  uo3792->data[0] = (Object)closure3792;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_3792 = addmethod2pos(block3791, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_3792, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_3792[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_3792->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_3792);
  meth_meth_collectionsPrelude__apply_40_1_41_3792->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_3792->definitionLine = 1963;
// compiled block node returning block3791 (depth = 3)
  gc_frame_newslot(block3791);
// call case 5: prelude request
  params[0] = opresult3790;
  params[1] = block3791;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3869 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3778);
// compiled call node returning call3869 (depth = 2)
// Begin line 1684
  setline(1684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3871 == NULL) {
    strlit3871 = alloc_String("""\xe2""""\x9f""""\xad""");
    gc_root(strlit3871);
  }
// compiled string node returning strlit3871 (depth = 3)
  int op_slot_right_3870 = gc_frame_newslot(strlit3871);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_3870 = gc_frame_newslot(*var_s);
  params[0] = strlit3871;
  partcv[0] = 1;
  Object opresult3873 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult3873 (depth = 2)
  gc_frame_end(frame);
  return opresult3873;
}
Object meth_collectionsPrelude_hasNext3881(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1692
  setline(1692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3882 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3883 = gc_frame_new();
// call case 4: self request
  Object call3884 = callmethodflags(self, "sourceIterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3883);
// compiled member node returning call3884 (depth = 3)
  Object call3885 = callmethodflags(call3884, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe3882);
// compiled member node returning call3885 (depth = 2)
  gc_frame_end(frame);
  return call3885;
}
Object meth_collectionsPrelude_next3886(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1693
  setline(1693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3887 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3888 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3889 = gc_frame_new();
// call case 4: self request
  Object call3890 = callmethodflags(self, "sourceIterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3889);
// compiled member node returning call3890 (depth = 4)
  Object call3891 = callmethodflags(call3890, "next", 0, partcv, params, 0);
  gc_frame_end(callframe3888);
// compiled member node returning call3891 (depth = 3)
  Object call3892 = callmethodflags(call3891, "key", 0, partcv, params, 0);
  gc_frame_end(callframe3887);
// compiled member node returning call3892 (depth = 2)
  gc_frame_end(frame);
  return call3892;
}
Object meth_collectionsPrelude_asString3893(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1695
  setline(1695);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3895 == NULL) {
    strlit3895 = alloc_String("");
    gc_root(strlit3895);
  }
// compiled string node returning strlit3895 (depth = 3)
  int op_slot_right_3894 = gc_frame_newslot(strlit3895);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  int op_slot_right_3897 = gc_frame_newslot(*var_sourceDictionary);
// starting to compile string node (depth = 4)
  if (strlit3899 == NULL) {
    strlit3899 = alloc_String("an iterator over keys of ");
    gc_root(strlit3899);
  }
// compiled string node returning strlit3899 (depth = 4)
  int op_slot_left_3897 = gc_frame_newslot(strlit3899);
  params[0] = *var_sourceDictionary;
  partcv[0] = 1;
  Object opresult3900 = callmethod(strlit3899, "++(1)", 1, partcv, params);
// compiled op node returning opresult3900 (depth = 3)
  int op_slot_left_3894 = gc_frame_newslot(opresult3900);
  params[0] = strlit3895;
  partcv[0] = 1;
  Object opresult3901 = callmethod(opresult3900, "++(1)", 1, partcv, params);
// compiled op node returning opresult3901 (depth = 2)
  gc_frame_end(frame);
  return opresult3901;
}
Object meth_collectionsPrelude_iterator3877(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3878 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3878 = alloc_userobj2(4,5, objclass3878);
  gc_frame_newslot(obj3878);
if (objclass3878 == NULL) {
  glfree(obj3878->class->name);
  obj3878->class->name = "dictionary.empty.object.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3878, self, 0);
  addmethodreal(obj3878,"outer", &reader_collectionsPrelude_outer_3879);
  Object oldself3878 = self;
  struct StackFrameObject *oldstackframe3878 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3878);
  gc_frame_newslot((Object)stackframe);
  self = obj3878;
  Object *oldselfslot3878 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3878 = (*(struct UserObject *)self).data[0], lowerouter3878 = thisouter3878;
  if (inheritingObject3878) {
    struct UserObject *inho3878 = (struct UserObject *)inheritingObject3878;
    while (inho3878->super != GraceDefaultObject) inho3878 = (struct UserObject *)inho3878->super;
    inho3878->super = obj3878;
    self = inheritingObject3878;
    *selfslot = self;
    lowerouter3878 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3878;
  }
if (objclass3878 == NULL) {
  Method *reader3880 = addmethodrealflags(obj3878, "sourceIterator",&reader_collectionsPrelude_sourceIterator_3880, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader3880->definitionModule = modulename;
  reader3880->definitionLine = 1691;
}
adddatum2(obj3878, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo3881 = (struct UserObject*)obj3878;
  uo3881->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext3881 = addmethod2pos(obj3878, "hasNext", &meth_collectionsPrelude_hasNext3881, 2);
  int argcv_meth_collectionsPrelude_hasNext3881[] = {0};
  meth_meth_collectionsPrelude_hasNext3881->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext3881);
  meth_meth_collectionsPrelude_hasNext3881->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext3881->definitionLine = 1692;
// method "next"
  struct UserObject *uo3886 = (struct UserObject*)obj3878;
  uo3886->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_next3886 = addmethod2pos(obj3878, "next", &meth_collectionsPrelude_next3886, 3);
  int argcv_meth_collectionsPrelude_next3886[] = {0};
  meth_meth_collectionsPrelude_next3886->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next3886);
  meth_meth_collectionsPrelude_next3886->definitionModule = modulename;
  meth_meth_collectionsPrelude_next3886->definitionLine = 1693;
// method "asString"
  block_savedest(obj3878);
  Object closure3893 = createclosure(1, "asString");
  setclosureframe(closure3893, stackframe);
  addtoclosure(closure3893, var_sourceDictionary);
  struct UserObject *uo3893 = (struct UserObject*)obj3878;
  uo3893->data[4] = (Object)closure3893;
  Method *meth_meth_collectionsPrelude_asString3893 = addmethod2pos(obj3878, "asString", &meth_collectionsPrelude_asString3893, 4);
  int argcv_meth_collectionsPrelude_asString3893[] = {0};
  meth_meth_collectionsPrelude_asString3893->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString3893);
  meth_meth_collectionsPrelude_asString3893->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString3893->definitionLine = 1694;
  sourceObject = obj3878;
// Begin line 1691
  setline(1691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3902 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  Object call3903 = callmethodflags(*var_sourceDictionary, "bindingsIterator", 0, partcv, params, 0);
  gc_frame_end(callframe3902);
// compiled member node returning call3903 (depth = 2)
  adddatum2(obj3878, call3903, 1);
  sourceObject = obj3878;
  sourceObject = obj3878;
  sourceObject = obj3878;
  objclass3878 = obj3878->class;
  objclass3878->definitionModule = modulename;
  objclass3878->definitionLine = 1690;
  (*(struct UserObject *)self).data[0] = lowerouter3878;
  self = oldself3878;
  selfslot = oldselfslot3878;
  stackframe = oldstackframe3878;
  gc_frame_end(frame);
  return obj3878;
}
Object meth_collectionsPrelude_iterator3877_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3878 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3878 = alloc_userobj2(4,5, objclass3878);
  gc_frame_newslot(obj3878);
if (objclass3878 == NULL) {
  glfree(obj3878->class->name);
  obj3878->class->name = "dictionary.empty.object.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3878, self, 0);
  addmethodreal(obj3878,"outer", &reader_collectionsPrelude_outer_3879);
  Object oldself3878 = self;
  struct StackFrameObject *oldstackframe3878 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3878);
  gc_frame_newslot((Object)stackframe);
  self = obj3878;
  Object *oldselfslot3878 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3878 = (*(struct UserObject *)self).data[0], lowerouter3878 = thisouter3878;
  if (inheritingObject3878) {
    struct UserObject *inho3878 = (struct UserObject *)inheritingObject3878;
    while (inho3878->super != GraceDefaultObject) inho3878 = (struct UserObject *)inho3878->super;
    inho3878->super = obj3878;
    self = inheritingObject3878;
    *selfslot = self;
    lowerouter3878 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3878;
  }
if (objclass3878 == NULL) {
  Method *reader3880 = addmethodrealflags(obj3878, "sourceIterator",&reader_collectionsPrelude_sourceIterator_3880, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader3880->definitionModule = modulename;
  reader3880->definitionLine = 1691;
}
adddatum2(obj3878, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo3881 = (struct UserObject*)obj3878;
  uo3881->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext3881 = addmethod2pos(obj3878, "hasNext", &meth_collectionsPrelude_hasNext3881, 2);
  int argcv_meth_collectionsPrelude_hasNext3881[] = {0};
  meth_meth_collectionsPrelude_hasNext3881->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext3881);
  meth_meth_collectionsPrelude_hasNext3881->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext3881->definitionLine = 1692;
// method "next"
  struct UserObject *uo3886 = (struct UserObject*)obj3878;
  uo3886->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_next3886 = addmethod2pos(obj3878, "next", &meth_collectionsPrelude_next3886, 3);
  int argcv_meth_collectionsPrelude_next3886[] = {0};
  meth_meth_collectionsPrelude_next3886->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next3886);
  meth_meth_collectionsPrelude_next3886->definitionModule = modulename;
  meth_meth_collectionsPrelude_next3886->definitionLine = 1693;
// method "asString"
  block_savedest(obj3878);
  Object closure3893 = createclosure(1, "asString");
  setclosureframe(closure3893, stackframe);
  addtoclosure(closure3893, var_sourceDictionary);
  struct UserObject *uo3893 = (struct UserObject*)obj3878;
  uo3893->data[4] = (Object)closure3893;
  Method *meth_meth_collectionsPrelude_asString3893 = addmethod2pos(obj3878, "asString", &meth_collectionsPrelude_asString3893, 4);
  int argcv_meth_collectionsPrelude_asString3893[] = {0};
  meth_meth_collectionsPrelude_asString3893->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString3893);
  meth_meth_collectionsPrelude_asString3893->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString3893->definitionLine = 1694;
  sourceObject = obj3878;
// Begin line 1691
  setline(1691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3902 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  Object call3903 = callmethodflags(*var_sourceDictionary, "bindingsIterator", 0, partcv, params, 0);
  gc_frame_end(callframe3902);
// compiled member node returning call3903 (depth = 2)
  adddatum2(obj3878, call3903, 1);
  sourceObject = obj3878;
  sourceObject = obj3878;
  sourceObject = obj3878;
  objclass3878 = obj3878->class;
  objclass3878->definitionModule = modulename;
  objclass3878->definitionLine = 1690;
  (*(struct UserObject *)self).data[0] = lowerouter3878;
  self = oldself3878;
  selfslot = oldselfslot3878;
  stackframe = oldstackframe3878;
  gc_frame_end(frame);
  return obj3878;
}
Object meth_collectionsPrelude_asDebugString3906(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1700
  setline(1700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3908 == NULL) {
    strlit3908 = alloc_String("");
    gc_root(strlit3908);
  }
// compiled string node returning strlit3908 (depth = 3)
  int op_slot_right_3907 = gc_frame_newslot(strlit3908);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  int op_slot_right_3910 = gc_frame_newslot(*var_sourceDictionary);
// starting to compile string node (depth = 4)
  if (strlit3912 == NULL) {
    strlit3912 = alloc_String("a lazy sequence over keys of ");
    gc_root(strlit3912);
  }
// compiled string node returning strlit3912 (depth = 4)
  int op_slot_left_3910 = gc_frame_newslot(strlit3912);
  params[0] = *var_sourceDictionary;
  partcv[0] = 1;
  Object opresult3913 = callmethod(strlit3912, "++(1)", 1, partcv, params);
// compiled op node returning opresult3913 (depth = 3)
  int op_slot_left_3907 = gc_frame_newslot(opresult3913);
  params[0] = strlit3908;
  partcv[0] = 1;
  Object opresult3914 = callmethod(opresult3913, "++(1)", 1, partcv, params);
// compiled op node returning opresult3914 (depth = 2)
  gc_frame_end(frame);
  return opresult3914;
}
Object meth_collectionsPrelude_keys3874(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1687
  setline(1687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3875 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3875 = alloc_userobj2(4,5, objclass3875);
  gc_frame_newslot(obj3875);
if (objclass3875 == NULL) {
  glfree(obj3875->class->name);
  obj3875->class->name = "dictionary.empty.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3875, self, 0);
  addmethodreal(obj3875,"outer", &reader_collectionsPrelude_outer_3876);
  Object oldself3875 = self;
  struct StackFrameObject *oldstackframe3875 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3875);
  gc_frame_newslot((Object)stackframe);
  self = obj3875;
  Object *oldselfslot3875 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3875 = (*(struct UserObject *)self).data[0], lowerouter3875 = thisouter3875;
  if (inheritingObject3875) {
    struct UserObject *inho3875 = (struct UserObject *)inheritingObject3875;
    while (inho3875->super != GraceDefaultObject) inho3875 = (struct UserObject *)inho3875->super;
    inho3875->super = obj3875;
    self = inheritingObject3875;
    *selfslot = self;
    lowerouter3875 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3875;
  }
// method "iterator"
  block_savedest(obj3875);
  Object closure3877 = createclosure(1, "iterator");
  setclosureframe(closure3877, stackframe);
  addtoclosure(closure3877, var_sourceDictionary);
  struct UserObject *uo3877 = (struct UserObject*)obj3875;
  uo3877->data[1] = (Object)closure3877;
  Method *meth_meth_collectionsPrelude_iterator3877 = addmethod2pos(obj3875, "iterator", &meth_collectionsPrelude_iterator3877, 1);
  int argcv_meth_collectionsPrelude_iterator3877[] = {0};
  meth_meth_collectionsPrelude_iterator3877->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator3877);
  meth_meth_collectionsPrelude_iterator3877->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3877->definitionLine = 1690;
  block_savedest(obj3875);
  Object closure3904 = createclosure(1, "iterator$object(1)");
  setclosureframe(closure3904, stackframe);
  addtoclosure(closure3904, var_sourceDictionary);
  Method *meth_meth_collectionsPrelude_iterator3877_object = addmethod2pos(obj3875, "iterator$object(1)", &meth_collectionsPrelude_iterator3877_object, 1);
  meth_meth_collectionsPrelude_iterator3877_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3877_object->definitionLine = 1690;
if (objclass3875 == NULL) {
  Method *reader3905 = addmethodrealflags(obj3875, "size",&reader_collectionsPrelude_size_3905, MFLAG_DEF);
  reader3905->definitionModule = modulename;
  reader3905->definitionLine = 1698;
}
adddatum2(obj3875, alloc_Undefined(), 2);
// method "asDebugString"
  block_savedest(obj3875);
  Object closure3906 = createclosure(1, "asDebugString");
  setclosureframe(closure3906, stackframe);
  addtoclosure(closure3906, var_sourceDictionary);
  struct UserObject *uo3906 = (struct UserObject*)obj3875;
  uo3906->data[3] = (Object)closure3906;
  Method *meth_meth_collectionsPrelude_asDebugString3906 = addmethod2pos(obj3875, "asDebugString", &meth_collectionsPrelude_asDebugString3906, 3);
  int argcv_meth_collectionsPrelude_asDebugString3906[] = {0};
  meth_meth_collectionsPrelude_asDebugString3906->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString3906);
  meth_meth_collectionsPrelude_asDebugString3906->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString3906->definitionLine = 1699;
  sourceObject = obj3875;
// Begin line 1689
  setline(1689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3915 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3916 = callmethodflags(*var_enumerable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3915);
// compiled call node returning call3916 (depth = 2)
  struct UserObject *obj3875_uo = (struct UserObject *)obj3875;
  obj3875_uo->super = call3916;
  sourceObject = obj3875;
  sourceObject = obj3875;
// Begin line 1698
  setline(1698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3917 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  Object call3918 = callmethodflags(*var_sourceDictionary, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3917);
// compiled member node returning call3918 (depth = 2)
  adddatum2(obj3875, call3918, 2);
  sourceObject = obj3875;
  objclass3875 = obj3875->class;
  objclass3875->definitionModule = modulename;
  objclass3875->definitionLine = 1688;
  (*(struct UserObject *)self).data[0] = lowerouter3875;
  self = oldself3875;
  selfslot = oldselfslot3875;
  stackframe = oldstackframe3875;
  gc_frame_end(frame);
  return obj3875;
}
Object meth_collectionsPrelude_keys3874_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "keys$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1687
  setline(1687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3875 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3875 = alloc_userobj2(4,5, objclass3875);
  gc_frame_newslot(obj3875);
if (objclass3875 == NULL) {
  glfree(obj3875->class->name);
  obj3875->class->name = "dictionary.empty.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3875, self, 0);
  addmethodreal(obj3875,"outer", &reader_collectionsPrelude_outer_3876);
  Object oldself3875 = self;
  struct StackFrameObject *oldstackframe3875 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3875);
  gc_frame_newslot((Object)stackframe);
  self = obj3875;
  Object *oldselfslot3875 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3875 = (*(struct UserObject *)self).data[0], lowerouter3875 = thisouter3875;
  if (inheritingObject3875) {
    struct UserObject *inho3875 = (struct UserObject *)inheritingObject3875;
    while (inho3875->super != GraceDefaultObject) inho3875 = (struct UserObject *)inho3875->super;
    inho3875->super = obj3875;
    self = inheritingObject3875;
    *selfslot = self;
    lowerouter3875 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3875;
  }
// method "iterator"
  block_savedest(obj3875);
  Object closure3877 = createclosure(1, "iterator");
  setclosureframe(closure3877, stackframe);
  addtoclosure(closure3877, var_sourceDictionary);
  struct UserObject *uo3877 = (struct UserObject*)obj3875;
  uo3877->data[1] = (Object)closure3877;
  Method *meth_meth_collectionsPrelude_iterator3877 = addmethod2pos(obj3875, "iterator", &meth_collectionsPrelude_iterator3877, 1);
  int argcv_meth_collectionsPrelude_iterator3877[] = {0};
  meth_meth_collectionsPrelude_iterator3877->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator3877);
  meth_meth_collectionsPrelude_iterator3877->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3877->definitionLine = 1690;
  block_savedest(obj3875);
  Object closure3904 = createclosure(1, "iterator$object(1)");
  setclosureframe(closure3904, stackframe);
  addtoclosure(closure3904, var_sourceDictionary);
  Method *meth_meth_collectionsPrelude_iterator3877_object = addmethod2pos(obj3875, "iterator$object(1)", &meth_collectionsPrelude_iterator3877_object, 1);
  meth_meth_collectionsPrelude_iterator3877_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3877_object->definitionLine = 1690;
if (objclass3875 == NULL) {
  Method *reader3905 = addmethodrealflags(obj3875, "size",&reader_collectionsPrelude_size_3905, MFLAG_DEF);
  reader3905->definitionModule = modulename;
  reader3905->definitionLine = 1698;
}
adddatum2(obj3875, alloc_Undefined(), 2);
// method "asDebugString"
  block_savedest(obj3875);
  Object closure3906 = createclosure(1, "asDebugString");
  setclosureframe(closure3906, stackframe);
  addtoclosure(closure3906, var_sourceDictionary);
  struct UserObject *uo3906 = (struct UserObject*)obj3875;
  uo3906->data[3] = (Object)closure3906;
  Method *meth_meth_collectionsPrelude_asDebugString3906 = addmethod2pos(obj3875, "asDebugString", &meth_collectionsPrelude_asDebugString3906, 3);
  int argcv_meth_collectionsPrelude_asDebugString3906[] = {0};
  meth_meth_collectionsPrelude_asDebugString3906->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString3906);
  meth_meth_collectionsPrelude_asDebugString3906->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString3906->definitionLine = 1699;
  sourceObject = obj3875;
// Begin line 1689
  setline(1689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3915 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3916 = callmethodflags(*var_enumerable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3915);
// compiled call node returning call3916 (depth = 2)
  struct UserObject *obj3875_uo = (struct UserObject *)obj3875;
  obj3875_uo->super = call3916;
  sourceObject = obj3875;
  sourceObject = obj3875;
// Begin line 1698
  setline(1698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3917 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  Object call3918 = callmethodflags(*var_sourceDictionary, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3917);
// compiled member node returning call3918 (depth = 2)
  adddatum2(obj3875, call3918, 2);
  sourceObject = obj3875;
  objclass3875 = obj3875->class;
  objclass3875->definitionModule = modulename;
  objclass3875->definitionLine = 1688;
  (*(struct UserObject *)self).data[0] = lowerouter3875;
  self = oldself3875;
  selfslot = oldselfslot3875;
  stackframe = oldstackframe3875;
  gc_frame_end(frame);
  return obj3875;
}
Object meth_collectionsPrelude_hasNext3927(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1711
  setline(1711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3928 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3929 = gc_frame_new();
// call case 4: self request
  Object call3930 = callmethodflags(self, "sourceIterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3929);
// compiled member node returning call3930 (depth = 3)
  Object call3931 = callmethodflags(call3930, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe3928);
// compiled member node returning call3931 (depth = 2)
  gc_frame_end(frame);
  return call3931;
}
Object meth_collectionsPrelude_next3932(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1712
  setline(1712);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3933 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3934 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe3935 = gc_frame_new();
// call case 4: self request
  Object call3936 = callmethodflags(self, "sourceIterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3935);
// compiled member node returning call3936 (depth = 4)
  Object call3937 = callmethodflags(call3936, "next", 0, partcv, params, 0);
  gc_frame_end(callframe3934);
// compiled member node returning call3937 (depth = 3)
  Object call3938 = callmethodflags(call3937, "value", 0, partcv, params, 0);
  gc_frame_end(callframe3933);
// compiled member node returning call3938 (depth = 2)
  gc_frame_end(frame);
  return call3938;
}
Object meth_collectionsPrelude_asString3939(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1714
  setline(1714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3941 == NULL) {
    strlit3941 = alloc_String("");
    gc_root(strlit3941);
  }
// compiled string node returning strlit3941 (depth = 3)
  int op_slot_right_3940 = gc_frame_newslot(strlit3941);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  int op_slot_right_3943 = gc_frame_newslot(*var_sourceDictionary);
// starting to compile string node (depth = 4)
  if (strlit3945 == NULL) {
    strlit3945 = alloc_String("an iterator over values of ");
    gc_root(strlit3945);
  }
// compiled string node returning strlit3945 (depth = 4)
  int op_slot_left_3943 = gc_frame_newslot(strlit3945);
  params[0] = *var_sourceDictionary;
  partcv[0] = 1;
  Object opresult3946 = callmethod(strlit3945, "++(1)", 1, partcv, params);
// compiled op node returning opresult3946 (depth = 3)
  int op_slot_left_3940 = gc_frame_newslot(opresult3946);
  params[0] = strlit3941;
  partcv[0] = 1;
  Object opresult3947 = callmethod(opresult3946, "++(1)", 1, partcv, params);
// compiled op node returning opresult3947 (depth = 2)
  gc_frame_end(frame);
  return opresult3947;
}
Object meth_collectionsPrelude_iterator3923(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3924 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3924 = alloc_userobj2(4,5, objclass3924);
  gc_frame_newslot(obj3924);
if (objclass3924 == NULL) {
  glfree(obj3924->class->name);
  obj3924->class->name = "dictionary.empty.object.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3924, self, 0);
  addmethodreal(obj3924,"outer", &reader_collectionsPrelude_outer_3925);
  Object oldself3924 = self;
  struct StackFrameObject *oldstackframe3924 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3924);
  gc_frame_newslot((Object)stackframe);
  self = obj3924;
  Object *oldselfslot3924 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3924 = (*(struct UserObject *)self).data[0], lowerouter3924 = thisouter3924;
  if (inheritingObject3924) {
    struct UserObject *inho3924 = (struct UserObject *)inheritingObject3924;
    while (inho3924->super != GraceDefaultObject) inho3924 = (struct UserObject *)inho3924->super;
    inho3924->super = obj3924;
    self = inheritingObject3924;
    *selfslot = self;
    lowerouter3924 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3924;
  }
if (objclass3924 == NULL) {
  Method *reader3926 = addmethodrealflags(obj3924, "sourceIterator",&reader_collectionsPrelude_sourceIterator_3926, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader3926->definitionModule = modulename;
  reader3926->definitionLine = 1709;
}
adddatum2(obj3924, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo3927 = (struct UserObject*)obj3924;
  uo3927->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext3927 = addmethod2pos(obj3924, "hasNext", &meth_collectionsPrelude_hasNext3927, 2);
  int argcv_meth_collectionsPrelude_hasNext3927[] = {0};
  meth_meth_collectionsPrelude_hasNext3927->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext3927);
  meth_meth_collectionsPrelude_hasNext3927->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext3927->definitionLine = 1711;
// method "next"
  struct UserObject *uo3932 = (struct UserObject*)obj3924;
  uo3932->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_next3932 = addmethod2pos(obj3924, "next", &meth_collectionsPrelude_next3932, 3);
  int argcv_meth_collectionsPrelude_next3932[] = {0};
  meth_meth_collectionsPrelude_next3932->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next3932);
  meth_meth_collectionsPrelude_next3932->definitionModule = modulename;
  meth_meth_collectionsPrelude_next3932->definitionLine = 1712;
// method "asString"
  block_savedest(obj3924);
  Object closure3939 = createclosure(1, "asString");
  setclosureframe(closure3939, stackframe);
  addtoclosure(closure3939, var_sourceDictionary);
  struct UserObject *uo3939 = (struct UserObject*)obj3924;
  uo3939->data[4] = (Object)closure3939;
  Method *meth_meth_collectionsPrelude_asString3939 = addmethod2pos(obj3924, "asString", &meth_collectionsPrelude_asString3939, 4);
  int argcv_meth_collectionsPrelude_asString3939[] = {0};
  meth_meth_collectionsPrelude_asString3939->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString3939);
  meth_meth_collectionsPrelude_asString3939->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString3939->definitionLine = 1713;
  sourceObject = obj3924;
// Begin line 1709
  setline(1709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3948 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  Object call3949 = callmethodflags(*var_sourceDictionary, "bindingsIterator", 0, partcv, params, 0);
  gc_frame_end(callframe3948);
// compiled member node returning call3949 (depth = 2)
  adddatum2(obj3924, call3949, 1);
  sourceObject = obj3924;
  sourceObject = obj3924;
  sourceObject = obj3924;
  objclass3924 = obj3924->class;
  objclass3924->definitionModule = modulename;
  objclass3924->definitionLine = 1708;
  (*(struct UserObject *)self).data[0] = lowerouter3924;
  self = oldself3924;
  selfslot = oldselfslot3924;
  stackframe = oldstackframe3924;
  gc_frame_end(frame);
  return obj3924;
}
Object meth_collectionsPrelude_iterator3923_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3924 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3924 = alloc_userobj2(4,5, objclass3924);
  gc_frame_newslot(obj3924);
if (objclass3924 == NULL) {
  glfree(obj3924->class->name);
  obj3924->class->name = "dictionary.empty.object.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3924, self, 0);
  addmethodreal(obj3924,"outer", &reader_collectionsPrelude_outer_3925);
  Object oldself3924 = self;
  struct StackFrameObject *oldstackframe3924 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3924);
  gc_frame_newslot((Object)stackframe);
  self = obj3924;
  Object *oldselfslot3924 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3924 = (*(struct UserObject *)self).data[0], lowerouter3924 = thisouter3924;
  if (inheritingObject3924) {
    struct UserObject *inho3924 = (struct UserObject *)inheritingObject3924;
    while (inho3924->super != GraceDefaultObject) inho3924 = (struct UserObject *)inho3924->super;
    inho3924->super = obj3924;
    self = inheritingObject3924;
    *selfslot = self;
    lowerouter3924 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3924;
  }
if (objclass3924 == NULL) {
  Method *reader3926 = addmethodrealflags(obj3924, "sourceIterator",&reader_collectionsPrelude_sourceIterator_3926, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader3926->definitionModule = modulename;
  reader3926->definitionLine = 1709;
}
adddatum2(obj3924, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo3927 = (struct UserObject*)obj3924;
  uo3927->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext3927 = addmethod2pos(obj3924, "hasNext", &meth_collectionsPrelude_hasNext3927, 2);
  int argcv_meth_collectionsPrelude_hasNext3927[] = {0};
  meth_meth_collectionsPrelude_hasNext3927->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext3927);
  meth_meth_collectionsPrelude_hasNext3927->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext3927->definitionLine = 1711;
// method "next"
  struct UserObject *uo3932 = (struct UserObject*)obj3924;
  uo3932->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_next3932 = addmethod2pos(obj3924, "next", &meth_collectionsPrelude_next3932, 3);
  int argcv_meth_collectionsPrelude_next3932[] = {0};
  meth_meth_collectionsPrelude_next3932->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next3932);
  meth_meth_collectionsPrelude_next3932->definitionModule = modulename;
  meth_meth_collectionsPrelude_next3932->definitionLine = 1712;
// method "asString"
  block_savedest(obj3924);
  Object closure3939 = createclosure(1, "asString");
  setclosureframe(closure3939, stackframe);
  addtoclosure(closure3939, var_sourceDictionary);
  struct UserObject *uo3939 = (struct UserObject*)obj3924;
  uo3939->data[4] = (Object)closure3939;
  Method *meth_meth_collectionsPrelude_asString3939 = addmethod2pos(obj3924, "asString", &meth_collectionsPrelude_asString3939, 4);
  int argcv_meth_collectionsPrelude_asString3939[] = {0};
  meth_meth_collectionsPrelude_asString3939->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString3939);
  meth_meth_collectionsPrelude_asString3939->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString3939->definitionLine = 1713;
  sourceObject = obj3924;
// Begin line 1709
  setline(1709);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3948 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  Object call3949 = callmethodflags(*var_sourceDictionary, "bindingsIterator", 0, partcv, params, 0);
  gc_frame_end(callframe3948);
// compiled member node returning call3949 (depth = 2)
  adddatum2(obj3924, call3949, 1);
  sourceObject = obj3924;
  sourceObject = obj3924;
  sourceObject = obj3924;
  objclass3924 = obj3924->class;
  objclass3924->definitionModule = modulename;
  objclass3924->definitionLine = 1708;
  (*(struct UserObject *)self).data[0] = lowerouter3924;
  self = oldself3924;
  selfslot = oldselfslot3924;
  stackframe = oldstackframe3924;
  gc_frame_end(frame);
  return obj3924;
}
Object meth_collectionsPrelude_asDebugString3952(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1719
  setline(1719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3954 == NULL) {
    strlit3954 = alloc_String("");
    gc_root(strlit3954);
  }
// compiled string node returning strlit3954 (depth = 3)
  int op_slot_right_3953 = gc_frame_newslot(strlit3954);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  int op_slot_right_3956 = gc_frame_newslot(*var_sourceDictionary);
// starting to compile string node (depth = 4)
  if (strlit3958 == NULL) {
    strlit3958 = alloc_String("a lazy sequence over values of ");
    gc_root(strlit3958);
  }
// compiled string node returning strlit3958 (depth = 4)
  int op_slot_left_3956 = gc_frame_newslot(strlit3958);
  params[0] = *var_sourceDictionary;
  partcv[0] = 1;
  Object opresult3959 = callmethod(strlit3958, "++(1)", 1, partcv, params);
// compiled op node returning opresult3959 (depth = 3)
  int op_slot_left_3953 = gc_frame_newslot(opresult3959);
  params[0] = strlit3954;
  partcv[0] = 1;
  Object opresult3960 = callmethod(opresult3959, "++(1)", 1, partcv, params);
// compiled op node returning opresult3960 (depth = 2)
  gc_frame_end(frame);
  return opresult3960;
}
Object meth_collectionsPrelude_values3920(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1705
  setline(1705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3921 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3921 = alloc_userobj2(4,5, objclass3921);
  gc_frame_newslot(obj3921);
if (objclass3921 == NULL) {
  glfree(obj3921->class->name);
  obj3921->class->name = "dictionary.empty.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3921, self, 0);
  addmethodreal(obj3921,"outer", &reader_collectionsPrelude_outer_3922);
  Object oldself3921 = self;
  struct StackFrameObject *oldstackframe3921 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3921);
  gc_frame_newslot((Object)stackframe);
  self = obj3921;
  Object *oldselfslot3921 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3921 = (*(struct UserObject *)self).data[0], lowerouter3921 = thisouter3921;
  if (inheritingObject3921) {
    struct UserObject *inho3921 = (struct UserObject *)inheritingObject3921;
    while (inho3921->super != GraceDefaultObject) inho3921 = (struct UserObject *)inho3921->super;
    inho3921->super = obj3921;
    self = inheritingObject3921;
    *selfslot = self;
    lowerouter3921 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3921;
  }
// method "iterator"
  block_savedest(obj3921);
  Object closure3923 = createclosure(1, "iterator");
  setclosureframe(closure3923, stackframe);
  addtoclosure(closure3923, var_sourceDictionary);
  struct UserObject *uo3923 = (struct UserObject*)obj3921;
  uo3923->data[1] = (Object)closure3923;
  Method *meth_meth_collectionsPrelude_iterator3923 = addmethod2pos(obj3921, "iterator", &meth_collectionsPrelude_iterator3923, 1);
  int argcv_meth_collectionsPrelude_iterator3923[] = {0};
  meth_meth_collectionsPrelude_iterator3923->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator3923);
  meth_meth_collectionsPrelude_iterator3923->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3923->definitionLine = 1708;
  block_savedest(obj3921);
  Object closure3950 = createclosure(1, "iterator$object(1)");
  setclosureframe(closure3950, stackframe);
  addtoclosure(closure3950, var_sourceDictionary);
  Method *meth_meth_collectionsPrelude_iterator3923_object = addmethod2pos(obj3921, "iterator$object(1)", &meth_collectionsPrelude_iterator3923_object, 1);
  meth_meth_collectionsPrelude_iterator3923_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3923_object->definitionLine = 1708;
if (objclass3921 == NULL) {
  Method *reader3951 = addmethodrealflags(obj3921, "size",&reader_collectionsPrelude_size_3951, MFLAG_DEF);
  reader3951->definitionModule = modulename;
  reader3951->definitionLine = 1717;
}
adddatum2(obj3921, alloc_Undefined(), 2);
// method "asDebugString"
  block_savedest(obj3921);
  Object closure3952 = createclosure(1, "asDebugString");
  setclosureframe(closure3952, stackframe);
  addtoclosure(closure3952, var_sourceDictionary);
  struct UserObject *uo3952 = (struct UserObject*)obj3921;
  uo3952->data[3] = (Object)closure3952;
  Method *meth_meth_collectionsPrelude_asDebugString3952 = addmethod2pos(obj3921, "asDebugString", &meth_collectionsPrelude_asDebugString3952, 3);
  int argcv_meth_collectionsPrelude_asDebugString3952[] = {0};
  meth_meth_collectionsPrelude_asDebugString3952->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString3952);
  meth_meth_collectionsPrelude_asDebugString3952->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString3952->definitionLine = 1718;
  sourceObject = obj3921;
// Begin line 1707
  setline(1707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3961 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3962 = callmethodflags(*var_enumerable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3961);
// compiled call node returning call3962 (depth = 2)
  struct UserObject *obj3921_uo = (struct UserObject *)obj3921;
  obj3921_uo->super = call3962;
  sourceObject = obj3921;
  sourceObject = obj3921;
// Begin line 1717
  setline(1717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3963 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  Object call3964 = callmethodflags(*var_sourceDictionary, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3963);
// compiled member node returning call3964 (depth = 2)
  adddatum2(obj3921, call3964, 2);
  sourceObject = obj3921;
  objclass3921 = obj3921->class;
  objclass3921->definitionModule = modulename;
  objclass3921->definitionLine = 1706;
  (*(struct UserObject *)self).data[0] = lowerouter3921;
  self = oldself3921;
  selfslot = oldselfslot3921;
  stackframe = oldstackframe3921;
  gc_frame_end(frame);
  return obj3921;
}
Object meth_collectionsPrelude_values3920_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "values$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1705
  setline(1705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3921 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3921 = alloc_userobj2(4,5, objclass3921);
  gc_frame_newslot(obj3921);
if (objclass3921 == NULL) {
  glfree(obj3921->class->name);
  obj3921->class->name = "dictionary.empty.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3921, self, 0);
  addmethodreal(obj3921,"outer", &reader_collectionsPrelude_outer_3922);
  Object oldself3921 = self;
  struct StackFrameObject *oldstackframe3921 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3921);
  gc_frame_newslot((Object)stackframe);
  self = obj3921;
  Object *oldselfslot3921 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3921 = (*(struct UserObject *)self).data[0], lowerouter3921 = thisouter3921;
  if (inheritingObject3921) {
    struct UserObject *inho3921 = (struct UserObject *)inheritingObject3921;
    while (inho3921->super != GraceDefaultObject) inho3921 = (struct UserObject *)inho3921->super;
    inho3921->super = obj3921;
    self = inheritingObject3921;
    *selfslot = self;
    lowerouter3921 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3921;
  }
// method "iterator"
  block_savedest(obj3921);
  Object closure3923 = createclosure(1, "iterator");
  setclosureframe(closure3923, stackframe);
  addtoclosure(closure3923, var_sourceDictionary);
  struct UserObject *uo3923 = (struct UserObject*)obj3921;
  uo3923->data[1] = (Object)closure3923;
  Method *meth_meth_collectionsPrelude_iterator3923 = addmethod2pos(obj3921, "iterator", &meth_collectionsPrelude_iterator3923, 1);
  int argcv_meth_collectionsPrelude_iterator3923[] = {0};
  meth_meth_collectionsPrelude_iterator3923->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator3923);
  meth_meth_collectionsPrelude_iterator3923->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3923->definitionLine = 1708;
  block_savedest(obj3921);
  Object closure3950 = createclosure(1, "iterator$object(1)");
  setclosureframe(closure3950, stackframe);
  addtoclosure(closure3950, var_sourceDictionary);
  Method *meth_meth_collectionsPrelude_iterator3923_object = addmethod2pos(obj3921, "iterator$object(1)", &meth_collectionsPrelude_iterator3923_object, 1);
  meth_meth_collectionsPrelude_iterator3923_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3923_object->definitionLine = 1708;
if (objclass3921 == NULL) {
  Method *reader3951 = addmethodrealflags(obj3921, "size",&reader_collectionsPrelude_size_3951, MFLAG_DEF);
  reader3951->definitionModule = modulename;
  reader3951->definitionLine = 1717;
}
adddatum2(obj3921, alloc_Undefined(), 2);
// method "asDebugString"
  block_savedest(obj3921);
  Object closure3952 = createclosure(1, "asDebugString");
  setclosureframe(closure3952, stackframe);
  addtoclosure(closure3952, var_sourceDictionary);
  struct UserObject *uo3952 = (struct UserObject*)obj3921;
  uo3952->data[3] = (Object)closure3952;
  Method *meth_meth_collectionsPrelude_asDebugString3952 = addmethod2pos(obj3921, "asDebugString", &meth_collectionsPrelude_asDebugString3952, 3);
  int argcv_meth_collectionsPrelude_asDebugString3952[] = {0};
  meth_meth_collectionsPrelude_asDebugString3952->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString3952);
  meth_meth_collectionsPrelude_asDebugString3952->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString3952->definitionLine = 1718;
  sourceObject = obj3921;
// Begin line 1707
  setline(1707);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3961 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3962 = callmethodflags(*var_enumerable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3961);
// compiled call node returning call3962 (depth = 2)
  struct UserObject *obj3921_uo = (struct UserObject *)obj3921;
  obj3921_uo->super = call3962;
  sourceObject = obj3921;
  sourceObject = obj3921;
// Begin line 1717
  setline(1717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3963 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  Object call3964 = callmethodflags(*var_sourceDictionary, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3963);
// compiled member node returning call3964 (depth = 2)
  adddatum2(obj3921, call3964, 2);
  sourceObject = obj3921;
  objclass3921 = obj3921->class;
  objclass3921->definitionModule = modulename;
  objclass3921->definitionLine = 1706;
  (*(struct UserObject *)self).data[0] = lowerouter3921;
  self = oldself3921;
  selfslot = oldselfslot3921;
  stackframe = oldstackframe3921;
  gc_frame_end(frame);
  return obj3921;
}
Object meth_collectionsPrelude_iterator3969(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1727
  setline(1727);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3970 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  Object call3971 = callmethodflags(*var_sourceDictionary, "bindingsIterator", 0, partcv, params, 0);
  gc_frame_end(callframe3970);
// compiled member node returning call3971 (depth = 2)
  gc_frame_end(frame);
  return call3971;
}
Object meth_collectionsPrelude_asDebugString3973(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1731
  setline(1731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3975 == NULL) {
    strlit3975 = alloc_String("");
    gc_root(strlit3975);
  }
// compiled string node returning strlit3975 (depth = 3)
  int op_slot_right_3974 = gc_frame_newslot(strlit3975);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  int op_slot_right_3977 = gc_frame_newslot(*var_sourceDictionary);
// starting to compile string node (depth = 4)
  if (strlit3979 == NULL) {
    strlit3979 = alloc_String("a lazy sequence over bindings of ");
    gc_root(strlit3979);
  }
// compiled string node returning strlit3979 (depth = 4)
  int op_slot_left_3977 = gc_frame_newslot(strlit3979);
  params[0] = *var_sourceDictionary;
  partcv[0] = 1;
  Object opresult3980 = callmethod(strlit3979, "++(1)", 1, partcv, params);
// compiled op node returning opresult3980 (depth = 3)
  int op_slot_left_3974 = gc_frame_newslot(opresult3980);
  params[0] = strlit3975;
  partcv[0] = 1;
  Object opresult3981 = callmethod(opresult3980, "++(1)", 1, partcv, params);
// compiled op node returning opresult3981 (depth = 2)
  gc_frame_end(frame);
  return opresult3981;
}
Object meth_collectionsPrelude_bindings3966(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "bindings");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1724
  setline(1724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3967 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3967 = alloc_userobj2(3,4, objclass3967);
  gc_frame_newslot(obj3967);
if (objclass3967 == NULL) {
  glfree(obj3967->class->name);
  obj3967->class->name = "dictionary.empty.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3967, self, 0);
  addmethodreal(obj3967,"outer", &reader_collectionsPrelude_outer_3968);
  Object oldself3967 = self;
  struct StackFrameObject *oldstackframe3967 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3967);
  gc_frame_newslot((Object)stackframe);
  self = obj3967;
  Object *oldselfslot3967 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3967 = (*(struct UserObject *)self).data[0], lowerouter3967 = thisouter3967;
  if (inheritingObject3967) {
    struct UserObject *inho3967 = (struct UserObject *)inheritingObject3967;
    while (inho3967->super != GraceDefaultObject) inho3967 = (struct UserObject *)inho3967->super;
    inho3967->super = obj3967;
    self = inheritingObject3967;
    *selfslot = self;
    lowerouter3967 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3967;
  }
// method "iterator"
  block_savedest(obj3967);
  Object closure3969 = createclosure(1, "iterator");
  setclosureframe(closure3969, stackframe);
  addtoclosure(closure3969, var_sourceDictionary);
  struct UserObject *uo3969 = (struct UserObject*)obj3967;
  uo3969->data[1] = (Object)closure3969;
  Method *meth_meth_collectionsPrelude_iterator3969 = addmethod2pos(obj3967, "iterator", &meth_collectionsPrelude_iterator3969, 1);
  int argcv_meth_collectionsPrelude_iterator3969[] = {0};
  meth_meth_collectionsPrelude_iterator3969->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator3969);
  meth_meth_collectionsPrelude_iterator3969->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3969->definitionLine = 1727;
if (objclass3967 == NULL) {
  Method *reader3972 = addmethodrealflags(obj3967, "size",&reader_collectionsPrelude_size_3972, MFLAG_DEF);
  reader3972->definitionModule = modulename;
  reader3972->definitionLine = 1729;
}
adddatum2(obj3967, alloc_Undefined(), 2);
// method "asDebugString"
  block_savedest(obj3967);
  Object closure3973 = createclosure(1, "asDebugString");
  setclosureframe(closure3973, stackframe);
  addtoclosure(closure3973, var_sourceDictionary);
  struct UserObject *uo3973 = (struct UserObject*)obj3967;
  uo3973->data[3] = (Object)closure3973;
  Method *meth_meth_collectionsPrelude_asDebugString3973 = addmethod2pos(obj3967, "asDebugString", &meth_collectionsPrelude_asDebugString3973, 3);
  int argcv_meth_collectionsPrelude_asDebugString3973[] = {0};
  meth_meth_collectionsPrelude_asDebugString3973->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString3973);
  meth_meth_collectionsPrelude_asDebugString3973->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString3973->definitionLine = 1730;
  sourceObject = obj3967;
// Begin line 1726
  setline(1726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3982 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3983 = callmethodflags(*var_enumerable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3982);
// compiled call node returning call3983 (depth = 2)
  struct UserObject *obj3967_uo = (struct UserObject *)obj3967;
  obj3967_uo->super = call3983;
  sourceObject = obj3967;
  sourceObject = obj3967;
// Begin line 1729
  setline(1729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3984 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  Object call3985 = callmethodflags(*var_sourceDictionary, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3984);
// compiled member node returning call3985 (depth = 2)
  adddatum2(obj3967, call3985, 2);
  sourceObject = obj3967;
  objclass3967 = obj3967->class;
  objclass3967->definitionModule = modulename;
  objclass3967->definitionLine = 1725;
  (*(struct UserObject *)self).data[0] = lowerouter3967;
  self = oldself3967;
  selfslot = oldselfslot3967;
  stackframe = oldstackframe3967;
  gc_frame_end(frame);
  return obj3967;
}
Object meth_collectionsPrelude_bindings3966_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "bindings$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1724
  setline(1724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3967 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3967 = alloc_userobj2(3,4, objclass3967);
  gc_frame_newslot(obj3967);
if (objclass3967 == NULL) {
  glfree(obj3967->class->name);
  obj3967->class->name = "dictionary.empty.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3967, self, 0);
  addmethodreal(obj3967,"outer", &reader_collectionsPrelude_outer_3968);
  Object oldself3967 = self;
  struct StackFrameObject *oldstackframe3967 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3967);
  gc_frame_newslot((Object)stackframe);
  self = obj3967;
  Object *oldselfslot3967 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3967 = (*(struct UserObject *)self).data[0], lowerouter3967 = thisouter3967;
  if (inheritingObject3967) {
    struct UserObject *inho3967 = (struct UserObject *)inheritingObject3967;
    while (inho3967->super != GraceDefaultObject) inho3967 = (struct UserObject *)inho3967->super;
    inho3967->super = obj3967;
    self = inheritingObject3967;
    *selfslot = self;
    lowerouter3967 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3967;
  }
// method "iterator"
  block_savedest(obj3967);
  Object closure3969 = createclosure(1, "iterator");
  setclosureframe(closure3969, stackframe);
  addtoclosure(closure3969, var_sourceDictionary);
  struct UserObject *uo3969 = (struct UserObject*)obj3967;
  uo3969->data[1] = (Object)closure3969;
  Method *meth_meth_collectionsPrelude_iterator3969 = addmethod2pos(obj3967, "iterator", &meth_collectionsPrelude_iterator3969, 1);
  int argcv_meth_collectionsPrelude_iterator3969[] = {0};
  meth_meth_collectionsPrelude_iterator3969->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator3969);
  meth_meth_collectionsPrelude_iterator3969->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3969->definitionLine = 1727;
if (objclass3967 == NULL) {
  Method *reader3972 = addmethodrealflags(obj3967, "size",&reader_collectionsPrelude_size_3972, MFLAG_DEF);
  reader3972->definitionModule = modulename;
  reader3972->definitionLine = 1729;
}
adddatum2(obj3967, alloc_Undefined(), 2);
// method "asDebugString"
  block_savedest(obj3967);
  Object closure3973 = createclosure(1, "asDebugString");
  setclosureframe(closure3973, stackframe);
  addtoclosure(closure3973, var_sourceDictionary);
  struct UserObject *uo3973 = (struct UserObject*)obj3967;
  uo3973->data[3] = (Object)closure3973;
  Method *meth_meth_collectionsPrelude_asDebugString3973 = addmethod2pos(obj3967, "asDebugString", &meth_collectionsPrelude_asDebugString3973, 3);
  int argcv_meth_collectionsPrelude_asDebugString3973[] = {0};
  meth_meth_collectionsPrelude_asDebugString3973->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString3973);
  meth_meth_collectionsPrelude_asDebugString3973->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString3973->definitionLine = 1730;
  sourceObject = obj3967;
// Begin line 1726
  setline(1726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3982 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3983 = callmethodflags(*var_enumerable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe3982);
// compiled call node returning call3983 (depth = 2)
  struct UserObject *obj3967_uo = (struct UserObject *)obj3967;
  obj3967_uo->super = call3983;
  sourceObject = obj3967;
  sourceObject = obj3967;
// Begin line 1729
  setline(1729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3984 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sourceDictionary (depth = 3)
  Object call3985 = callmethodflags(*var_sourceDictionary, "size", 0, partcv, params, 0);
  gc_frame_end(callframe3984);
// compiled member node returning call3985 (depth = 2)
  adddatum2(obj3967, call3985, 2);
  sourceObject = obj3967;
  objclass3967 = obj3967->class;
  objclass3967->definitionModule = modulename;
  objclass3967->definitionLine = 1725;
  (*(struct UserObject *)self).data[0] = lowerouter3967;
  self = oldself3967;
  selfslot = oldselfslot3967;
  stackframe = oldstackframe3967;
  gc_frame_end(frame);
  return obj3967;
}
Object meth_collectionsPrelude_iterator3987(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1735
  setline(1735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe3988 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe3989 = gc_frame_new();
// call case 4: self request
  Object call3990 = callmethodflags(self, "values", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3989);
// compiled member node returning call3990 (depth = 3)
  Object call3991 = callmethodflags(call3990, "iterator", 0, partcv, params, 0);
  gc_frame_end(callframe3988);
// compiled member node returning call3991 (depth = 2)
  gc_frame_end(frame);
  return call3991;
}
Object meth_collectionsPrelude_hasNext3999(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1742
  setline(1742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4001 = gc_frame_new();
// call case 4: self request
  Object call4002 = callmethodflags(self, "count", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4001);
// compiled member node returning call4002 (depth = 3)
  int op_slot_right_4000 = gc_frame_newslot(call4002);
// starting to compile member node (depth = 3)
  int callframe4004 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4005 = gc_frame_new();
// call case 3: self.outer request
  Object call4006 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4005);
// compiled member node returning call4006 (depth = 4)
  Object call4007 = callmethodflags(call4006, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4004);
// compiled member node returning call4007 (depth = 3)
  int op_slot_left_4000 = gc_frame_newslot(call4007);
  params[0] = call4002;
  partcv[0] = 1;
  Object opresult4008 = callmethod(call4007, "≥(1)", 1, partcv, params);
// compiled op node returning opresult4008 (depth = 2)
  gc_frame_end(frame);
  return opresult4008;
}
Object meth_collectionsPrelude__apply4052(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe4053 = gc_frame_new();
// Begin line 1749
  setline(1749);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4054 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4055 = gc_frame_new();
// call case 4: self request
  Object call4056 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4055);
// compiled member node returning call4056 (depth = 6)
  gc_frame_newslot(call4056);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4057 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4058 = gc_frame_new();
// call case 3: self.outer request
  Object call4059 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4058);
// compiled member node returning call4059 (depth = 7)
  Object call4060 = callmethodflags(call4059, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4057);
// compiled member node returning call4060 (depth = 6)
  params[0] = call4056;
  partcv[0] = 1;
  Object call4061 = callmethodflags(call4060, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4054);
// compiled call node returning call4061 (depth = 5)
  gc_frame_newslot(call4061);
// call case 4: self request
  params[0] = call4061;
  partcv[0] = 1;
  Object call4062 = callmethodflags(self, "elt:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4053);
// compiled call node returning call4062 (depth = 4)
// Begin line 1750
  setline(1750);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4065 = gc_frame_new();
// call case 4: self request
  Object call4066 = callmethodflags(self, "elt", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4065);
// compiled member node returning call4066 (depth = 6)
  int op_slot_right_4064 = gc_frame_newslot(call4066);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  int op_slot_left_4064 = gc_frame_newslot(*var_removed);
  params[0] = call4066;
  partcv[0] = 1;
  Object opresult4068 = callmethod(*var_removed, "==(1)", 1, partcv, params);
// compiled op node returning opresult4068 (depth = 5)
  int op_slot_right_4063 = gc_frame_newslot(opresult4068);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4071 = gc_frame_new();
// call case 4: self request
  Object call4072 = callmethodflags(self, "elt", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4071);
// compiled member node returning call4072 (depth = 6)
  int op_slot_right_4070 = gc_frame_newslot(call4072);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_unused (depth = 6)
  int op_slot_left_4070 = gc_frame_newslot(*var_unused);
  params[0] = call4072;
  partcv[0] = 1;
  Object opresult4074 = callmethod(*var_unused, "==(1)", 1, partcv, params);
// compiled op node returning opresult4074 (depth = 5)
  int op_slot_left_4063 = gc_frame_newslot(opresult4074);
  params[0] = opresult4068;
  partcv[0] = 1;
  Object opresult4075 = callmethod(opresult4074, "||(1)", 1, partcv, params);
// compiled op node returning opresult4075 (depth = 4)
  gc_frame_end(frame);
  return opresult4075;
}
Object meth_collectionsPrelude__apply4078(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe4079 = gc_frame_new();
// Begin line 1752
  setline(1752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4081 = alloc_Float64(1);
// compiled num node returning num4081 (depth = 6)
  int op_slot_right_4080 = gc_frame_newslot(num4081);
// starting to compile member node (depth = 6)
  int callframe4083 = gc_frame_new();
// call case 4: self request
  Object call4084 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4083);
// compiled member node returning call4084 (depth = 6)
  int op_slot_left_4080 = gc_frame_newslot(call4084);
  params[0] = num4081;
  partcv[0] = 1;
  Object sum4085 = callmethod(call4084, "+(1)", 1, partcv, params);
// compiled op node returning sum4085 (depth = 5)
  gc_frame_newslot(sum4085);
// call case 4: self request
  params[0] = sum4085;
  partcv[0] = 1;
  Object call4086 = callmethodflags(self, "idx:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4079);
// compiled call node returning call4086 (depth = 4)
  gc_frame_end(frame);
  return call4086;
}
Object meth_collectionsPrelude_next4009(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1744
  setline(1744);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4012 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4013 = gc_frame_new();
// call case 3: self.outer request
  Object call4014 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4013);
// compiled member node returning call4014 (depth = 5)
  Object call4015 = callmethodflags(call4014, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4012);
// compiled member node returning call4015 (depth = 4)
  int op_slot_right_4011 = gc_frame_newslot(call4015);
// starting to compile member node (depth = 4)
  int callframe4017 = gc_frame_new();
// call case 4: self request
  Object call4018 = callmethodflags(self, "imods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4017);
// compiled member node returning call4018 (depth = 4)
  int op_slot_left_4011 = gc_frame_newslot(call4018);
  params[0] = call4015;
  partcv[0] = 1;
  Object opresult4019 = callmethod(call4018, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4019 (depth = 3)
  Object if4010 = done;
  if (istrue(opresult4019)) {
// Begin line 1745
  setline(1745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4020 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe4021 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4022 = gc_frame_new();
// call case 3: self.outer request
  Object call4023 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4022);
// compiled member node returning call4023 (depth = 5)
  Object call4024 = callmethodflags(call4023, "asString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4021);
// compiled member node returning call4024 (depth = 4)
  gc_frame_newslot(call4024);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ConcurrentModification (depth = 4)
  params[0] = call4024;
  partcv[0] = 1;
  Object call4025 = callmethodflags(*var_ConcurrentModification, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4020);
// compiled call node returning call4025 (depth = 3)
    gc_frame_newslot(call4025);
    if4010 = call4025;
  } else {
  }
// compiled if node returning if4010 (depth = 2)
// Begin line 1747
  setline(1747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4028 = gc_frame_new();
// call case 4: self request
  Object call4029 = callmethodflags(self, "count", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4028);
// compiled member node returning call4029 (depth = 4)
  int op_slot_right_4027 = gc_frame_newslot(call4029);
// starting to compile member node (depth = 4)
  int callframe4031 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4032 = gc_frame_new();
// call case 3: self.outer request
  Object call4033 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4032);
// compiled member node returning call4033 (depth = 5)
  Object call4034 = callmethodflags(call4033, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4031);
// compiled member node returning call4034 (depth = 4)
  int op_slot_left_4027 = gc_frame_newslot(call4034);
  params[0] = call4029;
  partcv[0] = 1;
  Object opresult4035 = callmethod(call4034, "<(1)", 1, partcv, params);
// compiled op node returning opresult4035 (depth = 3)
  Object if4026 = done;
  if (istrue(opresult4035)) {
// starting to compile call node (depth = 3)
  int callframe4036 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4038 == NULL) {
    strlit4038 = alloc_String("");
    gc_root(strlit4038);
  }
// compiled string node returning strlit4038 (depth = 5)
  int op_slot_right_4037 = gc_frame_newslot(strlit4038);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4041 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4042 = gc_frame_new();
// call case 3: self.outer request
  Object call4043 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4042);
// compiled member node returning call4043 (depth = 7)
  Object call4044 = callmethodflags(call4043, "asString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4041);
// compiled member node returning call4044 (depth = 6)
  int op_slot_right_4040 = gc_frame_newslot(call4044);
// starting to compile string node (depth = 6)
  if (strlit4046 == NULL) {
    strlit4046 = alloc_String("over ");
    gc_root(strlit4046);
  }
// compiled string node returning strlit4046 (depth = 6)
  int op_slot_left_4040 = gc_frame_newslot(strlit4046);
  params[0] = call4044;
  partcv[0] = 1;
  Object opresult4047 = callmethod(strlit4046, "++(1)", 1, partcv, params);
// compiled op node returning opresult4047 (depth = 5)
  int op_slot_left_4037 = gc_frame_newslot(opresult4047);
  params[0] = strlit4038;
  partcv[0] = 1;
  Object opresult4048 = callmethod(opresult4047, "++(1)", 1, partcv, params);
// compiled op node returning opresult4048 (depth = 4)
  gc_frame_newslot(opresult4048);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_IteratorExhausted (depth = 4)
  params[0] = opresult4048;
  partcv[0] = 1;
  Object call4049 = callmethodflags(*var_IteratorExhausted, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4036);
// compiled call node returning call4049 (depth = 3)
    gc_frame_newslot(call4049);
    if4026 = call4049;
  } else {
  }
// compiled if node returning if4026 (depth = 2)
// Begin line 1748
  setline(1748);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4050 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4051 = alloc_Block(NULL, NULL, "collectionsPrelude", 1748);
  gc_frame_newslot(block4051);
// method "_apply"
  block_savedest(block4051);
  Object closure4052 = createclosure(3, "_apply");
  setclosureframe(closure4052, stackframe);
  addtoclosure(closure4052, var_removed);
  addtoclosure(closure4052, var_unused);
  addtoclosure(closure4052, selfslot);
  struct UserObject *uo4052 = (struct UserObject*)block4051;
  uo4052->data[0] = (Object)closure4052;
  Method *meth_meth_collectionsPrelude__apply4052 = addmethod2pos(block4051, "_apply", &meth_collectionsPrelude__apply4052, 0);
  int argcv_meth_collectionsPrelude__apply4052[] = {0};
  meth_meth_collectionsPrelude__apply4052->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4052);
  meth_meth_collectionsPrelude__apply4052->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4052->definitionLine = 1963;
// compiled block node returning block4051 (depth = 3)
  gc_frame_newslot(block4051);
// Begin line 1751
  setline(1751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4077 = alloc_Block(NULL, NULL, "collectionsPrelude", 1751);
  gc_frame_newslot(block4077);
// method "_apply"
  block_savedest(block4077);
  Object closure4078 = createclosure(1, "_apply");
  setclosureframe(closure4078, stackframe);
  addtoclosure(closure4078, selfslot);
  struct UserObject *uo4078 = (struct UserObject*)block4077;
  uo4078->data[0] = (Object)closure4078;
  Method *meth_meth_collectionsPrelude__apply4078 = addmethod2pos(block4077, "_apply", &meth_collectionsPrelude__apply4078, 0);
  int argcv_meth_collectionsPrelude__apply4078[] = {0};
  meth_meth_collectionsPrelude__apply4078->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4078);
  meth_meth_collectionsPrelude__apply4078->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4078->definitionLine = 1963;
// compiled block node returning block4077 (depth = 3)
  gc_frame_newslot(block4077);
// call case 5: prelude request
  params[0] = block4051;
  params[1] = block4077;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4088 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4050);
// compiled call node returning call4088 (depth = 2)
// Begin line 1754
  setline(1754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4089 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4091 = alloc_Float64(1);
// compiled num node returning num4091 (depth = 4)
  int op_slot_right_4090 = gc_frame_newslot(num4091);
// starting to compile member node (depth = 4)
  int callframe4093 = gc_frame_new();
// call case 4: self request
  Object call4094 = callmethodflags(self, "count", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4093);
// compiled member node returning call4094 (depth = 4)
  int op_slot_left_4090 = gc_frame_newslot(call4094);
  params[0] = num4091;
  partcv[0] = 1;
  Object sum4095 = callmethod(call4094, "+(1)", 1, partcv, params);
// compiled op node returning sum4095 (depth = 3)
  gc_frame_newslot(sum4095);
// call case 4: self request
  params[0] = sum4095;
  partcv[0] = 1;
  Object call4096 = callmethodflags(self, "count:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4089);
// compiled call node returning call4096 (depth = 2)
// Begin line 1755
  setline(1755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4097 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4099 = alloc_Float64(1);
// compiled num node returning num4099 (depth = 4)
  int op_slot_right_4098 = gc_frame_newslot(num4099);
// starting to compile member node (depth = 4)
  int callframe4101 = gc_frame_new();
// call case 4: self request
  Object call4102 = callmethodflags(self, "idx", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4101);
// compiled member node returning call4102 (depth = 4)
  int op_slot_left_4098 = gc_frame_newslot(call4102);
  params[0] = num4099;
  partcv[0] = 1;
  Object sum4103 = callmethod(call4102, "+(1)", 1, partcv, params);
// compiled op node returning sum4103 (depth = 3)
  gc_frame_newslot(sum4103);
// call case 4: self request
  params[0] = sum4103;
  partcv[0] = 1;
  Object call4104 = callmethodflags(self, "idx:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4097);
// compiled call node returning call4104 (depth = 2)
// Begin line 1756
  setline(1756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4105 = gc_frame_new();
// call case 4: self request
  Object call4106 = callmethodflags(self, "elt", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4105);
// compiled member node returning call4106 (depth = 2)
  gc_frame_end(frame);
  return call4106;
}
Object meth_collectionsPrelude_bindingsIterator3992(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "bindingsIterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3993 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3993 = alloc_userobj2(9,7, objclass3993);
  gc_frame_newslot(obj3993);
if (objclass3993 == NULL) {
  glfree(obj3993->class->name);
  obj3993->class->name = "dictionary.empty.bindingsIterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3993, self, 0);
  addmethodreal(obj3993,"outer", &reader_collectionsPrelude_outer_3994);
  Object oldself3993 = self;
  struct StackFrameObject *oldstackframe3993 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3993);
  gc_frame_newslot((Object)stackframe);
  self = obj3993;
  Object *oldselfslot3993 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3993 = (*(struct UserObject *)self).data[0], lowerouter3993 = thisouter3993;
  if (inheritingObject3993) {
    struct UserObject *inho3993 = (struct UserObject *)inheritingObject3993;
    while (inho3993->super != GraceDefaultObject) inho3993 = (struct UserObject *)inho3993->super;
    inho3993->super = obj3993;
    self = inheritingObject3993;
    *selfslot = self;
    lowerouter3993 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3993;
  }
if (objclass3993 == NULL) {
  Method *reader3995 = addmethodrealflags(obj3993, "imods",&reader_collectionsPrelude_imods_3995, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader3995->definitionModule = modulename;
  reader3995->definitionLine = 1738;
}
adddatum2(obj3993, alloc_Undefined(), 1);
if (objclass3993 == NULL) {
  Method *reader3996 = addmethodrealflags(obj3993, "count", &reader_collectionsPrelude_count_3996, MFLAG_CONFIDENTIAL);
  Method *writer3996 = addmethodrealflags(obj3993, "count:=(1)", &writer_collectionsPrelude_count_3996, MFLAG_CONFIDENTIAL);
  reader3996->definitionModule = modulename;
  writer3996->definitionModule = modulename;
  reader3996->definitionLine = 1739;
  writer3996->definitionLine = 1739;
}
obj3993->flags |= OFLAG_MUTABLE;
adddatum2(obj3993, alloc_Undefined(), 2);
if (objclass3993 == NULL) {
  Method *reader3997 = addmethodrealflags(obj3993, "idx", &reader_collectionsPrelude_idx_3997, MFLAG_CONFIDENTIAL);
  Method *writer3997 = addmethodrealflags(obj3993, "idx:=(1)", &writer_collectionsPrelude_idx_3997, MFLAG_CONFIDENTIAL);
  reader3997->definitionModule = modulename;
  writer3997->definitionModule = modulename;
  reader3997->definitionLine = 1740;
  writer3997->definitionLine = 1740;
}
obj3993->flags |= OFLAG_MUTABLE;
adddatum2(obj3993, alloc_Undefined(), 3);
if (objclass3993 == NULL) {
  Method *reader3998 = addmethodrealflags(obj3993, "elt", &reader_collectionsPrelude_elt_3998, MFLAG_CONFIDENTIAL);
  Method *writer3998 = addmethodrealflags(obj3993, "elt:=(1)", &writer_collectionsPrelude_elt_3998, MFLAG_CONFIDENTIAL);
  reader3998->definitionModule = modulename;
  writer3998->definitionModule = modulename;
  reader3998->definitionLine = 1741;
  writer3998->definitionLine = 1741;
}
obj3993->flags |= OFLAG_MUTABLE;
adddatum2(obj3993, alloc_Undefined(), 4);
// method "hasNext"
  struct UserObject *uo3999 = (struct UserObject*)obj3993;
  uo3999->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext3999 = addmethod2pos(obj3993, "hasNext", &meth_collectionsPrelude_hasNext3999, 5);
  int argcv_meth_collectionsPrelude_hasNext3999[] = {0};
  meth_meth_collectionsPrelude_hasNext3999->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext3999);
  meth_meth_collectionsPrelude_hasNext3999->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext3999->definitionLine = 1742;
// method "next"
  block_savedest(obj3993);
  Object closure4009 = createclosure(4, "next");
  setclosureframe(closure4009, stackframe);
  addtoclosure(closure4009, var_ConcurrentModification);
  addtoclosure(closure4009, var_IteratorExhausted);
  addtoclosure(closure4009, var_removed);
  addtoclosure(closure4009, var_unused);
  struct UserObject *uo4009 = (struct UserObject*)obj3993;
  uo4009->data[6] = (Object)closure4009;
  Method *meth_meth_collectionsPrelude_next4009 = addmethod2pos(obj3993, "next", &meth_collectionsPrelude_next4009, 6);
  int argcv_meth_collectionsPrelude_next4009[] = {0};
  meth_meth_collectionsPrelude_next4009->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next4009);
  meth_meth_collectionsPrelude_next4009->definitionModule = modulename;
  meth_meth_collectionsPrelude_next4009->definitionLine = 1743;
  sourceObject = obj3993;
// Begin line 1738
  setline(1738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4107 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4108 = gc_frame_new();
// call case 3: self.outer request
  Object call4109 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4108);
// compiled member node returning call4109 (depth = 3)
  Object call4110 = callmethodflags(call4109, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4107);
// compiled member node returning call4110 (depth = 2)
  adddatum2(obj3993, call4110, 1);
  sourceObject = obj3993;
// Begin line 1739
  setline(1739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4111 = alloc_Float64(1);
// compiled num node returning num4111 (depth = 2)
  adddatum2(obj3993, num4111, 2);
  sourceObject = obj3993;
// Begin line 1740
  setline(1740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4112 = alloc_Float64(0);
// compiled num node returning num4112 (depth = 2)
  adddatum2(obj3993, num4112, 3);
  sourceObject = obj3993;
  adddatum2(obj3993, undefined, 4);
  sourceObject = obj3993;
  sourceObject = obj3993;
  objclass3993 = obj3993->class;
  objclass3993->definitionModule = modulename;
  objclass3993->definitionLine = 1736;
  (*(struct UserObject *)self).data[0] = lowerouter3993;
  self = oldself3993;
  selfslot = oldselfslot3993;
  stackframe = oldstackframe3993;
  gc_frame_end(frame);
  return obj3993;
}
Object meth_collectionsPrelude_bindingsIterator3992_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "bindingsIterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3993 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3993 = alloc_userobj2(9,7, objclass3993);
  gc_frame_newslot(obj3993);
if (objclass3993 == NULL) {
  glfree(obj3993->class->name);
  obj3993->class->name = "dictionary.empty.bindingsIterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3993, self, 0);
  addmethodreal(obj3993,"outer", &reader_collectionsPrelude_outer_3994);
  Object oldself3993 = self;
  struct StackFrameObject *oldstackframe3993 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3993);
  gc_frame_newslot((Object)stackframe);
  self = obj3993;
  Object *oldselfslot3993 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3993 = (*(struct UserObject *)self).data[0], lowerouter3993 = thisouter3993;
  if (inheritingObject3993) {
    struct UserObject *inho3993 = (struct UserObject *)inheritingObject3993;
    while (inho3993->super != GraceDefaultObject) inho3993 = (struct UserObject *)inho3993->super;
    inho3993->super = obj3993;
    self = inheritingObject3993;
    *selfslot = self;
    lowerouter3993 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3993;
  }
if (objclass3993 == NULL) {
  Method *reader3995 = addmethodrealflags(obj3993, "imods",&reader_collectionsPrelude_imods_3995, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader3995->definitionModule = modulename;
  reader3995->definitionLine = 1738;
}
adddatum2(obj3993, alloc_Undefined(), 1);
if (objclass3993 == NULL) {
  Method *reader3996 = addmethodrealflags(obj3993, "count", &reader_collectionsPrelude_count_3996, MFLAG_CONFIDENTIAL);
  Method *writer3996 = addmethodrealflags(obj3993, "count:=(1)", &writer_collectionsPrelude_count_3996, MFLAG_CONFIDENTIAL);
  reader3996->definitionModule = modulename;
  writer3996->definitionModule = modulename;
  reader3996->definitionLine = 1739;
  writer3996->definitionLine = 1739;
}
obj3993->flags |= OFLAG_MUTABLE;
adddatum2(obj3993, alloc_Undefined(), 2);
if (objclass3993 == NULL) {
  Method *reader3997 = addmethodrealflags(obj3993, "idx", &reader_collectionsPrelude_idx_3997, MFLAG_CONFIDENTIAL);
  Method *writer3997 = addmethodrealflags(obj3993, "idx:=(1)", &writer_collectionsPrelude_idx_3997, MFLAG_CONFIDENTIAL);
  reader3997->definitionModule = modulename;
  writer3997->definitionModule = modulename;
  reader3997->definitionLine = 1740;
  writer3997->definitionLine = 1740;
}
obj3993->flags |= OFLAG_MUTABLE;
adddatum2(obj3993, alloc_Undefined(), 3);
if (objclass3993 == NULL) {
  Method *reader3998 = addmethodrealflags(obj3993, "elt", &reader_collectionsPrelude_elt_3998, MFLAG_CONFIDENTIAL);
  Method *writer3998 = addmethodrealflags(obj3993, "elt:=(1)", &writer_collectionsPrelude_elt_3998, MFLAG_CONFIDENTIAL);
  reader3998->definitionModule = modulename;
  writer3998->definitionModule = modulename;
  reader3998->definitionLine = 1741;
  writer3998->definitionLine = 1741;
}
obj3993->flags |= OFLAG_MUTABLE;
adddatum2(obj3993, alloc_Undefined(), 4);
// method "hasNext"
  struct UserObject *uo3999 = (struct UserObject*)obj3993;
  uo3999->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext3999 = addmethod2pos(obj3993, "hasNext", &meth_collectionsPrelude_hasNext3999, 5);
  int argcv_meth_collectionsPrelude_hasNext3999[] = {0};
  meth_meth_collectionsPrelude_hasNext3999->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext3999);
  meth_meth_collectionsPrelude_hasNext3999->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext3999->definitionLine = 1742;
// method "next"
  block_savedest(obj3993);
  Object closure4009 = createclosure(4, "next");
  setclosureframe(closure4009, stackframe);
  addtoclosure(closure4009, var_ConcurrentModification);
  addtoclosure(closure4009, var_IteratorExhausted);
  addtoclosure(closure4009, var_removed);
  addtoclosure(closure4009, var_unused);
  struct UserObject *uo4009 = (struct UserObject*)obj3993;
  uo4009->data[6] = (Object)closure4009;
  Method *meth_meth_collectionsPrelude_next4009 = addmethod2pos(obj3993, "next", &meth_collectionsPrelude_next4009, 6);
  int argcv_meth_collectionsPrelude_next4009[] = {0};
  meth_meth_collectionsPrelude_next4009->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next4009);
  meth_meth_collectionsPrelude_next4009->definitionModule = modulename;
  meth_meth_collectionsPrelude_next4009->definitionLine = 1743;
  sourceObject = obj3993;
// Begin line 1738
  setline(1738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4107 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4108 = gc_frame_new();
// call case 3: self.outer request
  Object call4109 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4108);
// compiled member node returning call4109 (depth = 3)
  Object call4110 = callmethodflags(call4109, "mods", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4107);
// compiled member node returning call4110 (depth = 2)
  adddatum2(obj3993, call4110, 1);
  sourceObject = obj3993;
// Begin line 1739
  setline(1739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4111 = alloc_Float64(1);
// compiled num node returning num4111 (depth = 2)
  adddatum2(obj3993, num4111, 2);
  sourceObject = obj3993;
// Begin line 1740
  setline(1740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4112 = alloc_Float64(0);
// compiled num node returning num4112 (depth = 2)
  adddatum2(obj3993, num4112, 3);
  sourceObject = obj3993;
  adddatum2(obj3993, undefined, 4);
  sourceObject = obj3993;
  sourceObject = obj3993;
  objclass3993 = obj3993->class;
  objclass3993->definitionModule = modulename;
  objclass3993->definitionLine = 1736;
  (*(struct UserObject *)self).data[0] = lowerouter3993;
  self = oldself3993;
  selfslot = oldselfslot3993;
  stackframe = oldstackframe3993;
  gc_frame_end(frame);
  return obj3993;
}
Object meth_collectionsPrelude__apply_40_1_41_4141(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1765
  setline(1765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4142 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  gc_frame_newslot(*var_unused);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4143 = gc_frame_new();
// call case 4: self request
  Object call4144 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4143);
// compiled member node returning call4144 (depth = 5)
  params[0] = *var_i;
  params[1] = *var_unused;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4145 = callmethodflags(call4144, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4142);
// compiled call node returning call4145 (depth = 4)
  gc_frame_end(frame);
  return call4145;
}
Object meth_collectionsPrelude__apply_40_1_41_4161(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_oldInner = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4162 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_oldInner (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call4163 = callmethodflags(*var_oldInner, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4162);
// compiled call node returning call4163 (depth = 5)
  *var_a = call4163;
  if (call4163 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1770
  setline(1770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4166 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_4166 = gc_frame_newslot(*var_removed);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4168 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4168 (depth = 6)
  int op_slot_right_4165 = gc_frame_newslot(opresult4168);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4170 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_4170 = gc_frame_newslot(*var_unused);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4172 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4172 (depth = 6)
  int op_slot_left_4165 = gc_frame_newslot(opresult4172);
  params[0] = opresult4168;
  partcv[0] = 1;
  Object opresult4173 = callmethod(opresult4172, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4173 (depth = 5)
  Object if4164 = done;
  if (istrue(opresult4173)) {
// Begin line 1771
  setline(1771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4174 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4175 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  Object call4176 = callmethodflags(*var_a, "key", 0, partcv, params, 0);
  gc_frame_end(callframe4175);
// compiled member node returning call4176 (depth = 6)
  gc_frame_newslot(call4176);
// starting to compile member node (depth = 6)
  int callframe4177 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  Object call4178 = callmethodflags(*var_a, "value", 0, partcv, params, 0);
  gc_frame_end(callframe4177);
// compiled member node returning call4178 (depth = 6)
  gc_frame_newslot(call4178);
// call case 4: self request
  params[0] = call4176;
  params[1] = call4178;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4179 = callmethodflags(self, "at(1)put(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4174);
// compiled call node returning call4179 (depth = 5)
    gc_frame_newslot(call4179);
    if4164 = call4179;
  } else {
  }
// compiled if node returning if4164 (depth = 4)
  gc_frame_end(frame);
  return if4164;
}
Object meth_collectionsPrelude_expand4114(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expand");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var__prelude = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_c = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "c");
  Object *var_n = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "n");
  Object *var_oldInner = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "oldInner");
// Begin line 1760
  setline(1760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4115 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4116 = gc_frame_new();
// call case 4: self request
  Object call4117 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4116);
// compiled member node returning call4117 (depth = 4)
  Object call4118 = callmethodflags(call4117, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4115);
// compiled member node returning call4118 (depth = 3)
  *var_c = call4118;
  if (call4118 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1761
  setline(1761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4120 = alloc_Float64(2);
// compiled num node returning num4120 (depth = 4)
  int op_slot_right_4119 = gc_frame_newslot(num4120);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  int op_slot_left_4119 = gc_frame_newslot(*var_c);
  params[0] = num4120;
  partcv[0] = 1;
  Object prod4122 = callmethod(*var_c, "*(1)", 1, partcv, params);
// compiled op node returning prod4122 (depth = 3)
  *var_n = prod4122;
  if (prod4122 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1762
  setline(1762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4123 = gc_frame_new();
// call case 4: self request
  Object call4124 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4123);
// compiled member node returning call4124 (depth = 3)
  *var_oldInner = call4124;
  if (call4124 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1763
  setline(1763);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4125 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe4126 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4127 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var__prelude (depth = 5)
  Object call4128 = callmethodflags(*var__prelude, "primitiveArray", 0, partcv, params, 0);
  gc_frame_end(callframe4127);
// compiled member node returning call4128 (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call4129 = callmethodflags(call4128, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4126);
// compiled call node returning call4129 (depth = 3)
  gc_frame_newslot(call4129);
// call case 4: self request
  params[0] = call4129;
  partcv[0] = 1;
  Object call4130 = callmethodflags(self, "inner:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4125);
// compiled call node returning call4130 (depth = 2)
// Begin line 1764
  setline(1764);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4131 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4134 = alloc_Float64(1);
// compiled num node returning num4134 (depth = 5)
  int op_slot_right_4133 = gc_frame_newslot(num4134);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  int op_slot_left_4133 = gc_frame_newslot(*var_n);
  params[0] = num4134;
  partcv[0] = 1;
  Object diff4136 = callmethod(*var_n, "-(1)", 1, partcv, params);
// compiled op node returning diff4136 (depth = 4)
  int op_slot_right_4132 = gc_frame_newslot(diff4136);
// starting to compile num node (depth = 4)
  Object num4138 = alloc_Float64(0);
// compiled num node returning num4138 (depth = 4)
  int op_slot_left_4132 = gc_frame_newslot(num4138);
  params[0] = diff4136;
  partcv[0] = 1;
  Object opresult4139 = callmethod(num4138, "..(1)", 1, partcv, params);
// compiled op node returning opresult4139 (depth = 3)
  gc_frame_newslot(opresult4139);
// starting to compile block node (depth = 3)
  Object block4140 = alloc_Block(NULL, NULL, "collectionsPrelude", 1764);
  gc_frame_newslot(block4140);
// method "_apply(_)"
  block_savedest(block4140);
  Object closure4141 = createclosure(2, "_apply(1)");
  setclosureframe(closure4141, stackframe);
  addtoclosure(closure4141, var_unused);
  addtoclosure(closure4141, selfslot);
  struct UserObject *uo4141 = (struct UserObject*)block4140;
  uo4141->data[0] = (Object)closure4141;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4141 = addmethod2pos(block4140, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4141, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4141[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4141->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4141);
  meth_meth_collectionsPrelude__apply_40_1_41_4141->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4141->definitionLine = 1963;
// compiled block node returning block4140 (depth = 3)
  gc_frame_newslot(block4140);
// call case 5: prelude request
  params[0] = opresult4139;
  params[1] = block4140;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4147 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4131);
// compiled call node returning call4147 (depth = 2)
// Begin line 1767
  setline(1767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4148 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num4149 = alloc_Float64(0);
// compiled num node returning num4149 (depth = 3)
  gc_frame_newslot(num4149);
// call case 4: self request
  params[0] = num4149;
  partcv[0] = 1;
  Object call4150 = callmethodflags(self, "numBindings:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4148);
// compiled call node returning call4150 (depth = 2)
// Begin line 1768
  setline(1768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4151 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4154 = alloc_Float64(1);
// compiled num node returning num4154 (depth = 5)
  int op_slot_right_4153 = gc_frame_newslot(num4154);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  int op_slot_left_4153 = gc_frame_newslot(*var_c);
  params[0] = num4154;
  partcv[0] = 1;
  Object diff4156 = callmethod(*var_c, "-(1)", 1, partcv, params);
// compiled op node returning diff4156 (depth = 4)
  int op_slot_right_4152 = gc_frame_newslot(diff4156);
// starting to compile num node (depth = 4)
  Object num4158 = alloc_Float64(0);
// compiled num node returning num4158 (depth = 4)
  int op_slot_left_4152 = gc_frame_newslot(num4158);
  params[0] = diff4156;
  partcv[0] = 1;
  Object opresult4159 = callmethod(num4158, "..(1)", 1, partcv, params);
// compiled op node returning opresult4159 (depth = 3)
  gc_frame_newslot(opresult4159);
// starting to compile block node (depth = 3)
  Object block4160 = alloc_Block(NULL, NULL, "collectionsPrelude", 1768);
  gc_frame_newslot(block4160);
// method "_apply(_)"
  block_savedest(block4160);
  Object closure4161 = createclosure(4, "_apply(1)");
  setclosureframe(closure4161, stackframe);
  addtoclosure(closure4161, var_oldInner);
  addtoclosure(closure4161, var_removed);
  addtoclosure(closure4161, var_unused);
  addtoclosure(closure4161, selfslot);
  struct UserObject *uo4161 = (struct UserObject*)block4160;
  uo4161->data[0] = (Object)closure4161;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4161 = addmethod2pos(block4160, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4161, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4161[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4161->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4161);
  meth_meth_collectionsPrelude__apply_40_1_41_4161->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4161->definitionLine = 1963;
// compiled block node returning block4160 (depth = 3)
  gc_frame_newslot(block4160);
// call case 5: prelude request
  params[0] = opresult4159;
  params[1] = block4160;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4181 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4151);
// compiled call node returning call4181 (depth = 2)
  gc_frame_end(frame);
  return call4181;
}
Object meth_collectionsPrelude__apply_40_1_41_4197(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_block2 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1777
  setline(1777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4198 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4199 = gc_frame_new();
// call case 4: self request
  Object call4200 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4199);
// compiled member node returning call4200 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call4201 = callmethodflags(call4200, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4198);
// compiled call node returning call4201 (depth = 5)
  *var_a = call4201;
  if (call4201 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1778
  setline(1778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4204 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_4204 = gc_frame_newslot(*var_removed);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4206 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4206 (depth = 6)
  int op_slot_right_4203 = gc_frame_newslot(opresult4206);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4208 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_4208 = gc_frame_newslot(*var_unused);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4210 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4210 (depth = 6)
  int op_slot_left_4203 = gc_frame_newslot(opresult4210);
  params[0] = opresult4206;
  partcv[0] = 1;
  Object opresult4211 = callmethod(opresult4210, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4211 (depth = 5)
  Object if4202 = done;
  if (istrue(opresult4211)) {
// Begin line 1779
  setline(1779);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4212 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4213 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  Object call4214 = callmethodflags(*var_a, "key", 0, partcv, params, 0);
  gc_frame_end(callframe4213);
// compiled member node returning call4214 (depth = 6)
  gc_frame_newslot(call4214);
// starting to compile member node (depth = 6)
  int callframe4215 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  Object call4216 = callmethodflags(*var_a, "value", 0, partcv, params, 0);
  gc_frame_end(callframe4215);
// compiled member node returning call4216 (depth = 6)
  gc_frame_newslot(call4216);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block2 (depth = 6)
  params[0] = call4214;
  params[1] = call4216;
  partcv[0] = 2;
  Object call4217 = callmethodflags(*var_block2, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4212);
// compiled call node returning call4217 (depth = 5)
    gc_frame_newslot(call4217);
    if4202 = call4217;
  } else {
  }
// compiled if node returning if4202 (depth = 4)
  gc_frame_end(frame);
  return if4202;
}
Object meth_collectionsPrelude_keysAndValuesDo_40_1_41_4182(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "keysAndValuesDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysAndValuesDo(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysAndValuesDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part keysAndValuesDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1776
  setline(1776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4183 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4186 = alloc_Float64(1);
// compiled num node returning num4186 (depth = 5)
  int op_slot_right_4185 = gc_frame_newslot(num4186);
// starting to compile member node (depth = 5)
  int callframe4188 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4189 = gc_frame_new();
// call case 4: self request
  Object call4190 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4189);
// compiled member node returning call4190 (depth = 6)
  Object call4191 = callmethodflags(call4190, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4188);
// compiled member node returning call4191 (depth = 5)
  int op_slot_left_4185 = gc_frame_newslot(call4191);
  params[0] = num4186;
  partcv[0] = 1;
  Object diff4192 = callmethod(call4191, "-(1)", 1, partcv, params);
// compiled op node returning diff4192 (depth = 4)
  int op_slot_right_4184 = gc_frame_newslot(diff4192);
// starting to compile num node (depth = 4)
  Object num4194 = alloc_Float64(0);
// compiled num node returning num4194 (depth = 4)
  int op_slot_left_4184 = gc_frame_newslot(num4194);
  params[0] = diff4192;
  partcv[0] = 1;
  Object opresult4195 = callmethod(num4194, "..(1)", 1, partcv, params);
// compiled op node returning opresult4195 (depth = 3)
  gc_frame_newslot(opresult4195);
// starting to compile block node (depth = 3)
  Object block4196 = alloc_Block(NULL, NULL, "collectionsPrelude", 1776);
  gc_frame_newslot(block4196);
// method "_apply(_)"
  block_savedest(block4196);
  Object closure4197 = createclosure(4, "_apply(1)");
  setclosureframe(closure4197, stackframe);
  addtoclosure(closure4197, var_removed);
  addtoclosure(closure4197, var_unused);
  addtoclosure(closure4197, var_block2);
  addtoclosure(closure4197, selfslot);
  struct UserObject *uo4197 = (struct UserObject*)block4196;
  uo4197->data[0] = (Object)closure4197;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4197 = addmethod2pos(block4196, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4197, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4197[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4197->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4197);
  meth_meth_collectionsPrelude__apply_40_1_41_4197->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4197->definitionLine = 1963;
// compiled block node returning block4196 (depth = 3)
  gc_frame_newslot(block4196);
// call case 5: prelude request
  params[0] = opresult4195;
  params[1] = block4196;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4219 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4183);
// compiled call node returning call4219 (depth = 2)
  gc_frame_end(frame);
  return call4219;
}
Object meth_collectionsPrelude__apply_40_1_41_4235(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_block1 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1785
  setline(1785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4236 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4237 = gc_frame_new();
// call case 4: self request
  Object call4238 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4237);
// compiled member node returning call4238 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call4239 = callmethodflags(call4238, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4236);
// compiled call node returning call4239 (depth = 5)
  *var_a = call4239;
  if (call4239 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1786
  setline(1786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4242 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_4242 = gc_frame_newslot(*var_removed);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4244 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4244 (depth = 6)
  int op_slot_right_4241 = gc_frame_newslot(opresult4244);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4246 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_4246 = gc_frame_newslot(*var_unused);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4248 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4248 (depth = 6)
  int op_slot_left_4241 = gc_frame_newslot(opresult4248);
  params[0] = opresult4244;
  partcv[0] = 1;
  Object opresult4249 = callmethod(opresult4248, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4249 (depth = 5)
  Object if4240 = done;
  if (istrue(opresult4249)) {
// Begin line 1787
  setline(1787);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4250 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4251 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  Object call4252 = callmethodflags(*var_a, "key", 0, partcv, params, 0);
  gc_frame_end(callframe4251);
// compiled member node returning call4252 (depth = 6)
  gc_frame_newslot(call4252);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block1 (depth = 6)
  params[0] = call4252;
  partcv[0] = 1;
  Object call4253 = callmethodflags(*var_block1, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4250);
// compiled call node returning call4253 (depth = 5)
    gc_frame_newslot(call4253);
    if4240 = call4253;
  } else {
  }
// compiled if node returning if4240 (depth = 4)
  gc_frame_end(frame);
  return if4240;
}
Object meth_collectionsPrelude_keysDo_40_1_41_4220(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "keysDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysDo(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part keysDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1784
  setline(1784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4221 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4224 = alloc_Float64(1);
// compiled num node returning num4224 (depth = 5)
  int op_slot_right_4223 = gc_frame_newslot(num4224);
// starting to compile member node (depth = 5)
  int callframe4226 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4227 = gc_frame_new();
// call case 4: self request
  Object call4228 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4227);
// compiled member node returning call4228 (depth = 6)
  Object call4229 = callmethodflags(call4228, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4226);
// compiled member node returning call4229 (depth = 5)
  int op_slot_left_4223 = gc_frame_newslot(call4229);
  params[0] = num4224;
  partcv[0] = 1;
  Object diff4230 = callmethod(call4229, "-(1)", 1, partcv, params);
// compiled op node returning diff4230 (depth = 4)
  int op_slot_right_4222 = gc_frame_newslot(diff4230);
// starting to compile num node (depth = 4)
  Object num4232 = alloc_Float64(0);
// compiled num node returning num4232 (depth = 4)
  int op_slot_left_4222 = gc_frame_newslot(num4232);
  params[0] = diff4230;
  partcv[0] = 1;
  Object opresult4233 = callmethod(num4232, "..(1)", 1, partcv, params);
// compiled op node returning opresult4233 (depth = 3)
  gc_frame_newslot(opresult4233);
// starting to compile block node (depth = 3)
  Object block4234 = alloc_Block(NULL, NULL, "collectionsPrelude", 1784);
  gc_frame_newslot(block4234);
// method "_apply(_)"
  block_savedest(block4234);
  Object closure4235 = createclosure(4, "_apply(1)");
  setclosureframe(closure4235, stackframe);
  addtoclosure(closure4235, var_removed);
  addtoclosure(closure4235, var_unused);
  addtoclosure(closure4235, var_block1);
  addtoclosure(closure4235, selfslot);
  struct UserObject *uo4235 = (struct UserObject*)block4234;
  uo4235->data[0] = (Object)closure4235;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4235 = addmethod2pos(block4234, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4235, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4235[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4235->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4235);
  meth_meth_collectionsPrelude__apply_40_1_41_4235->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4235->definitionLine = 1963;
// compiled block node returning block4234 (depth = 3)
  gc_frame_newslot(block4234);
// call case 5: prelude request
  params[0] = opresult4233;
  params[1] = block4234;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4255 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4221);
// compiled call node returning call4255 (depth = 2)
  gc_frame_end(frame);
  return call4255;
}
Object meth_collectionsPrelude__apply_40_1_41_4271(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_block1 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1793
  setline(1793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4272 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4273 = gc_frame_new();
// call case 4: self request
  Object call4274 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4273);
// compiled member node returning call4274 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call4275 = callmethodflags(call4274, "at(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4272);
// compiled call node returning call4275 (depth = 5)
  *var_a = call4275;
  if (call4275 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1794
  setline(1794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4278 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_4278 = gc_frame_newslot(*var_removed);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4280 = callmethod(*var_removed, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4280 (depth = 6)
  int op_slot_right_4277 = gc_frame_newslot(opresult4280);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4282 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_4282 = gc_frame_newslot(*var_unused);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4284 = callmethod(*var_unused, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4284 (depth = 6)
  int op_slot_left_4277 = gc_frame_newslot(opresult4284);
  params[0] = opresult4280;
  partcv[0] = 1;
  Object opresult4285 = callmethod(opresult4284, "&&(1)", 1, partcv, params);
// compiled op node returning opresult4285 (depth = 5)
  Object if4276 = done;
  if (istrue(opresult4285)) {
// Begin line 1795
  setline(1795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4286 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe4287 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  Object call4288 = callmethodflags(*var_a, "value", 0, partcv, params, 0);
  gc_frame_end(callframe4287);
// compiled member node returning call4288 (depth = 6)
  gc_frame_newslot(call4288);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block1 (depth = 6)
  params[0] = call4288;
  partcv[0] = 1;
  Object call4289 = callmethodflags(*var_block1, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4286);
// compiled call node returning call4289 (depth = 5)
    gc_frame_newslot(call4289);
    if4276 = call4289;
  } else {
  }
// compiled if node returning if4276 (depth = 4)
  gc_frame_end(frame);
  return if4276;
}
Object meth_collectionsPrelude_valuesDo_40_1_41_4256(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "valuesDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method valuesDo(_)");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for valuesDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part valuesDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1792
  setline(1792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4257 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4260 = alloc_Float64(1);
// compiled num node returning num4260 (depth = 5)
  int op_slot_right_4259 = gc_frame_newslot(num4260);
// starting to compile member node (depth = 5)
  int callframe4262 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4263 = gc_frame_new();
// call case 4: self request
  Object call4264 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4263);
// compiled member node returning call4264 (depth = 6)
  Object call4265 = callmethodflags(call4264, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4262);
// compiled member node returning call4265 (depth = 5)
  int op_slot_left_4259 = gc_frame_newslot(call4265);
  params[0] = num4260;
  partcv[0] = 1;
  Object diff4266 = callmethod(call4265, "-(1)", 1, partcv, params);
// compiled op node returning diff4266 (depth = 4)
  int op_slot_right_4258 = gc_frame_newslot(diff4266);
// starting to compile num node (depth = 4)
  Object num4268 = alloc_Float64(0);
// compiled num node returning num4268 (depth = 4)
  int op_slot_left_4258 = gc_frame_newslot(num4268);
  params[0] = diff4266;
  partcv[0] = 1;
  Object opresult4269 = callmethod(num4268, "..(1)", 1, partcv, params);
// compiled op node returning opresult4269 (depth = 3)
  gc_frame_newslot(opresult4269);
// starting to compile block node (depth = 3)
  Object block4270 = alloc_Block(NULL, NULL, "collectionsPrelude", 1792);
  gc_frame_newslot(block4270);
// method "_apply(_)"
  block_savedest(block4270);
  Object closure4271 = createclosure(4, "_apply(1)");
  setclosureframe(closure4271, stackframe);
  addtoclosure(closure4271, var_removed);
  addtoclosure(closure4271, var_unused);
  addtoclosure(closure4271, var_block1);
  addtoclosure(closure4271, selfslot);
  struct UserObject *uo4271 = (struct UserObject*)block4270;
  uo4271->data[0] = (Object)closure4271;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4271 = addmethod2pos(block4270, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4271, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4271[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4271->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4271);
  meth_meth_collectionsPrelude__apply_40_1_41_4271->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4271->definitionLine = 1963;
// compiled block node returning block4270 (depth = 3)
  gc_frame_newslot(block4270);
// call case 5: prelude request
  params[0] = opresult4269;
  params[1] = block4270;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4291 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4257);
// compiled call node returning call4291 (depth = 2)
  gc_frame_end(frame);
  return call4291;
}
Object meth_collectionsPrelude_do_40_1_41_4292(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1799
  setline(1799);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4293 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_block1 (depth = 3)
  gc_frame_newslot(*var_block1);
// call case 4: self request
  params[0] = *var_block1;
  partcv[0] = 1;
  Object call4294 = callmethodflags(self, "valuesDo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4293);
// compiled call node returning call4294 (depth = 2)
  gc_frame_end(frame);
  return call4294;
}
Object meth_collectionsPrelude__apply4316(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile return node (depth = 10)
// starting to compile identifier node (depth = 11)
  Object bool4317 = alloc_Boolean(0);
// compiled identifier node returning bool4317 (depth = 11)
  block_return(realself, bool4317);
// compiled return node returning undefined (depth = 10)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply_40_2_41_4310(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_o = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1806
  setline(1806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_v (depth = 8)
  int op_slot_right_4312 = gc_frame_newslot(*var_v);
// starting to compile call node (depth = 8)
  int callframe4314 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_k (depth = 9)
  gc_frame_newslot(*var_k);
// starting to compile block node (depth = 9)
  Object block4315 = alloc_Block(NULL, NULL, "collectionsPrelude", 1806);
  gc_frame_newslot(block4315);
// method "_apply"
  block_savedest(block4315);
  Object closure4316 = createclosure(1, "_apply");
  setclosureframe(closure4316, stackframe);
  addtoclosure(closure4316, selfslot);
  struct UserObject *uo4316 = (struct UserObject*)block4315;
  uo4316->data[0] = (Object)closure4316;
  Method *meth_meth_collectionsPrelude__apply4316 = addmethod2pos(block4315, "_apply", &meth_collectionsPrelude__apply4316, 0);
  int argcv_meth_collectionsPrelude__apply4316[] = {0};
  meth_meth_collectionsPrelude__apply4316->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4316);
  meth_meth_collectionsPrelude__apply4316->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4316->definitionLine = 1963;
// compiled block node returning block4315 (depth = 9)
  gc_frame_newslot(block4315);
// call case 6: other requests
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_o (depth = 9)
  params[0] = *var_k;
  params[1] = block4315;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4319 = callmethodflags(*var_o, "at(1)ifAbsent(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4314);
// compiled call node returning call4319 (depth = 8)
  int op_slot_left_4312 = gc_frame_newslot(call4319);
  params[0] = *var_v;
  partcv[0] = 1;
  Object opresult4320 = callmethod(call4319, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4320 (depth = 7)
  Object if4311 = done;
  if (istrue(opresult4320)) {
// Begin line 1807
  setline(1807);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool4321 = alloc_Boolean(0);
// compiled identifier node returning bool4321 (depth = 8)
  block_return(realself, bool4321);
// compiled return node returning undefined (depth = 7)
    gc_frame_newslot(undefined);
    if4311 = undefined;
  } else {
  }
// compiled if node returning if4311 (depth = 6)
  gc_frame_end(frame);
  return if4311;
}
Object meth_collectionsPrelude__apply_40_1_41_4298(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1804
  setline(1804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4301 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  Object call4302 = callmethodflags(*var_o, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4301);
// compiled member node returning call4302 (depth = 6)
  int op_slot_right_4300 = gc_frame_newslot(call4302);
// starting to compile member node (depth = 6)
  int callframe4304 = gc_frame_new();
// call case 4: self request
  Object call4305 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4304);
// compiled member node returning call4305 (depth = 6)
  int op_slot_left_4300 = gc_frame_newslot(call4305);
  params[0] = call4302;
  partcv[0] = 1;
  Object opresult4306 = callmethod(call4305, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4306 (depth = 5)
  Object if4299 = done;
  if (istrue(opresult4306)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4307 = alloc_Boolean(0);
// compiled identifier node returning bool4307 (depth = 6)
  block_return(realself, bool4307);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if4299 = undefined;
  } else {
  }
// compiled if node returning if4299 (depth = 4)
// Begin line 1805
  setline(1805);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4308 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block4309 = alloc_Block(NULL, NULL, "collectionsPrelude", 1805);
  gc_frame_newslot(block4309);
// method "_apply(_,_)"
  block_savedest(block4309);
  Object closure4310 = createclosure(2, "_apply(2)");
  setclosureframe(closure4310, stackframe);
  addtoclosure(closure4310, var_o);
  addtoclosure(closure4310, selfslot);
  struct UserObject *uo4310 = (struct UserObject*)block4309;
  uo4310->data[0] = (Object)closure4310;
  Method *meth_meth_collectionsPrelude__apply_40_2_41_4310 = addmethod2pos(block4309, "_apply(2)", &meth_collectionsPrelude__apply_40_2_41_4310, 0);
  int argcv_meth_collectionsPrelude__apply_40_2_41_4310[] = {2};
  meth_meth_collectionsPrelude__apply_40_2_41_4310->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_2_41_4310);
  meth_meth_collectionsPrelude__apply_40_2_41_4310->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_2_41_4310->definitionLine = 1963;
// compiled block node returning block4309 (depth = 5)
  gc_frame_newslot(block4309);
// call case 4: self request
  params[0] = block4309;
  partcv[0] = 1;
  Object call4323 = callmethodflags(self, "keysAndValuesDo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4308);
// compiled call node returning call4323 (depth = 4)
// Begin line 1810
  setline(1810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4324 = alloc_Boolean(1);
// compiled identifier node returning bool4324 (depth = 5)
  block_return(realself, bool4324);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply_40_1_41_4336(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___19 = &(stackframe->slots[0]);
  *var___19 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1813
  setline(1813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4337 = alloc_Boolean(0);
// compiled identifier node returning bool4337 (depth = 5)
  block_return(realself, bool4337);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__61__61__40_1_41_4295(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[2];
  int partcv[1];
  Object *var_ComparableToDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1802
  setline(1802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  int frame4296 = gc_frame_new();
  gc_frame_newslot(*var_other);
// Begin line 1803
  setline(1803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4297 = alloc_Block(NULL, NULL, "collectionsPrelude", 1803);
  gc_frame_newslot(block4297);
// method "_apply(_)"
  block_savedest(block4297);
  Object closure4298 = createclosure(1, "_apply(1)");
  setclosureframe(closure4298, stackframe);
  addtoclosure(closure4298, selfslot);
  struct UserObject *uo4298 = (struct UserObject*)block4297;
  uo4298->data[0] = (Object)closure4298;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4298 = addmethod2pos(block4297, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4298, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4298[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4298->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4298);
  meth_meth_collectionsPrelude__apply_40_1_41_4298->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4298->definitionLine = 1963;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4326 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe4327 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4328 == NULL) {
    strlit4328 = alloc_String("o");
    gc_root(strlit4328);
  }
// compiled string node returning strlit4328 (depth = 6)
  gc_frame_newslot(strlit4328);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4329 = gc_frame_new();
// call case 5: prelude request
  Object call4330 = callmethodflags(prelude, "VariablePattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4329);
// compiled member node returning call4330 (depth = 6)
  params[0] = strlit4328;
  partcv[0] = 1;
  Object call4331 = callmethodflags(call4330, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4327);
// compiled call node returning call4331 (depth = 5)
  gc_frame_newslot(call4331);
// Begin line 1803
  setline(1803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ComparableToDictionary (depth = 5)
  gc_frame_newslot(*var_ComparableToDictionary);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4332 = gc_frame_new();
// call case 5: prelude request
  Object call4333 = callmethodflags(prelude, "AndPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4332);
// compiled member node returning call4333 (depth = 5)
  params[0] = call4331;
  params[1] = *var_ComparableToDictionary;
  partcv[0] = 2;
  Object call4334 = callmethodflags(call4333, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4326);
// compiled call node returning call4334 (depth = 4)
((struct UserObject *)block4297)->data[1] = call4334;
// compiled block node returning block4297 (depth = 3)
  gc_frame_newslot(block4297);
// Begin line 1812
  setline(1812);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4335 = alloc_Block(NULL, NULL, "collectionsPrelude", 1812);
  gc_frame_newslot(block4335);
// method "_apply(_)"
  block_savedest(block4335);
  Object closure4336 = createclosure(1, "_apply(1)");
  setclosureframe(closure4336, stackframe);
  addtoclosure(closure4336, selfslot);
  struct UserObject *uo4336 = (struct UserObject*)block4335;
  uo4336->data[0] = (Object)closure4336;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4336 = addmethod2pos(block4335, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4336, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4336[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4336->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4336);
  meth_meth_collectionsPrelude__apply_40_1_41_4336->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4336->definitionLine = 1963;
// compiled block node returning block4335 (depth = 3)
  gc_frame_newslot(block4335);
  params[0] = block4297;
  params[1] = block4335;
  Object matchres4296 = matchCase(*var_other, params, 2,NULL);
  gc_frame_end(frame4296);
// compiled matchcase node returning matchres4296 (depth = 2)
  gc_frame_end(frame);
  return matchres4296;
}
Object meth_collectionsPrelude__apply_40_2_41_4350(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_newCopy = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1820
  setline(1820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4351 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  gc_frame_newslot(*var_k);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newCopy (depth = 5)
  params[0] = *var_k;
  params[1] = *var_v;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4352 = callmethodflags(*var_newCopy, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4351);
// compiled call node returning call4352 (depth = 4)
  gc_frame_end(frame);
  return call4352;
}
Object meth_collectionsPrelude_copy4339(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "copy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newCopy = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "newCopy");
// Begin line 1818
  setline(1818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4340 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4341 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4342 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4343 = gc_frame_new();
// call case 3: self.outer request
  Object call4344 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4343);
// compiled member node returning call4344 (depth = 6)
  Object call4345 = callmethodflags(call4344, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4342);
// compiled member node returning call4345 (depth = 5)
  Object call4346 = callmethodflags(call4345, "dictionary", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4341);
// compiled member node returning call4346 (depth = 4)
  Object call4347 = callmethodflags(call4346, "empty", 0, partcv, params, 0);
  gc_frame_end(callframe4340);
// compiled member node returning call4347 (depth = 3)
  *var_newCopy = call4347;
  if (call4347 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1819
  setline(1819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4348 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4349 = alloc_Block(NULL, NULL, "collectionsPrelude", 1819);
  gc_frame_newslot(block4349);
// method "_apply(_,_)"
  block_savedest(block4349);
  Object closure4350 = createclosure(2, "_apply(2)");
  setclosureframe(closure4350, stackframe);
  addtoclosure(closure4350, var_newCopy);
  addtoclosure(closure4350, selfslot);
  struct UserObject *uo4350 = (struct UserObject*)block4349;
  uo4350->data[0] = (Object)closure4350;
  Method *meth_meth_collectionsPrelude__apply_40_2_41_4350 = addmethod2pos(block4349, "_apply(2)", &meth_collectionsPrelude__apply_40_2_41_4350, 0);
  int argcv_meth_collectionsPrelude__apply_40_2_41_4350[] = {2};
  meth_meth_collectionsPrelude__apply_40_2_41_4350->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_2_41_4350);
  meth_meth_collectionsPrelude__apply_40_2_41_4350->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_2_41_4350->definitionLine = 1963;
// compiled block node returning block4349 (depth = 3)
  gc_frame_newslot(block4349);
// call case 4: self request
  params[0] = block4349;
  partcv[0] = 1;
  Object call4354 = callmethodflags(self, "keysAndValuesDo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4348);
// compiled call node returning call4354 (depth = 2)
// Begin line 1822
  setline(1822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_newCopy (depth = 2)
  gc_frame_end(frame);
  return *var_newCopy;
}
Object meth_collectionsPrelude_asDictionary4355(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDictionary");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1826
  setline(1826);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply_40_2_41_4361(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_newDict = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1832
  setline(1832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4362 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  gc_frame_newslot(*var_k);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newDict (depth = 5)
  params[0] = *var_k;
  params[1] = *var_v;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4363 = callmethodflags(*var_newDict, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4362);
// compiled call node returning call4363 (depth = 4)
  gc_frame_end(frame);
  return call4363;
}
Object meth_collectionsPrelude__43__43__40_1_41_4356(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ++(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newDict = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newDict");
// Begin line 1830
  setline(1830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4357 = gc_frame_new();
// call case 4: self request
  Object call4358 = callmethodflags(self, "copy", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4357);
// compiled member node returning call4358 (depth = 3)
  *var_newDict = call4358;
  if (call4358 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1831
  setline(1831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4359 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4360 = alloc_Block(NULL, NULL, "collectionsPrelude", 1831);
  gc_frame_newslot(block4360);
// method "_apply(_,_)"
  block_savedest(block4360);
  Object closure4361 = createclosure(2, "_apply(2)");
  setclosureframe(closure4361, stackframe);
  addtoclosure(closure4361, var_newDict);
  addtoclosure(closure4361, selfslot);
  struct UserObject *uo4361 = (struct UserObject*)block4360;
  uo4361->data[0] = (Object)closure4361;
  Method *meth_meth_collectionsPrelude__apply_40_2_41_4361 = addmethod2pos(block4360, "_apply(2)", &meth_collectionsPrelude__apply_40_2_41_4361, 0);
  int argcv_meth_collectionsPrelude__apply_40_2_41_4361[] = {2};
  meth_meth_collectionsPrelude__apply_40_2_41_4361->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_2_41_4361);
  meth_meth_collectionsPrelude__apply_40_2_41_4361->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_2_41_4361->definitionLine = 1963;
// compiled block node returning block4360 (depth = 3)
  gc_frame_newslot(block4360);
// call case 6: other requests
// Begin line 1831
  setline(1831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  params[0] = block4360;
  partcv[0] = 1;
  Object call4365 = callmethodflags(*var_other, "keysAndValuesDo(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4359);
// compiled call node returning call4365 (depth = 2)
// Begin line 1834
  setline(1834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_newDict (depth = 3)
  return *var_newDict;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply_40_2_41_4377(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_other = getfromclosure(closure, 0);
  Object *var_newDict = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1840
  setline(1840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4379 = gc_frame_new();
// call case 6: other requests
// starting to compile call node (depth = 6)
  int callframe4380 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_k (depth = 7)
  gc_frame_newslot(*var_k);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  params[0] = *var_k;
  partcv[0] = 1;
  Object call4381 = callmethodflags(*var_other, "containsKey(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4380);
// compiled call node returning call4381 (depth = 6)
  partcv[0] = 0;
  Object call4382 = callmethodflags(call4381, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe4379);
// compiled call node returning call4382 (depth = 5)
  Object if4378 = done;
  if (istrue(call4382)) {
// Begin line 1841
  setline(1841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4383 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  gc_frame_newslot(*var_k);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newDict (depth = 6)
  params[0] = *var_k;
  params[1] = *var_v;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4384 = callmethodflags(*var_newDict, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4383);
// compiled call node returning call4384 (depth = 5)
    gc_frame_newslot(call4384);
    if4378 = call4384;
  } else {
  }
// compiled if node returning if4378 (depth = 4)
  gc_frame_end(frame);
  return if4378;
}
Object meth_collectionsPrelude__45__45__40_1_41_4366(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "--(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method --(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for --(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part --(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newDict = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newDict");
// Begin line 1838
  setline(1838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4367 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4368 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4369 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4370 = gc_frame_new();
// call case 3: self.outer request
  Object call4371 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4370);
// compiled member node returning call4371 (depth = 6)
  Object call4372 = callmethodflags(call4371, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4369);
// compiled member node returning call4372 (depth = 5)
  Object call4373 = callmethodflags(call4372, "dictionary", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4368);
// compiled member node returning call4373 (depth = 4)
  Object call4374 = callmethodflags(call4373, "empty", 0, partcv, params, 0);
  gc_frame_end(callframe4367);
// compiled member node returning call4374 (depth = 3)
  *var_newDict = call4374;
  if (call4374 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1839
  setline(1839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4375 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4376 = alloc_Block(NULL, NULL, "collectionsPrelude", 1839);
  gc_frame_newslot(block4376);
// method "_apply(_,_)"
  block_savedest(block4376);
  Object closure4377 = createclosure(3, "_apply(2)");
  setclosureframe(closure4377, stackframe);
  addtoclosure(closure4377, var_other);
  addtoclosure(closure4377, var_newDict);
  addtoclosure(closure4377, selfslot);
  struct UserObject *uo4377 = (struct UserObject*)block4376;
  uo4377->data[0] = (Object)closure4377;
  Method *meth_meth_collectionsPrelude__apply_40_2_41_4377 = addmethod2pos(block4376, "_apply(2)", &meth_collectionsPrelude__apply_40_2_41_4377, 0);
  int argcv_meth_collectionsPrelude__apply_40_2_41_4377[] = {2};
  meth_meth_collectionsPrelude__apply_40_2_41_4377->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_2_41_4377);
  meth_meth_collectionsPrelude__apply_40_2_41_4377->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_2_41_4377->definitionLine = 1963;
// compiled block node returning block4376 (depth = 3)
  gc_frame_newslot(block4376);
// call case 4: self request
  params[0] = block4376;
  partcv[0] = 1;
  Object call4386 = callmethodflags(self, "keysAndValuesDo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4375);
// compiled call node returning call4386 (depth = 2)
// Begin line 1844
  setline(1844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_newDict (depth = 3)
  return *var_newDict;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply_40_1_41_4410(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1500
  setline(1500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4411 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  gc_frame_newslot(*var_unused);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4412 = gc_frame_new();
// call case 4: self request
  Object call4413 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4412);
// compiled member node returning call4413 (depth = 5)
  params[0] = *var_i;
  params[1] = *var_unused;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4414 = callmethodflags(call4413, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4411);
// compiled call node returning call4414 (depth = 4)
  gc_frame_end(frame);
  return call4414;
}
Object meth_collectionsPrelude_empty3102(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "empty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_binding = getfromclosure(closure, 2);
  Object *var_NoSuchObject = getfromclosure(closure, 3);
  Object *var_enumerable = getfromclosure(closure, 4);
  Object *var_ConcurrentModification = getfromclosure(closure, 5);
  Object *var_IteratorExhausted = getfromclosure(closure, 6);
  Object *var__prelude = getfromclosure(closure, 7);
  Object *var_ComparableToDictionary = getfromclosure(closure, 8);
  Object *var_collection = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3103 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3103 = alloc_userobj2(43,41, objclass3103);
  gc_frame_newslot(obj3103);
if (objclass3103 == NULL) {
  glfree(obj3103->class->name);
  obj3103->class->name = "dictionary.empty";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3103, self, 0);
  addmethodreal(obj3103,"outer", &reader_collectionsPrelude_outer_3104);
  Object oldself3103 = self;
  struct StackFrameObject *oldstackframe3103 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3103);
  gc_frame_newslot((Object)stackframe);
  self = obj3103;
  Object *oldselfslot3103 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3103 = (*(struct UserObject *)self).data[0], lowerouter3103 = thisouter3103;
  if (inheritingObject3103) {
    struct UserObject *inho3103 = (struct UserObject *)inheritingObject3103;
    while (inho3103->super != GraceDefaultObject) inho3103 = (struct UserObject *)inho3103->super;
    inho3103->super = obj3103;
    self = inheritingObject3103;
    *selfslot = self;
    lowerouter3103 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3103;
  }
if (objclass3103 == NULL) {
  Method *reader3105 = addmethodrealflags(obj3103, "mods", &reader_collectionsPrelude_mods_3105, 0);
  Method *writer3105 = addmethodrealflags(obj3103, "mods:=(1)", &writer_collectionsPrelude_mods_3105, MFLAG_CONFIDENTIAL);
  reader3105->definitionModule = modulename;
  writer3105->definitionModule = modulename;
  reader3105->definitionLine = 1496;
  writer3105->definitionLine = 1496;
}
obj3103->flags |= OFLAG_MUTABLE;
adddatum2(obj3103, alloc_Undefined(), 1);
if (objclass3103 == NULL) {
  Method *reader3106 = addmethodrealflags(obj3103, "numBindings", &reader_collectionsPrelude_numBindings_3106, MFLAG_CONFIDENTIAL);
  Method *writer3106 = addmethodrealflags(obj3103, "numBindings:=(1)", &writer_collectionsPrelude_numBindings_3106, MFLAG_CONFIDENTIAL);
  reader3106->definitionModule = modulename;
  writer3106->definitionModule = modulename;
  reader3106->definitionLine = 1497;
  writer3106->definitionLine = 1497;
}
obj3103->flags |= OFLAG_MUTABLE;
adddatum2(obj3103, alloc_Undefined(), 2);
if (objclass3103 == NULL) {
  Method *reader3107 = addmethodrealflags(obj3103, "inner", &reader_collectionsPrelude_inner_3107, MFLAG_CONFIDENTIAL);
  Method *writer3107 = addmethodrealflags(obj3103, "inner:=(1)", &writer_collectionsPrelude_inner_3107, MFLAG_CONFIDENTIAL);
  reader3107->definitionModule = modulename;
  writer3107->definitionModule = modulename;
  reader3107->definitionLine = 1498;
  writer3107->definitionLine = 1498;
}
obj3103->flags |= OFLAG_MUTABLE;
adddatum2(obj3103, alloc_Undefined(), 3);
// method "size"
  struct UserObject *uo3108 = (struct UserObject*)obj3103;
  uo3108->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_size3108 = addmethod2pos(obj3103, "size", &meth_collectionsPrelude_size3108, 4);
  int argcv_meth_collectionsPrelude_size3108[] = {0};
  meth_meth_collectionsPrelude_size3108->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size3108);
  meth_meth_collectionsPrelude_size3108->definitionModule = modulename;
  meth_meth_collectionsPrelude_size3108->definitionLine = 1502;
// method "at(_)put(_)"
  block_savedest(obj3103);
  Object closure3111 = createclosure(3, "at(1)put(1)");
  setclosureframe(closure3111, stackframe);
  addtoclosure(closure3111, var_removed);
  addtoclosure(closure3111, var_unused);
  addtoclosure(closure3111, var_binding);
  struct UserObject *uo3111 = (struct UserObject*)obj3103;
  uo3111->data[5] = (Object)closure3111;
  Method *meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_3111 = addmethod2pos(obj3103, "at(1)put(1)", &meth_collectionsPrelude_at_40_1_41_put_40_1_41_3111, 5);
  int argcv_meth_collectionsPrelude_at_40_1_41_put_40_1_41_3111[] = {1, 1};
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_3111->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40_1_41_put_40_1_41_3111);
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_3111->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_3111->definitionLine = 1503;
// method "add(_)"
  block_savedest(obj3103);
  Object closure3170 = createclosure(2, "add(1)");
  setclosureframe(closure3170, stackframe);
  addtoclosure(closure3170, var_removed);
  addtoclosure(closure3170, var_unused);
  struct UserObject *uo3170 = (struct UserObject*)obj3103;
  uo3170->data[6] = (Object)closure3170;
  Method *meth_meth_collectionsPrelude_add_40_1_41_3170 = addmethod2pos(obj3103, "add(1)", &meth_collectionsPrelude_add_40_1_41_3170, 6);
  int argcv_meth_collectionsPrelude_add_40_1_41_3170[] = {1};
  meth_meth_collectionsPrelude_add_40_1_41_3170->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add_40_1_41_3170);
  meth_meth_collectionsPrelude_add_40_1_41_3170->definitionModule = modulename;
  meth_meth_collectionsPrelude_add_40_1_41_3170->definitionLine = 1513;
// method "at(_)"
  block_savedest(obj3103);
  Object closure3229 = createclosure(1, "at(1)");
  setclosureframe(closure3229, stackframe);
  addtoclosure(closure3229, var_NoSuchObject);
  struct UserObject *uo3229 = (struct UserObject*)obj3103;
  uo3229->data[7] = (Object)closure3229;
  Method *meth_meth_collectionsPrelude_at_40_1_41_3229 = addmethod2pos(obj3103, "at(1)", &meth_collectionsPrelude_at_40_1_41_3229, 7);
  int argcv_meth_collectionsPrelude_at_40_1_41_3229[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_3229->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_3229);
  meth_meth_collectionsPrelude_at_40_1_41_3229->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_3229->definitionLine = 1523;
// method "at(_)ifAbsent(_)"
  struct UserObject *uo3254 = (struct UserObject*)obj3103;
  uo3254->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3254 = addmethod2pos(obj3103, "at(1)ifAbsent(1)", &meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3254, 8);
  int argcv_meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3254[] = {1, 1};
  meth_meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3254->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3254);
  meth_meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3254->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3254->definitionLine = 1530;
// method "containsKey(_)"
  struct UserObject *uo3271 = (struct UserObject*)obj3103;
  uo3271->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_containsKey_40_1_41_3271 = addmethod2pos(obj3103, "containsKey(1)", &meth_collectionsPrelude_containsKey_40_1_41_3271, 9);
  int argcv_meth_collectionsPrelude_containsKey_40_1_41_3271[] = {1};
  meth_meth_collectionsPrelude_containsKey_40_1_41_3271->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_containsKey_40_1_41_3271);
  meth_meth_collectionsPrelude_containsKey_40_1_41_3271->definitionModule = modulename;
  meth_meth_collectionsPrelude_containsKey_40_1_41_3271->definitionLine = 1537;
// method "removeAllKeys(_)"
  block_savedest(obj3103);
  Object closure3286 = createclosure(2, "removeAllKeys(1)");
  setclosureframe(closure3286, stackframe);
  addtoclosure(closure3286, var_removed);
  addtoclosure(closure3286, var_NoSuchObject);
  struct UserObject *uo3286 = (struct UserObject*)obj3103;
  uo3286->data[10] = (Object)closure3286;
  Method *meth_meth_collectionsPrelude_removeAllKeys_40_1_41_3286 = addmethod2pos(obj3103, "removeAllKeys(1)", &meth_collectionsPrelude_removeAllKeys_40_1_41_3286, 10);
  int argcv_meth_collectionsPrelude_removeAllKeys_40_1_41_3286[] = {1};
  meth_meth_collectionsPrelude_removeAllKeys_40_1_41_3286->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAllKeys_40_1_41_3286);
  meth_meth_collectionsPrelude_removeAllKeys_40_1_41_3286->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAllKeys_40_1_41_3286->definitionLine = 1544;
// method "removeKey(_)"
  block_savedest(obj3103);
  Object closure3334 = createclosure(2, "removeKey(1)");
  setclosureframe(closure3334, stackframe);
  addtoclosure(closure3334, var_removed);
  addtoclosure(closure3334, var_NoSuchObject);
  struct UserObject *uo3334 = (struct UserObject*)obj3103;
  uo3334->data[11] = (Object)closure3334;
  Method *meth_meth_collectionsPrelude_removeKey_40_1_41_3334 = addmethod2pos(obj3103, "removeKey(1)", &meth_collectionsPrelude_removeKey_40_1_41_3334, 11);
  int argcv_meth_collectionsPrelude_removeKey_40_1_41_3334[] = {1};
  meth_meth_collectionsPrelude_removeKey_40_1_41_3334->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeKey_40_1_41_3334);
  meth_meth_collectionsPrelude_removeKey_40_1_41_3334->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeKey_40_1_41_3334->definitionLine = 1557;
// method "removeAllValues(_)"
  block_savedest(obj3103);
  Object closure3377 = createclosure(1, "removeAllValues(1)");
  setclosureframe(closure3377, stackframe);
  addtoclosure(closure3377, var_removed);
  struct UserObject *uo3377 = (struct UserObject*)obj3103;
  uo3377->data[12] = (Object)closure3377;
  Method *meth_meth_collectionsPrelude_removeAllValues_40_1_41_3377 = addmethod2pos(obj3103, "removeAllValues(1)", &meth_collectionsPrelude_removeAllValues_40_1_41_3377, 12);
  int argcv_meth_collectionsPrelude_removeAllValues_40_1_41_3377[] = {1};
  meth_meth_collectionsPrelude_removeAllValues_40_1_41_3377->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAllValues_40_1_41_3377);
  meth_meth_collectionsPrelude_removeAllValues_40_1_41_3377->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAllValues_40_1_41_3377->definitionLine = 1568;
// method "removeValue(_)"
  block_savedest(obj3103);
  Object closure3424 = createclosure(2, "removeValue(1)");
  setclosureframe(closure3424, stackframe);
  addtoclosure(closure3424, var_removed);
  addtoclosure(closure3424, var_NoSuchObject);
  struct UserObject *uo3424 = (struct UserObject*)obj3103;
  uo3424->data[13] = (Object)closure3424;
  Method *meth_meth_collectionsPrelude_removeValue_40_1_41_3424 = addmethod2pos(obj3103, "removeValue(1)", &meth_collectionsPrelude_removeValue_40_1_41_3424, 13);
  int argcv_meth_collectionsPrelude_removeValue_40_1_41_3424[] = {1};
  meth_meth_collectionsPrelude_removeValue_40_1_41_3424->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeValue_40_1_41_3424);
  meth_meth_collectionsPrelude_removeValue_40_1_41_3424->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeValue_40_1_41_3424->definitionLine = 1579;
// method "removeValue(_)ifAbsent(_)"
  block_savedest(obj3103);
  Object closure3490 = createclosure(1, "removeValue(1)ifAbsent(1)");
  setclosureframe(closure3490, stackframe);
  addtoclosure(closure3490, var_removed);
  struct UserObject *uo3490 = (struct UserObject*)obj3103;
  uo3490->data[14] = (Object)closure3490;
  Method *meth_meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3490 = addmethod2pos(obj3103, "removeValue(1)ifAbsent(1)", &meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3490, 14);
  int argcv_meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3490[] = {1, 1};
  meth_meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3490->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3490);
  meth_meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3490->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3490->definitionLine = 1595;
// method "containsValue(_)"
  struct UserObject *uo3548 = (struct UserObject*)obj3103;
  uo3548->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_containsValue_40_1_41_3548 = addmethod2pos(obj3103, "containsValue(1)", &meth_collectionsPrelude_containsValue_40_1_41_3548, 15);
  int argcv_meth_collectionsPrelude_containsValue_40_1_41_3548[] = {1};
  meth_meth_collectionsPrelude_containsValue_40_1_41_3548->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_containsValue_40_1_41_3548);
  meth_meth_collectionsPrelude_containsValue_40_1_41_3548->definitionModule = modulename;
  meth_meth_collectionsPrelude_containsValue_40_1_41_3548->definitionLine = 1611;
// method "contains(_)"
  struct UserObject *uo3560 = (struct UserObject*)obj3103;
  uo3560->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_3560 = addmethod2pos(obj3103, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_3560, 16);
  int argcv_meth_collectionsPrelude_contains_40_1_41_3560[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_3560->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_3560);
  meth_meth_collectionsPrelude_contains_40_1_41_3560->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_3560->definitionLine = 1617;
// method "findPosition(_)"
  block_savedest(obj3103);
  Object closure3563 = createclosure(1, "findPosition(1)");
  setclosureframe(closure3563, stackframe);
  addtoclosure(closure3563, var_unused);
  struct UserObject *uo3563 = (struct UserObject*)obj3103;
  uo3563->data[17] = (Object)closure3563;
  Method *meth_meth_collectionsPrelude_findPosition_40_1_41_3563 = addmethod2pos(obj3103, "findPosition(1)", &meth_collectionsPrelude_findPosition_40_1_41_3563, 17);
  int argcv_meth_collectionsPrelude_findPosition_40_1_41_3563[] = {1};
  meth_meth_collectionsPrelude_findPosition_40_1_41_3563->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPosition_40_1_41_3563);
  meth_meth_collectionsPrelude_findPosition_40_1_41_3563->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPosition_40_1_41_3563->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPosition_40_1_41_3563->definitionLine = 1619;
// method "findPositionForAdd(_)"
  block_savedest(obj3103);
  Object closure3629 = createclosure(2, "findPositionForAdd(1)");
  setclosureframe(closure3629, stackframe);
  addtoclosure(closure3629, var_removed);
  addtoclosure(closure3629, var_unused);
  struct UserObject *uo3629 = (struct UserObject*)obj3103;
  uo3629->data[18] = (Object)closure3629;
  Method *meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_3629 = addmethod2pos(obj3103, "findPositionForAdd(1)", &meth_collectionsPrelude_findPositionForAdd_40_1_41_3629, 18);
  int argcv_meth_collectionsPrelude_findPositionForAdd_40_1_41_3629[] = {1};
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_3629->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPositionForAdd_40_1_41_3629);
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_3629->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_3629->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_3629->definitionLine = 1637;
// method "asString"
  block_savedest(obj3103);
  Object closure3705 = createclosure(2, "asString");
  setclosureframe(closure3705, stackframe);
  addtoclosure(closure3705, var_removed);
  addtoclosure(closure3705, var_unused);
  struct UserObject *uo3705 = (struct UserObject*)obj3103;
  uo3705->data[19] = (Object)closure3705;
  Method *meth_meth_collectionsPrelude_asString3705 = addmethod2pos(obj3103, "asString", &meth_collectionsPrelude_asString3705, 19);
  int argcv_meth_collectionsPrelude_asString3705[] = {0};
  meth_meth_collectionsPrelude_asString3705->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString3705);
  meth_meth_collectionsPrelude_asString3705->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString3705->definitionLine = 1655;
// method "asDebugString"
  block_savedest(obj3103);
  Object closure3776 = createclosure(2, "asDebugString");
  setclosureframe(closure3776, stackframe);
  addtoclosure(closure3776, var_removed);
  addtoclosure(closure3776, var_unused);
  struct UserObject *uo3776 = (struct UserObject*)obj3103;
  uo3776->data[20] = (Object)closure3776;
  Method *meth_meth_collectionsPrelude_asDebugString3776 = addmethod2pos(obj3103, "asDebugString", &meth_collectionsPrelude_asDebugString3776, 20);
  int argcv_meth_collectionsPrelude_asDebugString3776[] = {0};
  meth_meth_collectionsPrelude_asDebugString3776->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString3776);
  meth_meth_collectionsPrelude_asDebugString3776->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString3776->definitionLine = 1673;
// method "keys"
  block_savedest(obj3103);
  Object closure3874 = createclosure(1, "keys");
  setclosureframe(closure3874, stackframe);
  addtoclosure(closure3874, var_enumerable);
  struct UserObject *uo3874 = (struct UserObject*)obj3103;
  uo3874->data[21] = (Object)closure3874;
  Method *meth_meth_collectionsPrelude_keys3874 = addmethod2pos(obj3103, "keys", &meth_collectionsPrelude_keys3874, 21);
  int argcv_meth_collectionsPrelude_keys3874[] = {0};
  meth_meth_collectionsPrelude_keys3874->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys3874);
  meth_meth_collectionsPrelude_keys3874->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys3874->definitionLine = 1686;
  block_savedest(obj3103);
  Object closure3919 = createclosure(1, "keys$object(1)");
  setclosureframe(closure3919, stackframe);
  addtoclosure(closure3919, var_enumerable);
  Method *meth_meth_collectionsPrelude_keys3874_object = addmethod2pos(obj3103, "keys$object(1)", &meth_collectionsPrelude_keys3874_object, 21);
  meth_meth_collectionsPrelude_keys3874_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys3874_object->definitionLine = 1686;
// method "values"
  block_savedest(obj3103);
  Object closure3920 = createclosure(1, "values");
  setclosureframe(closure3920, stackframe);
  addtoclosure(closure3920, var_enumerable);
  struct UserObject *uo3920 = (struct UserObject*)obj3103;
  uo3920->data[22] = (Object)closure3920;
  Method *meth_meth_collectionsPrelude_values3920 = addmethod2pos(obj3103, "values", &meth_collectionsPrelude_values3920, 22);
  int argcv_meth_collectionsPrelude_values3920[] = {0};
  meth_meth_collectionsPrelude_values3920->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values3920);
  meth_meth_collectionsPrelude_values3920->definitionModule = modulename;
  meth_meth_collectionsPrelude_values3920->definitionLine = 1704;
  block_savedest(obj3103);
  Object closure3965 = createclosure(1, "values$object(1)");
  setclosureframe(closure3965, stackframe);
  addtoclosure(closure3965, var_enumerable);
  Method *meth_meth_collectionsPrelude_values3920_object = addmethod2pos(obj3103, "values$object(1)", &meth_collectionsPrelude_values3920_object, 22);
  meth_meth_collectionsPrelude_values3920_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_values3920_object->definitionLine = 1704;
// method "bindings"
  block_savedest(obj3103);
  Object closure3966 = createclosure(1, "bindings");
  setclosureframe(closure3966, stackframe);
  addtoclosure(closure3966, var_enumerable);
  struct UserObject *uo3966 = (struct UserObject*)obj3103;
  uo3966->data[23] = (Object)closure3966;
  Method *meth_meth_collectionsPrelude_bindings3966 = addmethod2pos(obj3103, "bindings", &meth_collectionsPrelude_bindings3966, 23);
  int argcv_meth_collectionsPrelude_bindings3966[] = {0};
  meth_meth_collectionsPrelude_bindings3966->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_bindings3966);
  meth_meth_collectionsPrelude_bindings3966->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindings3966->definitionLine = 1723;
  block_savedest(obj3103);
  Object closure3986 = createclosure(1, "bindings$object(1)");
  setclosureframe(closure3986, stackframe);
  addtoclosure(closure3986, var_enumerable);
  Method *meth_meth_collectionsPrelude_bindings3966_object = addmethod2pos(obj3103, "bindings$object(1)", &meth_collectionsPrelude_bindings3966_object, 23);
  meth_meth_collectionsPrelude_bindings3966_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindings3966_object->definitionLine = 1723;
// method "iterator"
  struct UserObject *uo3987 = (struct UserObject*)obj3103;
  uo3987->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iterator3987 = addmethod2pos(obj3103, "iterator", &meth_collectionsPrelude_iterator3987, 24);
  int argcv_meth_collectionsPrelude_iterator3987[] = {0};
  meth_meth_collectionsPrelude_iterator3987->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator3987);
  meth_meth_collectionsPrelude_iterator3987->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3987->definitionLine = 1735;
// method "bindingsIterator"
  block_savedest(obj3103);
  Object closure3992 = createclosure(4, "bindingsIterator");
  setclosureframe(closure3992, stackframe);
  addtoclosure(closure3992, var_ConcurrentModification);
  addtoclosure(closure3992, var_IteratorExhausted);
  addtoclosure(closure3992, var_removed);
  addtoclosure(closure3992, var_unused);
  struct UserObject *uo3992 = (struct UserObject*)obj3103;
  uo3992->data[25] = (Object)closure3992;
  Method *meth_meth_collectionsPrelude_bindingsIterator3992 = addmethod2pos(obj3103, "bindingsIterator", &meth_collectionsPrelude_bindingsIterator3992, 25);
  int argcv_meth_collectionsPrelude_bindingsIterator3992[] = {0};
  meth_meth_collectionsPrelude_bindingsIterator3992->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_bindingsIterator3992);
  meth_meth_collectionsPrelude_bindingsIterator3992->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindingsIterator3992->definitionLine = 1736;
  block_savedest(obj3103);
  Object closure4113 = createclosure(4, "bindingsIterator$object(1)");
  setclosureframe(closure4113, stackframe);
  addtoclosure(closure4113, var_ConcurrentModification);
  addtoclosure(closure4113, var_IteratorExhausted);
  addtoclosure(closure4113, var_removed);
  addtoclosure(closure4113, var_unused);
  Method *meth_meth_collectionsPrelude_bindingsIterator3992_object = addmethod2pos(obj3103, "bindingsIterator$object(1)", &meth_collectionsPrelude_bindingsIterator3992_object, 25);
  meth_meth_collectionsPrelude_bindingsIterator3992_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindingsIterator3992_object->definitionLine = 1736;
// method "expand"
  block_savedest(obj3103);
  Object closure4114 = createclosure(3, "expand");
  setclosureframe(closure4114, stackframe);
  addtoclosure(closure4114, var__prelude);
  addtoclosure(closure4114, var_unused);
  addtoclosure(closure4114, var_removed);
  struct UserObject *uo4114 = (struct UserObject*)obj3103;
  uo4114->data[26] = (Object)closure4114;
  Method *meth_meth_collectionsPrelude_expand4114 = addmethod2pos(obj3103, "expand", &meth_collectionsPrelude_expand4114, 26);
  int argcv_meth_collectionsPrelude_expand4114[] = {0};
  meth_meth_collectionsPrelude_expand4114->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_expand4114);
  meth_meth_collectionsPrelude_expand4114->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_expand4114->definitionModule = modulename;
  meth_meth_collectionsPrelude_expand4114->definitionLine = 1759;
// method "keysAndValuesDo(_)"
  block_savedest(obj3103);
  Object closure4182 = createclosure(2, "keysAndValuesDo(1)");
  setclosureframe(closure4182, stackframe);
  addtoclosure(closure4182, var_removed);
  addtoclosure(closure4182, var_unused);
  struct UserObject *uo4182 = (struct UserObject*)obj3103;
  uo4182->data[27] = (Object)closure4182;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4182 = addmethod2pos(obj3103, "keysAndValuesDo(1)", &meth_collectionsPrelude_keysAndValuesDo_40_1_41_4182, 27);
  int argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4182[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4182->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4182);
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4182->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4182->definitionLine = 1775;
// method "keysDo(_)"
  block_savedest(obj3103);
  Object closure4220 = createclosure(2, "keysDo(1)");
  setclosureframe(closure4220, stackframe);
  addtoclosure(closure4220, var_removed);
  addtoclosure(closure4220, var_unused);
  struct UserObject *uo4220 = (struct UserObject*)obj3103;
  uo4220->data[28] = (Object)closure4220;
  Method *meth_meth_collectionsPrelude_keysDo_40_1_41_4220 = addmethod2pos(obj3103, "keysDo(1)", &meth_collectionsPrelude_keysDo_40_1_41_4220, 28);
  int argcv_meth_collectionsPrelude_keysDo_40_1_41_4220[] = {1};
  meth_meth_collectionsPrelude_keysDo_40_1_41_4220->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysDo_40_1_41_4220);
  meth_meth_collectionsPrelude_keysDo_40_1_41_4220->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysDo_40_1_41_4220->definitionLine = 1783;
// method "valuesDo(_)"
  block_savedest(obj3103);
  Object closure4256 = createclosure(2, "valuesDo(1)");
  setclosureframe(closure4256, stackframe);
  addtoclosure(closure4256, var_removed);
  addtoclosure(closure4256, var_unused);
  struct UserObject *uo4256 = (struct UserObject*)obj3103;
  uo4256->data[29] = (Object)closure4256;
  Method *meth_meth_collectionsPrelude_valuesDo_40_1_41_4256 = addmethod2pos(obj3103, "valuesDo(1)", &meth_collectionsPrelude_valuesDo_40_1_41_4256, 29);
  int argcv_meth_collectionsPrelude_valuesDo_40_1_41_4256[] = {1};
  meth_meth_collectionsPrelude_valuesDo_40_1_41_4256->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_valuesDo_40_1_41_4256);
  meth_meth_collectionsPrelude_valuesDo_40_1_41_4256->definitionModule = modulename;
  meth_meth_collectionsPrelude_valuesDo_40_1_41_4256->definitionLine = 1791;
// method "do(_)"
  struct UserObject *uo4292 = (struct UserObject*)obj3103;
  uo4292->data[30] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_4292 = addmethod2pos(obj3103, "do(1)", &meth_collectionsPrelude_do_40_1_41_4292, 30);
  int argcv_meth_collectionsPrelude_do_40_1_41_4292[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_4292->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_4292);
  meth_meth_collectionsPrelude_do_40_1_41_4292->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_4292->definitionLine = 1799;
// method "==(_)"
  block_savedest(obj3103);
  Object closure4295 = createclosure(1, "==(1)");
  setclosureframe(closure4295, stackframe);
  addtoclosure(closure4295, var_ComparableToDictionary);
  struct UserObject *uo4295 = (struct UserObject*)obj3103;
  uo4295->data[31] = (Object)closure4295;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_4295 = addmethod2pos(obj3103, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_4295, 31);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_4295[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_4295->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_4295);
  meth_meth_collectionsPrelude__61__61__40_1_41_4295->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_4295->definitionLine = 1801;
// method "copy"
  struct UserObject *uo4339 = (struct UserObject*)obj3103;
  uo4339->data[32] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy4339 = addmethod2pos(obj3103, "copy", &meth_collectionsPrelude_copy4339, 32);
  int argcv_meth_collectionsPrelude_copy4339[] = {0};
  meth_meth_collectionsPrelude_copy4339->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy4339);
  meth_meth_collectionsPrelude_copy4339->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy4339->definitionLine = 1817;
// method "asDictionary"
  struct UserObject *uo4355 = (struct UserObject*)obj3103;
  uo4355->data[33] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDictionary4355 = addmethod2pos(obj3103, "asDictionary", &meth_collectionsPrelude_asDictionary4355, 33);
  int argcv_meth_collectionsPrelude_asDictionary4355[] = {0};
  meth_meth_collectionsPrelude_asDictionary4355->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDictionary4355);
  meth_meth_collectionsPrelude_asDictionary4355->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDictionary4355->definitionLine = 1825;
// method "++(_)"
  struct UserObject *uo4356 = (struct UserObject*)obj3103;
  uo4356->data[34] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_4356 = addmethod2pos(obj3103, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_4356, 34);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_4356[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_4356->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_4356);
  meth_meth_collectionsPrelude__43__43__40_1_41_4356->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_4356->definitionLine = 1829;
// method "--(_)"
  struct UserObject *uo4366 = (struct UserObject*)obj3103;
  uo4366->data[35] = emptyclosure;
  Method *meth_meth_collectionsPrelude__45__45__40_1_41_4366 = addmethod2pos(obj3103, "--(1)", &meth_collectionsPrelude__45__45__40_1_41_4366, 35);
  int argcv_meth_collectionsPrelude__45__45__40_1_41_4366[] = {1};
  meth_meth_collectionsPrelude__45__45__40_1_41_4366->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__45__45__40_1_41_4366);
  meth_meth_collectionsPrelude__45__45__40_1_41_4366->definitionModule = modulename;
  meth_meth_collectionsPrelude__45__45__40_1_41_4366->definitionLine = 1837;
  sourceObject = obj3103;
// Begin line 1495
  setline(1495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4387 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_collection (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4388 = callmethodflags(*var_collection, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4387);
// compiled call node returning call4388 (depth = 2)
  struct UserObject *obj3103_uo = (struct UserObject *)obj3103;
  obj3103_uo->super = call4388;
  sourceObject = obj3103;
// Begin line 1496
  setline(1496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4389 = alloc_Float64(0);
// compiled num node returning num4389 (depth = 2)
  adddatum2(obj3103, num4389, 1);
  sourceObject = obj3103;
// Begin line 1497
  setline(1497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4390 = alloc_Float64(0);
// compiled num node returning num4390 (depth = 2)
  adddatum2(obj3103, num4390, 2);
  sourceObject = obj3103;
// Begin line 1498
  setline(1498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4391 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num4392 = alloc_Float64(8);
// compiled num node returning num4392 (depth = 3)
  gc_frame_newslot(num4392);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4393 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__prelude (depth = 4)
  Object call4394 = callmethodflags(*var__prelude, "primitiveArray", 0, partcv, params, 0);
  gc_frame_end(callframe4393);
// compiled member node returning call4394 (depth = 3)
  params[0] = num4392;
  partcv[0] = 1;
  Object call4395 = callmethodflags(call4394, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4391);
// compiled call node returning call4395 (depth = 2)
  adddatum2(obj3103, call4395, 3);
  sourceObject = obj3103;
// Begin line 1499
  setline(1499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4396 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4399 = alloc_Float64(1);
// compiled num node returning num4399 (depth = 5)
  int op_slot_right_4398 = gc_frame_newslot(num4399);
// starting to compile member node (depth = 5)
  int callframe4401 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4402 = gc_frame_new();
// call case 4: self request
  Object call4403 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4402);
// compiled member node returning call4403 (depth = 6)
  Object call4404 = callmethodflags(call4403, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4401);
// compiled member node returning call4404 (depth = 5)
  int op_slot_left_4398 = gc_frame_newslot(call4404);
  params[0] = num4399;
  partcv[0] = 1;
  Object diff4405 = callmethod(call4404, "-(1)", 1, partcv, params);
// compiled op node returning diff4405 (depth = 4)
  int op_slot_right_4397 = gc_frame_newslot(diff4405);
// starting to compile num node (depth = 4)
  Object num4407 = alloc_Float64(0);
// compiled num node returning num4407 (depth = 4)
  int op_slot_left_4397 = gc_frame_newslot(num4407);
  params[0] = diff4405;
  partcv[0] = 1;
  Object opresult4408 = callmethod(num4407, "..(1)", 1, partcv, params);
// compiled op node returning opresult4408 (depth = 3)
  gc_frame_newslot(opresult4408);
// starting to compile block node (depth = 3)
  Object block4409 = alloc_Block(NULL, NULL, "collectionsPrelude", 1499);
  gc_frame_newslot(block4409);
// method "_apply(_)"
  block_savedest(block4409);
  Object closure4410 = createclosure(2, "_apply(1)");
  setclosureframe(closure4410, stackframe);
  addtoclosure(closure4410, var_unused);
  addtoclosure(closure4410, selfslot);
  struct UserObject *uo4410 = (struct UserObject*)block4409;
  uo4410->data[0] = (Object)closure4410;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4410 = addmethod2pos(block4409, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4410, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4410[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4410->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4410);
  meth_meth_collectionsPrelude__apply_40_1_41_4410->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4410->definitionLine = 1963;
// compiled block node returning block4409 (depth = 3)
  gc_frame_newslot(block4409);
// call case 5: prelude request
  params[0] = opresult4408;
  params[1] = block4409;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4416 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4396);
// compiled call node returning call4416 (depth = 2)
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  objclass3103 = obj3103->class;
  objclass3103->definitionModule = modulename;
  objclass3103->definitionLine = 1494;
  (*(struct UserObject *)self).data[0] = lowerouter3103;
  self = oldself3103;
  selfslot = oldselfslot3103;
  stackframe = oldstackframe3103;
  gc_frame_end(frame);
  return obj3103;
}
Object meth_collectionsPrelude_empty3102_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "empty$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_binding = getfromclosure(closure, 2);
  Object *var_NoSuchObject = getfromclosure(closure, 3);
  Object *var_enumerable = getfromclosure(closure, 4);
  Object *var_ConcurrentModification = getfromclosure(closure, 5);
  Object *var_IteratorExhausted = getfromclosure(closure, 6);
  Object *var__prelude = getfromclosure(closure, 7);
  Object *var_ComparableToDictionary = getfromclosure(closure, 8);
  Object *var_collection = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3103 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3103 = alloc_userobj2(43,41, objclass3103);
  gc_frame_newslot(obj3103);
if (objclass3103 == NULL) {
  glfree(obj3103->class->name);
  obj3103->class->name = "dictionary.empty";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3103, self, 0);
  addmethodreal(obj3103,"outer", &reader_collectionsPrelude_outer_3104);
  Object oldself3103 = self;
  struct StackFrameObject *oldstackframe3103 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3103);
  gc_frame_newslot((Object)stackframe);
  self = obj3103;
  Object *oldselfslot3103 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3103 = (*(struct UserObject *)self).data[0], lowerouter3103 = thisouter3103;
  if (inheritingObject3103) {
    struct UserObject *inho3103 = (struct UserObject *)inheritingObject3103;
    while (inho3103->super != GraceDefaultObject) inho3103 = (struct UserObject *)inho3103->super;
    inho3103->super = obj3103;
    self = inheritingObject3103;
    *selfslot = self;
    lowerouter3103 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3103;
  }
if (objclass3103 == NULL) {
  Method *reader3105 = addmethodrealflags(obj3103, "mods", &reader_collectionsPrelude_mods_3105, 0);
  Method *writer3105 = addmethodrealflags(obj3103, "mods:=(1)", &writer_collectionsPrelude_mods_3105, MFLAG_CONFIDENTIAL);
  reader3105->definitionModule = modulename;
  writer3105->definitionModule = modulename;
  reader3105->definitionLine = 1496;
  writer3105->definitionLine = 1496;
}
obj3103->flags |= OFLAG_MUTABLE;
adddatum2(obj3103, alloc_Undefined(), 1);
if (objclass3103 == NULL) {
  Method *reader3106 = addmethodrealflags(obj3103, "numBindings", &reader_collectionsPrelude_numBindings_3106, MFLAG_CONFIDENTIAL);
  Method *writer3106 = addmethodrealflags(obj3103, "numBindings:=(1)", &writer_collectionsPrelude_numBindings_3106, MFLAG_CONFIDENTIAL);
  reader3106->definitionModule = modulename;
  writer3106->definitionModule = modulename;
  reader3106->definitionLine = 1497;
  writer3106->definitionLine = 1497;
}
obj3103->flags |= OFLAG_MUTABLE;
adddatum2(obj3103, alloc_Undefined(), 2);
if (objclass3103 == NULL) {
  Method *reader3107 = addmethodrealflags(obj3103, "inner", &reader_collectionsPrelude_inner_3107, MFLAG_CONFIDENTIAL);
  Method *writer3107 = addmethodrealflags(obj3103, "inner:=(1)", &writer_collectionsPrelude_inner_3107, MFLAG_CONFIDENTIAL);
  reader3107->definitionModule = modulename;
  writer3107->definitionModule = modulename;
  reader3107->definitionLine = 1498;
  writer3107->definitionLine = 1498;
}
obj3103->flags |= OFLAG_MUTABLE;
adddatum2(obj3103, alloc_Undefined(), 3);
// method "size"
  struct UserObject *uo3108 = (struct UserObject*)obj3103;
  uo3108->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_size3108 = addmethod2pos(obj3103, "size", &meth_collectionsPrelude_size3108, 4);
  int argcv_meth_collectionsPrelude_size3108[] = {0};
  meth_meth_collectionsPrelude_size3108->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size3108);
  meth_meth_collectionsPrelude_size3108->definitionModule = modulename;
  meth_meth_collectionsPrelude_size3108->definitionLine = 1502;
// method "at(_)put(_)"
  block_savedest(obj3103);
  Object closure3111 = createclosure(3, "at(1)put(1)");
  setclosureframe(closure3111, stackframe);
  addtoclosure(closure3111, var_removed);
  addtoclosure(closure3111, var_unused);
  addtoclosure(closure3111, var_binding);
  struct UserObject *uo3111 = (struct UserObject*)obj3103;
  uo3111->data[5] = (Object)closure3111;
  Method *meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_3111 = addmethod2pos(obj3103, "at(1)put(1)", &meth_collectionsPrelude_at_40_1_41_put_40_1_41_3111, 5);
  int argcv_meth_collectionsPrelude_at_40_1_41_put_40_1_41_3111[] = {1, 1};
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_3111->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40_1_41_put_40_1_41_3111);
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_3111->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_put_40_1_41_3111->definitionLine = 1503;
// method "add(_)"
  block_savedest(obj3103);
  Object closure3170 = createclosure(2, "add(1)");
  setclosureframe(closure3170, stackframe);
  addtoclosure(closure3170, var_removed);
  addtoclosure(closure3170, var_unused);
  struct UserObject *uo3170 = (struct UserObject*)obj3103;
  uo3170->data[6] = (Object)closure3170;
  Method *meth_meth_collectionsPrelude_add_40_1_41_3170 = addmethod2pos(obj3103, "add(1)", &meth_collectionsPrelude_add_40_1_41_3170, 6);
  int argcv_meth_collectionsPrelude_add_40_1_41_3170[] = {1};
  meth_meth_collectionsPrelude_add_40_1_41_3170->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add_40_1_41_3170);
  meth_meth_collectionsPrelude_add_40_1_41_3170->definitionModule = modulename;
  meth_meth_collectionsPrelude_add_40_1_41_3170->definitionLine = 1513;
// method "at(_)"
  block_savedest(obj3103);
  Object closure3229 = createclosure(1, "at(1)");
  setclosureframe(closure3229, stackframe);
  addtoclosure(closure3229, var_NoSuchObject);
  struct UserObject *uo3229 = (struct UserObject*)obj3103;
  uo3229->data[7] = (Object)closure3229;
  Method *meth_meth_collectionsPrelude_at_40_1_41_3229 = addmethod2pos(obj3103, "at(1)", &meth_collectionsPrelude_at_40_1_41_3229, 7);
  int argcv_meth_collectionsPrelude_at_40_1_41_3229[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_3229->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_3229);
  meth_meth_collectionsPrelude_at_40_1_41_3229->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_3229->definitionLine = 1523;
// method "at(_)ifAbsent(_)"
  struct UserObject *uo3254 = (struct UserObject*)obj3103;
  uo3254->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3254 = addmethod2pos(obj3103, "at(1)ifAbsent(1)", &meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3254, 8);
  int argcv_meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3254[] = {1, 1};
  meth_meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3254->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3254);
  meth_meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3254->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_ifAbsent_40_1_41_3254->definitionLine = 1530;
// method "containsKey(_)"
  struct UserObject *uo3271 = (struct UserObject*)obj3103;
  uo3271->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_containsKey_40_1_41_3271 = addmethod2pos(obj3103, "containsKey(1)", &meth_collectionsPrelude_containsKey_40_1_41_3271, 9);
  int argcv_meth_collectionsPrelude_containsKey_40_1_41_3271[] = {1};
  meth_meth_collectionsPrelude_containsKey_40_1_41_3271->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_containsKey_40_1_41_3271);
  meth_meth_collectionsPrelude_containsKey_40_1_41_3271->definitionModule = modulename;
  meth_meth_collectionsPrelude_containsKey_40_1_41_3271->definitionLine = 1537;
// method "removeAllKeys(_)"
  block_savedest(obj3103);
  Object closure3286 = createclosure(2, "removeAllKeys(1)");
  setclosureframe(closure3286, stackframe);
  addtoclosure(closure3286, var_removed);
  addtoclosure(closure3286, var_NoSuchObject);
  struct UserObject *uo3286 = (struct UserObject*)obj3103;
  uo3286->data[10] = (Object)closure3286;
  Method *meth_meth_collectionsPrelude_removeAllKeys_40_1_41_3286 = addmethod2pos(obj3103, "removeAllKeys(1)", &meth_collectionsPrelude_removeAllKeys_40_1_41_3286, 10);
  int argcv_meth_collectionsPrelude_removeAllKeys_40_1_41_3286[] = {1};
  meth_meth_collectionsPrelude_removeAllKeys_40_1_41_3286->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAllKeys_40_1_41_3286);
  meth_meth_collectionsPrelude_removeAllKeys_40_1_41_3286->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAllKeys_40_1_41_3286->definitionLine = 1544;
// method "removeKey(_)"
  block_savedest(obj3103);
  Object closure3334 = createclosure(2, "removeKey(1)");
  setclosureframe(closure3334, stackframe);
  addtoclosure(closure3334, var_removed);
  addtoclosure(closure3334, var_NoSuchObject);
  struct UserObject *uo3334 = (struct UserObject*)obj3103;
  uo3334->data[11] = (Object)closure3334;
  Method *meth_meth_collectionsPrelude_removeKey_40_1_41_3334 = addmethod2pos(obj3103, "removeKey(1)", &meth_collectionsPrelude_removeKey_40_1_41_3334, 11);
  int argcv_meth_collectionsPrelude_removeKey_40_1_41_3334[] = {1};
  meth_meth_collectionsPrelude_removeKey_40_1_41_3334->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeKey_40_1_41_3334);
  meth_meth_collectionsPrelude_removeKey_40_1_41_3334->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeKey_40_1_41_3334->definitionLine = 1557;
// method "removeAllValues(_)"
  block_savedest(obj3103);
  Object closure3377 = createclosure(1, "removeAllValues(1)");
  setclosureframe(closure3377, stackframe);
  addtoclosure(closure3377, var_removed);
  struct UserObject *uo3377 = (struct UserObject*)obj3103;
  uo3377->data[12] = (Object)closure3377;
  Method *meth_meth_collectionsPrelude_removeAllValues_40_1_41_3377 = addmethod2pos(obj3103, "removeAllValues(1)", &meth_collectionsPrelude_removeAllValues_40_1_41_3377, 12);
  int argcv_meth_collectionsPrelude_removeAllValues_40_1_41_3377[] = {1};
  meth_meth_collectionsPrelude_removeAllValues_40_1_41_3377->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAllValues_40_1_41_3377);
  meth_meth_collectionsPrelude_removeAllValues_40_1_41_3377->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAllValues_40_1_41_3377->definitionLine = 1568;
// method "removeValue(_)"
  block_savedest(obj3103);
  Object closure3424 = createclosure(2, "removeValue(1)");
  setclosureframe(closure3424, stackframe);
  addtoclosure(closure3424, var_removed);
  addtoclosure(closure3424, var_NoSuchObject);
  struct UserObject *uo3424 = (struct UserObject*)obj3103;
  uo3424->data[13] = (Object)closure3424;
  Method *meth_meth_collectionsPrelude_removeValue_40_1_41_3424 = addmethod2pos(obj3103, "removeValue(1)", &meth_collectionsPrelude_removeValue_40_1_41_3424, 13);
  int argcv_meth_collectionsPrelude_removeValue_40_1_41_3424[] = {1};
  meth_meth_collectionsPrelude_removeValue_40_1_41_3424->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeValue_40_1_41_3424);
  meth_meth_collectionsPrelude_removeValue_40_1_41_3424->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeValue_40_1_41_3424->definitionLine = 1579;
// method "removeValue(_)ifAbsent(_)"
  block_savedest(obj3103);
  Object closure3490 = createclosure(1, "removeValue(1)ifAbsent(1)");
  setclosureframe(closure3490, stackframe);
  addtoclosure(closure3490, var_removed);
  struct UserObject *uo3490 = (struct UserObject*)obj3103;
  uo3490->data[14] = (Object)closure3490;
  Method *meth_meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3490 = addmethod2pos(obj3103, "removeValue(1)ifAbsent(1)", &meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3490, 14);
  int argcv_meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3490[] = {1, 1};
  meth_meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3490->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3490);
  meth_meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3490->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeValue_40_1_41_ifAbsent_40_1_41_3490->definitionLine = 1595;
// method "containsValue(_)"
  struct UserObject *uo3548 = (struct UserObject*)obj3103;
  uo3548->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_containsValue_40_1_41_3548 = addmethod2pos(obj3103, "containsValue(1)", &meth_collectionsPrelude_containsValue_40_1_41_3548, 15);
  int argcv_meth_collectionsPrelude_containsValue_40_1_41_3548[] = {1};
  meth_meth_collectionsPrelude_containsValue_40_1_41_3548->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_containsValue_40_1_41_3548);
  meth_meth_collectionsPrelude_containsValue_40_1_41_3548->definitionModule = modulename;
  meth_meth_collectionsPrelude_containsValue_40_1_41_3548->definitionLine = 1611;
// method "contains(_)"
  struct UserObject *uo3560 = (struct UserObject*)obj3103;
  uo3560->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_3560 = addmethod2pos(obj3103, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_3560, 16);
  int argcv_meth_collectionsPrelude_contains_40_1_41_3560[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_3560->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_3560);
  meth_meth_collectionsPrelude_contains_40_1_41_3560->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_3560->definitionLine = 1617;
// method "findPosition(_)"
  block_savedest(obj3103);
  Object closure3563 = createclosure(1, "findPosition(1)");
  setclosureframe(closure3563, stackframe);
  addtoclosure(closure3563, var_unused);
  struct UserObject *uo3563 = (struct UserObject*)obj3103;
  uo3563->data[17] = (Object)closure3563;
  Method *meth_meth_collectionsPrelude_findPosition_40_1_41_3563 = addmethod2pos(obj3103, "findPosition(1)", &meth_collectionsPrelude_findPosition_40_1_41_3563, 17);
  int argcv_meth_collectionsPrelude_findPosition_40_1_41_3563[] = {1};
  meth_meth_collectionsPrelude_findPosition_40_1_41_3563->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPosition_40_1_41_3563);
  meth_meth_collectionsPrelude_findPosition_40_1_41_3563->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPosition_40_1_41_3563->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPosition_40_1_41_3563->definitionLine = 1619;
// method "findPositionForAdd(_)"
  block_savedest(obj3103);
  Object closure3629 = createclosure(2, "findPositionForAdd(1)");
  setclosureframe(closure3629, stackframe);
  addtoclosure(closure3629, var_removed);
  addtoclosure(closure3629, var_unused);
  struct UserObject *uo3629 = (struct UserObject*)obj3103;
  uo3629->data[18] = (Object)closure3629;
  Method *meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_3629 = addmethod2pos(obj3103, "findPositionForAdd(1)", &meth_collectionsPrelude_findPositionForAdd_40_1_41_3629, 18);
  int argcv_meth_collectionsPrelude_findPositionForAdd_40_1_41_3629[] = {1};
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_3629->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPositionForAdd_40_1_41_3629);
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_3629->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_3629->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPositionForAdd_40_1_41_3629->definitionLine = 1637;
// method "asString"
  block_savedest(obj3103);
  Object closure3705 = createclosure(2, "asString");
  setclosureframe(closure3705, stackframe);
  addtoclosure(closure3705, var_removed);
  addtoclosure(closure3705, var_unused);
  struct UserObject *uo3705 = (struct UserObject*)obj3103;
  uo3705->data[19] = (Object)closure3705;
  Method *meth_meth_collectionsPrelude_asString3705 = addmethod2pos(obj3103, "asString", &meth_collectionsPrelude_asString3705, 19);
  int argcv_meth_collectionsPrelude_asString3705[] = {0};
  meth_meth_collectionsPrelude_asString3705->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString3705);
  meth_meth_collectionsPrelude_asString3705->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString3705->definitionLine = 1655;
// method "asDebugString"
  block_savedest(obj3103);
  Object closure3776 = createclosure(2, "asDebugString");
  setclosureframe(closure3776, stackframe);
  addtoclosure(closure3776, var_removed);
  addtoclosure(closure3776, var_unused);
  struct UserObject *uo3776 = (struct UserObject*)obj3103;
  uo3776->data[20] = (Object)closure3776;
  Method *meth_meth_collectionsPrelude_asDebugString3776 = addmethod2pos(obj3103, "asDebugString", &meth_collectionsPrelude_asDebugString3776, 20);
  int argcv_meth_collectionsPrelude_asDebugString3776[] = {0};
  meth_meth_collectionsPrelude_asDebugString3776->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString3776);
  meth_meth_collectionsPrelude_asDebugString3776->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString3776->definitionLine = 1673;
// method "keys"
  block_savedest(obj3103);
  Object closure3874 = createclosure(1, "keys");
  setclosureframe(closure3874, stackframe);
  addtoclosure(closure3874, var_enumerable);
  struct UserObject *uo3874 = (struct UserObject*)obj3103;
  uo3874->data[21] = (Object)closure3874;
  Method *meth_meth_collectionsPrelude_keys3874 = addmethod2pos(obj3103, "keys", &meth_collectionsPrelude_keys3874, 21);
  int argcv_meth_collectionsPrelude_keys3874[] = {0};
  meth_meth_collectionsPrelude_keys3874->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys3874);
  meth_meth_collectionsPrelude_keys3874->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys3874->definitionLine = 1686;
  block_savedest(obj3103);
  Object closure3919 = createclosure(1, "keys$object(1)");
  setclosureframe(closure3919, stackframe);
  addtoclosure(closure3919, var_enumerable);
  Method *meth_meth_collectionsPrelude_keys3874_object = addmethod2pos(obj3103, "keys$object(1)", &meth_collectionsPrelude_keys3874_object, 21);
  meth_meth_collectionsPrelude_keys3874_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys3874_object->definitionLine = 1686;
// method "values"
  block_savedest(obj3103);
  Object closure3920 = createclosure(1, "values");
  setclosureframe(closure3920, stackframe);
  addtoclosure(closure3920, var_enumerable);
  struct UserObject *uo3920 = (struct UserObject*)obj3103;
  uo3920->data[22] = (Object)closure3920;
  Method *meth_meth_collectionsPrelude_values3920 = addmethod2pos(obj3103, "values", &meth_collectionsPrelude_values3920, 22);
  int argcv_meth_collectionsPrelude_values3920[] = {0};
  meth_meth_collectionsPrelude_values3920->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values3920);
  meth_meth_collectionsPrelude_values3920->definitionModule = modulename;
  meth_meth_collectionsPrelude_values3920->definitionLine = 1704;
  block_savedest(obj3103);
  Object closure3965 = createclosure(1, "values$object(1)");
  setclosureframe(closure3965, stackframe);
  addtoclosure(closure3965, var_enumerable);
  Method *meth_meth_collectionsPrelude_values3920_object = addmethod2pos(obj3103, "values$object(1)", &meth_collectionsPrelude_values3920_object, 22);
  meth_meth_collectionsPrelude_values3920_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_values3920_object->definitionLine = 1704;
// method "bindings"
  block_savedest(obj3103);
  Object closure3966 = createclosure(1, "bindings");
  setclosureframe(closure3966, stackframe);
  addtoclosure(closure3966, var_enumerable);
  struct UserObject *uo3966 = (struct UserObject*)obj3103;
  uo3966->data[23] = (Object)closure3966;
  Method *meth_meth_collectionsPrelude_bindings3966 = addmethod2pos(obj3103, "bindings", &meth_collectionsPrelude_bindings3966, 23);
  int argcv_meth_collectionsPrelude_bindings3966[] = {0};
  meth_meth_collectionsPrelude_bindings3966->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_bindings3966);
  meth_meth_collectionsPrelude_bindings3966->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindings3966->definitionLine = 1723;
  block_savedest(obj3103);
  Object closure3986 = createclosure(1, "bindings$object(1)");
  setclosureframe(closure3986, stackframe);
  addtoclosure(closure3986, var_enumerable);
  Method *meth_meth_collectionsPrelude_bindings3966_object = addmethod2pos(obj3103, "bindings$object(1)", &meth_collectionsPrelude_bindings3966_object, 23);
  meth_meth_collectionsPrelude_bindings3966_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindings3966_object->definitionLine = 1723;
// method "iterator"
  struct UserObject *uo3987 = (struct UserObject*)obj3103;
  uo3987->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iterator3987 = addmethod2pos(obj3103, "iterator", &meth_collectionsPrelude_iterator3987, 24);
  int argcv_meth_collectionsPrelude_iterator3987[] = {0};
  meth_meth_collectionsPrelude_iterator3987->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator3987);
  meth_meth_collectionsPrelude_iterator3987->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3987->definitionLine = 1735;
// method "bindingsIterator"
  block_savedest(obj3103);
  Object closure3992 = createclosure(4, "bindingsIterator");
  setclosureframe(closure3992, stackframe);
  addtoclosure(closure3992, var_ConcurrentModification);
  addtoclosure(closure3992, var_IteratorExhausted);
  addtoclosure(closure3992, var_removed);
  addtoclosure(closure3992, var_unused);
  struct UserObject *uo3992 = (struct UserObject*)obj3103;
  uo3992->data[25] = (Object)closure3992;
  Method *meth_meth_collectionsPrelude_bindingsIterator3992 = addmethod2pos(obj3103, "bindingsIterator", &meth_collectionsPrelude_bindingsIterator3992, 25);
  int argcv_meth_collectionsPrelude_bindingsIterator3992[] = {0};
  meth_meth_collectionsPrelude_bindingsIterator3992->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_bindingsIterator3992);
  meth_meth_collectionsPrelude_bindingsIterator3992->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindingsIterator3992->definitionLine = 1736;
  block_savedest(obj3103);
  Object closure4113 = createclosure(4, "bindingsIterator$object(1)");
  setclosureframe(closure4113, stackframe);
  addtoclosure(closure4113, var_ConcurrentModification);
  addtoclosure(closure4113, var_IteratorExhausted);
  addtoclosure(closure4113, var_removed);
  addtoclosure(closure4113, var_unused);
  Method *meth_meth_collectionsPrelude_bindingsIterator3992_object = addmethod2pos(obj3103, "bindingsIterator$object(1)", &meth_collectionsPrelude_bindingsIterator3992_object, 25);
  meth_meth_collectionsPrelude_bindingsIterator3992_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindingsIterator3992_object->definitionLine = 1736;
// method "expand"
  block_savedest(obj3103);
  Object closure4114 = createclosure(3, "expand");
  setclosureframe(closure4114, stackframe);
  addtoclosure(closure4114, var__prelude);
  addtoclosure(closure4114, var_unused);
  addtoclosure(closure4114, var_removed);
  struct UserObject *uo4114 = (struct UserObject*)obj3103;
  uo4114->data[26] = (Object)closure4114;
  Method *meth_meth_collectionsPrelude_expand4114 = addmethod2pos(obj3103, "expand", &meth_collectionsPrelude_expand4114, 26);
  int argcv_meth_collectionsPrelude_expand4114[] = {0};
  meth_meth_collectionsPrelude_expand4114->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_expand4114);
  meth_meth_collectionsPrelude_expand4114->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_expand4114->definitionModule = modulename;
  meth_meth_collectionsPrelude_expand4114->definitionLine = 1759;
// method "keysAndValuesDo(_)"
  block_savedest(obj3103);
  Object closure4182 = createclosure(2, "keysAndValuesDo(1)");
  setclosureframe(closure4182, stackframe);
  addtoclosure(closure4182, var_removed);
  addtoclosure(closure4182, var_unused);
  struct UserObject *uo4182 = (struct UserObject*)obj3103;
  uo4182->data[27] = (Object)closure4182;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4182 = addmethod2pos(obj3103, "keysAndValuesDo(1)", &meth_collectionsPrelude_keysAndValuesDo_40_1_41_4182, 27);
  int argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4182[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4182->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4182);
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4182->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4182->definitionLine = 1775;
// method "keysDo(_)"
  block_savedest(obj3103);
  Object closure4220 = createclosure(2, "keysDo(1)");
  setclosureframe(closure4220, stackframe);
  addtoclosure(closure4220, var_removed);
  addtoclosure(closure4220, var_unused);
  struct UserObject *uo4220 = (struct UserObject*)obj3103;
  uo4220->data[28] = (Object)closure4220;
  Method *meth_meth_collectionsPrelude_keysDo_40_1_41_4220 = addmethod2pos(obj3103, "keysDo(1)", &meth_collectionsPrelude_keysDo_40_1_41_4220, 28);
  int argcv_meth_collectionsPrelude_keysDo_40_1_41_4220[] = {1};
  meth_meth_collectionsPrelude_keysDo_40_1_41_4220->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysDo_40_1_41_4220);
  meth_meth_collectionsPrelude_keysDo_40_1_41_4220->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysDo_40_1_41_4220->definitionLine = 1783;
// method "valuesDo(_)"
  block_savedest(obj3103);
  Object closure4256 = createclosure(2, "valuesDo(1)");
  setclosureframe(closure4256, stackframe);
  addtoclosure(closure4256, var_removed);
  addtoclosure(closure4256, var_unused);
  struct UserObject *uo4256 = (struct UserObject*)obj3103;
  uo4256->data[29] = (Object)closure4256;
  Method *meth_meth_collectionsPrelude_valuesDo_40_1_41_4256 = addmethod2pos(obj3103, "valuesDo(1)", &meth_collectionsPrelude_valuesDo_40_1_41_4256, 29);
  int argcv_meth_collectionsPrelude_valuesDo_40_1_41_4256[] = {1};
  meth_meth_collectionsPrelude_valuesDo_40_1_41_4256->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_valuesDo_40_1_41_4256);
  meth_meth_collectionsPrelude_valuesDo_40_1_41_4256->definitionModule = modulename;
  meth_meth_collectionsPrelude_valuesDo_40_1_41_4256->definitionLine = 1791;
// method "do(_)"
  struct UserObject *uo4292 = (struct UserObject*)obj3103;
  uo4292->data[30] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_4292 = addmethod2pos(obj3103, "do(1)", &meth_collectionsPrelude_do_40_1_41_4292, 30);
  int argcv_meth_collectionsPrelude_do_40_1_41_4292[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_4292->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_4292);
  meth_meth_collectionsPrelude_do_40_1_41_4292->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_4292->definitionLine = 1799;
// method "==(_)"
  block_savedest(obj3103);
  Object closure4295 = createclosure(1, "==(1)");
  setclosureframe(closure4295, stackframe);
  addtoclosure(closure4295, var_ComparableToDictionary);
  struct UserObject *uo4295 = (struct UserObject*)obj3103;
  uo4295->data[31] = (Object)closure4295;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_4295 = addmethod2pos(obj3103, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_4295, 31);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_4295[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_4295->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_4295);
  meth_meth_collectionsPrelude__61__61__40_1_41_4295->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_4295->definitionLine = 1801;
// method "copy"
  struct UserObject *uo4339 = (struct UserObject*)obj3103;
  uo4339->data[32] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy4339 = addmethod2pos(obj3103, "copy", &meth_collectionsPrelude_copy4339, 32);
  int argcv_meth_collectionsPrelude_copy4339[] = {0};
  meth_meth_collectionsPrelude_copy4339->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy4339);
  meth_meth_collectionsPrelude_copy4339->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy4339->definitionLine = 1817;
// method "asDictionary"
  struct UserObject *uo4355 = (struct UserObject*)obj3103;
  uo4355->data[33] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDictionary4355 = addmethod2pos(obj3103, "asDictionary", &meth_collectionsPrelude_asDictionary4355, 33);
  int argcv_meth_collectionsPrelude_asDictionary4355[] = {0};
  meth_meth_collectionsPrelude_asDictionary4355->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDictionary4355);
  meth_meth_collectionsPrelude_asDictionary4355->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDictionary4355->definitionLine = 1825;
// method "++(_)"
  struct UserObject *uo4356 = (struct UserObject*)obj3103;
  uo4356->data[34] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_4356 = addmethod2pos(obj3103, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_4356, 34);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_4356[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_4356->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_4356);
  meth_meth_collectionsPrelude__43__43__40_1_41_4356->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_4356->definitionLine = 1829;
// method "--(_)"
  struct UserObject *uo4366 = (struct UserObject*)obj3103;
  uo4366->data[35] = emptyclosure;
  Method *meth_meth_collectionsPrelude__45__45__40_1_41_4366 = addmethod2pos(obj3103, "--(1)", &meth_collectionsPrelude__45__45__40_1_41_4366, 35);
  int argcv_meth_collectionsPrelude__45__45__40_1_41_4366[] = {1};
  meth_meth_collectionsPrelude__45__45__40_1_41_4366->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__45__45__40_1_41_4366);
  meth_meth_collectionsPrelude__45__45__40_1_41_4366->definitionModule = modulename;
  meth_meth_collectionsPrelude__45__45__40_1_41_4366->definitionLine = 1837;
  sourceObject = obj3103;
// Begin line 1495
  setline(1495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4387 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_collection (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4388 = callmethodflags(*var_collection, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4387);
// compiled call node returning call4388 (depth = 2)
  struct UserObject *obj3103_uo = (struct UserObject *)obj3103;
  obj3103_uo->super = call4388;
  sourceObject = obj3103;
// Begin line 1496
  setline(1496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4389 = alloc_Float64(0);
// compiled num node returning num4389 (depth = 2)
  adddatum2(obj3103, num4389, 1);
  sourceObject = obj3103;
// Begin line 1497
  setline(1497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4390 = alloc_Float64(0);
// compiled num node returning num4390 (depth = 2)
  adddatum2(obj3103, num4390, 2);
  sourceObject = obj3103;
// Begin line 1498
  setline(1498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4391 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num4392 = alloc_Float64(8);
// compiled num node returning num4392 (depth = 3)
  gc_frame_newslot(num4392);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4393 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var__prelude (depth = 4)
  Object call4394 = callmethodflags(*var__prelude, "primitiveArray", 0, partcv, params, 0);
  gc_frame_end(callframe4393);
// compiled member node returning call4394 (depth = 3)
  params[0] = num4392;
  partcv[0] = 1;
  Object call4395 = callmethodflags(call4394, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4391);
// compiled call node returning call4395 (depth = 2)
  adddatum2(obj3103, call4395, 3);
  sourceObject = obj3103;
// Begin line 1499
  setline(1499);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4396 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4399 = alloc_Float64(1);
// compiled num node returning num4399 (depth = 5)
  int op_slot_right_4398 = gc_frame_newslot(num4399);
// starting to compile member node (depth = 5)
  int callframe4401 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4402 = gc_frame_new();
// call case 4: self request
  Object call4403 = callmethodflags(self, "inner", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4402);
// compiled member node returning call4403 (depth = 6)
  Object call4404 = callmethodflags(call4403, "size", 0, partcv, params, 0);
  gc_frame_end(callframe4401);
// compiled member node returning call4404 (depth = 5)
  int op_slot_left_4398 = gc_frame_newslot(call4404);
  params[0] = num4399;
  partcv[0] = 1;
  Object diff4405 = callmethod(call4404, "-(1)", 1, partcv, params);
// compiled op node returning diff4405 (depth = 4)
  int op_slot_right_4397 = gc_frame_newslot(diff4405);
// starting to compile num node (depth = 4)
  Object num4407 = alloc_Float64(0);
// compiled num node returning num4407 (depth = 4)
  int op_slot_left_4397 = gc_frame_newslot(num4407);
  params[0] = diff4405;
  partcv[0] = 1;
  Object opresult4408 = callmethod(num4407, "..(1)", 1, partcv, params);
// compiled op node returning opresult4408 (depth = 3)
  gc_frame_newslot(opresult4408);
// starting to compile block node (depth = 3)
  Object block4409 = alloc_Block(NULL, NULL, "collectionsPrelude", 1499);
  gc_frame_newslot(block4409);
// method "_apply(_)"
  block_savedest(block4409);
  Object closure4410 = createclosure(2, "_apply(1)");
  setclosureframe(closure4410, stackframe);
  addtoclosure(closure4410, var_unused);
  addtoclosure(closure4410, selfslot);
  struct UserObject *uo4410 = (struct UserObject*)block4409;
  uo4410->data[0] = (Object)closure4410;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4410 = addmethod2pos(block4409, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4410, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4410[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4410->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4410);
  meth_meth_collectionsPrelude__apply_40_1_41_4410->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4410->definitionLine = 1963;
// compiled block node returning block4409 (depth = 3)
  gc_frame_newslot(block4409);
// call case 5: prelude request
  params[0] = opresult4408;
  params[1] = block4409;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4416 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4396);
// compiled call node returning call4416 (depth = 2)
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  sourceObject = obj3103;
  objclass3103 = obj3103->class;
  objclass3103->definitionModule = modulename;
  objclass3103->definitionLine = 1494;
  (*(struct UserObject *)self).data[0] = lowerouter3103;
  self = oldself3103;
  selfslot = oldselfslot3103;
  stackframe = oldstackframe3103;
  gc_frame_end(frame);
  return obj3103;
}
Object meth_collectionsPrelude_dictionary3087(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dictionary");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_binding = getfromclosure(closure, 2);
  Object *var_NoSuchObject = getfromclosure(closure, 3);
  Object *var_enumerable = getfromclosure(closure, 4);
  Object *var_ConcurrentModification = getfromclosure(closure, 5);
  Object *var_IteratorExhausted = getfromclosure(closure, 6);
  Object *var__prelude = getfromclosure(closure, 7);
  Object *var_ComparableToDictionary = getfromclosure(closure, 8);
  Object *var_collection = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_K = &(stackframe->slots[1]);
  Object *var_T = &(stackframe->slots[2]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 2) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_K = args[curarg++];
    *var_T = args[curarg++];
  } else {
    *var_K = Unknown;
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3088 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3088 = alloc_userobj2(4,5, objclass3088);
  gc_frame_newslot(obj3088);
if (objclass3088 == NULL) {
  glfree(obj3088->class->name);
  obj3088->class->name = "dictionary";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3088, self, 0);
  addmethodreal(obj3088,"outer", &reader_collectionsPrelude_outer_3089);
  Object oldself3088 = self;
  struct StackFrameObject *oldstackframe3088 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3088);
  gc_frame_newslot((Object)stackframe);
  self = obj3088;
  Object *oldselfslot3088 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3088 = (*(struct UserObject *)self).data[0], lowerouter3088 = thisouter3088;
  if (inheritingObject3088) {
    struct UserObject *inho3088 = (struct UserObject *)inheritingObject3088;
    while (inho3088->super != GraceDefaultObject) inho3088 = (struct UserObject *)inho3088->super;
    inho3088->super = obj3088;
    self = inheritingObject3088;
    *selfslot = self;
    lowerouter3088 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3088;
  }
// method "asString"
  struct UserObject *uo3090 = (struct UserObject*)obj3088;
  uo3090->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString3090 = addmethod2pos(obj3088, "asString", &meth_collectionsPrelude_asString3090, 1);
  int argcv_meth_collectionsPrelude_asString3090[] = {0};
  meth_meth_collectionsPrelude_asString3090->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString3090);
  meth_meth_collectionsPrelude_asString3090->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString3090->definitionLine = 1486;
// method "withAll(_)"
  struct UserObject *uo3092 = (struct UserObject*)obj3088;
  uo3092->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_withAll_40_1_41_3092 = addmethod2pos(obj3088, "withAll(1)", &meth_collectionsPrelude_withAll_40_1_41_3092, 2);
  int argcv_meth_collectionsPrelude_withAll_40_1_41_3092[] = {1};
  meth_meth_collectionsPrelude_withAll_40_1_41_3092->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll_40_1_41_3092);
  meth_meth_collectionsPrelude_withAll_40_1_41_3092->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll_40_1_41_3092->definitionLine = 1488;
// method "empty"
  block_savedest(obj3088);
  Object closure3102 = createclosure(10, "empty");
  setclosureframe(closure3102, stackframe);
  addtoclosure(closure3102, var_removed);
  addtoclosure(closure3102, var_unused);
  addtoclosure(closure3102, var_binding);
  addtoclosure(closure3102, var_NoSuchObject);
  addtoclosure(closure3102, var_enumerable);
  addtoclosure(closure3102, var_ConcurrentModification);
  addtoclosure(closure3102, var_IteratorExhausted);
  addtoclosure(closure3102, var__prelude);
  addtoclosure(closure3102, var_ComparableToDictionary);
  addtoclosure(closure3102, var_collection);
  struct UserObject *uo3102 = (struct UserObject*)obj3088;
  uo3102->data[3] = (Object)closure3102;
  Method *meth_meth_collectionsPrelude_empty3102 = addmethod2pos(obj3088, "empty", &meth_collectionsPrelude_empty3102, 3);
  int argcv_meth_collectionsPrelude_empty3102[] = {0};
  meth_meth_collectionsPrelude_empty3102->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_empty3102);
  meth_meth_collectionsPrelude_empty3102->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty3102->definitionLine = 1494;
  block_savedest(obj3088);
  Object closure4417 = createclosure(10, "empty$object(1)");
  setclosureframe(closure4417, stackframe);
  addtoclosure(closure4417, var_removed);
  addtoclosure(closure4417, var_unused);
  addtoclosure(closure4417, var_binding);
  addtoclosure(closure4417, var_NoSuchObject);
  addtoclosure(closure4417, var_enumerable);
  addtoclosure(closure4417, var_ConcurrentModification);
  addtoclosure(closure4417, var_IteratorExhausted);
  addtoclosure(closure4417, var__prelude);
  addtoclosure(closure4417, var_ComparableToDictionary);
  addtoclosure(closure4417, var_collection);
  Method *meth_meth_collectionsPrelude_empty3102_object = addmethod2pos(obj3088, "empty$object(1)", &meth_collectionsPrelude_empty3102_object, 3);
  meth_meth_collectionsPrelude_empty3102_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty3102_object->definitionLine = 1494;
  sourceObject = obj3088;
  sourceObject = obj3088;
  sourceObject = obj3088;
  objclass3088 = obj3088->class;
  objclass3088->definitionModule = modulename;
  objclass3088->definitionLine = 1484;
  (*(struct UserObject *)self).data[0] = lowerouter3088;
  self = oldself3088;
  selfslot = oldselfslot3088;
  stackframe = oldstackframe3088;
  gc_frame_end(frame);
  return obj3088;
}
Object meth_collectionsPrelude_dictionary3087_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dictionary$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_binding = getfromclosure(closure, 2);
  Object *var_NoSuchObject = getfromclosure(closure, 3);
  Object *var_enumerable = getfromclosure(closure, 4);
  Object *var_ConcurrentModification = getfromclosure(closure, 5);
  Object *var_IteratorExhausted = getfromclosure(closure, 6);
  Object *var__prelude = getfromclosure(closure, 7);
  Object *var_ComparableToDictionary = getfromclosure(closure, 8);
  Object *var_collection = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_K = &(stackframe->slots[1]);
  Object *var_T = &(stackframe->slots[2]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 2) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_K = args[curarg++];
    *var_T = args[curarg++];
  } else {
    *var_K = Unknown;
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3088 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3088 = alloc_userobj2(4,5, objclass3088);
  gc_frame_newslot(obj3088);
if (objclass3088 == NULL) {
  glfree(obj3088->class->name);
  obj3088->class->name = "dictionary";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3088, self, 0);
  addmethodreal(obj3088,"outer", &reader_collectionsPrelude_outer_3089);
  Object oldself3088 = self;
  struct StackFrameObject *oldstackframe3088 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3088);
  gc_frame_newslot((Object)stackframe);
  self = obj3088;
  Object *oldselfslot3088 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3088 = (*(struct UserObject *)self).data[0], lowerouter3088 = thisouter3088;
  if (inheritingObject3088) {
    struct UserObject *inho3088 = (struct UserObject *)inheritingObject3088;
    while (inho3088->super != GraceDefaultObject) inho3088 = (struct UserObject *)inho3088->super;
    inho3088->super = obj3088;
    self = inheritingObject3088;
    *selfslot = self;
    lowerouter3088 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3088;
  }
// method "asString"
  struct UserObject *uo3090 = (struct UserObject*)obj3088;
  uo3090->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString3090 = addmethod2pos(obj3088, "asString", &meth_collectionsPrelude_asString3090, 1);
  int argcv_meth_collectionsPrelude_asString3090[] = {0};
  meth_meth_collectionsPrelude_asString3090->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString3090);
  meth_meth_collectionsPrelude_asString3090->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString3090->definitionLine = 1486;
// method "withAll(_)"
  struct UserObject *uo3092 = (struct UserObject*)obj3088;
  uo3092->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_withAll_40_1_41_3092 = addmethod2pos(obj3088, "withAll(1)", &meth_collectionsPrelude_withAll_40_1_41_3092, 2);
  int argcv_meth_collectionsPrelude_withAll_40_1_41_3092[] = {1};
  meth_meth_collectionsPrelude_withAll_40_1_41_3092->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll_40_1_41_3092);
  meth_meth_collectionsPrelude_withAll_40_1_41_3092->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll_40_1_41_3092->definitionLine = 1488;
// method "empty"
  block_savedest(obj3088);
  Object closure3102 = createclosure(10, "empty");
  setclosureframe(closure3102, stackframe);
  addtoclosure(closure3102, var_removed);
  addtoclosure(closure3102, var_unused);
  addtoclosure(closure3102, var_binding);
  addtoclosure(closure3102, var_NoSuchObject);
  addtoclosure(closure3102, var_enumerable);
  addtoclosure(closure3102, var_ConcurrentModification);
  addtoclosure(closure3102, var_IteratorExhausted);
  addtoclosure(closure3102, var__prelude);
  addtoclosure(closure3102, var_ComparableToDictionary);
  addtoclosure(closure3102, var_collection);
  struct UserObject *uo3102 = (struct UserObject*)obj3088;
  uo3102->data[3] = (Object)closure3102;
  Method *meth_meth_collectionsPrelude_empty3102 = addmethod2pos(obj3088, "empty", &meth_collectionsPrelude_empty3102, 3);
  int argcv_meth_collectionsPrelude_empty3102[] = {0};
  meth_meth_collectionsPrelude_empty3102->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_empty3102);
  meth_meth_collectionsPrelude_empty3102->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty3102->definitionLine = 1494;
  block_savedest(obj3088);
  Object closure4417 = createclosure(10, "empty$object(1)");
  setclosureframe(closure4417, stackframe);
  addtoclosure(closure4417, var_removed);
  addtoclosure(closure4417, var_unused);
  addtoclosure(closure4417, var_binding);
  addtoclosure(closure4417, var_NoSuchObject);
  addtoclosure(closure4417, var_enumerable);
  addtoclosure(closure4417, var_ConcurrentModification);
  addtoclosure(closure4417, var_IteratorExhausted);
  addtoclosure(closure4417, var__prelude);
  addtoclosure(closure4417, var_ComparableToDictionary);
  addtoclosure(closure4417, var_collection);
  Method *meth_meth_collectionsPrelude_empty3102_object = addmethod2pos(obj3088, "empty$object(1)", &meth_collectionsPrelude_empty3102_object, 3);
  meth_meth_collectionsPrelude_empty3102_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty3102_object->definitionLine = 1494;
  sourceObject = obj3088;
  sourceObject = obj3088;
  sourceObject = obj3088;
  objclass3088 = obj3088->class;
  objclass3088->definitionModule = modulename;
  objclass3088->definitionLine = 1484;
  (*(struct UserObject *)self).data[0] = lowerouter3088;
  self = oldself3088;
  selfslot = oldselfslot3088;
  stackframe = oldstackframe3088;
  gc_frame_end(frame);
  return obj3088;
}
Object meth_collectionsPrelude__apply_40_1_41_4425(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___20 = &(stackframe->slots[0]);
  *var___20 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply_40_1_41_4437(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_upper = getfromclosure(closure, 0);
  Object *var_lower = getfromclosure(closure, 1);
  Object *var_RequestError = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___21 = &(stackframe->slots[0]);
  *var___21 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe4438 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 1854
  setline(1854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4441 == NULL) {
    strlit4441 = alloc_String(") is not an integer");
    gc_root(strlit4441);
  }
// compiled string node returning strlit4441 (depth = 7)
  int op_slot_right_4440 = gc_frame_newslot(strlit4441);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_upper (depth = 8)
  int op_slot_right_4443 = gc_frame_newslot(*var_upper);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4446 == NULL) {
    strlit4446 = alloc_String(")to(");
    gc_root(strlit4446);
  }
// compiled string node returning strlit4446 (depth = 9)
  int op_slot_right_4445 = gc_frame_newslot(strlit4446);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lower (depth = 10)
  int op_slot_right_4448 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 10)
  if (strlit4450 == NULL) {
    strlit4450 = alloc_String(" in range.from(");
    gc_root(strlit4450);
  }
// compiled string node returning strlit4450 (depth = 10)
  int op_slot_left_4448 = gc_frame_newslot(strlit4450);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4451 = callmethod(strlit4450, "++(1)", 1, partcv, params);
// compiled op node returning opresult4451 (depth = 9)
  int op_slot_left_4445 = gc_frame_newslot(opresult4451);
  params[0] = strlit4446;
  partcv[0] = 1;
  Object opresult4452 = callmethod(opresult4451, "++(1)", 1, partcv, params);
// compiled op node returning opresult4452 (depth = 8)
  int op_slot_left_4443 = gc_frame_newslot(opresult4452);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4453 = callmethod(opresult4452, "++(1)", 1, partcv, params);
// compiled op node returning opresult4453 (depth = 7)
  int op_slot_left_4440 = gc_frame_newslot(opresult4453);
  params[0] = strlit4441;
  partcv[0] = 1;
  Object opresult4454 = callmethod(opresult4453, "++(1)", 1, partcv, params);
// compiled op node returning opresult4454 (depth = 6)
  int op_slot_right_4439 = gc_frame_newslot(opresult4454);
// Begin line 1853
  setline(1853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4457 == NULL) {
    strlit4457 = alloc_String("");
    gc_root(strlit4457);
  }
// compiled string node returning strlit4457 (depth = 7)
  int op_slot_right_4456 = gc_frame_newslot(strlit4457);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lower (depth = 8)
  int op_slot_right_4459 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 8)
  if (strlit4461 == NULL) {
    strlit4461 = alloc_String("lower bound ");
    gc_root(strlit4461);
  }
// compiled string node returning strlit4461 (depth = 8)
  int op_slot_left_4459 = gc_frame_newslot(strlit4461);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4462 = callmethod(strlit4461, "++(1)", 1, partcv, params);
// compiled op node returning opresult4462 (depth = 7)
  int op_slot_left_4456 = gc_frame_newslot(opresult4462);
  params[0] = strlit4457;
  partcv[0] = 1;
  Object opresult4463 = callmethod(opresult4462, "++(1)", 1, partcv, params);
// compiled op node returning opresult4463 (depth = 6)
  int op_slot_left_4439 = gc_frame_newslot(opresult4463);
  params[0] = opresult4454;
  partcv[0] = 1;
  Object opresult4464 = callmethod(opresult4463, "++(1)", 1, partcv, params);
// compiled op node returning opresult4464 (depth = 5)
  gc_frame_newslot(opresult4464);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_RequestError (depth = 5)
  params[0] = opresult4464;
  partcv[0] = 1;
  Object call4465 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4438);
// compiled call node returning call4465 (depth = 4)
  gc_frame_end(frame);
  return call4465;
}
Object meth_collectionsPrelude__apply_40_1_41_4503(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___22 = &(stackframe->slots[0]);
  *var___22 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply_40_1_41_4515(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_upper = getfromclosure(closure, 0);
  Object *var_lower = getfromclosure(closure, 1);
  Object *var_RequestError = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___23 = &(stackframe->slots[0]);
  *var___23 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe4516 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 1863
  setline(1863);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4519 == NULL) {
    strlit4519 = alloc_String(") is not an integer");
    gc_root(strlit4519);
  }
// compiled string node returning strlit4519 (depth = 7)
  int op_slot_right_4518 = gc_frame_newslot(strlit4519);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_upper (depth = 8)
  int op_slot_right_4521 = gc_frame_newslot(*var_upper);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4524 == NULL) {
    strlit4524 = alloc_String(")to(");
    gc_root(strlit4524);
  }
// compiled string node returning strlit4524 (depth = 9)
  int op_slot_right_4523 = gc_frame_newslot(strlit4524);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lower (depth = 10)
  int op_slot_right_4526 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 10)
  if (strlit4528 == NULL) {
    strlit4528 = alloc_String(" in range.from(");
    gc_root(strlit4528);
  }
// compiled string node returning strlit4528 (depth = 10)
  int op_slot_left_4526 = gc_frame_newslot(strlit4528);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4529 = callmethod(strlit4528, "++(1)", 1, partcv, params);
// compiled op node returning opresult4529 (depth = 9)
  int op_slot_left_4523 = gc_frame_newslot(opresult4529);
  params[0] = strlit4524;
  partcv[0] = 1;
  Object opresult4530 = callmethod(opresult4529, "++(1)", 1, partcv, params);
// compiled op node returning opresult4530 (depth = 8)
  int op_slot_left_4521 = gc_frame_newslot(opresult4530);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4531 = callmethod(opresult4530, "++(1)", 1, partcv, params);
// compiled op node returning opresult4531 (depth = 7)
  int op_slot_left_4518 = gc_frame_newslot(opresult4531);
  params[0] = strlit4519;
  partcv[0] = 1;
  Object opresult4532 = callmethod(opresult4531, "++(1)", 1, partcv, params);
// compiled op node returning opresult4532 (depth = 6)
  int op_slot_right_4517 = gc_frame_newslot(opresult4532);
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4535 == NULL) {
    strlit4535 = alloc_String("");
    gc_root(strlit4535);
  }
// compiled string node returning strlit4535 (depth = 7)
  int op_slot_right_4534 = gc_frame_newslot(strlit4535);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_upper (depth = 8)
  int op_slot_right_4537 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 8)
  if (strlit4539 == NULL) {
    strlit4539 = alloc_String("upper bound ");
    gc_root(strlit4539);
  }
// compiled string node returning strlit4539 (depth = 8)
  int op_slot_left_4537 = gc_frame_newslot(strlit4539);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4540 = callmethod(strlit4539, "++(1)", 1, partcv, params);
// compiled op node returning opresult4540 (depth = 7)
  int op_slot_left_4534 = gc_frame_newslot(opresult4540);
  params[0] = strlit4535;
  partcv[0] = 1;
  Object opresult4541 = callmethod(opresult4540, "++(1)", 1, partcv, params);
// compiled op node returning opresult4541 (depth = 6)
  int op_slot_left_4517 = gc_frame_newslot(opresult4541);
  params[0] = opresult4532;
  partcv[0] = 1;
  Object opresult4542 = callmethod(opresult4541, "++(1)", 1, partcv, params);
// compiled op node returning opresult4542 (depth = 5)
  gc_frame_newslot(opresult4542);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_RequestError (depth = 5)
  params[0] = opresult4542;
  partcv[0] = 1;
  Object call4543 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4516);
// compiled call node returning call4543 (depth = 4)
  gc_frame_end(frame);
  return call4543;
}
Object meth_collectionsPrelude_from_40_1_41_to_40_1_41_4422(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "from(1)to(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method from(_)to(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method from(_)to(_)");
  Object params[2];
  int partcv[2];
  Object *var_Number = getfromclosure(closure, 0);
  Object *var_RequestError = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for from(_)to(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_lower = &(stackframe->slots[0]);
  *var_lower = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *var_upper = &(stackframe->slots[1]);
  *var_upper = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part to(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_start = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "start");
  Object *var_stop = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "stop");
// Begin line 1851
  setline(1851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  int frame4423 = gc_frame_new();
  gc_frame_newslot(*var_lower);
// Begin line 1852
  setline(1852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4424 = alloc_Block(NULL, NULL, "collectionsPrelude", 1852);
  gc_frame_newslot(block4424);
// method "_apply(_)"
  block_savedest(block4424);
  Object closure4425 = createclosure(1, "_apply(1)");
  setclosureframe(closure4425, stackframe);
  addtoclosure(closure4425, selfslot);
  struct UserObject *uo4425 = (struct UserObject*)block4424;
  uo4425->data[0] = (Object)closure4425;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4425 = addmethod2pos(block4424, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4425, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4425[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4425->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4425);
meth_meth_collectionsPrelude__apply_40_1_41_4425->type->types[0] = type_Number;
meth_meth_collectionsPrelude__apply_40_1_41_4425->type->names[0] = "__20";
  meth_meth_collectionsPrelude__apply_40_1_41_4425->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4425->definitionLine = 1963;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4427 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe4428 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4429 == NULL) {
    strlit4429 = alloc_String("__20");
    gc_root(strlit4429);
  }
// compiled string node returning strlit4429 (depth = 6)
  gc_frame_newslot(strlit4429);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4430 = gc_frame_new();
// call case 5: prelude request
  Object call4431 = callmethodflags(prelude, "VariablePattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4430);
// compiled member node returning call4431 (depth = 6)
  params[0] = strlit4429;
  partcv[0] = 1;
  Object call4432 = callmethodflags(call4431, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4428);
// compiled call node returning call4432 (depth = 5)
  gc_frame_newslot(call4432);
// Begin line 1852
  setline(1852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4433 = gc_frame_new();
// call case 5: prelude request
  Object call4434 = callmethodflags(prelude, "AndPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4433);
// compiled member node returning call4434 (depth = 5)
  params[0] = call4432;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call4435 = callmethodflags(call4434, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4427);
// compiled call node returning call4435 (depth = 4)
((struct UserObject *)block4424)->data[1] = call4435;
// compiled block node returning block4424 (depth = 3)
  gc_frame_newslot(block4424);
// Begin line 1853
  setline(1853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4436 = alloc_Block(NULL, NULL, "collectionsPrelude", 1853);
  gc_frame_newslot(block4436);
// method "_apply(_)"
  block_savedest(block4436);
  Object closure4437 = createclosure(4, "_apply(1)");
  setclosureframe(closure4437, stackframe);
  addtoclosure(closure4437, var_upper);
  addtoclosure(closure4437, var_lower);
  addtoclosure(closure4437, var_RequestError);
  addtoclosure(closure4437, selfslot);
  struct UserObject *uo4437 = (struct UserObject*)block4436;
  uo4437->data[0] = (Object)closure4437;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4437 = addmethod2pos(block4436, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4437, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4437[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4437->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4437);
  meth_meth_collectionsPrelude__apply_40_1_41_4437->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4437->definitionLine = 1963;
// compiled block node returning block4436 (depth = 3)
  gc_frame_newslot(block4436);
  params[0] = block4424;
  params[1] = block4436;
  Object matchres4423 = matchCase(*var_lower, params, 2,NULL);
  gc_frame_end(frame4423);
// compiled matchcase node returning matchres4423 (depth = 2)
// Begin line 1855
  setline(1855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4467 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  Object call4468 = callmethodflags(*var_lower, "truncated", 0, partcv, params, 0);
  gc_frame_end(callframe4467);
// compiled member node returning call4468 (depth = 3)
  *var_start = call4468;
  if (call4468 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1856
  setline(1856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  int op_slot_right_4470 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_start (depth = 4)
  int op_slot_left_4470 = gc_frame_newslot(*var_start);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4472 = callmethod(*var_start, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4472 (depth = 3)
  Object if4469 = done;
  if (istrue(opresult4472)) {
// Begin line 1857
  setline(1857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4473 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1858
  setline(1858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4476 == NULL) {
    strlit4476 = alloc_String(") is not an integer");
    gc_root(strlit4476);
  }
// compiled string node returning strlit4476 (depth = 6)
  int op_slot_right_4475 = gc_frame_newslot(strlit4476);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_upper (depth = 7)
  int op_slot_right_4478 = gc_frame_newslot(*var_upper);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4481 == NULL) {
    strlit4481 = alloc_String(")to(");
    gc_root(strlit4481);
  }
// compiled string node returning strlit4481 (depth = 8)
  int op_slot_right_4480 = gc_frame_newslot(strlit4481);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lower (depth = 9)
  int op_slot_right_4483 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 9)
  if (strlit4485 == NULL) {
    strlit4485 = alloc_String(" in range.from(");
    gc_root(strlit4485);
  }
// compiled string node returning strlit4485 (depth = 9)
  int op_slot_left_4483 = gc_frame_newslot(strlit4485);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4486 = callmethod(strlit4485, "++(1)", 1, partcv, params);
// compiled op node returning opresult4486 (depth = 8)
  int op_slot_left_4480 = gc_frame_newslot(opresult4486);
  params[0] = strlit4481;
  partcv[0] = 1;
  Object opresult4487 = callmethod(opresult4486, "++(1)", 1, partcv, params);
// compiled op node returning opresult4487 (depth = 7)
  int op_slot_left_4478 = gc_frame_newslot(opresult4487);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4488 = callmethod(opresult4487, "++(1)", 1, partcv, params);
// compiled op node returning opresult4488 (depth = 6)
  int op_slot_left_4475 = gc_frame_newslot(opresult4488);
  params[0] = strlit4476;
  partcv[0] = 1;
  Object opresult4489 = callmethod(opresult4488, "++(1)", 1, partcv, params);
// compiled op node returning opresult4489 (depth = 5)
  int op_slot_right_4474 = gc_frame_newslot(opresult4489);
// Begin line 1857
  setline(1857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4492 == NULL) {
    strlit4492 = alloc_String("");
    gc_root(strlit4492);
  }
// compiled string node returning strlit4492 (depth = 6)
  int op_slot_right_4491 = gc_frame_newslot(strlit4492);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_4494 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 7)
  if (strlit4496 == NULL) {
    strlit4496 = alloc_String("lower bound ");
    gc_root(strlit4496);
  }
// compiled string node returning strlit4496 (depth = 7)
  int op_slot_left_4494 = gc_frame_newslot(strlit4496);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4497 = callmethod(strlit4496, "++(1)", 1, partcv, params);
// compiled op node returning opresult4497 (depth = 6)
  int op_slot_left_4491 = gc_frame_newslot(opresult4497);
  params[0] = strlit4492;
  partcv[0] = 1;
  Object opresult4498 = callmethod(opresult4497, "++(1)", 1, partcv, params);
// compiled op node returning opresult4498 (depth = 5)
  int op_slot_left_4474 = gc_frame_newslot(opresult4498);
  params[0] = opresult4489;
  partcv[0] = 1;
  Object opresult4499 = callmethod(opresult4498, "++(1)", 1, partcv, params);
// compiled op node returning opresult4499 (depth = 4)
  gc_frame_newslot(opresult4499);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_RequestError (depth = 4)
  params[0] = opresult4499;
  partcv[0] = 1;
  Object call4500 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4473);
// compiled call node returning call4500 (depth = 3)
    gc_frame_newslot(call4500);
    if4469 = call4500;
  } else {
  }
// compiled if node returning if4469 (depth = 2)
// Begin line 1860
  setline(1860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  int frame4501 = gc_frame_new();
  gc_frame_newslot(*var_upper);
// Begin line 1861
  setline(1861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4502 = alloc_Block(NULL, NULL, "collectionsPrelude", 1861);
  gc_frame_newslot(block4502);
// method "_apply(_)"
  block_savedest(block4502);
  Object closure4503 = createclosure(1, "_apply(1)");
  setclosureframe(closure4503, stackframe);
  addtoclosure(closure4503, selfslot);
  struct UserObject *uo4503 = (struct UserObject*)block4502;
  uo4503->data[0] = (Object)closure4503;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4503 = addmethod2pos(block4502, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4503, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4503[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4503->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4503);
meth_meth_collectionsPrelude__apply_40_1_41_4503->type->types[0] = type_Number;
meth_meth_collectionsPrelude__apply_40_1_41_4503->type->names[0] = "__22";
  meth_meth_collectionsPrelude__apply_40_1_41_4503->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4503->definitionLine = 1963;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4505 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe4506 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4507 == NULL) {
    strlit4507 = alloc_String("__22");
    gc_root(strlit4507);
  }
// compiled string node returning strlit4507 (depth = 6)
  gc_frame_newslot(strlit4507);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4508 = gc_frame_new();
// call case 5: prelude request
  Object call4509 = callmethodflags(prelude, "VariablePattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4508);
// compiled member node returning call4509 (depth = 6)
  params[0] = strlit4507;
  partcv[0] = 1;
  Object call4510 = callmethodflags(call4509, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4506);
// compiled call node returning call4510 (depth = 5)
  gc_frame_newslot(call4510);
// Begin line 1861
  setline(1861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4511 = gc_frame_new();
// call case 5: prelude request
  Object call4512 = callmethodflags(prelude, "AndPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4511);
// compiled member node returning call4512 (depth = 5)
  params[0] = call4510;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call4513 = callmethodflags(call4512, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4505);
// compiled call node returning call4513 (depth = 4)
((struct UserObject *)block4502)->data[1] = call4513;
// compiled block node returning block4502 (depth = 3)
  gc_frame_newslot(block4502);
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4514 = alloc_Block(NULL, NULL, "collectionsPrelude", 1862);
  gc_frame_newslot(block4514);
// method "_apply(_)"
  block_savedest(block4514);
  Object closure4515 = createclosure(4, "_apply(1)");
  setclosureframe(closure4515, stackframe);
  addtoclosure(closure4515, var_upper);
  addtoclosure(closure4515, var_lower);
  addtoclosure(closure4515, var_RequestError);
  addtoclosure(closure4515, selfslot);
  struct UserObject *uo4515 = (struct UserObject*)block4514;
  uo4515->data[0] = (Object)closure4515;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4515 = addmethod2pos(block4514, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4515, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4515[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4515->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4515);
  meth_meth_collectionsPrelude__apply_40_1_41_4515->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4515->definitionLine = 1963;
// compiled block node returning block4514 (depth = 3)
  gc_frame_newslot(block4514);
  params[0] = block4502;
  params[1] = block4514;
  Object matchres4501 = matchCase(*var_upper, params, 2,NULL);
  gc_frame_end(frame4501);
// compiled matchcase node returning matchres4501 (depth = 2)
// Begin line 1864
  setline(1864);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4545 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  Object call4546 = callmethodflags(*var_upper, "truncated", 0, partcv, params, 0);
  gc_frame_end(callframe4545);
// compiled member node returning call4546 (depth = 3)
  *var_stop = call4546;
  if (call4546 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 2)
// Begin line 1865
  setline(1865);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  int op_slot_right_4548 = gc_frame_newslot(*var_upper);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_stop (depth = 4)
  int op_slot_left_4548 = gc_frame_newslot(*var_stop);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4550 = callmethod(*var_stop, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4550 (depth = 3)
  Object if4547 = done;
  if (istrue(opresult4550)) {
// Begin line 1866
  setline(1866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4551 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1867
  setline(1867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit4553 == NULL) {
    strlit4553 = alloc_String(" in range.from()to() is not an integer");
    gc_root(strlit4553);
  }
// compiled string node returning strlit4553 (depth = 5)
  int op_slot_right_4552 = gc_frame_newslot(strlit4553);
// Begin line 1866
  setline(1866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4556 == NULL) {
    strlit4556 = alloc_String("");
    gc_root(strlit4556);
  }
// compiled string node returning strlit4556 (depth = 6)
  int op_slot_right_4555 = gc_frame_newslot(strlit4556);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_upper (depth = 7)
  int op_slot_right_4558 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 7)
  if (strlit4560 == NULL) {
    strlit4560 = alloc_String("upper bound ");
    gc_root(strlit4560);
  }
// compiled string node returning strlit4560 (depth = 7)
  int op_slot_left_4558 = gc_frame_newslot(strlit4560);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4561 = callmethod(strlit4560, "++(1)", 1, partcv, params);
// compiled op node returning opresult4561 (depth = 6)
  int op_slot_left_4555 = gc_frame_newslot(opresult4561);
  params[0] = strlit4556;
  partcv[0] = 1;
  Object opresult4562 = callmethod(opresult4561, "++(1)", 1, partcv, params);
// compiled op node returning opresult4562 (depth = 5)
  int op_slot_left_4552 = gc_frame_newslot(opresult4562);
  params[0] = strlit4553;
  partcv[0] = 1;
  Object opresult4563 = callmethod(opresult4562, "++(1)", 1, partcv, params);
// compiled op node returning opresult4563 (depth = 4)
  gc_frame_newslot(opresult4563);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_RequestError (depth = 4)
  params[0] = opresult4563;
  partcv[0] = 1;
  Object call4564 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4551);
// compiled call node returning call4564 (depth = 3)
    gc_frame_newslot(call4564);
    if4547 = call4564;
  } else {
  }
// compiled if node returning if4547 (depth = 2)
// Begin line 1870
  setline(1870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4565 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  gc_frame_newslot(*var_upper);
// call case 4: self request
  params[0] = *var_lower;
  params[1] = *var_upper;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4566 = callmethodflags(self, "uncheckedFrom(1)to(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4565);
// compiled call node returning call4566 (depth = 2)
  gc_frame_end(frame);
  return call4566;
}
Object meth_collectionsPrelude_hasNext4578(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1886
  setline(1886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4580 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4581 = gc_frame_new();
// call case 3: self.outer request
  Object call4582 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4581);
// compiled member node returning call4582 (depth = 4)
  Object call4583 = callmethodflags(call4582, "stop", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4580);
// compiled member node returning call4583 (depth = 3)
  int op_slot_right_4579 = gc_frame_newslot(call4583);
// starting to compile member node (depth = 3)
  int callframe4585 = gc_frame_new();
// call case 4: self request
  Object call4586 = callmethodflags(self, "val", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4585);
// compiled member node returning call4586 (depth = 3)
  int op_slot_left_4579 = gc_frame_newslot(call4586);
  params[0] = call4583;
  partcv[0] = 1;
  Object opresult4587 = callmethod(call4586, "≤(1)", 1, partcv, params);
// compiled op node returning opresult4587 (depth = 2)
  gc_frame_end(frame);
  return opresult4587;
}
Object meth_collectionsPrelude_next4588(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1888
  setline(1888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4591 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4592 = gc_frame_new();
// call case 3: self.outer request
  Object call4593 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4592);
// compiled member node returning call4593 (depth = 5)
  Object call4594 = callmethodflags(call4593, "stop", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4591);
// compiled member node returning call4594 (depth = 4)
  int op_slot_right_4590 = gc_frame_newslot(call4594);
// starting to compile member node (depth = 4)
  int callframe4596 = gc_frame_new();
// call case 4: self request
  Object call4597 = callmethodflags(self, "val", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4596);
// compiled member node returning call4597 (depth = 4)
  int op_slot_left_4590 = gc_frame_newslot(call4597);
  params[0] = call4594;
  partcv[0] = 1;
  Object opresult4598 = callmethod(call4597, ">(1)", 1, partcv, params);
// compiled op node returning opresult4598 (depth = 3)
  Object if4589 = done;
  if (istrue(opresult4598)) {
// Begin line 1889
  setline(1889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4599 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4601 == NULL) {
    strlit4601 = alloc_String("");
    gc_root(strlit4601);
  }
// compiled string node returning strlit4601 (depth = 5)
  int op_slot_right_4600 = gc_frame_newslot(strlit4601);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4604 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4605 = gc_frame_new();
// call case 3: self.outer request
  Object call4606 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4605);
// compiled member node returning call4606 (depth = 7)
  Object call4607 = callmethodflags(call4606, "asString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4604);
// compiled member node returning call4607 (depth = 6)
  int op_slot_right_4603 = gc_frame_newslot(call4607);
// starting to compile string node (depth = 6)
  if (strlit4609 == NULL) {
    strlit4609 = alloc_String("over ");
    gc_root(strlit4609);
  }
// compiled string node returning strlit4609 (depth = 6)
  int op_slot_left_4603 = gc_frame_newslot(strlit4609);
  params[0] = call4607;
  partcv[0] = 1;
  Object opresult4610 = callmethod(strlit4609, "++(1)", 1, partcv, params);
// compiled op node returning opresult4610 (depth = 5)
  int op_slot_left_4600 = gc_frame_newslot(opresult4610);
  params[0] = strlit4601;
  partcv[0] = 1;
  Object opresult4611 = callmethod(opresult4610, "++(1)", 1, partcv, params);
// compiled op node returning opresult4611 (depth = 4)
  gc_frame_newslot(opresult4611);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_IteratorExhausted (depth = 4)
  params[0] = opresult4611;
  partcv[0] = 1;
  Object call4612 = callmethodflags(*var_IteratorExhausted, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4599);
// compiled call node returning call4612 (depth = 3)
    gc_frame_newslot(call4612);
    if4589 = call4612;
  } else {
  }
// compiled if node returning if4589 (depth = 2)
// Begin line 1891
  setline(1891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4613 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4615 = alloc_Float64(1);
// compiled num node returning num4615 (depth = 4)
  int op_slot_right_4614 = gc_frame_newslot(num4615);
// starting to compile member node (depth = 4)
  int callframe4617 = gc_frame_new();
// call case 4: self request
  Object call4618 = callmethodflags(self, "val", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4617);
// compiled member node returning call4618 (depth = 4)
  int op_slot_left_4614 = gc_frame_newslot(call4618);
  params[0] = num4615;
  partcv[0] = 1;
  Object sum4619 = callmethod(call4618, "+(1)", 1, partcv, params);
// compiled op node returning sum4619 (depth = 3)
  gc_frame_newslot(sum4619);
// call case 4: self request
  params[0] = sum4619;
  partcv[0] = 1;
  Object call4620 = callmethodflags(self, "val:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4613);
// compiled call node returning call4620 (depth = 2)
// Begin line 1892
  setline(1892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4622 = alloc_Float64(1);
// compiled num node returning num4622 (depth = 4)
  int op_slot_right_4621 = gc_frame_newslot(num4622);
// starting to compile member node (depth = 4)
  int callframe4624 = gc_frame_new();
// call case 4: self request
  Object call4625 = callmethodflags(self, "val", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4624);
// compiled member node returning call4625 (depth = 4)
  int op_slot_left_4621 = gc_frame_newslot(call4625);
  params[0] = num4622;
  partcv[0] = 1;
  Object diff4626 = callmethod(call4625, "-(1)", 1, partcv, params);
// compiled op node returning diff4626 (depth = 3)
  return diff4626;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_asString4627(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lower = getfromclosure(closure, 0);
  Object *var_upper = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit4629 == NULL) {
    strlit4629 = alloc_String("");
    gc_root(strlit4629);
  }
// compiled string node returning strlit4629 (depth = 3)
  int op_slot_right_4628 = gc_frame_newslot(strlit4629);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  int op_slot_right_4631 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4634 == NULL) {
    strlit4634 = alloc_String(" to ");
    gc_root(strlit4634);
  }
// compiled string node returning strlit4634 (depth = 5)
  int op_slot_right_4633 = gc_frame_newslot(strlit4634);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_right_4636 = gc_frame_newslot(*var_upper);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4639 == NULL) {
    strlit4639 = alloc_String(" from ");
    gc_root(strlit4639);
  }
// compiled string node returning strlit4639 (depth = 7)
  int op_slot_right_4638 = gc_frame_newslot(strlit4639);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
  int callframe4642 = gc_frame_new();
// call case 1: super request
  Object call4643 = callmethod4(self, "asString", 0, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe4642);
// compiled member node returning call4643 (depth = 8)
  int op_slot_right_4641 = gc_frame_newslot(call4643);
// starting to compile string node (depth = 8)
  if (strlit4645 == NULL) {
    strlit4645 = alloc_String("");
    gc_root(strlit4645);
  }
// compiled string node returning strlit4645 (depth = 8)
  int op_slot_left_4641 = gc_frame_newslot(strlit4645);
  params[0] = call4643;
  partcv[0] = 1;
  Object opresult4646 = callmethod(strlit4645, "++(1)", 1, partcv, params);
// compiled op node returning opresult4646 (depth = 7)
  int op_slot_left_4638 = gc_frame_newslot(opresult4646);
  params[0] = strlit4639;
  partcv[0] = 1;
  Object opresult4647 = callmethod(opresult4646, "++(1)", 1, partcv, params);
// compiled op node returning opresult4647 (depth = 6)
  int op_slot_left_4636 = gc_frame_newslot(opresult4647);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4648 = callmethod(opresult4647, "++(1)", 1, partcv, params);
// compiled op node returning opresult4648 (depth = 5)
  int op_slot_left_4633 = gc_frame_newslot(opresult4648);
  params[0] = strlit4634;
  partcv[0] = 1;
  Object opresult4649 = callmethod(opresult4648, "++(1)", 1, partcv, params);
// compiled op node returning opresult4649 (depth = 4)
  int op_slot_left_4631 = gc_frame_newslot(opresult4649);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4650 = callmethod(opresult4649, "++(1)", 1, partcv, params);
// compiled op node returning opresult4650 (depth = 3)
  int op_slot_left_4628 = gc_frame_newslot(opresult4650);
  params[0] = strlit4629;
  partcv[0] = 1;
  Object opresult4651 = callmethod(opresult4650, "++(1)", 1, partcv, params);
// compiled op node returning opresult4651 (depth = 2)
  gc_frame_end(frame);
  return opresult4651;
}
Object meth_collectionsPrelude_iterator4574(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  Object *var_lower = getfromclosure(closure, 1);
  Object *var_upper = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4575 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4575 = alloc_userobj2(5,5, objclass4575);
  gc_frame_newslot(obj4575);
if (objclass4575 == NULL) {
  glfree(obj4575->class->name);
  obj4575->class->name = "range.object.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4575, self, 0);
  addmethodreal(obj4575,"outer", &reader_collectionsPrelude_outer_4576);
  Object oldself4575 = self;
  struct StackFrameObject *oldstackframe4575 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4575);
  gc_frame_newslot((Object)stackframe);
  self = obj4575;
  Object *oldselfslot4575 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4575 = (*(struct UserObject *)self).data[0], lowerouter4575 = thisouter4575;
  if (inheritingObject4575) {
    struct UserObject *inho4575 = (struct UserObject *)inheritingObject4575;
    while (inho4575->super != GraceDefaultObject) inho4575 = (struct UserObject *)inho4575->super;
    inho4575->super = obj4575;
    self = inheritingObject4575;
    *selfslot = self;
    lowerouter4575 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4575;
  }
if (objclass4575 == NULL) {
  Method *reader4577 = addmethodrealflags(obj4575, "val", &reader_collectionsPrelude_val_4577, MFLAG_CONFIDENTIAL);
  Method *writer4577 = addmethodrealflags(obj4575, "val:=(1)", &writer_collectionsPrelude_val_4577, MFLAG_CONFIDENTIAL);
  reader4577->definitionModule = modulename;
  writer4577->definitionModule = modulename;
  reader4577->definitionLine = 1885;
  writer4577->definitionLine = 1885;
}
obj4575->flags |= OFLAG_MUTABLE;
adddatum2(obj4575, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo4578 = (struct UserObject*)obj4575;
  uo4578->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext4578 = addmethod2pos(obj4575, "hasNext", &meth_collectionsPrelude_hasNext4578, 2);
  int argcv_meth_collectionsPrelude_hasNext4578[] = {0};
  meth_meth_collectionsPrelude_hasNext4578->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext4578);
  meth_meth_collectionsPrelude_hasNext4578->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext4578->definitionLine = 1886;
// method "next"
  block_savedest(obj4575);
  Object closure4588 = createclosure(1, "next");
  setclosureframe(closure4588, stackframe);
  addtoclosure(closure4588, var_IteratorExhausted);
  struct UserObject *uo4588 = (struct UserObject*)obj4575;
  uo4588->data[3] = (Object)closure4588;
  Method *meth_meth_collectionsPrelude_next4588 = addmethod2pos(obj4575, "next", &meth_collectionsPrelude_next4588, 3);
  int argcv_meth_collectionsPrelude_next4588[] = {0};
  meth_meth_collectionsPrelude_next4588->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next4588);
  meth_meth_collectionsPrelude_next4588->definitionModule = modulename;
  meth_meth_collectionsPrelude_next4588->definitionLine = 1887;
// method "asString"
  block_savedest(obj4575);
  Object closure4627 = createclosure(2, "asString");
  setclosureframe(closure4627, stackframe);
  addtoclosure(closure4627, var_lower);
  addtoclosure(closure4627, var_upper);
  struct UserObject *uo4627 = (struct UserObject*)obj4575;
  uo4627->data[4] = (Object)closure4627;
  Method *meth_meth_collectionsPrelude_asString4627 = addmethod2pos(obj4575, "asString", &meth_collectionsPrelude_asString4627, 4);
  int argcv_meth_collectionsPrelude_asString4627[] = {0};
  meth_meth_collectionsPrelude_asString4627->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString4627);
  meth_meth_collectionsPrelude_asString4627->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString4627->definitionLine = 1894;
  sourceObject = obj4575;
// Begin line 1885
  setline(1885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4652 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4653 = gc_frame_new();
// call case 3: self.outer request
  Object call4654 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4653);
// compiled member node returning call4654 (depth = 3)
  Object call4655 = callmethodflags(call4654, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4652);
// compiled member node returning call4655 (depth = 2)
  adddatum2(obj4575, call4655, 1);
  sourceObject = obj4575;
  sourceObject = obj4575;
  sourceObject = obj4575;
  objclass4575 = obj4575->class;
  objclass4575->definitionModule = modulename;
  objclass4575->definitionLine = 1884;
  (*(struct UserObject *)self).data[0] = lowerouter4575;
  self = oldself4575;
  selfslot = oldselfslot4575;
  stackframe = oldstackframe4575;
  gc_frame_end(frame);
  return obj4575;
}
Object meth_collectionsPrelude_iterator4574_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  Object *var_lower = getfromclosure(closure, 1);
  Object *var_upper = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4575 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4575 = alloc_userobj2(5,5, objclass4575);
  gc_frame_newslot(obj4575);
if (objclass4575 == NULL) {
  glfree(obj4575->class->name);
  obj4575->class->name = "range.object.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4575, self, 0);
  addmethodreal(obj4575,"outer", &reader_collectionsPrelude_outer_4576);
  Object oldself4575 = self;
  struct StackFrameObject *oldstackframe4575 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4575);
  gc_frame_newslot((Object)stackframe);
  self = obj4575;
  Object *oldselfslot4575 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4575 = (*(struct UserObject *)self).data[0], lowerouter4575 = thisouter4575;
  if (inheritingObject4575) {
    struct UserObject *inho4575 = (struct UserObject *)inheritingObject4575;
    while (inho4575->super != GraceDefaultObject) inho4575 = (struct UserObject *)inho4575->super;
    inho4575->super = obj4575;
    self = inheritingObject4575;
    *selfslot = self;
    lowerouter4575 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4575;
  }
if (objclass4575 == NULL) {
  Method *reader4577 = addmethodrealflags(obj4575, "val", &reader_collectionsPrelude_val_4577, MFLAG_CONFIDENTIAL);
  Method *writer4577 = addmethodrealflags(obj4575, "val:=(1)", &writer_collectionsPrelude_val_4577, MFLAG_CONFIDENTIAL);
  reader4577->definitionModule = modulename;
  writer4577->definitionModule = modulename;
  reader4577->definitionLine = 1885;
  writer4577->definitionLine = 1885;
}
obj4575->flags |= OFLAG_MUTABLE;
adddatum2(obj4575, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo4578 = (struct UserObject*)obj4575;
  uo4578->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext4578 = addmethod2pos(obj4575, "hasNext", &meth_collectionsPrelude_hasNext4578, 2);
  int argcv_meth_collectionsPrelude_hasNext4578[] = {0};
  meth_meth_collectionsPrelude_hasNext4578->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext4578);
  meth_meth_collectionsPrelude_hasNext4578->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext4578->definitionLine = 1886;
// method "next"
  block_savedest(obj4575);
  Object closure4588 = createclosure(1, "next");
  setclosureframe(closure4588, stackframe);
  addtoclosure(closure4588, var_IteratorExhausted);
  struct UserObject *uo4588 = (struct UserObject*)obj4575;
  uo4588->data[3] = (Object)closure4588;
  Method *meth_meth_collectionsPrelude_next4588 = addmethod2pos(obj4575, "next", &meth_collectionsPrelude_next4588, 3);
  int argcv_meth_collectionsPrelude_next4588[] = {0};
  meth_meth_collectionsPrelude_next4588->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next4588);
  meth_meth_collectionsPrelude_next4588->definitionModule = modulename;
  meth_meth_collectionsPrelude_next4588->definitionLine = 1887;
// method "asString"
  block_savedest(obj4575);
  Object closure4627 = createclosure(2, "asString");
  setclosureframe(closure4627, stackframe);
  addtoclosure(closure4627, var_lower);
  addtoclosure(closure4627, var_upper);
  struct UserObject *uo4627 = (struct UserObject*)obj4575;
  uo4627->data[4] = (Object)closure4627;
  Method *meth_meth_collectionsPrelude_asString4627 = addmethod2pos(obj4575, "asString", &meth_collectionsPrelude_asString4627, 4);
  int argcv_meth_collectionsPrelude_asString4627[] = {0};
  meth_meth_collectionsPrelude_asString4627->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString4627);
  meth_meth_collectionsPrelude_asString4627->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString4627->definitionLine = 1894;
  sourceObject = obj4575;
// Begin line 1885
  setline(1885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4652 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4653 = gc_frame_new();
// call case 3: self.outer request
  Object call4654 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4653);
// compiled member node returning call4654 (depth = 3)
  Object call4655 = callmethodflags(call4654, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4652);
// compiled member node returning call4655 (depth = 2)
  adddatum2(obj4575, call4655, 1);
  sourceObject = obj4575;
  sourceObject = obj4575;
  sourceObject = obj4575;
  objclass4575 = obj4575->class;
  objclass4575->definitionModule = modulename;
  objclass4575->definitionLine = 1884;
  (*(struct UserObject *)self).data[0] = lowerouter4575;
  self = oldself4575;
  selfslot = oldselfslot4575;
  stackframe = oldstackframe4575;
  gc_frame_end(frame);
  return obj4575;
}
Object meth_collectionsPrelude_at_40_1_41_4657(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "at(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)");
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1898
  setline(1898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4659 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4661 = gc_frame_new();
// call case 4: self request
  Object call4662 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4661);
// compiled member node returning call4662 (depth = 5)
  int op_slot_right_4660 = gc_frame_newslot(call4662);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_4660 = gc_frame_newslot(*var_ix);
  params[0] = call4662;
  partcv[0] = 1;
  Object opresult4664 = callmethod(*var_ix, "≤(1)", 1, partcv, params);
// compiled op node returning opresult4664 (depth = 4)
  partcv[0] = 0;
  Object call4665 = callmethodflags(opresult4664, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe4659);
// compiled call node returning call4665 (depth = 3)
  Object if4658 = done;
  if (istrue(call4665)) {
// Begin line 1899
  setline(1899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4666 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4668 == NULL) {
    strlit4668 = alloc_String("");
    gc_root(strlit4668);
  }
// compiled string node returning strlit4668 (depth = 5)
  int op_slot_right_4667 = gc_frame_newslot(strlit4668);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4671 = gc_frame_new();
// call case 4: self request
  Object call4672 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4671);
// compiled member node returning call4672 (depth = 6)
  int op_slot_right_4670 = gc_frame_newslot(call4672);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4675 == NULL) {
    strlit4675 = alloc_String("), but upper bound is ");
    gc_root(strlit4675);
  }
// compiled string node returning strlit4675 (depth = 7)
  int op_slot_right_4674 = gc_frame_newslot(strlit4675);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  int op_slot_right_4677 = gc_frame_newslot(*var_ix);
// starting to compile string node (depth = 8)
  if (strlit4679 == NULL) {
    strlit4679 = alloc_String("requested range.at(");
    gc_root(strlit4679);
  }
// compiled string node returning strlit4679 (depth = 8)
  int op_slot_left_4677 = gc_frame_newslot(strlit4679);
  params[0] = *var_ix;
  partcv[0] = 1;
  Object opresult4680 = callmethod(strlit4679, "++(1)", 1, partcv, params);
// compiled op node returning opresult4680 (depth = 7)
  int op_slot_left_4674 = gc_frame_newslot(opresult4680);
  params[0] = strlit4675;
  partcv[0] = 1;
  Object opresult4681 = callmethod(opresult4680, "++(1)", 1, partcv, params);
// compiled op node returning opresult4681 (depth = 6)
  int op_slot_left_4670 = gc_frame_newslot(opresult4681);
  params[0] = call4672;
  partcv[0] = 1;
  Object opresult4682 = callmethod(opresult4681, "++(1)", 1, partcv, params);
// compiled op node returning opresult4682 (depth = 5)
  int op_slot_left_4667 = gc_frame_newslot(opresult4682);
  params[0] = strlit4668;
  partcv[0] = 1;
  Object opresult4683 = callmethod(opresult4682, "++(1)", 1, partcv, params);
// compiled op node returning opresult4683 (depth = 4)
  gc_frame_newslot(opresult4683);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult4683;
  partcv[0] = 1;
  Object call4684 = callmethodflags(*var_BoundsError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4666);
// compiled call node returning call4684 (depth = 3)
    gc_frame_newslot(call4684);
    if4658 = call4684;
  } else {
  }
// compiled if node returning if4658 (depth = 2)
// Begin line 1901
  setline(1901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4686 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4688 = alloc_Float64(1);
// compiled num node returning num4688 (depth = 5)
  int op_slot_right_4687 = gc_frame_newslot(num4688);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_4687 = gc_frame_newslot(*var_ix);
  params[0] = num4688;
  partcv[0] = 1;
  Object opresult4690 = callmethod(*var_ix, "≥(1)", 1, partcv, params);
// compiled op node returning opresult4690 (depth = 4)
  partcv[0] = 0;
  Object call4691 = callmethodflags(opresult4690, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe4686);
// compiled call node returning call4691 (depth = 3)
  Object if4685 = done;
  if (istrue(call4691)) {
// Begin line 1902
  setline(1902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4692 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4694 == NULL) {
    strlit4694 = alloc_String("), but lower bound is 1");
    gc_root(strlit4694);
  }
// compiled string node returning strlit4694 (depth = 5)
  int op_slot_right_4693 = gc_frame_newslot(strlit4694);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  int op_slot_right_4696 = gc_frame_newslot(*var_ix);
// starting to compile string node (depth = 6)
  if (strlit4698 == NULL) {
    strlit4698 = alloc_String("requested range.at(");
    gc_root(strlit4698);
  }
// compiled string node returning strlit4698 (depth = 6)
  int op_slot_left_4696 = gc_frame_newslot(strlit4698);
  params[0] = *var_ix;
  partcv[0] = 1;
  Object opresult4699 = callmethod(strlit4698, "++(1)", 1, partcv, params);
// compiled op node returning opresult4699 (depth = 5)
  int op_slot_left_4693 = gc_frame_newslot(opresult4699);
  params[0] = strlit4694;
  partcv[0] = 1;
  Object opresult4700 = callmethod(opresult4699, "++(1)", 1, partcv, params);
// compiled op node returning opresult4700 (depth = 4)
  gc_frame_newslot(opresult4700);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult4700;
  partcv[0] = 1;
  Object call4701 = callmethodflags(*var_BoundsError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4692);
// compiled call node returning call4701 (depth = 3)
    gc_frame_newslot(call4701);
    if4685 = call4701;
  } else {
  }
// compiled if node returning if4685 (depth = 2)
// Begin line 1904
  setline(1904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4704 = alloc_Float64(1);
// compiled num node returning num4704 (depth = 5)
  int op_slot_right_4703 = gc_frame_newslot(num4704);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_4703 = gc_frame_newslot(*var_ix);
  params[0] = num4704;
  partcv[0] = 1;
  Object diff4706 = callmethod(*var_ix, "-(1)", 1, partcv, params);
// compiled op node returning diff4706 (depth = 4)
  int op_slot_right_4702 = gc_frame_newslot(diff4706);
// starting to compile member node (depth = 4)
  int callframe4708 = gc_frame_new();
// call case 4: self request
  Object call4709 = callmethodflags(self, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4708);
// compiled member node returning call4709 (depth = 4)
  int op_slot_left_4702 = gc_frame_newslot(call4709);
  params[0] = diff4706;
  partcv[0] = 1;
  Object sum4710 = callmethod(call4709, "+(1)", 1, partcv, params);
// compiled op node returning sum4710 (depth = 3)
  return sum4710;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply4714(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_elem = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_intElem = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "intElem");
// Begin line 1908
  setline(1908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4715 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elem (depth = 6)
  Object call4716 = callmethodflags(*var_elem, "truncated", 0, partcv, params, 0);
  gc_frame_end(callframe4715);
// compiled member node returning call4716 (depth = 5)
  *var_intElem = call4716;
  if (call4716 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 1909
  setline(1909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elem (depth = 6)
  int op_slot_right_4718 = gc_frame_newslot(*var_elem);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_4718 = gc_frame_newslot(*var_intElem);
  params[0] = *var_elem;
  partcv[0] = 1;
  Object opresult4720 = callmethod(*var_intElem, "≠(1)", 1, partcv, params);
// compiled op node returning opresult4720 (depth = 5)
  Object if4717 = done;
  if (istrue(opresult4720)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4721 = alloc_Boolean(0);
// compiled identifier node returning bool4721 (depth = 6)
  block_return(realself, bool4721);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if4717 = undefined;
  } else {
  }
// compiled if node returning if4717 (depth = 4)
// Begin line 1910
  setline(1910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4724 = gc_frame_new();
// call case 4: self request
  Object call4725 = callmethodflags(self, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4724);
// compiled member node returning call4725 (depth = 6)
  int op_slot_right_4723 = gc_frame_newslot(call4725);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_4723 = gc_frame_newslot(*var_intElem);
  params[0] = call4725;
  partcv[0] = 1;
  Object opresult4727 = callmethod(*var_intElem, "<(1)", 1, partcv, params);
// compiled op node returning opresult4727 (depth = 5)
  Object if4722 = done;
  if (istrue(opresult4727)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4728 = alloc_Boolean(0);
// compiled identifier node returning bool4728 (depth = 6)
  block_return(realself, bool4728);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if4722 = undefined;
  } else {
  }
// compiled if node returning if4722 (depth = 4)
// Begin line 1911
  setline(1911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4731 = gc_frame_new();
// call case 4: self request
  Object call4732 = callmethodflags(self, "stop", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4731);
// compiled member node returning call4732 (depth = 6)
  int op_slot_right_4730 = gc_frame_newslot(call4732);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_4730 = gc_frame_newslot(*var_intElem);
  params[0] = call4732;
  partcv[0] = 1;
  Object opresult4734 = callmethod(*var_intElem, ">(1)", 1, partcv, params);
// compiled op node returning opresult4734 (depth = 5)
  Object if4729 = done;
  if (istrue(opresult4734)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4735 = alloc_Boolean(0);
// compiled identifier node returning bool4735 (depth = 6)
  block_return(realself, bool4735);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if4729 = undefined;
  } else {
  }
// compiled if node returning if4729 (depth = 4)
  gc_frame_end(frame);
  return if4729;
}
Object meth_collectionsPrelude__apply_40_1_41_4738(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ex = &(stackframe->slots[0]);
  *var_ex = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4739 = alloc_Boolean(0);
// compiled identifier node returning bool4739 (depth = 5)
  block_return(realself, bool4739);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_contains_40_1_41_4711(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "contains(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains(_)");
  Object params[2];
  int partcv[1];
  Object *var__prelude = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elem = &(stackframe->slots[0]);
  *var_elem = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part contains(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1907
  setline(1907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile trycatch node (depth = 2)
// starting to compile block node (depth = 3)
  Object block4713 = alloc_Block(NULL, NULL, "collectionsPrelude", 1907);
  gc_frame_newslot(block4713);
// method "_apply"
  block_savedest(block4713);
  Object closure4714 = createclosure(2, "_apply");
  setclosureframe(closure4714, stackframe);
  addtoclosure(closure4714, var_elem);
  addtoclosure(closure4714, selfslot);
  struct UserObject *uo4714 = (struct UserObject*)block4713;
  uo4714->data[0] = (Object)closure4714;
  Method *meth_meth_collectionsPrelude__apply4714 = addmethod2pos(block4713, "_apply", &meth_collectionsPrelude__apply4714, 0);
  int argcv_meth_collectionsPrelude__apply4714[] = {0};
  meth_meth_collectionsPrelude__apply4714->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4714);
  meth_meth_collectionsPrelude__apply4714->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4714->definitionLine = 1963;
// compiled block node returning block4713 (depth = 3)
  int frame4712 = gc_frame_new();
  gc_frame_newslot(block4713);
// Begin line 1912
  setline(1912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4737 = alloc_Block(NULL, NULL, "collectionsPrelude", 1912);
  gc_frame_newslot(block4737);
// method "_apply(_)"
  block_savedest(block4737);
  Object closure4738 = createclosure(1, "_apply(1)");
  setclosureframe(closure4738, stackframe);
  addtoclosure(closure4738, selfslot);
  struct UserObject *uo4738 = (struct UserObject*)block4737;
  uo4738->data[0] = (Object)closure4738;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4738 = addmethod2pos(block4737, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4738, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4738[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4738->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4738);
  meth_meth_collectionsPrelude__apply_40_1_41_4738->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4738->definitionLine = 1963;
// starting to compile call node (depth = 4)
  int callframe4741 = gc_frame_new();
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4742 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4743 == NULL) {
    strlit4743 = alloc_String("ex");
    gc_root(strlit4743);
  }
// compiled string node returning strlit4743 (depth = 6)
  gc_frame_newslot(strlit4743);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4744 = gc_frame_new();
// call case 5: prelude request
  Object call4745 = callmethodflags(prelude, "VariablePattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4744);
// compiled member node returning call4745 (depth = 6)
  params[0] = strlit4743;
  partcv[0] = 1;
  Object call4746 = callmethodflags(call4745, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4742);
// compiled call node returning call4746 (depth = 5)
  gc_frame_newslot(call4746);
// Begin line 1912
  setline(1912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe4747 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var__prelude (depth = 6)
  Object call4748 = callmethodflags(*var__prelude, "Exception", 0, partcv, params, 0);
  gc_frame_end(callframe4747);
// compiled member node returning call4748 (depth = 5)
  gc_frame_newslot(call4748);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4749 = gc_frame_new();
// call case 5: prelude request
  Object call4750 = callmethodflags(prelude, "AndPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4749);
// compiled member node returning call4750 (depth = 5)
  params[0] = call4746;
  params[1] = call4748;
  partcv[0] = 2;
  Object call4751 = callmethodflags(call4750, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4741);
// compiled call node returning call4751 (depth = 4)
((struct UserObject *)block4737)->data[1] = call4751;
// compiled block node returning block4737 (depth = 3)
  gc_frame_newslot(block4737);
  params[0] = block4737;
  setline(1907);
  Object catchres4712 = tryCatch(block4713, params, 1,NULL);
  gc_frame_end(frame4712);
// compiled trycatch node returning catchres4712 (depth = 2)
// Begin line 1913
  setline(1913);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool4752 = alloc_Boolean(1);
// compiled identifier node returning bool4752 (depth = 3)
  return bool4752;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply4758(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4760 = gc_frame_new();
// call case 4: self request
  Object call4761 = callmethodflags(self, "stop", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4760);
// compiled member node returning call4761 (depth = 5)
  int op_slot_right_4759 = gc_frame_newslot(call4761);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  int op_slot_left_4759 = gc_frame_newslot(*var_val);
  params[0] = call4761;
  partcv[0] = 1;
  Object opresult4763 = callmethod(*var_val, "≤(1)", 1, partcv, params);
// compiled op node returning opresult4763 (depth = 4)
  gc_frame_end(frame);
  return opresult4763;
}
Object meth_collectionsPrelude__apply4766(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object *var_block1 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1918
  setline(1918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4767 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block1 (depth = 5)
  params[0] = *var_val;
  partcv[0] = 1;
  Object call4768 = callmethodflags(*var_block1, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4767);
// compiled call node returning call4768 (depth = 4)
// Begin line 1919
  setline(1919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4770 = alloc_Float64(1);
// compiled num node returning num4770 (depth = 6)
  int op_slot_right_4769 = gc_frame_newslot(num4770);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_val (depth = 6)
  int op_slot_left_4769 = gc_frame_newslot(*var_val);
  params[0] = num4770;
  partcv[0] = 1;
  Object sum4772 = callmethod(*var_val, "+(1)", 1, partcv, params);
// compiled op node returning sum4772 (depth = 5)
  *var_val = sum4772;
  if (sum4772 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_do_40_1_41_4753(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_val = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "val");
// Begin line 1916
  setline(1916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4754 = gc_frame_new();
// call case 4: self request
  Object call4755 = callmethodflags(self, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4754);
// compiled member node returning call4755 (depth = 3)
  *var_val = call4755;
  if (call4755 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1917
  setline(1917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4756 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4757 = alloc_Block(NULL, NULL, "collectionsPrelude", 1917);
  gc_frame_newslot(block4757);
// method "_apply"
  block_savedest(block4757);
  Object closure4758 = createclosure(2, "_apply");
  setclosureframe(closure4758, stackframe);
  addtoclosure(closure4758, var_val);
  addtoclosure(closure4758, selfslot);
  struct UserObject *uo4758 = (struct UserObject*)block4757;
  uo4758->data[0] = (Object)closure4758;
  Method *meth_meth_collectionsPrelude__apply4758 = addmethod2pos(block4757, "_apply", &meth_collectionsPrelude__apply4758, 0);
  int argcv_meth_collectionsPrelude__apply4758[] = {0};
  meth_meth_collectionsPrelude__apply4758->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4758);
  meth_meth_collectionsPrelude__apply4758->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4758->definitionLine = 1963;
// compiled block node returning block4757 (depth = 3)
  gc_frame_newslot(block4757);
// starting to compile block node (depth = 3)
  Object block4765 = alloc_Block(NULL, NULL, "collectionsPrelude", 1917);
  gc_frame_newslot(block4765);
// method "_apply"
  block_savedest(block4765);
  Object closure4766 = createclosure(3, "_apply");
  setclosureframe(closure4766, stackframe);
  addtoclosure(closure4766, var_val);
  addtoclosure(closure4766, var_block1);
  addtoclosure(closure4766, selfslot);
  struct UserObject *uo4766 = (struct UserObject*)block4765;
  uo4766->data[0] = (Object)closure4766;
  Method *meth_meth_collectionsPrelude__apply4766 = addmethod2pos(block4765, "_apply", &meth_collectionsPrelude__apply4766, 0);
  int argcv_meth_collectionsPrelude__apply4766[] = {0};
  meth_meth_collectionsPrelude__apply4766->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4766);
  meth_meth_collectionsPrelude__apply4766->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4766->definitionLine = 1963;
// compiled block node returning block4765 (depth = 3)
  gc_frame_newslot(block4765);
// call case 5: prelude request
  params[0] = block4757;
  params[1] = block4765;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4775 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4756);
// compiled call node returning call4775 (depth = 2)
  gc_frame_end(frame);
  return call4775;
}
Object meth_collectionsPrelude__apply4782(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4784 = gc_frame_new();
// call case 4: self request
  Object call4785 = callmethodflags(self, "stop", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4784);
// compiled member node returning call4785 (depth = 5)
  int op_slot_right_4783 = gc_frame_newslot(call4785);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  int op_slot_left_4783 = gc_frame_newslot(*var_val);
  params[0] = call4785;
  partcv[0] = 1;
  Object opresult4787 = callmethod(*var_val, "≤(1)", 1, partcv, params);
// compiled op node returning opresult4787 (depth = 4)
  gc_frame_end(frame);
  return opresult4787;
}
Object meth_collectionsPrelude__apply4790(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_key = getfromclosure(closure, 0);
  Object *var_val = getfromclosure(closure, 1);
  Object *var_block2 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1926
  setline(1926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4791 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_key (depth = 5)
  gc_frame_newslot(*var_key);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block2 (depth = 5)
  params[0] = *var_key;
  params[1] = *var_val;
  partcv[0] = 2;
  Object call4792 = callmethodflags(*var_block2, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe4791);
// compiled call node returning call4792 (depth = 4)
// Begin line 1927
  setline(1927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4794 = alloc_Float64(1);
// compiled num node returning num4794 (depth = 6)
  int op_slot_right_4793 = gc_frame_newslot(num4794);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_key (depth = 6)
  int op_slot_left_4793 = gc_frame_newslot(*var_key);
  params[0] = num4794;
  partcv[0] = 1;
  Object sum4796 = callmethod(*var_key, "+(1)", 1, partcv, params);
// compiled op node returning sum4796 (depth = 5)
  *var_key = sum4796;
  if (sum4796 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 1928
  setline(1928);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4799 = alloc_Float64(1);
// compiled num node returning num4799 (depth = 6)
  int op_slot_right_4798 = gc_frame_newslot(num4799);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_val (depth = 6)
  int op_slot_left_4798 = gc_frame_newslot(*var_val);
  params[0] = num4799;
  partcv[0] = 1;
  Object sum4801 = callmethod(*var_val, "+(1)", 1, partcv, params);
// compiled op node returning sum4801 (depth = 5)
  *var_val = sum4801;
  if (sum4801 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_keysAndValuesDo_40_1_41_4776(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keysAndValuesDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysAndValuesDo(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysAndValuesDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part keysAndValuesDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_key = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "key");
  Object *var_val = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "val");
// Begin line 1923
  setline(1923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num4777 = alloc_Float64(1);
// compiled num node returning num4777 (depth = 3)
  *var_key = num4777;
  if (num4777 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1924
  setline(1924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4778 = gc_frame_new();
// call case 4: self request
  Object call4779 = callmethodflags(self, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4778);
// compiled member node returning call4779 (depth = 3)
  *var_val = call4779;
  if (call4779 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1925
  setline(1925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4780 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4781 = alloc_Block(NULL, NULL, "collectionsPrelude", 1925);
  gc_frame_newslot(block4781);
// method "_apply"
  block_savedest(block4781);
  Object closure4782 = createclosure(2, "_apply");
  setclosureframe(closure4782, stackframe);
  addtoclosure(closure4782, var_val);
  addtoclosure(closure4782, selfslot);
  struct UserObject *uo4782 = (struct UserObject*)block4781;
  uo4782->data[0] = (Object)closure4782;
  Method *meth_meth_collectionsPrelude__apply4782 = addmethod2pos(block4781, "_apply", &meth_collectionsPrelude__apply4782, 0);
  int argcv_meth_collectionsPrelude__apply4782[] = {0};
  meth_meth_collectionsPrelude__apply4782->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4782);
  meth_meth_collectionsPrelude__apply4782->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4782->definitionLine = 1963;
// compiled block node returning block4781 (depth = 3)
  gc_frame_newslot(block4781);
// starting to compile block node (depth = 3)
  Object block4789 = alloc_Block(NULL, NULL, "collectionsPrelude", 1925);
  gc_frame_newslot(block4789);
// method "_apply"
  block_savedest(block4789);
  Object closure4790 = createclosure(4, "_apply");
  setclosureframe(closure4790, stackframe);
  addtoclosure(closure4790, var_key);
  addtoclosure(closure4790, var_val);
  addtoclosure(closure4790, var_block2);
  addtoclosure(closure4790, selfslot);
  struct UserObject *uo4790 = (struct UserObject*)block4789;
  uo4790->data[0] = (Object)closure4790;
  Method *meth_meth_collectionsPrelude__apply4790 = addmethod2pos(block4789, "_apply", &meth_collectionsPrelude__apply4790, 0);
  int argcv_meth_collectionsPrelude__apply4790[] = {0};
  meth_meth_collectionsPrelude__apply4790->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4790);
  meth_meth_collectionsPrelude__apply4790->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4790->definitionLine = 1963;
// compiled block node returning block4789 (depth = 3)
  gc_frame_newslot(block4789);
// call case 5: prelude request
  params[0] = block4781;
  params[1] = block4789;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4804 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4780);
// compiled call node returning call4804 (depth = 2)
  gc_frame_end(frame);
  return call4804;
}
Object meth_collectionsPrelude_reversed4805(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "reversed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_upper = getfromclosure(closure, 0);
  Object *var_lower = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1932
  setline(1932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4806 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  gc_frame_newslot(*var_upper);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  gc_frame_newslot(*var_lower);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4807 = gc_frame_new();
// call case 3: self.outer request
  Object call4808 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4807);
// compiled member node returning call4808 (depth = 3)
  params[0] = *var_upper;
  params[1] = *var_lower;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4809 = callmethodflags(call4808, "from(1)downTo(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4806);
// compiled call node returning call4809 (depth = 2)
  gc_frame_end(frame);
  return call4809;
}
Object meth_collectionsPrelude__43__43__40_1_41_4810(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ++(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1935
  setline(1935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4811 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe4812 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4813 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4814 = gc_frame_new();
// call case 3: self.outer request
  Object call4815 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4814);
// compiled member node returning call4815 (depth = 5)
  Object call4816 = callmethodflags(call4815, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4813);
// compiled member node returning call4816 (depth = 4)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 2;
  Object call4817 = callmethodflags(call4816, "lazyConcatenation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4812);
// compiled call node returning call4817 (depth = 3)
  gc_frame_newslot(call4817);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4818 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4819 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4820 = gc_frame_new();
// call case 3: self.outer request
  Object call4821 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4820);
// compiled member node returning call4821 (depth = 5)
  Object call4822 = callmethodflags(call4821, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4819);
// compiled member node returning call4822 (depth = 4)
  Object call4823 = callmethodflags(call4822, "sequence", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4818);
// compiled member node returning call4823 (depth = 3)
  params[0] = call4817;
  partcv[0] = 1;
  Object call4824 = callmethodflags(call4823, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4811);
// compiled call node returning call4824 (depth = 2)
  gc_frame_end(frame);
  return call4824;
}
Object meth_collectionsPrelude__61__61__40_1_41_4825(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1938
  setline(1938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4826 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4827 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4828 = gc_frame_new();
// call case 3: self.outer request
  Object call4829 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4828);
// compiled member node returning call4829 (depth = 4)
  Object call4830 = callmethodflags(call4829, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4827);
// compiled member node returning call4830 (depth = 3)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4831 = callmethodflags(call4830, "isEqual(1)toIterable(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4826);
// compiled call node returning call4831 (depth = 2)
  gc_frame_end(frame);
  return call4831;
}
Object meth_collectionsPrelude_sorted4832(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1940
  setline(1940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_sortedBy_40_1_41_4833(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortedBy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortedBy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sortedBy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1942
  setline(1942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4834 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4835 = gc_frame_new();
// call case 4: self request
  Object call4836 = callmethodflags(self, "asList", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4835);
// compiled member node returning call4836 (depth = 3)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4837 = callmethodflags(call4836, "sortBy(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4834);
// compiled call node returning call4837 (depth = 2)
  gc_frame_end(frame);
  return call4837;
}
Object meth_collectionsPrelude_keys4838(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1944
  setline(1944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4840 = gc_frame_new();
// call case 4: self request
  Object call4841 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4840);
// compiled member node returning call4841 (depth = 3)
  int op_slot_right_4839 = gc_frame_newslot(call4841);
// starting to compile num node (depth = 3)
  Object num4843 = alloc_Float64(1);
// compiled num node returning num4843 (depth = 3)
  int op_slot_left_4839 = gc_frame_newslot(num4843);
  params[0] = call4841;
  partcv[0] = 1;
  Object opresult4844 = callmethod(num4843, "..(1)", 1, partcv, params);
// compiled op node returning opresult4844 (depth = 2)
  gc_frame_end(frame);
  return opresult4844;
}
Object meth_collectionsPrelude_values4845(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1946
  setline(1946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_asString4846(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_upper = getfromclosure(closure, 0);
  Object *var_lower = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1949
  setline(1949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit4848 == NULL) {
    strlit4848 = alloc_String(")");
    gc_root(strlit4848);
  }
// compiled string node returning strlit4848 (depth = 3)
  int op_slot_right_4847 = gc_frame_newslot(strlit4848);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  int op_slot_right_4850 = gc_frame_newslot(*var_upper);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4853 == NULL) {
    strlit4853 = alloc_String(")to(");
    gc_root(strlit4853);
  }
// compiled string node returning strlit4853 (depth = 5)
  int op_slot_right_4852 = gc_frame_newslot(strlit4853);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lower (depth = 6)
  int op_slot_right_4855 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 6)
  if (strlit4857 == NULL) {
    strlit4857 = alloc_String("range.from(");
    gc_root(strlit4857);
  }
// compiled string node returning strlit4857 (depth = 6)
  int op_slot_left_4855 = gc_frame_newslot(strlit4857);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4858 = callmethod(strlit4857, "++(1)", 1, partcv, params);
// compiled op node returning opresult4858 (depth = 5)
  int op_slot_left_4852 = gc_frame_newslot(opresult4858);
  params[0] = strlit4853;
  partcv[0] = 1;
  Object opresult4859 = callmethod(opresult4858, "++(1)", 1, partcv, params);
// compiled op node returning opresult4859 (depth = 4)
  int op_slot_left_4850 = gc_frame_newslot(opresult4859);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4860 = callmethod(opresult4859, "++(1)", 1, partcv, params);
// compiled op node returning opresult4860 (depth = 3)
  int op_slot_left_4847 = gc_frame_newslot(opresult4860);
  params[0] = strlit4848;
  partcv[0] = 1;
  Object opresult4861 = callmethod(opresult4860, "++(1)", 1, partcv, params);
// compiled op node returning opresult4861 (depth = 2)
  gc_frame_end(frame);
  return opresult4861;
}
Object meth_collectionsPrelude__apply_40_1_41_4873(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe4874 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call4875 = callmethodflags(*var_result, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4874);
// compiled call node returning call4875 (depth = 4)
  gc_frame_end(frame);
  return call4875;
}
Object meth_collectionsPrelude_asList4862(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asList");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 1953
  setline(1953);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4863 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4864 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4865 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4866 = gc_frame_new();
// call case 3: self.outer request
  Object call4867 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4866);
// compiled member node returning call4867 (depth = 6)
  Object call4868 = callmethodflags(call4867, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe4865);
// compiled member node returning call4868 (depth = 5)
  Object call4869 = callmethodflags(call4868, "list", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4864);
// compiled member node returning call4869 (depth = 4)
  Object call4870 = callmethodflags(call4869, "empty", 0, partcv, params, 0);
  gc_frame_end(callframe4863);
// compiled member node returning call4870 (depth = 3)
  *var_result = call4870;
  if (call4870 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1954
  setline(1954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4871 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile block node (depth = 3)
  Object block4872 = alloc_Block(NULL, NULL, "collectionsPrelude", 1954);
  gc_frame_newslot(block4872);
// method "_apply(_)"
  block_savedest(block4872);
  Object closure4873 = createclosure(2, "_apply(1)");
  setclosureframe(closure4873, stackframe);
  addtoclosure(closure4873, var_result);
  addtoclosure(closure4873, selfslot);
  struct UserObject *uo4873 = (struct UserObject*)block4872;
  uo4873->data[0] = (Object)closure4873;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_4873 = addmethod2pos(block4872, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_4873, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_4873[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_4873->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_4873);
  meth_meth_collectionsPrelude__apply_40_1_41_4873->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_4873->definitionLine = 1963;
// compiled block node returning block4872 (depth = 3)
  gc_frame_newslot(block4872);
// call case 5: prelude request
  params[0] = self;
  params[1] = block4872;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4877 = callmethodflags(prelude, "for(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4871);
// compiled call node returning call4877 (depth = 2)
// Begin line 1955
  setline(1955);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude_asSequence4878(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asSequence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1959
  setline(1959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply4902(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4904 = alloc_Float64(3);
// compiled num node returning num4904 (depth = 4)
  int op_slot_right_4903 = gc_frame_newslot(num4904);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe4907 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe4908 = gc_frame_new();
// call case 4: self request
  Object call4909 = callmethodflags(self, "stop", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4908);
// compiled member node returning call4909 (depth = 6)
  Object call4910 = callmethodflags(call4909, "hash", 0, partcv, params, 0);
  gc_frame_end(callframe4907);
// compiled member node returning call4910 (depth = 5)
  int op_slot_right_4906 = gc_frame_newslot(call4910);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4913 = alloc_Float64(1021);
// compiled num node returning num4913 (depth = 6)
  int op_slot_right_4912 = gc_frame_newslot(num4913);
// starting to compile member node (depth = 6)
  int callframe4915 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4916 = gc_frame_new();
// call case 4: self request
  Object call4917 = callmethodflags(self, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4916);
// compiled member node returning call4917 (depth = 7)
  Object call4918 = callmethodflags(call4917, "hash", 0, partcv, params, 0);
  gc_frame_end(callframe4915);
// compiled member node returning call4918 (depth = 6)
  int op_slot_left_4912 = gc_frame_newslot(call4918);
  params[0] = num4913;
  partcv[0] = 1;
  Object prod4919 = callmethod(call4918, "*(1)", 1, partcv, params);
// compiled op node returning prod4919 (depth = 5)
  int op_slot_left_4906 = gc_frame_newslot(prod4919);
  params[0] = call4910;
  partcv[0] = 1;
  Object sum4920 = callmethod(prod4919, "+(1)", 1, partcv, params);
// compiled op node returning sum4920 (depth = 4)
  int op_slot_left_4903 = gc_frame_newslot(sum4920);
  params[0] = num4904;
  partcv[0] = 1;
  Object prod4921 = callmethod(sum4920, "*(1)", 1, partcv, params);
// compiled op node returning prod4921 (depth = 3)
  gc_frame_end(frame);
  return prod4921;
}
Object meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4567(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "uncheckedFrom(1)to(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method uncheckedFrom(_)to(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method uncheckedFrom(_)to(_)");
  Object params[1];
  int partcv[2];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  Object *var__prelude = getfromclosure(closure, 2);
  Object *var_indexable = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for uncheckedFrom(_)to(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_lower = &(stackframe->slots[0]);
  *var_lower = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part uncheckedFrom(_)");
  Object *var_upper = &(stackframe->slots[1]);
  *var_upper = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part to(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4568 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4568 = alloc_userobj2(20,21, objclass4568);
  gc_frame_newslot(obj4568);
if (objclass4568 == NULL) {
  glfree(obj4568->class->name);
  obj4568->class->name = "range.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4568, self, 0);
  addmethodreal(obj4568,"outer", &reader_collectionsPrelude_outer_4569);
  Object oldself4568 = self;
  struct StackFrameObject *oldstackframe4568 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4568);
  gc_frame_newslot((Object)stackframe);
  self = obj4568;
  Object *oldselfslot4568 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4568 = (*(struct UserObject *)self).data[0], lowerouter4568 = thisouter4568;
  if (inheritingObject4568) {
    struct UserObject *inho4568 = (struct UserObject *)inheritingObject4568;
    while (inho4568->super != GraceDefaultObject) inho4568 = (struct UserObject *)inho4568->super;
    inho4568->super = obj4568;
    self = inheritingObject4568;
    *selfslot = self;
    lowerouter4568 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4568;
  }
if (objclass4568 == NULL) {
  Method *reader4570 = addmethodrealflags(obj4568, "start",&reader_collectionsPrelude_start_4570, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4570->definitionModule = modulename;
  reader4570->definitionLine = 1876;
}
adddatum2(obj4568, alloc_Undefined(), 1);
if (objclass4568 == NULL) {
  Method *reader4571 = addmethodrealflags(obj4568, "stop",&reader_collectionsPrelude_stop_4571, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4571->definitionModule = modulename;
  reader4571->definitionLine = 1877;
}
adddatum2(obj4568, alloc_Undefined(), 2);
if (objclass4568 == NULL) {
  Method *reader4572 = addmethodrealflags(obj4568, "size",&reader_collectionsPrelude_size_4572, MFLAG_DEF);
  reader4572->definitionModule = modulename;
  reader4572->definitionLine = 1878;
}
adddatum2(obj4568, alloc_Undefined(), 3);
if (objclass4568 == NULL) {
  Method *reader4573 = addmethodrealflags(obj4568, "hash",&reader_collectionsPrelude_hash_4573, MFLAG_DEF);
  reader4573->definitionModule = modulename;
  reader4573->definitionLine = 1881;
}
adddatum2(obj4568, alloc_Undefined(), 4);
// method "iterator"
  block_savedest(obj4568);
  Object closure4574 = createclosure(3, "iterator");
  setclosureframe(closure4574, stackframe);
  addtoclosure(closure4574, var_IteratorExhausted);
  addtoclosure(closure4574, var_lower);
  addtoclosure(closure4574, var_upper);
  struct UserObject *uo4574 = (struct UserObject*)obj4568;
  uo4574->data[5] = (Object)closure4574;
  Method *meth_meth_collectionsPrelude_iterator4574 = addmethod2pos(obj4568, "iterator", &meth_collectionsPrelude_iterator4574, 5);
  int argcv_meth_collectionsPrelude_iterator4574[] = {0};
  meth_meth_collectionsPrelude_iterator4574->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator4574);
  meth_meth_collectionsPrelude_iterator4574->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4574->definitionLine = 1883;
  block_savedest(obj4568);
  Object closure4656 = createclosure(3, "iterator$object(1)");
  setclosureframe(closure4656, stackframe);
  addtoclosure(closure4656, var_IteratorExhausted);
  addtoclosure(closure4656, var_lower);
  addtoclosure(closure4656, var_upper);
  Method *meth_meth_collectionsPrelude_iterator4574_object = addmethod2pos(obj4568, "iterator$object(1)", &meth_collectionsPrelude_iterator4574_object, 5);
  meth_meth_collectionsPrelude_iterator4574_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4574_object->definitionLine = 1883;
// method "at(_)"
  block_savedest(obj4568);
  Object closure4657 = createclosure(1, "at(1)");
  setclosureframe(closure4657, stackframe);
  addtoclosure(closure4657, var_BoundsError);
  struct UserObject *uo4657 = (struct UserObject*)obj4568;
  uo4657->data[6] = (Object)closure4657;
  Method *meth_meth_collectionsPrelude_at_40_1_41_4657 = addmethod2pos(obj4568, "at(1)", &meth_collectionsPrelude_at_40_1_41_4657, 6);
  int argcv_meth_collectionsPrelude_at_40_1_41_4657[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_4657->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_4657);
meth_meth_collectionsPrelude_at_40_1_41_4657->type->types[0] = type_Number;
meth_meth_collectionsPrelude_at_40_1_41_4657->type->names[0] = "ix";
  meth_meth_collectionsPrelude_at_40_1_41_4657->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_4657->definitionLine = 1897;
// method "contains(_)"
  block_savedest(obj4568);
  Object closure4711 = createclosure(1, "contains(1)");
  setclosureframe(closure4711, stackframe);
  addtoclosure(closure4711, var__prelude);
  struct UserObject *uo4711 = (struct UserObject*)obj4568;
  uo4711->data[7] = (Object)closure4711;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_4711 = addmethod2pos(obj4568, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_4711, 7);
  int argcv_meth_collectionsPrelude_contains_40_1_41_4711[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_4711->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_4711);
  meth_meth_collectionsPrelude_contains_40_1_41_4711->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_4711->definitionLine = 1906;
// method "do(_)"
  struct UserObject *uo4753 = (struct UserObject*)obj4568;
  uo4753->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_4753 = addmethod2pos(obj4568, "do(1)", &meth_collectionsPrelude_do_40_1_41_4753, 8);
  int argcv_meth_collectionsPrelude_do_40_1_41_4753[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_4753->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_4753);
  meth_meth_collectionsPrelude_do_40_1_41_4753->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_4753->definitionLine = 1915;
// method "keysAndValuesDo(_)"
  struct UserObject *uo4776 = (struct UserObject*)obj4568;
  uo4776->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4776 = addmethod2pos(obj4568, "keysAndValuesDo(1)", &meth_collectionsPrelude_keysAndValuesDo_40_1_41_4776, 9);
  int argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4776[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4776->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4776);
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4776->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4776->definitionLine = 1922;
// method "reversed"
  block_savedest(obj4568);
  Object closure4805 = createclosure(2, "reversed");
  setclosureframe(closure4805, stackframe);
  addtoclosure(closure4805, var_upper);
  addtoclosure(closure4805, var_lower);
  struct UserObject *uo4805 = (struct UserObject*)obj4568;
  uo4805->data[10] = (Object)closure4805;
  Method *meth_meth_collectionsPrelude_reversed4805 = addmethod2pos(obj4568, "reversed", &meth_collectionsPrelude_reversed4805, 10);
  int argcv_meth_collectionsPrelude_reversed4805[] = {0};
  meth_meth_collectionsPrelude_reversed4805->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed4805);
  meth_meth_collectionsPrelude_reversed4805->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed4805->definitionLine = 1931;
// method "++(_)"
  struct UserObject *uo4810 = (struct UserObject*)obj4568;
  uo4810->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_4810 = addmethod2pos(obj4568, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_4810, 11);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_4810[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_4810->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_4810);
  meth_meth_collectionsPrelude__43__43__40_1_41_4810->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_4810->definitionLine = 1934;
// method "==(_)"
  struct UserObject *uo4825 = (struct UserObject*)obj4568;
  uo4825->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_4825 = addmethod2pos(obj4568, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_4825, 12);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_4825[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_4825->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_4825);
  meth_meth_collectionsPrelude__61__61__40_1_41_4825->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_4825->definitionLine = 1937;
// method "sorted"
  struct UserObject *uo4832 = (struct UserObject*)obj4568;
  uo4832->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted4832 = addmethod2pos(obj4568, "sorted", &meth_collectionsPrelude_sorted4832, 13);
  int argcv_meth_collectionsPrelude_sorted4832[] = {0};
  meth_meth_collectionsPrelude_sorted4832->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted4832);
  meth_meth_collectionsPrelude_sorted4832->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted4832->definitionLine = 1940;
// method "sortedBy(_)"
  struct UserObject *uo4833 = (struct UserObject*)obj4568;
  uo4833->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy_40_1_41_4833 = addmethod2pos(obj4568, "sortedBy(1)", &meth_collectionsPrelude_sortedBy_40_1_41_4833, 14);
  int argcv_meth_collectionsPrelude_sortedBy_40_1_41_4833[] = {1};
  meth_meth_collectionsPrelude_sortedBy_40_1_41_4833->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy_40_1_41_4833);
  meth_meth_collectionsPrelude_sortedBy_40_1_41_4833->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy_40_1_41_4833->definitionLine = 1942;
// method "keys"
  struct UserObject *uo4838 = (struct UserObject*)obj4568;
  uo4838->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys4838 = addmethod2pos(obj4568, "keys", &meth_collectionsPrelude_keys4838, 15);
  int argcv_meth_collectionsPrelude_keys4838[] = {0};
  meth_meth_collectionsPrelude_keys4838->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys4838);
  meth_meth_collectionsPrelude_keys4838->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys4838->definitionLine = 1944;
// method "values"
  struct UserObject *uo4845 = (struct UserObject*)obj4568;
  uo4845->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values4845 = addmethod2pos(obj4568, "values", &meth_collectionsPrelude_values4845, 16);
  int argcv_meth_collectionsPrelude_values4845[] = {0};
  meth_meth_collectionsPrelude_values4845->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values4845);
  meth_meth_collectionsPrelude_values4845->definitionModule = modulename;
  meth_meth_collectionsPrelude_values4845->definitionLine = 1946;
// method "asString"
  block_savedest(obj4568);
  Object closure4846 = createclosure(2, "asString");
  setclosureframe(closure4846, stackframe);
  addtoclosure(closure4846, var_upper);
  addtoclosure(closure4846, var_lower);
  struct UserObject *uo4846 = (struct UserObject*)obj4568;
  uo4846->data[17] = (Object)closure4846;
  Method *meth_meth_collectionsPrelude_asString4846 = addmethod2pos(obj4568, "asString", &meth_collectionsPrelude_asString4846, 17);
  int argcv_meth_collectionsPrelude_asString4846[] = {0};
  meth_meth_collectionsPrelude_asString4846->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString4846);
  meth_meth_collectionsPrelude_asString4846->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString4846->definitionLine = 1948;
// method "asList"
  struct UserObject *uo4862 = (struct UserObject*)obj4568;
  uo4862->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asList4862 = addmethod2pos(obj4568, "asList", &meth_collectionsPrelude_asList4862, 18);
  int argcv_meth_collectionsPrelude_asList4862[] = {0};
  meth_meth_collectionsPrelude_asList4862->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asList4862);
  meth_meth_collectionsPrelude_asList4862->definitionModule = modulename;
  meth_meth_collectionsPrelude_asList4862->definitionLine = 1952;
// method "asSequence"
  struct UserObject *uo4878 = (struct UserObject*)obj4568;
  uo4878->data[19] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSequence4878 = addmethod2pos(obj4568, "asSequence", &meth_collectionsPrelude_asSequence4878, 19);
  int argcv_meth_collectionsPrelude_asSequence4878[] = {0};
  meth_meth_collectionsPrelude_asSequence4878->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSequence4878);
  meth_meth_collectionsPrelude_asSequence4878->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSequence4878->definitionLine = 1958;
  sourceObject = obj4568;
// Begin line 1875
  setline(1875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4879 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4880 = callmethodflags(*var_indexable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4879);
// compiled call node returning call4880 (depth = 2)
  struct UserObject *obj4568_uo = (struct UserObject *)obj4568;
  obj4568_uo->super = call4880;
  sourceObject = obj4568;
// Begin line 1876
  setline(1876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_lower (depth = 2)
  adddatum2(obj4568, *var_lower, 1);
  sourceObject = obj4568;
// Begin line 1877
  setline(1877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_upper (depth = 2)
  adddatum2(obj4568, *var_upper, 2);
  sourceObject = obj4568;
// Begin line 1879
  setline(1879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4883 = alloc_Float64(0);
// compiled num node returning num4883 (depth = 4)
  int op_slot_right_4882 = gc_frame_newslot(num4883);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4886 = alloc_Float64(1);
// compiled num node returning num4886 (depth = 5)
  int op_slot_right_4885 = gc_frame_newslot(num4886);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lower (depth = 6)
  int op_slot_right_4888 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_left_4888 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff4890 = callmethod(*var_upper, "-(1)", 1, partcv, params);
// compiled op node returning diff4890 (depth = 5)
  int op_slot_left_4885 = gc_frame_newslot(diff4890);
  params[0] = num4886;
  partcv[0] = 1;
  Object sum4891 = callmethod(diff4890, "+(1)", 1, partcv, params);
// compiled op node returning sum4891 (depth = 4)
  int op_slot_left_4882 = gc_frame_newslot(sum4891);
  params[0] = num4883;
  partcv[0] = 1;
  Object opresult4892 = callmethod(sum4891, "<(1)", 1, partcv, params);
// compiled op node returning opresult4892 (depth = 3)
  Object if4881 = done;
struct StackFrameObject *iftmpstackframe4881 = stackframe;
  if (istrue(opresult4892)) {
stackframe = alloc_StackFrame(0, iftmpstackframe4881);
gc_frame_newslot((Object)stackframe);
// starting to compile num node (depth = 3)
  Object num4893 = alloc_Float64(0);
// compiled num node returning num4893 (depth = 3)
    gc_frame_newslot(num4893);
    if4881 = num4893;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe4881);
  gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4895 = alloc_Float64(1);
// compiled num node returning num4895 (depth = 4)
  int op_slot_right_4894 = gc_frame_newslot(num4895);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lower (depth = 5)
  int op_slot_right_4897 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_upper (depth = 5)
  int op_slot_left_4897 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff4899 = callmethod(*var_upper, "-(1)", 1, partcv, params);
// compiled op node returning diff4899 (depth = 4)
  int op_slot_left_4894 = gc_frame_newslot(diff4899);
  params[0] = num4895;
  partcv[0] = 1;
  Object sum4900 = callmethod(diff4899, "+(1)", 1, partcv, params);
// compiled op node returning sum4900 (depth = 3)
    gc_frame_newslot(sum4900);
    if4881 = sum4900;
  }
stackframe = iftmpstackframe4881;
// compiled if node returning if4881 (depth = 2)
  adddatum2(obj4568, if4881, 3);
  sourceObject = obj4568;
// Begin line 1881
  setline(1881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 2)
  Object block4901 = alloc_Block(NULL, NULL, "collectionsPrelude", 1881);
  gc_frame_newslot(block4901);
// method "_apply"
  block_savedest(block4901);
  Object closure4902 = createclosure(1, "_apply");
  setclosureframe(closure4902, stackframe);
  addtoclosure(closure4902, selfslot);
  struct UserObject *uo4902 = (struct UserObject*)block4901;
  uo4902->data[0] = (Object)closure4902;
  Method *meth_meth_collectionsPrelude__apply4902 = addmethod2pos(block4901, "_apply", &meth_collectionsPrelude__apply4902, 0);
  int argcv_meth_collectionsPrelude__apply4902[] = {0};
  meth_meth_collectionsPrelude__apply4902->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4902);
  meth_meth_collectionsPrelude__apply4902->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4902->definitionLine = 1963;
// compiled block node returning block4901 (depth = 2)
  adddatum2(obj4568, block4901, 4);
  sourceObject = obj4568;
  sourceObject = obj4568;
  sourceObject = obj4568;
  sourceObject = obj4568;
  sourceObject = obj4568;
  sourceObject = obj4568;
  sourceObject = obj4568;
  sourceObject = obj4568;
  sourceObject = obj4568;
  sourceObject = obj4568;
  sourceObject = obj4568;
  sourceObject = obj4568;
  sourceObject = obj4568;
  sourceObject = obj4568;
  sourceObject = obj4568;
  objclass4568 = obj4568->class;
  objclass4568->definitionModule = modulename;
  objclass4568->definitionLine = 1874;
  (*(struct UserObject *)self).data[0] = lowerouter4568;
  self = oldself4568;
  selfslot = oldselfslot4568;
  stackframe = oldstackframe4568;
  gc_frame_end(frame);
  return obj4568;
}
Object meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4567_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "uncheckedFrom(1)to(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method uncheckedFrom(_)to(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments for method uncheckedFrom(_)to(_)");
  Object params[1];
  int partcv[2];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  Object *var__prelude = getfromclosure(closure, 2);
  Object *var_indexable = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for uncheckedFrom(_)to(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_lower = &(stackframe->slots[0]);
  *var_lower = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part uncheckedFrom(_)");
  Object *var_upper = &(stackframe->slots[1]);
  *var_upper = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part to(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4568 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4568 = alloc_userobj2(20,21, objclass4568);
  gc_frame_newslot(obj4568);
if (objclass4568 == NULL) {
  glfree(obj4568->class->name);
  obj4568->class->name = "range.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4568, self, 0);
  addmethodreal(obj4568,"outer", &reader_collectionsPrelude_outer_4569);
  Object oldself4568 = self;
  struct StackFrameObject *oldstackframe4568 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4568);
  gc_frame_newslot((Object)stackframe);
  self = obj4568;
  Object *oldselfslot4568 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4568 = (*(struct UserObject *)self).data[0], lowerouter4568 = thisouter4568;
  if (inheritingObject4568) {
    struct UserObject *inho4568 = (struct UserObject *)inheritingObject4568;
    while (inho4568->super != GraceDefaultObject) inho4568 = (struct UserObject *)inho4568->super;
    inho4568->super = obj4568;
    self = inheritingObject4568;
    *selfslot = self;
    lowerouter4568 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4568;
  }
if (objclass4568 == NULL) {
  Method *reader4570 = addmethodrealflags(obj4568, "start",&reader_collectionsPrelude_start_4570, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4570->definitionModule = modulename;
  reader4570->definitionLine = 1876;
}
adddatum2(obj4568, alloc_Undefined(), 1);
if (objclass4568 == NULL) {
  Method *reader4571 = addmethodrealflags(obj4568, "stop",&reader_collectionsPrelude_stop_4571, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4571->definitionModule = modulename;
  reader4571->definitionLine = 1877;
}
adddatum2(obj4568, alloc_Undefined(), 2);
if (objclass4568 == NULL) {
  Method *reader4572 = addmethodrealflags(obj4568, "size",&reader_collectionsPrelude_size_4572, MFLAG_DEF);
  reader4572->definitionModule = modulename;
  reader4572->definitionLine = 1878;
}
adddatum2(obj4568, alloc_Undefined(), 3);
if (objclass4568 == NULL) {
  Method *reader4573 = addmethodrealflags(obj4568, "hash",&reader_collectionsPrelude_hash_4573, MFLAG_DEF);
  reader4573->definitionModule = modulename;
  reader4573->definitionLine = 1881;
}
adddatum2(obj4568, alloc_Undefined(), 4);
// method "iterator"
  block_savedest(obj4568);
  Object closure4574 = createclosure(3, "iterator");
  setclosureframe(closure4574, stackframe);
  addtoclosure(closure4574, var_IteratorExhausted);
  addtoclosure(closure4574, var_lower);
  addtoclosure(closure4574, var_upper);
  struct UserObject *uo4574 = (struct UserObject*)obj4568;
  uo4574->data[5] = (Object)closure4574;
  Method *meth_meth_collectionsPrelude_iterator4574 = addmethod2pos(obj4568, "iterator", &meth_collectionsPrelude_iterator4574, 5);
  int argcv_meth_collectionsPrelude_iterator4574[] = {0};
  meth_meth_collectionsPrelude_iterator4574->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator4574);
  meth_meth_collectionsPrelude_iterator4574->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4574->definitionLine = 1883;
  block_savedest(obj4568);
  Object closure4656 = createclosure(3, "iterator$object(1)");
  setclosureframe(closure4656, stackframe);
  addtoclosure(closure4656, var_IteratorExhausted);
  addtoclosure(closure4656, var_lower);
  addtoclosure(closure4656, var_upper);
  Method *meth_meth_collectionsPrelude_iterator4574_object = addmethod2pos(obj4568, "iterator$object(1)", &meth_collectionsPrelude_iterator4574_object, 5);
  meth_meth_collectionsPrelude_iterator4574_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4574_object->definitionLine = 1883;
// method "at(_)"
  block_savedest(obj4568);
  Object closure4657 = createclosure(1, "at(1)");
  setclosureframe(closure4657, stackframe);
  addtoclosure(closure4657, var_BoundsError);
  struct UserObject *uo4657 = (struct UserObject*)obj4568;
  uo4657->data[6] = (Object)closure4657;
  Method *meth_meth_collectionsPrelude_at_40_1_41_4657 = addmethod2pos(obj4568, "at(1)", &meth_collectionsPrelude_at_40_1_41_4657, 6);
  int argcv_meth_collectionsPrelude_at_40_1_41_4657[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_4657->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_4657);
meth_meth_collectionsPrelude_at_40_1_41_4657->type->types[0] = type_Number;
meth_meth_collectionsPrelude_at_40_1_41_4657->type->names[0] = "ix";
  meth_meth_collectionsPrelude_at_40_1_41_4657->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_4657->definitionLine = 1897;
// method "contains(_)"
  block_savedest(obj4568);
  Object closure4711 = createclosure(1, "contains(1)");
  setclosureframe(closure4711, stackframe);
  addtoclosure(closure4711, var__prelude);
  struct UserObject *uo4711 = (struct UserObject*)obj4568;
  uo4711->data[7] = (Object)closure4711;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_4711 = addmethod2pos(obj4568, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_4711, 7);
  int argcv_meth_collectionsPrelude_contains_40_1_41_4711[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_4711->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_4711);
  meth_meth_collectionsPrelude_contains_40_1_41_4711->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_4711->definitionLine = 1906;
// method "do(_)"
  struct UserObject *uo4753 = (struct UserObject*)obj4568;
  uo4753->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_4753 = addmethod2pos(obj4568, "do(1)", &meth_collectionsPrelude_do_40_1_41_4753, 8);
  int argcv_meth_collectionsPrelude_do_40_1_41_4753[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_4753->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_4753);
  meth_meth_collectionsPrelude_do_40_1_41_4753->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_4753->definitionLine = 1915;
// method "keysAndValuesDo(_)"
  struct UserObject *uo4776 = (struct UserObject*)obj4568;
  uo4776->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4776 = addmethod2pos(obj4568, "keysAndValuesDo(1)", &meth_collectionsPrelude_keysAndValuesDo_40_1_41_4776, 9);
  int argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4776[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4776->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4776);
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4776->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_4776->definitionLine = 1922;
// method "reversed"
  block_savedest(obj4568);
  Object closure4805 = createclosure(2, "reversed");
  setclosureframe(closure4805, stackframe);
  addtoclosure(closure4805, var_upper);
  addtoclosure(closure4805, var_lower);
  struct UserObject *uo4805 = (struct UserObject*)obj4568;
  uo4805->data[10] = (Object)closure4805;
  Method *meth_meth_collectionsPrelude_reversed4805 = addmethod2pos(obj4568, "reversed", &meth_collectionsPrelude_reversed4805, 10);
  int argcv_meth_collectionsPrelude_reversed4805[] = {0};
  meth_meth_collectionsPrelude_reversed4805->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed4805);
  meth_meth_collectionsPrelude_reversed4805->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed4805->definitionLine = 1931;
// method "++(_)"
  struct UserObject *uo4810 = (struct UserObject*)obj4568;
  uo4810->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_4810 = addmethod2pos(obj4568, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_4810, 11);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_4810[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_4810->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_4810);
  meth_meth_collectionsPrelude__43__43__40_1_41_4810->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_4810->definitionLine = 1934;
// method "==(_)"
  struct UserObject *uo4825 = (struct UserObject*)obj4568;
  uo4825->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_4825 = addmethod2pos(obj4568, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_4825, 12);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_4825[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_4825->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_4825);
  meth_meth_collectionsPrelude__61__61__40_1_41_4825->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_4825->definitionLine = 1937;
// method "sorted"
  struct UserObject *uo4832 = (struct UserObject*)obj4568;
  uo4832->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted4832 = addmethod2pos(obj4568, "sorted", &meth_collectionsPrelude_sorted4832, 13);
  int argcv_meth_collectionsPrelude_sorted4832[] = {0};
  meth_meth_collectionsPrelude_sorted4832->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted4832);
  meth_meth_collectionsPrelude_sorted4832->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted4832->definitionLine = 1940;
// method "sortedBy(_)"
  struct UserObject *uo4833 = (struct UserObject*)obj4568;
  uo4833->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy_40_1_41_4833 = addmethod2pos(obj4568, "sortedBy(1)", &meth_collectionsPrelude_sortedBy_40_1_41_4833, 14);
  int argcv_meth_collectionsPrelude_sortedBy_40_1_41_4833[] = {1};
  meth_meth_collectionsPrelude_sortedBy_40_1_41_4833->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy_40_1_41_4833);
  meth_meth_collectionsPrelude_sortedBy_40_1_41_4833->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy_40_1_41_4833->definitionLine = 1942;
// method "keys"
  struct UserObject *uo4838 = (struct UserObject*)obj4568;
  uo4838->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys4838 = addmethod2pos(obj4568, "keys", &meth_collectionsPrelude_keys4838, 15);
  int argcv_meth_collectionsPrelude_keys4838[] = {0};
  meth_meth_collectionsPrelude_keys4838->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys4838);
  meth_meth_collectionsPrelude_keys4838->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys4838->definitionLine = 1944;
// method "values"
  struct UserObject *uo4845 = (struct UserObject*)obj4568;
  uo4845->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values4845 = addmethod2pos(obj4568, "values", &meth_collectionsPrelude_values4845, 16);
  int argcv_meth_collectionsPrelude_values4845[] = {0};
  meth_meth_collectionsPrelude_values4845->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values4845);
  meth_meth_collectionsPrelude_values4845->definitionModule = modulename;
  meth_meth_collectionsPrelude_values4845->definitionLine = 1946;
// method "asString"
  block_savedest(obj4568);
  Object closure4846 = createclosure(2, "asString");
  setclosureframe(closure4846, stackframe);
  addtoclosure(closure4846, var_upper);
  addtoclosure(closure4846, var_lower);
  struct UserObject *uo4846 = (struct UserObject*)obj4568;
  uo4846->data[17] = (Object)closure4846;
  Method *meth_meth_collectionsPrelude_asString4846 = addmethod2pos(obj4568, "asString", &meth_collectionsPrelude_asString4846, 17);
  int argcv_meth_collectionsPrelude_asString4846[] = {0};
  meth_meth_collectionsPrelude_asString4846->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString4846);
  meth_meth_collectionsPrelude_asString4846->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString4846->definitionLine = 1948;
// method "asList"
  struct UserObject *uo4862 = (struct UserObject*)obj4568;
  uo4862->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asList4862 = addmethod2pos(obj4568, "asList", &meth_collectionsPrelude_asList4862, 18);
  int argcv_meth_collectionsPrelude_asList4862[] = {0};
  meth_meth_collectionsPrelude_asList4862->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asList4862);
  meth_meth_collectionsPrelude_asList4862->definitionModule = modulename;
  meth_meth_collectionsPrelude_asList4862->definitionLine = 1952;
// method "asSequence"
  struct UserObject *uo4878 = (struct UserObject*)obj4568;
  uo4878->data[19] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSequence4878 = addmethod2pos(obj4568, "asSequence", &meth_collectionsPrelude_asSequence4878, 19);
  int argcv_meth_collectionsPrelude_asSequence4878[] = {0};
  meth_meth_collectionsPrelude_asSequence4878->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSequence4878);
  meth_meth_collectionsPrelude_asSequence4878->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSequence4878->definitionLine = 1958;
  sourceObject = obj4568;
// Begin line 1875
  setline(1875);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4879 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4880 = callmethodflags(*var_indexable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe4879);
// compiled call node returning call4880 (depth = 2)
  struct UserObject *obj4568_uo = (struct UserObject *)obj4568;
  obj4568_uo->super = call4880;
  sourceObject = obj4568;
// Begin line 1876
  setline(1876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_lower (depth = 2)
  adddatum2(obj4568, *var_lower, 1);
  sourceObject = obj4568;
// Begin line 1877
  setline(1877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_upper (depth = 2)
  adddatum2(obj4568, *var_upper, 2);
  sourceObject = obj4568;
// Begin line 1879
  setline(1879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4883 = alloc_Float64(0);
// compiled num node returning num4883 (depth = 4)
  int op_slot_right_4882 = gc_frame_newslot(num4883);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4886 = alloc_Float64(1);
// compiled num node returning num4886 (depth = 5)
  int op_slot_right_4885 = gc_frame_newslot(num4886);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lower (depth = 6)
  int op_slot_right_4888 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_left_4888 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff4890 = callmethod(*var_upper, "-(1)", 1, partcv, params);
// compiled op node returning diff4890 (depth = 5)
  int op_slot_left_4885 = gc_frame_newslot(diff4890);
  params[0] = num4886;
  partcv[0] = 1;
  Object sum4891 = callmethod(diff4890, "+(1)", 1, partcv, params);
// compiled op node returning sum4891 (depth = 4)
  int op_slot_left_4882 = gc_frame_newslot(sum4891);
  params[0] = num4883;
  partcv[0] = 1;
  Object opresult4892 = callmethod(sum4891, "<(1)", 1, partcv, params);
// compiled op node returning opresult4892 (depth = 3)
  Object if4881 = done;
struct StackFrameObject *iftmpstackframe4881 = stackframe;
  if (istrue(opresult4892)) {
stackframe = alloc_StackFrame(0, iftmpstackframe4881);
gc_frame_newslot((Object)stackframe);
// starting to compile num node (depth = 3)
  Object num4893 = alloc_Float64(0);
// compiled num node returning num4893 (depth = 3)
    gc_frame_newslot(num4893);
    if4881 = num4893;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe4881);
  gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4895 = alloc_Float64(1);
// compiled num node returning num4895 (depth = 4)
  int op_slot_right_4894 = gc_frame_newslot(num4895);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lower (depth = 5)
  int op_slot_right_4897 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_upper (depth = 5)
  int op_slot_left_4897 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff4899 = callmethod(*var_upper, "-(1)", 1, partcv, params);
// compiled op node returning diff4899 (depth = 4)
  int op_slot_left_4894 = gc_frame_newslot(diff4899);
  params[0] = num4895;
  partcv[0] = 1;
  Object sum4900 = callmethod(diff4899, "+(1)", 1, partcv, params);
// compiled op node returning sum4900 (depth = 3)
    gc_frame_newslot(sum4900);
    if4881 = sum4900;
  }
stackframe = iftmpstackframe4881;
// compiled if node returning if4881 (depth = 2)
  adddatum2(obj4568, if4881, 3);
  sourceObject = obj4568;
// Begin line 1881
  setline(1881);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 2)
  Object block4901 = alloc_Block(NULL, NULL, "collectionsPrelude", 1881);
  gc_frame_newslot(block4901);
// method "_apply"
  block_savedest(block4901);
  Object closure4902 = createclosure(1, "_apply");
  setclosureframe(closure4902, stackframe);
  addtoclosure(closure4902, selfslot);
  struct UserObject *uo4902 = (struct UserObject*)block4901;
  uo4902->data[0] = (Object)closure4902;
  Method *meth_meth_collectionsPrelude__apply4902 = addmethod2pos(block4901, "_apply", &meth_collectionsPrelude__apply4902, 0);
  int argcv_meth_collectionsPrelude__apply4902[] = {0};
  meth_meth_collectionsPrelude__apply4902->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4902);
  meth_meth_collectionsPrelude__apply4902->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4902->definitionLine = 1963;
// compiled block node returning block4901 (depth = 2)
  adddatum2(obj4568, block4901, 4);
  sourceObject = obj4568;
  sourceObject = obj4568;
  sourceObject = obj4568;
  sourceObject = obj4568;
  sourceObject = obj4568;
  sourceObject = obj4568;
  sourceObject = obj4568;
  sourceObject = obj4568;
  sourceObject = obj4568;
  sourceObject = obj4568;
  sourceObject = obj4568;
  sourceObject = obj4568;
  sourceObject = obj4568;
  sourceObject = obj4568;
  sourceObject = obj4568;
  objclass4568 = obj4568->class;
  objclass4568->definitionModule = modulename;
  objclass4568->definitionLine = 1874;
  (*(struct UserObject *)self).data[0] = lowerouter4568;
  self = oldself4568;
  selfslot = oldselfslot4568;
  stackframe = oldstackframe4568;
  gc_frame_end(frame);
  return obj4568;
}
Object meth_collectionsPrelude_hasNext4934(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1989
  setline(1989);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe4936 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe4937 = gc_frame_new();
// call case 3: self.outer request
  Object call4938 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4937);
// compiled member node returning call4938 (depth = 4)
  Object call4939 = callmethodflags(call4938, "stop", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4936);
// compiled member node returning call4939 (depth = 3)
  int op_slot_right_4935 = gc_frame_newslot(call4939);
// starting to compile member node (depth = 3)
  int callframe4941 = gc_frame_new();
// call case 4: self request
  Object call4942 = callmethodflags(self, "val", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4941);
// compiled member node returning call4942 (depth = 3)
  int op_slot_left_4935 = gc_frame_newslot(call4942);
  params[0] = call4939;
  partcv[0] = 1;
  Object opresult4943 = callmethod(call4942, "≥(1)", 1, partcv, params);
// compiled op node returning opresult4943 (depth = 2)
  gc_frame_end(frame);
  return opresult4943;
}
Object meth_collectionsPrelude_next4944(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4947 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe4948 = gc_frame_new();
// call case 3: self.outer request
  Object call4949 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4948);
// compiled member node returning call4949 (depth = 5)
  Object call4950 = callmethodflags(call4949, "stop", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4947);
// compiled member node returning call4950 (depth = 4)
  int op_slot_right_4946 = gc_frame_newslot(call4950);
// starting to compile member node (depth = 4)
  int callframe4952 = gc_frame_new();
// call case 4: self request
  Object call4953 = callmethodflags(self, "val", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4952);
// compiled member node returning call4953 (depth = 4)
  int op_slot_left_4946 = gc_frame_newslot(call4953);
  params[0] = call4950;
  partcv[0] = 1;
  Object opresult4954 = callmethod(call4953, "<(1)", 1, partcv, params);
// compiled op node returning opresult4954 (depth = 3)
  Object if4945 = done;
  if (istrue(opresult4954)) {
// starting to compile call node (depth = 3)
  int callframe4955 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4957 == NULL) {
    strlit4957 = alloc_String("");
    gc_root(strlit4957);
  }
// compiled string node returning strlit4957 (depth = 5)
  int op_slot_right_4956 = gc_frame_newslot(strlit4957);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe4960 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe4961 = gc_frame_new();
// call case 3: self.outer request
  Object call4962 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4961);
// compiled member node returning call4962 (depth = 7)
  Object call4963 = callmethodflags(call4962, "asString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4960);
// compiled member node returning call4963 (depth = 6)
  int op_slot_right_4959 = gc_frame_newslot(call4963);
// starting to compile string node (depth = 6)
  if (strlit4965 == NULL) {
    strlit4965 = alloc_String("over ");
    gc_root(strlit4965);
  }
// compiled string node returning strlit4965 (depth = 6)
  int op_slot_left_4959 = gc_frame_newslot(strlit4965);
  params[0] = call4963;
  partcv[0] = 1;
  Object opresult4966 = callmethod(strlit4965, "++(1)", 1, partcv, params);
// compiled op node returning opresult4966 (depth = 5)
  int op_slot_left_4956 = gc_frame_newslot(opresult4966);
  params[0] = strlit4957;
  partcv[0] = 1;
  Object opresult4967 = callmethod(opresult4966, "++(1)", 1, partcv, params);
// compiled op node returning opresult4967 (depth = 4)
  gc_frame_newslot(opresult4967);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_IteratorExhausted (depth = 4)
  params[0] = opresult4967;
  partcv[0] = 1;
  Object call4968 = callmethodflags(*var_IteratorExhausted, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe4955);
// compiled call node returning call4968 (depth = 3)
    gc_frame_newslot(call4968);
    if4945 = call4968;
  } else {
  }
// compiled if node returning if4945 (depth = 2)
// Begin line 1992
  setline(1992);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4969 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4971 = alloc_Float64(1);
// compiled num node returning num4971 (depth = 4)
  int op_slot_right_4970 = gc_frame_newslot(num4971);
// starting to compile member node (depth = 4)
  int callframe4973 = gc_frame_new();
// call case 4: self request
  Object call4974 = callmethodflags(self, "val", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4973);
// compiled member node returning call4974 (depth = 4)
  int op_slot_left_4970 = gc_frame_newslot(call4974);
  params[0] = num4971;
  partcv[0] = 1;
  Object diff4975 = callmethod(call4974, "-(1)", 1, partcv, params);
// compiled op node returning diff4975 (depth = 3)
  gc_frame_newslot(diff4975);
// call case 4: self request
  params[0] = diff4975;
  partcv[0] = 1;
  Object call4976 = callmethodflags(self, "val:=(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4969);
// compiled call node returning call4976 (depth = 2)
// Begin line 1993
  setline(1993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4978 = alloc_Float64(1);
// compiled num node returning num4978 (depth = 4)
  int op_slot_right_4977 = gc_frame_newslot(num4978);
// starting to compile member node (depth = 4)
  int callframe4980 = gc_frame_new();
// call case 4: self request
  Object call4981 = callmethodflags(self, "val", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4980);
// compiled member node returning call4981 (depth = 4)
  int op_slot_left_4977 = gc_frame_newslot(call4981);
  params[0] = num4978;
  partcv[0] = 1;
  Object sum4982 = callmethod(call4981, "+(1)", 1, partcv, params);
// compiled op node returning sum4982 (depth = 3)
  return sum4982;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_asString4983(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1995
  setline(1995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit4985 == NULL) {
    strlit4985 = alloc_String("");
    gc_root(strlit4985);
  }
// compiled string node returning strlit4985 (depth = 3)
  int op_slot_right_4984 = gc_frame_newslot(strlit4985);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe4988 = gc_frame_new();
// call case 1: super request
  Object call4989 = callmethod4(self, "asString", 0, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe4988);
// compiled member node returning call4989 (depth = 4)
  int op_slot_right_4987 = gc_frame_newslot(call4989);
// starting to compile string node (depth = 4)
  if (strlit4991 == NULL) {
    strlit4991 = alloc_String("anIterator over ");
    gc_root(strlit4991);
  }
// compiled string node returning strlit4991 (depth = 4)
  int op_slot_left_4987 = gc_frame_newslot(strlit4991);
  params[0] = call4989;
  partcv[0] = 1;
  Object opresult4992 = callmethod(strlit4991, "++(1)", 1, partcv, params);
// compiled op node returning opresult4992 (depth = 3)
  int op_slot_left_4984 = gc_frame_newslot(opresult4992);
  params[0] = strlit4985;
  partcv[0] = 1;
  Object opresult4993 = callmethod(opresult4992, "++(1)", 1, partcv, params);
// compiled op node returning opresult4993 (depth = 2)
  gc_frame_end(frame);
  return opresult4993;
}
Object meth_collectionsPrelude_iterator4930(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4931 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4931 = alloc_userobj2(5,5, objclass4931);
  gc_frame_newslot(obj4931);
if (objclass4931 == NULL) {
  glfree(obj4931->class->name);
  obj4931->class->name = "range.object.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4931, self, 0);
  addmethodreal(obj4931,"outer", &reader_collectionsPrelude_outer_4932);
  Object oldself4931 = self;
  struct StackFrameObject *oldstackframe4931 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4931);
  gc_frame_newslot((Object)stackframe);
  self = obj4931;
  Object *oldselfslot4931 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4931 = (*(struct UserObject *)self).data[0], lowerouter4931 = thisouter4931;
  if (inheritingObject4931) {
    struct UserObject *inho4931 = (struct UserObject *)inheritingObject4931;
    while (inho4931->super != GraceDefaultObject) inho4931 = (struct UserObject *)inho4931->super;
    inho4931->super = obj4931;
    self = inheritingObject4931;
    *selfslot = self;
    lowerouter4931 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4931;
  }
if (objclass4931 == NULL) {
  Method *reader4933 = addmethodrealflags(obj4931, "val", &reader_collectionsPrelude_val_4933, MFLAG_CONFIDENTIAL);
  Method *writer4933 = addmethodrealflags(obj4931, "val:=(1)", &writer_collectionsPrelude_val_4933, MFLAG_CONFIDENTIAL);
  reader4933->definitionModule = modulename;
  writer4933->definitionModule = modulename;
  reader4933->definitionLine = 1988;
  writer4933->definitionLine = 1988;
}
obj4931->flags |= OFLAG_MUTABLE;
adddatum2(obj4931, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo4934 = (struct UserObject*)obj4931;
  uo4934->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext4934 = addmethod2pos(obj4931, "hasNext", &meth_collectionsPrelude_hasNext4934, 2);
  int argcv_meth_collectionsPrelude_hasNext4934[] = {0};
  meth_meth_collectionsPrelude_hasNext4934->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext4934);
  meth_meth_collectionsPrelude_hasNext4934->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext4934->definitionLine = 1989;
// method "next"
  block_savedest(obj4931);
  Object closure4944 = createclosure(1, "next");
  setclosureframe(closure4944, stackframe);
  addtoclosure(closure4944, var_IteratorExhausted);
  struct UserObject *uo4944 = (struct UserObject*)obj4931;
  uo4944->data[3] = (Object)closure4944;
  Method *meth_meth_collectionsPrelude_next4944 = addmethod2pos(obj4931, "next", &meth_collectionsPrelude_next4944, 3);
  int argcv_meth_collectionsPrelude_next4944[] = {0};
  meth_meth_collectionsPrelude_next4944->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next4944);
  meth_meth_collectionsPrelude_next4944->definitionModule = modulename;
  meth_meth_collectionsPrelude_next4944->definitionLine = 1990;
// method "asString"
  struct UserObject *uo4983 = (struct UserObject*)obj4931;
  uo4983->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString4983 = addmethod2pos(obj4931, "asString", &meth_collectionsPrelude_asString4983, 4);
  int argcv_meth_collectionsPrelude_asString4983[] = {0};
  meth_meth_collectionsPrelude_asString4983->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString4983);
  meth_meth_collectionsPrelude_asString4983->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString4983->definitionLine = 1995;
  sourceObject = obj4931;
// Begin line 1988
  setline(1988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4994 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4995 = gc_frame_new();
// call case 3: self.outer request
  Object call4996 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4995);
// compiled member node returning call4996 (depth = 3)
  Object call4997 = callmethodflags(call4996, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4994);
// compiled member node returning call4997 (depth = 2)
  adddatum2(obj4931, call4997, 1);
  sourceObject = obj4931;
  sourceObject = obj4931;
  sourceObject = obj4931;
  objclass4931 = obj4931->class;
  objclass4931->definitionModule = modulename;
  objclass4931->definitionLine = 1987;
  (*(struct UserObject *)self).data[0] = lowerouter4931;
  self = oldself4931;
  selfslot = oldselfslot4931;
  stackframe = oldstackframe4931;
  gc_frame_end(frame);
  return obj4931;
}
Object meth_collectionsPrelude_iterator4930_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4931 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4931 = alloc_userobj2(5,5, objclass4931);
  gc_frame_newslot(obj4931);
if (objclass4931 == NULL) {
  glfree(obj4931->class->name);
  obj4931->class->name = "range.object.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4931, self, 0);
  addmethodreal(obj4931,"outer", &reader_collectionsPrelude_outer_4932);
  Object oldself4931 = self;
  struct StackFrameObject *oldstackframe4931 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4931);
  gc_frame_newslot((Object)stackframe);
  self = obj4931;
  Object *oldselfslot4931 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4931 = (*(struct UserObject *)self).data[0], lowerouter4931 = thisouter4931;
  if (inheritingObject4931) {
    struct UserObject *inho4931 = (struct UserObject *)inheritingObject4931;
    while (inho4931->super != GraceDefaultObject) inho4931 = (struct UserObject *)inho4931->super;
    inho4931->super = obj4931;
    self = inheritingObject4931;
    *selfslot = self;
    lowerouter4931 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4931;
  }
if (objclass4931 == NULL) {
  Method *reader4933 = addmethodrealflags(obj4931, "val", &reader_collectionsPrelude_val_4933, MFLAG_CONFIDENTIAL);
  Method *writer4933 = addmethodrealflags(obj4931, "val:=(1)", &writer_collectionsPrelude_val_4933, MFLAG_CONFIDENTIAL);
  reader4933->definitionModule = modulename;
  writer4933->definitionModule = modulename;
  reader4933->definitionLine = 1988;
  writer4933->definitionLine = 1988;
}
obj4931->flags |= OFLAG_MUTABLE;
adddatum2(obj4931, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo4934 = (struct UserObject*)obj4931;
  uo4934->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext4934 = addmethod2pos(obj4931, "hasNext", &meth_collectionsPrelude_hasNext4934, 2);
  int argcv_meth_collectionsPrelude_hasNext4934[] = {0};
  meth_meth_collectionsPrelude_hasNext4934->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext4934);
  meth_meth_collectionsPrelude_hasNext4934->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext4934->definitionLine = 1989;
// method "next"
  block_savedest(obj4931);
  Object closure4944 = createclosure(1, "next");
  setclosureframe(closure4944, stackframe);
  addtoclosure(closure4944, var_IteratorExhausted);
  struct UserObject *uo4944 = (struct UserObject*)obj4931;
  uo4944->data[3] = (Object)closure4944;
  Method *meth_meth_collectionsPrelude_next4944 = addmethod2pos(obj4931, "next", &meth_collectionsPrelude_next4944, 3);
  int argcv_meth_collectionsPrelude_next4944[] = {0};
  meth_meth_collectionsPrelude_next4944->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next4944);
  meth_meth_collectionsPrelude_next4944->definitionModule = modulename;
  meth_meth_collectionsPrelude_next4944->definitionLine = 1990;
// method "asString"
  struct UserObject *uo4983 = (struct UserObject*)obj4931;
  uo4983->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString4983 = addmethod2pos(obj4931, "asString", &meth_collectionsPrelude_asString4983, 4);
  int argcv_meth_collectionsPrelude_asString4983[] = {0};
  meth_meth_collectionsPrelude_asString4983->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString4983);
  meth_meth_collectionsPrelude_asString4983->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString4983->definitionLine = 1995;
  sourceObject = obj4931;
// Begin line 1988
  setline(1988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe4994 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe4995 = gc_frame_new();
// call case 3: self.outer request
  Object call4996 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4995);
// compiled member node returning call4996 (depth = 3)
  Object call4997 = callmethodflags(call4996, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4994);
// compiled member node returning call4997 (depth = 2)
  adddatum2(obj4931, call4997, 1);
  sourceObject = obj4931;
  sourceObject = obj4931;
  sourceObject = obj4931;
  objclass4931 = obj4931->class;
  objclass4931->definitionModule = modulename;
  objclass4931->definitionLine = 1987;
  (*(struct UserObject *)self).data[0] = lowerouter4931;
  self = oldself4931;
  selfslot = oldselfslot4931;
  stackframe = oldstackframe4931;
  gc_frame_end(frame);
  return obj4931;
}
Object meth_collectionsPrelude_at_40_1_41_4999(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "at(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)");
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1999
  setline(1999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5001 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5003 = gc_frame_new();
// call case 4: self request
  Object call5004 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5003);
// compiled member node returning call5004 (depth = 5)
  int op_slot_right_5002 = gc_frame_newslot(call5004);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_5002 = gc_frame_newslot(*var_ix);
  params[0] = call5004;
  partcv[0] = 1;
  Object opresult5006 = callmethod(*var_ix, "≤(1)", 1, partcv, params);
// compiled op node returning opresult5006 (depth = 4)
  partcv[0] = 0;
  Object call5007 = callmethodflags(opresult5006, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe5001);
// compiled call node returning call5007 (depth = 3)
  Object if5000 = done;
  if (istrue(call5007)) {
// Begin line 2000
  setline(2000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5008 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5010 == NULL) {
    strlit5010 = alloc_String("");
    gc_root(strlit5010);
  }
// compiled string node returning strlit5010 (depth = 5)
  int op_slot_right_5009 = gc_frame_newslot(strlit5010);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5013 = gc_frame_new();
// call case 4: self request
  Object call5014 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5013);
// compiled member node returning call5014 (depth = 6)
  int op_slot_right_5012 = gc_frame_newslot(call5014);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5017 == NULL) {
    strlit5017 = alloc_String(") but upper bound is ");
    gc_root(strlit5017);
  }
// compiled string node returning strlit5017 (depth = 7)
  int op_slot_right_5016 = gc_frame_newslot(strlit5017);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  int op_slot_right_5019 = gc_frame_newslot(*var_ix);
// starting to compile string node (depth = 8)
  if (strlit5021 == NULL) {
    strlit5021 = alloc_String("requested range.at(");
    gc_root(strlit5021);
  }
// compiled string node returning strlit5021 (depth = 8)
  int op_slot_left_5019 = gc_frame_newslot(strlit5021);
  params[0] = *var_ix;
  partcv[0] = 1;
  Object opresult5022 = callmethod(strlit5021, "++(1)", 1, partcv, params);
// compiled op node returning opresult5022 (depth = 7)
  int op_slot_left_5016 = gc_frame_newslot(opresult5022);
  params[0] = strlit5017;
  partcv[0] = 1;
  Object opresult5023 = callmethod(opresult5022, "++(1)", 1, partcv, params);
// compiled op node returning opresult5023 (depth = 6)
  int op_slot_left_5012 = gc_frame_newslot(opresult5023);
  params[0] = call5014;
  partcv[0] = 1;
  Object opresult5024 = callmethod(opresult5023, "++(1)", 1, partcv, params);
// compiled op node returning opresult5024 (depth = 5)
  int op_slot_left_5009 = gc_frame_newslot(opresult5024);
  params[0] = strlit5010;
  partcv[0] = 1;
  Object opresult5025 = callmethod(opresult5024, "++(1)", 1, partcv, params);
// compiled op node returning opresult5025 (depth = 4)
  gc_frame_newslot(opresult5025);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult5025;
  partcv[0] = 1;
  Object call5026 = callmethodflags(*var_BoundsError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5008);
// compiled call node returning call5026 (depth = 3)
    gc_frame_newslot(call5026);
    if5000 = call5026;
  } else {
  }
// compiled if node returning if5000 (depth = 2)
// Begin line 2002
  setline(2002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5028 = gc_frame_new();
// call case 6: other requests
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5030 = alloc_Float64(1);
// compiled num node returning num5030 (depth = 5)
  int op_slot_right_5029 = gc_frame_newslot(num5030);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_5029 = gc_frame_newslot(*var_ix);
  params[0] = num5030;
  partcv[0] = 1;
  Object opresult5032 = callmethod(*var_ix, "≥(1)", 1, partcv, params);
// compiled op node returning opresult5032 (depth = 4)
  partcv[0] = 0;
  Object call5033 = callmethodflags(opresult5032, "prefix!", 1, partcv, params, 0);
  gc_frame_end(callframe5028);
// compiled call node returning call5033 (depth = 3)
  Object if5027 = done;
  if (istrue(call5033)) {
// Begin line 2003
  setline(2003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5034 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5036 == NULL) {
    strlit5036 = alloc_String(") but lower bound is 1");
    gc_root(strlit5036);
  }
// compiled string node returning strlit5036 (depth = 5)
  int op_slot_right_5035 = gc_frame_newslot(strlit5036);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  int op_slot_right_5038 = gc_frame_newslot(*var_ix);
// starting to compile string node (depth = 6)
  if (strlit5040 == NULL) {
    strlit5040 = alloc_String("requested range.at(");
    gc_root(strlit5040);
  }
// compiled string node returning strlit5040 (depth = 6)
  int op_slot_left_5038 = gc_frame_newslot(strlit5040);
  params[0] = *var_ix;
  partcv[0] = 1;
  Object opresult5041 = callmethod(strlit5040, "++(1)", 1, partcv, params);
// compiled op node returning opresult5041 (depth = 5)
  int op_slot_left_5035 = gc_frame_newslot(opresult5041);
  params[0] = strlit5036;
  partcv[0] = 1;
  Object opresult5042 = callmethod(opresult5041, "++(1)", 1, partcv, params);
// compiled op node returning opresult5042 (depth = 4)
  gc_frame_newslot(opresult5042);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult5042;
  partcv[0] = 1;
  Object call5043 = callmethodflags(*var_BoundsError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5034);
// compiled call node returning call5043 (depth = 3)
    gc_frame_newslot(call5043);
    if5027 = call5043;
  } else {
  }
// compiled if node returning if5027 (depth = 2)
// Begin line 2005
  setline(2005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5046 = alloc_Float64(1);
// compiled num node returning num5046 (depth = 5)
  int op_slot_right_5045 = gc_frame_newslot(num5046);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_5045 = gc_frame_newslot(*var_ix);
  params[0] = num5046;
  partcv[0] = 1;
  Object diff5048 = callmethod(*var_ix, "-(1)", 1, partcv, params);
// compiled op node returning diff5048 (depth = 4)
  int op_slot_right_5044 = gc_frame_newslot(diff5048);
// starting to compile member node (depth = 4)
  int callframe5050 = gc_frame_new();
// call case 4: self request
  Object call5051 = callmethodflags(self, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5050);
// compiled member node returning call5051 (depth = 4)
  int op_slot_left_5044 = gc_frame_newslot(call5051);
  params[0] = diff5048;
  partcv[0] = 1;
  Object diff5052 = callmethod(call5051, "-(1)", 1, partcv, params);
// compiled op node returning diff5052 (depth = 3)
  return diff5052;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply5056(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_elem = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_intElem = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "intElem");
// Begin line 2009
  setline(2009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5057 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elem (depth = 6)
  Object call5058 = callmethodflags(*var_elem, "truncated", 0, partcv, params, 0);
  gc_frame_end(callframe5057);
// compiled member node returning call5058 (depth = 5)
  *var_intElem = call5058;
  if (call5058 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 4)
// Begin line 2010
  setline(2010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elem (depth = 6)
  int op_slot_right_5060 = gc_frame_newslot(*var_elem);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_5060 = gc_frame_newslot(*var_intElem);
  params[0] = *var_elem;
  partcv[0] = 1;
  Object opresult5062 = callmethod(*var_intElem, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5062 (depth = 5)
  Object if5059 = done;
  if (istrue(opresult5062)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool5063 = alloc_Boolean(0);
// compiled identifier node returning bool5063 (depth = 6)
  block_return(realself, bool5063);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if5059 = undefined;
  } else {
  }
// compiled if node returning if5059 (depth = 4)
// Begin line 2011
  setline(2011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5066 = gc_frame_new();
// call case 4: self request
  Object call5067 = callmethodflags(self, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5066);
// compiled member node returning call5067 (depth = 6)
  int op_slot_right_5065 = gc_frame_newslot(call5067);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_5065 = gc_frame_newslot(*var_intElem);
  params[0] = call5067;
  partcv[0] = 1;
  Object opresult5069 = callmethod(*var_intElem, ">(1)", 1, partcv, params);
// compiled op node returning opresult5069 (depth = 5)
  Object if5064 = done;
  if (istrue(opresult5069)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool5070 = alloc_Boolean(0);
// compiled identifier node returning bool5070 (depth = 6)
  block_return(realself, bool5070);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if5064 = undefined;
  } else {
  }
// compiled if node returning if5064 (depth = 4)
// Begin line 2012
  setline(2012);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5073 = gc_frame_new();
// call case 4: self request
  Object call5074 = callmethodflags(self, "stop", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5073);
// compiled member node returning call5074 (depth = 6)
  int op_slot_right_5072 = gc_frame_newslot(call5074);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_5072 = gc_frame_newslot(*var_intElem);
  params[0] = call5074;
  partcv[0] = 1;
  Object opresult5076 = callmethod(*var_intElem, "<(1)", 1, partcv, params);
// compiled op node returning opresult5076 (depth = 5)
  Object if5071 = done;
  if (istrue(opresult5076)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool5077 = alloc_Boolean(0);
// compiled identifier node returning bool5077 (depth = 6)
  block_return(realself, bool5077);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if5071 = undefined;
  } else {
  }
// compiled if node returning if5071 (depth = 4)
  gc_frame_end(frame);
  return if5071;
}
Object meth_collectionsPrelude__apply_40_1_41_5080(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ex = &(stackframe->slots[0]);
  *var_ex = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool5081 = alloc_Boolean(0);
// compiled identifier node returning bool5081 (depth = 5)
  block_return(realself, bool5081);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_contains_40_1_41_5053(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "contains(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains(_)");
  Object params[2];
  int partcv[1];
  Object *var__prelude = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elem = &(stackframe->slots[0]);
  *var_elem = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part contains(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2008
  setline(2008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile trycatch node (depth = 2)
// starting to compile block node (depth = 3)
  Object block5055 = alloc_Block(NULL, NULL, "collectionsPrelude", 2008);
  gc_frame_newslot(block5055);
// method "_apply"
  block_savedest(block5055);
  Object closure5056 = createclosure(2, "_apply");
  setclosureframe(closure5056, stackframe);
  addtoclosure(closure5056, var_elem);
  addtoclosure(closure5056, selfslot);
  struct UserObject *uo5056 = (struct UserObject*)block5055;
  uo5056->data[0] = (Object)closure5056;
  Method *meth_meth_collectionsPrelude__apply5056 = addmethod2pos(block5055, "_apply", &meth_collectionsPrelude__apply5056, 0);
  int argcv_meth_collectionsPrelude__apply5056[] = {0};
  meth_meth_collectionsPrelude__apply5056->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5056);
  meth_meth_collectionsPrelude__apply5056->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5056->definitionLine = 1963;
// compiled block node returning block5055 (depth = 3)
  int frame5054 = gc_frame_new();
  gc_frame_newslot(block5055);
// Begin line 2013
  setline(2013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5079 = alloc_Block(NULL, NULL, "collectionsPrelude", 2013);
  gc_frame_newslot(block5079);
// method "_apply(_)"
  block_savedest(block5079);
  Object closure5080 = createclosure(1, "_apply(1)");
  setclosureframe(closure5080, stackframe);
  addtoclosure(closure5080, selfslot);
  struct UserObject *uo5080 = (struct UserObject*)block5079;
  uo5080->data[0] = (Object)closure5080;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_5080 = addmethod2pos(block5079, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_5080, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_5080[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_5080->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_5080);
  meth_meth_collectionsPrelude__apply_40_1_41_5080->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_5080->definitionLine = 1963;
// starting to compile call node (depth = 4)
  int callframe5083 = gc_frame_new();
// Begin line 1912
  setline(1912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5084 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5085 == NULL) {
    strlit5085 = alloc_String("ex");
    gc_root(strlit5085);
  }
// compiled string node returning strlit5085 (depth = 6)
  gc_frame_newslot(strlit5085);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5086 = gc_frame_new();
// call case 5: prelude request
  Object call5087 = callmethodflags(prelude, "VariablePattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5086);
// compiled member node returning call5087 (depth = 6)
  params[0] = strlit5085;
  partcv[0] = 1;
  Object call5088 = callmethodflags(call5087, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5084);
// compiled call node returning call5088 (depth = 5)
  gc_frame_newslot(call5088);
// Begin line 2013
  setline(2013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5089 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var__prelude (depth = 6)
  Object call5090 = callmethodflags(*var__prelude, "Exception", 0, partcv, params, 0);
  gc_frame_end(callframe5089);
// compiled member node returning call5090 (depth = 5)
  gc_frame_newslot(call5090);
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5091 = gc_frame_new();
// call case 5: prelude request
  Object call5092 = callmethodflags(prelude, "AndPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5091);
// compiled member node returning call5092 (depth = 5)
  params[0] = call5088;
  params[1] = call5090;
  partcv[0] = 2;
  Object call5093 = callmethodflags(call5092, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5083);
// compiled call node returning call5093 (depth = 4)
((struct UserObject *)block5079)->data[1] = call5093;
// compiled block node returning block5079 (depth = 3)
  gc_frame_newslot(block5079);
  params[0] = block5079;
  setline(2008);
  Object catchres5054 = tryCatch(block5055, params, 1,NULL);
  gc_frame_end(frame5054);
// compiled trycatch node returning catchres5054 (depth = 2)
// Begin line 2014
  setline(2014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool5094 = alloc_Boolean(1);
// compiled identifier node returning bool5094 (depth = 3)
  return bool5094;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply5100(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5102 = gc_frame_new();
// call case 4: self request
  Object call5103 = callmethodflags(self, "stop", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5102);
// compiled member node returning call5103 (depth = 5)
  int op_slot_right_5101 = gc_frame_newslot(call5103);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  int op_slot_left_5101 = gc_frame_newslot(*var_val);
  params[0] = call5103;
  partcv[0] = 1;
  Object opresult5105 = callmethod(*var_val, "≥(1)", 1, partcv, params);
// compiled op node returning opresult5105 (depth = 4)
  gc_frame_end(frame);
  return opresult5105;
}
Object meth_collectionsPrelude__apply5108(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object *var_block1 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2019
  setline(2019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5109 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block1 (depth = 5)
  params[0] = *var_val;
  partcv[0] = 1;
  Object call5110 = callmethodflags(*var_block1, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5109);
// compiled call node returning call5110 (depth = 4)
// Begin line 2020
  setline(2020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num5112 = alloc_Float64(1);
// compiled num node returning num5112 (depth = 6)
  int op_slot_right_5111 = gc_frame_newslot(num5112);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_val (depth = 6)
  int op_slot_left_5111 = gc_frame_newslot(*var_val);
  params[0] = num5112;
  partcv[0] = 1;
  Object diff5114 = callmethod(*var_val, "-(1)", 1, partcv, params);
// compiled op node returning diff5114 (depth = 5)
  *var_val = diff5114;
  if (diff5114 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_do_40_1_41_5095(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_val = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "val");
// Begin line 2017
  setline(2017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5096 = gc_frame_new();
// call case 4: self request
  Object call5097 = callmethodflags(self, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5096);
// compiled member node returning call5097 (depth = 3)
  *var_val = call5097;
  if (call5097 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2018
  setline(2018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5098 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block5099 = alloc_Block(NULL, NULL, "collectionsPrelude", 2018);
  gc_frame_newslot(block5099);
// method "_apply"
  block_savedest(block5099);
  Object closure5100 = createclosure(2, "_apply");
  setclosureframe(closure5100, stackframe);
  addtoclosure(closure5100, var_val);
  addtoclosure(closure5100, selfslot);
  struct UserObject *uo5100 = (struct UserObject*)block5099;
  uo5100->data[0] = (Object)closure5100;
  Method *meth_meth_collectionsPrelude__apply5100 = addmethod2pos(block5099, "_apply", &meth_collectionsPrelude__apply5100, 0);
  int argcv_meth_collectionsPrelude__apply5100[] = {0};
  meth_meth_collectionsPrelude__apply5100->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5100);
  meth_meth_collectionsPrelude__apply5100->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5100->definitionLine = 1963;
// compiled block node returning block5099 (depth = 3)
  gc_frame_newslot(block5099);
// starting to compile block node (depth = 3)
  Object block5107 = alloc_Block(NULL, NULL, "collectionsPrelude", 2018);
  gc_frame_newslot(block5107);
// method "_apply"
  block_savedest(block5107);
  Object closure5108 = createclosure(3, "_apply");
  setclosureframe(closure5108, stackframe);
  addtoclosure(closure5108, var_val);
  addtoclosure(closure5108, var_block1);
  addtoclosure(closure5108, selfslot);
  struct UserObject *uo5108 = (struct UserObject*)block5107;
  uo5108->data[0] = (Object)closure5108;
  Method *meth_meth_collectionsPrelude__apply5108 = addmethod2pos(block5107, "_apply", &meth_collectionsPrelude__apply5108, 0);
  int argcv_meth_collectionsPrelude__apply5108[] = {0};
  meth_meth_collectionsPrelude__apply5108->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5108);
  meth_meth_collectionsPrelude__apply5108->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5108->definitionLine = 1963;
// compiled block node returning block5107 (depth = 3)
  gc_frame_newslot(block5107);
// call case 5: prelude request
  params[0] = block5099;
  params[1] = block5107;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5117 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5098);
// compiled call node returning call5117 (depth = 2)
  gc_frame_end(frame);
  return call5117;
}
Object meth_collectionsPrelude__apply5124(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
  int callframe5126 = gc_frame_new();
// call case 4: self request
  Object call5127 = callmethodflags(self, "stop", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5126);
// compiled member node returning call5127 (depth = 5)
  int op_slot_right_5125 = gc_frame_newslot(call5127);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  int op_slot_left_5125 = gc_frame_newslot(*var_val);
  params[0] = call5127;
  partcv[0] = 1;
  Object opresult5129 = callmethod(*var_val, "≥(1)", 1, partcv, params);
// compiled op node returning opresult5129 (depth = 4)
  gc_frame_end(frame);
  return opresult5129;
}
Object meth_collectionsPrelude__apply5132(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_key = getfromclosure(closure, 0);
  Object *var_val = getfromclosure(closure, 1);
  Object *var_block2 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2027
  setline(2027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5133 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_key (depth = 5)
  gc_frame_newslot(*var_key);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block2 (depth = 5)
  params[0] = *var_key;
  params[1] = *var_val;
  partcv[0] = 2;
  Object call5134 = callmethodflags(*var_block2, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5133);
// compiled call node returning call5134 (depth = 4)
// Begin line 2028
  setline(2028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num5136 = alloc_Float64(1);
// compiled num node returning num5136 (depth = 6)
  int op_slot_right_5135 = gc_frame_newslot(num5136);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_key (depth = 6)
  int op_slot_left_5135 = gc_frame_newslot(*var_key);
  params[0] = num5136;
  partcv[0] = 1;
  Object sum5138 = callmethod(*var_key, "+(1)", 1, partcv, params);
// compiled op node returning sum5138 (depth = 5)
  *var_key = sum5138;
  if (sum5138 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
// Begin line 2029
  setline(2029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num5141 = alloc_Float64(1);
// compiled num node returning num5141 (depth = 6)
  int op_slot_right_5140 = gc_frame_newslot(num5141);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_val (depth = 6)
  int op_slot_left_5140 = gc_frame_newslot(*var_val);
  params[0] = num5141;
  partcv[0] = 1;
  Object diff5143 = callmethod(*var_val, "-(1)", 1, partcv, params);
// compiled op node returning diff5143 (depth = 5)
  *var_val = diff5143;
  if (diff5143 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_keysAndValuesDo_40_1_41_5118(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keysAndValuesDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysAndValuesDo(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysAndValuesDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part keysAndValuesDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_key = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "key");
  Object *var_val = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "val");
// Begin line 2024
  setline(2024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num5119 = alloc_Float64(1);
// compiled num node returning num5119 (depth = 3)
  *var_key = num5119;
  if (num5119 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2025
  setline(2025);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5120 = gc_frame_new();
// call case 4: self request
  Object call5121 = callmethodflags(self, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5120);
// compiled member node returning call5121 (depth = 3)
  *var_val = call5121;
  if (call5121 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2026
  setline(2026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5122 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block5123 = alloc_Block(NULL, NULL, "collectionsPrelude", 2026);
  gc_frame_newslot(block5123);
// method "_apply"
  block_savedest(block5123);
  Object closure5124 = createclosure(2, "_apply");
  setclosureframe(closure5124, stackframe);
  addtoclosure(closure5124, var_val);
  addtoclosure(closure5124, selfslot);
  struct UserObject *uo5124 = (struct UserObject*)block5123;
  uo5124->data[0] = (Object)closure5124;
  Method *meth_meth_collectionsPrelude__apply5124 = addmethod2pos(block5123, "_apply", &meth_collectionsPrelude__apply5124, 0);
  int argcv_meth_collectionsPrelude__apply5124[] = {0};
  meth_meth_collectionsPrelude__apply5124->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5124);
  meth_meth_collectionsPrelude__apply5124->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5124->definitionLine = 1963;
// compiled block node returning block5123 (depth = 3)
  gc_frame_newslot(block5123);
// starting to compile block node (depth = 3)
  Object block5131 = alloc_Block(NULL, NULL, "collectionsPrelude", 2026);
  gc_frame_newslot(block5131);
// method "_apply"
  block_savedest(block5131);
  Object closure5132 = createclosure(4, "_apply");
  setclosureframe(closure5132, stackframe);
  addtoclosure(closure5132, var_key);
  addtoclosure(closure5132, var_val);
  addtoclosure(closure5132, var_block2);
  addtoclosure(closure5132, selfslot);
  struct UserObject *uo5132 = (struct UserObject*)block5131;
  uo5132->data[0] = (Object)closure5132;
  Method *meth_meth_collectionsPrelude__apply5132 = addmethod2pos(block5131, "_apply", &meth_collectionsPrelude__apply5132, 0);
  int argcv_meth_collectionsPrelude__apply5132[] = {0};
  meth_meth_collectionsPrelude__apply5132->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5132);
  meth_meth_collectionsPrelude__apply5132->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5132->definitionLine = 1963;
// compiled block node returning block5131 (depth = 3)
  gc_frame_newslot(block5131);
// call case 5: prelude request
  params[0] = block5123;
  params[1] = block5131;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5146 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5122);
// compiled call node returning call5146 (depth = 2)
  gc_frame_end(frame);
  return call5146;
}
Object meth_collectionsPrelude_reversed5147(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "reversed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_lower = getfromclosure(closure, 0);
  Object *var_upper = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2033
  setline(2033);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5148 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  gc_frame_newslot(*var_upper);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5149 = gc_frame_new();
// call case 3: self.outer request
  Object call5150 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5149);
// compiled member node returning call5150 (depth = 3)
  params[0] = *var_lower;
  params[1] = *var_upper;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5151 = callmethodflags(call5150, "from(1)to(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5148);
// compiled call node returning call5151 (depth = 2)
  gc_frame_end(frame);
  return call5151;
}
Object meth_collectionsPrelude__43__43__40_1_41_5152(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ++(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2036
  setline(2036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5153 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe5154 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5155 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5156 = gc_frame_new();
// call case 3: self.outer request
  Object call5157 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5156);
// compiled member node returning call5157 (depth = 5)
  Object call5158 = callmethodflags(call5157, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5155);
// compiled member node returning call5158 (depth = 4)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 2;
  Object call5159 = callmethodflags(call5158, "lazyConcatenation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5154);
// compiled call node returning call5159 (depth = 3)
  gc_frame_newslot(call5159);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5160 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5161 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5162 = gc_frame_new();
// call case 3: self.outer request
  Object call5163 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5162);
// compiled member node returning call5163 (depth = 5)
  Object call5164 = callmethodflags(call5163, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5161);
// compiled member node returning call5164 (depth = 4)
  Object call5165 = callmethodflags(call5164, "sequence", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5160);
// compiled member node returning call5165 (depth = 3)
  params[0] = call5159;
  partcv[0] = 1;
  Object call5166 = callmethodflags(call5165, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5153);
// compiled call node returning call5166 (depth = 2)
  gc_frame_end(frame);
  return call5166;
}
Object meth_collectionsPrelude__61__61__40_1_41_5167(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2039
  setline(2039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5168 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5169 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5170 = gc_frame_new();
// call case 3: self.outer request
  Object call5171 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5170);
// compiled member node returning call5171 (depth = 4)
  Object call5172 = callmethodflags(call5171, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5169);
// compiled member node returning call5172 (depth = 3)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5173 = callmethodflags(call5172, "isEqual(1)toIterable(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5168);
// compiled call node returning call5173 (depth = 2)
  gc_frame_end(frame);
  return call5173;
}
Object meth_collectionsPrelude_sorted5174(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2041
  setline(2041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe5175 = gc_frame_new();
// call case 4: self request
  Object call5176 = callmethodflags(self, "reversed", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5175);
// compiled member node returning call5176 (depth = 2)
  gc_frame_end(frame);
  return call5176;
}
Object meth_collectionsPrelude_sortedBy_40_1_41_5177(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortedBy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortedBy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sortedBy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2043
  setline(2043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5178 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
  gc_frame_newslot(*var_c);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5179 = gc_frame_new();
// call case 4: self request
  Object call5180 = callmethodflags(self, "asList", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5179);
// compiled member node returning call5180 (depth = 3)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call5181 = callmethodflags(call5180, "sortBy(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5178);
// compiled call node returning call5181 (depth = 2)
  gc_frame_end(frame);
  return call5181;
}
Object meth_collectionsPrelude_keys5182(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2045
  setline(2045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
  int callframe5184 = gc_frame_new();
// call case 4: self request
  Object call5185 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5184);
// compiled member node returning call5185 (depth = 3)
  int op_slot_right_5183 = gc_frame_newslot(call5185);
// starting to compile num node (depth = 3)
  Object num5187 = alloc_Float64(1);
// compiled num node returning num5187 (depth = 3)
  int op_slot_left_5183 = gc_frame_newslot(num5187);
  params[0] = call5185;
  partcv[0] = 1;
  Object opresult5188 = callmethod(num5187, "..(1)", 1, partcv, params);
// compiled op node returning opresult5188 (depth = 2)
  gc_frame_end(frame);
  return opresult5188;
}
Object meth_collectionsPrelude_values5189(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2047
  setline(2047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_asString5190(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lower = getfromclosure(closure, 0);
  Object *var_upper = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2050
  setline(2050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit5192 == NULL) {
    strlit5192 = alloc_String("");
    gc_root(strlit5192);
  }
// compiled string node returning strlit5192 (depth = 3)
  int op_slot_right_5191 = gc_frame_newslot(strlit5192);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  int op_slot_right_5194 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5197 == NULL) {
    strlit5197 = alloc_String(" downTo ");
    gc_root(strlit5197);
  }
// compiled string node returning strlit5197 (depth = 5)
  int op_slot_right_5196 = gc_frame_newslot(strlit5197);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_right_5199 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 6)
  if (strlit5201 == NULL) {
    strlit5201 = alloc_String("range.from ");
    gc_root(strlit5201);
  }
// compiled string node returning strlit5201 (depth = 6)
  int op_slot_left_5199 = gc_frame_newslot(strlit5201);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5202 = callmethod(strlit5201, "++(1)", 1, partcv, params);
// compiled op node returning opresult5202 (depth = 5)
  int op_slot_left_5196 = gc_frame_newslot(opresult5202);
  params[0] = strlit5197;
  partcv[0] = 1;
  Object opresult5203 = callmethod(opresult5202, "++(1)", 1, partcv, params);
// compiled op node returning opresult5203 (depth = 4)
  int op_slot_left_5194 = gc_frame_newslot(opresult5203);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5204 = callmethod(opresult5203, "++(1)", 1, partcv, params);
// compiled op node returning opresult5204 (depth = 3)
  int op_slot_left_5191 = gc_frame_newslot(opresult5204);
  params[0] = strlit5192;
  partcv[0] = 1;
  Object opresult5205 = callmethod(opresult5204, "++(1)", 1, partcv, params);
// compiled op node returning opresult5205 (depth = 2)
  gc_frame_end(frame);
  return opresult5205;
}
Object meth_collectionsPrelude_asSequence5206(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asSequence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2053
  setline(2053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply_40_1_41_5211(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___24 = &(stackframe->slots[0]);
  *var___24 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply_40_1_41_5223(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_lower = getfromclosure(closure, 0);
  Object *var_upper = getfromclosure(closure, 1);
  Object *var_RequestError = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___25 = &(stackframe->slots[0]);
  *var___25 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe5224 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 1969
  setline(1969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5227 == NULL) {
    strlit5227 = alloc_String(") is not an integer");
    gc_root(strlit5227);
  }
// compiled string node returning strlit5227 (depth = 7)
  int op_slot_right_5226 = gc_frame_newslot(strlit5227);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lower (depth = 8)
  int op_slot_right_5229 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5232 == NULL) {
    strlit5232 = alloc_String(")downTo(");
    gc_root(strlit5232);
  }
// compiled string node returning strlit5232 (depth = 9)
  int op_slot_right_5231 = gc_frame_newslot(strlit5232);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_upper (depth = 10)
  int op_slot_right_5234 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 10)
  if (strlit5236 == NULL) {
    strlit5236 = alloc_String(" in range.from(");
    gc_root(strlit5236);
  }
// compiled string node returning strlit5236 (depth = 10)
  int op_slot_left_5234 = gc_frame_newslot(strlit5236);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5237 = callmethod(strlit5236, "++(1)", 1, partcv, params);
// compiled op node returning opresult5237 (depth = 9)
  int op_slot_left_5231 = gc_frame_newslot(opresult5237);
  params[0] = strlit5232;
  partcv[0] = 1;
  Object opresult5238 = callmethod(opresult5237, "++(1)", 1, partcv, params);
// compiled op node returning opresult5238 (depth = 8)
  int op_slot_left_5229 = gc_frame_newslot(opresult5238);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5239 = callmethod(opresult5238, "++(1)", 1, partcv, params);
// compiled op node returning opresult5239 (depth = 7)
  int op_slot_left_5226 = gc_frame_newslot(opresult5239);
  params[0] = strlit5227;
  partcv[0] = 1;
  Object opresult5240 = callmethod(opresult5239, "++(1)", 1, partcv, params);
// compiled op node returning opresult5240 (depth = 6)
  int op_slot_right_5225 = gc_frame_newslot(opresult5240);
// Begin line 1968
  setline(1968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5243 == NULL) {
    strlit5243 = alloc_String("");
    gc_root(strlit5243);
  }
// compiled string node returning strlit5243 (depth = 7)
  int op_slot_right_5242 = gc_frame_newslot(strlit5243);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_upper (depth = 8)
  int op_slot_right_5245 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 8)
  if (strlit5247 == NULL) {
    strlit5247 = alloc_String("upper bound ");
    gc_root(strlit5247);
  }
// compiled string node returning strlit5247 (depth = 8)
  int op_slot_left_5245 = gc_frame_newslot(strlit5247);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5248 = callmethod(strlit5247, "++(1)", 1, partcv, params);
// compiled op node returning opresult5248 (depth = 7)
  int op_slot_left_5242 = gc_frame_newslot(opresult5248);
  params[0] = strlit5243;
  partcv[0] = 1;
  Object opresult5249 = callmethod(opresult5248, "++(1)", 1, partcv, params);
// compiled op node returning opresult5249 (depth = 6)
  int op_slot_left_5225 = gc_frame_newslot(opresult5249);
  params[0] = opresult5240;
  partcv[0] = 1;
  Object opresult5250 = callmethod(opresult5249, "++(1)", 1, partcv, params);
// compiled op node returning opresult5250 (depth = 5)
  gc_frame_newslot(opresult5250);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_RequestError (depth = 5)
  params[0] = opresult5250;
  partcv[0] = 1;
  Object call5251 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5224);
// compiled call node returning call5251 (depth = 4)
  gc_frame_end(frame);
  return call5251;
}
Object meth_collectionsPrelude__apply_40_1_41_5291(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___26 = &(stackframe->slots[0]);
  *var___26 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply_40_1_41_5303(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_lower = getfromclosure(closure, 0);
  Object *var_upper = getfromclosure(closure, 1);
  Object *var_RequestError = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___27 = &(stackframe->slots[0]);
  *var___27 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe5304 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 1978
  setline(1978);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5307 == NULL) {
    strlit5307 = alloc_String(") is not an integer");
    gc_root(strlit5307);
  }
// compiled string node returning strlit5307 (depth = 7)
  int op_slot_right_5306 = gc_frame_newslot(strlit5307);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lower (depth = 8)
  int op_slot_right_5309 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5312 == NULL) {
    strlit5312 = alloc_String(")downTo(");
    gc_root(strlit5312);
  }
// compiled string node returning strlit5312 (depth = 9)
  int op_slot_right_5311 = gc_frame_newslot(strlit5312);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_upper (depth = 10)
  int op_slot_right_5314 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 10)
  if (strlit5316 == NULL) {
    strlit5316 = alloc_String(" in range.from(");
    gc_root(strlit5316);
  }
// compiled string node returning strlit5316 (depth = 10)
  int op_slot_left_5314 = gc_frame_newslot(strlit5316);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5317 = callmethod(strlit5316, "++(1)", 1, partcv, params);
// compiled op node returning opresult5317 (depth = 9)
  int op_slot_left_5311 = gc_frame_newslot(opresult5317);
  params[0] = strlit5312;
  partcv[0] = 1;
  Object opresult5318 = callmethod(opresult5317, "++(1)", 1, partcv, params);
// compiled op node returning opresult5318 (depth = 8)
  int op_slot_left_5309 = gc_frame_newslot(opresult5318);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5319 = callmethod(opresult5318, "++(1)", 1, partcv, params);
// compiled op node returning opresult5319 (depth = 7)
  int op_slot_left_5306 = gc_frame_newslot(opresult5319);
  params[0] = strlit5307;
  partcv[0] = 1;
  Object opresult5320 = callmethod(opresult5319, "++(1)", 1, partcv, params);
// compiled op node returning opresult5320 (depth = 6)
  int op_slot_right_5305 = gc_frame_newslot(opresult5320);
// Begin line 1977
  setline(1977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5323 == NULL) {
    strlit5323 = alloc_String("");
    gc_root(strlit5323);
  }
// compiled string node returning strlit5323 (depth = 7)
  int op_slot_right_5322 = gc_frame_newslot(strlit5323);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lower (depth = 8)
  int op_slot_right_5325 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 8)
  if (strlit5327 == NULL) {
    strlit5327 = alloc_String("lower bound ");
    gc_root(strlit5327);
  }
// compiled string node returning strlit5327 (depth = 8)
  int op_slot_left_5325 = gc_frame_newslot(strlit5327);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5328 = callmethod(strlit5327, "++(1)", 1, partcv, params);
// compiled op node returning opresult5328 (depth = 7)
  int op_slot_left_5322 = gc_frame_newslot(opresult5328);
  params[0] = strlit5323;
  partcv[0] = 1;
  Object opresult5329 = callmethod(opresult5328, "++(1)", 1, partcv, params);
// compiled op node returning opresult5329 (depth = 6)
  int op_slot_left_5305 = gc_frame_newslot(opresult5329);
  params[0] = opresult5320;
  partcv[0] = 1;
  Object opresult5330 = callmethod(opresult5329, "++(1)", 1, partcv, params);
// compiled op node returning opresult5330 (depth = 5)
  gc_frame_newslot(opresult5330);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_RequestError (depth = 5)
  params[0] = opresult5330;
  partcv[0] = 1;
  Object call5331 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5304);
// compiled call node returning call5331 (depth = 4)
  gc_frame_end(frame);
  return call5331;
}
Object meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_4924(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "from(1)downTo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method from(_)downTo(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method from(_)downTo(_)");
  Object params[2];
  int partcv[2];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  Object *var__prelude = getfromclosure(closure, 2);
  Object *var_indexable = getfromclosure(closure, 3);
  Object *var_Number = getfromclosure(closure, 4);
  Object *var_RequestError = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for from(_)downTo(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_upper = &(stackframe->slots[0]);
  *var_upper = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *var_lower = &(stackframe->slots[1]);
  *var_lower = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part downTo(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4925 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4925 = alloc_userobj2(22,23, objclass4925);
  gc_frame_newslot(obj4925);
if (objclass4925 == NULL) {
  glfree(obj4925->class->name);
  obj4925->class->name = "range.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4925, self, 0);
  addmethodreal(obj4925,"outer", &reader_collectionsPrelude_outer_4926);
  Object oldself4925 = self;
  struct StackFrameObject *oldstackframe4925 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4925);
  gc_frame_newslot((Object)stackframe);
  self = obj4925;
  Object *oldselfslot4925 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4925 = (*(struct UserObject *)self).data[0], lowerouter4925 = thisouter4925;
  if (inheritingObject4925) {
    struct UserObject *inho4925 = (struct UserObject *)inheritingObject4925;
    while (inho4925->super != GraceDefaultObject) inho4925 = (struct UserObject *)inho4925->super;
    inho4925->super = obj4925;
    self = inheritingObject4925;
    *selfslot = self;
    lowerouter4925 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4925;
  }
if (objclass4925 == NULL) {
  Method *reader4927 = addmethodrealflags(obj4925, "start",&reader_collectionsPrelude_start_4927, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4927->definitionModule = modulename;
  reader4927->definitionLine = 1970;
}
adddatum2(obj4925, alloc_Undefined(), 1);
if (objclass4925 == NULL) {
  Method *reader4928 = addmethodrealflags(obj4925, "stop",&reader_collectionsPrelude_stop_4928, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4928->definitionModule = modulename;
  reader4928->definitionLine = 1979;
}
adddatum2(obj4925, alloc_Undefined(), 2);
if (objclass4925 == NULL) {
  Method *reader4929 = addmethodrealflags(obj4925, "size",&reader_collectionsPrelude_size_4929, MFLAG_DEF);
  reader4929->definitionModule = modulename;
  reader4929->definitionLine = 1984;
}
adddatum2(obj4925, alloc_Undefined(), 3);
// method "iterator"
  block_savedest(obj4925);
  Object closure4930 = createclosure(1, "iterator");
  setclosureframe(closure4930, stackframe);
  addtoclosure(closure4930, var_IteratorExhausted);
  struct UserObject *uo4930 = (struct UserObject*)obj4925;
  uo4930->data[4] = (Object)closure4930;
  Method *meth_meth_collectionsPrelude_iterator4930 = addmethod2pos(obj4925, "iterator", &meth_collectionsPrelude_iterator4930, 4);
  int argcv_meth_collectionsPrelude_iterator4930[] = {0};
  meth_meth_collectionsPrelude_iterator4930->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator4930);
  meth_meth_collectionsPrelude_iterator4930->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4930->definitionLine = 1986;
  block_savedest(obj4925);
  Object closure4998 = createclosure(1, "iterator$object(1)");
  setclosureframe(closure4998, stackframe);
  addtoclosure(closure4998, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_iterator4930_object = addmethod2pos(obj4925, "iterator$object(1)", &meth_collectionsPrelude_iterator4930_object, 4);
  meth_meth_collectionsPrelude_iterator4930_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4930_object->definitionLine = 1986;
// method "at(_)"
  block_savedest(obj4925);
  Object closure4999 = createclosure(1, "at(1)");
  setclosureframe(closure4999, stackframe);
  addtoclosure(closure4999, var_BoundsError);
  struct UserObject *uo4999 = (struct UserObject*)obj4925;
  uo4999->data[5] = (Object)closure4999;
  Method *meth_meth_collectionsPrelude_at_40_1_41_4999 = addmethod2pos(obj4925, "at(1)", &meth_collectionsPrelude_at_40_1_41_4999, 5);
  int argcv_meth_collectionsPrelude_at_40_1_41_4999[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_4999->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_4999);
meth_meth_collectionsPrelude_at_40_1_41_4999->type->types[0] = type_Number;
meth_meth_collectionsPrelude_at_40_1_41_4999->type->names[0] = "ix";
  meth_meth_collectionsPrelude_at_40_1_41_4999->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_4999->definitionLine = 1998;
// method "contains(_)"
  block_savedest(obj4925);
  Object closure5053 = createclosure(1, "contains(1)");
  setclosureframe(closure5053, stackframe);
  addtoclosure(closure5053, var__prelude);
  struct UserObject *uo5053 = (struct UserObject*)obj4925;
  uo5053->data[6] = (Object)closure5053;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_5053 = addmethod2pos(obj4925, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_5053, 6);
  int argcv_meth_collectionsPrelude_contains_40_1_41_5053[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_5053->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_5053);
  meth_meth_collectionsPrelude_contains_40_1_41_5053->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_5053->definitionLine = 2007;
// method "do(_)"
  struct UserObject *uo5095 = (struct UserObject*)obj4925;
  uo5095->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_5095 = addmethod2pos(obj4925, "do(1)", &meth_collectionsPrelude_do_40_1_41_5095, 7);
  int argcv_meth_collectionsPrelude_do_40_1_41_5095[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_5095->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_5095);
  meth_meth_collectionsPrelude_do_40_1_41_5095->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_5095->definitionLine = 2016;
// method "keysAndValuesDo(_)"
  struct UserObject *uo5118 = (struct UserObject*)obj4925;
  uo5118->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5118 = addmethod2pos(obj4925, "keysAndValuesDo(1)", &meth_collectionsPrelude_keysAndValuesDo_40_1_41_5118, 8);
  int argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5118[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5118->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5118);
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5118->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5118->definitionLine = 2023;
// method "reversed"
  block_savedest(obj4925);
  Object closure5147 = createclosure(2, "reversed");
  setclosureframe(closure5147, stackframe);
  addtoclosure(closure5147, var_lower);
  addtoclosure(closure5147, var_upper);
  struct UserObject *uo5147 = (struct UserObject*)obj4925;
  uo5147->data[9] = (Object)closure5147;
  Method *meth_meth_collectionsPrelude_reversed5147 = addmethod2pos(obj4925, "reversed", &meth_collectionsPrelude_reversed5147, 9);
  int argcv_meth_collectionsPrelude_reversed5147[] = {0};
  meth_meth_collectionsPrelude_reversed5147->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed5147);
  meth_meth_collectionsPrelude_reversed5147->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed5147->definitionLine = 2032;
// method "++(_)"
  struct UserObject *uo5152 = (struct UserObject*)obj4925;
  uo5152->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_5152 = addmethod2pos(obj4925, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_5152, 10);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_5152[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_5152->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_5152);
  meth_meth_collectionsPrelude__43__43__40_1_41_5152->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_5152->definitionLine = 2035;
// method "==(_)"
  struct UserObject *uo5167 = (struct UserObject*)obj4925;
  uo5167->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_5167 = addmethod2pos(obj4925, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_5167, 11);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_5167[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_5167->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_5167);
  meth_meth_collectionsPrelude__61__61__40_1_41_5167->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_5167->definitionLine = 2038;
// method "sorted"
  struct UserObject *uo5174 = (struct UserObject*)obj4925;
  uo5174->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted5174 = addmethod2pos(obj4925, "sorted", &meth_collectionsPrelude_sorted5174, 12);
  int argcv_meth_collectionsPrelude_sorted5174[] = {0};
  meth_meth_collectionsPrelude_sorted5174->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted5174);
  meth_meth_collectionsPrelude_sorted5174->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted5174->definitionLine = 2041;
// method "sortedBy(_)"
  struct UserObject *uo5177 = (struct UserObject*)obj4925;
  uo5177->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy_40_1_41_5177 = addmethod2pos(obj4925, "sortedBy(1)", &meth_collectionsPrelude_sortedBy_40_1_41_5177, 13);
  int argcv_meth_collectionsPrelude_sortedBy_40_1_41_5177[] = {1};
  meth_meth_collectionsPrelude_sortedBy_40_1_41_5177->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy_40_1_41_5177);
  meth_meth_collectionsPrelude_sortedBy_40_1_41_5177->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy_40_1_41_5177->definitionLine = 2043;
// method "keys"
  struct UserObject *uo5182 = (struct UserObject*)obj4925;
  uo5182->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys5182 = addmethod2pos(obj4925, "keys", &meth_collectionsPrelude_keys5182, 14);
  int argcv_meth_collectionsPrelude_keys5182[] = {0};
  meth_meth_collectionsPrelude_keys5182->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys5182);
  meth_meth_collectionsPrelude_keys5182->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys5182->definitionLine = 2045;
// method "values"
  struct UserObject *uo5189 = (struct UserObject*)obj4925;
  uo5189->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values5189 = addmethod2pos(obj4925, "values", &meth_collectionsPrelude_values5189, 15);
  int argcv_meth_collectionsPrelude_values5189[] = {0};
  meth_meth_collectionsPrelude_values5189->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values5189);
  meth_meth_collectionsPrelude_values5189->definitionModule = modulename;
  meth_meth_collectionsPrelude_values5189->definitionLine = 2047;
// method "asString"
  block_savedest(obj4925);
  Object closure5190 = createclosure(2, "asString");
  setclosureframe(closure5190, stackframe);
  addtoclosure(closure5190, var_lower);
  addtoclosure(closure5190, var_upper);
  struct UserObject *uo5190 = (struct UserObject*)obj4925;
  uo5190->data[16] = (Object)closure5190;
  Method *meth_meth_collectionsPrelude_asString5190 = addmethod2pos(obj4925, "asString", &meth_collectionsPrelude_asString5190, 16);
  int argcv_meth_collectionsPrelude_asString5190[] = {0};
  meth_meth_collectionsPrelude_asString5190->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5190);
  meth_meth_collectionsPrelude_asString5190->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5190->definitionLine = 2049;
// method "asSequence"
  struct UserObject *uo5206 = (struct UserObject*)obj4925;
  uo5206->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSequence5206 = addmethod2pos(obj4925, "asSequence", &meth_collectionsPrelude_asSequence5206, 17);
  int argcv_meth_collectionsPrelude_asSequence5206[] = {0};
  meth_meth_collectionsPrelude_asSequence5206->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSequence5206);
  meth_meth_collectionsPrelude_asSequence5206->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSequence5206->definitionLine = 2052;
  sourceObject = obj4925;
// Begin line 1965
  setline(1965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5207 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5208 = callmethodflags(*var_indexable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5207);
// compiled call node returning call5208 (depth = 2)
  struct UserObject *obj4925_uo = (struct UserObject *)obj4925;
  obj4925_uo->super = call5208;
  sourceObject = obj4925;
// Begin line 1966
  setline(1966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  int frame5209 = gc_frame_new();
  gc_frame_newslot(*var_upper);
// Begin line 1967
  setline(1967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5210 = alloc_Block(NULL, NULL, "collectionsPrelude", 1967);
  gc_frame_newslot(block5210);
// method "_apply(_)"
  block_savedest(block5210);
  Object closure5211 = createclosure(1, "_apply(1)");
  setclosureframe(closure5211, stackframe);
  addtoclosure(closure5211, selfslot);
  struct UserObject *uo5211 = (struct UserObject*)block5210;
  uo5211->data[0] = (Object)closure5211;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_5211 = addmethod2pos(block5210, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_5211, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_5211[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_5211->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_5211);
meth_meth_collectionsPrelude__apply_40_1_41_5211->type->types[0] = type_Number;
meth_meth_collectionsPrelude__apply_40_1_41_5211->type->names[0] = "__24";
  meth_meth_collectionsPrelude__apply_40_1_41_5211->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_5211->definitionLine = 1963;
// Begin line 1912
  setline(1912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5213 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe5214 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5215 == NULL) {
    strlit5215 = alloc_String("__24");
    gc_root(strlit5215);
  }
// compiled string node returning strlit5215 (depth = 6)
  gc_frame_newslot(strlit5215);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5216 = gc_frame_new();
// call case 5: prelude request
  Object call5217 = callmethodflags(prelude, "VariablePattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5216);
// compiled member node returning call5217 (depth = 6)
  params[0] = strlit5215;
  partcv[0] = 1;
  Object call5218 = callmethodflags(call5217, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5214);
// compiled call node returning call5218 (depth = 5)
  gc_frame_newslot(call5218);
// Begin line 1967
  setline(1967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other requests
// Begin line 1912
  setline(1912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5219 = gc_frame_new();
// call case 5: prelude request
  Object call5220 = callmethodflags(prelude, "AndPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5219);
// compiled member node returning call5220 (depth = 5)
  params[0] = call5218;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call5221 = callmethodflags(call5220, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5213);
// compiled call node returning call5221 (depth = 4)
((struct UserObject *)block5210)->data[1] = call5221;
// compiled block node returning block5210 (depth = 3)
  gc_frame_newslot(block5210);
// Begin line 1968
  setline(1968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5222 = alloc_Block(NULL, NULL, "collectionsPrelude", 1968);
  gc_frame_newslot(block5222);
// method "_apply(_)"
  block_savedest(block5222);
  Object closure5223 = createclosure(4, "_apply(1)");
  setclosureframe(closure5223, stackframe);
  addtoclosure(closure5223, var_lower);
  addtoclosure(closure5223, var_upper);
  addtoclosure(closure5223, var_RequestError);
  addtoclosure(closure5223, selfslot);
  struct UserObject *uo5223 = (struct UserObject*)block5222;
  uo5223->data[0] = (Object)closure5223;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_5223 = addmethod2pos(block5222, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_5223, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_5223[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_5223->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_5223);
  meth_meth_collectionsPrelude__apply_40_1_41_5223->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_5223->definitionLine = 1963;
// compiled block node returning block5222 (depth = 3)
  gc_frame_newslot(block5222);
  params[0] = block5210;
  params[1] = block5222;
  Object matchres5209 = matchCase(*var_upper, params, 2,NULL);
  gc_frame_end(frame5209);
// compiled matchcase node returning matchres5209 (depth = 2)
  sourceObject = obj4925;
// Begin line 1970
  setline(1970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe5253 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  Object call5254 = callmethodflags(*var_upper, "truncated", 0, partcv, params, 0);
  gc_frame_end(callframe5253);
// compiled member node returning call5254 (depth = 2)
  adddatum2(obj4925, call5254, 1);
  sourceObject = obj4925;
// Begin line 1971
  setline(1971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  int op_slot_right_5256 = gc_frame_newslot(*var_upper);
// starting to compile member node (depth = 4)
  int callframe5258 = gc_frame_new();
// call case 4: self request
  Object call5259 = callmethodflags(self, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5258);
// compiled member node returning call5259 (depth = 4)
  int op_slot_left_5256 = gc_frame_newslot(call5259);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5260 = callmethod(call5259, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5260 (depth = 3)
  Object if5255 = done;
struct StackFrameObject *iftmpstackframe5255 = stackframe;
  if (istrue(opresult5260)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5255);
gc_frame_newslot((Object)stackframe);
// Begin line 1972
  setline(1972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5261 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1973
  setline(1973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5264 == NULL) {
    strlit5264 = alloc_String(") is not an integer");
    gc_root(strlit5264);
  }
// compiled string node returning strlit5264 (depth = 6)
  int op_slot_right_5263 = gc_frame_newslot(strlit5264);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_5266 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5269 == NULL) {
    strlit5269 = alloc_String(")downTo(");
    gc_root(strlit5269);
  }
// compiled string node returning strlit5269 (depth = 8)
  int op_slot_right_5268 = gc_frame_newslot(strlit5269);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_upper (depth = 9)
  int op_slot_right_5271 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 9)
  if (strlit5273 == NULL) {
    strlit5273 = alloc_String(" in range.from(");
    gc_root(strlit5273);
  }
// compiled string node returning strlit5273 (depth = 9)
  int op_slot_left_5271 = gc_frame_newslot(strlit5273);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5274 = callmethod(strlit5273, "++(1)", 1, partcv, params);
// compiled op node returning opresult5274 (depth = 8)
  int op_slot_left_5268 = gc_frame_newslot(opresult5274);
  params[0] = strlit5269;
  partcv[0] = 1;
  Object opresult5275 = callmethod(opresult5274, "++(1)", 1, partcv, params);
// compiled op node returning opresult5275 (depth = 7)
  int op_slot_left_5266 = gc_frame_newslot(opresult5275);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5276 = callmethod(opresult5275, "++(1)", 1, partcv, params);
// compiled op node returning opresult5276 (depth = 6)
  int op_slot_left_5263 = gc_frame_newslot(opresult5276);
  params[0] = strlit5264;
  partcv[0] = 1;
  Object opresult5277 = callmethod(opresult5276, "++(1)", 1, partcv, params);
// compiled op node returning opresult5277 (depth = 5)
  int op_slot_right_5262 = gc_frame_newslot(opresult5277);
// Begin line 1972
  setline(1972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5280 == NULL) {
    strlit5280 = alloc_String("");
    gc_root(strlit5280);
  }
// compiled string node returning strlit5280 (depth = 6)
  int op_slot_right_5279 = gc_frame_newslot(strlit5280);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_upper (depth = 7)
  int op_slot_right_5282 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 7)
  if (strlit5284 == NULL) {
    strlit5284 = alloc_String("upper bound ");
    gc_root(strlit5284);
  }
// compiled string node returning strlit5284 (depth = 7)
  int op_slot_left_5282 = gc_frame_newslot(strlit5284);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5285 = callmethod(strlit5284, "++(1)", 1, partcv, params);
// compiled op node returning opresult5285 (depth = 6)
  int op_slot_left_5279 = gc_frame_newslot(opresult5285);
  params[0] = strlit5280;
  partcv[0] = 1;
  Object opresult5286 = callmethod(opresult5285, "++(1)", 1, partcv, params);
// compiled op node returning opresult5286 (depth = 5)
  int op_slot_left_5262 = gc_frame_newslot(opresult5286);
  params[0] = opresult5277;
  partcv[0] = 1;
  Object opresult5287 = callmethod(opresult5286, "++(1)", 1, partcv, params);
// compiled op node returning opresult5287 (depth = 4)
  gc_frame_newslot(opresult5287);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_RequestError (depth = 4)
  params[0] = opresult5287;
  partcv[0] = 1;
  Object call5288 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5261);
// compiled call node returning call5288 (depth = 3)
    gc_frame_newslot(call5288);
    if5255 = call5288;
  } else {
  }
stackframe = iftmpstackframe5255;
// compiled if node returning if5255 (depth = 2)
  sourceObject = obj4925;
// Begin line 1975
  setline(1975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  int frame5289 = gc_frame_new();
  gc_frame_newslot(*var_lower);
// Begin line 1976
  setline(1976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5290 = alloc_Block(NULL, NULL, "collectionsPrelude", 1976);
  gc_frame_newslot(block5290);
// method "_apply(_)"
  block_savedest(block5290);
  Object closure5291 = createclosure(1, "_apply(1)");
  setclosureframe(closure5291, stackframe);
  addtoclosure(closure5291, selfslot);
  struct UserObject *uo5291 = (struct UserObject*)block5290;
  uo5291->data[0] = (Object)closure5291;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_5291 = addmethod2pos(block5290, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_5291, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_5291[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_5291->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_5291);
meth_meth_collectionsPrelude__apply_40_1_41_5291->type->types[0] = type_Number;
meth_meth_collectionsPrelude__apply_40_1_41_5291->type->names[0] = "__26";
  meth_meth_collectionsPrelude__apply_40_1_41_5291->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_5291->definitionLine = 1963;
// Begin line 1912
  setline(1912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5293 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe5294 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5295 == NULL) {
    strlit5295 = alloc_String("__26");
    gc_root(strlit5295);
  }
// compiled string node returning strlit5295 (depth = 6)
  gc_frame_newslot(strlit5295);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5296 = gc_frame_new();
// call case 5: prelude request
  Object call5297 = callmethodflags(prelude, "VariablePattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5296);
// compiled member node returning call5297 (depth = 6)
  params[0] = strlit5295;
  partcv[0] = 1;
  Object call5298 = callmethodflags(call5297, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5294);
// compiled call node returning call5298 (depth = 5)
  gc_frame_newslot(call5298);
// Begin line 1976
  setline(1976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other requests
// Begin line 1912
  setline(1912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5299 = gc_frame_new();
// call case 5: prelude request
  Object call5300 = callmethodflags(prelude, "AndPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5299);
// compiled member node returning call5300 (depth = 5)
  params[0] = call5298;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call5301 = callmethodflags(call5300, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5293);
// compiled call node returning call5301 (depth = 4)
((struct UserObject *)block5290)->data[1] = call5301;
// compiled block node returning block5290 (depth = 3)
  gc_frame_newslot(block5290);
// Begin line 1977
  setline(1977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5302 = alloc_Block(NULL, NULL, "collectionsPrelude", 1977);
  gc_frame_newslot(block5302);
// method "_apply(_)"
  block_savedest(block5302);
  Object closure5303 = createclosure(4, "_apply(1)");
  setclosureframe(closure5303, stackframe);
  addtoclosure(closure5303, var_lower);
  addtoclosure(closure5303, var_upper);
  addtoclosure(closure5303, var_RequestError);
  addtoclosure(closure5303, selfslot);
  struct UserObject *uo5303 = (struct UserObject*)block5302;
  uo5303->data[0] = (Object)closure5303;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_5303 = addmethod2pos(block5302, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_5303, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_5303[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_5303->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_5303);
  meth_meth_collectionsPrelude__apply_40_1_41_5303->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_5303->definitionLine = 1963;
// compiled block node returning block5302 (depth = 3)
  gc_frame_newslot(block5302);
  params[0] = block5290;
  params[1] = block5302;
  Object matchres5289 = matchCase(*var_lower, params, 2,NULL);
  gc_frame_end(frame5289);
// compiled matchcase node returning matchres5289 (depth = 2)
  sourceObject = obj4925;
// Begin line 1979
  setline(1979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe5333 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  Object call5334 = callmethodflags(*var_lower, "truncated", 0, partcv, params, 0);
  gc_frame_end(callframe5333);
// compiled member node returning call5334 (depth = 2)
  adddatum2(obj4925, call5334, 2);
  sourceObject = obj4925;
// Begin line 1980
  setline(1980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  int op_slot_right_5336 = gc_frame_newslot(*var_lower);
// starting to compile member node (depth = 4)
  int callframe5338 = gc_frame_new();
// call case 4: self request
  Object call5339 = callmethodflags(self, "stop", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5338);
// compiled member node returning call5339 (depth = 4)
  int op_slot_left_5336 = gc_frame_newslot(call5339);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5340 = callmethod(call5339, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5340 (depth = 3)
  Object if5335 = done;
struct StackFrameObject *iftmpstackframe5335 = stackframe;
  if (istrue(opresult5340)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5335);
gc_frame_newslot((Object)stackframe);
// Begin line 1981
  setline(1981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5341 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1982
  setline(1982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5344 == NULL) {
    strlit5344 = alloc_String(") is not an integer");
    gc_root(strlit5344);
  }
// compiled string node returning strlit5344 (depth = 6)
  int op_slot_right_5343 = gc_frame_newslot(strlit5344);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_5346 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5349 == NULL) {
    strlit5349 = alloc_String(")downTo(");
    gc_root(strlit5349);
  }
// compiled string node returning strlit5349 (depth = 8)
  int op_slot_right_5348 = gc_frame_newslot(strlit5349);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_upper (depth = 9)
  int op_slot_right_5351 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 9)
  if (strlit5353 == NULL) {
    strlit5353 = alloc_String(" in range.from(");
    gc_root(strlit5353);
  }
// compiled string node returning strlit5353 (depth = 9)
  int op_slot_left_5351 = gc_frame_newslot(strlit5353);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5354 = callmethod(strlit5353, "++(1)", 1, partcv, params);
// compiled op node returning opresult5354 (depth = 8)
  int op_slot_left_5348 = gc_frame_newslot(opresult5354);
  params[0] = strlit5349;
  partcv[0] = 1;
  Object opresult5355 = callmethod(opresult5354, "++(1)", 1, partcv, params);
// compiled op node returning opresult5355 (depth = 7)
  int op_slot_left_5346 = gc_frame_newslot(opresult5355);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5356 = callmethod(opresult5355, "++(1)", 1, partcv, params);
// compiled op node returning opresult5356 (depth = 6)
  int op_slot_left_5343 = gc_frame_newslot(opresult5356);
  params[0] = strlit5344;
  partcv[0] = 1;
  Object opresult5357 = callmethod(opresult5356, "++(1)", 1, partcv, params);
// compiled op node returning opresult5357 (depth = 5)
  int op_slot_right_5342 = gc_frame_newslot(opresult5357);
// Begin line 1981
  setline(1981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5360 == NULL) {
    strlit5360 = alloc_String("");
    gc_root(strlit5360);
  }
// compiled string node returning strlit5360 (depth = 6)
  int op_slot_right_5359 = gc_frame_newslot(strlit5360);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_5362 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 7)
  if (strlit5364 == NULL) {
    strlit5364 = alloc_String("lower bound ");
    gc_root(strlit5364);
  }
// compiled string node returning strlit5364 (depth = 7)
  int op_slot_left_5362 = gc_frame_newslot(strlit5364);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5365 = callmethod(strlit5364, "++(1)", 1, partcv, params);
// compiled op node returning opresult5365 (depth = 6)
  int op_slot_left_5359 = gc_frame_newslot(opresult5365);
  params[0] = strlit5360;
  partcv[0] = 1;
  Object opresult5366 = callmethod(opresult5365, "++(1)", 1, partcv, params);
// compiled op node returning opresult5366 (depth = 5)
  int op_slot_left_5342 = gc_frame_newslot(opresult5366);
  params[0] = opresult5357;
  partcv[0] = 1;
  Object opresult5367 = callmethod(opresult5366, "++(1)", 1, partcv, params);
// compiled op node returning opresult5367 (depth = 4)
  gc_frame_newslot(opresult5367);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_RequestError (depth = 4)
  params[0] = opresult5367;
  partcv[0] = 1;
  Object call5368 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5341);
// compiled call node returning call5368 (depth = 3)
    gc_frame_newslot(call5368);
    if5335 = call5368;
  } else {
  }
stackframe = iftmpstackframe5335;
// compiled if node returning if5335 (depth = 2)
  sourceObject = obj4925;
// Begin line 1985
  setline(1985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5371 = alloc_Float64(0);
// compiled num node returning num5371 (depth = 4)
  int op_slot_right_5370 = gc_frame_newslot(num5371);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5374 = alloc_Float64(1);
// compiled num node returning num5374 (depth = 5)
  int op_slot_right_5373 = gc_frame_newslot(num5374);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lower (depth = 6)
  int op_slot_right_5376 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_left_5376 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff5378 = callmethod(*var_upper, "-(1)", 1, partcv, params);
// compiled op node returning diff5378 (depth = 5)
  int op_slot_left_5373 = gc_frame_newslot(diff5378);
  params[0] = num5374;
  partcv[0] = 1;
  Object sum5379 = callmethod(diff5378, "+(1)", 1, partcv, params);
// compiled op node returning sum5379 (depth = 4)
  int op_slot_left_5370 = gc_frame_newslot(sum5379);
  params[0] = num5371;
  partcv[0] = 1;
  Object opresult5380 = callmethod(sum5379, "<(1)", 1, partcv, params);
// compiled op node returning opresult5380 (depth = 3)
  Object if5369 = done;
struct StackFrameObject *iftmpstackframe5369 = stackframe;
  if (istrue(opresult5380)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5369);
gc_frame_newslot((Object)stackframe);
// starting to compile num node (depth = 3)
  Object num5381 = alloc_Float64(0);
// compiled num node returning num5381 (depth = 3)
    gc_frame_newslot(num5381);
    if5369 = num5381;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe5369);
  gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5383 = alloc_Float64(1);
// compiled num node returning num5383 (depth = 4)
  int op_slot_right_5382 = gc_frame_newslot(num5383);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lower (depth = 5)
  int op_slot_right_5385 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_upper (depth = 5)
  int op_slot_left_5385 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff5387 = callmethod(*var_upper, "-(1)", 1, partcv, params);
// compiled op node returning diff5387 (depth = 4)
  int op_slot_left_5382 = gc_frame_newslot(diff5387);
  params[0] = num5383;
  partcv[0] = 1;
  Object sum5388 = callmethod(diff5387, "+(1)", 1, partcv, params);
// compiled op node returning sum5388 (depth = 3)
    gc_frame_newslot(sum5388);
    if5369 = sum5388;
  }
stackframe = iftmpstackframe5369;
// compiled if node returning if5369 (depth = 2)
  adddatum2(obj4925, if5369, 3);
  sourceObject = obj4925;
  sourceObject = obj4925;
  sourceObject = obj4925;
  sourceObject = obj4925;
  sourceObject = obj4925;
  sourceObject = obj4925;
  sourceObject = obj4925;
  sourceObject = obj4925;
  sourceObject = obj4925;
  sourceObject = obj4925;
  sourceObject = obj4925;
  sourceObject = obj4925;
  sourceObject = obj4925;
  sourceObject = obj4925;
  objclass4925 = obj4925->class;
  objclass4925->definitionModule = modulename;
  objclass4925->definitionLine = 1964;
  (*(struct UserObject *)self).data[0] = lowerouter4925;
  self = oldself4925;
  selfslot = oldselfslot4925;
  stackframe = oldstackframe4925;
  gc_frame_end(frame);
  return obj4925;
}
Object meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_4924_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "from(1)downTo(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method from(_)downTo(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments for method from(_)downTo(_)");
  Object params[2];
  int partcv[2];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  Object *var__prelude = getfromclosure(closure, 2);
  Object *var_indexable = getfromclosure(closure, 3);
  Object *var_Number = getfromclosure(closure, 4);
  Object *var_RequestError = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for from(_)downTo(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_upper = &(stackframe->slots[0]);
  *var_upper = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part from(_)");
  Object *var_lower = &(stackframe->slots[1]);
  *var_lower = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part downTo(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4925 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4925 = alloc_userobj2(22,23, objclass4925);
  gc_frame_newslot(obj4925);
if (objclass4925 == NULL) {
  glfree(obj4925->class->name);
  obj4925->class->name = "range.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4925, self, 0);
  addmethodreal(obj4925,"outer", &reader_collectionsPrelude_outer_4926);
  Object oldself4925 = self;
  struct StackFrameObject *oldstackframe4925 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4925);
  gc_frame_newslot((Object)stackframe);
  self = obj4925;
  Object *oldselfslot4925 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4925 = (*(struct UserObject *)self).data[0], lowerouter4925 = thisouter4925;
  if (inheritingObject4925) {
    struct UserObject *inho4925 = (struct UserObject *)inheritingObject4925;
    while (inho4925->super != GraceDefaultObject) inho4925 = (struct UserObject *)inho4925->super;
    inho4925->super = obj4925;
    self = inheritingObject4925;
    *selfslot = self;
    lowerouter4925 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4925;
  }
if (objclass4925 == NULL) {
  Method *reader4927 = addmethodrealflags(obj4925, "start",&reader_collectionsPrelude_start_4927, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4927->definitionModule = modulename;
  reader4927->definitionLine = 1970;
}
adddatum2(obj4925, alloc_Undefined(), 1);
if (objclass4925 == NULL) {
  Method *reader4928 = addmethodrealflags(obj4925, "stop",&reader_collectionsPrelude_stop_4928, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4928->definitionModule = modulename;
  reader4928->definitionLine = 1979;
}
adddatum2(obj4925, alloc_Undefined(), 2);
if (objclass4925 == NULL) {
  Method *reader4929 = addmethodrealflags(obj4925, "size",&reader_collectionsPrelude_size_4929, MFLAG_DEF);
  reader4929->definitionModule = modulename;
  reader4929->definitionLine = 1984;
}
adddatum2(obj4925, alloc_Undefined(), 3);
// method "iterator"
  block_savedest(obj4925);
  Object closure4930 = createclosure(1, "iterator");
  setclosureframe(closure4930, stackframe);
  addtoclosure(closure4930, var_IteratorExhausted);
  struct UserObject *uo4930 = (struct UserObject*)obj4925;
  uo4930->data[4] = (Object)closure4930;
  Method *meth_meth_collectionsPrelude_iterator4930 = addmethod2pos(obj4925, "iterator", &meth_collectionsPrelude_iterator4930, 4);
  int argcv_meth_collectionsPrelude_iterator4930[] = {0};
  meth_meth_collectionsPrelude_iterator4930->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator4930);
  meth_meth_collectionsPrelude_iterator4930->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4930->definitionLine = 1986;
  block_savedest(obj4925);
  Object closure4998 = createclosure(1, "iterator$object(1)");
  setclosureframe(closure4998, stackframe);
  addtoclosure(closure4998, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_iterator4930_object = addmethod2pos(obj4925, "iterator$object(1)", &meth_collectionsPrelude_iterator4930_object, 4);
  meth_meth_collectionsPrelude_iterator4930_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4930_object->definitionLine = 1986;
// method "at(_)"
  block_savedest(obj4925);
  Object closure4999 = createclosure(1, "at(1)");
  setclosureframe(closure4999, stackframe);
  addtoclosure(closure4999, var_BoundsError);
  struct UserObject *uo4999 = (struct UserObject*)obj4925;
  uo4999->data[5] = (Object)closure4999;
  Method *meth_meth_collectionsPrelude_at_40_1_41_4999 = addmethod2pos(obj4925, "at(1)", &meth_collectionsPrelude_at_40_1_41_4999, 5);
  int argcv_meth_collectionsPrelude_at_40_1_41_4999[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_4999->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_4999);
meth_meth_collectionsPrelude_at_40_1_41_4999->type->types[0] = type_Number;
meth_meth_collectionsPrelude_at_40_1_41_4999->type->names[0] = "ix";
  meth_meth_collectionsPrelude_at_40_1_41_4999->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_4999->definitionLine = 1998;
// method "contains(_)"
  block_savedest(obj4925);
  Object closure5053 = createclosure(1, "contains(1)");
  setclosureframe(closure5053, stackframe);
  addtoclosure(closure5053, var__prelude);
  struct UserObject *uo5053 = (struct UserObject*)obj4925;
  uo5053->data[6] = (Object)closure5053;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_5053 = addmethod2pos(obj4925, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_5053, 6);
  int argcv_meth_collectionsPrelude_contains_40_1_41_5053[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_5053->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_5053);
  meth_meth_collectionsPrelude_contains_40_1_41_5053->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_5053->definitionLine = 2007;
// method "do(_)"
  struct UserObject *uo5095 = (struct UserObject*)obj4925;
  uo5095->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_5095 = addmethod2pos(obj4925, "do(1)", &meth_collectionsPrelude_do_40_1_41_5095, 7);
  int argcv_meth_collectionsPrelude_do_40_1_41_5095[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_5095->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_5095);
  meth_meth_collectionsPrelude_do_40_1_41_5095->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_5095->definitionLine = 2016;
// method "keysAndValuesDo(_)"
  struct UserObject *uo5118 = (struct UserObject*)obj4925;
  uo5118->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5118 = addmethod2pos(obj4925, "keysAndValuesDo(1)", &meth_collectionsPrelude_keysAndValuesDo_40_1_41_5118, 8);
  int argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5118[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5118->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5118);
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5118->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5118->definitionLine = 2023;
// method "reversed"
  block_savedest(obj4925);
  Object closure5147 = createclosure(2, "reversed");
  setclosureframe(closure5147, stackframe);
  addtoclosure(closure5147, var_lower);
  addtoclosure(closure5147, var_upper);
  struct UserObject *uo5147 = (struct UserObject*)obj4925;
  uo5147->data[9] = (Object)closure5147;
  Method *meth_meth_collectionsPrelude_reversed5147 = addmethod2pos(obj4925, "reversed", &meth_collectionsPrelude_reversed5147, 9);
  int argcv_meth_collectionsPrelude_reversed5147[] = {0};
  meth_meth_collectionsPrelude_reversed5147->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed5147);
  meth_meth_collectionsPrelude_reversed5147->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed5147->definitionLine = 2032;
// method "++(_)"
  struct UserObject *uo5152 = (struct UserObject*)obj4925;
  uo5152->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_5152 = addmethod2pos(obj4925, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_5152, 10);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_5152[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_5152->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_5152);
  meth_meth_collectionsPrelude__43__43__40_1_41_5152->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_5152->definitionLine = 2035;
// method "==(_)"
  struct UserObject *uo5167 = (struct UserObject*)obj4925;
  uo5167->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_5167 = addmethod2pos(obj4925, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_5167, 11);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_5167[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_5167->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_5167);
  meth_meth_collectionsPrelude__61__61__40_1_41_5167->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_5167->definitionLine = 2038;
// method "sorted"
  struct UserObject *uo5174 = (struct UserObject*)obj4925;
  uo5174->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted5174 = addmethod2pos(obj4925, "sorted", &meth_collectionsPrelude_sorted5174, 12);
  int argcv_meth_collectionsPrelude_sorted5174[] = {0};
  meth_meth_collectionsPrelude_sorted5174->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted5174);
  meth_meth_collectionsPrelude_sorted5174->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted5174->definitionLine = 2041;
// method "sortedBy(_)"
  struct UserObject *uo5177 = (struct UserObject*)obj4925;
  uo5177->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy_40_1_41_5177 = addmethod2pos(obj4925, "sortedBy(1)", &meth_collectionsPrelude_sortedBy_40_1_41_5177, 13);
  int argcv_meth_collectionsPrelude_sortedBy_40_1_41_5177[] = {1};
  meth_meth_collectionsPrelude_sortedBy_40_1_41_5177->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy_40_1_41_5177);
  meth_meth_collectionsPrelude_sortedBy_40_1_41_5177->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy_40_1_41_5177->definitionLine = 2043;
// method "keys"
  struct UserObject *uo5182 = (struct UserObject*)obj4925;
  uo5182->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys5182 = addmethod2pos(obj4925, "keys", &meth_collectionsPrelude_keys5182, 14);
  int argcv_meth_collectionsPrelude_keys5182[] = {0};
  meth_meth_collectionsPrelude_keys5182->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys5182);
  meth_meth_collectionsPrelude_keys5182->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys5182->definitionLine = 2045;
// method "values"
  struct UserObject *uo5189 = (struct UserObject*)obj4925;
  uo5189->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values5189 = addmethod2pos(obj4925, "values", &meth_collectionsPrelude_values5189, 15);
  int argcv_meth_collectionsPrelude_values5189[] = {0};
  meth_meth_collectionsPrelude_values5189->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values5189);
  meth_meth_collectionsPrelude_values5189->definitionModule = modulename;
  meth_meth_collectionsPrelude_values5189->definitionLine = 2047;
// method "asString"
  block_savedest(obj4925);
  Object closure5190 = createclosure(2, "asString");
  setclosureframe(closure5190, stackframe);
  addtoclosure(closure5190, var_lower);
  addtoclosure(closure5190, var_upper);
  struct UserObject *uo5190 = (struct UserObject*)obj4925;
  uo5190->data[16] = (Object)closure5190;
  Method *meth_meth_collectionsPrelude_asString5190 = addmethod2pos(obj4925, "asString", &meth_collectionsPrelude_asString5190, 16);
  int argcv_meth_collectionsPrelude_asString5190[] = {0};
  meth_meth_collectionsPrelude_asString5190->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5190);
  meth_meth_collectionsPrelude_asString5190->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5190->definitionLine = 2049;
// method "asSequence"
  struct UserObject *uo5206 = (struct UserObject*)obj4925;
  uo5206->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSequence5206 = addmethod2pos(obj4925, "asSequence", &meth_collectionsPrelude_asSequence5206, 17);
  int argcv_meth_collectionsPrelude_asSequence5206[] = {0};
  meth_meth_collectionsPrelude_asSequence5206->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSequence5206);
  meth_meth_collectionsPrelude_asSequence5206->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSequence5206->definitionLine = 2052;
  sourceObject = obj4925;
// Begin line 1965
  setline(1965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5207 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5208 = callmethodflags(*var_indexable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5207);
// compiled call node returning call5208 (depth = 2)
  struct UserObject *obj4925_uo = (struct UserObject *)obj4925;
  obj4925_uo->super = call5208;
  sourceObject = obj4925;
// Begin line 1966
  setline(1966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  int frame5209 = gc_frame_new();
  gc_frame_newslot(*var_upper);
// Begin line 1967
  setline(1967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5210 = alloc_Block(NULL, NULL, "collectionsPrelude", 1967);
  gc_frame_newslot(block5210);
// method "_apply(_)"
  block_savedest(block5210);
  Object closure5211 = createclosure(1, "_apply(1)");
  setclosureframe(closure5211, stackframe);
  addtoclosure(closure5211, selfslot);
  struct UserObject *uo5211 = (struct UserObject*)block5210;
  uo5211->data[0] = (Object)closure5211;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_5211 = addmethod2pos(block5210, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_5211, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_5211[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_5211->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_5211);
meth_meth_collectionsPrelude__apply_40_1_41_5211->type->types[0] = type_Number;
meth_meth_collectionsPrelude__apply_40_1_41_5211->type->names[0] = "__24";
  meth_meth_collectionsPrelude__apply_40_1_41_5211->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_5211->definitionLine = 1963;
// Begin line 1912
  setline(1912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5213 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe5214 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5215 == NULL) {
    strlit5215 = alloc_String("__24");
    gc_root(strlit5215);
  }
// compiled string node returning strlit5215 (depth = 6)
  gc_frame_newslot(strlit5215);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5216 = gc_frame_new();
// call case 5: prelude request
  Object call5217 = callmethodflags(prelude, "VariablePattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5216);
// compiled member node returning call5217 (depth = 6)
  params[0] = strlit5215;
  partcv[0] = 1;
  Object call5218 = callmethodflags(call5217, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5214);
// compiled call node returning call5218 (depth = 5)
  gc_frame_newslot(call5218);
// Begin line 1967
  setline(1967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other requests
// Begin line 1912
  setline(1912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5219 = gc_frame_new();
// call case 5: prelude request
  Object call5220 = callmethodflags(prelude, "AndPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5219);
// compiled member node returning call5220 (depth = 5)
  params[0] = call5218;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call5221 = callmethodflags(call5220, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5213);
// compiled call node returning call5221 (depth = 4)
((struct UserObject *)block5210)->data[1] = call5221;
// compiled block node returning block5210 (depth = 3)
  gc_frame_newslot(block5210);
// Begin line 1968
  setline(1968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5222 = alloc_Block(NULL, NULL, "collectionsPrelude", 1968);
  gc_frame_newslot(block5222);
// method "_apply(_)"
  block_savedest(block5222);
  Object closure5223 = createclosure(4, "_apply(1)");
  setclosureframe(closure5223, stackframe);
  addtoclosure(closure5223, var_lower);
  addtoclosure(closure5223, var_upper);
  addtoclosure(closure5223, var_RequestError);
  addtoclosure(closure5223, selfslot);
  struct UserObject *uo5223 = (struct UserObject*)block5222;
  uo5223->data[0] = (Object)closure5223;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_5223 = addmethod2pos(block5222, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_5223, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_5223[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_5223->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_5223);
  meth_meth_collectionsPrelude__apply_40_1_41_5223->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_5223->definitionLine = 1963;
// compiled block node returning block5222 (depth = 3)
  gc_frame_newslot(block5222);
  params[0] = block5210;
  params[1] = block5222;
  Object matchres5209 = matchCase(*var_upper, params, 2,NULL);
  gc_frame_end(frame5209);
// compiled matchcase node returning matchres5209 (depth = 2)
  sourceObject = obj4925;
// Begin line 1970
  setline(1970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe5253 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  Object call5254 = callmethodflags(*var_upper, "truncated", 0, partcv, params, 0);
  gc_frame_end(callframe5253);
// compiled member node returning call5254 (depth = 2)
  adddatum2(obj4925, call5254, 1);
  sourceObject = obj4925;
// Begin line 1971
  setline(1971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  int op_slot_right_5256 = gc_frame_newslot(*var_upper);
// starting to compile member node (depth = 4)
  int callframe5258 = gc_frame_new();
// call case 4: self request
  Object call5259 = callmethodflags(self, "start", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5258);
// compiled member node returning call5259 (depth = 4)
  int op_slot_left_5256 = gc_frame_newslot(call5259);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5260 = callmethod(call5259, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5260 (depth = 3)
  Object if5255 = done;
struct StackFrameObject *iftmpstackframe5255 = stackframe;
  if (istrue(opresult5260)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5255);
gc_frame_newslot((Object)stackframe);
// Begin line 1972
  setline(1972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5261 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1973
  setline(1973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5264 == NULL) {
    strlit5264 = alloc_String(") is not an integer");
    gc_root(strlit5264);
  }
// compiled string node returning strlit5264 (depth = 6)
  int op_slot_right_5263 = gc_frame_newslot(strlit5264);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_5266 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5269 == NULL) {
    strlit5269 = alloc_String(")downTo(");
    gc_root(strlit5269);
  }
// compiled string node returning strlit5269 (depth = 8)
  int op_slot_right_5268 = gc_frame_newslot(strlit5269);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_upper (depth = 9)
  int op_slot_right_5271 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 9)
  if (strlit5273 == NULL) {
    strlit5273 = alloc_String(" in range.from(");
    gc_root(strlit5273);
  }
// compiled string node returning strlit5273 (depth = 9)
  int op_slot_left_5271 = gc_frame_newslot(strlit5273);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5274 = callmethod(strlit5273, "++(1)", 1, partcv, params);
// compiled op node returning opresult5274 (depth = 8)
  int op_slot_left_5268 = gc_frame_newslot(opresult5274);
  params[0] = strlit5269;
  partcv[0] = 1;
  Object opresult5275 = callmethod(opresult5274, "++(1)", 1, partcv, params);
// compiled op node returning opresult5275 (depth = 7)
  int op_slot_left_5266 = gc_frame_newslot(opresult5275);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5276 = callmethod(opresult5275, "++(1)", 1, partcv, params);
// compiled op node returning opresult5276 (depth = 6)
  int op_slot_left_5263 = gc_frame_newslot(opresult5276);
  params[0] = strlit5264;
  partcv[0] = 1;
  Object opresult5277 = callmethod(opresult5276, "++(1)", 1, partcv, params);
// compiled op node returning opresult5277 (depth = 5)
  int op_slot_right_5262 = gc_frame_newslot(opresult5277);
// Begin line 1972
  setline(1972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5280 == NULL) {
    strlit5280 = alloc_String("");
    gc_root(strlit5280);
  }
// compiled string node returning strlit5280 (depth = 6)
  int op_slot_right_5279 = gc_frame_newslot(strlit5280);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_upper (depth = 7)
  int op_slot_right_5282 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 7)
  if (strlit5284 == NULL) {
    strlit5284 = alloc_String("upper bound ");
    gc_root(strlit5284);
  }
// compiled string node returning strlit5284 (depth = 7)
  int op_slot_left_5282 = gc_frame_newslot(strlit5284);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5285 = callmethod(strlit5284, "++(1)", 1, partcv, params);
// compiled op node returning opresult5285 (depth = 6)
  int op_slot_left_5279 = gc_frame_newslot(opresult5285);
  params[0] = strlit5280;
  partcv[0] = 1;
  Object opresult5286 = callmethod(opresult5285, "++(1)", 1, partcv, params);
// compiled op node returning opresult5286 (depth = 5)
  int op_slot_left_5262 = gc_frame_newslot(opresult5286);
  params[0] = opresult5277;
  partcv[0] = 1;
  Object opresult5287 = callmethod(opresult5286, "++(1)", 1, partcv, params);
// compiled op node returning opresult5287 (depth = 4)
  gc_frame_newslot(opresult5287);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_RequestError (depth = 4)
  params[0] = opresult5287;
  partcv[0] = 1;
  Object call5288 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5261);
// compiled call node returning call5288 (depth = 3)
    gc_frame_newslot(call5288);
    if5255 = call5288;
  } else {
  }
stackframe = iftmpstackframe5255;
// compiled if node returning if5255 (depth = 2)
  sourceObject = obj4925;
// Begin line 1975
  setline(1975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  int frame5289 = gc_frame_new();
  gc_frame_newslot(*var_lower);
// Begin line 1976
  setline(1976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5290 = alloc_Block(NULL, NULL, "collectionsPrelude", 1976);
  gc_frame_newslot(block5290);
// method "_apply(_)"
  block_savedest(block5290);
  Object closure5291 = createclosure(1, "_apply(1)");
  setclosureframe(closure5291, stackframe);
  addtoclosure(closure5291, selfslot);
  struct UserObject *uo5291 = (struct UserObject*)block5290;
  uo5291->data[0] = (Object)closure5291;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_5291 = addmethod2pos(block5290, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_5291, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_5291[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_5291->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_5291);
meth_meth_collectionsPrelude__apply_40_1_41_5291->type->types[0] = type_Number;
meth_meth_collectionsPrelude__apply_40_1_41_5291->type->names[0] = "__26";
  meth_meth_collectionsPrelude__apply_40_1_41_5291->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_5291->definitionLine = 1963;
// Begin line 1912
  setline(1912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5293 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe5294 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5295 == NULL) {
    strlit5295 = alloc_String("__26");
    gc_root(strlit5295);
  }
// compiled string node returning strlit5295 (depth = 6)
  gc_frame_newslot(strlit5295);
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5296 = gc_frame_new();
// call case 5: prelude request
  Object call5297 = callmethodflags(prelude, "VariablePattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5296);
// compiled member node returning call5297 (depth = 6)
  params[0] = strlit5295;
  partcv[0] = 1;
  Object call5298 = callmethodflags(call5297, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5294);
// compiled call node returning call5298 (depth = 5)
  gc_frame_newslot(call5298);
// Begin line 1976
  setline(1976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other requests
// Begin line 1912
  setline(1912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5299 = gc_frame_new();
// call case 5: prelude request
  Object call5300 = callmethodflags(prelude, "AndPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5299);
// compiled member node returning call5300 (depth = 5)
  params[0] = call5298;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call5301 = callmethodflags(call5300, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5293);
// compiled call node returning call5301 (depth = 4)
((struct UserObject *)block5290)->data[1] = call5301;
// compiled block node returning block5290 (depth = 3)
  gc_frame_newslot(block5290);
// Begin line 1977
  setline(1977);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5302 = alloc_Block(NULL, NULL, "collectionsPrelude", 1977);
  gc_frame_newslot(block5302);
// method "_apply(_)"
  block_savedest(block5302);
  Object closure5303 = createclosure(4, "_apply(1)");
  setclosureframe(closure5303, stackframe);
  addtoclosure(closure5303, var_lower);
  addtoclosure(closure5303, var_upper);
  addtoclosure(closure5303, var_RequestError);
  addtoclosure(closure5303, selfslot);
  struct UserObject *uo5303 = (struct UserObject*)block5302;
  uo5303->data[0] = (Object)closure5303;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_5303 = addmethod2pos(block5302, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_5303, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_5303[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_5303->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_5303);
  meth_meth_collectionsPrelude__apply_40_1_41_5303->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_5303->definitionLine = 1963;
// compiled block node returning block5302 (depth = 3)
  gc_frame_newslot(block5302);
  params[0] = block5290;
  params[1] = block5302;
  Object matchres5289 = matchCase(*var_lower, params, 2,NULL);
  gc_frame_end(frame5289);
// compiled matchcase node returning matchres5289 (depth = 2)
  sourceObject = obj4925;
// Begin line 1979
  setline(1979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
  int callframe5333 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  Object call5334 = callmethodflags(*var_lower, "truncated", 0, partcv, params, 0);
  gc_frame_end(callframe5333);
// compiled member node returning call5334 (depth = 2)
  adddatum2(obj4925, call5334, 2);
  sourceObject = obj4925;
// Begin line 1980
  setline(1980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  int op_slot_right_5336 = gc_frame_newslot(*var_lower);
// starting to compile member node (depth = 4)
  int callframe5338 = gc_frame_new();
// call case 4: self request
  Object call5339 = callmethodflags(self, "stop", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5338);
// compiled member node returning call5339 (depth = 4)
  int op_slot_left_5336 = gc_frame_newslot(call5339);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5340 = callmethod(call5339, "≠(1)", 1, partcv, params);
// compiled op node returning opresult5340 (depth = 3)
  Object if5335 = done;
struct StackFrameObject *iftmpstackframe5335 = stackframe;
  if (istrue(opresult5340)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5335);
gc_frame_newslot((Object)stackframe);
// Begin line 1981
  setline(1981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5341 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1982
  setline(1982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5344 == NULL) {
    strlit5344 = alloc_String(") is not an integer");
    gc_root(strlit5344);
  }
// compiled string node returning strlit5344 (depth = 6)
  int op_slot_right_5343 = gc_frame_newslot(strlit5344);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_5346 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5349 == NULL) {
    strlit5349 = alloc_String(")downTo(");
    gc_root(strlit5349);
  }
// compiled string node returning strlit5349 (depth = 8)
  int op_slot_right_5348 = gc_frame_newslot(strlit5349);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_upper (depth = 9)
  int op_slot_right_5351 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 9)
  if (strlit5353 == NULL) {
    strlit5353 = alloc_String(" in range.from(");
    gc_root(strlit5353);
  }
// compiled string node returning strlit5353 (depth = 9)
  int op_slot_left_5351 = gc_frame_newslot(strlit5353);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5354 = callmethod(strlit5353, "++(1)", 1, partcv, params);
// compiled op node returning opresult5354 (depth = 8)
  int op_slot_left_5348 = gc_frame_newslot(opresult5354);
  params[0] = strlit5349;
  partcv[0] = 1;
  Object opresult5355 = callmethod(opresult5354, "++(1)", 1, partcv, params);
// compiled op node returning opresult5355 (depth = 7)
  int op_slot_left_5346 = gc_frame_newslot(opresult5355);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5356 = callmethod(opresult5355, "++(1)", 1, partcv, params);
// compiled op node returning opresult5356 (depth = 6)
  int op_slot_left_5343 = gc_frame_newslot(opresult5356);
  params[0] = strlit5344;
  partcv[0] = 1;
  Object opresult5357 = callmethod(opresult5356, "++(1)", 1, partcv, params);
// compiled op node returning opresult5357 (depth = 5)
  int op_slot_right_5342 = gc_frame_newslot(opresult5357);
// Begin line 1981
  setline(1981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5360 == NULL) {
    strlit5360 = alloc_String("");
    gc_root(strlit5360);
  }
// compiled string node returning strlit5360 (depth = 6)
  int op_slot_right_5359 = gc_frame_newslot(strlit5360);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_5362 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 7)
  if (strlit5364 == NULL) {
    strlit5364 = alloc_String("lower bound ");
    gc_root(strlit5364);
  }
// compiled string node returning strlit5364 (depth = 7)
  int op_slot_left_5362 = gc_frame_newslot(strlit5364);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5365 = callmethod(strlit5364, "++(1)", 1, partcv, params);
// compiled op node returning opresult5365 (depth = 6)
  int op_slot_left_5359 = gc_frame_newslot(opresult5365);
  params[0] = strlit5360;
  partcv[0] = 1;
  Object opresult5366 = callmethod(opresult5365, "++(1)", 1, partcv, params);
// compiled op node returning opresult5366 (depth = 5)
  int op_slot_left_5342 = gc_frame_newslot(opresult5366);
  params[0] = opresult5357;
  partcv[0] = 1;
  Object opresult5367 = callmethod(opresult5366, "++(1)", 1, partcv, params);
// compiled op node returning opresult5367 (depth = 4)
  gc_frame_newslot(opresult5367);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_RequestError (depth = 4)
  params[0] = opresult5367;
  partcv[0] = 1;
  Object call5368 = callmethodflags(*var_RequestError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5341);
// compiled call node returning call5368 (depth = 3)
    gc_frame_newslot(call5368);
    if5335 = call5368;
  } else {
  }
stackframe = iftmpstackframe5335;
// compiled if node returning if5335 (depth = 2)
  sourceObject = obj4925;
// Begin line 1985
  setline(1985);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5371 = alloc_Float64(0);
// compiled num node returning num5371 (depth = 4)
  int op_slot_right_5370 = gc_frame_newslot(num5371);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5374 = alloc_Float64(1);
// compiled num node returning num5374 (depth = 5)
  int op_slot_right_5373 = gc_frame_newslot(num5374);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lower (depth = 6)
  int op_slot_right_5376 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_left_5376 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff5378 = callmethod(*var_upper, "-(1)", 1, partcv, params);
// compiled op node returning diff5378 (depth = 5)
  int op_slot_left_5373 = gc_frame_newslot(diff5378);
  params[0] = num5374;
  partcv[0] = 1;
  Object sum5379 = callmethod(diff5378, "+(1)", 1, partcv, params);
// compiled op node returning sum5379 (depth = 4)
  int op_slot_left_5370 = gc_frame_newslot(sum5379);
  params[0] = num5371;
  partcv[0] = 1;
  Object opresult5380 = callmethod(sum5379, "<(1)", 1, partcv, params);
// compiled op node returning opresult5380 (depth = 3)
  Object if5369 = done;
struct StackFrameObject *iftmpstackframe5369 = stackframe;
  if (istrue(opresult5380)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5369);
gc_frame_newslot((Object)stackframe);
// starting to compile num node (depth = 3)
  Object num5381 = alloc_Float64(0);
// compiled num node returning num5381 (depth = 3)
    gc_frame_newslot(num5381);
    if5369 = num5381;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe5369);
  gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5383 = alloc_Float64(1);
// compiled num node returning num5383 (depth = 4)
  int op_slot_right_5382 = gc_frame_newslot(num5383);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lower (depth = 5)
  int op_slot_right_5385 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_upper (depth = 5)
  int op_slot_left_5385 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff5387 = callmethod(*var_upper, "-(1)", 1, partcv, params);
// compiled op node returning diff5387 (depth = 4)
  int op_slot_left_5382 = gc_frame_newslot(diff5387);
  params[0] = num5383;
  partcv[0] = 1;
  Object sum5388 = callmethod(diff5387, "+(1)", 1, partcv, params);
// compiled op node returning sum5388 (depth = 3)
    gc_frame_newslot(sum5388);
    if5369 = sum5388;
  }
stackframe = iftmpstackframe5369;
// compiled if node returning if5369 (depth = 2)
  adddatum2(obj4925, if5369, 3);
  sourceObject = obj4925;
  sourceObject = obj4925;
  sourceObject = obj4925;
  sourceObject = obj4925;
  sourceObject = obj4925;
  sourceObject = obj4925;
  sourceObject = obj4925;
  sourceObject = obj4925;
  sourceObject = obj4925;
  sourceObject = obj4925;
  sourceObject = obj4925;
  sourceObject = obj4925;
  sourceObject = obj4925;
  sourceObject = obj4925;
  objclass4925 = obj4925->class;
  objclass4925->definitionModule = modulename;
  objclass4925->definitionLine = 1964;
  (*(struct UserObject *)self).data[0] = lowerouter4925;
  self = oldself4925;
  selfslot = oldselfslot4925;
  stackframe = oldstackframe4925;
  gc_frame_end(frame);
  return obj4925;
}
Object meth_collectionsPrelude_range4419(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "range");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Number = getfromclosure(closure, 0);
  Object *var_RequestError = getfromclosure(closure, 1);
  Object *var_IteratorExhausted = getfromclosure(closure, 2);
  Object *var_BoundsError = getfromclosure(closure, 3);
  Object *var__prelude = getfromclosure(closure, 4);
  Object *var_indexable = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4420 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4420 = alloc_userobj2(5,6, objclass4420);
  gc_frame_newslot(obj4420);
if (objclass4420 == NULL) {
  glfree(obj4420->class->name);
  obj4420->class->name = "range";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4420, self, 0);
  addmethodreal(obj4420,"outer", &reader_collectionsPrelude_outer_4421);
  Object oldself4420 = self;
  struct StackFrameObject *oldstackframe4420 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4420);
  gc_frame_newslot((Object)stackframe);
  self = obj4420;
  Object *oldselfslot4420 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4420 = (*(struct UserObject *)self).data[0], lowerouter4420 = thisouter4420;
  if (inheritingObject4420) {
    struct UserObject *inho4420 = (struct UserObject *)inheritingObject4420;
    while (inho4420->super != GraceDefaultObject) inho4420 = (struct UserObject *)inho4420->super;
    inho4420->super = obj4420;
    self = inheritingObject4420;
    *selfslot = self;
    lowerouter4420 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4420;
  }
// method "from(_)to(_)"
  block_savedest(obj4420);
  Object closure4422 = createclosure(2, "from(1)to(1)");
  setclosureframe(closure4422, stackframe);
  addtoclosure(closure4422, var_Number);
  addtoclosure(closure4422, var_RequestError);
  struct UserObject *uo4422 = (struct UserObject*)obj4420;
  uo4422->data[1] = (Object)closure4422;
  Method *meth_meth_collectionsPrelude_from_40_1_41_to_40_1_41_4422 = addmethod2pos(obj4420, "from(1)to(1)", &meth_collectionsPrelude_from_40_1_41_to_40_1_41_4422, 1);
  int argcv_meth_collectionsPrelude_from_40_1_41_to_40_1_41_4422[] = {1, 1};
  meth_meth_collectionsPrelude_from_40_1_41_to_40_1_41_4422->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_from_40_1_41_to_40_1_41_4422);
  meth_meth_collectionsPrelude_from_40_1_41_to_40_1_41_4422->definitionModule = modulename;
  meth_meth_collectionsPrelude_from_40_1_41_to_40_1_41_4422->definitionLine = 1850;
// method "uncheckedFrom(_)to(_)"
  block_savedest(obj4420);
  Object closure4567 = createclosure(4, "uncheckedFrom(1)to(1)");
  setclosureframe(closure4567, stackframe);
  addtoclosure(closure4567, var_IteratorExhausted);
  addtoclosure(closure4567, var_BoundsError);
  addtoclosure(closure4567, var__prelude);
  addtoclosure(closure4567, var_indexable);
  struct UserObject *uo4567 = (struct UserObject*)obj4420;
  uo4567->data[2] = (Object)closure4567;
  Method *meth_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4567 = addmethod2pos(obj4420, "uncheckedFrom(1)to(1)", &meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4567, 2);
  int argcv_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4567[] = {1, 1};
  meth_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4567->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4567);
  meth_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4567->definitionModule = modulename;
  meth_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4567->definitionLine = 1873;
  block_savedest(obj4420);
  Object closure4923 = createclosure(4, "uncheckedFrom(1)to(1)$object(1)");
  setclosureframe(closure4923, stackframe);
  addtoclosure(closure4923, var_IteratorExhausted);
  addtoclosure(closure4923, var_BoundsError);
  addtoclosure(closure4923, var__prelude);
  addtoclosure(closure4923, var_indexable);
  Method *meth_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4567_object = addmethod2pos(obj4420, "uncheckedFrom(1)to(1)$object(1)", &meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4567_object, 2);
  meth_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4567_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4567_object->definitionLine = 1873;
// method "from(_)downTo(_)"
  block_savedest(obj4420);
  Object closure4924 = createclosure(6, "from(1)downTo(1)");
  setclosureframe(closure4924, stackframe);
  addtoclosure(closure4924, var_IteratorExhausted);
  addtoclosure(closure4924, var_BoundsError);
  addtoclosure(closure4924, var__prelude);
  addtoclosure(closure4924, var_indexable);
  addtoclosure(closure4924, var_Number);
  addtoclosure(closure4924, var_RequestError);
  struct UserObject *uo4924 = (struct UserObject*)obj4420;
  uo4924->data[3] = (Object)closure4924;
  Method *meth_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_4924 = addmethod2pos(obj4420, "from(1)downTo(1)", &meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_4924, 3);
  int argcv_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_4924[] = {1, 1};
  meth_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_4924->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_4924);
  meth_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_4924->definitionModule = modulename;
  meth_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_4924->definitionLine = 1963;
  block_savedest(obj4420);
  Object closure5389 = createclosure(6, "from(1)downTo(1)$object(1)");
  setclosureframe(closure5389, stackframe);
  addtoclosure(closure5389, var_IteratorExhausted);
  addtoclosure(closure5389, var_BoundsError);
  addtoclosure(closure5389, var__prelude);
  addtoclosure(closure5389, var_indexable);
  addtoclosure(closure5389, var_Number);
  addtoclosure(closure5389, var_RequestError);
  Method *meth_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_4924_object = addmethod2pos(obj4420, "from(1)downTo(1)$object(1)", &meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_4924_object, 3);
  meth_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_4924_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_4924_object->definitionLine = 1963;
  sourceObject = obj4420;
  sourceObject = obj4420;
  sourceObject = obj4420;
  objclass4420 = obj4420->class;
  objclass4420->definitionModule = modulename;
  objclass4420->definitionLine = 1849;
  (*(struct UserObject *)self).data[0] = lowerouter4420;
  self = oldself4420;
  selfslot = oldselfslot4420;
  stackframe = oldstackframe4420;
  gc_frame_end(frame);
  return obj4420;
}
Object meth_collectionsPrelude_range4419_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "range$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_Number = getfromclosure(closure, 0);
  Object *var_RequestError = getfromclosure(closure, 1);
  Object *var_IteratorExhausted = getfromclosure(closure, 2);
  Object *var_BoundsError = getfromclosure(closure, 3);
  Object *var__prelude = getfromclosure(closure, 4);
  Object *var_indexable = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4420 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4420 = alloc_userobj2(5,6, objclass4420);
  gc_frame_newslot(obj4420);
if (objclass4420 == NULL) {
  glfree(obj4420->class->name);
  obj4420->class->name = "range";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4420, self, 0);
  addmethodreal(obj4420,"outer", &reader_collectionsPrelude_outer_4421);
  Object oldself4420 = self;
  struct StackFrameObject *oldstackframe4420 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4420);
  gc_frame_newslot((Object)stackframe);
  self = obj4420;
  Object *oldselfslot4420 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4420 = (*(struct UserObject *)self).data[0], lowerouter4420 = thisouter4420;
  if (inheritingObject4420) {
    struct UserObject *inho4420 = (struct UserObject *)inheritingObject4420;
    while (inho4420->super != GraceDefaultObject) inho4420 = (struct UserObject *)inho4420->super;
    inho4420->super = obj4420;
    self = inheritingObject4420;
    *selfslot = self;
    lowerouter4420 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4420;
  }
// method "from(_)to(_)"
  block_savedest(obj4420);
  Object closure4422 = createclosure(2, "from(1)to(1)");
  setclosureframe(closure4422, stackframe);
  addtoclosure(closure4422, var_Number);
  addtoclosure(closure4422, var_RequestError);
  struct UserObject *uo4422 = (struct UserObject*)obj4420;
  uo4422->data[1] = (Object)closure4422;
  Method *meth_meth_collectionsPrelude_from_40_1_41_to_40_1_41_4422 = addmethod2pos(obj4420, "from(1)to(1)", &meth_collectionsPrelude_from_40_1_41_to_40_1_41_4422, 1);
  int argcv_meth_collectionsPrelude_from_40_1_41_to_40_1_41_4422[] = {1, 1};
  meth_meth_collectionsPrelude_from_40_1_41_to_40_1_41_4422->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_from_40_1_41_to_40_1_41_4422);
  meth_meth_collectionsPrelude_from_40_1_41_to_40_1_41_4422->definitionModule = modulename;
  meth_meth_collectionsPrelude_from_40_1_41_to_40_1_41_4422->definitionLine = 1850;
// method "uncheckedFrom(_)to(_)"
  block_savedest(obj4420);
  Object closure4567 = createclosure(4, "uncheckedFrom(1)to(1)");
  setclosureframe(closure4567, stackframe);
  addtoclosure(closure4567, var_IteratorExhausted);
  addtoclosure(closure4567, var_BoundsError);
  addtoclosure(closure4567, var__prelude);
  addtoclosure(closure4567, var_indexable);
  struct UserObject *uo4567 = (struct UserObject*)obj4420;
  uo4567->data[2] = (Object)closure4567;
  Method *meth_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4567 = addmethod2pos(obj4420, "uncheckedFrom(1)to(1)", &meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4567, 2);
  int argcv_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4567[] = {1, 1};
  meth_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4567->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4567);
  meth_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4567->definitionModule = modulename;
  meth_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4567->definitionLine = 1873;
  block_savedest(obj4420);
  Object closure4923 = createclosure(4, "uncheckedFrom(1)to(1)$object(1)");
  setclosureframe(closure4923, stackframe);
  addtoclosure(closure4923, var_IteratorExhausted);
  addtoclosure(closure4923, var_BoundsError);
  addtoclosure(closure4923, var__prelude);
  addtoclosure(closure4923, var_indexable);
  Method *meth_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4567_object = addmethod2pos(obj4420, "uncheckedFrom(1)to(1)$object(1)", &meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4567_object, 2);
  meth_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4567_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_uncheckedFrom_40_1_41_to_40_1_41_4567_object->definitionLine = 1873;
// method "from(_)downTo(_)"
  block_savedest(obj4420);
  Object closure4924 = createclosure(6, "from(1)downTo(1)");
  setclosureframe(closure4924, stackframe);
  addtoclosure(closure4924, var_IteratorExhausted);
  addtoclosure(closure4924, var_BoundsError);
  addtoclosure(closure4924, var__prelude);
  addtoclosure(closure4924, var_indexable);
  addtoclosure(closure4924, var_Number);
  addtoclosure(closure4924, var_RequestError);
  struct UserObject *uo4924 = (struct UserObject*)obj4420;
  uo4924->data[3] = (Object)closure4924;
  Method *meth_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_4924 = addmethod2pos(obj4420, "from(1)downTo(1)", &meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_4924, 3);
  int argcv_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_4924[] = {1, 1};
  meth_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_4924->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_4924);
  meth_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_4924->definitionModule = modulename;
  meth_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_4924->definitionLine = 1963;
  block_savedest(obj4420);
  Object closure5389 = createclosure(6, "from(1)downTo(1)$object(1)");
  setclosureframe(closure5389, stackframe);
  addtoclosure(closure5389, var_IteratorExhausted);
  addtoclosure(closure5389, var_BoundsError);
  addtoclosure(closure5389, var__prelude);
  addtoclosure(closure5389, var_indexable);
  addtoclosure(closure5389, var_Number);
  addtoclosure(closure5389, var_RequestError);
  Method *meth_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_4924_object = addmethod2pos(obj4420, "from(1)downTo(1)$object(1)", &meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_4924_object, 3);
  meth_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_4924_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_from_40_1_41_downTo_40_1_41_4924_object->definitionLine = 1963;
  sourceObject = obj4420;
  sourceObject = obj4420;
  sourceObject = obj4420;
  objclass4420 = obj4420->class;
  objclass4420->definitionModule = modulename;
  objclass4420->definitionLine = 1849;
  (*(struct UserObject *)self).data[0] = lowerouter4420;
  self = oldself4420;
  selfslot = oldselfslot4420;
  stackframe = oldstackframe4420;
  gc_frame_end(frame);
  return obj4420;
}
Object meth_collectionsPrelude_BoundsError5396(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "BoundsError");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_BoundsError (depth = 3)
  gc_frame_end(frame);
  return *var_BoundsError;
}
Object meth_collectionsPrelude_IteratorExhausted5402(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "IteratorExhausted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 4
  setline(4);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_IteratorExhausted (depth = 3)
  gc_frame_end(frame);
  return *var_IteratorExhausted;
}
Object meth_collectionsPrelude_SubobjectResponsibility5408(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "SubobjectResponsibility");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SubobjectResponsibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 5
  setline(5);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_SubobjectResponsibility (depth = 3)
  gc_frame_end(frame);
  return *var_SubobjectResponsibility;
}
Object meth_collectionsPrelude_NoSuchObject5414(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "NoSuchObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 6
  setline(6);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_NoSuchObject (depth = 3)
  gc_frame_end(frame);
  return *var_NoSuchObject;
}
Object meth_collectionsPrelude_RequestError5420(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "RequestError");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_RequestError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 7
  setline(7);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_RequestError (depth = 3)
  gc_frame_end(frame);
  return *var_RequestError;
}
Object meth_collectionsPrelude_ConcurrentModification5426(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ConcurrentModification");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 8
  setline(8);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ConcurrentModification (depth = 3)
  gc_frame_end(frame);
  return *var_ConcurrentModification;
}
Object meth_collectionsPrelude_SizeUnknown5432(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "SizeUnknown");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_SizeUnknown (depth = 3)
  gc_frame_end(frame);
  return *var_SizeUnknown;
}
Object meth_collectionsPrelude_Block05435(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Block0");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Block0 = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Block0 (depth = 3)
  gc_frame_end(frame);
  return *var_Block0;
}
Object meth_collectionsPrelude_Block15438(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Block1");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Block1 = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Block1 (depth = 3)
  gc_frame_end(frame);
  return *var_Block1;
}
Object meth_collectionsPrelude_Block25441(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Block2");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Block2 = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Block2 (depth = 3)
  gc_frame_end(frame);
  return *var_Block2;
}
Object meth_collectionsPrelude_SelfType5443(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "SelfType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SelfType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_SelfType (depth = 3)
  gc_frame_end(frame);
  return *var_SelfType;
}
Object meth_collectionsPrelude_Iterable5449(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Iterable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Iterable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Iterable (depth = 3)
  gc_frame_end(frame);
  return *var_Iterable;
}
Object meth_collectionsPrelude_Expandable5455(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Expandable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Expandable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Expandable (depth = 3)
  gc_frame_end(frame);
  return *var_Expandable;
}
Object meth_collectionsPrelude_Collection5461(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Collection");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Collection = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 61
  setline(61);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Collection (depth = 3)
  gc_frame_end(frame);
  return *var_Collection;
}
Object meth_collectionsPrelude_Enumerable5467(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Enumerable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 67
  setline(67);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Enumerable (depth = 3)
  gc_frame_end(frame);
  return *var_Enumerable;
}
Object meth_collectionsPrelude_Sequence5473(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Sequence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Sequence = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 76
  setline(76);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Sequence (depth = 3)
  gc_frame_end(frame);
  return *var_Sequence;
}
Object meth_collectionsPrelude_List5479(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "List");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_List = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_List (depth = 3)
  gc_frame_end(frame);
  return *var_List;
}
Object meth_collectionsPrelude_Set5485(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Set");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Set = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 116
  setline(116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Set (depth = 3)
  gc_frame_end(frame);
  return *var_Set;
}
Object meth_collectionsPrelude_Dictionary5491(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Dictionary");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Dictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 136
  setline(136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Dictionary (depth = 3)
  gc_frame_end(frame);
  return *var_Dictionary;
}
Object meth_collectionsPrelude_Iterator5494(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Iterator = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 161
  setline(161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Iterator (depth = 3)
  gc_frame_end(frame);
  return *var_Iterator;
}
Object meth_collectionsPrelude_asString5500(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 252
  setline(252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5501 == NULL) {
    strlit5501 = alloc_String("a collection TRAIT");
    gc_root(strlit5501);
  }
// compiled string node returning strlit5501 (depth = 3)
  gc_frame_end(frame);
  return strlit5501;
}
Object meth_collectionsPrelude_sizeIfUnknown_40_1_41_5502(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sizeIfUnknown(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sizeIfUnknown(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sizeIfUnknown(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sizeIfUnknown(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5503 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_action (depth = 4)
  Object call5504 = callmethodflags(*var_action, "apply", 0, partcv, params, 0);
  gc_frame_end(callframe5503);
// compiled member node returning call5504 (depth = 3)
  gc_frame_end(frame);
  return call5504;
}
Object meth_collectionsPrelude_size5505(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 257
  setline(257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5506 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5507 == NULL) {
    strlit5507 = alloc_String("this collection does not know its size");
    gc_root(strlit5507);
  }
// compiled string node returning strlit5507 (depth = 4)
  gc_frame_newslot(strlit5507);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_SizeUnknown (depth = 4)
  params[0] = strlit5507;
  partcv[0] = 1;
  Object call5508 = callmethodflags(*var_SizeUnknown, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5506);
// compiled call node returning call5508 (depth = 3)
  gc_frame_end(frame);
  return call5508;
}
Object meth_collectionsPrelude_do5509(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 259
  setline(259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5510 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5511 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5512 = gc_frame_new();
// call case 3: self.outer request
  Object call5513 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5512);
// compiled member node returning call5513 (depth = 5)
  Object call5514 = callmethodflags(call5513, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5511);
// compiled member node returning call5514 (depth = 4)
  Object call5515 = callmethodflags(call5514, "abstract", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5510);
// compiled member node returning call5515 (depth = 3)
  gc_frame_end(frame);
  return call5515;
}
Object meth_collectionsPrelude_iterator5516(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 260
  setline(260);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5517 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5518 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5519 = gc_frame_new();
// call case 3: self.outer request
  Object call5520 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5519);
// compiled member node returning call5520 (depth = 5)
  Object call5521 = callmethodflags(call5520, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5518);
// compiled member node returning call5521 (depth = 4)
  Object call5522 = callmethodflags(call5521, "abstract", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5517);
// compiled member node returning call5522 (depth = 3)
  gc_frame_end(frame);
  return call5522;
}
Object meth_collectionsPrelude_isEmpty5523(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 263
  setline(263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5524 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5525 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5526 = gc_frame_new();
// call case 4: self request
  Object call5527 = callmethodflags(self, "iterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5526);
// compiled member node returning call5527 (depth = 5)
  Object call5528 = callmethodflags(call5527, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe5525);
// compiled member node returning call5528 (depth = 4)
  Object call5529 = callmethodflags(call5528, "not", 0, partcv, params, 0);
  gc_frame_end(callframe5524);
// compiled member node returning call5529 (depth = 3)
  gc_frame_end(frame);
  return call5529;
}
Object meth_collectionsPrelude_first5530(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "first");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_it = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "it");
// Begin line 266
  setline(266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5531 = gc_frame_new();
// call case 4: self request
  Object call5532 = callmethodflags(self, "iterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5531);
// compiled member node returning call5532 (depth = 4)
  *var_it = call5532;
  if (call5532 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 267
  setline(267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5534 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_it (depth = 5)
  Object call5535 = callmethodflags(*var_it, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe5534);
// compiled member node returning call5535 (depth = 4)
  Object if5533 = done;
  if (istrue(call5535)) {
// Begin line 268
  setline(268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
  int callframe5536 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_it (depth = 5)
  Object call5537 = callmethodflags(*var_it, "next", 0, partcv, params, 0);
  gc_frame_end(callframe5536);
// compiled member node returning call5537 (depth = 4)
    gc_frame_newslot(call5537);
    if5533 = call5537;
  } else {
// Begin line 270
  setline(270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5538 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5540 == NULL) {
    strlit5540 = alloc_String("");
    gc_root(strlit5540);
  }
// compiled string node returning strlit5540 (depth = 6)
  int op_slot_right_5539 = gc_frame_newslot(strlit5540);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  int op_slot_right_5542 = gc_frame_newslot(self);
// starting to compile string node (depth = 7)
  if (strlit5544 == NULL) {
    strlit5544 = alloc_String("no first element in ");
    gc_root(strlit5544);
  }
// compiled string node returning strlit5544 (depth = 7)
  int op_slot_left_5542 = gc_frame_newslot(strlit5544);
  params[0] = self;
  partcv[0] = 1;
  Object opresult5545 = callmethod(strlit5544, "++(1)", 1, partcv, params);
// compiled op node returning opresult5545 (depth = 6)
  int op_slot_left_5539 = gc_frame_newslot(opresult5545);
  params[0] = strlit5540;
  partcv[0] = 1;
  Object opresult5546 = callmethod(opresult5545, "++(1)", 1, partcv, params);
// compiled op node returning opresult5546 (depth = 5)
  gc_frame_newslot(opresult5546);
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_BoundsError (depth = 5)
  params[0] = opresult5546;
  partcv[0] = 1;
  Object call5547 = callmethodflags(*var_BoundsError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5538);
// compiled call node returning call5547 (depth = 4)
    gc_frame_newslot(call5547);
    if5533 = call5547;
  }
// compiled if node returning if5533 (depth = 3)
  gc_frame_end(frame);
  return if5533;
}
Object meth_collectionsPrelude__apply_40_1_41_5553(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_firstTime = getfromclosure(closure, 0);
  Object *var_block0 = getfromclosure(closure, 1);
  Object *var_block1 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 277
  setline(277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_firstTime (depth = 6)
  Object if5554 = done;
  if (istrue(*var_firstTime)) {
// Begin line 278
  setline(278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool5555 = alloc_Boolean(0);
// compiled identifier node returning bool5555 (depth = 7)
  *var_firstTime = bool5555;
  if (bool5555 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if5554 = done;
  } else {
// Begin line 280
  setline(280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe5557 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_block0 (depth = 7)
  Object call5558 = callmethodflags(*var_block0, "apply", 0, partcv, params, 0);
  gc_frame_end(callframe5557);
// compiled member node returning call5558 (depth = 6)
    gc_frame_newslot(call5558);
    if5554 = call5558;
  }
// compiled if node returning if5554 (depth = 5)
// Begin line 282
  setline(282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5559 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  gc_frame_newslot(*var_each);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block1 (depth = 6)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call5560 = callmethodflags(*var_block1, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5559);
// compiled call node returning call5560 (depth = 5)
  gc_frame_end(frame);
  return call5560;
}
Object meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5548(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do(1)separatedBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)separatedBy(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)separatedBy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for do(_)separatedBy(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *var_block0 = &(stackframe->slots[1]);
  *var_block0 = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part separatedBy(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_firstTime = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "firstTime");
  Object *var_i = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "i");
// Begin line 274
  setline(274);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool5549 = alloc_Boolean(1);
// compiled identifier node returning bool5549 (depth = 4)
  *var_firstTime = bool5549;
  if (bool5549 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 275
  setline(275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5550 = alloc_Float64(0);
// compiled num node returning num5550 (depth = 4)
  *var_i = num5550;
  if (num5550 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 276
  setline(276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5551 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5552 = alloc_Block(NULL, NULL, "collectionsPrelude", 276);
  gc_frame_newslot(block5552);
// method "_apply(_)"
  block_savedest(block5552);
  Object closure5553 = createclosure(4, "_apply(1)");
  setclosureframe(closure5553, stackframe);
  addtoclosure(closure5553, var_firstTime);
  addtoclosure(closure5553, var_block0);
  addtoclosure(closure5553, var_block1);
  addtoclosure(closure5553, selfslot);
  struct UserObject *uo5553 = (struct UserObject*)block5552;
  uo5553->data[0] = (Object)closure5553;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_5553 = addmethod2pos(block5552, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_5553, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_5553[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_5553->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_5553);
  meth_meth_collectionsPrelude__apply_40_1_41_5553->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_5553->definitionLine = 1963;
// compiled block node returning block5552 (depth = 4)
  gc_frame_newslot(block5552);
// call case 4: self request
  params[0] = block5552;
  partcv[0] = 1;
  Object call5562 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5551);
// compiled call node returning call5562 (depth = 3)
// Begin line 284
  setline(284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  return self;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_reduce_40_2_41_5563(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "reduce(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method reduce(_,_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for reduce(_,_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_initial = &(stackframe->slots[0]);
  *var_initial = args[curarg];
  curarg++;
  Object *var_blk = &(stackframe->slots[1]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for part reduce(_,_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 288
  setline(288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5564 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_initial (depth = 4)
  gc_frame_newslot(*var_initial);
// call case 4: self request
  params[0] = *var_blk;
  params[1] = *var_initial;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5565 = callmethodflags(self, "fold(1)startingWith(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5564);
// compiled call node returning call5565 (depth = 3)
  gc_frame_end(frame);
  return call5565;
}
Object meth_collectionsPrelude__apply_40_1_41_5569(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[2];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object *var_blk = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_it = &(stackframe->slots[0]);
  *var_it = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 293
  setline(293);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5570 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_result (depth = 7)
  gc_frame_newslot(*var_result);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_it (depth = 7)
  gc_frame_newslot(*var_it);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  params[0] = *var_result;
  params[1] = *var_it;
  partcv[0] = 2;
  Object call5571 = callmethodflags(*var_blk, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5570);
// compiled call node returning call5571 (depth = 6)
  *var_result = call5571;
  if (call5571 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5566(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "fold(1)startingWith(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method fold(_)startingWith(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method fold(_)startingWith(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for fold(_)startingWith(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part fold(_)");
  Object *var_initial = &(stackframe->slots[1]);
  *var_initial = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part startingWith(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 291
  setline(291);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_initial (depth = 4)
  *var_result = *var_initial;
  if (*var_initial == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 292
  setline(292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5567 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5568 = alloc_Block(NULL, NULL, "collectionsPrelude", 292);
  gc_frame_newslot(block5568);
// method "_apply(_)"
  block_savedest(block5568);
  Object closure5569 = createclosure(3, "_apply(1)");
  setclosureframe(closure5569, stackframe);
  addtoclosure(closure5569, var_result);
  addtoclosure(closure5569, var_blk);
  addtoclosure(closure5569, selfslot);
  struct UserObject *uo5569 = (struct UserObject*)block5568;
  uo5569->data[0] = (Object)closure5569;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_5569 = addmethod2pos(block5568, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_5569, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_5569[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_5569->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_5569);
  meth_meth_collectionsPrelude__apply_40_1_41_5569->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_5569->definitionLine = 1963;
// compiled block node returning block5568 (depth = 4)
  gc_frame_newslot(block5568);
// call case 4: self request
  params[0] = block5568;
  partcv[0] = 1;
  Object call5574 = callmethodflags(self, "do(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5567);
// compiled call node returning call5574 (depth = 3)
// Begin line 295
  setline(295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  return *var_result;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_map_40_1_41_5575(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for map(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part map(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_R = &(stackframe->slots[2]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_R = args[curarg++];
  } else {
    *var_R = Unknown;
  }
// End typeParams
// Begin line 298
  setline(298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5576 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_block1 (depth = 4)
  gc_frame_newslot(*var_block1);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5577 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5578 = gc_frame_new();
// call case 3: self.outer request
  Object call5579 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5578);
// compiled member node returning call5579 (depth = 5)
  Object call5580 = callmethodflags(call5579, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5577);
// compiled member node returning call5580 (depth = 4)
  params[0] = self;
  params[1] = *var_block1;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5581 = callmethodflags(call5580, "lazySequenceOver(1)mappedBy(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5576);
// compiled call node returning call5581 (depth = 3)
  gc_frame_end(frame);
  return call5581;
}
Object meth_collectionsPrelude_filter_40_1_41_5582(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "filter(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method filter(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for filter(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_selectionCondition = &(stackframe->slots[0]);
  *var_selectionCondition = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part filter(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 301
  setline(301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5583 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_selectionCondition (depth = 4)
  gc_frame_newslot(*var_selectionCondition);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5584 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5585 = gc_frame_new();
// call case 3: self.outer request
  Object call5586 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5585);
// compiled member node returning call5586 (depth = 5)
  Object call5587 = callmethodflags(call5586, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5584);
// compiled member node returning call5587 (depth = 4)
  params[0] = self;
  params[1] = *var_selectionCondition;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5588 = callmethodflags(call5587, "lazySequenceOver(1)filteredBy(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5583);
// compiled call node returning call5588 (depth = 3)
  gc_frame_end(frame);
  return call5588;
}
Object meth_collectionsPrelude_iter5589(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iter");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 304
  setline(304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5590 = gc_frame_new();
// call case 4: self request
  Object call5591 = callmethodflags(self, "iterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5590);
// compiled member node returning call5591 (depth = 3)
  gc_frame_end(frame);
  return call5591;
}
Object meth_collectionsPrelude_asSequence5592(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asSequence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 307
  setline(307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5593 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5594 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5595 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5596 = gc_frame_new();
// call case 3: self.outer request
  Object call5597 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5596);
// compiled member node returning call5597 (depth = 6)
  Object call5598 = callmethodflags(call5597, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5595);
// compiled member node returning call5598 (depth = 5)
  Object call5599 = callmethodflags(call5598, "sequence", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5594);
// compiled member node returning call5599 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5600 = callmethodflags(call5599, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5593);
// compiled call node returning call5600 (depth = 3)
  gc_frame_end(frame);
  return call5600;
}
Object meth_collectionsPrelude_asList5601(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asList");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 310
  setline(310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5602 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5603 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5604 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5605 = gc_frame_new();
// call case 3: self.outer request
  Object call5606 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5605);
// compiled member node returning call5606 (depth = 6)
  Object call5607 = callmethodflags(call5606, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5604);
// compiled member node returning call5607 (depth = 5)
  Object call5608 = callmethodflags(call5607, "list", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5603);
// compiled member node returning call5608 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5609 = callmethodflags(call5608, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5602);
// compiled call node returning call5609 (depth = 3)
  gc_frame_end(frame);
  return call5609;
}
Object meth_collectionsPrelude_asSet5610(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asSet");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 313
  setline(313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5611 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5612 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5613 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5614 = gc_frame_new();
// call case 3: self.outer request
  Object call5615 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5614);
// compiled member node returning call5615 (depth = 6)
  Object call5616 = callmethodflags(call5615, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5613);
// compiled member node returning call5616 (depth = 5)
  Object call5617 = callmethodflags(call5616, "set", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5612);
// compiled member node returning call5617 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5618 = callmethodflags(call5617, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5611);
// compiled call node returning call5618 (depth = 3)
  gc_frame_end(frame);
  return call5618;
}
Object meth_collectionsPrelude_TRAIT5497(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "TRAIT");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5498 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5498 = alloc_userobj2(16,17, objclass5498);
  gc_frame_newslot(obj5498);
if (objclass5498 == NULL) {
  glfree(obj5498->class->name);
  obj5498->class->name = "collection.collection.TRAIT";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5498, self, 0);
  addmethodreal(obj5498,"outer", &reader_collectionsPrelude_outer_5499);
  Object oldself5498 = self;
  struct StackFrameObject *oldstackframe5498 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5498);
  gc_frame_newslot((Object)stackframe);
  self = obj5498;
  Object *oldselfslot5498 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5498 = (*(struct UserObject *)self).data[0], lowerouter5498 = thisouter5498;
  if (inheritingObject5498) {
    struct UserObject *inho5498 = (struct UserObject *)inheritingObject5498;
    while (inho5498->super != GraceDefaultObject) inho5498 = (struct UserObject *)inho5498->super;
    inho5498->super = obj5498;
    self = inheritingObject5498;
    *selfslot = self;
    lowerouter5498 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5498;
  }
// method "asString"
  struct UserObject *uo5500 = (struct UserObject*)obj5498;
  uo5500->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString5500 = addmethod2pos(obj5498, "asString", &meth_collectionsPrelude_asString5500, 1);
  int argcv_meth_collectionsPrelude_asString5500[] = {0};
  meth_meth_collectionsPrelude_asString5500->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5500);
  meth_meth_collectionsPrelude_asString5500->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5500->definitionLine = 252;
// method "sizeIfUnknown(_)"
  struct UserObject *uo5502 = (struct UserObject*)obj5498;
  uo5502->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sizeIfUnknown_40_1_41_5502 = addmethod2pos(obj5498, "sizeIfUnknown(1)", &meth_collectionsPrelude_sizeIfUnknown_40_1_41_5502, 2);
  int argcv_meth_collectionsPrelude_sizeIfUnknown_40_1_41_5502[] = {1};
  meth_meth_collectionsPrelude_sizeIfUnknown_40_1_41_5502->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sizeIfUnknown_40_1_41_5502);
  meth_meth_collectionsPrelude_sizeIfUnknown_40_1_41_5502->definitionModule = modulename;
  meth_meth_collectionsPrelude_sizeIfUnknown_40_1_41_5502->definitionLine = 253;
// method "size"
  block_savedest(obj5498);
  Object closure5505 = createclosure(1, "size");
  setclosureframe(closure5505, stackframe);
  addtoclosure(closure5505, var_SizeUnknown);
  struct UserObject *uo5505 = (struct UserObject*)obj5498;
  uo5505->data[3] = (Object)closure5505;
  Method *meth_meth_collectionsPrelude_size5505 = addmethod2pos(obj5498, "size", &meth_collectionsPrelude_size5505, 3);
  int argcv_meth_collectionsPrelude_size5505[] = {0};
  meth_meth_collectionsPrelude_size5505->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size5505);
  meth_meth_collectionsPrelude_size5505->definitionModule = modulename;
  meth_meth_collectionsPrelude_size5505->definitionLine = 256;
// method "do"
  struct UserObject *uo5509 = (struct UserObject*)obj5498;
  uo5509->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do5509 = addmethod2pos(obj5498, "do", &meth_collectionsPrelude_do5509, 4);
  int argcv_meth_collectionsPrelude_do5509[] = {0};
  meth_meth_collectionsPrelude_do5509->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do5509);
  meth_meth_collectionsPrelude_do5509->definitionModule = modulename;
  meth_meth_collectionsPrelude_do5509->definitionLine = 259;
// method "iterator"
  struct UserObject *uo5516 = (struct UserObject*)obj5498;
  uo5516->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iterator5516 = addmethod2pos(obj5498, "iterator", &meth_collectionsPrelude_iterator5516, 5);
  int argcv_meth_collectionsPrelude_iterator5516[] = {0};
  meth_meth_collectionsPrelude_iterator5516->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator5516);
  meth_meth_collectionsPrelude_iterator5516->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator5516->definitionLine = 260;
// method "isEmpty"
  struct UserObject *uo5523 = (struct UserObject*)obj5498;
  uo5523->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isEmpty5523 = addmethod2pos(obj5498, "isEmpty", &meth_collectionsPrelude_isEmpty5523, 6);
  int argcv_meth_collectionsPrelude_isEmpty5523[] = {0};
  meth_meth_collectionsPrelude_isEmpty5523->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isEmpty5523);
  meth_meth_collectionsPrelude_isEmpty5523->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEmpty5523->definitionLine = 261;
// method "first"
  block_savedest(obj5498);
  Object closure5530 = createclosure(1, "first");
  setclosureframe(closure5530, stackframe);
  addtoclosure(closure5530, var_BoundsError);
  struct UserObject *uo5530 = (struct UserObject*)obj5498;
  uo5530->data[7] = (Object)closure5530;
  Method *meth_meth_collectionsPrelude_first5530 = addmethod2pos(obj5498, "first", &meth_collectionsPrelude_first5530, 7);
  int argcv_meth_collectionsPrelude_first5530[] = {0};
  meth_meth_collectionsPrelude_first5530->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_first5530);
  meth_meth_collectionsPrelude_first5530->definitionModule = modulename;
  meth_meth_collectionsPrelude_first5530->definitionLine = 265;
// method "do(_)separatedBy(_)"
  struct UserObject *uo5548 = (struct UserObject*)obj5498;
  uo5548->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5548 = addmethod2pos(obj5498, "do(1)separatedBy(1)", &meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5548, 8);
  int argcv_meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5548[] = {1, 1};
  meth_meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5548->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5548);
  meth_meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5548->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5548->definitionLine = 273;
// method "reduce(_,_)"
  struct UserObject *uo5563 = (struct UserObject*)obj5498;
  uo5563->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reduce_40_2_41_5563 = addmethod2pos(obj5498, "reduce(2)", &meth_collectionsPrelude_reduce_40_2_41_5563, 9);
  int argcv_meth_collectionsPrelude_reduce_40_2_41_5563[] = {2};
  meth_meth_collectionsPrelude_reduce_40_2_41_5563->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reduce_40_2_41_5563);
  meth_meth_collectionsPrelude_reduce_40_2_41_5563->definitionModule = modulename;
  meth_meth_collectionsPrelude_reduce_40_2_41_5563->definitionLine = 286;
// method "fold(_)startingWith(_)"
  struct UserObject *uo5566 = (struct UserObject*)obj5498;
  uo5566->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5566 = addmethod2pos(obj5498, "fold(1)startingWith(1)", &meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5566, 10);
  int argcv_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5566[] = {1, 1};
  meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5566->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5566);
  meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5566->definitionModule = modulename;
  meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5566->definitionLine = 290;
// method "map(_)"
  struct UserObject *uo5575 = (struct UserObject*)obj5498;
  uo5575->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_map_40_1_41_5575 = addmethod2pos(obj5498, "map(1)", &meth_collectionsPrelude_map_40_1_41_5575, 11);
  int argcv_meth_collectionsPrelude_map_40_1_41_5575[] = {1};
  meth_meth_collectionsPrelude_map_40_1_41_5575->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_map_40_1_41_5575);
  meth_meth_collectionsPrelude_map_40_1_41_5575->definitionModule = modulename;
  meth_meth_collectionsPrelude_map_40_1_41_5575->definitionLine = 297;
// method "filter(_)"
  struct UserObject *uo5582 = (struct UserObject*)obj5498;
  uo5582->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_filter_40_1_41_5582 = addmethod2pos(obj5498, "filter(1)", &meth_collectionsPrelude_filter_40_1_41_5582, 12);
  int argcv_meth_collectionsPrelude_filter_40_1_41_5582[] = {1};
  meth_meth_collectionsPrelude_filter_40_1_41_5582->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_filter_40_1_41_5582);
  meth_meth_collectionsPrelude_filter_40_1_41_5582->definitionModule = modulename;
  meth_meth_collectionsPrelude_filter_40_1_41_5582->definitionLine = 300;
// method "iter"
  struct UserObject *uo5589 = (struct UserObject*)obj5498;
  uo5589->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iter5589 = addmethod2pos(obj5498, "iter", &meth_collectionsPrelude_iter5589, 13);
  int argcv_meth_collectionsPrelude_iter5589[] = {0};
  meth_meth_collectionsPrelude_iter5589->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iter5589);
  meth_meth_collectionsPrelude_iter5589->definitionModule = modulename;
  meth_meth_collectionsPrelude_iter5589->definitionLine = 304;
// method "asSequence"
  struct UserObject *uo5592 = (struct UserObject*)obj5498;
  uo5592->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSequence5592 = addmethod2pos(obj5498, "asSequence", &meth_collectionsPrelude_asSequence5592, 14);
  int argcv_meth_collectionsPrelude_asSequence5592[] = {0};
  meth_meth_collectionsPrelude_asSequence5592->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSequence5592);
  meth_meth_collectionsPrelude_asSequence5592->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSequence5592->definitionLine = 306;
// method "asList"
  struct UserObject *uo5601 = (struct UserObject*)obj5498;
  uo5601->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asList5601 = addmethod2pos(obj5498, "asList", &meth_collectionsPrelude_asList5601, 15);
  int argcv_meth_collectionsPrelude_asList5601[] = {0};
  meth_meth_collectionsPrelude_asList5601->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asList5601);
  meth_meth_collectionsPrelude_asList5601->definitionModule = modulename;
  meth_meth_collectionsPrelude_asList5601->definitionLine = 309;
// method "asSet"
  struct UserObject *uo5610 = (struct UserObject*)obj5498;
  uo5610->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSet5610 = addmethod2pos(obj5498, "asSet", &meth_collectionsPrelude_asSet5610, 16);
  int argcv_meth_collectionsPrelude_asSet5610[] = {0};
  meth_meth_collectionsPrelude_asSet5610->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSet5610);
  meth_meth_collectionsPrelude_asSet5610->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSet5610->definitionLine = 312;
  sourceObject = obj5498;
  sourceObject = obj5498;
  sourceObject = obj5498;
  sourceObject = obj5498;
  sourceObject = obj5498;
  sourceObject = obj5498;
  sourceObject = obj5498;
  sourceObject = obj5498;
  sourceObject = obj5498;
  sourceObject = obj5498;
  sourceObject = obj5498;
  sourceObject = obj5498;
  sourceObject = obj5498;
  sourceObject = obj5498;
  sourceObject = obj5498;
  sourceObject = obj5498;
  objclass5498 = obj5498->class;
  objclass5498->definitionModule = modulename;
  objclass5498->definitionLine = 250;
  (*(struct UserObject *)self).data[0] = lowerouter5498;
  self = oldself5498;
  selfslot = oldselfslot5498;
  stackframe = oldstackframe5498;
  gc_frame_end(frame);
  return obj5498;
}
Object meth_collectionsPrelude_TRAIT5497_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "TRAIT$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5498 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5498 = alloc_userobj2(16,17, objclass5498);
  gc_frame_newslot(obj5498);
if (objclass5498 == NULL) {
  glfree(obj5498->class->name);
  obj5498->class->name = "collection.collection.TRAIT";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5498, self, 0);
  addmethodreal(obj5498,"outer", &reader_collectionsPrelude_outer_5499);
  Object oldself5498 = self;
  struct StackFrameObject *oldstackframe5498 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5498);
  gc_frame_newslot((Object)stackframe);
  self = obj5498;
  Object *oldselfslot5498 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5498 = (*(struct UserObject *)self).data[0], lowerouter5498 = thisouter5498;
  if (inheritingObject5498) {
    struct UserObject *inho5498 = (struct UserObject *)inheritingObject5498;
    while (inho5498->super != GraceDefaultObject) inho5498 = (struct UserObject *)inho5498->super;
    inho5498->super = obj5498;
    self = inheritingObject5498;
    *selfslot = self;
    lowerouter5498 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5498;
  }
// method "asString"
  struct UserObject *uo5500 = (struct UserObject*)obj5498;
  uo5500->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString5500 = addmethod2pos(obj5498, "asString", &meth_collectionsPrelude_asString5500, 1);
  int argcv_meth_collectionsPrelude_asString5500[] = {0};
  meth_meth_collectionsPrelude_asString5500->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5500);
  meth_meth_collectionsPrelude_asString5500->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5500->definitionLine = 252;
// method "sizeIfUnknown(_)"
  struct UserObject *uo5502 = (struct UserObject*)obj5498;
  uo5502->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sizeIfUnknown_40_1_41_5502 = addmethod2pos(obj5498, "sizeIfUnknown(1)", &meth_collectionsPrelude_sizeIfUnknown_40_1_41_5502, 2);
  int argcv_meth_collectionsPrelude_sizeIfUnknown_40_1_41_5502[] = {1};
  meth_meth_collectionsPrelude_sizeIfUnknown_40_1_41_5502->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sizeIfUnknown_40_1_41_5502);
  meth_meth_collectionsPrelude_sizeIfUnknown_40_1_41_5502->definitionModule = modulename;
  meth_meth_collectionsPrelude_sizeIfUnknown_40_1_41_5502->definitionLine = 253;
// method "size"
  block_savedest(obj5498);
  Object closure5505 = createclosure(1, "size");
  setclosureframe(closure5505, stackframe);
  addtoclosure(closure5505, var_SizeUnknown);
  struct UserObject *uo5505 = (struct UserObject*)obj5498;
  uo5505->data[3] = (Object)closure5505;
  Method *meth_meth_collectionsPrelude_size5505 = addmethod2pos(obj5498, "size", &meth_collectionsPrelude_size5505, 3);
  int argcv_meth_collectionsPrelude_size5505[] = {0};
  meth_meth_collectionsPrelude_size5505->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size5505);
  meth_meth_collectionsPrelude_size5505->definitionModule = modulename;
  meth_meth_collectionsPrelude_size5505->definitionLine = 256;
// method "do"
  struct UserObject *uo5509 = (struct UserObject*)obj5498;
  uo5509->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do5509 = addmethod2pos(obj5498, "do", &meth_collectionsPrelude_do5509, 4);
  int argcv_meth_collectionsPrelude_do5509[] = {0};
  meth_meth_collectionsPrelude_do5509->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do5509);
  meth_meth_collectionsPrelude_do5509->definitionModule = modulename;
  meth_meth_collectionsPrelude_do5509->definitionLine = 259;
// method "iterator"
  struct UserObject *uo5516 = (struct UserObject*)obj5498;
  uo5516->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iterator5516 = addmethod2pos(obj5498, "iterator", &meth_collectionsPrelude_iterator5516, 5);
  int argcv_meth_collectionsPrelude_iterator5516[] = {0};
  meth_meth_collectionsPrelude_iterator5516->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator5516);
  meth_meth_collectionsPrelude_iterator5516->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator5516->definitionLine = 260;
// method "isEmpty"
  struct UserObject *uo5523 = (struct UserObject*)obj5498;
  uo5523->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isEmpty5523 = addmethod2pos(obj5498, "isEmpty", &meth_collectionsPrelude_isEmpty5523, 6);
  int argcv_meth_collectionsPrelude_isEmpty5523[] = {0};
  meth_meth_collectionsPrelude_isEmpty5523->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isEmpty5523);
  meth_meth_collectionsPrelude_isEmpty5523->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEmpty5523->definitionLine = 261;
// method "first"
  block_savedest(obj5498);
  Object closure5530 = createclosure(1, "first");
  setclosureframe(closure5530, stackframe);
  addtoclosure(closure5530, var_BoundsError);
  struct UserObject *uo5530 = (struct UserObject*)obj5498;
  uo5530->data[7] = (Object)closure5530;
  Method *meth_meth_collectionsPrelude_first5530 = addmethod2pos(obj5498, "first", &meth_collectionsPrelude_first5530, 7);
  int argcv_meth_collectionsPrelude_first5530[] = {0};
  meth_meth_collectionsPrelude_first5530->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_first5530);
  meth_meth_collectionsPrelude_first5530->definitionModule = modulename;
  meth_meth_collectionsPrelude_first5530->definitionLine = 265;
// method "do(_)separatedBy(_)"
  struct UserObject *uo5548 = (struct UserObject*)obj5498;
  uo5548->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5548 = addmethod2pos(obj5498, "do(1)separatedBy(1)", &meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5548, 8);
  int argcv_meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5548[] = {1, 1};
  meth_meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5548->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5548);
  meth_meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5548->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_separatedBy_40_1_41_5548->definitionLine = 273;
// method "reduce(_,_)"
  struct UserObject *uo5563 = (struct UserObject*)obj5498;
  uo5563->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reduce_40_2_41_5563 = addmethod2pos(obj5498, "reduce(2)", &meth_collectionsPrelude_reduce_40_2_41_5563, 9);
  int argcv_meth_collectionsPrelude_reduce_40_2_41_5563[] = {2};
  meth_meth_collectionsPrelude_reduce_40_2_41_5563->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reduce_40_2_41_5563);
  meth_meth_collectionsPrelude_reduce_40_2_41_5563->definitionModule = modulename;
  meth_meth_collectionsPrelude_reduce_40_2_41_5563->definitionLine = 286;
// method "fold(_)startingWith(_)"
  struct UserObject *uo5566 = (struct UserObject*)obj5498;
  uo5566->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5566 = addmethod2pos(obj5498, "fold(1)startingWith(1)", &meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5566, 10);
  int argcv_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5566[] = {1, 1};
  meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5566->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5566);
  meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5566->definitionModule = modulename;
  meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5566->definitionLine = 290;
// method "map(_)"
  struct UserObject *uo5575 = (struct UserObject*)obj5498;
  uo5575->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_map_40_1_41_5575 = addmethod2pos(obj5498, "map(1)", &meth_collectionsPrelude_map_40_1_41_5575, 11);
  int argcv_meth_collectionsPrelude_map_40_1_41_5575[] = {1};
  meth_meth_collectionsPrelude_map_40_1_41_5575->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_map_40_1_41_5575);
  meth_meth_collectionsPrelude_map_40_1_41_5575->definitionModule = modulename;
  meth_meth_collectionsPrelude_map_40_1_41_5575->definitionLine = 297;
// method "filter(_)"
  struct UserObject *uo5582 = (struct UserObject*)obj5498;
  uo5582->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_filter_40_1_41_5582 = addmethod2pos(obj5498, "filter(1)", &meth_collectionsPrelude_filter_40_1_41_5582, 12);
  int argcv_meth_collectionsPrelude_filter_40_1_41_5582[] = {1};
  meth_meth_collectionsPrelude_filter_40_1_41_5582->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_filter_40_1_41_5582);
  meth_meth_collectionsPrelude_filter_40_1_41_5582->definitionModule = modulename;
  meth_meth_collectionsPrelude_filter_40_1_41_5582->definitionLine = 300;
// method "iter"
  struct UserObject *uo5589 = (struct UserObject*)obj5498;
  uo5589->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iter5589 = addmethod2pos(obj5498, "iter", &meth_collectionsPrelude_iter5589, 13);
  int argcv_meth_collectionsPrelude_iter5589[] = {0};
  meth_meth_collectionsPrelude_iter5589->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iter5589);
  meth_meth_collectionsPrelude_iter5589->definitionModule = modulename;
  meth_meth_collectionsPrelude_iter5589->definitionLine = 304;
// method "asSequence"
  struct UserObject *uo5592 = (struct UserObject*)obj5498;
  uo5592->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSequence5592 = addmethod2pos(obj5498, "asSequence", &meth_collectionsPrelude_asSequence5592, 14);
  int argcv_meth_collectionsPrelude_asSequence5592[] = {0};
  meth_meth_collectionsPrelude_asSequence5592->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSequence5592);
  meth_meth_collectionsPrelude_asSequence5592->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSequence5592->definitionLine = 306;
// method "asList"
  struct UserObject *uo5601 = (struct UserObject*)obj5498;
  uo5601->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asList5601 = addmethod2pos(obj5498, "asList", &meth_collectionsPrelude_asList5601, 15);
  int argcv_meth_collectionsPrelude_asList5601[] = {0};
  meth_meth_collectionsPrelude_asList5601->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asList5601);
  meth_meth_collectionsPrelude_asList5601->definitionModule = modulename;
  meth_meth_collectionsPrelude_asList5601->definitionLine = 309;
// method "asSet"
  struct UserObject *uo5610 = (struct UserObject*)obj5498;
  uo5610->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSet5610 = addmethod2pos(obj5498, "asSet", &meth_collectionsPrelude_asSet5610, 16);
  int argcv_meth_collectionsPrelude_asSet5610[] = {0};
  meth_meth_collectionsPrelude_asSet5610->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSet5610);
  meth_meth_collectionsPrelude_asSet5610->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSet5610->definitionLine = 312;
  sourceObject = obj5498;
  sourceObject = obj5498;
  sourceObject = obj5498;
  sourceObject = obj5498;
  sourceObject = obj5498;
  sourceObject = obj5498;
  sourceObject = obj5498;
  sourceObject = obj5498;
  sourceObject = obj5498;
  sourceObject = obj5498;
  sourceObject = obj5498;
  sourceObject = obj5498;
  sourceObject = obj5498;
  sourceObject = obj5498;
  sourceObject = obj5498;
  sourceObject = obj5498;
  objclass5498 = obj5498->class;
  objclass5498->definitionModule = modulename;
  objclass5498->definitionLine = 250;
  (*(struct UserObject *)self).data[0] = lowerouter5498;
  self = oldself5498;
  selfslot = oldselfslot5498;
  stackframe = oldstackframe5498;
  gc_frame_end(frame);
  return obj5498;
}
Object meth_collectionsPrelude_asString5620(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 250
  setline(250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5621 == NULL) {
    strlit5621 = alloc_String("class collection");
    gc_root(strlit5621);
  }
// compiled string node returning strlit5621 (depth = 3)
  gc_frame_end(frame);
  return strlit5621;
}
Object meth_collectionsPrelude_collection5622(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 33, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "collection");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_collection = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 250
  setline(250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_collection (depth = 3)
  gc_frame_end(frame);
  return *var_collection;
}
Object meth_collectionsPrelude_iterator5628(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 319
  setline(319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5629 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5630 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5631 = gc_frame_new();
// call case 3: self.outer request
  Object call5632 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5631);
// compiled member node returning call5632 (depth = 5)
  Object call5633 = callmethodflags(call5632, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5630);
// compiled member node returning call5633 (depth = 4)
  Object call5634 = callmethodflags(call5633, "abstract", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5629);
// compiled member node returning call5634 (depth = 3)
  gc_frame_end(frame);
  return call5634;
}
Object meth_collectionsPrelude_size5635(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 322
  setline(322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5636 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5638 == NULL) {
    strlit5638 = alloc_String("");
    gc_root(strlit5638);
  }
// compiled string node returning strlit5638 (depth = 5)
  int op_slot_right_5637 = gc_frame_newslot(strlit5638);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
  int callframe5641 = gc_frame_new();
// call case 4: self request
  Object call5642 = callmethodflags(self, "asDebugString", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5641);
// compiled member node returning call5642 (depth = 6)
  int op_slot_right_5640 = gc_frame_newslot(call5642);
// starting to compile string node (depth = 6)
  if (strlit5644 == NULL) {
    strlit5644 = alloc_String("size requested on ");
    gc_root(strlit5644);
  }
// compiled string node returning strlit5644 (depth = 6)
  int op_slot_left_5640 = gc_frame_newslot(strlit5644);
  params[0] = call5642;
  partcv[0] = 1;
  Object opresult5645 = callmethod(strlit5644, "++(1)", 1, partcv, params);
// compiled op node returning opresult5645 (depth = 5)
  int op_slot_left_5637 = gc_frame_newslot(opresult5645);
  params[0] = strlit5638;
  partcv[0] = 1;
  Object opresult5646 = callmethod(opresult5645, "++(1)", 1, partcv, params);
// compiled op node returning opresult5646 (depth = 4)
  gc_frame_newslot(opresult5646);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_SizeUnknown (depth = 4)
  params[0] = opresult5646;
  partcv[0] = 1;
  Object call5647 = callmethodflags(*var_SizeUnknown, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5636);
// compiled call node returning call5647 (depth = 3)
  gc_frame_end(frame);
  return call5647;
}
Object meth_collectionsPrelude__apply_40_2_41_5659(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 327
  setline(327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5660 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  gc_frame_newslot(*var_k);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_result (depth = 6)
  params[0] = *var_k;
  params[1] = *var_v;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5661 = callmethodflags(*var_result, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5660);
// compiled call node returning call5661 (depth = 5)
  gc_frame_end(frame);
  return call5661;
}
Object meth_collectionsPrelude_asDictionary5648(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDictionary");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 325
  setline(325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5649 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5650 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5651 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe5652 = gc_frame_new();
// call case 3: self.outer request
  Object call5653 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5652);
// compiled member node returning call5653 (depth = 7)
  Object call5654 = callmethodflags(call5653, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5651);
// compiled member node returning call5654 (depth = 6)
  Object call5655 = callmethodflags(call5654, "dictionary", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5650);
// compiled member node returning call5655 (depth = 5)
  Object call5656 = callmethodflags(call5655, "empty", 0, partcv, params, 0);
  gc_frame_end(callframe5649);
// compiled member node returning call5656 (depth = 4)
  *var_result = call5656;
  if (call5656 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 326
  setline(326);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5657 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5658 = alloc_Block(NULL, NULL, "collectionsPrelude", 326);
  gc_frame_newslot(block5658);
// method "_apply(_,_)"
  block_savedest(block5658);
  Object closure5659 = createclosure(2, "_apply(2)");
  setclosureframe(closure5659, stackframe);
  addtoclosure(closure5659, var_result);
  addtoclosure(closure5659, selfslot);
  struct UserObject *uo5659 = (struct UserObject*)block5658;
  uo5659->data[0] = (Object)closure5659;
  Method *meth_meth_collectionsPrelude__apply_40_2_41_5659 = addmethod2pos(block5658, "_apply(2)", &meth_collectionsPrelude__apply_40_2_41_5659, 0);
  int argcv_meth_collectionsPrelude__apply_40_2_41_5659[] = {2};
  meth_meth_collectionsPrelude__apply_40_2_41_5659->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_2_41_5659);
  meth_meth_collectionsPrelude__apply_40_2_41_5659->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_2_41_5659->definitionLine = 1963;
// compiled block node returning block5658 (depth = 4)
  gc_frame_newslot(block5658);
// call case 4: self request
  params[0] = block5658;
  partcv[0] = 1;
  Object call5663 = callmethodflags(self, "keysAndValuesDo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5657);
// compiled call node returning call5663 (depth = 3)
// Begin line 329
  setline(329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  return *var_result;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply5669(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
  int callframe5670 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_selfIterator (depth = 6)
  Object call5671 = callmethodflags(*var_selfIterator, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe5670);
// compiled member node returning call5671 (depth = 5)
  gc_frame_end(frame);
  return call5671;
}
Object meth_collectionsPrelude__apply5674(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object *var_existing = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 334
  setline(334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5675 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe5676 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_selfIterator (depth = 7)
  Object call5677 = callmethodflags(*var_selfIterator, "next", 0, partcv, params, 0);
  gc_frame_end(callframe5676);
// compiled member node returning call5677 (depth = 6)
  gc_frame_newslot(call5677);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_existing (depth = 6)
  params[0] = call5677;
  partcv[0] = 1;
  Object call5678 = callmethodflags(*var_existing, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5675);
// compiled call node returning call5678 (depth = 5)
  gc_frame_end(frame);
  return call5678;
}
Object meth_collectionsPrelude_into_40_1_41_5664(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "into(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method into(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for into(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_existing = &(stackframe->slots[0]);
  *var_existing = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part into(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_selfIterator = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "selfIterator");
// Begin line 332
  setline(332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5665 = gc_frame_new();
// call case 4: self request
  Object call5666 = callmethodflags(self, "iterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5665);
// compiled member node returning call5666 (depth = 4)
  *var_selfIterator = call5666;
  if (call5666 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 333
  setline(333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5667 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5668 = alloc_Block(NULL, NULL, "collectionsPrelude", 333);
  gc_frame_newslot(block5668);
// method "_apply"
  block_savedest(block5668);
  Object closure5669 = createclosure(2, "_apply");
  setclosureframe(closure5669, stackframe);
  addtoclosure(closure5669, var_selfIterator);
  addtoclosure(closure5669, selfslot);
  struct UserObject *uo5669 = (struct UserObject*)block5668;
  uo5669->data[0] = (Object)closure5669;
  Method *meth_meth_collectionsPrelude__apply5669 = addmethod2pos(block5668, "_apply", &meth_collectionsPrelude__apply5669, 0);
  int argcv_meth_collectionsPrelude__apply5669[] = {0};
  meth_meth_collectionsPrelude__apply5669->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5669);
  meth_meth_collectionsPrelude__apply5669->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5669->definitionLine = 1963;
// compiled block node returning block5668 (depth = 4)
  gc_frame_newslot(block5668);
// starting to compile block node (depth = 4)
  Object block5673 = alloc_Block(NULL, NULL, "collectionsPrelude", 333);
  gc_frame_newslot(block5673);
// method "_apply"
  block_savedest(block5673);
  Object closure5674 = createclosure(3, "_apply");
  setclosureframe(closure5674, stackframe);
  addtoclosure(closure5674, var_selfIterator);
  addtoclosure(closure5674, var_existing);
  addtoclosure(closure5674, selfslot);
  struct UserObject *uo5674 = (struct UserObject*)block5673;
  uo5674->data[0] = (Object)closure5674;
  Method *meth_meth_collectionsPrelude__apply5674 = addmethod2pos(block5673, "_apply", &meth_collectionsPrelude__apply5674, 0);
  int argcv_meth_collectionsPrelude__apply5674[] = {0};
  meth_meth_collectionsPrelude__apply5674->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5674);
  meth_meth_collectionsPrelude__apply5674->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5674->definitionLine = 1963;
// compiled block node returning block5673 (depth = 4)
  gc_frame_newslot(block5673);
// call case 5: prelude request
  params[0] = block5668;
  params[1] = block5673;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5680 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5667);
// compiled call node returning call5680 (depth = 3)
// Begin line 336
  setline(336);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_existing (depth = 3)
  gc_frame_end(frame);
  return *var_existing;
}
Object meth_collectionsPrelude__61__61__40_1_41_5681(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 339
  setline(339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5682 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5683 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5684 = gc_frame_new();
// call case 3: self.outer request
  Object call5685 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5684);
// compiled member node returning call5685 (depth = 5)
  Object call5686 = callmethodflags(call5685, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5683);
// compiled member node returning call5686 (depth = 4)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5687 = callmethodflags(call5686, "isEqual(1)toIterable(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5682);
// compiled call node returning call5687 (depth = 3)
  gc_frame_end(frame);
  return call5687;
}
Object meth_collectionsPrelude__apply5693(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
  int callframe5694 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_selfIterator (depth = 6)
  Object call5695 = callmethodflags(*var_selfIterator, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe5694);
// compiled member node returning call5695 (depth = 5)
  gc_frame_end(frame);
  return call5695;
}
Object meth_collectionsPrelude__apply5698(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object *var_block1 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 344
  setline(344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5699 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe5700 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_selfIterator (depth = 7)
  Object call5701 = callmethodflags(*var_selfIterator, "next", 0, partcv, params, 0);
  gc_frame_end(callframe5700);
// compiled member node returning call5701 (depth = 6)
  gc_frame_newslot(call5701);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block1 (depth = 6)
  params[0] = call5701;
  partcv[0] = 1;
  Object call5702 = callmethodflags(*var_block1, "apply(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5699);
// compiled call node returning call5702 (depth = 5)
  gc_frame_end(frame);
  return call5702;
}
Object meth_collectionsPrelude_do_40_1_41_5688(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_selfIterator = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "selfIterator");
// Begin line 342
  setline(342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5689 = gc_frame_new();
// call case 4: self request
  Object call5690 = callmethodflags(self, "iterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5689);
// compiled member node returning call5690 (depth = 4)
  *var_selfIterator = call5690;
  if (call5690 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 343
  setline(343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5691 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5692 = alloc_Block(NULL, NULL, "collectionsPrelude", 343);
  gc_frame_newslot(block5692);
// method "_apply"
  block_savedest(block5692);
  Object closure5693 = createclosure(2, "_apply");
  setclosureframe(closure5693, stackframe);
  addtoclosure(closure5693, var_selfIterator);
  addtoclosure(closure5693, selfslot);
  struct UserObject *uo5693 = (struct UserObject*)block5692;
  uo5693->data[0] = (Object)closure5693;
  Method *meth_meth_collectionsPrelude__apply5693 = addmethod2pos(block5692, "_apply", &meth_collectionsPrelude__apply5693, 0);
  int argcv_meth_collectionsPrelude__apply5693[] = {0};
  meth_meth_collectionsPrelude__apply5693->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5693);
  meth_meth_collectionsPrelude__apply5693->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5693->definitionLine = 1963;
// compiled block node returning block5692 (depth = 4)
  gc_frame_newslot(block5692);
// starting to compile block node (depth = 4)
  Object block5697 = alloc_Block(NULL, NULL, "collectionsPrelude", 343);
  gc_frame_newslot(block5697);
// method "_apply"
  block_savedest(block5697);
  Object closure5698 = createclosure(3, "_apply");
  setclosureframe(closure5698, stackframe);
  addtoclosure(closure5698, var_selfIterator);
  addtoclosure(closure5698, var_block1);
  addtoclosure(closure5698, selfslot);
  struct UserObject *uo5698 = (struct UserObject*)block5697;
  uo5698->data[0] = (Object)closure5698;
  Method *meth_meth_collectionsPrelude__apply5698 = addmethod2pos(block5697, "_apply", &meth_collectionsPrelude__apply5698, 0);
  int argcv_meth_collectionsPrelude__apply5698[] = {0};
  meth_meth_collectionsPrelude__apply5698->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5698);
  meth_meth_collectionsPrelude__apply5698->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5698->definitionLine = 1963;
// compiled block node returning block5697 (depth = 4)
  gc_frame_newslot(block5697);
// call case 5: prelude request
  params[0] = block5692;
  params[1] = block5697;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5704 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5691);
// compiled call node returning call5704 (depth = 3)
  gc_frame_end(frame);
  return call5704;
}
Object meth_collectionsPrelude__apply5711(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
  int callframe5712 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_selfIterator (depth = 6)
  Object call5713 = callmethodflags(*var_selfIterator, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe5712);
// compiled member node returning call5713 (depth = 5)
  gc_frame_end(frame);
  return call5713;
}
Object meth_collectionsPrelude__apply5716(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_selfIterator = getfromclosure(closure, 1);
  Object *var_block2 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 351
  setline(351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num5718 = alloc_Float64(1);
// compiled num node returning num5718 (depth = 7)
  int op_slot_right_5717 = gc_frame_newslot(num5718);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  int op_slot_left_5717 = gc_frame_newslot(*var_ix);
  params[0] = num5718;
  partcv[0] = 1;
  Object sum5720 = callmethod(*var_ix, "+(1)", 1, partcv, params);
// compiled op node returning sum5720 (depth = 6)
  *var_ix = sum5720;
  if (sum5720 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
// Begin line 352
  setline(352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5722 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  gc_frame_newslot(*var_ix);
// starting to compile member node (depth = 6)
  int callframe5723 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_selfIterator (depth = 7)
  Object call5724 = callmethodflags(*var_selfIterator, "next", 0, partcv, params, 0);
  gc_frame_end(callframe5723);
// compiled member node returning call5724 (depth = 6)
  gc_frame_newslot(call5724);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block2 (depth = 6)
  params[0] = *var_ix;
  params[1] = call5724;
  partcv[0] = 2;
  Object call5725 = callmethodflags(*var_block2, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5722);
// compiled call node returning call5725 (depth = 5)
  gc_frame_end(frame);
  return call5725;
}
Object meth_collectionsPrelude_keysAndValuesDo_40_1_41_5705(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keysAndValuesDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysAndValuesDo(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysAndValuesDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part keysAndValuesDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
  Object *var_selfIterator = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "selfIterator");
// Begin line 348
  setline(348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5706 = alloc_Float64(0);
// compiled num node returning num5706 (depth = 4)
  *var_ix = num5706;
  if (num5706 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5707 = gc_frame_new();
// call case 4: self request
  Object call5708 = callmethodflags(self, "iterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5707);
// compiled member node returning call5708 (depth = 4)
  *var_selfIterator = call5708;
  if (call5708 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5709 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5710 = alloc_Block(NULL, NULL, "collectionsPrelude", 350);
  gc_frame_newslot(block5710);
// method "_apply"
  block_savedest(block5710);
  Object closure5711 = createclosure(2, "_apply");
  setclosureframe(closure5711, stackframe);
  addtoclosure(closure5711, var_selfIterator);
  addtoclosure(closure5711, selfslot);
  struct UserObject *uo5711 = (struct UserObject*)block5710;
  uo5711->data[0] = (Object)closure5711;
  Method *meth_meth_collectionsPrelude__apply5711 = addmethod2pos(block5710, "_apply", &meth_collectionsPrelude__apply5711, 0);
  int argcv_meth_collectionsPrelude__apply5711[] = {0};
  meth_meth_collectionsPrelude__apply5711->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5711);
  meth_meth_collectionsPrelude__apply5711->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5711->definitionLine = 1963;
// compiled block node returning block5710 (depth = 4)
  gc_frame_newslot(block5710);
// starting to compile block node (depth = 4)
  Object block5715 = alloc_Block(NULL, NULL, "collectionsPrelude", 350);
  gc_frame_newslot(block5715);
// method "_apply"
  block_savedest(block5715);
  Object closure5716 = createclosure(4, "_apply");
  setclosureframe(closure5716, stackframe);
  addtoclosure(closure5716, var_ix);
  addtoclosure(closure5716, var_selfIterator);
  addtoclosure(closure5716, var_block2);
  addtoclosure(closure5716, selfslot);
  struct UserObject *uo5716 = (struct UserObject*)block5715;
  uo5716->data[0] = (Object)closure5716;
  Method *meth_meth_collectionsPrelude__apply5716 = addmethod2pos(block5715, "_apply", &meth_collectionsPrelude__apply5716, 0);
  int argcv_meth_collectionsPrelude__apply5716[] = {0};
  meth_meth_collectionsPrelude__apply5716->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5716);
  meth_meth_collectionsPrelude__apply5716->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5716->definitionLine = 1963;
// compiled block node returning block5715 (depth = 4)
  gc_frame_newslot(block5715);
// call case 5: prelude request
  params[0] = block5710;
  params[1] = block5715;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5727 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5709);
// compiled call node returning call5727 (depth = 3)
  gc_frame_end(frame);
  return call5727;
}
Object meth_collectionsPrelude_values5728(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 356
  setline(356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply5734(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
  int callframe5735 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_selfIterator (depth = 6)
  Object call5736 = callmethodflags(*var_selfIterator, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe5735);
// compiled member node returning call5736 (depth = 5)
  gc_frame_end(frame);
  return call5736;
}
Object meth_collectionsPrelude__apply5739(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_res = getfromclosure(closure, 0);
  Object *var_selfIterator = getfromclosure(closure, 1);
  Object *var_block2 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5740 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_res (depth = 7)
  gc_frame_newslot(*var_res);
// starting to compile member node (depth = 7)
  int callframe5741 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_selfIterator (depth = 8)
  Object call5742 = callmethodflags(*var_selfIterator, "next", 0, partcv, params, 0);
  gc_frame_end(callframe5741);
// compiled member node returning call5742 (depth = 7)
  gc_frame_newslot(call5742);
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_block2 (depth = 7)
  params[0] = *var_res;
  params[1] = call5742;
  partcv[0] = 2;
  Object call5743 = callmethodflags(*var_block2, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5740);
// compiled call node returning call5743 (depth = 6)
  *var_res = call5743;
  if (call5743 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5729(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "fold(1)startingWith(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method fold(_)startingWith(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method fold(_)startingWith(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for fold(_)startingWith(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part fold(_)");
  Object *var_initial = &(stackframe->slots[1]);
  *var_initial = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part startingWith(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_R = &(stackframe->slots[3]);
  if (nparts == 1 + 2 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_R = args[curarg++];
  } else {
    *var_R = Unknown;
  }
// End typeParams
  Object *var_res = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "res");
  Object *var_selfIterator = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "selfIterator");
// Begin line 359
  setline(359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_initial (depth = 4)
  *var_res = *var_initial;
  if (*var_initial == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 360
  setline(360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5730 = gc_frame_new();
// call case 4: self request
  Object call5731 = callmethodflags(self, "iterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5730);
// compiled member node returning call5731 (depth = 4)
  *var_selfIterator = call5731;
  if (call5731 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 361
  setline(361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5732 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5733 = alloc_Block(NULL, NULL, "collectionsPrelude", 361);
  gc_frame_newslot(block5733);
// method "_apply"
  block_savedest(block5733);
  Object closure5734 = createclosure(2, "_apply");
  setclosureframe(closure5734, stackframe);
  addtoclosure(closure5734, var_selfIterator);
  addtoclosure(closure5734, selfslot);
  struct UserObject *uo5734 = (struct UserObject*)block5733;
  uo5734->data[0] = (Object)closure5734;
  Method *meth_meth_collectionsPrelude__apply5734 = addmethod2pos(block5733, "_apply", &meth_collectionsPrelude__apply5734, 0);
  int argcv_meth_collectionsPrelude__apply5734[] = {0};
  meth_meth_collectionsPrelude__apply5734->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5734);
  meth_meth_collectionsPrelude__apply5734->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5734->definitionLine = 1963;
// compiled block node returning block5733 (depth = 4)
  gc_frame_newslot(block5733);
// starting to compile block node (depth = 4)
  Object block5738 = alloc_Block(NULL, NULL, "collectionsPrelude", 361);
  gc_frame_newslot(block5738);
// method "_apply"
  block_savedest(block5738);
  Object closure5739 = createclosure(4, "_apply");
  setclosureframe(closure5739, stackframe);
  addtoclosure(closure5739, var_res);
  addtoclosure(closure5739, var_selfIterator);
  addtoclosure(closure5739, var_block2);
  addtoclosure(closure5739, selfslot);
  struct UserObject *uo5739 = (struct UserObject*)block5738;
  uo5739->data[0] = (Object)closure5739;
  Method *meth_meth_collectionsPrelude__apply5739 = addmethod2pos(block5738, "_apply", &meth_collectionsPrelude__apply5739, 0);
  int argcv_meth_collectionsPrelude__apply5739[] = {0};
  meth_meth_collectionsPrelude__apply5739->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5739);
  meth_meth_collectionsPrelude__apply5739->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5739->definitionLine = 1963;
// compiled block node returning block5738 (depth = 4)
  gc_frame_newslot(block5738);
// call case 5: prelude request
  params[0] = block5733;
  params[1] = block5738;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5746 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5732);
// compiled call node returning call5746 (depth = 3)
// Begin line 364
  setline(364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_res (depth = 4)
  return *var_res;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__43__43__40_1_41_5747(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++(_)");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ++(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 367
  setline(367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5748 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5749 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5750 = gc_frame_new();
// call case 3: self.outer request
  Object call5751 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5750);
// compiled member node returning call5751 (depth = 5)
  Object call5752 = callmethodflags(call5751, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5749);
// compiled member node returning call5752 (depth = 4)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 2;
  Object call5753 = callmethodflags(call5752, "lazyConcatenation(2)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5748);
// compiled call node returning call5753 (depth = 3)
  gc_frame_end(frame);
  return call5753;
}
Object meth_collectionsPrelude_sortedBy_40_1_41_5754(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortedBy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortedBy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sortedBy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 370
  setline(370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5755 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sortBlock (depth = 4)
  gc_frame_newslot(*var_sortBlock);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5756 = gc_frame_new();
// call case 4: self request
  Object call5757 = callmethodflags(self, "asList", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5756);
// compiled member node returning call5757 (depth = 4)
  params[0] = *var_sortBlock;
  partcv[0] = 1;
  Object call5758 = callmethodflags(call5757, "sortBy(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5755);
// compiled call node returning call5758 (depth = 3)
  gc_frame_end(frame);
  return call5758;
}
Object meth_collectionsPrelude_sorted5759(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 373
  setline(373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5760 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5761 = gc_frame_new();
// call case 4: self request
  Object call5762 = callmethodflags(self, "asList", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5761);
// compiled member node returning call5762 (depth = 4)
  Object call5763 = callmethodflags(call5762, "sort", 0, partcv, params, 0);
  gc_frame_end(callframe5760);
// compiled member node returning call5763 (depth = 3)
  gc_frame_end(frame);
  return call5763;
}
Object meth_collectionsPrelude__apply_40_1_41_5768(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe5770 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  Object call5771 = callmethodflags(*var_each, "asString", 0, partcv, params, 0);
  gc_frame_end(callframe5770);
// compiled member node returning call5771 (depth = 7)
  int op_slot_right_5769 = gc_frame_newslot(call5771);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5769 = gc_frame_newslot(*var_s);
  params[0] = call5771;
  partcv[0] = 1;
  Object opresult5773 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5773 (depth = 6)
  *var_s = opresult5773;
  if (opresult5773 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply5777(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5779 == NULL) {
    strlit5779 = alloc_String(", ");
    gc_root(strlit5779);
  }
// compiled string node returning strlit5779 (depth = 7)
  int op_slot_right_5778 = gc_frame_newslot(strlit5779);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5778 = gc_frame_newslot(*var_s);
  params[0] = strlit5779;
  partcv[0] = 1;
  Object opresult5781 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5781 (depth = 6)
  *var_s = opresult5781;
  if (opresult5781 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_asString5764(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 376
  setline(376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5765 == NULL) {
    strlit5765 = alloc_String("""\xe2""""\x9f""""\xa8""");
    gc_root(strlit5765);
  }
// compiled string node returning strlit5765 (depth = 4)
  *var_s = strlit5765;
  if (strlit5765 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 377
  setline(377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5766 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5767 = alloc_Block(NULL, NULL, "collectionsPrelude", 377);
  gc_frame_newslot(block5767);
// method "_apply(_)"
  block_savedest(block5767);
  Object closure5768 = createclosure(2, "_apply(1)");
  setclosureframe(closure5768, stackframe);
  addtoclosure(closure5768, var_s);
  addtoclosure(closure5768, selfslot);
  struct UserObject *uo5768 = (struct UserObject*)block5767;
  uo5768->data[0] = (Object)closure5768;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_5768 = addmethod2pos(block5767, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_5768, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_5768[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_5768->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_5768);
  meth_meth_collectionsPrelude__apply_40_1_41_5768->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_5768->definitionLine = 1963;
// compiled block node returning block5767 (depth = 4)
  gc_frame_newslot(block5767);
// starting to compile block node (depth = 4)
  Object block5776 = alloc_Block(NULL, NULL, "collectionsPrelude", 377);
  gc_frame_newslot(block5776);
// method "_apply"
  block_savedest(block5776);
  Object closure5777 = createclosure(2, "_apply");
  setclosureframe(closure5777, stackframe);
  addtoclosure(closure5777, var_s);
  addtoclosure(closure5777, selfslot);
  struct UserObject *uo5777 = (struct UserObject*)block5776;
  uo5777->data[0] = (Object)closure5777;
  Method *meth_meth_collectionsPrelude__apply5777 = addmethod2pos(block5776, "_apply", &meth_collectionsPrelude__apply5777, 0);
  int argcv_meth_collectionsPrelude__apply5777[] = {0};
  meth_meth_collectionsPrelude__apply5777->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5777);
  meth_meth_collectionsPrelude__apply5777->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5777->definitionLine = 1963;
// compiled block node returning block5776 (depth = 4)
  gc_frame_newslot(block5776);
// call case 4: self request
  params[0] = block5767;
  params[1] = block5776;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5784 = callmethodflags(self, "do(1)separatedBy(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5766);
// compiled call node returning call5784 (depth = 3)
// Begin line 378
  setline(378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5786 == NULL) {
    strlit5786 = alloc_String("""\xe2""""\x9f""""\xa9""");
    gc_root(strlit5786);
  }
// compiled string node returning strlit5786 (depth = 4)
  int op_slot_right_5785 = gc_frame_newslot(strlit5786);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_5785 = gc_frame_newslot(*var_s);
  params[0] = strlit5786;
  partcv[0] = 1;
  Object opresult5788 = callmethod(*var_s, "++(1)", 1, partcv, params);
// compiled op node returning opresult5788 (depth = 3)
  gc_frame_end(frame);
  return opresult5788;
}
Object meth_collectionsPrelude_TRAIT5625(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "TRAIT");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  Object *var_collection = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5626 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5626 = alloc_userobj2(13,14, objclass5626);
  gc_frame_newslot(obj5626);
if (objclass5626 == NULL) {
  glfree(obj5626->class->name);
  obj5626->class->name = "enumerable.enumerable.TRAIT";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5626, self, 0);
  addmethodreal(obj5626,"outer", &reader_collectionsPrelude_outer_5627);
  Object oldself5626 = self;
  struct StackFrameObject *oldstackframe5626 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5626);
  gc_frame_newslot((Object)stackframe);
  self = obj5626;
  Object *oldselfslot5626 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5626 = (*(struct UserObject *)self).data[0], lowerouter5626 = thisouter5626;
  if (inheritingObject5626) {
    struct UserObject *inho5626 = (struct UserObject *)inheritingObject5626;
    while (inho5626->super != GraceDefaultObject) inho5626 = (struct UserObject *)inho5626->super;
    inho5626->super = obj5626;
    self = inheritingObject5626;
    *selfslot = self;
    lowerouter5626 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5626;
  }
// method "iterator"
  struct UserObject *uo5628 = (struct UserObject*)obj5626;
  uo5628->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iterator5628 = addmethod2pos(obj5626, "iterator", &meth_collectionsPrelude_iterator5628, 1);
  int argcv_meth_collectionsPrelude_iterator5628[] = {0};
  meth_meth_collectionsPrelude_iterator5628->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator5628);
  meth_meth_collectionsPrelude_iterator5628->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator5628->definitionLine = 319;
// method "size"
  block_savedest(obj5626);
  Object closure5635 = createclosure(1, "size");
  setclosureframe(closure5635, stackframe);
  addtoclosure(closure5635, var_SizeUnknown);
  struct UserObject *uo5635 = (struct UserObject*)obj5626;
  uo5635->data[2] = (Object)closure5635;
  Method *meth_meth_collectionsPrelude_size5635 = addmethod2pos(obj5626, "size", &meth_collectionsPrelude_size5635, 2);
  int argcv_meth_collectionsPrelude_size5635[] = {0};
  meth_meth_collectionsPrelude_size5635->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size5635);
  meth_meth_collectionsPrelude_size5635->definitionModule = modulename;
  meth_meth_collectionsPrelude_size5635->definitionLine = 320;
// method "asDictionary"
  struct UserObject *uo5648 = (struct UserObject*)obj5626;
  uo5648->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDictionary5648 = addmethod2pos(obj5626, "asDictionary", &meth_collectionsPrelude_asDictionary5648, 3);
  int argcv_meth_collectionsPrelude_asDictionary5648[] = {0};
  meth_meth_collectionsPrelude_asDictionary5648->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDictionary5648);
  meth_meth_collectionsPrelude_asDictionary5648->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDictionary5648->definitionLine = 324;
// method "into(_)"
  struct UserObject *uo5664 = (struct UserObject*)obj5626;
  uo5664->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_into_40_1_41_5664 = addmethod2pos(obj5626, "into(1)", &meth_collectionsPrelude_into_40_1_41_5664, 4);
  int argcv_meth_collectionsPrelude_into_40_1_41_5664[] = {1};
  meth_meth_collectionsPrelude_into_40_1_41_5664->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_into_40_1_41_5664);
  meth_meth_collectionsPrelude_into_40_1_41_5664->definitionModule = modulename;
  meth_meth_collectionsPrelude_into_40_1_41_5664->definitionLine = 331;
// method "==(_)"
  struct UserObject *uo5681 = (struct UserObject*)obj5626;
  uo5681->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_5681 = addmethod2pos(obj5626, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_5681, 5);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_5681[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_5681->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_5681);
  meth_meth_collectionsPrelude__61__61__40_1_41_5681->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_5681->definitionLine = 338;
// method "do(_)"
  struct UserObject *uo5688 = (struct UserObject*)obj5626;
  uo5688->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_5688 = addmethod2pos(obj5626, "do(1)", &meth_collectionsPrelude_do_40_1_41_5688, 6);
  int argcv_meth_collectionsPrelude_do_40_1_41_5688[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_5688->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_5688);
  meth_meth_collectionsPrelude_do_40_1_41_5688->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_5688->definitionLine = 341;
// method "keysAndValuesDo(_)"
  struct UserObject *uo5705 = (struct UserObject*)obj5626;
  uo5705->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5705 = addmethod2pos(obj5626, "keysAndValuesDo(1)", &meth_collectionsPrelude_keysAndValuesDo_40_1_41_5705, 7);
  int argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5705[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5705->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5705);
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5705->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5705->definitionLine = 347;
// method "values"
  struct UserObject *uo5728 = (struct UserObject*)obj5626;
  uo5728->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values5728 = addmethod2pos(obj5626, "values", &meth_collectionsPrelude_values5728, 8);
  int argcv_meth_collectionsPrelude_values5728[] = {0};
  meth_meth_collectionsPrelude_values5728->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values5728);
  meth_meth_collectionsPrelude_values5728->definitionModule = modulename;
  meth_meth_collectionsPrelude_values5728->definitionLine = 355;
// method "fold(_)startingWith(_)"
  struct UserObject *uo5729 = (struct UserObject*)obj5626;
  uo5729->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5729 = addmethod2pos(obj5626, "fold(1)startingWith(1)", &meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5729, 9);
  int argcv_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5729[] = {1, 1};
  meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5729->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5729);
  meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5729->definitionModule = modulename;
  meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5729->definitionLine = 358;
// method "++(_)"
  struct UserObject *uo5747 = (struct UserObject*)obj5626;
  uo5747->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_5747 = addmethod2pos(obj5626, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_5747, 10);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_5747[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_5747->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_5747);
  meth_meth_collectionsPrelude__43__43__40_1_41_5747->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_5747->definitionLine = 366;
// method "sortedBy(_)"
  struct UserObject *uo5754 = (struct UserObject*)obj5626;
  uo5754->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy_40_1_41_5754 = addmethod2pos(obj5626, "sortedBy(1)", &meth_collectionsPrelude_sortedBy_40_1_41_5754, 11);
  int argcv_meth_collectionsPrelude_sortedBy_40_1_41_5754[] = {1};
  meth_meth_collectionsPrelude_sortedBy_40_1_41_5754->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy_40_1_41_5754);
  meth_meth_collectionsPrelude_sortedBy_40_1_41_5754->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy_40_1_41_5754->definitionLine = 369;
// method "sorted"
  struct UserObject *uo5759 = (struct UserObject*)obj5626;
  uo5759->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted5759 = addmethod2pos(obj5626, "sorted", &meth_collectionsPrelude_sorted5759, 12);
  int argcv_meth_collectionsPrelude_sorted5759[] = {0};
  meth_meth_collectionsPrelude_sorted5759->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted5759);
  meth_meth_collectionsPrelude_sorted5759->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted5759->definitionLine = 372;
// method "asString"
  struct UserObject *uo5764 = (struct UserObject*)obj5626;
  uo5764->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString5764 = addmethod2pos(obj5626, "asString", &meth_collectionsPrelude_asString5764, 13);
  int argcv_meth_collectionsPrelude_asString5764[] = {0};
  meth_meth_collectionsPrelude_asString5764->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5764);
  meth_meth_collectionsPrelude_asString5764->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5764->definitionLine = 375;
  sourceObject = obj5626;
// Begin line 318
  setline(318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5789 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_collection (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5790 = callmethodflags(*var_collection, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5789);
// compiled call node returning call5790 (depth = 3)
  struct UserObject *obj5626_uo = (struct UserObject *)obj5626;
  obj5626_uo->super = call5790;
  sourceObject = obj5626;
  sourceObject = obj5626;
  sourceObject = obj5626;
  sourceObject = obj5626;
  sourceObject = obj5626;
  sourceObject = obj5626;
  sourceObject = obj5626;
  sourceObject = obj5626;
  sourceObject = obj5626;
  sourceObject = obj5626;
  sourceObject = obj5626;
  sourceObject = obj5626;
  sourceObject = obj5626;
  objclass5626 = obj5626->class;
  objclass5626->definitionModule = modulename;
  objclass5626->definitionLine = 317;
  (*(struct UserObject *)self).data[0] = lowerouter5626;
  self = oldself5626;
  selfslot = oldselfslot5626;
  stackframe = oldstackframe5626;
  gc_frame_end(frame);
  return obj5626;
}
Object meth_collectionsPrelude_TRAIT5625_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "TRAIT$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  Object *var_collection = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5626 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5626 = alloc_userobj2(13,14, objclass5626);
  gc_frame_newslot(obj5626);
if (objclass5626 == NULL) {
  glfree(obj5626->class->name);
  obj5626->class->name = "enumerable.enumerable.TRAIT";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5626, self, 0);
  addmethodreal(obj5626,"outer", &reader_collectionsPrelude_outer_5627);
  Object oldself5626 = self;
  struct StackFrameObject *oldstackframe5626 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5626);
  gc_frame_newslot((Object)stackframe);
  self = obj5626;
  Object *oldselfslot5626 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5626 = (*(struct UserObject *)self).data[0], lowerouter5626 = thisouter5626;
  if (inheritingObject5626) {
    struct UserObject *inho5626 = (struct UserObject *)inheritingObject5626;
    while (inho5626->super != GraceDefaultObject) inho5626 = (struct UserObject *)inho5626->super;
    inho5626->super = obj5626;
    self = inheritingObject5626;
    *selfslot = self;
    lowerouter5626 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5626;
  }
// method "iterator"
  struct UserObject *uo5628 = (struct UserObject*)obj5626;
  uo5628->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iterator5628 = addmethod2pos(obj5626, "iterator", &meth_collectionsPrelude_iterator5628, 1);
  int argcv_meth_collectionsPrelude_iterator5628[] = {0};
  meth_meth_collectionsPrelude_iterator5628->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator5628);
  meth_meth_collectionsPrelude_iterator5628->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator5628->definitionLine = 319;
// method "size"
  block_savedest(obj5626);
  Object closure5635 = createclosure(1, "size");
  setclosureframe(closure5635, stackframe);
  addtoclosure(closure5635, var_SizeUnknown);
  struct UserObject *uo5635 = (struct UserObject*)obj5626;
  uo5635->data[2] = (Object)closure5635;
  Method *meth_meth_collectionsPrelude_size5635 = addmethod2pos(obj5626, "size", &meth_collectionsPrelude_size5635, 2);
  int argcv_meth_collectionsPrelude_size5635[] = {0};
  meth_meth_collectionsPrelude_size5635->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size5635);
  meth_meth_collectionsPrelude_size5635->definitionModule = modulename;
  meth_meth_collectionsPrelude_size5635->definitionLine = 320;
// method "asDictionary"
  struct UserObject *uo5648 = (struct UserObject*)obj5626;
  uo5648->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDictionary5648 = addmethod2pos(obj5626, "asDictionary", &meth_collectionsPrelude_asDictionary5648, 3);
  int argcv_meth_collectionsPrelude_asDictionary5648[] = {0};
  meth_meth_collectionsPrelude_asDictionary5648->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDictionary5648);
  meth_meth_collectionsPrelude_asDictionary5648->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDictionary5648->definitionLine = 324;
// method "into(_)"
  struct UserObject *uo5664 = (struct UserObject*)obj5626;
  uo5664->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_into_40_1_41_5664 = addmethod2pos(obj5626, "into(1)", &meth_collectionsPrelude_into_40_1_41_5664, 4);
  int argcv_meth_collectionsPrelude_into_40_1_41_5664[] = {1};
  meth_meth_collectionsPrelude_into_40_1_41_5664->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_into_40_1_41_5664);
  meth_meth_collectionsPrelude_into_40_1_41_5664->definitionModule = modulename;
  meth_meth_collectionsPrelude_into_40_1_41_5664->definitionLine = 331;
// method "==(_)"
  struct UserObject *uo5681 = (struct UserObject*)obj5626;
  uo5681->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_5681 = addmethod2pos(obj5626, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_5681, 5);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_5681[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_5681->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_5681);
  meth_meth_collectionsPrelude__61__61__40_1_41_5681->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_5681->definitionLine = 338;
// method "do(_)"
  struct UserObject *uo5688 = (struct UserObject*)obj5626;
  uo5688->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40_1_41_5688 = addmethod2pos(obj5626, "do(1)", &meth_collectionsPrelude_do_40_1_41_5688, 6);
  int argcv_meth_collectionsPrelude_do_40_1_41_5688[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_5688->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_5688);
  meth_meth_collectionsPrelude_do_40_1_41_5688->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_5688->definitionLine = 341;
// method "keysAndValuesDo(_)"
  struct UserObject *uo5705 = (struct UserObject*)obj5626;
  uo5705->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5705 = addmethod2pos(obj5626, "keysAndValuesDo(1)", &meth_collectionsPrelude_keysAndValuesDo_40_1_41_5705, 7);
  int argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5705[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5705->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5705);
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5705->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5705->definitionLine = 347;
// method "values"
  struct UserObject *uo5728 = (struct UserObject*)obj5626;
  uo5728->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values5728 = addmethod2pos(obj5626, "values", &meth_collectionsPrelude_values5728, 8);
  int argcv_meth_collectionsPrelude_values5728[] = {0};
  meth_meth_collectionsPrelude_values5728->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values5728);
  meth_meth_collectionsPrelude_values5728->definitionModule = modulename;
  meth_meth_collectionsPrelude_values5728->definitionLine = 355;
// method "fold(_)startingWith(_)"
  struct UserObject *uo5729 = (struct UserObject*)obj5626;
  uo5729->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5729 = addmethod2pos(obj5626, "fold(1)startingWith(1)", &meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5729, 9);
  int argcv_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5729[] = {1, 1};
  meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5729->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5729);
  meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5729->definitionModule = modulename;
  meth_meth_collectionsPrelude_fold_40_1_41_startingWith_40_1_41_5729->definitionLine = 358;
// method "++(_)"
  struct UserObject *uo5747 = (struct UserObject*)obj5626;
  uo5747->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_5747 = addmethod2pos(obj5626, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_5747, 10);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_5747[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_5747->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_5747);
  meth_meth_collectionsPrelude__43__43__40_1_41_5747->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_5747->definitionLine = 366;
// method "sortedBy(_)"
  struct UserObject *uo5754 = (struct UserObject*)obj5626;
  uo5754->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy_40_1_41_5754 = addmethod2pos(obj5626, "sortedBy(1)", &meth_collectionsPrelude_sortedBy_40_1_41_5754, 11);
  int argcv_meth_collectionsPrelude_sortedBy_40_1_41_5754[] = {1};
  meth_meth_collectionsPrelude_sortedBy_40_1_41_5754->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy_40_1_41_5754);
  meth_meth_collectionsPrelude_sortedBy_40_1_41_5754->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy_40_1_41_5754->definitionLine = 369;
// method "sorted"
  struct UserObject *uo5759 = (struct UserObject*)obj5626;
  uo5759->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted5759 = addmethod2pos(obj5626, "sorted", &meth_collectionsPrelude_sorted5759, 12);
  int argcv_meth_collectionsPrelude_sorted5759[] = {0};
  meth_meth_collectionsPrelude_sorted5759->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted5759);
  meth_meth_collectionsPrelude_sorted5759->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted5759->definitionLine = 372;
// method "asString"
  struct UserObject *uo5764 = (struct UserObject*)obj5626;
  uo5764->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString5764 = addmethod2pos(obj5626, "asString", &meth_collectionsPrelude_asString5764, 13);
  int argcv_meth_collectionsPrelude_asString5764[] = {0};
  meth_meth_collectionsPrelude_asString5764->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5764);
  meth_meth_collectionsPrelude_asString5764->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5764->definitionLine = 375;
  sourceObject = obj5626;
// Begin line 318
  setline(318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5789 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_collection (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5790 = callmethodflags(*var_collection, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5789);
// compiled call node returning call5790 (depth = 3)
  struct UserObject *obj5626_uo = (struct UserObject *)obj5626;
  obj5626_uo->super = call5790;
  sourceObject = obj5626;
  sourceObject = obj5626;
  sourceObject = obj5626;
  sourceObject = obj5626;
  sourceObject = obj5626;
  sourceObject = obj5626;
  sourceObject = obj5626;
  sourceObject = obj5626;
  sourceObject = obj5626;
  sourceObject = obj5626;
  sourceObject = obj5626;
  sourceObject = obj5626;
  sourceObject = obj5626;
  objclass5626 = obj5626->class;
  objclass5626->definitionModule = modulename;
  objclass5626->definitionLine = 317;
  (*(struct UserObject *)self).data[0] = lowerouter5626;
  self = oldself5626;
  selfslot = oldselfslot5626;
  stackframe = oldstackframe5626;
  gc_frame_end(frame);
  return obj5626;
}
Object meth_collectionsPrelude_asString5792(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 317
  setline(317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5793 == NULL) {
    strlit5793 = alloc_String("class enumerable");
    gc_root(strlit5793);
  }
// compiled string node returning strlit5793 (depth = 3)
  gc_frame_end(frame);
  return strlit5793;
}
Object meth_collectionsPrelude_enumerable5794(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 34, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "enumerable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 317
  setline(317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  gc_frame_end(frame);
  return *var_enumerable;
}
Object meth_collectionsPrelude_at_40_1_41_5800(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_index = &(stackframe->slots[0]);
  *var_index = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 384
  setline(384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5801 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5802 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5803 = gc_frame_new();
// call case 3: self.outer request
  Object call5804 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5803);
// compiled member node returning call5804 (depth = 5)
  Object call5805 = callmethodflags(call5804, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5802);
// compiled member node returning call5805 (depth = 4)
  Object call5806 = callmethodflags(call5805, "abstract", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5801);
// compiled member node returning call5806 (depth = 3)
  gc_frame_end(frame);
  return call5806;
}
Object meth_collectionsPrelude_size5807(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 385
  setline(385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5808 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5809 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5810 = gc_frame_new();
// call case 3: self.outer request
  Object call5811 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5810);
// compiled member node returning call5811 (depth = 5)
  Object call5812 = callmethodflags(call5811, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5809);
// compiled member node returning call5812 (depth = 4)
  Object call5813 = callmethodflags(call5812, "abstract", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5808);
// compiled member node returning call5813 (depth = 3)
  gc_frame_end(frame);
  return call5813;
}
Object meth_collectionsPrelude_isEmpty5814(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5816 = alloc_Float64(0);
// compiled num node returning num5816 (depth = 4)
  int op_slot_right_5815 = gc_frame_newslot(num5816);
// starting to compile member node (depth = 4)
  int callframe5818 = gc_frame_new();
// call case 4: self request
  Object call5819 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5818);
// compiled member node returning call5819 (depth = 4)
  int op_slot_left_5815 = gc_frame_newslot(call5819);
  params[0] = num5816;
  partcv[0] = 1;
  Object opresult5820 = callmethod(call5819, "==(1)", 1, partcv, params);
// compiled op node returning opresult5820 (depth = 3)
  gc_frame_end(frame);
  return opresult5820;
}
Object meth_collectionsPrelude__apply5827(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_curSize = getfromclosure(closure, 0);
  Object *var_i = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_curSize (depth = 6)
  int op_slot_right_5828 = gc_frame_newslot(*var_curSize);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_5828 = gc_frame_newslot(*var_i);
  params[0] = *var_curSize;
  partcv[0] = 1;
  Object opresult5830 = callmethod(*var_i, "≤(1)", 1, partcv, params);
// compiled op node returning opresult5830 (depth = 5)
  gc_frame_end(frame);
  return opresult5830;
}
Object meth_collectionsPrelude__apply5833(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_action = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 391
  setline(391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5834 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// starting to compile call node (depth = 6)
  int callframe5835 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  gc_frame_newslot(*var_i);
// call case 4: self request
  params[0] = *var_i;
  partcv[0] = 1;
  Object call5836 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5835);
// compiled call node returning call5836 (depth = 6)
  gc_frame_newslot(call5836);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_action (depth = 6)
  params[0] = *var_i;
  params[1] = call5836;
  partcv[0] = 2;
  Object call5837 = callmethodflags(*var_action, "apply(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5834);
// compiled call node returning call5837 (depth = 5)
// Begin line 392
  setline(392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num5839 = alloc_Float64(1);
// compiled num node returning num5839 (depth = 7)
  int op_slot_right_5838 = gc_frame_newslot(num5839);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  int op_slot_left_5838 = gc_frame_newslot(*var_i);
  params[0] = num5839;
  partcv[0] = 1;
  Object sum5841 = callmethod(*var_i, "+(1)", 1, partcv, params);
// compiled op node returning sum5841 (depth = 6)
  *var_i = sum5841;
  if (sum5841 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_keysAndValuesDo_40_1_41_5821(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keysAndValuesDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysAndValuesDo(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysAndValuesDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part keysAndValuesDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_curSize = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "curSize");
  Object *var_i = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "i");
// Begin line 388
  setline(388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5822 = gc_frame_new();
// call case 4: self request
  Object call5823 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5822);
// compiled member node returning call5823 (depth = 4)
  *var_curSize = call5823;
  if (call5823 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 389
  setline(389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5824 = alloc_Float64(1);
// compiled num node returning num5824 (depth = 4)
  *var_i = num5824;
  if (num5824 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 390
  setline(390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5825 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5826 = alloc_Block(NULL, NULL, "collectionsPrelude", 390);
  gc_frame_newslot(block5826);
// method "_apply"
  block_savedest(block5826);
  Object closure5827 = createclosure(3, "_apply");
  setclosureframe(closure5827, stackframe);
  addtoclosure(closure5827, var_curSize);
  addtoclosure(closure5827, var_i);
  addtoclosure(closure5827, selfslot);
  struct UserObject *uo5827 = (struct UserObject*)block5826;
  uo5827->data[0] = (Object)closure5827;
  Method *meth_meth_collectionsPrelude__apply5827 = addmethod2pos(block5826, "_apply", &meth_collectionsPrelude__apply5827, 0);
  int argcv_meth_collectionsPrelude__apply5827[] = {0};
  meth_meth_collectionsPrelude__apply5827->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5827);
  meth_meth_collectionsPrelude__apply5827->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5827->definitionLine = 1963;
// compiled block node returning block5826 (depth = 4)
  gc_frame_newslot(block5826);
// starting to compile block node (depth = 4)
  Object block5832 = alloc_Block(NULL, NULL, "collectionsPrelude", 390);
  gc_frame_newslot(block5832);
// method "_apply"
  block_savedest(block5832);
  Object closure5833 = createclosure(3, "_apply");
  setclosureframe(closure5833, stackframe);
  addtoclosure(closure5833, var_i);
  addtoclosure(closure5833, var_action);
  addtoclosure(closure5833, selfslot);
  struct UserObject *uo5833 = (struct UserObject*)block5832;
  uo5833->data[0] = (Object)closure5833;
  Method *meth_meth_collectionsPrelude__apply5833 = addmethod2pos(block5832, "_apply", &meth_collectionsPrelude__apply5833, 0);
  int argcv_meth_collectionsPrelude__apply5833[] = {0};
  meth_meth_collectionsPrelude__apply5833->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5833);
  meth_meth_collectionsPrelude__apply5833->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5833->definitionLine = 1963;
// compiled block node returning block5832 (depth = 4)
  gc_frame_newslot(block5832);
// call case 5: prelude request
  params[0] = block5826;
  params[1] = block5832;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5844 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5825);
// compiled call node returning call5844 (depth = 3)
  gc_frame_end(frame);
  return call5844;
}
Object meth_collectionsPrelude_first5845(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "first");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5846 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5847 = alloc_Float64(1);
// compiled num node returning num5847 (depth = 4)
  gc_frame_newslot(num5847);
// call case 4: self request
  params[0] = num5847;
  partcv[0] = 1;
  Object call5848 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5846);
// compiled call node returning call5848 (depth = 3)
  gc_frame_end(frame);
  return call5848;
}
Object meth_collectionsPrelude_second5849(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "second");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 396
  setline(396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5850 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5851 = alloc_Float64(2);
// compiled num node returning num5851 (depth = 4)
  gc_frame_newslot(num5851);
// call case 4: self request
  params[0] = num5851;
  partcv[0] = 1;
  Object call5852 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5850);
// compiled call node returning call5852 (depth = 3)
  gc_frame_end(frame);
  return call5852;
}
Object meth_collectionsPrelude_third5853(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "third");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 397
  setline(397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5854 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5855 = alloc_Float64(3);
// compiled num node returning num5855 (depth = 4)
  gc_frame_newslot(num5855);
// call case 4: self request
  params[0] = num5855;
  partcv[0] = 1;
  Object call5856 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5854);
// compiled call node returning call5856 (depth = 3)
  gc_frame_end(frame);
  return call5856;
}
Object meth_collectionsPrelude_fourth5857(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "fourth");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 398
  setline(398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5858 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5859 = alloc_Float64(4);
// compiled num node returning num5859 (depth = 4)
  gc_frame_newslot(num5859);
// call case 4: self request
  params[0] = num5859;
  partcv[0] = 1;
  Object call5860 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5858);
// compiled call node returning call5860 (depth = 3)
  gc_frame_end(frame);
  return call5860;
}
Object meth_collectionsPrelude_fifth5861(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "fifth");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 399
  setline(399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5862 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5863 = alloc_Float64(5);
// compiled num node returning num5863 (depth = 4)
  gc_frame_newslot(num5863);
// call case 4: self request
  params[0] = num5863;
  partcv[0] = 1;
  Object call5864 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5862);
// compiled call node returning call5864 (depth = 3)
  gc_frame_end(frame);
  return call5864;
}
Object meth_collectionsPrelude_last5865(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "last");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5866 = gc_frame_new();
// starting to compile member node (depth = 4)
  int callframe5867 = gc_frame_new();
// call case 4: self request
  Object call5868 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5867);
// compiled member node returning call5868 (depth = 4)
  gc_frame_newslot(call5868);
// call case 4: self request
  params[0] = call5868;
  partcv[0] = 1;
  Object call5869 = callmethodflags(self, "at(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5866);
// compiled call node returning call5869 (depth = 3)
  gc_frame_end(frame);
  return call5869;
}
Object meth_collectionsPrelude_indices5870(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "indices");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 401
  setline(401);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5871 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5872 = alloc_Float64(1);
// compiled num node returning num5872 (depth = 4)
  gc_frame_newslot(num5872);
// starting to compile member node (depth = 4)
  int callframe5873 = gc_frame_new();
// call case 4: self request
  Object call5874 = callmethodflags(self, "size", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5873);
// compiled member node returning call5874 (depth = 4)
  gc_frame_newslot(call5874);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5875 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5876 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5877 = gc_frame_new();
// call case 3: self.outer request
  Object call5878 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5877);
// compiled member node returning call5878 (depth = 6)
  Object call5879 = callmethodflags(call5878, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5876);
// compiled member node returning call5879 (depth = 5)
  Object call5880 = callmethodflags(call5879, "range", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5875);
// compiled member node returning call5880 (depth = 4)
  params[0] = num5872;
  params[1] = call5874;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5881 = callmethodflags(call5880, "from(1)to(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5871);
// compiled call node returning call5881 (depth = 3)
  gc_frame_end(frame);
  return call5881;
}
Object meth_collectionsPrelude__apply5885(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sought = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe5886 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5888 == NULL) {
    strlit5888 = alloc_String("");
    gc_root(strlit5888);
  }
// compiled string node returning strlit5888 (depth = 7)
  int op_slot_right_5887 = gc_frame_newslot(strlit5888);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sought (depth = 8)
  int op_slot_right_5890 = gc_frame_newslot(*var_sought);
// starting to compile string node (depth = 8)
  if (strlit5892 == NULL) {
    strlit5892 = alloc_String("collection does not contain ");
    gc_root(strlit5892);
  }
// compiled string node returning strlit5892 (depth = 8)
  int op_slot_left_5890 = gc_frame_newslot(strlit5892);
  params[0] = *var_sought;
  partcv[0] = 1;
  Object opresult5893 = callmethod(strlit5892, "++(1)", 1, partcv, params);
// compiled op node returning opresult5893 (depth = 7)
  int op_slot_left_5887 = gc_frame_newslot(opresult5893);
  params[0] = strlit5888;
  partcv[0] = 1;
  Object opresult5894 = callmethod(opresult5893, "++(1)", 1, partcv, params);
// compiled op node returning opresult5894 (depth = 6)
  gc_frame_newslot(opresult5894);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_NoSuchObject (depth = 6)
  params[0] = opresult5894;
  partcv[0] = 1;
  Object call5895 = callmethodflags(*var_NoSuchObject, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5886);
// compiled call node returning call5895 (depth = 5)
  gc_frame_end(frame);
  return call5895;
}
Object meth_collectionsPrelude_indexOf_40_1_41_5882(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indexOf(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method indexOf(_)");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for indexOf(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sought = &(stackframe->slots[0]);
  *var_sought = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part indexOf(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 403
  setline(403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5883 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sought (depth = 4)
  gc_frame_newslot(*var_sought);
// starting to compile block node (depth = 4)
  Object block5884 = alloc_Block(NULL, NULL, "collectionsPrelude", 403);
  gc_frame_newslot(block5884);
// method "_apply"
  block_savedest(block5884);
  Object closure5885 = createclosure(3, "_apply");
  setclosureframe(closure5885, stackframe);
  addtoclosure(closure5885, var_sought);
  addtoclosure(closure5885, var_NoSuchObject);
  addtoclosure(closure5885, selfslot);
  struct UserObject *uo5885 = (struct UserObject*)block5884;
  uo5885->data[0] = (Object)closure5885;
  Method *meth_meth_collectionsPrelude__apply5885 = addmethod2pos(block5884, "_apply", &meth_collectionsPrelude__apply5885, 0);
  int argcv_meth_collectionsPrelude__apply5885[] = {0};
  meth_meth_collectionsPrelude__apply5885->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5885);
  meth_meth_collectionsPrelude__apply5885->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5885->definitionLine = 1963;
// compiled block node returning block5884 (depth = 4)
  gc_frame_newslot(block5884);
// call case 4: self request
  params[0] = *var_sought;
  params[1] = block5884;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5897 = callmethodflags(self, "indexOf(1)ifAbsent(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5883);
// compiled call node returning call5897 (depth = 3)
  gc_frame_end(frame);
  return call5897;
}
Object meth_collectionsPrelude__apply_40_2_41_5901(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[1];
  int partcv[1];
  Object *var_sought = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 407
  setline(407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sought (depth = 7)
  int op_slot_right_5903 = gc_frame_newslot(*var_sought);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  int op_slot_left_5903 = gc_frame_newslot(*var_v);
  params[0] = *var_sought;
  partcv[0] = 1;
  Object opresult5905 = callmethod(*var_v, "==(1)", 1, partcv, params);
// compiled op node returning opresult5905 (depth = 6)
  Object if5902 = done;
  if (istrue(opresult5905)) {
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  block_return(realself, *var_ix);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if5902 = undefined;
  } else {
  }
// compiled if node returning if5902 (depth = 5)
  gc_frame_end(frame);
  return if5902;
}
Object meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5898(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "indexOf(1)ifAbsent(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method indexOf(_)ifAbsent(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method indexOf(_)ifAbsent(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for indexOf(_)ifAbsent(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_sought = &(stackframe->slots[0]);
  *var_sought = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part indexOf(_)");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ifAbsent(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 406
  setline(406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5899 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5900 = alloc_Block(NULL, NULL, "collectionsPrelude", 406);
  gc_frame_newslot(block5900);
// method "_apply(_,_)"
  block_savedest(block5900);
  Object closure5901 = createclosure(2, "_apply(2)");
  setclosureframe(closure5901, stackframe);
  addtoclosure(closure5901, var_sought);
  addtoclosure(closure5901, selfslot);
  struct UserObject *uo5901 = (struct UserObject*)block5900;
  uo5901->data[0] = (Object)closure5901;
  Method *meth_meth_collectionsPrelude__apply_40_2_41_5901 = addmethod2pos(block5900, "_apply(2)", &meth_collectionsPrelude__apply_40_2_41_5901, 0);
  int argcv_meth_collectionsPrelude__apply_40_2_41_5901[] = {2};
  meth_meth_collectionsPrelude__apply_40_2_41_5901->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_2_41_5901);
  meth_meth_collectionsPrelude__apply_40_2_41_5901->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_2_41_5901->definitionLine = 1963;
// compiled block node returning block5900 (depth = 4)
  gc_frame_newslot(block5900);
// call case 4: self request
  params[0] = block5900;
  partcv[0] = 1;
  Object call5907 = callmethodflags(self, "keysAndValuesDo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5899);
// compiled call node returning call5907 (depth = 3)
// Begin line 409
  setline(409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
  int callframe5908 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_action (depth = 4)
  Object call5909 = callmethodflags(*var_action, "apply", 0, partcv, params, 0);
  gc_frame_end(callframe5908);
// compiled member node returning call5909 (depth = 3)
  gc_frame_end(frame);
  return call5909;
}
Object meth_collectionsPrelude__apply_40_2_41_5921(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(2)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_,_)");
  Object params[2];
  int partcv[2];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 414
  setline(414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5922 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  gc_frame_newslot(*var_k);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  gc_frame_newslot(*var_v);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_result (depth = 6)
  params[0] = *var_k;
  params[1] = *var_v;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5923 = callmethodflags(*var_result, "at(1)put(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5922);
// compiled call node returning call5923 (depth = 5)
  gc_frame_end(frame);
  return call5923;
}
Object meth_collectionsPrelude_asDictionary5910(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDictionary");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 412
  setline(412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5911 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5912 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 6)
  int callframe5913 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe5914 = gc_frame_new();
// call case 3: self.outer request
  Object call5915 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5914);
// compiled member node returning call5915 (depth = 7)
  Object call5916 = callmethodflags(call5915, "outer", 0, partcv, params, 0);
  gc_frame_end(callframe5913);
// compiled member node returning call5916 (depth = 6)
  Object call5917 = callmethodflags(call5916, "dictionary", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5912);
// compiled member node returning call5917 (depth = 5)
  Object call5918 = callmethodflags(call5917, "empty", 0, partcv, params, 0);
  gc_frame_end(callframe5911);
// compiled member node returning call5918 (depth = 4)
  *var_result = call5918;
  if (call5918 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 413
  setline(413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5919 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5920 = alloc_Block(NULL, NULL, "collectionsPrelude", 413);
  gc_frame_newslot(block5920);
// method "_apply(_,_)"
  block_savedest(block5920);
  Object closure5921 = createclosure(2, "_apply(2)");
  setclosureframe(closure5921, stackframe);
  addtoclosure(closure5921, var_result);
  addtoclosure(closure5921, selfslot);
  struct UserObject *uo5921 = (struct UserObject*)block5920;
  uo5921->data[0] = (Object)closure5921;
  Method *meth_meth_collectionsPrelude__apply_40_2_41_5921 = addmethod2pos(block5920, "_apply(2)", &meth_collectionsPrelude__apply_40_2_41_5921, 0);
  int argcv_meth_collectionsPrelude__apply_40_2_41_5921[] = {2};
  meth_meth_collectionsPrelude__apply_40_2_41_5921->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_2_41_5921);
  meth_meth_collectionsPrelude__apply_40_2_41_5921->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_2_41_5921->definitionLine = 1963;
// compiled block node returning block5920 (depth = 4)
  gc_frame_newslot(block5920);
// call case 4: self request
  params[0] = block5920;
  partcv[0] = 1;
  Object call5925 = callmethodflags(self, "keysAndValuesDo(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5919);
// compiled call node returning call5925 (depth = 3)
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  return *var_result;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply5931(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
  int callframe5932 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_selfIterator (depth = 6)
  Object call5933 = callmethodflags(*var_selfIterator, "hasNext", 0, partcv, params, 0);
  gc_frame_end(callframe5932);
// compiled member node returning call5933 (depth = 5)
  gc_frame_end(frame);
  return call5933;
}
Object meth_collectionsPrelude__apply5936(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object *var_existing = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5937 = gc_frame_new();
// starting to compile member node (depth = 6)
  int callframe5938 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_selfIterator (depth = 7)
  Object call5939 = callmethodflags(*var_selfIterator, "next", 0, partcv, params, 0);
  gc_frame_end(callframe5938);
// compiled member node returning call5939 (depth = 6)
  gc_frame_newslot(call5939);
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_existing (depth = 6)
  params[0] = call5939;
  partcv[0] = 1;
  Object call5940 = callmethodflags(*var_existing, "add(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5937);
// compiled call node returning call5940 (depth = 5)
  gc_frame_end(frame);
  return call5940;
}
Object meth_collectionsPrelude_into_40_1_41_5926(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "into(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method into(_)");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for into(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_existing = &(stackframe->slots[0]);
  *var_existing = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part into(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_selfIterator = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "selfIterator");
// Begin line 419
  setline(419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe5927 = gc_frame_new();
// call case 4: self request
  Object call5928 = callmethodflags(self, "iterator", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5927);
// compiled member node returning call5928 (depth = 4)
  *var_selfIterator = call5928;
  if (call5928 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// compiled defdec node returning done (depth = 3)
// Begin line 420
  setline(420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5929 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5930 = alloc_Block(NULL, NULL, "collectionsPrelude", 420);
  gc_frame_newslot(block5930);
// method "_apply"
  block_savedest(block5930);
  Object closure5931 = createclosure(2, "_apply");
  setclosureframe(closure5931, stackframe);
  addtoclosure(closure5931, var_selfIterator);
  addtoclosure(closure5931, selfslot);
  struct UserObject *uo5931 = (struct UserObject*)block5930;
  uo5931->data[0] = (Object)closure5931;
  Method *meth_meth_collectionsPrelude__apply5931 = addmethod2pos(block5930, "_apply", &meth_collectionsPrelude__apply5931, 0);
  int argcv_meth_collectionsPrelude__apply5931[] = {0};
  meth_meth_collectionsPrelude__apply5931->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5931);
  meth_meth_collectionsPrelude__apply5931->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5931->definitionLine = 1963;
// compiled block node returning block5930 (depth = 4)
  gc_frame_newslot(block5930);
// starting to compile block node (depth = 4)
  Object block5935 = alloc_Block(NULL, NULL, "collectionsPrelude", 420);
  gc_frame_newslot(block5935);
// method "_apply"
  block_savedest(block5935);
  Object closure5936 = createclosure(3, "_apply");
  setclosureframe(closure5936, stackframe);
  addtoclosure(closure5936, var_selfIterator);
  addtoclosure(closure5936, var_existing);
  addtoclosure(closure5936, selfslot);
  struct UserObject *uo5936 = (struct UserObject*)block5935;
  uo5936->data[0] = (Object)closure5936;
  Method *meth_meth_collectionsPrelude__apply5936 = addmethod2pos(block5935, "_apply", &meth_collectionsPrelude__apply5936, 0);
  int argcv_meth_collectionsPrelude__apply5936[] = {0};
  meth_meth_collectionsPrelude__apply5936->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5936);
  meth_meth_collectionsPrelude__apply5936->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5936->definitionLine = 1963;
// compiled block node returning block5935 (depth = 4)
  gc_frame_newslot(block5935);
// call case 5: prelude request
  params[0] = block5930;
  params[1] = block5935;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5942 = callmethodflags(prelude, "while(1)do(1)", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5929);
// compiled call node returning call5942 (depth = 3)
// Begin line 423
  setline(423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_existing (depth = 3)
  gc_frame_end(frame);
  return *var_existing;
}
Object meth_collectionsPrelude_TRAIT5797(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "TRAIT");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_collection = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5798 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5798 = alloc_userobj2(15,16, objclass5798);
  gc_frame_newslot(obj5798);
if (objclass5798 == NULL) {
  glfree(obj5798->class->name);
  obj5798->class->name = "indexable.indexable.TRAIT";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5798, self, 0);
  addmethodreal(obj5798,"outer", &reader_collectionsPrelude_outer_5799);
  Object oldself5798 = self;
  struct StackFrameObject *oldstackframe5798 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5798);
  gc_frame_newslot((Object)stackframe);
  self = obj5798;
  Object *oldselfslot5798 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5798 = (*(struct UserObject *)self).data[0], lowerouter5798 = thisouter5798;
  if (inheritingObject5798) {
    struct UserObject *inho5798 = (struct UserObject *)inheritingObject5798;
    while (inho5798->super != GraceDefaultObject) inho5798 = (struct UserObject *)inho5798->super;
    inho5798->super = obj5798;
    self = inheritingObject5798;
    *selfslot = self;
    lowerouter5798 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5798;
  }
// method "at(_)"
  struct UserObject *uo5800 = (struct UserObject*)obj5798;
  uo5800->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40_1_41_5800 = addmethod2pos(obj5798, "at(1)", &meth_collectionsPrelude_at_40_1_41_5800, 1);
  int argcv_meth_collectionsPrelude_at_40_1_41_5800[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_5800->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_5800);
  meth_meth_collectionsPrelude_at_40_1_41_5800->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_5800->definitionLine = 384;
// method "size"
  struct UserObject *uo5807 = (struct UserObject*)obj5798;
  uo5807->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_size5807 = addmethod2pos(obj5798, "size", &meth_collectionsPrelude_size5807, 2);
  int argcv_meth_collectionsPrelude_size5807[] = {0};
  meth_meth_collectionsPrelude_size5807->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size5807);
  meth_meth_collectionsPrelude_size5807->definitionModule = modulename;
  meth_meth_collectionsPrelude_size5807->definitionLine = 385;
// method "isEmpty"
  struct UserObject *uo5814 = (struct UserObject*)obj5798;
  uo5814->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isEmpty5814 = addmethod2pos(obj5798, "isEmpty", &meth_collectionsPrelude_isEmpty5814, 3);
  int argcv_meth_collectionsPrelude_isEmpty5814[] = {0};
  meth_meth_collectionsPrelude_isEmpty5814->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isEmpty5814);
  meth_meth_collectionsPrelude_isEmpty5814->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEmpty5814->definitionLine = 386;
// method "keysAndValuesDo(_)"
  struct UserObject *uo5821 = (struct UserObject*)obj5798;
  uo5821->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5821 = addmethod2pos(obj5798, "keysAndValuesDo(1)", &meth_collectionsPrelude_keysAndValuesDo_40_1_41_5821, 4);
  int argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5821[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5821->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5821);
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5821->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5821->definitionLine = 387;
// method "first"
  struct UserObject *uo5845 = (struct UserObject*)obj5798;
  uo5845->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_first5845 = addmethod2pos(obj5798, "first", &meth_collectionsPrelude_first5845, 5);
  int argcv_meth_collectionsPrelude_first5845[] = {0};
  meth_meth_collectionsPrelude_first5845->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_first5845);
  meth_meth_collectionsPrelude_first5845->definitionModule = modulename;
  meth_meth_collectionsPrelude_first5845->definitionLine = 395;
// method "second"
  struct UserObject *uo5849 = (struct UserObject*)obj5798;
  uo5849->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_second5849 = addmethod2pos(obj5798, "second", &meth_collectionsPrelude_second5849, 6);
  int argcv_meth_collectionsPrelude_second5849[] = {0};
  meth_meth_collectionsPrelude_second5849->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_second5849);
  meth_meth_collectionsPrelude_second5849->definitionModule = modulename;
  meth_meth_collectionsPrelude_second5849->definitionLine = 396;
// method "third"
  struct UserObject *uo5853 = (struct UserObject*)obj5798;
  uo5853->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_third5853 = addmethod2pos(obj5798, "third", &meth_collectionsPrelude_third5853, 7);
  int argcv_meth_collectionsPrelude_third5853[] = {0};
  meth_meth_collectionsPrelude_third5853->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_third5853);
  meth_meth_collectionsPrelude_third5853->definitionModule = modulename;
  meth_meth_collectionsPrelude_third5853->definitionLine = 397;
// method "fourth"
  struct UserObject *uo5857 = (struct UserObject*)obj5798;
  uo5857->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fourth5857 = addmethod2pos(obj5798, "fourth", &meth_collectionsPrelude_fourth5857, 8);
  int argcv_meth_collectionsPrelude_fourth5857[] = {0};
  meth_meth_collectionsPrelude_fourth5857->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_fourth5857);
  meth_meth_collectionsPrelude_fourth5857->definitionModule = modulename;
  meth_meth_collectionsPrelude_fourth5857->definitionLine = 398;
// method "fifth"
  struct UserObject *uo5861 = (struct UserObject*)obj5798;
  uo5861->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fifth5861 = addmethod2pos(obj5798, "fifth", &meth_collectionsPrelude_fifth5861, 9);
  int argcv_meth_collectionsPrelude_fifth5861[] = {0};
  meth_meth_collectionsPrelude_fifth5861->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_fifth5861);
  meth_meth_collectionsPrelude_fifth5861->definitionModule = modulename;
  meth_meth_collectionsPrelude_fifth5861->definitionLine = 399;
// method "last"
  struct UserObject *uo5865 = (struct UserObject*)obj5798;
  uo5865->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_last5865 = addmethod2pos(obj5798, "last", &meth_collectionsPrelude_last5865, 10);
  int argcv_meth_collectionsPrelude_last5865[] = {0};
  meth_meth_collectionsPrelude_last5865->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_last5865);
  meth_meth_collectionsPrelude_last5865->definitionModule = modulename;
  meth_meth_collectionsPrelude_last5865->definitionLine = 400;
// method "indices"
  struct UserObject *uo5870 = (struct UserObject*)obj5798;
  uo5870->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_indices5870 = addmethod2pos(obj5798, "indices", &meth_collectionsPrelude_indices5870, 11);
  int argcv_meth_collectionsPrelude_indices5870[] = {0};
  meth_meth_collectionsPrelude_indices5870->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_indices5870);
  meth_meth_collectionsPrelude_indices5870->definitionModule = modulename;
  meth_meth_collectionsPrelude_indices5870->definitionLine = 401;
// method "indexOf(_)"
  block_savedest(obj5798);
  Object closure5882 = createclosure(1, "indexOf(1)");
  setclosureframe(closure5882, stackframe);
  addtoclosure(closure5882, var_NoSuchObject);
  struct UserObject *uo5882 = (struct UserObject*)obj5798;
  uo5882->data[12] = (Object)closure5882;
  Method *meth_meth_collectionsPrelude_indexOf_40_1_41_5882 = addmethod2pos(obj5798, "indexOf(1)", &meth_collectionsPrelude_indexOf_40_1_41_5882, 12);
  int argcv_meth_collectionsPrelude_indexOf_40_1_41_5882[] = {1};
  meth_meth_collectionsPrelude_indexOf_40_1_41_5882->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_indexOf_40_1_41_5882);
  meth_meth_collectionsPrelude_indexOf_40_1_41_5882->definitionModule = modulename;
  meth_meth_collectionsPrelude_indexOf_40_1_41_5882->definitionLine = 402;
// method "indexOf(_)ifAbsent(_)"
  struct UserObject *uo5898 = (struct UserObject*)obj5798;
  uo5898->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5898 = addmethod2pos(obj5798, "indexOf(1)ifAbsent(1)", &meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5898, 13);
  int argcv_meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5898[] = {1, 1};
  meth_meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5898->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5898);
  meth_meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5898->definitionModule = modulename;
  meth_meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5898->definitionLine = 405;
// method "asDictionary"
  struct UserObject *uo5910 = (struct UserObject*)obj5798;
  uo5910->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDictionary5910 = addmethod2pos(obj5798, "asDictionary", &meth_collectionsPrelude_asDictionary5910, 14);
  int argcv_meth_collectionsPrelude_asDictionary5910[] = {0};
  meth_meth_collectionsPrelude_asDictionary5910->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDictionary5910);
  meth_meth_collectionsPrelude_asDictionary5910->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDictionary5910->definitionLine = 411;
// method "into(_)"
  struct UserObject *uo5926 = (struct UserObject*)obj5798;
  uo5926->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_into_40_1_41_5926 = addmethod2pos(obj5798, "into(1)", &meth_collectionsPrelude_into_40_1_41_5926, 15);
  int argcv_meth_collectionsPrelude_into_40_1_41_5926[] = {1};
  meth_meth_collectionsPrelude_into_40_1_41_5926->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_into_40_1_41_5926);
  meth_meth_collectionsPrelude_into_40_1_41_5926->definitionModule = modulename;
  meth_meth_collectionsPrelude_into_40_1_41_5926->definitionLine = 418;
  sourceObject = obj5798;
// Begin line 383
  setline(383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5943 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_collection (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5944 = callmethodflags(*var_collection, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5943);
// compiled call node returning call5944 (depth = 3)
  struct UserObject *obj5798_uo = (struct UserObject *)obj5798;
  obj5798_uo->super = call5944;
  sourceObject = obj5798;
  sourceObject = obj5798;
  sourceObject = obj5798;
  sourceObject = obj5798;
  sourceObject = obj5798;
  sourceObject = obj5798;
  sourceObject = obj5798;
  sourceObject = obj5798;
  sourceObject = obj5798;
  sourceObject = obj5798;
  sourceObject = obj5798;
  sourceObject = obj5798;
  sourceObject = obj5798;
  sourceObject = obj5798;
  sourceObject = obj5798;
  objclass5798 = obj5798->class;
  objclass5798->definitionModule = modulename;
  objclass5798->definitionLine = 382;
  (*(struct UserObject *)self).data[0] = lowerouter5798;
  self = oldself5798;
  selfslot = oldselfslot5798;
  stackframe = oldstackframe5798;
  gc_frame_end(frame);
  return obj5798;
}
Object meth_collectionsPrelude_TRAIT5797_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "TRAIT$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_collection = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5798 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5798 = alloc_userobj2(15,16, objclass5798);
  gc_frame_newslot(obj5798);
if (objclass5798 == NULL) {
  glfree(obj5798->class->name);
  obj5798->class->name = "indexable.indexable.TRAIT";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5798, self, 0);
  addmethodreal(obj5798,"outer", &reader_collectionsPrelude_outer_5799);
  Object oldself5798 = self;
  struct StackFrameObject *oldstackframe5798 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5798);
  gc_frame_newslot((Object)stackframe);
  self = obj5798;
  Object *oldselfslot5798 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5798 = (*(struct UserObject *)self).data[0], lowerouter5798 = thisouter5798;
  if (inheritingObject5798) {
    struct UserObject *inho5798 = (struct UserObject *)inheritingObject5798;
    while (inho5798->super != GraceDefaultObject) inho5798 = (struct UserObject *)inho5798->super;
    inho5798->super = obj5798;
    self = inheritingObject5798;
    *selfslot = self;
    lowerouter5798 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5798;
  }
// method "at(_)"
  struct UserObject *uo5800 = (struct UserObject*)obj5798;
  uo5800->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40_1_41_5800 = addmethod2pos(obj5798, "at(1)", &meth_collectionsPrelude_at_40_1_41_5800, 1);
  int argcv_meth_collectionsPrelude_at_40_1_41_5800[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_5800->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_5800);
  meth_meth_collectionsPrelude_at_40_1_41_5800->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_5800->definitionLine = 384;
// method "size"
  struct UserObject *uo5807 = (struct UserObject*)obj5798;
  uo5807->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_size5807 = addmethod2pos(obj5798, "size", &meth_collectionsPrelude_size5807, 2);
  int argcv_meth_collectionsPrelude_size5807[] = {0};
  meth_meth_collectionsPrelude_size5807->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size5807);
  meth_meth_collectionsPrelude_size5807->definitionModule = modulename;
  meth_meth_collectionsPrelude_size5807->definitionLine = 385;
// method "isEmpty"
  struct UserObject *uo5814 = (struct UserObject*)obj5798;
  uo5814->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isEmpty5814 = addmethod2pos(obj5798, "isEmpty", &meth_collectionsPrelude_isEmpty5814, 3);
  int argcv_meth_collectionsPrelude_isEmpty5814[] = {0};
  meth_meth_collectionsPrelude_isEmpty5814->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isEmpty5814);
  meth_meth_collectionsPrelude_isEmpty5814->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEmpty5814->definitionLine = 386;
// method "keysAndValuesDo(_)"
  struct UserObject *uo5821 = (struct UserObject*)obj5798;
  uo5821->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5821 = addmethod2pos(obj5798, "keysAndValuesDo(1)", &meth_collectionsPrelude_keysAndValuesDo_40_1_41_5821, 4);
  int argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5821[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5821->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5821);
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5821->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5821->definitionLine = 387;
// method "first"
  struct UserObject *uo5845 = (struct UserObject*)obj5798;
  uo5845->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_first5845 = addmethod2pos(obj5798, "first", &meth_collectionsPrelude_first5845, 5);
  int argcv_meth_collectionsPrelude_first5845[] = {0};
  meth_meth_collectionsPrelude_first5845->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_first5845);
  meth_meth_collectionsPrelude_first5845->definitionModule = modulename;
  meth_meth_collectionsPrelude_first5845->definitionLine = 395;
// method "second"
  struct UserObject *uo5849 = (struct UserObject*)obj5798;
  uo5849->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_second5849 = addmethod2pos(obj5798, "second", &meth_collectionsPrelude_second5849, 6);
  int argcv_meth_collectionsPrelude_second5849[] = {0};
  meth_meth_collectionsPrelude_second5849->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_second5849);
  meth_meth_collectionsPrelude_second5849->definitionModule = modulename;
  meth_meth_collectionsPrelude_second5849->definitionLine = 396;
// method "third"
  struct UserObject *uo5853 = (struct UserObject*)obj5798;
  uo5853->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_third5853 = addmethod2pos(obj5798, "third", &meth_collectionsPrelude_third5853, 7);
  int argcv_meth_collectionsPrelude_third5853[] = {0};
  meth_meth_collectionsPrelude_third5853->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_third5853);
  meth_meth_collectionsPrelude_third5853->definitionModule = modulename;
  meth_meth_collectionsPrelude_third5853->definitionLine = 397;
// method "fourth"
  struct UserObject *uo5857 = (struct UserObject*)obj5798;
  uo5857->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fourth5857 = addmethod2pos(obj5798, "fourth", &meth_collectionsPrelude_fourth5857, 8);
  int argcv_meth_collectionsPrelude_fourth5857[] = {0};
  meth_meth_collectionsPrelude_fourth5857->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_fourth5857);
  meth_meth_collectionsPrelude_fourth5857->definitionModule = modulename;
  meth_meth_collectionsPrelude_fourth5857->definitionLine = 398;
// method "fifth"
  struct UserObject *uo5861 = (struct UserObject*)obj5798;
  uo5861->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fifth5861 = addmethod2pos(obj5798, "fifth", &meth_collectionsPrelude_fifth5861, 9);
  int argcv_meth_collectionsPrelude_fifth5861[] = {0};
  meth_meth_collectionsPrelude_fifth5861->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_fifth5861);
  meth_meth_collectionsPrelude_fifth5861->definitionModule = modulename;
  meth_meth_collectionsPrelude_fifth5861->definitionLine = 399;
// method "last"
  struct UserObject *uo5865 = (struct UserObject*)obj5798;
  uo5865->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_last5865 = addmethod2pos(obj5798, "last", &meth_collectionsPrelude_last5865, 10);
  int argcv_meth_collectionsPrelude_last5865[] = {0};
  meth_meth_collectionsPrelude_last5865->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_last5865);
  meth_meth_collectionsPrelude_last5865->definitionModule = modulename;
  meth_meth_collectionsPrelude_last5865->definitionLine = 400;
// method "indices"
  struct UserObject *uo5870 = (struct UserObject*)obj5798;
  uo5870->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_indices5870 = addmethod2pos(obj5798, "indices", &meth_collectionsPrelude_indices5870, 11);
  int argcv_meth_collectionsPrelude_indices5870[] = {0};
  meth_meth_collectionsPrelude_indices5870->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_indices5870);
  meth_meth_collectionsPrelude_indices5870->definitionModule = modulename;
  meth_meth_collectionsPrelude_indices5870->definitionLine = 401;
// method "indexOf(_)"
  block_savedest(obj5798);
  Object closure5882 = createclosure(1, "indexOf(1)");
  setclosureframe(closure5882, stackframe);
  addtoclosure(closure5882, var_NoSuchObject);
  struct UserObject *uo5882 = (struct UserObject*)obj5798;
  uo5882->data[12] = (Object)closure5882;
  Method *meth_meth_collectionsPrelude_indexOf_40_1_41_5882 = addmethod2pos(obj5798, "indexOf(1)", &meth_collectionsPrelude_indexOf_40_1_41_5882, 12);
  int argcv_meth_collectionsPrelude_indexOf_40_1_41_5882[] = {1};
  meth_meth_collectionsPrelude_indexOf_40_1_41_5882->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_indexOf_40_1_41_5882);
  meth_meth_collectionsPrelude_indexOf_40_1_41_5882->definitionModule = modulename;
  meth_meth_collectionsPrelude_indexOf_40_1_41_5882->definitionLine = 402;
// method "indexOf(_)ifAbsent(_)"
  struct UserObject *uo5898 = (struct UserObject*)obj5798;
  uo5898->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5898 = addmethod2pos(obj5798, "indexOf(1)ifAbsent(1)", &meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5898, 13);
  int argcv_meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5898[] = {1, 1};
  meth_meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5898->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5898);
  meth_meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5898->definitionModule = modulename;
  meth_meth_collectionsPrelude_indexOf_40_1_41_ifAbsent_40_1_41_5898->definitionLine = 405;
// method "asDictionary"
  struct UserObject *uo5910 = (struct UserObject*)obj5798;
  uo5910->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDictionary5910 = addmethod2pos(obj5798, "asDictionary", &meth_collectionsPrelude_asDictionary5910, 14);
  int argcv_meth_collectionsPrelude_asDictionary5910[] = {0};
  meth_meth_collectionsPrelude_asDictionary5910->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDictionary5910);
  meth_meth_collectionsPrelude_asDictionary5910->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDictionary5910->definitionLine = 411;
// method "into(_)"
  struct UserObject *uo5926 = (struct UserObject*)obj5798;
  uo5926->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_into_40_1_41_5926 = addmethod2pos(obj5798, "into(1)", &meth_collectionsPrelude_into_40_1_41_5926, 15);
  int argcv_meth_collectionsPrelude_into_40_1_41_5926[] = {1};
  meth_meth_collectionsPrelude_into_40_1_41_5926->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_into_40_1_41_5926);
  meth_meth_collectionsPrelude_into_40_1_41_5926->definitionModule = modulename;
  meth_meth_collectionsPrelude_into_40_1_41_5926->definitionLine = 418;
  sourceObject = obj5798;
// Begin line 383
  setline(383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5943 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_collection (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5944 = callmethodflags(*var_collection, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe5943);
// compiled call node returning call5944 (depth = 3)
  struct UserObject *obj5798_uo = (struct UserObject *)obj5798;
  obj5798_uo->super = call5944;
  sourceObject = obj5798;
  sourceObject = obj5798;
  sourceObject = obj5798;
  sourceObject = obj5798;
  sourceObject = obj5798;
  sourceObject = obj5798;
  sourceObject = obj5798;
  sourceObject = obj5798;
  sourceObject = obj5798;
  sourceObject = obj5798;
  sourceObject = obj5798;
  sourceObject = obj5798;
  sourceObject = obj5798;
  sourceObject = obj5798;
  sourceObject = obj5798;
  objclass5798 = obj5798->class;
  objclass5798->definitionModule = modulename;
  objclass5798->definitionLine = 382;
  (*(struct UserObject *)self).data[0] = lowerouter5798;
  self = oldself5798;
  selfslot = oldselfslot5798;
  stackframe = oldstackframe5798;
  gc_frame_end(frame);
  return obj5798;
}
Object meth_collectionsPrelude_asString5946(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 382
  setline(382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5947 == NULL) {
    strlit5947 = alloc_String("class indexable");
    gc_root(strlit5947);
  }
// compiled string node returning strlit5947 (depth = 3)
  gc_frame_end(frame);
  return strlit5947;
}
Object meth_collectionsPrelude_indexable5948(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 35, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indexable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_indexable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 382
  setline(382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  gc_frame_end(frame);
  return *var_indexable;
}
Object meth_collectionsPrelude_size5951(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 433
  setline(433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num5952 = alloc_Float64(0);
// compiled num node returning num5952 (depth = 3)
  gc_frame_end(frame);
  return num5952;
}
Object meth_collectionsPrelude_isEmpty5953(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 434
  setline(434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5954 = alloc_Boolean(1);
// compiled identifier node returning bool5954 (depth = 3)
  gc_frame_end(frame);
  return bool5954;
}
Object meth_collectionsPrelude_at_40_1_41_5955(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "at(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at(_)");
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part at(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 435
  setline(435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5956 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5958 == NULL) {
    strlit5958 = alloc_String(" of empty sequence");
    gc_root(strlit5958);
  }
// compiled string node returning strlit5958 (depth = 5)
  int op_slot_right_5957 = gc_frame_newslot(strlit5958);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_right_5960 = gc_frame_newslot(*var_n);
// starting to compile string node (depth = 6)
  if (strlit5962 == NULL) {
    strlit5962 = alloc_String("index ");
    gc_root(strlit5962);
  }
// compiled string node returning strlit5962 (depth = 6)
  int op_slot_left_5960 = gc_frame_newslot(strlit5962);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult5963 = callmethod(strlit5962, "++(1)", 1, partcv, params);
// compiled op node returning opresult5963 (depth = 5)
  int op_slot_left_5957 = gc_frame_newslot(opresult5963);
  params[0] = strlit5958;
  partcv[0] = 1;
  Object opresult5964 = callmethod(opresult5963, "++(1)", 1, partcv, params);
// compiled op node returning opresult5964 (depth = 4)
  gc_frame_newslot(opresult5964);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult5964;
  partcv[0] = 1;
  Object call5965 = callmethodflags(*var_BoundsError, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5956);
// compiled call node returning call5965 (depth = 3)
  gc_frame_end(frame);
  return call5965;
}
Object meth_collectionsPrelude_keys5966(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 436
  setline(436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_values5967(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 437
  setline(437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_keysAndValuesDo_40_1_41_5968(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "keysAndValuesDo(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysAndValuesDo(_)");
  Object params[1];
  int partcv[1];
  Object *var_done = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysAndValuesDo(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part keysAndValuesDo(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 438
  setline(438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_done (depth = 3)
  gc_frame_end(frame);
  return *var_done;
}
Object meth_collectionsPrelude_reversed5969(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "reversed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 439
  setline(439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__43__43__40_1_41_5970(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ++(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 440
  setline(440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5971 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 6: other requests
// starting to compile member node (depth = 4)
  int callframe5972 = gc_frame_new();
// call case 6: other requests
// starting to compile member node (depth = 5)
  int callframe5973 = gc_frame_new();
// call case 3: self.outer request
  Object call5974 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5973);
// compiled member node returning call5974 (depth = 5)
  Object call5975 = callmethodflags(call5974, "sequence", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5972);
// compiled member node returning call5975 (depth = 4)
  params[0] = *var_other;
  partcv[0] = 1;
  Object call5976 = callmethodflags(call5975, "withAll(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5971);
// compiled call node returning call5976 (depth = 3)
  gc_frame_end(frame);
  return call5976;
}
Object meth_collectionsPrelude_asString5977(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 441
  setline(441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5978 == NULL) {
    strlit5978 = alloc_String("""\xe2""""\x9f""""\xa8""""\xe2""""\x9f""""\xa9""");
    gc_root(strlit5978);
  }
// compiled string node returning strlit5978 (depth = 3)
  gc_frame_end(frame);
  return strlit5978;
}
Object meth_collectionsPrelude_contains_40_1_41_5979(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_element = &(stackframe->slots[0]);
  *var_element = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part contains(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 442
  setline(442);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5980 = alloc_Boolean(0);
// compiled identifier node returning bool5980 (depth = 3)
  gc_frame_end(frame);
  return bool5980;
}
Object meth_collectionsPrelude_do_40_1_41_5981(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "do(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do(_)");
  Object params[1];
  int partcv[1];
  Object *var_done = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part do(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 443
  setline(443);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_done (depth = 3)
  gc_frame_end(frame);
  return *var_done;
}
Object meth_collectionsPrelude__apply_40_1_41_5985(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 447
  setline(447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
  int callframe5986 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_o (depth = 6)
  Object call5987 = callmethodflags(*var_o, "isEmpty", 0, partcv, params, 0);
  gc_frame_end(callframe5986);
// compiled member node returning call5987 (depth = 5)
  gc_frame_end(frame);
  return call5987;
}
Object meth_collectionsPrelude__apply_40_1_41_5999(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___12 = &(stackframe->slots[0]);
  *var___12 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool6000 = alloc_Boolean(0);
// compiled identifier node returning bool6000 (depth = 5)
  gc_frame_end(frame);
  return bool6000;
}
Object meth_collectionsPrelude__61__61__40_1_41_5982(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[2];
  int partcv[1];
  Object *var_Iterable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 445
  setline(445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  int frame5983 = gc_frame_new();
  gc_frame_newslot(*var_other);
// Begin line 446
  setline(446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block5984 = alloc_Block(NULL, NULL, "collectionsPrelude", 446);
  gc_frame_newslot(block5984);
// method "_apply(_)"
  block_savedest(block5984);
  Object closure5985 = createclosure(1, "_apply(1)");
  setclosureframe(closure5985, stackframe);
  addtoclosure(closure5985, selfslot);
  struct UserObject *uo5985 = (struct UserObject*)block5984;
  uo5985->data[0] = (Object)closure5985;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_5985 = addmethod2pos(block5984, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_5985, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_5985[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_5985->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_5985);
  meth_meth_collectionsPrelude__apply_40_1_41_5985->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_5985->definitionLine = 1963;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5989 = gc_frame_new();
// starting to compile call node (depth = 6)
  int callframe5990 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5991 == NULL) {
    strlit5991 = alloc_String("o");
    gc_root(strlit5991);
  }
// compiled string node returning strlit5991 (depth = 7)
  gc_frame_newslot(strlit5991);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe5992 = gc_frame_new();
// call case 5: prelude request
  Object call5993 = callmethodflags(prelude, "VariablePattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5992);
// compiled member node returning call5993 (depth = 7)
  params[0] = strlit5991;
  partcv[0] = 1;
  Object call5994 = callmethodflags(call5993, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5990);
// compiled call node returning call5994 (depth = 6)
  gc_frame_newslot(call5994);
// Begin line 446
  setline(446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Iterable (depth = 6)
  gc_frame_newslot(*var_Iterable);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe5995 = gc_frame_new();
// call case 5: prelude request
  Object call5996 = callmethodflags(prelude, "AndPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5995);
// compiled member node returning call5996 (depth = 6)
  params[0] = call5994;
  params[1] = *var_Iterable;
  partcv[0] = 2;
  Object call5997 = callmethodflags(call5996, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe5989);
// compiled call node returning call5997 (depth = 5)
((struct UserObject *)block5984)->data[1] = call5997;
// compiled block node returning block5984 (depth = 4)
  gc_frame_newslot(block5984);
// Begin line 449
  setline(449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block5998 = alloc_Block(NULL, NULL, "collectionsPrelude", 449);
  gc_frame_newslot(block5998);
// method "_apply(_)"
  block_savedest(block5998);
  Object closure5999 = createclosure(1, "_apply(1)");
  setclosureframe(closure5999, stackframe);
  addtoclosure(closure5999, selfslot);
  struct UserObject *uo5999 = (struct UserObject*)block5998;
  uo5999->data[0] = (Object)closure5999;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_5999 = addmethod2pos(block5998, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_5999, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_5999[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_5999->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_5999);
  meth_meth_collectionsPrelude__apply_40_1_41_5999->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_5999->definitionLine = 1963;
// compiled block node returning block5998 (depth = 4)
  gc_frame_newslot(block5998);
  params[0] = block5984;
  params[1] = block5998;
  Object matchres5983 = matchCase(*var_other, params, 2,NULL);
  gc_frame_end(frame5983);
// compiled matchcase node returning matchres5983 (depth = 3)
  gc_frame_end(frame);
  return matchres5983;
}
Object meth_collectionsPrelude_asString6005(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 454
  setline(454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6006 == NULL) {
    strlit6006 = alloc_String("emptySequenceIterator");
    gc_root(strlit6006);
  }
// compiled string node returning strlit6006 (depth = 3)
  gc_frame_end(frame);
  return strlit6006;
}
Object meth_collectionsPrelude_hasNext6007(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 455
  setline(455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6008 = alloc_Boolean(0);
// compiled identifier node returning bool6008 (depth = 3)
  gc_frame_end(frame);
  return bool6008;
}
Object meth_collectionsPrelude_next6009(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 456
  setline(456);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6010 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6011 == NULL) {
    strlit6011 = alloc_String("on empty sequence");
    gc_root(strlit6011);
  }
// compiled string node returning strlit6011 (depth = 4)
  gc_frame_newslot(strlit6011);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_IteratorExhausted (depth = 4)
  params[0] = strlit6011;
  partcv[0] = 1;
  Object call6012 = callmethodflags(*var_IteratorExhausted, "raise(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6010);
// compiled call node returning call6012 (depth = 3)
  gc_frame_end(frame);
  return call6012;
}
Object meth_collectionsPrelude_iterator6002(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6003 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6003 = alloc_userobj2(3,4, objclass6003);
  gc_frame_newslot(obj6003);
if (objclass6003 == NULL) {
  glfree(obj6003->class->name);
  obj6003->class->name = "emptySequence.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6003, self, 0);
  addmethodreal(obj6003,"outer", &reader_collectionsPrelude_outer_6004);
  Object oldself6003 = self;
  struct StackFrameObject *oldstackframe6003 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6003);
  gc_frame_newslot((Object)stackframe);
  self = obj6003;
  Object *oldselfslot6003 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6003 = (*(struct UserObject *)self).data[0], lowerouter6003 = thisouter6003;
  if (inheritingObject6003) {
    struct UserObject *inho6003 = (struct UserObject *)inheritingObject6003;
    while (inho6003->super != GraceDefaultObject) inho6003 = (struct UserObject *)inho6003->super;
    inho6003->super = obj6003;
    self = inheritingObject6003;
    *selfslot = self;
    lowerouter6003 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6003;
  }
// method "asString"
  struct UserObject *uo6005 = (struct UserObject*)obj6003;
  uo6005->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString6005 = addmethod2pos(obj6003, "asString", &meth_collectionsPrelude_asString6005, 1);
  int argcv_meth_collectionsPrelude_asString6005[] = {0};
  meth_meth_collectionsPrelude_asString6005->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString6005);
  meth_meth_collectionsPrelude_asString6005->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString6005->definitionLine = 454;
// method "hasNext"
  struct UserObject *uo6007 = (struct UserObject*)obj6003;
  uo6007->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext6007 = addmethod2pos(obj6003, "hasNext", &meth_collectionsPrelude_hasNext6007, 2);
  int argcv_meth_collectionsPrelude_hasNext6007[] = {0};
  meth_meth_collectionsPrelude_hasNext6007->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext6007);
  meth_meth_collectionsPrelude_hasNext6007->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext6007->definitionLine = 455;
// method "next"
  block_savedest(obj6003);
  Object closure6009 = createclosure(1, "next");
  setclosureframe(closure6009, stackframe);
  addtoclosure(closure6009, var_IteratorExhausted);
  struct UserObject *uo6009 = (struct UserObject*)obj6003;
  uo6009->data[3] = (Object)closure6009;
  Method *meth_meth_collectionsPrelude_next6009 = addmethod2pos(obj6003, "next", &meth_collectionsPrelude_next6009, 3);
  int argcv_meth_collectionsPrelude_next6009[] = {0};
  meth_meth_collectionsPrelude_next6009->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next6009);
  meth_meth_collectionsPrelude_next6009->definitionModule = modulename;
  meth_meth_collectionsPrelude_next6009->definitionLine = 456;
  sourceObject = obj6003;
  sourceObject = obj6003;
  sourceObject = obj6003;
  objclass6003 = obj6003->class;
  objclass6003->definitionModule = modulename;
  objclass6003->definitionLine = 453;
  (*(struct UserObject *)self).data[0] = lowerouter6003;
  self = oldself6003;
  selfslot = oldselfslot6003;
  stackframe = oldstackframe6003;
  gc_frame_end(frame);
  return obj6003;
}
Object meth_collectionsPrelude_iterator6002_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6003 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6003 = alloc_userobj2(3,4, objclass6003);
  gc_frame_newslot(obj6003);
if (objclass6003 == NULL) {
  glfree(obj6003->class->name);
  obj6003->class->name = "emptySequence.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6003, self, 0);
  addmethodreal(obj6003,"outer", &reader_collectionsPrelude_outer_6004);
  Object oldself6003 = self;
  struct StackFrameObject *oldstackframe6003 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6003);
  gc_frame_newslot((Object)stackframe);
  self = obj6003;
  Object *oldselfslot6003 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6003 = (*(struct UserObject *)self).data[0], lowerouter6003 = thisouter6003;
  if (inheritingObject6003) {
    struct UserObject *inho6003 = (struct UserObject *)inheritingObject6003;
    while (inho6003->super != GraceDefaultObject) inho6003 = (struct UserObject *)inho6003->super;
    inho6003->super = obj6003;
    self = inheritingObject6003;
    *selfslot = self;
    lowerouter6003 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6003;
  }
// method "asString"
  struct UserObject *uo6005 = (struct UserObject*)obj6003;
  uo6005->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString6005 = addmethod2pos(obj6003, "asString", &meth_collectionsPrelude_asString6005, 1);
  int argcv_meth_collectionsPrelude_asString6005[] = {0};
  meth_meth_collectionsPrelude_asString6005->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString6005);
  meth_meth_collectionsPrelude_asString6005->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString6005->definitionLine = 454;
// method "hasNext"
  struct UserObject *uo6007 = (struct UserObject*)obj6003;
  uo6007->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext6007 = addmethod2pos(obj6003, "hasNext", &meth_collectionsPrelude_hasNext6007, 2);
  int argcv_meth_collectionsPrelude_hasNext6007[] = {0};
  meth_meth_collectionsPrelude_hasNext6007->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext6007);
  meth_meth_collectionsPrelude_hasNext6007->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext6007->definitionLine = 455;
// method "next"
  block_savedest(obj6003);
  Object closure6009 = createclosure(1, "next");
  setclosureframe(closure6009, stackframe);
  addtoclosure(closure6009, var_IteratorExhausted);
  struct UserObject *uo6009 = (struct UserObject*)obj6003;
  uo6009->data[3] = (Object)closure6009;
  Method *meth_meth_collectionsPrelude_next6009 = addmethod2pos(obj6003, "next", &meth_collectionsPrelude_next6009, 3);
  int argcv_meth_collectionsPrelude_next6009[] = {0};
  meth_meth_collectionsPrelude_next6009->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next6009);
  meth_meth_collectionsPrelude_next6009->definitionModule = modulename;
  meth_meth_collectionsPrelude_next6009->definitionLine = 456;
  sourceObject = obj6003;
  sourceObject = obj6003;
  sourceObject = obj6003;
  objclass6003 = obj6003->class;
  objclass6003->definitionModule = modulename;
  objclass6003->definitionLine = 453;
  (*(struct UserObject *)self).data[0] = lowerouter6003;
  self = oldself6003;
  selfslot = oldselfslot6003;
  stackframe = oldstackframe6003;
  gc_frame_end(frame);
  return obj6003;
}
Object meth_collectionsPrelude_sorted6014(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_sortedBy_40_1_41_6015(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortedBy(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortedBy(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part sortedBy(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 459
  setline(459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_emptySequence6018(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 36, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "emptySequence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 431
  setline(431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptySequence (depth = 3)
  gc_frame_end(frame);
  return *var_emptySequence;
}
Object meth_collectionsPrelude_MinimalyIterable6021(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 37, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "MinimalyIterable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_MinimalyIterable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 599
  setline(599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_MinimalyIterable (depth = 3)
  gc_frame_end(frame);
  return *var_MinimalyIterable;
}
Object meth_collectionsPrelude_asString6027(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1160
  setline(1160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6028 == NULL) {
    strlit6028 = alloc_String("unused");
    gc_root(strlit6028);
  }
// compiled string node returning strlit6028 (depth = 3)
  gc_frame_end(frame);
  return strlit6028;
}
Object meth_collectionsPrelude__61__61__40_1_41_6029(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1161
  setline(1161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6030 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 4: self request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call6031 = callmethodflags(self, "isMe(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6030);
// compiled call node returning call6031 (depth = 3)
  gc_frame_end(frame);
  return call6031;
}
Object meth_collectionsPrelude_unused6033(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 38, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "unused");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_unused = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1156
  setline(1156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_unused (depth = 3)
  gc_frame_end(frame);
  return *var_unused;
}
Object meth_collectionsPrelude_asString6039(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1168
  setline(1168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6040 == NULL) {
    strlit6040 = alloc_String("removed");
    gc_root(strlit6040);
  }
// compiled string node returning strlit6040 (depth = 3)
  gc_frame_end(frame);
  return strlit6040;
}
Object meth_collectionsPrelude__61__61__40_1_41_6041(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1169
  setline(1169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6042 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 4: self request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call6043 = callmethodflags(self, "isMe(1)", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6042);
// compiled call node returning call6043 (depth = 3)
  gc_frame_end(frame);
  return call6043;
}
Object meth_collectionsPrelude_removed6045(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 39, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1164
  setline(1164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_removed (depth = 3)
  gc_frame_end(frame);
  return *var_removed;
}
Object meth_collectionsPrelude_Binding6048(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 40, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Binding");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Binding = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1455
  setline(1455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Binding (depth = 3)
  gc_frame_end(frame);
  return *var_Binding;
}
Object meth_collectionsPrelude_asString6051(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1463
  setline(1463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6052 == NULL) {
    strlit6052 = alloc_String("binding class");
    gc_root(strlit6052);
  }
// compiled string node returning strlit6052 (depth = 3)
  gc_frame_end(frame);
  return strlit6052;
}
Object meth_collectionsPrelude_key6056(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "key");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1466
  setline(1466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_k (depth = 3)
  gc_frame_end(frame);
  return *var_k;
}
Object meth_collectionsPrelude_value6057(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "value");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1467
  setline(1467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  gc_frame_end(frame);
  return *var_v;
}
Object meth_collectionsPrelude_asString6058(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_k = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1468
  setline(1468);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6060 == NULL) {
    strlit6060 = alloc_String("");
    gc_root(strlit6060);
  }
// compiled string node returning strlit6060 (depth = 4)
  int op_slot_right_6059 = gc_frame_newslot(strlit6060);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  int op_slot_right_6062 = gc_frame_newslot(*var_v);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6065 == NULL) {
    strlit6065 = alloc_String("::");
    gc_root(strlit6065);
  }
// compiled string node returning strlit6065 (depth = 6)
  int op_slot_right_6064 = gc_frame_newslot(strlit6065);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_k (depth = 7)
  int op_slot_right_6067 = gc_frame_newslot(*var_k);
// starting to compile string node (depth = 7)
  if (strlit6069 == NULL) {
    strlit6069 = alloc_String("");
    gc_root(strlit6069);
  }
// compiled string node returning strlit6069 (depth = 7)
  int op_slot_left_6067 = gc_frame_newslot(strlit6069);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult6070 = callmethod(strlit6069, "++(1)", 1, partcv, params);
// compiled op node returning opresult6070 (depth = 6)
  int op_slot_left_6064 = gc_frame_newslot(opresult6070);
  params[0] = strlit6065;
  partcv[0] = 1;
  Object opresult6071 = callmethod(opresult6070, "++(1)", 1, partcv, params);
// compiled op node returning opresult6071 (depth = 5)
  int op_slot_left_6062 = gc_frame_newslot(opresult6071);
  params[0] = *var_v;
  partcv[0] = 1;
  Object opresult6072 = callmethod(opresult6071, "++(1)", 1, partcv, params);
// compiled op node returning opresult6072 (depth = 4)
  int op_slot_left_6059 = gc_frame_newslot(opresult6072);
  params[0] = strlit6060;
  partcv[0] = 1;
  Object opresult6073 = callmethod(opresult6072, "++(1)", 1, partcv, params);
// compiled op node returning opresult6073 (depth = 3)
  gc_frame_end(frame);
  return opresult6073;
}
Object meth_collectionsPrelude_hashcode6074(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hashcode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_k = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1469
  setline(1469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6076 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  Object call6077 = callmethodflags(*var_v, "hashcode", 0, partcv, params, 0);
  gc_frame_end(callframe6076);
// compiled member node returning call6077 (depth = 4)
  int op_slot_right_6075 = gc_frame_newslot(call6077);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num6080 = alloc_Float64(1021);
// compiled num node returning num6080 (depth = 5)
  int op_slot_right_6079 = gc_frame_newslot(num6080);
// starting to compile member node (depth = 5)
  int callframe6082 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  Object call6083 = callmethodflags(*var_k, "hashcode", 0, partcv, params, 0);
  gc_frame_end(callframe6082);
// compiled member node returning call6083 (depth = 5)
  int op_slot_left_6079 = gc_frame_newslot(call6083);
  params[0] = num6080;
  partcv[0] = 1;
  Object prod6084 = callmethod(call6083, "*(1)", 1, partcv, params);
// compiled op node returning prod6084 (depth = 4)
  int op_slot_left_6075 = gc_frame_newslot(prod6084);
  params[0] = call6077;
  partcv[0] = 1;
  Object sum6085 = callmethod(prod6084, "+(1)", 1, partcv, params);
// compiled op node returning sum6085 (depth = 3)
  gc_frame_end(frame);
  return sum6085;
}
Object meth_collectionsPrelude_hash6086(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hash");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_k = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1470
  setline(1470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
  int callframe6088 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  Object call6089 = callmethodflags(*var_v, "hash", 0, partcv, params, 0);
  gc_frame_end(callframe6088);
// compiled member node returning call6089 (depth = 4)
  int op_slot_right_6087 = gc_frame_newslot(call6089);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num6092 = alloc_Float64(1021);
// compiled num node returning num6092 (depth = 5)
  int op_slot_right_6091 = gc_frame_newslot(num6092);
// starting to compile member node (depth = 5)
  int callframe6094 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  Object call6095 = callmethodflags(*var_k, "hash", 0, partcv, params, 0);
  gc_frame_end(callframe6094);
// compiled member node returning call6095 (depth = 5)
  int op_slot_left_6091 = gc_frame_newslot(call6095);
  params[0] = num6092;
  partcv[0] = 1;
  Object prod6096 = callmethod(call6095, "*(1)", 1, partcv, params);
// compiled op node returning prod6096 (depth = 4)
  int op_slot_left_6087 = gc_frame_newslot(prod6096);
  params[0] = call6089;
  partcv[0] = 1;
  Object sum6097 = callmethod(prod6096, "+(1)", 1, partcv, params);
// compiled op node returning sum6097 (depth = 3)
  gc_frame_end(frame);
  return sum6097;
}
Object meth_collectionsPrelude__apply_40_1_41_6101(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_k = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe6104 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  Object call6105 = callmethodflags(*var_o, "value", 0, partcv, params, 0);
  gc_frame_end(callframe6104);
// compiled member node returning call6105 (depth = 7)
  int op_slot_right_6103 = gc_frame_newslot(call6105);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  int op_slot_left_6103 = gc_frame_newslot(*var_v);
  params[0] = call6105;
  partcv[0] = 1;
  Object opresult6107 = callmethod(*var_v, "==(1)", 1, partcv, params);
// compiled op node returning opresult6107 (depth = 6)
  int op_slot_right_6102 = gc_frame_newslot(opresult6107);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
  int callframe6110 = gc_frame_new();
// call case 6: other requests
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  Object call6111 = callmethodflags(*var_o, "key", 0, partcv, params, 0);
  gc_frame_end(callframe6110);
// compiled member node returning call6111 (depth = 7)
  int op_slot_right_6109 = gc_frame_newslot(call6111);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_k (depth = 7)
  int op_slot_left_6109 = gc_frame_newslot(*var_k);
  params[0] = call6111;
  partcv[0] = 1;
  Object opresult6113 = callmethod(*var_k, "==(1)", 1, partcv, params);
// compiled op node returning opresult6113 (depth = 6)
  int op_slot_left_6102 = gc_frame_newslot(opresult6113);
  params[0] = opresult6107;
  partcv[0] = 1;
  Object opresult6114 = callmethod(opresult6113, "&&(1)", 1, partcv, params);
// compiled op node returning opresult6114 (depth = 5)
  gc_frame_end(frame);
  return opresult6114;
}
Object meth_collectionsPrelude__apply_40_1_41_6126(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply(_)");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___15 = &(stackframe->slots[0]);
  *var___15 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool6127 = alloc_Boolean(0);
// compiled identifier node returning bool6127 (depth = 6)
  block_return(realself, bool6127);
// compiled return node returning undefined (depth = 5)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__61__61__40_1_41_6098(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==(_)");
  Object params[2];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_k = getfromclosure(closure, 1);
  Object *var_Binding = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ==(_) (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part ==(_)");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1472
  setline(1472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  int frame6099 = gc_frame_new();
  gc_frame_newslot(*var_other);
// Begin line 1473
  setline(1473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block6100 = alloc_Block(NULL, NULL, "collectionsPrelude", 1473);
  gc_frame_newslot(block6100);
// method "_apply(_)"
  block_savedest(block6100);
  Object closure6101 = createclosure(3, "_apply(1)");
  setclosureframe(closure6101, stackframe);
  addtoclosure(closure6101, var_v);
  addtoclosure(closure6101, var_k);
  addtoclosure(closure6101, selfslot);
  struct UserObject *uo6101 = (struct UserObject*)block6100;
  uo6101->data[0] = (Object)closure6101;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_6101 = addmethod2pos(block6100, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_6101, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_6101[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_6101->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_6101);
  meth_meth_collectionsPrelude__apply_40_1_41_6101->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_6101->definitionLine = 1963;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6116 = gc_frame_new();
// starting to compile call node (depth = 6)
  int callframe6117 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6118 == NULL) {
    strlit6118 = alloc_String("o");
    gc_root(strlit6118);
  }
// compiled string node returning strlit6118 (depth = 7)
  gc_frame_newslot(strlit6118);
// call case 6: other requests
// starting to compile member node (depth = 7)
  int callframe6119 = gc_frame_new();
// call case 5: prelude request
  Object call6120 = callmethodflags(prelude, "VariablePattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6119);
// compiled member node returning call6120 (depth = 7)
  params[0] = strlit6118;
  partcv[0] = 1;
  Object call6121 = callmethodflags(call6120, "new(1)", 1, partcv, params, 0);
  gc_frame_end(callframe6117);
// compiled call node returning call6121 (depth = 6)
  gc_frame_newslot(call6121);
// Begin line 1473
  setline(1473);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Binding (depth = 6)
  gc_frame_newslot(*var_Binding);
// call case 6: other requests
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
  int callframe6122 = gc_frame_new();
// call case 5: prelude request
  Object call6123 = callmethodflags(prelude, "AndPattern", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6122);
// compiled member node returning call6123 (depth = 6)
  params[0] = call6121;
  params[1] = *var_Binding;
  partcv[0] = 2;
  Object call6124 = callmethodflags(call6123, "new(2)", 1, partcv, params, 0);
  gc_frame_end(callframe6116);
// compiled call node returning call6124 (depth = 5)
((struct UserObject *)block6100)->data[1] = call6124;
// compiled block node returning block6100 (depth = 4)
  gc_frame_newslot(block6100);
// Begin line 1474
  setline(1474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block6125 = alloc_Block(NULL, NULL, "collectionsPrelude", 1474);
  gc_frame_newslot(block6125);
// method "_apply(_)"
  block_savedest(block6125);
  Object closure6126 = createclosure(1, "_apply(1)");
  setclosureframe(closure6126, stackframe);
  addtoclosure(closure6126, selfslot);
  struct UserObject *uo6126 = (struct UserObject*)block6125;
  uo6126->data[0] = (Object)closure6126;
  Method *meth_meth_collectionsPrelude__apply_40_1_41_6126 = addmethod2pos(block6125, "_apply(1)", &meth_collectionsPrelude__apply_40_1_41_6126, 0);
  int argcv_meth_collectionsPrelude__apply_40_1_41_6126[] = {1};
  meth_meth_collectionsPrelude__apply_40_1_41_6126->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply_40_1_41_6126);
  meth_meth_collectionsPrelude__apply_40_1_41_6126->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply_40_1_41_6126->definitionLine = 1963;
// compiled block node returning block6125 (depth = 4)
  gc_frame_newslot(block6125);
  params[0] = block6100;
  params[1] = block6125;
  Object matchres6099 = matchCase(*var_other, params, 2,NULL);
  gc_frame_end(frame6099);
// compiled matchcase node returning matchres6099 (depth = 3)
  gc_frame_end(frame);
  return matchres6099;
}
Object meth_collectionsPrelude_key_40_1_41_value_40_1_41_6053(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "key(1)value(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method key(_)value(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method key(_)value(_)");
  Object params[1];
  int partcv[1];
  Object *var_Binding = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for key(_)value(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part key(_)");
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part value(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6054 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6054 = alloc_userobj2(6,7, objclass6054);
  gc_frame_newslot(obj6054);
if (objclass6054 == NULL) {
  glfree(obj6054->class->name);
  obj6054->class->name = "binding.key(_)value(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6054, self, 0);
  addmethodreal(obj6054,"outer", &reader_collectionsPrelude_outer_6055);
  Object oldself6054 = self;
  struct StackFrameObject *oldstackframe6054 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6054);
  gc_frame_newslot((Object)stackframe);
  self = obj6054;
  Object *oldselfslot6054 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6054 = (*(struct UserObject *)self).data[0], lowerouter6054 = thisouter6054;
  if (inheritingObject6054) {
    struct UserObject *inho6054 = (struct UserObject *)inheritingObject6054;
    while (inho6054->super != GraceDefaultObject) inho6054 = (struct UserObject *)inho6054->super;
    inho6054->super = obj6054;
    self = inheritingObject6054;
    *selfslot = self;
    lowerouter6054 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6054;
  }
// method "key"
  block_savedest(obj6054);
  Object closure6056 = createclosure(1, "key");
  setclosureframe(closure6056, stackframe);
  addtoclosure(closure6056, var_k);
  struct UserObject *uo6056 = (struct UserObject*)obj6054;
  uo6056->data[1] = (Object)closure6056;
  Method *meth_meth_collectionsPrelude_key6056 = addmethod2pos(obj6054, "key", &meth_collectionsPrelude_key6056, 1);
  int argcv_meth_collectionsPrelude_key6056[] = {0};
  meth_meth_collectionsPrelude_key6056->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_key6056);
  meth_meth_collectionsPrelude_key6056->definitionModule = modulename;
  meth_meth_collectionsPrelude_key6056->definitionLine = 1466;
// method "value"
  block_savedest(obj6054);
  Object closure6057 = createclosure(1, "value");
  setclosureframe(closure6057, stackframe);
  addtoclosure(closure6057, var_v);
  struct UserObject *uo6057 = (struct UserObject*)obj6054;
  uo6057->data[2] = (Object)closure6057;
  Method *meth_meth_collectionsPrelude_value6057 = addmethod2pos(obj6054, "value", &meth_collectionsPrelude_value6057, 2);
  int argcv_meth_collectionsPrelude_value6057[] = {0};
  meth_meth_collectionsPrelude_value6057->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_value6057);
  meth_meth_collectionsPrelude_value6057->definitionModule = modulename;
  meth_meth_collectionsPrelude_value6057->definitionLine = 1467;
// method "asString"
  block_savedest(obj6054);
  Object closure6058 = createclosure(2, "asString");
  setclosureframe(closure6058, stackframe);
  addtoclosure(closure6058, var_v);
  addtoclosure(closure6058, var_k);
  struct UserObject *uo6058 = (struct UserObject*)obj6054;
  uo6058->data[3] = (Object)closure6058;
  Method *meth_meth_collectionsPrelude_asString6058 = addmethod2pos(obj6054, "asString", &meth_collectionsPrelude_asString6058, 3);
  int argcv_meth_collectionsPrelude_asString6058[] = {0};
  meth_meth_collectionsPrelude_asString6058->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString6058);
  meth_meth_collectionsPrelude_asString6058->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString6058->definitionLine = 1468;
// method "hashcode"
  block_savedest(obj6054);
  Object closure6074 = createclosure(2, "hashcode");
  setclosureframe(closure6074, stackframe);
  addtoclosure(closure6074, var_v);
  addtoclosure(closure6074, var_k);
  struct UserObject *uo6074 = (struct UserObject*)obj6054;
  uo6074->data[4] = (Object)closure6074;
  Method *meth_meth_collectionsPrelude_hashcode6074 = addmethod2pos(obj6054, "hashcode", &meth_collectionsPrelude_hashcode6074, 4);
  int argcv_meth_collectionsPrelude_hashcode6074[] = {0};
  meth_meth_collectionsPrelude_hashcode6074->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hashcode6074);
  meth_meth_collectionsPrelude_hashcode6074->definitionModule = modulename;
  meth_meth_collectionsPrelude_hashcode6074->definitionLine = 1469;
// method "hash"
  block_savedest(obj6054);
  Object closure6086 = createclosure(2, "hash");
  setclosureframe(closure6086, stackframe);
  addtoclosure(closure6086, var_v);
  addtoclosure(closure6086, var_k);
  struct UserObject *uo6086 = (struct UserObject*)obj6054;
  uo6086->data[5] = (Object)closure6086;
  Method *meth_meth_collectionsPrelude_hash6086 = addmethod2pos(obj6054, "hash", &meth_collectionsPrelude_hash6086, 5);
  int argcv_meth_collectionsPrelude_hash6086[] = {0};
  meth_meth_collectionsPrelude_hash6086->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hash6086);
  meth_meth_collectionsPrelude_hash6086->definitionModule = modulename;
  meth_meth_collectionsPrelude_hash6086->definitionLine = 1470;
// method "==(_)"
  block_savedest(obj6054);
  Object closure6098 = createclosure(3, "==(1)");
  setclosureframe(closure6098, stackframe);
  addtoclosure(closure6098, var_v);
  addtoclosure(closure6098, var_k);
  addtoclosure(closure6098, var_Binding);
  struct UserObject *uo6098 = (struct UserObject*)obj6054;
  uo6098->data[6] = (Object)closure6098;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_6098 = addmethod2pos(obj6054, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_6098, 6);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_6098[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_6098->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_6098);
  meth_meth_collectionsPrelude__61__61__40_1_41_6098->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_6098->definitionLine = 1471;
  sourceObject = obj6054;
  sourceObject = obj6054;
  sourceObject = obj6054;
  sourceObject = obj6054;
  sourceObject = obj6054;
  sourceObject = obj6054;
  objclass6054 = obj6054->class;
  objclass6054->definitionModule = modulename;
  objclass6054->definitionLine = 1465;
  (*(struct UserObject *)self).data[0] = lowerouter6054;
  self = oldself6054;
  selfslot = oldselfslot6054;
  stackframe = oldstackframe6054;
  gc_frame_end(frame);
  return obj6054;
}
Object meth_collectionsPrelude_key_40_1_41_value_40_1_41_6053_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "key(1)value(1)$object(1)");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments for method key(_)value(_)");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments for method key(_)value(_)");
  Object params[1];
  int partcv[1];
  Object *var_Binding = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for key(_)value(_) (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part key(_)");
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for part value(_)");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6054 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6054 = alloc_userobj2(6,7, objclass6054);
  gc_frame_newslot(obj6054);
if (objclass6054 == NULL) {
  glfree(obj6054->class->name);
  obj6054->class->name = "binding.key(_)value(_)";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6054, self, 0);
  addmethodreal(obj6054,"outer", &reader_collectionsPrelude_outer_6055);
  Object oldself6054 = self;
  struct StackFrameObject *oldstackframe6054 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6054);
  gc_frame_newslot((Object)stackframe);
  self = obj6054;
  Object *oldselfslot6054 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6054 = (*(struct UserObject *)self).data[0], lowerouter6054 = thisouter6054;
  if (inheritingObject6054) {
    struct UserObject *inho6054 = (struct UserObject *)inheritingObject6054;
    while (inho6054->super != GraceDefaultObject) inho6054 = (struct UserObject *)inho6054->super;
    inho6054->super = obj6054;
    self = inheritingObject6054;
    *selfslot = self;
    lowerouter6054 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6054;
  }
// method "key"
  block_savedest(obj6054);
  Object closure6056 = createclosure(1, "key");
  setclosureframe(closure6056, stackframe);
  addtoclosure(closure6056, var_k);
  struct UserObject *uo6056 = (struct UserObject*)obj6054;
  uo6056->data[1] = (Object)closure6056;
  Method *meth_meth_collectionsPrelude_key6056 = addmethod2pos(obj6054, "key", &meth_collectionsPrelude_key6056, 1);
  int argcv_meth_collectionsPrelude_key6056[] = {0};
  meth_meth_collectionsPrelude_key6056->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_key6056);
  meth_meth_collectionsPrelude_key6056->definitionModule = modulename;
  meth_meth_collectionsPrelude_key6056->definitionLine = 1466;
// method "value"
  block_savedest(obj6054);
  Object closure6057 = createclosure(1, "value");
  setclosureframe(closure6057, stackframe);
  addtoclosure(closure6057, var_v);
  struct UserObject *uo6057 = (struct UserObject*)obj6054;
  uo6057->data[2] = (Object)closure6057;
  Method *meth_meth_collectionsPrelude_value6057 = addmethod2pos(obj6054, "value", &meth_collectionsPrelude_value6057, 2);
  int argcv_meth_collectionsPrelude_value6057[] = {0};
  meth_meth_collectionsPrelude_value6057->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_value6057);
  meth_meth_collectionsPrelude_value6057->definitionModule = modulename;
  meth_meth_collectionsPrelude_value6057->definitionLine = 1467;
// method "asString"
  block_savedest(obj6054);
  Object closure6058 = createclosure(2, "asString");
  setclosureframe(closure6058, stackframe);
  addtoclosure(closure6058, var_v);
  addtoclosure(closure6058, var_k);
  struct UserObject *uo6058 = (struct UserObject*)obj6054;
  uo6058->data[3] = (Object)closure6058;
  Method *meth_meth_collectionsPrelude_asString6058 = addmethod2pos(obj6054, "asString", &meth_collectionsPrelude_asString6058, 3);
  int argcv_meth_collectionsPrelude_asString6058[] = {0};
  meth_meth_collectionsPrelude_asString6058->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString6058);
  meth_meth_collectionsPrelude_asString6058->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString6058->definitionLine = 1468;
// method "hashcode"
  block_savedest(obj6054);
  Object closure6074 = createclosure(2, "hashcode");
  setclosureframe(closure6074, stackframe);
  addtoclosure(closure6074, var_v);
  addtoclosure(closure6074, var_k);
  struct UserObject *uo6074 = (struct UserObject*)obj6054;
  uo6074->data[4] = (Object)closure6074;
  Method *meth_meth_collectionsPrelude_hashcode6074 = addmethod2pos(obj6054, "hashcode", &meth_collectionsPrelude_hashcode6074, 4);
  int argcv_meth_collectionsPrelude_hashcode6074[] = {0};
  meth_meth_collectionsPrelude_hashcode6074->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hashcode6074);
  meth_meth_collectionsPrelude_hashcode6074->definitionModule = modulename;
  meth_meth_collectionsPrelude_hashcode6074->definitionLine = 1469;
// method "hash"
  block_savedest(obj6054);
  Object closure6086 = createclosure(2, "hash");
  setclosureframe(closure6086, stackframe);
  addtoclosure(closure6086, var_v);
  addtoclosure(closure6086, var_k);
  struct UserObject *uo6086 = (struct UserObject*)obj6054;
  uo6086->data[5] = (Object)closure6086;
  Method *meth_meth_collectionsPrelude_hash6086 = addmethod2pos(obj6054, "hash", &meth_collectionsPrelude_hash6086, 5);
  int argcv_meth_collectionsPrelude_hash6086[] = {0};
  meth_meth_collectionsPrelude_hash6086->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hash6086);
  meth_meth_collectionsPrelude_hash6086->definitionModule = modulename;
  meth_meth_collectionsPrelude_hash6086->definitionLine = 1470;
// method "==(_)"
  block_savedest(obj6054);
  Object closure6098 = createclosure(3, "==(1)");
  setclosureframe(closure6098, stackframe);
  addtoclosure(closure6098, var_v);
  addtoclosure(closure6098, var_k);
  addtoclosure(closure6098, var_Binding);
  struct UserObject *uo6098 = (struct UserObject*)obj6054;
  uo6098->data[6] = (Object)closure6098;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_6098 = addmethod2pos(obj6054, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_6098, 6);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_6098[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_6098->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_6098);
  meth_meth_collectionsPrelude__61__61__40_1_41_6098->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_6098->definitionLine = 1471;
  sourceObject = obj6054;
  sourceObject = obj6054;
  sourceObject = obj6054;
  sourceObject = obj6054;
  sourceObject = obj6054;
  sourceObject = obj6054;
  objclass6054 = obj6054->class;
  objclass6054->definitionModule = modulename;
  objclass6054->definitionLine = 1465;
  (*(struct UserObject *)self).data[0] = lowerouter6054;
  self = oldself6054;
  selfslot = oldselfslot6054;
  stackframe = oldstackframe6054;
  gc_frame_end(frame);
  return obj6054;
}
Object meth_collectionsPrelude_binding6130(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 41, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "binding");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_binding = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1462
  setline(1462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_binding (depth = 3)
  gc_frame_end(frame);
  return *var_binding;
}
Object meth_collectionsPrelude_ComparableToDictionary6133(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 42, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ComparableToDictionary");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ComparableToDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1479
  setline(1479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ComparableToDictionary (depth = 3)
  gc_frame_end(frame);
  return *var_ComparableToDictionary;
}
Object module_collectionsPrelude_init() {
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(53, 53);
  self->class->definitionModule = modulename;
  gc_root(self);
  prelude = grace_prelude();
  adddatum2(self, grace_prelude(), 0);
  Object ObjectType = alloc_ObjectType();
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
  setclassname(self, "Module<collectionsPrelude>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = prelude;
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(53, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
// end of preamble
  Object params[1];
  int partcv[2];
  Object *var_BoundsError = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "BoundsError");
  Object *var_IteratorExhausted = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "IteratorExhausted");
  Object *var_SubobjectResponsibility = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "SubobjectResponsibility");
  Object *var_NoSuchObject = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "NoSuchObject");
  Object *var_RequestError = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "RequestError");
  Object *var_ConcurrentModification = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "ConcurrentModification");
  Object *var_SizeUnknown = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "SizeUnknown");
  Object *var_Block0 = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "Block0");
  Object *var_Block1 = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "Block1");
  Object *var_Block2 = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "Block2");
  Object *var_SelfType = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "SelfType");
  Object *var_Iterable = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "Iterable");
  Object *var_Expandable = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "Expandable");
  Object *var_Collection = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "Collection");
  Object *var_Enumerable = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "Enumerable");
  Object *var_Sequence = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "Sequence");
  Object *var_List = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "List");
  Object *var_Set = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "Set");
  Object *var_Dictionary = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "Dictionary");
  Object *var_Iterator = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "Iterator");
  Object *var_collection = &(stackframe->slots[21]);
  setframeelementname(stackframe, 21, "collection");
  Object *var_enumerable = &(stackframe->slots[22]);
  setframeelementname(stackframe, 22, "enumerable");
  Object *var_indexable = &(stackframe->slots[23]);
  setframeelementname(stackframe, 23, "indexable");
  Object *var_emptySequence = &(stackframe->slots[24]);
  setframeelementname(stackframe, 24, "emptySequence");
  Object *var_MinimalyIterable = &(stackframe->slots[25]);
  setframeelementname(stackframe, 25, "MinimalyIterable");
  Object *var_unused = &(stackframe->slots[26]);
  setframeelementname(stackframe, 26, "unused");
  Object *var_removed = &(stackframe->slots[27]);
  setframeelementname(stackframe, 27, "removed");
  Object *var_Binding = &(stackframe->slots[28]);
  setframeelementname(stackframe, 28, "Binding");
  Object *var_binding = &(stackframe->slots[29]);
  setframeelementname(stackframe, 29, "binding");
  Object *var_ComparableToDictionary = &(stackframe->slots[30]);
  setframeelementname(stackframe, 30, "ComparableToDictionary");
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "abstract"
  block_savedest(self);
  Object closure1 = createclosure(1, "abstract");
  setclosureframe(closure1, stackframe);
  addtoclosure(closure1, var_SubobjectResponsibility);
  struct UserObject *uo1 = (struct UserObject*)self;
  uo1->data[1] = (Object)closure1;
  Method *meth_meth_collectionsPrelude_abstract1 = addmethod2pos(self, "abstract", &meth_collectionsPrelude_abstract1, 1);
  int argcv_meth_collectionsPrelude_abstract1[] = {0};
  meth_meth_collectionsPrelude_abstract1->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_abstract1);
  meth_meth_collectionsPrelude_abstract1->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_abstract1->definitionModule = modulename;
  meth_meth_collectionsPrelude_abstract1->definitionLine = 11;
// compiled method node returning  (depth = 1)
// Begin line 166
  setline(166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "lazySequenceOver(_)mappedBy(_)"
  block_savedest(self);
  Object closure5 = createclosure(1, "lazySequenceOver(1)mappedBy(1)");
  setclosureframe(closure5, stackframe);
  addtoclosure(closure5, var_enumerable);
  struct UserObject *uo5 = (struct UserObject*)self;
  uo5->data[2] = (Object)closure5;
  Method *meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5 = addmethod2pos(self, "lazySequenceOver(1)mappedBy(1)", &meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5, 2);
  int argcv_meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5[] = {1, 1};
  meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5);
  meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5->definitionModule = modulename;
  meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5->definitionLine = 166;
  block_savedest(self);
  Object closure46 = createclosure(1, "lazySequenceOver(1)mappedBy(1)$object(1)");
  setclosureframe(closure46, stackframe);
  addtoclosure(closure46, var_enumerable);
  Method *meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5_object = addmethod2pos(self, "lazySequenceOver(1)mappedBy(1)$object(1)", &meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5_object, 2);
  meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5_object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_mappedBy_40_1_41_5_object->definitionLine = 166;
// compiled method node returning  (depth = 1)
// Begin line 180
  setline(180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "lazySequenceOver(_)filteredBy(_)"
  block_savedest(self);
  Object closure47 = createclosure(1, "lazySequenceOver(1)filteredBy(1)");
  setclosureframe(closure47, stackframe);
  addtoclosure(closure47, var_enumerable);
  struct UserObject *uo47 = (struct UserObject*)self;
  uo47->data[3] = (Object)closure47;
  Method *meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47 = addmethod2pos(self, "lazySequenceOver(1)filteredBy(1)", &meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47, 3);
  int argcv_meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47[] = {1, 1};
  meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47);
  meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47->definitionModule = modulename;
  meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47->definitionLine = 180;
  block_savedest(self);
  Object closure150 = createclosure(1, "lazySequenceOver(1)filteredBy(1)$object(1)");
  setclosureframe(closure150, stackframe);
  addtoclosure(closure150, var_enumerable);
  Method *meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47_object = addmethod2pos(self, "lazySequenceOver(1)filteredBy(1)$object(1)", &meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47_object, 3);
  meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47_object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_lazySequenceOver_40_1_41_filteredBy_40_1_41_47_object->definitionLine = 180;
// compiled method node returning  (depth = 1)
// Begin line 225
  setline(225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "iteratorConcat(_,_)"
  struct UserObject *uo151 = (struct UserObject*)self;
  uo151->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iteratorConcat_40_2_41_151 = addmethod2pos(self, "iteratorConcat(2)", &meth_collectionsPrelude_iteratorConcat_40_2_41_151, 4);
  int argcv_meth_collectionsPrelude_iteratorConcat_40_2_41_151[] = {2};
  meth_meth_collectionsPrelude_iteratorConcat_40_2_41_151->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iteratorConcat_40_2_41_151);
  meth_meth_collectionsPrelude_iteratorConcat_40_2_41_151->definitionModule = modulename;
  meth_meth_collectionsPrelude_iteratorConcat_40_2_41_151->definitionLine = 225;
  Method *meth_meth_collectionsPrelude_iteratorConcat_40_2_41_151_object = addmethod2pos(self, "iteratorConcat(2)$object(1)", &meth_collectionsPrelude_iteratorConcat_40_2_41_151_object, 4);
  int argcv_meth_collectionsPrelude_iteratorConcat_40_2_41_151_object[] = {2};
  meth_meth_collectionsPrelude_iteratorConcat_40_2_41_151_object->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iteratorConcat_40_2_41_151_object);
  meth_meth_collectionsPrelude_iteratorConcat_40_2_41_151_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iteratorConcat_40_2_41_151_object->definitionLine = 225;
// compiled method node returning  (depth = 1)
// Begin line 240
  setline(240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "lazyConcatenation(_,_)"
  block_savedest(self);
  Object closure188 = createclosure(1, "lazyConcatenation(2)");
  setclosureframe(closure188, stackframe);
  addtoclosure(closure188, var_enumerable);
  struct UserObject *uo188 = (struct UserObject*)self;
  uo188->data[5] = (Object)closure188;
  Method *meth_meth_collectionsPrelude_lazyConcatenation_40_2_41_188 = addmethod2pos(self, "lazyConcatenation(2)", &meth_collectionsPrelude_lazyConcatenation_40_2_41_188, 5);
  int argcv_meth_collectionsPrelude_lazyConcatenation_40_2_41_188[] = {2};
  meth_meth_collectionsPrelude_lazyConcatenation_40_2_41_188->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_lazyConcatenation_40_2_41_188);
  meth_meth_collectionsPrelude_lazyConcatenation_40_2_41_188->definitionModule = modulename;
  meth_meth_collectionsPrelude_lazyConcatenation_40_2_41_188->definitionLine = 240;
  block_savedest(self);
  Object closure229 = createclosure(1, "lazyConcatenation(2)$object(1)");
  setclosureframe(closure229, stackframe);
  addtoclosure(closure229, var_enumerable);
  Method *meth_meth_collectionsPrelude_lazyConcatenation_40_2_41_188_object = addmethod2pos(self, "lazyConcatenation(2)$object(1)", &meth_collectionsPrelude_lazyConcatenation_40_2_41_188_object, 5);
  meth_meth_collectionsPrelude_lazyConcatenation_40_2_41_188_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_lazyConcatenation_40_2_41_188_object->definitionLine = 240;
// compiled method node returning  (depth = 1)
// Begin line 427
  setline(427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "max(_,_)"
  struct UserObject *uo230 = (struct UserObject*)self;
  uo230->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_max_40_2_41_230 = addmethod2pos(self, "max(2)", &meth_collectionsPrelude_max_40_2_41_230, 6);
  int argcv_meth_collectionsPrelude_max_40_2_41_230[] = {2};
  meth_meth_collectionsPrelude_max_40_2_41_230->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_max_40_2_41_230);
  meth_meth_collectionsPrelude_max_40_2_41_230->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_max_40_2_41_230->definitionModule = modulename;
  meth_meth_collectionsPrelude_max_40_2_41_230->definitionLine = 427;
// compiled method node returning  (depth = 1)
// Begin line 462
  setline(462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "sequence"
  block_savedest(self);
  Object closure235 = createclosure(5, "sequence");
  setclosureframe(closure235, stackframe);
  addtoclosure(closure235, var_emptySequence);
  addtoclosure(closure235, var__prelude);
  addtoclosure(closure235, var_BoundsError);
  addtoclosure(closure235, var_IteratorExhausted);
  addtoclosure(closure235, var_indexable);
  struct UserObject *uo235 = (struct UserObject*)self;
  uo235->data[7] = (Object)closure235;
  Method *meth_meth_collectionsPrelude_sequence235 = addmethod2pos(self, "sequence", &meth_collectionsPrelude_sequence235, 7);
  int argcv_meth_collectionsPrelude_sequence235[] = {0};
  meth_meth_collectionsPrelude_sequence235->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sequence235);
  meth_meth_collectionsPrelude_sequence235->definitionModule = modulename;
  meth_meth_collectionsPrelude_sequence235->definitionLine = 462;
  block_savedest(self);
  Object closure665 = createclosure(5, "sequence$object(1)");
  setclosureframe(closure665, stackframe);
  addtoclosure(closure665, var_emptySequence);
  addtoclosure(closure665, var__prelude);
  addtoclosure(closure665, var_BoundsError);
  addtoclosure(closure665, var_IteratorExhausted);
  addtoclosure(closure665, var_indexable);
  Method *meth_meth_collectionsPrelude_sequence235_object = addmethod2pos(self, "sequence$object(1)", &meth_collectionsPrelude_sequence235_object, 7);
  meth_meth_collectionsPrelude_sequence235_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_sequence235_object->definitionLine = 462;
// compiled method node returning  (depth = 1)
// Begin line 603
  setline(603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "isEqual(_)toIterable(_)"
  block_savedest(self);
  Object closure666 = createclosure(1, "isEqual(1)toIterable(1)");
  setclosureframe(closure666, stackframe);
  addtoclosure(closure666, var_MinimalyIterable);
  struct UserObject *uo666 = (struct UserObject*)self;
  uo666->data[8] = (Object)closure666;
  Method *meth_meth_collectionsPrelude_isEqual_40_1_41_toIterable_40_1_41_666 = addmethod2pos(self, "isEqual(1)toIterable(1)", &meth_collectionsPrelude_isEqual_40_1_41_toIterable_40_1_41_666, 8);
  int argcv_meth_collectionsPrelude_isEqual_40_1_41_toIterable_40_1_41_666[] = {1, 1};
  meth_meth_collectionsPrelude_isEqual_40_1_41_toIterable_40_1_41_666->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_isEqual_40_1_41_toIterable_40_1_41_666);
  meth_meth_collectionsPrelude_isEqual_40_1_41_toIterable_40_1_41_666->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEqual_40_1_41_toIterable_40_1_41_666->definitionLine = 603;
// compiled method node returning  (depth = 1)
// Begin line 618
  setline(618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "list"
  block_savedest(self);
  Object closure706 = createclosure(8, "list");
  setclosureframe(closure706, stackframe);
  addtoclosure(closure706, var_emptySequence);
  addtoclosure(closure706, var_NoSuchObject);
  addtoclosure(closure706, var_done);
  addtoclosure(closure706, var_ConcurrentModification);
  addtoclosure(closure706, var_IteratorExhausted);
  addtoclosure(closure706, var_indexable);
  addtoclosure(closure706, var_BoundsError);
  addtoclosure(closure706, var__prelude);
  struct UserObject *uo706 = (struct UserObject*)self;
  uo706->data[9] = (Object)closure706;
  Method *meth_meth_collectionsPrelude_list706 = addmethod2pos(self, "list", &meth_collectionsPrelude_list706, 9);
  int argcv_meth_collectionsPrelude_list706[] = {0};
  meth_meth_collectionsPrelude_list706->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_list706);
  meth_meth_collectionsPrelude_list706->definitionModule = modulename;
  meth_meth_collectionsPrelude_list706->definitionLine = 618;
  block_savedest(self);
  Object closure2264 = createclosure(8, "list$object(1)");
  setclosureframe(closure2264, stackframe);
  addtoclosure(closure2264, var_emptySequence);
  addtoclosure(closure2264, var_NoSuchObject);
  addtoclosure(closure2264, var_done);
  addtoclosure(closure2264, var_ConcurrentModification);
  addtoclosure(closure2264, var_IteratorExhausted);
  addtoclosure(closure2264, var_indexable);
  addtoclosure(closure2264, var_BoundsError);
  addtoclosure(closure2264, var__prelude);
  Method *meth_meth_collectionsPrelude_list706_object = addmethod2pos(self, "list$object(1)", &meth_collectionsPrelude_list706_object, 9);
  meth_meth_collectionsPrelude_list706_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_list706_object->definitionLine = 618;
// compiled method node returning  (depth = 1)
// Begin line 1172
  setline(1172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "set"
  block_savedest(self);
  Object closure2265 = createclosure(8, "set");
  setclosureframe(closure2265, stackframe);
  addtoclosure(closure2265, var_NoSuchObject);
  addtoclosure(closure2265, var_removed);
  addtoclosure(closure2265, var_unused);
  addtoclosure(closure2265, var_ConcurrentModification);
  addtoclosure(closure2265, var_IteratorExhausted);
  addtoclosure(closure2265, var__prelude);
  addtoclosure(closure2265, var_Iterable);
  addtoclosure(closure2265, var_collection);
  struct UserObject *uo2265 = (struct UserObject*)self;
  uo2265->data[10] = (Object)closure2265;
  Method *meth_meth_collectionsPrelude_set2265 = addmethod2pos(self, "set", &meth_collectionsPrelude_set2265, 10);
  int argcv_meth_collectionsPrelude_set2265[] = {0};
  meth_meth_collectionsPrelude_set2265->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_set2265);
  meth_meth_collectionsPrelude_set2265->definitionModule = modulename;
  meth_meth_collectionsPrelude_set2265->definitionLine = 1172;
  block_savedest(self);
  Object closure3086 = createclosure(8, "set$object(1)");
  setclosureframe(closure3086, stackframe);
  addtoclosure(closure3086, var_NoSuchObject);
  addtoclosure(closure3086, var_removed);
  addtoclosure(closure3086, var_unused);
  addtoclosure(closure3086, var_ConcurrentModification);
  addtoclosure(closure3086, var_IteratorExhausted);
  addtoclosure(closure3086, var__prelude);
  addtoclosure(closure3086, var_Iterable);
  addtoclosure(closure3086, var_collection);
  Method *meth_meth_collectionsPrelude_set2265_object = addmethod2pos(self, "set$object(1)", &meth_collectionsPrelude_set2265_object, 10);
  meth_meth_collectionsPrelude_set2265_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_set2265_object->definitionLine = 1172;
// compiled method node returning  (depth = 1)
// Begin line 1484
  setline(1484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "dictionary"
  block_savedest(self);
  Object closure3087 = createclosure(10, "dictionary");
  setclosureframe(closure3087, stackframe);
  addtoclosure(closure3087, var_removed);
  addtoclosure(closure3087, var_unused);
  addtoclosure(closure3087, var_binding);
  addtoclosure(closure3087, var_NoSuchObject);
  addtoclosure(closure3087, var_enumerable);
  addtoclosure(closure3087, var_ConcurrentModification);
  addtoclosure(closure3087, var_IteratorExhausted);
  addtoclosure(closure3087, var__prelude);
  addtoclosure(closure3087, var_ComparableToDictionary);
  addtoclosure(closure3087, var_collection);
  struct UserObject *uo3087 = (struct UserObject*)self;
  uo3087->data[11] = (Object)closure3087;
  Method *meth_meth_collectionsPrelude_dictionary3087 = addmethod2pos(self, "dictionary", &meth_collectionsPrelude_dictionary3087, 11);
  int argcv_meth_collectionsPrelude_dictionary3087[] = {0};
  meth_meth_collectionsPrelude_dictionary3087->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_dictionary3087);
  meth_meth_collectionsPrelude_dictionary3087->definitionModule = modulename;
  meth_meth_collectionsPrelude_dictionary3087->definitionLine = 1484;
  block_savedest(self);
  Object closure4418 = createclosure(10, "dictionary$object(1)");
  setclosureframe(closure4418, stackframe);
  addtoclosure(closure4418, var_removed);
  addtoclosure(closure4418, var_unused);
  addtoclosure(closure4418, var_binding);
  addtoclosure(closure4418, var_NoSuchObject);
  addtoclosure(closure4418, var_enumerable);
  addtoclosure(closure4418, var_ConcurrentModification);
  addtoclosure(closure4418, var_IteratorExhausted);
  addtoclosure(closure4418, var__prelude);
  addtoclosure(closure4418, var_ComparableToDictionary);
  addtoclosure(closure4418, var_collection);
  Method *meth_meth_collectionsPrelude_dictionary3087_object = addmethod2pos(self, "dictionary$object(1)", &meth_collectionsPrelude_dictionary3087_object, 11);
  meth_meth_collectionsPrelude_dictionary3087_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_dictionary3087_object->definitionLine = 1484;
// compiled method node returning  (depth = 1)
// Begin line 1849
  setline(1849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "range"
  block_savedest(self);
  Object closure4419 = createclosure(6, "range");
  setclosureframe(closure4419, stackframe);
  addtoclosure(closure4419, var_Number);
  addtoclosure(closure4419, var_RequestError);
  addtoclosure(closure4419, var_IteratorExhausted);
  addtoclosure(closure4419, var_BoundsError);
  addtoclosure(closure4419, var__prelude);
  addtoclosure(closure4419, var_indexable);
  struct UserObject *uo4419 = (struct UserObject*)self;
  uo4419->data[12] = (Object)closure4419;
  Method *meth_meth_collectionsPrelude_range4419 = addmethod2pos(self, "range", &meth_collectionsPrelude_range4419, 12);
  int argcv_meth_collectionsPrelude_range4419[] = {0};
  meth_meth_collectionsPrelude_range4419->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_range4419);
  meth_meth_collectionsPrelude_range4419->definitionModule = modulename;
  meth_meth_collectionsPrelude_range4419->definitionLine = 1849;
  block_savedest(self);
  Object closure5390 = createclosure(6, "range$object(1)");
  setclosureframe(closure5390, stackframe);
  addtoclosure(closure5390, var_Number);
  addtoclosure(closure5390, var_RequestError);
  addtoclosure(closure5390, var_IteratorExhausted);
  addtoclosure(closure5390, var_BoundsError);
  addtoclosure(closure5390, var__prelude);
  addtoclosure(closure5390, var_indexable);
  Method *meth_meth_collectionsPrelude_range4419_object = addmethod2pos(self, "range$object(1)", &meth_collectionsPrelude_range4419_object, 12);
  meth_meth_collectionsPrelude_range4419_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_range4419_object->definitionLine = 1849;
// compiled method node returning  (depth = 1)
// Begin line 2
  setline(2);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5391 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5392 == NULL) {
    strlit5392 = alloc_String("BoundsError");
    gc_root(strlit5392);
  }
// compiled string node returning strlit5392 (depth = 3)
  gc_frame_newslot(strlit5392);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5393 = gc_frame_new();
// call case 5: prelude request
  Object call5394 = callmethodflags(prelude, "ProgrammingError", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5393);
// compiled member node returning call5394 (depth = 3)
  params[0] = strlit5392;
  partcv[0] = 1;
  Object call5395 = callmethodflags(call5394, "refine(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5391);
// compiled call node returning call5395 (depth = 2)
  *var_BoundsError = call5395;
  if (call5395 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "BoundsError"
  block_savedest(self);
  Object closure5396 = createclosure(1, "BoundsError");
  setclosureframe(closure5396, stackframe);
  addtoclosure(closure5396, var_BoundsError);
  struct UserObject *uo5396 = (struct UserObject*)self;
  uo5396->data[13] = (Object)closure5396;
  Method *meth_meth_collectionsPrelude_BoundsError5396 = addmethod2pos(self, "BoundsError", &meth_collectionsPrelude_BoundsError5396, 13);
  int argcv_meth_collectionsPrelude_BoundsError5396[] = {0};
  meth_meth_collectionsPrelude_BoundsError5396->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_BoundsError5396);
  meth_meth_collectionsPrelude_BoundsError5396->definitionModule = modulename;
  meth_meth_collectionsPrelude_BoundsError5396->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 4
  setline(4);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5397 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5398 == NULL) {
    strlit5398 = alloc_String("IteratorExhausted");
    gc_root(strlit5398);
  }
// compiled string node returning strlit5398 (depth = 3)
  gc_frame_newslot(strlit5398);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5399 = gc_frame_new();
// call case 5: prelude request
  Object call5400 = callmethodflags(prelude, "ProgrammingError", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5399);
// compiled member node returning call5400 (depth = 3)
  params[0] = strlit5398;
  partcv[0] = 1;
  Object call5401 = callmethodflags(call5400, "refine(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5397);
// compiled call node returning call5401 (depth = 2)
  *var_IteratorExhausted = call5401;
  if (call5401 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "IteratorExhausted"
  block_savedest(self);
  Object closure5402 = createclosure(1, "IteratorExhausted");
  setclosureframe(closure5402, stackframe);
  addtoclosure(closure5402, var_IteratorExhausted);
  struct UserObject *uo5402 = (struct UserObject*)self;
  uo5402->data[14] = (Object)closure5402;
  Method *meth_meth_collectionsPrelude_IteratorExhausted5402 = addmethod2pos(self, "IteratorExhausted", &meth_collectionsPrelude_IteratorExhausted5402, 14);
  int argcv_meth_collectionsPrelude_IteratorExhausted5402[] = {0};
  meth_meth_collectionsPrelude_IteratorExhausted5402->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_IteratorExhausted5402);
  meth_meth_collectionsPrelude_IteratorExhausted5402->definitionModule = modulename;
  meth_meth_collectionsPrelude_IteratorExhausted5402->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 5
  setline(5);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5403 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5404 == NULL) {
    strlit5404 = alloc_String("SubobjectResponsibility");
    gc_root(strlit5404);
  }
// compiled string node returning strlit5404 (depth = 3)
  gc_frame_newslot(strlit5404);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5405 = gc_frame_new();
// call case 5: prelude request
  Object call5406 = callmethodflags(prelude, "ProgrammingError", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5405);
// compiled member node returning call5406 (depth = 3)
  params[0] = strlit5404;
  partcv[0] = 1;
  Object call5407 = callmethodflags(call5406, "refine(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5403);
// compiled call node returning call5407 (depth = 2)
  *var_SubobjectResponsibility = call5407;
  if (call5407 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "SubobjectResponsibility"
  block_savedest(self);
  Object closure5408 = createclosure(1, "SubobjectResponsibility");
  setclosureframe(closure5408, stackframe);
  addtoclosure(closure5408, var_SubobjectResponsibility);
  struct UserObject *uo5408 = (struct UserObject*)self;
  uo5408->data[15] = (Object)closure5408;
  Method *meth_meth_collectionsPrelude_SubobjectResponsibility5408 = addmethod2pos(self, "SubobjectResponsibility", &meth_collectionsPrelude_SubobjectResponsibility5408, 15);
  int argcv_meth_collectionsPrelude_SubobjectResponsibility5408[] = {0};
  meth_meth_collectionsPrelude_SubobjectResponsibility5408->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_SubobjectResponsibility5408);
  meth_meth_collectionsPrelude_SubobjectResponsibility5408->definitionModule = modulename;
  meth_meth_collectionsPrelude_SubobjectResponsibility5408->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 6
  setline(6);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5409 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5410 == NULL) {
    strlit5410 = alloc_String("NoSuchObject");
    gc_root(strlit5410);
  }
// compiled string node returning strlit5410 (depth = 3)
  gc_frame_newslot(strlit5410);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5411 = gc_frame_new();
// call case 5: prelude request
  Object call5412 = callmethodflags(prelude, "ProgrammingError", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5411);
// compiled member node returning call5412 (depth = 3)
  params[0] = strlit5410;
  partcv[0] = 1;
  Object call5413 = callmethodflags(call5412, "refine(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5409);
// compiled call node returning call5413 (depth = 2)
  *var_NoSuchObject = call5413;
  if (call5413 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "NoSuchObject"
  block_savedest(self);
  Object closure5414 = createclosure(1, "NoSuchObject");
  setclosureframe(closure5414, stackframe);
  addtoclosure(closure5414, var_NoSuchObject);
  struct UserObject *uo5414 = (struct UserObject*)self;
  uo5414->data[16] = (Object)closure5414;
  Method *meth_meth_collectionsPrelude_NoSuchObject5414 = addmethod2pos(self, "NoSuchObject", &meth_collectionsPrelude_NoSuchObject5414, 16);
  int argcv_meth_collectionsPrelude_NoSuchObject5414[] = {0};
  meth_meth_collectionsPrelude_NoSuchObject5414->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_NoSuchObject5414);
  meth_meth_collectionsPrelude_NoSuchObject5414->definitionModule = modulename;
  meth_meth_collectionsPrelude_NoSuchObject5414->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 7
  setline(7);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5415 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5416 == NULL) {
    strlit5416 = alloc_String("RequestError");
    gc_root(strlit5416);
  }
// compiled string node returning strlit5416 (depth = 3)
  gc_frame_newslot(strlit5416);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5417 = gc_frame_new();
// call case 5: prelude request
  Object call5418 = callmethodflags(prelude, "ProgrammingError", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5417);
// compiled member node returning call5418 (depth = 3)
  params[0] = strlit5416;
  partcv[0] = 1;
  Object call5419 = callmethodflags(call5418, "refine(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5415);
// compiled call node returning call5419 (depth = 2)
  *var_RequestError = call5419;
  if (call5419 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "RequestError"
  block_savedest(self);
  Object closure5420 = createclosure(1, "RequestError");
  setclosureframe(closure5420, stackframe);
  addtoclosure(closure5420, var_RequestError);
  struct UserObject *uo5420 = (struct UserObject*)self;
  uo5420->data[17] = (Object)closure5420;
  Method *meth_meth_collectionsPrelude_RequestError5420 = addmethod2pos(self, "RequestError", &meth_collectionsPrelude_RequestError5420, 17);
  int argcv_meth_collectionsPrelude_RequestError5420[] = {0};
  meth_meth_collectionsPrelude_RequestError5420->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_RequestError5420);
  meth_meth_collectionsPrelude_RequestError5420->definitionModule = modulename;
  meth_meth_collectionsPrelude_RequestError5420->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 8
  setline(8);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5421 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5422 == NULL) {
    strlit5422 = alloc_String("ConcurrentModification");
    gc_root(strlit5422);
  }
// compiled string node returning strlit5422 (depth = 3)
  gc_frame_newslot(strlit5422);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5423 = gc_frame_new();
// call case 5: prelude request
  Object call5424 = callmethodflags(prelude, "ProgrammingError", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5423);
// compiled member node returning call5424 (depth = 3)
  params[0] = strlit5422;
  partcv[0] = 1;
  Object call5425 = callmethodflags(call5424, "refine(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5421);
// compiled call node returning call5425 (depth = 2)
  *var_ConcurrentModification = call5425;
  if (call5425 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "ConcurrentModification"
  block_savedest(self);
  Object closure5426 = createclosure(1, "ConcurrentModification");
  setclosureframe(closure5426, stackframe);
  addtoclosure(closure5426, var_ConcurrentModification);
  struct UserObject *uo5426 = (struct UserObject*)self;
  uo5426->data[18] = (Object)closure5426;
  Method *meth_meth_collectionsPrelude_ConcurrentModification5426 = addmethod2pos(self, "ConcurrentModification", &meth_collectionsPrelude_ConcurrentModification5426, 18);
  int argcv_meth_collectionsPrelude_ConcurrentModification5426[] = {0};
  meth_meth_collectionsPrelude_ConcurrentModification5426->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_ConcurrentModification5426);
  meth_meth_collectionsPrelude_ConcurrentModification5426->definitionModule = modulename;
  meth_meth_collectionsPrelude_ConcurrentModification5426->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5427 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5428 == NULL) {
    strlit5428 = alloc_String("SizeUnknown");
    gc_root(strlit5428);
  }
// compiled string node returning strlit5428 (depth = 3)
  gc_frame_newslot(strlit5428);
// call case 6: other requests
// starting to compile member node (depth = 3)
  int callframe5429 = gc_frame_new();
// call case 5: prelude request
  Object call5430 = callmethodflags(prelude, "Exception", 0, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5429);
// compiled member node returning call5430 (depth = 3)
  params[0] = strlit5428;
  partcv[0] = 1;
  Object call5431 = callmethodflags(call5430, "refine(1)", 1, partcv, params, 0);
  gc_frame_end(callframe5427);
// compiled call node returning call5431 (depth = 2)
  *var_SizeUnknown = call5431;
  if (call5431 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "SizeUnknown"
  block_savedest(self);
  Object closure5432 = createclosure(1, "SizeUnknown");
  setclosureframe(closure5432, stackframe);
  addtoclosure(closure5432, var_SizeUnknown);
  struct UserObject *uo5432 = (struct UserObject*)self;
  uo5432->data[19] = (Object)closure5432;
  Method *meth_meth_collectionsPrelude_SizeUnknown5432 = addmethod2pos(self, "SizeUnknown", &meth_collectionsPrelude_SizeUnknown5432, 19);
  int argcv_meth_collectionsPrelude_SizeUnknown5432[] = {0};
  meth_meth_collectionsPrelude_SizeUnknown5432->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_SizeUnknown5432);
  meth_meth_collectionsPrelude_SizeUnknown5432->definitionModule = modulename;
  meth_meth_collectionsPrelude_SizeUnknown5432->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 10
  setline(10);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Block0
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type5434 = alloc_Type("Block0", 1);
    add_Method((ClassData)type5434, "apply", NULL);
// compiled typeliteral node returning type5434 (depth = 2)
  *var_Block0 = type5434;
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Block0"
  block_savedest(self);
  Object closure5435 = createclosure(1, "Block0");
  setclosureframe(closure5435, stackframe);
  addtoclosure(closure5435, var_Block0);
  struct UserObject *uo5435 = (struct UserObject*)self;
  uo5435->data[20] = (Object)closure5435;
  Method *meth_meth_collectionsPrelude_Block05435 = addmethod2pos(self, "Block0", &meth_collectionsPrelude_Block05435, 20);
  int argcv_meth_collectionsPrelude_Block05435[] = {0};
  meth_meth_collectionsPrelude_Block05435->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Block05435);
  meth_meth_collectionsPrelude_Block05435->definitionModule = modulename;
  meth_meth_collectionsPrelude_Block05435->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Block1
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type5437 = alloc_Type("Block1", 1);
    add_Method((ClassData)type5437, "apply(1)", NULL);
// compiled typeliteral node returning type5437 (depth = 2)
  *var_Block1 = type5437;
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Block1"
  block_savedest(self);
  Object closure5438 = createclosure(1, "Block1");
  setclosureframe(closure5438, stackframe);
  addtoclosure(closure5438, var_Block1);
  struct UserObject *uo5438 = (struct UserObject*)self;
  uo5438->data[21] = (Object)closure5438;
  Method *meth_meth_collectionsPrelude_Block15438 = addmethod2pos(self, "Block1", &meth_collectionsPrelude_Block15438, 21);
  int argcv_meth_collectionsPrelude_Block15438[] = {0};
  meth_meth_collectionsPrelude_Block15438->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Block15438);
  meth_meth_collectionsPrelude_Block15438->definitionModule = modulename;
  meth_meth_collectionsPrelude_Block15438->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Block2
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type5440 = alloc_Type("Block2", 1);
    add_Method((ClassData)type5440, "apply(2)", NULL);
// compiled typeliteral node returning type5440 (depth = 2)
  *var_Block2 = type5440;
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Block2"
  block_savedest(self);
  Object closure5441 = createclosure(1, "Block2");
  setclosureframe(closure5441, stackframe);
  addtoclosure(closure5441, var_Block2);
  struct UserObject *uo5441 = (struct UserObject*)self;
  uo5441->data[22] = (Object)closure5441;
  Method *meth_meth_collectionsPrelude_Block25441 = addmethod2pos(self, "Block2", &meth_collectionsPrelude_Block25441, 22);
  int argcv_meth_collectionsPrelude_Block25441[] = {0};
  meth_meth_collectionsPrelude_Block25441->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Block25441);
  meth_meth_collectionsPrelude_Block25441->definitionModule = modulename;
  meth_meth_collectionsPrelude_Block25441->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 27
  setline(27);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl SelfType
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_Unknown (depth = 2)
  *var_SelfType = *var_Unknown;
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "SelfType"
  block_savedest(self);
  Object closure5443 = createclosure(1, "SelfType");
  setclosureframe(closure5443, stackframe);
  addtoclosure(closure5443, var_SelfType);
  struct UserObject *uo5443 = (struct UserObject*)self;
  uo5443->data[23] = (Object)closure5443;
  Method *meth_meth_collectionsPrelude_SelfType5443 = addmethod2pos(self, "SelfType", &meth_collectionsPrelude_SelfType5443, 23);
  int argcv_meth_collectionsPrelude_SelfType5443[] = {0};
  meth_meth_collectionsPrelude_SelfType5443->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_SelfType5443);
  meth_meth_collectionsPrelude_SelfType5443->definitionModule = modulename;
  meth_meth_collectionsPrelude_SelfType5443->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 29
  setline(29);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Iterable
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5446 = alloc_Type("‹anon›", 11);
    add_Method((ClassData)type5446, "iterator", NULL);
    add_Method((ClassData)type5446, "isEmpty", NULL);
    add_Method((ClassData)type5446, "size", NULL);
    add_Method((ClassData)type5446, "sizeIfUnknown(1)", NULL);
    add_Method((ClassData)type5446, "first", NULL);
    add_Method((ClassData)type5446, "do(1)", NULL);
    add_Method((ClassData)type5446, "do(1)separatedBy(1)", NULL);
    add_Method((ClassData)type5446, "++(1)", NULL);
    add_Method((ClassData)type5446, "fold(1)startingWith(1)", NULL);
    add_Method((ClassData)type5446, "map(1)", NULL);
    add_Method((ClassData)type5446, "filter(1)", NULL);
// compiled typeliteral node returning type5446 (depth = 3)
  int op_slot_right_5445 = gc_frame_newslot(type5446);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Object (depth = 3)
  int op_slot_left_5445 = gc_frame_newslot(*var_Object);
  params[0] = type5446;
  partcv[0] = 1;
  Object opresult5448 = callmethod(*var_Object, "&(1)", 1, partcv, params);
// compiled op node returning opresult5448 (depth = 2)
  *var_Iterable = opresult5448;
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Iterable"
  block_savedest(self);
  Object closure5449 = createclosure(1, "Iterable");
  setclosureframe(closure5449, stackframe);
  addtoclosure(closure5449, var_Iterable);
  struct UserObject *uo5449 = (struct UserObject*)self;
  uo5449->data[24] = (Object)closure5449;
  Method *meth_meth_collectionsPrelude_Iterable5449 = addmethod2pos(self, "Iterable", &meth_collectionsPrelude_Iterable5449, 24);
  int argcv_meth_collectionsPrelude_Iterable5449[] = {0};
  meth_meth_collectionsPrelude_Iterable5449->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Iterable5449);
  meth_meth_collectionsPrelude_Iterable5449->definitionModule = modulename;
  meth_meth_collectionsPrelude_Iterable5449->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Expandable
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5452 = alloc_Type("‹anon›", 2);
    add_Method((ClassData)type5452, "add(1)", NULL);
    add_Method((ClassData)type5452, "addAll(1)", NULL);
// compiled typeliteral node returning type5452 (depth = 3)
  int op_slot_right_5451 = gc_frame_newslot(type5452);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Iterable (depth = 3)
  int op_slot_left_5451 = gc_frame_newslot(*var_Iterable);
  params[0] = type5452;
  partcv[0] = 1;
  Object opresult5454 = callmethod(*var_Iterable, "&(1)", 1, partcv, params);
// compiled op node returning opresult5454 (depth = 2)
  *var_Expandable = opresult5454;
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Expandable"
  block_savedest(self);
  Object closure5455 = createclosure(1, "Expandable");
  setclosureframe(closure5455, stackframe);
  addtoclosure(closure5455, var_Expandable);
  struct UserObject *uo5455 = (struct UserObject*)self;
  uo5455->data[25] = (Object)closure5455;
  Method *meth_meth_collectionsPrelude_Expandable5455 = addmethod2pos(self, "Expandable", &meth_collectionsPrelude_Expandable5455, 25);
  int argcv_meth_collectionsPrelude_Expandable5455[] = {0};
  meth_meth_collectionsPrelude_Expandable5455->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Expandable5455);
  meth_meth_collectionsPrelude_Expandable5455->definitionModule = modulename;
  meth_meth_collectionsPrelude_Expandable5455->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 60
  setline(60);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 61
  setline(61);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Collection
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5458 = alloc_Type("‹anon›", 3);
    add_Method((ClassData)type5458, "asList", NULL);
    add_Method((ClassData)type5458, "asSequence", NULL);
    add_Method((ClassData)type5458, "asSet", NULL);
// compiled typeliteral node returning type5458 (depth = 3)
  int op_slot_right_5457 = gc_frame_newslot(type5458);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Iterable (depth = 3)
  int op_slot_left_5457 = gc_frame_newslot(*var_Iterable);
  params[0] = type5458;
  partcv[0] = 1;
  Object opresult5460 = callmethod(*var_Iterable, "&(1)", 1, partcv, params);
// compiled op node returning opresult5460 (depth = 2)
  *var_Collection = opresult5460;
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Collection"
  block_savedest(self);
  Object closure5461 = createclosure(1, "Collection");
  setclosureframe(closure5461, stackframe);
  addtoclosure(closure5461, var_Collection);
  struct UserObject *uo5461 = (struct UserObject*)self;
  uo5461->data[26] = (Object)closure5461;
  Method *meth_meth_collectionsPrelude_Collection5461 = addmethod2pos(self, "Collection", &meth_collectionsPrelude_Collection5461, 26);
  int argcv_meth_collectionsPrelude_Collection5461[] = {0};
  meth_meth_collectionsPrelude_Collection5461->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Collection5461);
  meth_meth_collectionsPrelude_Collection5461->definitionModule = modulename;
  meth_meth_collectionsPrelude_Collection5461->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 66
  setline(66);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 67
  setline(67);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Enumerable
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5464 = alloc_Type("‹anon›", 6);
    add_Method((ClassData)type5464, "values", NULL);
    add_Method((ClassData)type5464, "asDictionary", NULL);
    add_Method((ClassData)type5464, "keysAndValuesDo(1)", NULL);
    add_Method((ClassData)type5464, "into(1)", NULL);
    add_Method((ClassData)type5464, "sortedBy(1)", NULL);
    add_Method((ClassData)type5464, "sorted", NULL);
// compiled typeliteral node returning type5464 (depth = 3)
  int op_slot_right_5463 = gc_frame_newslot(type5464);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Collection (depth = 3)
  int op_slot_left_5463 = gc_frame_newslot(*var_Collection);
  params[0] = type5464;
  partcv[0] = 1;
  Object opresult5466 = callmethod(*var_Collection, "&(1)", 1, partcv, params);
// compiled op node returning opresult5466 (depth = 2)
  *var_Enumerable = opresult5466;
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Enumerable"
  block_savedest(self);
  Object closure5467 = createclosure(1, "Enumerable");
  setclosureframe(closure5467, stackframe);
  addtoclosure(closure5467, var_Enumerable);
  struct UserObject *uo5467 = (struct UserObject*)self;
  uo5467->data[27] = (Object)closure5467;
  Method *meth_meth_collectionsPrelude_Enumerable5467 = addmethod2pos(self, "Enumerable", &meth_collectionsPrelude_Enumerable5467, 27);
  int argcv_meth_collectionsPrelude_Enumerable5467[] = {0};
  meth_meth_collectionsPrelude_Enumerable5467->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Enumerable5467);
  meth_meth_collectionsPrelude_Enumerable5467->definitionModule = modulename;
  meth_meth_collectionsPrelude_Enumerable5467->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 75
  setline(75);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 76
  setline(76);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Sequence
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5470 = alloc_Type("‹anon›", 13);
    add_Method((ClassData)type5470, "size", NULL);
    add_Method((ClassData)type5470, "at(1)", NULL);
    add_Method((ClassData)type5470, "indices", NULL);
    add_Method((ClassData)type5470, "keys", NULL);
    add_Method((ClassData)type5470, "second", NULL);
    add_Method((ClassData)type5470, "third", NULL);
    add_Method((ClassData)type5470, "fourth", NULL);
    add_Method((ClassData)type5470, "fifth", NULL);
    add_Method((ClassData)type5470, "last", NULL);
    add_Method((ClassData)type5470, "indexOf(1)ifAbsent(1)", NULL);
    add_Method((ClassData)type5470, "indexOf(1)", NULL);
    add_Method((ClassData)type5470, "contains(1)", NULL);
    add_Method((ClassData)type5470, "reversed", NULL);
// compiled typeliteral node returning type5470 (depth = 3)
  int op_slot_right_5469 = gc_frame_newslot(type5470);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Enumerable (depth = 3)
  int op_slot_left_5469 = gc_frame_newslot(*var_Enumerable);
  params[0] = type5470;
  partcv[0] = 1;
  Object opresult5472 = callmethod(*var_Enumerable, "&(1)", 1, partcv, params);
// compiled op node returning opresult5472 (depth = 2)
  *var_Sequence = opresult5472;
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Sequence"
  block_savedest(self);
  Object closure5473 = createclosure(1, "Sequence");
  setclosureframe(closure5473, stackframe);
  addtoclosure(closure5473, var_Sequence);
  struct UserObject *uo5473 = (struct UserObject*)self;
  uo5473->data[28] = (Object)closure5473;
  Method *meth_meth_collectionsPrelude_Sequence5473 = addmethod2pos(self, "Sequence", &meth_collectionsPrelude_Sequence5473, 28);
  int argcv_meth_collectionsPrelude_Sequence5473[] = {0};
  meth_meth_collectionsPrelude_Sequence5473->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Sequence5473);
  meth_meth_collectionsPrelude_Sequence5473->definitionModule = modulename;
  meth_meth_collectionsPrelude_Sequence5473->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl List
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5476 = alloc_Type("‹anon›", 21);
    add_Method((ClassData)type5476, "add(1)", NULL);
    add_Method((ClassData)type5476, "addAll(1)", NULL);
    add_Method((ClassData)type5476, "addFirst(1)", NULL);
    add_Method((ClassData)type5476, "addAllFirst(1)", NULL);
    add_Method((ClassData)type5476, "addLast(1)", NULL);
    add_Method((ClassData)type5476, "at(1)put(1)", NULL);
    add_Method((ClassData)type5476, "removeFirst", NULL);
    add_Method((ClassData)type5476, "removeAt(1)", NULL);
    add_Method((ClassData)type5476, "removeLast", NULL);
    add_Method((ClassData)type5476, "remove(1)", NULL);
    add_Method((ClassData)type5476, "remove(1)ifAbsent(1)", NULL);
    add_Method((ClassData)type5476, "removeAll(1)", NULL);
    add_Method((ClassData)type5476, "removeAll(1)ifAbsent(1)", NULL);
    add_Method((ClassData)type5476, "pop", NULL);
    add_Method((ClassData)type5476, "++(1)", NULL);
    add_Method((ClassData)type5476, "addAll(1)", NULL);
    add_Method((ClassData)type5476, "copy", NULL);
    add_Method((ClassData)type5476, "sort", NULL);
    add_Method((ClassData)type5476, "sortBy(1)", NULL);
    add_Method((ClassData)type5476, "reverse", NULL);
    add_Method((ClassData)type5476, "reversed", NULL);
// compiled typeliteral node returning type5476 (depth = 3)
  int op_slot_right_5475 = gc_frame_newslot(type5476);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Sequence (depth = 3)
  int op_slot_left_5475 = gc_frame_newslot(*var_Sequence);
  params[0] = type5476;
  partcv[0] = 1;
  Object opresult5478 = callmethod(*var_Sequence, "&(1)", 1, partcv, params);
// compiled op node returning opresult5478 (depth = 2)
  *var_List = opresult5478;
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "List"
  block_savedest(self);
  Object closure5479 = createclosure(1, "List");
  setclosureframe(closure5479, stackframe);
  addtoclosure(closure5479, var_List);
  struct UserObject *uo5479 = (struct UserObject*)self;
  uo5479->data[29] = (Object)closure5479;
  Method *meth_meth_collectionsPrelude_List5479 = addmethod2pos(self, "List", &meth_collectionsPrelude_List5479, 29);
  int argcv_meth_collectionsPrelude_List5479[] = {0};
  meth_meth_collectionsPrelude_List5479->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_List5479);
  meth_meth_collectionsPrelude_List5479->definitionModule = modulename;
  meth_meth_collectionsPrelude_List5479->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 115
  setline(115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 116
  setline(116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Set
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5482 = alloc_Type("‹anon›", 17);
    add_Method((ClassData)type5482, "size", NULL);
    add_Method((ClassData)type5482, "add(1)", NULL);
    add_Method((ClassData)type5482, "addAll(1)", NULL);
    add_Method((ClassData)type5482, "remove(1)", NULL);
    add_Method((ClassData)type5482, "remove(1)ifAbsent(1)", NULL);
    add_Method((ClassData)type5482, "includes(1)", NULL);
    add_Method((ClassData)type5482, "find(1)ifNone(1)", NULL);
    add_Method((ClassData)type5482, "copy", NULL);
    add_Method((ClassData)type5482, "contains(1)", NULL);
    add_Method((ClassData)type5482, "**(1)", NULL);
    add_Method((ClassData)type5482, "--(1)", NULL);
    add_Method((ClassData)type5482, "++(1)", NULL);
    add_Method((ClassData)type5482, "isSubset(1)", NULL);
    add_Method((ClassData)type5482, "isSuperset(1)", NULL);
    add_Method((ClassData)type5482, "removeAll(1)", NULL);
    add_Method((ClassData)type5482, "removeAll(1)ifAbsent(1)", NULL);
    add_Method((ClassData)type5482, "into(1)", NULL);
// compiled typeliteral node returning type5482 (depth = 3)
  int op_slot_right_5481 = gc_frame_newslot(type5482);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Collection (depth = 3)
  int op_slot_left_5481 = gc_frame_newslot(*var_Collection);
  params[0] = type5482;
  partcv[0] = 1;
  Object opresult5484 = callmethod(*var_Collection, "&(1)", 1, partcv, params);
// compiled op node returning opresult5484 (depth = 2)
  *var_Set = opresult5484;
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Set"
  block_savedest(self);
  Object closure5485 = createclosure(1, "Set");
  setclosureframe(closure5485, stackframe);
  addtoclosure(closure5485, var_Set);
  struct UserObject *uo5485 = (struct UserObject*)self;
  uo5485->data[30] = (Object)closure5485;
  Method *meth_meth_collectionsPrelude_Set5485 = addmethod2pos(self, "Set", &meth_collectionsPrelude_Set5485, 30);
  int argcv_meth_collectionsPrelude_Set5485[] = {0};
  meth_meth_collectionsPrelude_Set5485->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Set5485);
  meth_meth_collectionsPrelude_Set5485->definitionModule = modulename;
  meth_meth_collectionsPrelude_Set5485->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 136
  setline(136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Dictionary
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5488 = alloc_Type("‹anon›", 22);
    add_Method((ClassData)type5488, "size", NULL);
    add_Method((ClassData)type5488, "containsKey(1)", NULL);
    add_Method((ClassData)type5488, "containsValue(1)", NULL);
    add_Method((ClassData)type5488, "contains(1)", NULL);
    add_Method((ClassData)type5488, "at(1)ifAbsent(1)", NULL);
    add_Method((ClassData)type5488, "at(1)put(1)", NULL);
    add_Method((ClassData)type5488, "at(1)", NULL);
    add_Method((ClassData)type5488, "removeAllKeys(1)", NULL);
    add_Method((ClassData)type5488, "removeKey(1)", NULL);
    add_Method((ClassData)type5488, "removeAllValues(1)", NULL);
    add_Method((ClassData)type5488, "removeValue(1)", NULL);
    add_Method((ClassData)type5488, "keys", NULL);
    add_Method((ClassData)type5488, "values", NULL);
    add_Method((ClassData)type5488, "bindings", NULL);
    add_Method((ClassData)type5488, "keysAndValuesDo(1)", NULL);
    add_Method((ClassData)type5488, "keysDo(1)", NULL);
    add_Method((ClassData)type5488, "valuesDo(1)", NULL);
    add_Method((ClassData)type5488, "==(1)", NULL);
    add_Method((ClassData)type5488, "copy", NULL);
    add_Method((ClassData)type5488, "++(1)", NULL);
    add_Method((ClassData)type5488, "--(1)", NULL);
    add_Method((ClassData)type5488, "asDictionary", NULL);
// compiled typeliteral node returning type5488 (depth = 3)
  int op_slot_right_5487 = gc_frame_newslot(type5488);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Collection (depth = 3)
  int op_slot_left_5487 = gc_frame_newslot(*var_Collection);
  params[0] = type5488;
  partcv[0] = 1;
  Object opresult5490 = callmethod(*var_Collection, "&(1)", 1, partcv, params);
// compiled op node returning opresult5490 (depth = 2)
  *var_Dictionary = opresult5490;
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Dictionary"
  block_savedest(self);
  Object closure5491 = createclosure(1, "Dictionary");
  setclosureframe(closure5491, stackframe);
  addtoclosure(closure5491, var_Dictionary);
  struct UserObject *uo5491 = (struct UserObject*)self;
  uo5491->data[31] = (Object)closure5491;
  Method *meth_meth_collectionsPrelude_Dictionary5491 = addmethod2pos(self, "Dictionary", &meth_collectionsPrelude_Dictionary5491, 31);
  int argcv_meth_collectionsPrelude_Dictionary5491[] = {0};
  meth_meth_collectionsPrelude_Dictionary5491->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Dictionary5491);
  meth_meth_collectionsPrelude_Dictionary5491->definitionModule = modulename;
  meth_meth_collectionsPrelude_Dictionary5491->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 160
  setline(160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 161
  setline(161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Iterator
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type5493 = alloc_Type("Iterator", 2);
    add_Method((ClassData)type5493, "hasNext", NULL);
    add_Method((ClassData)type5493, "next", NULL);
// compiled typeliteral node returning type5493 (depth = 2)
  *var_Iterator = type5493;
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Iterator"
  block_savedest(self);
  Object closure5494 = createclosure(1, "Iterator");
  setclosureframe(closure5494, stackframe);
  addtoclosure(closure5494, var_Iterator);
  struct UserObject *uo5494 = (struct UserObject*)self;
  uo5494->data[32] = (Object)closure5494;
  Method *meth_meth_collectionsPrelude_Iterator5494 = addmethod2pos(self, "Iterator", &meth_collectionsPrelude_Iterator5494, 32);
  int argcv_meth_collectionsPrelude_Iterator5494[] = {0};
  meth_meth_collectionsPrelude_Iterator5494->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Iterator5494);
  meth_meth_collectionsPrelude_Iterator5494->definitionModule = modulename;
  meth_meth_collectionsPrelude_Iterator5494->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 165
  setline(165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 179
  setline(179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 224
  setline(224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 249
  setline(249);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 250
  setline(250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject5495 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5495 = alloc_userobj2(3,4, objclass5495);
  gc_frame_newslot(obj5495);
if (objclass5495 == NULL) {
  glfree(obj5495->class->name);
  obj5495->class->name = "collection";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5495, self, 0);
  addmethodreal(obj5495,"outer", &reader_collectionsPrelude_outer_5496);
  Object oldself5495 = self;
  struct StackFrameObject *oldstackframe5495 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5495);
  gc_frame_newslot((Object)stackframe);
  self = obj5495;
  Object *oldselfslot5495 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5495 = (*(struct UserObject *)self).data[0], lowerouter5495 = thisouter5495;
  if (inheritingObject5495) {
    struct UserObject *inho5495 = (struct UserObject *)inheritingObject5495;
    while (inho5495->super != GraceDefaultObject) inho5495 = (struct UserObject *)inho5495->super;
    inho5495->super = obj5495;
    self = inheritingObject5495;
    *selfslot = self;
    lowerouter5495 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5495;
  }
// method "TRAIT"
  block_savedest(obj5495);
  Object closure5497 = createclosure(2, "TRAIT");
  setclosureframe(closure5497, stackframe);
  addtoclosure(closure5497, var_SizeUnknown);
  addtoclosure(closure5497, var_BoundsError);
  struct UserObject *uo5497 = (struct UserObject*)obj5495;
  uo5497->data[1] = (Object)closure5497;
  Method *meth_meth_collectionsPrelude_TRAIT5497 = addmethod2pos(obj5495, "TRAIT", &meth_collectionsPrelude_TRAIT5497, 1);
  int argcv_meth_collectionsPrelude_TRAIT5497[] = {0};
  meth_meth_collectionsPrelude_TRAIT5497->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_TRAIT5497);
  meth_meth_collectionsPrelude_TRAIT5497->definitionModule = modulename;
  meth_meth_collectionsPrelude_TRAIT5497->definitionLine = 250;
  block_savedest(obj5495);
  Object closure5619 = createclosure(2, "TRAIT$object(1)");
  setclosureframe(closure5619, stackframe);
  addtoclosure(closure5619, var_SizeUnknown);
  addtoclosure(closure5619, var_BoundsError);
  Method *meth_meth_collectionsPrelude_TRAIT5497_object = addmethod2pos(obj5495, "TRAIT$object(1)", &meth_collectionsPrelude_TRAIT5497_object, 1);
  meth_meth_collectionsPrelude_TRAIT5497_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_TRAIT5497_object->definitionLine = 250;
// method "asString"
  struct UserObject *uo5620 = (struct UserObject*)obj5495;
  uo5620->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString5620 = addmethod2pos(obj5495, "asString", &meth_collectionsPrelude_asString5620, 2);
  int argcv_meth_collectionsPrelude_asString5620[] = {0};
  meth_meth_collectionsPrelude_asString5620->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5620);
  meth_meth_collectionsPrelude_asString5620->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5620->definitionLine = 250;
  sourceObject = obj5495;
  sourceObject = obj5495;
  objclass5495 = obj5495->class;
  objclass5495->definitionModule = modulename;
  objclass5495->definitionLine = 250;
  (*(struct UserObject *)self).data[0] = lowerouter5495;
  self = oldself5495;
  selfslot = oldselfslot5495;
  stackframe = oldstackframe5495;
// compiled object node returning obj5495 (depth = 2)
  *var_collection = obj5495;
  if (obj5495 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "collection"
  block_savedest(self);
  Object closure5622 = createclosure(1, "collection");
  setclosureframe(closure5622, stackframe);
  addtoclosure(closure5622, var_collection);
  struct UserObject *uo5622 = (struct UserObject*)self;
  uo5622->data[33] = (Object)closure5622;
  Method *meth_meth_collectionsPrelude_collection5622 = addmethod2pos(self, "collection", &meth_collectionsPrelude_collection5622, 33);
  int argcv_meth_collectionsPrelude_collection5622[] = {0};
  meth_meth_collectionsPrelude_collection5622->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_collection5622);
  meth_meth_collectionsPrelude_collection5622->definitionModule = modulename;
  meth_meth_collectionsPrelude_collection5622->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 316
  setline(316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 317
  setline(317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject5623 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5623 = alloc_userobj2(3,4, objclass5623);
  gc_frame_newslot(obj5623);
if (objclass5623 == NULL) {
  glfree(obj5623->class->name);
  obj5623->class->name = "enumerable";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5623, self, 0);
  addmethodreal(obj5623,"outer", &reader_collectionsPrelude_outer_5624);
  Object oldself5623 = self;
  struct StackFrameObject *oldstackframe5623 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5623);
  gc_frame_newslot((Object)stackframe);
  self = obj5623;
  Object *oldselfslot5623 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5623 = (*(struct UserObject *)self).data[0], lowerouter5623 = thisouter5623;
  if (inheritingObject5623) {
    struct UserObject *inho5623 = (struct UserObject *)inheritingObject5623;
    while (inho5623->super != GraceDefaultObject) inho5623 = (struct UserObject *)inho5623->super;
    inho5623->super = obj5623;
    self = inheritingObject5623;
    *selfslot = self;
    lowerouter5623 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5623;
  }
// method "TRAIT"
  block_savedest(obj5623);
  Object closure5625 = createclosure(2, "TRAIT");
  setclosureframe(closure5625, stackframe);
  addtoclosure(closure5625, var_SizeUnknown);
  addtoclosure(closure5625, var_collection);
  struct UserObject *uo5625 = (struct UserObject*)obj5623;
  uo5625->data[1] = (Object)closure5625;
  Method *meth_meth_collectionsPrelude_TRAIT5625 = addmethod2pos(obj5623, "TRAIT", &meth_collectionsPrelude_TRAIT5625, 1);
  int argcv_meth_collectionsPrelude_TRAIT5625[] = {0};
  meth_meth_collectionsPrelude_TRAIT5625->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_TRAIT5625);
  meth_meth_collectionsPrelude_TRAIT5625->definitionModule = modulename;
  meth_meth_collectionsPrelude_TRAIT5625->definitionLine = 317;
  block_savedest(obj5623);
  Object closure5791 = createclosure(2, "TRAIT$object(1)");
  setclosureframe(closure5791, stackframe);
  addtoclosure(closure5791, var_SizeUnknown);
  addtoclosure(closure5791, var_collection);
  Method *meth_meth_collectionsPrelude_TRAIT5625_object = addmethod2pos(obj5623, "TRAIT$object(1)", &meth_collectionsPrelude_TRAIT5625_object, 1);
  meth_meth_collectionsPrelude_TRAIT5625_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_TRAIT5625_object->definitionLine = 317;
// method "asString"
  struct UserObject *uo5792 = (struct UserObject*)obj5623;
  uo5792->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString5792 = addmethod2pos(obj5623, "asString", &meth_collectionsPrelude_asString5792, 2);
  int argcv_meth_collectionsPrelude_asString5792[] = {0};
  meth_meth_collectionsPrelude_asString5792->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5792);
  meth_meth_collectionsPrelude_asString5792->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5792->definitionLine = 317;
  sourceObject = obj5623;
  sourceObject = obj5623;
  objclass5623 = obj5623->class;
  objclass5623->definitionModule = modulename;
  objclass5623->definitionLine = 317;
  (*(struct UserObject *)self).data[0] = lowerouter5623;
  self = oldself5623;
  selfslot = oldselfslot5623;
  stackframe = oldstackframe5623;
// compiled object node returning obj5623 (depth = 2)
  *var_enumerable = obj5623;
  if (obj5623 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "enumerable"
  block_savedest(self);
  Object closure5794 = createclosure(1, "enumerable");
  setclosureframe(closure5794, stackframe);
  addtoclosure(closure5794, var_enumerable);
  struct UserObject *uo5794 = (struct UserObject*)self;
  uo5794->data[34] = (Object)closure5794;
  Method *meth_meth_collectionsPrelude_enumerable5794 = addmethod2pos(self, "enumerable", &meth_collectionsPrelude_enumerable5794, 34);
  int argcv_meth_collectionsPrelude_enumerable5794[] = {0};
  meth_meth_collectionsPrelude_enumerable5794->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_enumerable5794);
  meth_meth_collectionsPrelude_enumerable5794->definitionModule = modulename;
  meth_meth_collectionsPrelude_enumerable5794->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 381
  setline(381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 382
  setline(382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject5795 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5795 = alloc_userobj2(3,4, objclass5795);
  gc_frame_newslot(obj5795);
if (objclass5795 == NULL) {
  glfree(obj5795->class->name);
  obj5795->class->name = "indexable";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5795, self, 0);
  addmethodreal(obj5795,"outer", &reader_collectionsPrelude_outer_5796);
  Object oldself5795 = self;
  struct StackFrameObject *oldstackframe5795 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5795);
  gc_frame_newslot((Object)stackframe);
  self = obj5795;
  Object *oldselfslot5795 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5795 = (*(struct UserObject *)self).data[0], lowerouter5795 = thisouter5795;
  if (inheritingObject5795) {
    struct UserObject *inho5795 = (struct UserObject *)inheritingObject5795;
    while (inho5795->super != GraceDefaultObject) inho5795 = (struct UserObject *)inho5795->super;
    inho5795->super = obj5795;
    self = inheritingObject5795;
    *selfslot = self;
    lowerouter5795 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5795;
  }
// method "TRAIT"
  block_savedest(obj5795);
  Object closure5797 = createclosure(2, "TRAIT");
  setclosureframe(closure5797, stackframe);
  addtoclosure(closure5797, var_NoSuchObject);
  addtoclosure(closure5797, var_collection);
  struct UserObject *uo5797 = (struct UserObject*)obj5795;
  uo5797->data[1] = (Object)closure5797;
  Method *meth_meth_collectionsPrelude_TRAIT5797 = addmethod2pos(obj5795, "TRAIT", &meth_collectionsPrelude_TRAIT5797, 1);
  int argcv_meth_collectionsPrelude_TRAIT5797[] = {0};
  meth_meth_collectionsPrelude_TRAIT5797->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_TRAIT5797);
  meth_meth_collectionsPrelude_TRAIT5797->definitionModule = modulename;
  meth_meth_collectionsPrelude_TRAIT5797->definitionLine = 382;
  block_savedest(obj5795);
  Object closure5945 = createclosure(2, "TRAIT$object(1)");
  setclosureframe(closure5945, stackframe);
  addtoclosure(closure5945, var_NoSuchObject);
  addtoclosure(closure5945, var_collection);
  Method *meth_meth_collectionsPrelude_TRAIT5797_object = addmethod2pos(obj5795, "TRAIT$object(1)", &meth_collectionsPrelude_TRAIT5797_object, 1);
  meth_meth_collectionsPrelude_TRAIT5797_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_TRAIT5797_object->definitionLine = 382;
// method "asString"
  struct UserObject *uo5946 = (struct UserObject*)obj5795;
  uo5946->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString5946 = addmethod2pos(obj5795, "asString", &meth_collectionsPrelude_asString5946, 2);
  int argcv_meth_collectionsPrelude_asString5946[] = {0};
  meth_meth_collectionsPrelude_asString5946->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5946);
  meth_meth_collectionsPrelude_asString5946->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5946->definitionLine = 382;
  sourceObject = obj5795;
  sourceObject = obj5795;
  objclass5795 = obj5795->class;
  objclass5795->definitionModule = modulename;
  objclass5795->definitionLine = 382;
  (*(struct UserObject *)self).data[0] = lowerouter5795;
  self = oldself5795;
  selfslot = oldselfslot5795;
  stackframe = oldstackframe5795;
// compiled object node returning obj5795 (depth = 2)
  *var_indexable = obj5795;
  if (obj5795 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "indexable"
  block_savedest(self);
  Object closure5948 = createclosure(1, "indexable");
  setclosureframe(closure5948, stackframe);
  addtoclosure(closure5948, var_indexable);
  struct UserObject *uo5948 = (struct UserObject*)self;
  uo5948->data[35] = (Object)closure5948;
  Method *meth_meth_collectionsPrelude_indexable5948 = addmethod2pos(self, "indexable", &meth_collectionsPrelude_indexable5948, 35);
  int argcv_meth_collectionsPrelude_indexable5948[] = {0};
  meth_meth_collectionsPrelude_indexable5948->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_indexable5948);
  meth_meth_collectionsPrelude_indexable5948->definitionModule = modulename;
  meth_meth_collectionsPrelude_indexable5948->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 426
  setline(426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 430
  setline(430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 431
  setline(431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject5949 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5949 = alloc_userobj2(16,17, objclass5949);
  gc_frame_newslot(obj5949);
if (objclass5949 == NULL) {
  glfree(obj5949->class->name);
  obj5949->class->name = "emptySequence";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5949, self, 0);
  addmethodreal(obj5949,"outer", &reader_collectionsPrelude_outer_5950);
  Object oldself5949 = self;
  struct StackFrameObject *oldstackframe5949 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5949);
  gc_frame_newslot((Object)stackframe);
  self = obj5949;
  Object *oldselfslot5949 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5949 = (*(struct UserObject *)self).data[0], lowerouter5949 = thisouter5949;
  if (inheritingObject5949) {
    struct UserObject *inho5949 = (struct UserObject *)inheritingObject5949;
    while (inho5949->super != GraceDefaultObject) inho5949 = (struct UserObject *)inho5949->super;
    inho5949->super = obj5949;
    self = inheritingObject5949;
    *selfslot = self;
    lowerouter5949 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5949;
  }
// method "size"
  struct UserObject *uo5951 = (struct UserObject*)obj5949;
  uo5951->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_size5951 = addmethod2pos(obj5949, "size", &meth_collectionsPrelude_size5951, 1);
  int argcv_meth_collectionsPrelude_size5951[] = {0};
  meth_meth_collectionsPrelude_size5951->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size5951);
  meth_meth_collectionsPrelude_size5951->definitionModule = modulename;
  meth_meth_collectionsPrelude_size5951->definitionLine = 433;
// method "isEmpty"
  struct UserObject *uo5953 = (struct UserObject*)obj5949;
  uo5953->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isEmpty5953 = addmethod2pos(obj5949, "isEmpty", &meth_collectionsPrelude_isEmpty5953, 2);
  int argcv_meth_collectionsPrelude_isEmpty5953[] = {0};
  meth_meth_collectionsPrelude_isEmpty5953->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isEmpty5953);
  meth_meth_collectionsPrelude_isEmpty5953->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEmpty5953->definitionLine = 434;
// method "at(_)"
  block_savedest(obj5949);
  Object closure5955 = createclosure(1, "at(1)");
  setclosureframe(closure5955, stackframe);
  addtoclosure(closure5955, var_BoundsError);
  struct UserObject *uo5955 = (struct UserObject*)obj5949;
  uo5955->data[3] = (Object)closure5955;
  Method *meth_meth_collectionsPrelude_at_40_1_41_5955 = addmethod2pos(obj5949, "at(1)", &meth_collectionsPrelude_at_40_1_41_5955, 3);
  int argcv_meth_collectionsPrelude_at_40_1_41_5955[] = {1};
  meth_meth_collectionsPrelude_at_40_1_41_5955->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at_40_1_41_5955);
  meth_meth_collectionsPrelude_at_40_1_41_5955->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40_1_41_5955->definitionLine = 435;
// method "keys"
  struct UserObject *uo5966 = (struct UserObject*)obj5949;
  uo5966->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys5966 = addmethod2pos(obj5949, "keys", &meth_collectionsPrelude_keys5966, 4);
  int argcv_meth_collectionsPrelude_keys5966[] = {0};
  meth_meth_collectionsPrelude_keys5966->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys5966);
  meth_meth_collectionsPrelude_keys5966->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys5966->definitionLine = 436;
// method "values"
  struct UserObject *uo5967 = (struct UserObject*)obj5949;
  uo5967->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values5967 = addmethod2pos(obj5949, "values", &meth_collectionsPrelude_values5967, 5);
  int argcv_meth_collectionsPrelude_values5967[] = {0};
  meth_meth_collectionsPrelude_values5967->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values5967);
  meth_meth_collectionsPrelude_values5967->definitionModule = modulename;
  meth_meth_collectionsPrelude_values5967->definitionLine = 437;
// method "keysAndValuesDo(_)"
  block_savedest(obj5949);
  Object closure5968 = createclosure(1, "keysAndValuesDo(1)");
  setclosureframe(closure5968, stackframe);
  addtoclosure(closure5968, var_done);
  struct UserObject *uo5968 = (struct UserObject*)obj5949;
  uo5968->data[6] = (Object)closure5968;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5968 = addmethod2pos(obj5949, "keysAndValuesDo(1)", &meth_collectionsPrelude_keysAndValuesDo_40_1_41_5968, 6);
  int argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5968[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5968->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5968);
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5968->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo_40_1_41_5968->definitionLine = 438;
// method "reversed"
  struct UserObject *uo5969 = (struct UserObject*)obj5949;
  uo5969->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reversed5969 = addmethod2pos(obj5949, "reversed", &meth_collectionsPrelude_reversed5969, 7);
  int argcv_meth_collectionsPrelude_reversed5969[] = {0};
  meth_meth_collectionsPrelude_reversed5969->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed5969);
  meth_meth_collectionsPrelude_reversed5969->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed5969->definitionLine = 439;
// method "++(_)"
  struct UserObject *uo5970 = (struct UserObject*)obj5949;
  uo5970->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43__40_1_41_5970 = addmethod2pos(obj5949, "++(1)", &meth_collectionsPrelude__43__43__40_1_41_5970, 8);
  int argcv_meth_collectionsPrelude__43__43__40_1_41_5970[] = {1};
  meth_meth_collectionsPrelude__43__43__40_1_41_5970->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43__40_1_41_5970);
  meth_meth_collectionsPrelude__43__43__40_1_41_5970->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43__40_1_41_5970->definitionLine = 440;
// method "asString"
  struct UserObject *uo5977 = (struct UserObject*)obj5949;
  uo5977->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString5977 = addmethod2pos(obj5949, "asString", &meth_collectionsPrelude_asString5977, 9);
  int argcv_meth_collectionsPrelude_asString5977[] = {0};
  meth_meth_collectionsPrelude_asString5977->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5977);
  meth_meth_collectionsPrelude_asString5977->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5977->definitionLine = 441;
// method "contains(_)"
  struct UserObject *uo5979 = (struct UserObject*)obj5949;
  uo5979->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains_40_1_41_5979 = addmethod2pos(obj5949, "contains(1)", &meth_collectionsPrelude_contains_40_1_41_5979, 10);
  int argcv_meth_collectionsPrelude_contains_40_1_41_5979[] = {1};
  meth_meth_collectionsPrelude_contains_40_1_41_5979->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains_40_1_41_5979);
  meth_meth_collectionsPrelude_contains_40_1_41_5979->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains_40_1_41_5979->definitionLine = 442;
// method "do(_)"
  block_savedest(obj5949);
  Object closure5981 = createclosure(1, "do(1)");
  setclosureframe(closure5981, stackframe);
  addtoclosure(closure5981, var_done);
  struct UserObject *uo5981 = (struct UserObject*)obj5949;
  uo5981->data[11] = (Object)closure5981;
  Method *meth_meth_collectionsPrelude_do_40_1_41_5981 = addmethod2pos(obj5949, "do(1)", &meth_collectionsPrelude_do_40_1_41_5981, 11);
  int argcv_meth_collectionsPrelude_do_40_1_41_5981[] = {1};
  meth_meth_collectionsPrelude_do_40_1_41_5981->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do_40_1_41_5981);
  meth_meth_collectionsPrelude_do_40_1_41_5981->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40_1_41_5981->definitionLine = 443;
// method "==(_)"
  block_savedest(obj5949);
  Object closure5982 = createclosure(1, "==(1)");
  setclosureframe(closure5982, stackframe);
  addtoclosure(closure5982, var_Iterable);
  struct UserObject *uo5982 = (struct UserObject*)obj5949;
  uo5982->data[12] = (Object)closure5982;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_5982 = addmethod2pos(obj5949, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_5982, 12);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_5982[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_5982->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_5982);
  meth_meth_collectionsPrelude__61__61__40_1_41_5982->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_5982->definitionLine = 444;
// method "iterator"
  block_savedest(obj5949);
  Object closure6002 = createclosure(1, "iterator");
  setclosureframe(closure6002, stackframe);
  addtoclosure(closure6002, var_IteratorExhausted);
  struct UserObject *uo6002 = (struct UserObject*)obj5949;
  uo6002->data[13] = (Object)closure6002;
  Method *meth_meth_collectionsPrelude_iterator6002 = addmethod2pos(obj5949, "iterator", &meth_collectionsPrelude_iterator6002, 13);
  int argcv_meth_collectionsPrelude_iterator6002[] = {0};
  meth_meth_collectionsPrelude_iterator6002->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator6002);
  meth_meth_collectionsPrelude_iterator6002->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator6002->definitionLine = 453;
  block_savedest(obj5949);
  Object closure6013 = createclosure(1, "iterator$object(1)");
  setclosureframe(closure6013, stackframe);
  addtoclosure(closure6013, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_iterator6002_object = addmethod2pos(obj5949, "iterator$object(1)", &meth_collectionsPrelude_iterator6002_object, 13);
  meth_meth_collectionsPrelude_iterator6002_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator6002_object->definitionLine = 453;
// method "sorted"
  struct UserObject *uo6014 = (struct UserObject*)obj5949;
  uo6014->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted6014 = addmethod2pos(obj5949, "sorted", &meth_collectionsPrelude_sorted6014, 14);
  int argcv_meth_collectionsPrelude_sorted6014[] = {0};
  meth_meth_collectionsPrelude_sorted6014->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted6014);
  meth_meth_collectionsPrelude_sorted6014->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted6014->definitionLine = 458;
// method "sortedBy(_)"
  struct UserObject *uo6015 = (struct UserObject*)obj5949;
  uo6015->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy_40_1_41_6015 = addmethod2pos(obj5949, "sortedBy(1)", &meth_collectionsPrelude_sortedBy_40_1_41_6015, 15);
  int argcv_meth_collectionsPrelude_sortedBy_40_1_41_6015[] = {1};
  meth_meth_collectionsPrelude_sortedBy_40_1_41_6015->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy_40_1_41_6015);
  meth_meth_collectionsPrelude_sortedBy_40_1_41_6015->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy_40_1_41_6015->definitionLine = 459;
  sourceObject = obj5949;
// Begin line 432
  setline(432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6016 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other requests
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_indexable (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6017 = callmethodflags(*var_indexable, "TRAIT$object(1)", 2, partcv, params, 0);
  gc_frame_end(callframe6016);
// compiled call node returning call6017 (depth = 3)
  struct UserObject *obj5949_uo = (struct UserObject *)obj5949;
  obj5949_uo->super = call6017;
  sourceObject = obj5949;
  sourceObject = obj5949;
  sourceObject = obj5949;
  sourceObject = obj5949;
  sourceObject = obj5949;
  sourceObject = obj5949;
  sourceObject = obj5949;
  sourceObject = obj5949;
  sourceObject = obj5949;
  sourceObject = obj5949;
  sourceObject = obj5949;
  sourceObject = obj5949;
  sourceObject = obj5949;
  sourceObject = obj5949;
  sourceObject = obj5949;
  objclass5949 = obj5949->class;
  objclass5949->definitionModule = modulename;
  objclass5949->definitionLine = 431;
  (*(struct UserObject *)self).data[0] = lowerouter5949;
  self = oldself5949;
  selfslot = oldselfslot5949;
  stackframe = oldstackframe5949;
// compiled object node returning obj5949 (depth = 2)
  *var_emptySequence = obj5949;
  if (obj5949 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "emptySequence"
  block_savedest(self);
  Object closure6018 = createclosure(1, "emptySequence");
  setclosureframe(closure6018, stackframe);
  addtoclosure(closure6018, var_emptySequence);
  struct UserObject *uo6018 = (struct UserObject*)self;
  uo6018->data[36] = (Object)closure6018;
  Method *meth_meth_collectionsPrelude_emptySequence6018 = addmethod2pos(self, "emptySequence", &meth_collectionsPrelude_emptySequence6018, 36);
  int argcv_meth_collectionsPrelude_emptySequence6018[] = {0};
  meth_meth_collectionsPrelude_emptySequence6018->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_emptySequence6018);
  meth_meth_collectionsPrelude_emptySequence6018->definitionModule = modulename;
  meth_meth_collectionsPrelude_emptySequence6018->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 461
  setline(461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 598
  setline(598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 599
  setline(599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl MinimalyIterable
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type6020 = alloc_Type("MinimalyIterable", 1);
    add_Method((ClassData)type6020, "iterator", NULL);
// compiled typeliteral node returning type6020 (depth = 2)
  *var_MinimalyIterable = type6020;
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "MinimalyIterable"
  block_savedest(self);
  Object closure6021 = createclosure(1, "MinimalyIterable");
  setclosureframe(closure6021, stackframe);
  addtoclosure(closure6021, var_MinimalyIterable);
  struct UserObject *uo6021 = (struct UserObject*)self;
  uo6021->data[37] = (Object)closure6021;
  Method *meth_meth_collectionsPrelude_MinimalyIterable6021 = addmethod2pos(self, "MinimalyIterable", &meth_collectionsPrelude_MinimalyIterable6021, 37);
  int argcv_meth_collectionsPrelude_MinimalyIterable6021[] = {0};
  meth_meth_collectionsPrelude_MinimalyIterable6021->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_MinimalyIterable6021);
  meth_meth_collectionsPrelude_MinimalyIterable6021->definitionModule = modulename;
  meth_meth_collectionsPrelude_MinimalyIterable6021->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 602
  setline(602);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 617
  setline(617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1155
  setline(1155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1156
  setline(1156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6022 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6022 = alloc_userobj2(6,6, objclass6022);
  gc_frame_newslot(obj6022);
if (objclass6022 == NULL) {
  glfree(obj6022->class->name);
  obj6022->class->name = "unused";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6022, self, 0);
  addmethodreal(obj6022,"outer", &reader_collectionsPrelude_outer_6023);
  Object oldself6022 = self;
  struct StackFrameObject *oldstackframe6022 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6022);
  gc_frame_newslot((Object)stackframe);
  self = obj6022;
  Object *oldselfslot6022 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6022 = (*(struct UserObject *)self).data[0], lowerouter6022 = thisouter6022;
  if (inheritingObject6022) {
    struct UserObject *inho6022 = (struct UserObject *)inheritingObject6022;
    while (inho6022->super != GraceDefaultObject) inho6022 = (struct UserObject *)inho6022->super;
    inho6022->super = obj6022;
    self = inheritingObject6022;
    *selfslot = self;
    lowerouter6022 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6022;
  }
if (objclass6022 == NULL) {
  Method *reader6024 = addmethodrealflags(obj6022, "unused", &reader_collectionsPrelude_unused_6024, MFLAG_CONFIDENTIAL);
  Method *writer6024 = addmethodrealflags(obj6022, "unused:=(1)", &writer_collectionsPrelude_unused_6024, MFLAG_CONFIDENTIAL);
  reader6024->definitionModule = modulename;
  writer6024->definitionModule = modulename;
  reader6024->definitionLine = 1157;
  writer6024->definitionLine = 1157;
}
obj6022->flags |= OFLAG_MUTABLE;
adddatum2(obj6022, alloc_Undefined(), 1);
if (objclass6022 == NULL) {
  Method *reader6025 = addmethodrealflags(obj6022, "key",&reader_collectionsPrelude_key_6025, MFLAG_DEF);
  reader6025->definitionModule = modulename;
  reader6025->definitionLine = 1158;
}
adddatum2(obj6022, alloc_Undefined(), 2);
if (objclass6022 == NULL) {
  Method *reader6026 = addmethodrealflags(obj6022, "value",&reader_collectionsPrelude_value_6026, MFLAG_DEF);
  reader6026->definitionModule = modulename;
  reader6026->definitionLine = 1159;
}
adddatum2(obj6022, alloc_Undefined(), 3);
// method "asString"
  struct UserObject *uo6027 = (struct UserObject*)obj6022;
  uo6027->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString6027 = addmethod2pos(obj6022, "asString", &meth_collectionsPrelude_asString6027, 4);
  int argcv_meth_collectionsPrelude_asString6027[] = {0};
  meth_meth_collectionsPrelude_asString6027->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString6027);
  meth_meth_collectionsPrelude_asString6027->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString6027->definitionLine = 1160;
// method "==(_)"
  struct UserObject *uo6029 = (struct UserObject*)obj6022;
  uo6029->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_6029 = addmethod2pos(obj6022, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_6029, 5);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_6029[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_6029->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_6029);
  meth_meth_collectionsPrelude__61__61__40_1_41_6029->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_6029->definitionLine = 1161;
  sourceObject = obj6022;
// Begin line 1157
  setline(1157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6032 = alloc_Boolean(1);
// compiled identifier node returning bool6032 (depth = 3)
  adddatum2(obj6022, bool6032, 1);
  sourceObject = obj6022;
// Begin line 1158
  setline(1158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  adddatum2(obj6022, self, 2);
  sourceObject = obj6022;
// Begin line 1159
  setline(1159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  adddatum2(obj6022, self, 3);
  sourceObject = obj6022;
  sourceObject = obj6022;
  objclass6022 = obj6022->class;
  objclass6022->definitionModule = modulename;
  objclass6022->definitionLine = 1156;
  (*(struct UserObject *)self).data[0] = lowerouter6022;
  self = oldself6022;
  selfslot = oldselfslot6022;
  stackframe = oldstackframe6022;
// compiled object node returning obj6022 (depth = 2)
  *var_unused = obj6022;
  if (obj6022 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "unused"
  block_savedest(self);
  Object closure6033 = createclosure(1, "unused");
  setclosureframe(closure6033, stackframe);
  addtoclosure(closure6033, var_unused);
  struct UserObject *uo6033 = (struct UserObject*)self;
  uo6033->data[38] = (Object)closure6033;
  Method *meth_meth_collectionsPrelude_unused6033 = addmethod2pos(self, "unused", &meth_collectionsPrelude_unused6033, 38);
  int argcv_meth_collectionsPrelude_unused6033[] = {0};
  meth_meth_collectionsPrelude_unused6033->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_unused6033);
  meth_meth_collectionsPrelude_unused6033->definitionModule = modulename;
  meth_meth_collectionsPrelude_unused6033->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1163
  setline(1163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1164
  setline(1164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6034 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6034 = alloc_userobj2(6,6, objclass6034);
  gc_frame_newslot(obj6034);
if (objclass6034 == NULL) {
  glfree(obj6034->class->name);
  obj6034->class->name = "removed";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6034, self, 0);
  addmethodreal(obj6034,"outer", &reader_collectionsPrelude_outer_6035);
  Object oldself6034 = self;
  struct StackFrameObject *oldstackframe6034 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6034);
  gc_frame_newslot((Object)stackframe);
  self = obj6034;
  Object *oldselfslot6034 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6034 = (*(struct UserObject *)self).data[0], lowerouter6034 = thisouter6034;
  if (inheritingObject6034) {
    struct UserObject *inho6034 = (struct UserObject *)inheritingObject6034;
    while (inho6034->super != GraceDefaultObject) inho6034 = (struct UserObject *)inho6034->super;
    inho6034->super = obj6034;
    self = inheritingObject6034;
    *selfslot = self;
    lowerouter6034 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6034;
  }
if (objclass6034 == NULL) {
  Method *reader6036 = addmethodrealflags(obj6034, "removed", &reader_collectionsPrelude_removed_6036, MFLAG_CONFIDENTIAL);
  Method *writer6036 = addmethodrealflags(obj6034, "removed:=(1)", &writer_collectionsPrelude_removed_6036, MFLAG_CONFIDENTIAL);
  reader6036->definitionModule = modulename;
  writer6036->definitionModule = modulename;
  reader6036->definitionLine = 1165;
  writer6036->definitionLine = 1165;
}
obj6034->flags |= OFLAG_MUTABLE;
adddatum2(obj6034, alloc_Undefined(), 1);
if (objclass6034 == NULL) {
  Method *reader6037 = addmethodrealflags(obj6034, "key",&reader_collectionsPrelude_key_6037, MFLAG_DEF);
  reader6037->definitionModule = modulename;
  reader6037->definitionLine = 1166;
}
adddatum2(obj6034, alloc_Undefined(), 2);
if (objclass6034 == NULL) {
  Method *reader6038 = addmethodrealflags(obj6034, "value",&reader_collectionsPrelude_value_6038, MFLAG_DEF);
  reader6038->definitionModule = modulename;
  reader6038->definitionLine = 1167;
}
adddatum2(obj6034, alloc_Undefined(), 3);
// method "asString"
  struct UserObject *uo6039 = (struct UserObject*)obj6034;
  uo6039->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString6039 = addmethod2pos(obj6034, "asString", &meth_collectionsPrelude_asString6039, 4);
  int argcv_meth_collectionsPrelude_asString6039[] = {0};
  meth_meth_collectionsPrelude_asString6039->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString6039);
  meth_meth_collectionsPrelude_asString6039->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString6039->definitionLine = 1168;
// method "==(_)"
  struct UserObject *uo6041 = (struct UserObject*)obj6034;
  uo6041->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61__40_1_41_6041 = addmethod2pos(obj6034, "==(1)", &meth_collectionsPrelude__61__61__40_1_41_6041, 5);
  int argcv_meth_collectionsPrelude__61__61__40_1_41_6041[] = {1};
  meth_meth_collectionsPrelude__61__61__40_1_41_6041->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61__40_1_41_6041);
  meth_meth_collectionsPrelude__61__61__40_1_41_6041->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61__40_1_41_6041->definitionLine = 1169;
  sourceObject = obj6034;
// Begin line 1165
  setline(1165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6044 = alloc_Boolean(1);
// compiled identifier node returning bool6044 (depth = 3)
  adddatum2(obj6034, bool6044, 1);
  sourceObject = obj6034;
// Begin line 1166
  setline(1166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  adddatum2(obj6034, self, 2);
  sourceObject = obj6034;
// Begin line 1167
  setline(1167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  adddatum2(obj6034, self, 3);
  sourceObject = obj6034;
  sourceObject = obj6034;
  objclass6034 = obj6034->class;
  objclass6034->definitionModule = modulename;
  objclass6034->definitionLine = 1164;
  (*(struct UserObject *)self).data[0] = lowerouter6034;
  self = oldself6034;
  selfslot = oldselfslot6034;
  stackframe = oldstackframe6034;
// compiled object node returning obj6034 (depth = 2)
  *var_removed = obj6034;
  if (obj6034 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "removed"
  block_savedest(self);
  Object closure6045 = createclosure(1, "removed");
  setclosureframe(closure6045, stackframe);
  addtoclosure(closure6045, var_removed);
  struct UserObject *uo6045 = (struct UserObject*)self;
  uo6045->data[39] = (Object)closure6045;
  Method *meth_meth_collectionsPrelude_removed6045 = addmethod2pos(self, "removed", &meth_collectionsPrelude_removed6045, 39);
  int argcv_meth_collectionsPrelude_removed6045[] = {0};
  meth_meth_collectionsPrelude_removed6045->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removed6045);
  meth_meth_collectionsPrelude_removed6045->definitionModule = modulename;
  meth_meth_collectionsPrelude_removed6045->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1171
  setline(1171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1454
  setline(1454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1455
  setline(1455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Binding
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type6047 = alloc_Type("Binding", 4);
    add_Method((ClassData)type6047, "key", NULL);
    add_Method((ClassData)type6047, "value", NULL);
    add_Method((ClassData)type6047, "hash", NULL);
    add_Method((ClassData)type6047, "==(1)", NULL);
// compiled typeliteral node returning type6047 (depth = 2)
  *var_Binding = type6047;
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Binding"
  block_savedest(self);
  Object closure6048 = createclosure(1, "Binding");
  setclosureframe(closure6048, stackframe);
  addtoclosure(closure6048, var_Binding);
  struct UserObject *uo6048 = (struct UserObject*)self;
  uo6048->data[40] = (Object)closure6048;
  Method *meth_meth_collectionsPrelude_Binding6048 = addmethod2pos(self, "Binding", &meth_collectionsPrelude_Binding6048, 40);
  int argcv_meth_collectionsPrelude_Binding6048[] = {0};
  meth_meth_collectionsPrelude_Binding6048->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Binding6048);
  meth_meth_collectionsPrelude_Binding6048->definitionModule = modulename;
  meth_meth_collectionsPrelude_Binding6048->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 1461
  setline(1461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1462
  setline(1462);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6049 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6049 = alloc_userobj2(3,4, objclass6049);
  gc_frame_newslot(obj6049);
if (objclass6049 == NULL) {
  glfree(obj6049->class->name);
  obj6049->class->name = "binding";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6049, self, 0);
  addmethodreal(obj6049,"outer", &reader_collectionsPrelude_outer_6050);
  Object oldself6049 = self;
  struct StackFrameObject *oldstackframe6049 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6049);
  gc_frame_newslot((Object)stackframe);
  self = obj6049;
  Object *oldselfslot6049 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6049 = (*(struct UserObject *)self).data[0], lowerouter6049 = thisouter6049;
  if (inheritingObject6049) {
    struct UserObject *inho6049 = (struct UserObject *)inheritingObject6049;
    while (inho6049->super != GraceDefaultObject) inho6049 = (struct UserObject *)inho6049->super;
    inho6049->super = obj6049;
    self = inheritingObject6049;
    *selfslot = self;
    lowerouter6049 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6049;
  }
// method "asString"
  struct UserObject *uo6051 = (struct UserObject*)obj6049;
  uo6051->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString6051 = addmethod2pos(obj6049, "asString", &meth_collectionsPrelude_asString6051, 1);
  int argcv_meth_collectionsPrelude_asString6051[] = {0};
  meth_meth_collectionsPrelude_asString6051->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString6051);
  meth_meth_collectionsPrelude_asString6051->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString6051->definitionLine = 1463;
// method "key(_)value(_)"
  block_savedest(obj6049);
  Object closure6053 = createclosure(1, "key(1)value(1)");
  setclosureframe(closure6053, stackframe);
  addtoclosure(closure6053, var_Binding);
  struct UserObject *uo6053 = (struct UserObject*)obj6049;
  uo6053->data[2] = (Object)closure6053;
  Method *meth_meth_collectionsPrelude_key_40_1_41_value_40_1_41_6053 = addmethod2pos(obj6049, "key(1)value(1)", &meth_collectionsPrelude_key_40_1_41_value_40_1_41_6053, 2);
  int argcv_meth_collectionsPrelude_key_40_1_41_value_40_1_41_6053[] = {1, 1};
  meth_meth_collectionsPrelude_key_40_1_41_value_40_1_41_6053->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_key_40_1_41_value_40_1_41_6053);
  meth_meth_collectionsPrelude_key_40_1_41_value_40_1_41_6053->definitionModule = modulename;
  meth_meth_collectionsPrelude_key_40_1_41_value_40_1_41_6053->definitionLine = 1465;
  block_savedest(obj6049);
  Object closure6129 = createclosure(1, "key(1)value(1)$object(1)");
  setclosureframe(closure6129, stackframe);
  addtoclosure(closure6129, var_Binding);
  Method *meth_meth_collectionsPrelude_key_40_1_41_value_40_1_41_6053_object = addmethod2pos(obj6049, "key(1)value(1)$object(1)", &meth_collectionsPrelude_key_40_1_41_value_40_1_41_6053_object, 2);
  meth_meth_collectionsPrelude_key_40_1_41_value_40_1_41_6053_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_key_40_1_41_value_40_1_41_6053_object->definitionLine = 1465;
  sourceObject = obj6049;
  sourceObject = obj6049;
  objclass6049 = obj6049->class;
  objclass6049->definitionModule = modulename;
  objclass6049->definitionLine = 1462;
  (*(struct UserObject *)self).data[0] = lowerouter6049;
  self = oldself6049;
  selfslot = oldselfslot6049;
  stackframe = oldstackframe6049;
// compiled object node returning obj6049 (depth = 2)
  *var_binding = obj6049;
  if (obj6049 == undefined)
    graceRaise(ProgrammingError(), "attempting to use an ininitilized variable");
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "binding"
  block_savedest(self);
  Object closure6130 = createclosure(1, "binding");
  setclosureframe(closure6130, stackframe);
  addtoclosure(closure6130, var_binding);
  struct UserObject *uo6130 = (struct UserObject*)self;
  uo6130->data[41] = (Object)closure6130;
  Method *meth_meth_collectionsPrelude_binding6130 = addmethod2pos(self, "binding", &meth_collectionsPrelude_binding6130, 41);
  int argcv_meth_collectionsPrelude_binding6130[] = {0};
  meth_meth_collectionsPrelude_binding6130->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_binding6130);
  meth_meth_collectionsPrelude_binding6130->definitionModule = modulename;
  meth_meth_collectionsPrelude_binding6130->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1478
  setline(1478);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1479
  setline(1479);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl ComparableToDictionary
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type6132 = alloc_Type("ComparableToDictionary", 2);
    add_Method((ClassData)type6132, "size", NULL);
    add_Method((ClassData)type6132, "at(1)ifAbsent(1)", NULL);
// compiled typeliteral node returning type6132 (depth = 2)
  *var_ComparableToDictionary = type6132;
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "ComparableToDictionary"
  block_savedest(self);
  Object closure6133 = createclosure(1, "ComparableToDictionary");
  setclosureframe(closure6133, stackframe);
  addtoclosure(closure6133, var_ComparableToDictionary);
  struct UserObject *uo6133 = (struct UserObject*)self;
  uo6133->data[42] = (Object)closure6133;
  Method *meth_meth_collectionsPrelude_ComparableToDictionary6133 = addmethod2pos(self, "ComparableToDictionary", &meth_collectionsPrelude_ComparableToDictionary6133, 42);
  int argcv_meth_collectionsPrelude_ComparableToDictionary6133[] = {0};
  meth_meth_collectionsPrelude_ComparableToDictionary6133->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_ComparableToDictionary6133);
  meth_meth_collectionsPrelude_ComparableToDictionary6133->definitionModule = modulename;
  meth_meth_collectionsPrelude_ComparableToDictionary6133->definitionLine = 1963;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 1483
  setline(1483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1848
  setline(1848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2048
  setline(2048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
  gc_frame_end(frame);
  return self;
}
